/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package grammar;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see grammar.GrammarFactory
 * @model kind="package"
 * @generated
 */
public interface GrammarPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "grammar";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.topcased.org/BNF/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "bnf";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	GrammarPackage eINSTANCE = grammar.impl.GrammarPackageImpl.init();

	/**
	 * The meta object id for the '{@link grammar.impl.GrammarElementImpl <em>Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.GrammarElementImpl
	 * @see grammar.impl.GrammarPackageImpl#getGrammarElement()
	 * @generated
	 */
	int GRAMMAR_ELEMENT = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAMMAR_ELEMENT__NAME = 0;

	/**
	 * The number of structural features of the '<em>Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAMMAR_ELEMENT_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link grammar.impl.TokenImpl <em>Token</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.TokenImpl
	 * @see grammar.impl.GrammarPackageImpl#getToken()
	 * @generated
	 */
	int TOKEN = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOKEN__NAME = GRAMMAR_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Token Expression</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOKEN__TOKEN_EXPRESSION = GRAMMAR_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Token</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOKEN_FEATURE_COUNT = GRAMMAR_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link grammar.impl.HelperImpl <em>Helper</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.HelperImpl
	 * @see grammar.impl.GrammarPackageImpl#getHelper()
	 * @generated
	 */
	int HELPER = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HELPER__NAME = GRAMMAR_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HELPER__VALUE = GRAMMAR_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Helper</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HELPER_FEATURE_COUNT = GRAMMAR_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link grammar.impl.RuleImpl <em>Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.RuleImpl
	 * @see grammar.impl.GrammarPackageImpl#getRule()
	 * @generated
	 */
	int RULE = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE__NAME = GRAMMAR_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Expressed As</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE__EXPRESSED_AS = GRAMMAR_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_FEATURE_COUNT = GRAMMAR_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link grammar.impl.VirtualLinkImpl <em>Virtual Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.VirtualLinkImpl
	 * @see grammar.impl.GrammarPackageImpl#getVirtualLink()
	 * @generated
	 */
	int VIRTUAL_LINK = 11;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK__MULTIPLICITY = 0;

	/**
	 * The number of structural features of the '<em>Virtual Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VIRTUAL_LINK_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link grammar.impl.LinkImpl <em>Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.LinkImpl
	 * @see grammar.impl.GrammarPackageImpl#getLink()
	 * @generated
	 */
	int LINK = 7;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__MULTIPLICITY = VIRTUAL_LINK__MULTIPLICITY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__NAME = VIRTUAL_LINK_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Use Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__USE_PREFIX = VIRTUAL_LINK_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__ELEMENT = VIRTUAL_LINK_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__CONTAINS = VIRTUAL_LINK_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_FEATURE_COUNT = VIRTUAL_LINK_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link grammar.impl.ShiftImpl <em>Shift</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.ShiftImpl
	 * @see grammar.impl.GrammarPackageImpl#getShift()
	 * @generated
	 */
	int SHIFT = 4;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHIFT__MULTIPLICITY = LINK__MULTIPLICITY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHIFT__NAME = LINK__NAME;

	/**
	 * The feature id for the '<em><b>Use Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHIFT__USE_PREFIX = LINK__USE_PREFIX;

	/**
	 * The feature id for the '<em><b>Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHIFT__ELEMENT = LINK__ELEMENT;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHIFT__CONTAINS = LINK__CONTAINS;

	/**
	 * The number of structural features of the '<em>Shift</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHIFT_FEATURE_COUNT = LINK_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link grammar.impl.ReduceImpl <em>Reduce</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.ReduceImpl
	 * @see grammar.impl.GrammarPackageImpl#getReduce()
	 * @generated
	 */
	int REDUCE = 5;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REDUCE__MULTIPLICITY = LINK__MULTIPLICITY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REDUCE__NAME = LINK__NAME;

	/**
	 * The feature id for the '<em><b>Use Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REDUCE__USE_PREFIX = LINK__USE_PREFIX;

	/**
	 * The feature id for the '<em><b>Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REDUCE__ELEMENT = LINK__ELEMENT;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REDUCE__CONTAINS = LINK__CONTAINS;

	/**
	 * The number of structural features of the '<em>Reduce</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REDUCE_FEATURE_COUNT = LINK_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link grammar.impl.OrImpl <em>Or</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.OrImpl
	 * @see grammar.impl.GrammarPackageImpl#getOr()
	 * @generated
	 */
	int OR = 6;

	/**
	 * The feature id for the '<em><b>Multiplicity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__MULTIPLICITY = VIRTUAL_LINK__MULTIPLICITY;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__CONTAINS = VIRTUAL_LINK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Or</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_FEATURE_COUNT = VIRTUAL_LINK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link grammar.impl.InlineRuleImpl <em>Inline Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.InlineRuleImpl
	 * @see grammar.impl.GrammarPackageImpl#getInlineRule()
	 * @generated
	 */
	int INLINE_RULE = 8;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INLINE_RULE__NAME = RULE__NAME;

	/**
	 * The feature id for the '<em><b>Expressed As</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INLINE_RULE__EXPRESSED_AS = RULE__EXPRESSED_AS;

	/**
	 * The feature id for the '<em><b>Specifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INLINE_RULE__SPECIFIER = RULE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Related Rule</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INLINE_RULE__RELATED_RULE = RULE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Inline Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INLINE_RULE_FEATURE_COUNT = RULE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link grammar.impl.GrammarImpl <em>Grammar</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.GrammarImpl
	 * @see grammar.impl.GrammarPackageImpl#getGrammar()
	 * @generated
	 */
	int GRAMMAR = 9;

	/**
	 * The feature id for the '<em><b>Package</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAMMAR__PACKAGE = 0;

	/**
	 * The feature id for the '<em><b>Helper</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAMMAR__HELPER = 1;

	/**
	 * The feature id for the '<em><b>Token</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAMMAR__TOKEN = 2;

	/**
	 * The feature id for the '<em><b>Ignored Token</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAMMAR__IGNORED_TOKEN = 3;

	/**
	 * The feature id for the '<em><b>Rule</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAMMAR__RULE = 4;

	/**
	 * The number of structural features of the '<em>Grammar</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAMMAR_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link grammar.impl.IgnoredTokenImpl <em>Ignored Token</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.IgnoredTokenImpl
	 * @see grammar.impl.GrammarPackageImpl#getIgnoredToken()
	 * @generated
	 */
	int IGNORED_TOKEN = 10;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IGNORED_TOKEN__NAME = GRAMMAR_ELEMENT__NAME;

	/**
	 * The number of structural features of the '<em>Ignored Token</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IGNORED_TOKEN_FEATURE_COUNT = GRAMMAR_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link grammar.impl.PackageImpl <em>Package</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.impl.PackageImpl
	 * @see grammar.impl.GrammarPackageImpl#getPackage()
	 * @generated
	 */
	int PACKAGE = 12;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE__NAME = GRAMMAR_ELEMENT__NAME;

	/**
	 * The number of structural features of the '<em>Package</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PACKAGE_FEATURE_COUNT = GRAMMAR_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link grammar.Cardinality <em>Cardinality</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see grammar.Cardinality
	 * @see grammar.impl.GrammarPackageImpl#getCardinality()
	 * @generated
	 */
	int CARDINALITY = 13;


	/**
	 * Returns the meta object for class '{@link grammar.Token <em>Token</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Token</em>'.
	 * @see grammar.Token
	 * @generated
	 */
	EClass getToken();

	/**
	 * Returns the meta object for the attribute '{@link grammar.Token#getTokenExpression <em>Token Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Token Expression</em>'.
	 * @see grammar.Token#getTokenExpression()
	 * @see #getToken()
	 * @generated
	 */
	EAttribute getToken_TokenExpression();

	/**
	 * Returns the meta object for class '{@link grammar.Helper <em>Helper</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Helper</em>'.
	 * @see grammar.Helper
	 * @generated
	 */
	EClass getHelper();

	/**
	 * Returns the meta object for the attribute '{@link grammar.Helper#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see grammar.Helper#getValue()
	 * @see #getHelper()
	 * @generated
	 */
	EAttribute getHelper_Value();

	/**
	 * Returns the meta object for class '{@link grammar.Rule <em>Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rule</em>'.
	 * @see grammar.Rule
	 * @generated
	 */
	EClass getRule();

	/**
	 * Returns the meta object for the containment reference '{@link grammar.Rule#getExpressedAs <em>Expressed As</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expressed As</em>'.
	 * @see grammar.Rule#getExpressedAs()
	 * @see #getRule()
	 * @generated
	 */
	EReference getRule_ExpressedAs();

	/**
	 * Returns the meta object for class '{@link grammar.GrammarElement <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Element</em>'.
	 * @see grammar.GrammarElement
	 * @generated
	 */
	EClass getGrammarElement();

	/**
	 * Returns the meta object for the attribute '{@link grammar.GrammarElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see grammar.GrammarElement#getName()
	 * @see #getGrammarElement()
	 * @generated
	 */
	EAttribute getGrammarElement_Name();

	/**
	 * Returns the meta object for class '{@link grammar.Shift <em>Shift</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Shift</em>'.
	 * @see grammar.Shift
	 * @generated
	 */
	EClass getShift();

	/**
	 * Returns the meta object for class '{@link grammar.Reduce <em>Reduce</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Reduce</em>'.
	 * @see grammar.Reduce
	 * @generated
	 */
	EClass getReduce();

	/**
	 * Returns the meta object for class '{@link grammar.Or <em>Or</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Or</em>'.
	 * @see grammar.Or
	 * @generated
	 */
	EClass getOr();

	/**
	 * Returns the meta object for the containment reference list '{@link grammar.Or#getContains <em>Contains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains</em>'.
	 * @see grammar.Or#getContains()
	 * @see #getOr()
	 * @generated
	 */
	EReference getOr_Contains();

	/**
	 * Returns the meta object for class '{@link grammar.Link <em>Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link</em>'.
	 * @see grammar.Link
	 * @generated
	 */
	EClass getLink();

	/**
	 * Returns the meta object for the attribute '{@link grammar.Link#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see grammar.Link#getName()
	 * @see #getLink()
	 * @generated
	 */
	EAttribute getLink_Name();

	/**
	 * Returns the meta object for the attribute '{@link grammar.Link#isUsePrefix <em>Use Prefix</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Use Prefix</em>'.
	 * @see grammar.Link#isUsePrefix()
	 * @see #getLink()
	 * @generated
	 */
	EAttribute getLink_UsePrefix();

	/**
	 * Returns the meta object for the reference '{@link grammar.Link#getElement <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Element</em>'.
	 * @see grammar.Link#getElement()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_Element();

	/**
	 * Returns the meta object for the containment reference '{@link grammar.Link#getContains <em>Contains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Contains</em>'.
	 * @see grammar.Link#getContains()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_Contains();

	/**
	 * Returns the meta object for class '{@link grammar.InlineRule <em>Inline Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Inline Rule</em>'.
	 * @see grammar.InlineRule
	 * @generated
	 */
	EClass getInlineRule();

	/**
	 * Returns the meta object for the attribute '{@link grammar.InlineRule#getSpecifier <em>Specifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Specifier</em>'.
	 * @see grammar.InlineRule#getSpecifier()
	 * @see #getInlineRule()
	 * @generated
	 */
	EAttribute getInlineRule_Specifier();

	/**
	 * Returns the meta object for the reference '{@link grammar.InlineRule#getRelatedRule <em>Related Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Related Rule</em>'.
	 * @see grammar.InlineRule#getRelatedRule()
	 * @see #getInlineRule()
	 * @generated
	 */
	EReference getInlineRule_RelatedRule();

	/**
	 * Returns the meta object for class '{@link grammar.Grammar <em>Grammar</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Grammar</em>'.
	 * @see grammar.Grammar
	 * @generated
	 */
	EClass getGrammar();

	/**
	 * Returns the meta object for the containment reference '{@link grammar.Grammar#getPackage <em>Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Package</em>'.
	 * @see grammar.Grammar#getPackage()
	 * @see #getGrammar()
	 * @generated
	 */
	EReference getGrammar_Package();

	/**
	 * Returns the meta object for the containment reference list '{@link grammar.Grammar#getHelper <em>Helper</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Helper</em>'.
	 * @see grammar.Grammar#getHelper()
	 * @see #getGrammar()
	 * @generated
	 */
	EReference getGrammar_Helper();

	/**
	 * Returns the meta object for the containment reference list '{@link grammar.Grammar#getToken <em>Token</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Token</em>'.
	 * @see grammar.Grammar#getToken()
	 * @see #getGrammar()
	 * @generated
	 */
	EReference getGrammar_Token();

	/**
	 * Returns the meta object for the containment reference list '{@link grammar.Grammar#getIgnoredToken <em>Ignored Token</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Ignored Token</em>'.
	 * @see grammar.Grammar#getIgnoredToken()
	 * @see #getGrammar()
	 * @generated
	 */
	EReference getGrammar_IgnoredToken();

	/**
	 * Returns the meta object for the containment reference list '{@link grammar.Grammar#getRule <em>Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rule</em>'.
	 * @see grammar.Grammar#getRule()
	 * @see #getGrammar()
	 * @generated
	 */
	EReference getGrammar_Rule();

	/**
	 * Returns the meta object for class '{@link grammar.IgnoredToken <em>Ignored Token</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ignored Token</em>'.
	 * @see grammar.IgnoredToken
	 * @generated
	 */
	EClass getIgnoredToken();

	/**
	 * Returns the meta object for class '{@link grammar.VirtualLink <em>Virtual Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Virtual Link</em>'.
	 * @see grammar.VirtualLink
	 * @generated
	 */
	EClass getVirtualLink();

	/**
	 * Returns the meta object for the attribute '{@link grammar.VirtualLink#getMultiplicity <em>Multiplicity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multiplicity</em>'.
	 * @see grammar.VirtualLink#getMultiplicity()
	 * @see #getVirtualLink()
	 * @generated
	 */
	EAttribute getVirtualLink_Multiplicity();

	/**
	 * Returns the meta object for class '{@link grammar.Package <em>Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Package</em>'.
	 * @see grammar.Package
	 * @generated
	 */
	EClass getPackage();

	/**
	 * Returns the meta object for enum '{@link grammar.Cardinality <em>Cardinality</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Cardinality</em>'.
	 * @see grammar.Cardinality
	 * @generated
	 */
	EEnum getCardinality();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	GrammarFactory getGrammarFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link grammar.impl.TokenImpl <em>Token</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.TokenImpl
		 * @see grammar.impl.GrammarPackageImpl#getToken()
		 * @generated
		 */
		EClass TOKEN = eINSTANCE.getToken();

		/**
		 * The meta object literal for the '<em><b>Token Expression</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TOKEN__TOKEN_EXPRESSION = eINSTANCE.getToken_TokenExpression();

		/**
		 * The meta object literal for the '{@link grammar.impl.HelperImpl <em>Helper</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.HelperImpl
		 * @see grammar.impl.GrammarPackageImpl#getHelper()
		 * @generated
		 */
		EClass HELPER = eINSTANCE.getHelper();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HELPER__VALUE = eINSTANCE.getHelper_Value();

		/**
		 * The meta object literal for the '{@link grammar.impl.RuleImpl <em>Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.RuleImpl
		 * @see grammar.impl.GrammarPackageImpl#getRule()
		 * @generated
		 */
		EClass RULE = eINSTANCE.getRule();

		/**
		 * The meta object literal for the '<em><b>Expressed As</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RULE__EXPRESSED_AS = eINSTANCE.getRule_ExpressedAs();

		/**
		 * The meta object literal for the '{@link grammar.impl.GrammarElementImpl <em>Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.GrammarElementImpl
		 * @see grammar.impl.GrammarPackageImpl#getGrammarElement()
		 * @generated
		 */
		EClass GRAMMAR_ELEMENT = eINSTANCE.getGrammarElement();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GRAMMAR_ELEMENT__NAME = eINSTANCE.getGrammarElement_Name();

		/**
		 * The meta object literal for the '{@link grammar.impl.ShiftImpl <em>Shift</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.ShiftImpl
		 * @see grammar.impl.GrammarPackageImpl#getShift()
		 * @generated
		 */
		EClass SHIFT = eINSTANCE.getShift();

		/**
		 * The meta object literal for the '{@link grammar.impl.ReduceImpl <em>Reduce</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.ReduceImpl
		 * @see grammar.impl.GrammarPackageImpl#getReduce()
		 * @generated
		 */
		EClass REDUCE = eINSTANCE.getReduce();

		/**
		 * The meta object literal for the '{@link grammar.impl.OrImpl <em>Or</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.OrImpl
		 * @see grammar.impl.GrammarPackageImpl#getOr()
		 * @generated
		 */
		EClass OR = eINSTANCE.getOr();

		/**
		 * The meta object literal for the '<em><b>Contains</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OR__CONTAINS = eINSTANCE.getOr_Contains();

		/**
		 * The meta object literal for the '{@link grammar.impl.LinkImpl <em>Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.LinkImpl
		 * @see grammar.impl.GrammarPackageImpl#getLink()
		 * @generated
		 */
		EClass LINK = eINSTANCE.getLink();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINK__NAME = eINSTANCE.getLink_Name();

		/**
		 * The meta object literal for the '<em><b>Use Prefix</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINK__USE_PREFIX = eINSTANCE.getLink_UsePrefix();

		/**
		 * The meta object literal for the '<em><b>Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__ELEMENT = eINSTANCE.getLink_Element();

		/**
		 * The meta object literal for the '<em><b>Contains</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__CONTAINS = eINSTANCE.getLink_Contains();

		/**
		 * The meta object literal for the '{@link grammar.impl.InlineRuleImpl <em>Inline Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.InlineRuleImpl
		 * @see grammar.impl.GrammarPackageImpl#getInlineRule()
		 * @generated
		 */
		EClass INLINE_RULE = eINSTANCE.getInlineRule();

		/**
		 * The meta object literal for the '<em><b>Specifier</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INLINE_RULE__SPECIFIER = eINSTANCE.getInlineRule_Specifier();

		/**
		 * The meta object literal for the '<em><b>Related Rule</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INLINE_RULE__RELATED_RULE = eINSTANCE.getInlineRule_RelatedRule();

		/**
		 * The meta object literal for the '{@link grammar.impl.GrammarImpl <em>Grammar</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.GrammarImpl
		 * @see grammar.impl.GrammarPackageImpl#getGrammar()
		 * @generated
		 */
		EClass GRAMMAR = eINSTANCE.getGrammar();

		/**
		 * The meta object literal for the '<em><b>Package</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GRAMMAR__PACKAGE = eINSTANCE.getGrammar_Package();

		/**
		 * The meta object literal for the '<em><b>Helper</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GRAMMAR__HELPER = eINSTANCE.getGrammar_Helper();

		/**
		 * The meta object literal for the '<em><b>Token</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GRAMMAR__TOKEN = eINSTANCE.getGrammar_Token();

		/**
		 * The meta object literal for the '<em><b>Ignored Token</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GRAMMAR__IGNORED_TOKEN = eINSTANCE.getGrammar_IgnoredToken();

		/**
		 * The meta object literal for the '<em><b>Rule</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GRAMMAR__RULE = eINSTANCE.getGrammar_Rule();

		/**
		 * The meta object literal for the '{@link grammar.impl.IgnoredTokenImpl <em>Ignored Token</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.IgnoredTokenImpl
		 * @see grammar.impl.GrammarPackageImpl#getIgnoredToken()
		 * @generated
		 */
		EClass IGNORED_TOKEN = eINSTANCE.getIgnoredToken();

		/**
		 * The meta object literal for the '{@link grammar.impl.VirtualLinkImpl <em>Virtual Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.VirtualLinkImpl
		 * @see grammar.impl.GrammarPackageImpl#getVirtualLink()
		 * @generated
		 */
		EClass VIRTUAL_LINK = eINSTANCE.getVirtualLink();

		/**
		 * The meta object literal for the '<em><b>Multiplicity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VIRTUAL_LINK__MULTIPLICITY = eINSTANCE.getVirtualLink_Multiplicity();

		/**
		 * The meta object literal for the '{@link grammar.impl.PackageImpl <em>Package</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.impl.PackageImpl
		 * @see grammar.impl.GrammarPackageImpl#getPackage()
		 * @generated
		 */
		EClass PACKAGE = eINSTANCE.getPackage();

		/**
		 * The meta object literal for the '{@link grammar.Cardinality <em>Cardinality</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see grammar.Cardinality
		 * @see grammar.impl.GrammarPackageImpl#getCardinality()
		 * @generated
		 */
		EEnum CARDINALITY = eINSTANCE.getCardinality();

	}

} //GrammarPackage
