/**
 * <copyright>
 * </copyright>
 *
 * $Id: GrammarSwitch.java,v 1.3 2007-03-05 10:47:36 sgabel Exp $
 */
package grammar.util;

import grammar.Grammar;
import grammar.GrammarElement;
import grammar.GrammarPackage;
import grammar.Helper;
import grammar.IgnoredToken;
import grammar.InlineRule;
import grammar.Link;
import grammar.Or;
import grammar.Reduce;
import grammar.Rule;
import grammar.Shift;
import grammar.Token;
import grammar.VirtualLink;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see grammar.GrammarPackage
 * @generated
 */
public class GrammarSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static GrammarPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GrammarSwitch() {
		if (modelPackage == null)
		{
			modelPackage = GrammarPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage)
		{
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else
		{
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID)
		{
			case GrammarPackage.TOKEN:
			{
				Token token = (Token)theEObject;
				T result = caseToken(token);
				if (result == null) result = caseGrammarElement(token);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.HELPER:
			{
				Helper helper = (Helper)theEObject;
				T result = caseHelper(helper);
				if (result == null) result = caseGrammarElement(helper);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.RULE:
			{
				Rule rule = (Rule)theEObject;
				T result = caseRule(rule);
				if (result == null) result = caseGrammarElement(rule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.GRAMMAR_ELEMENT:
			{
				GrammarElement grammarElement = (GrammarElement)theEObject;
				T result = caseGrammarElement(grammarElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.SHIFT:
			{
				Shift shift = (Shift)theEObject;
				T result = caseShift(shift);
				if (result == null) result = caseLink(shift);
				if (result == null) result = caseVirtualLink(shift);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.REDUCE:
			{
				Reduce reduce = (Reduce)theEObject;
				T result = caseReduce(reduce);
				if (result == null) result = caseLink(reduce);
				if (result == null) result = caseVirtualLink(reduce);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.OR:
			{
				Or or = (Or)theEObject;
				T result = caseOr(or);
				if (result == null) result = caseVirtualLink(or);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.LINK:
			{
				Link link = (Link)theEObject;
				T result = caseLink(link);
				if (result == null) result = caseVirtualLink(link);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.INLINE_RULE:
			{
				InlineRule inlineRule = (InlineRule)theEObject;
				T result = caseInlineRule(inlineRule);
				if (result == null) result = caseRule(inlineRule);
				if (result == null) result = caseGrammarElement(inlineRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.GRAMMAR:
			{
				Grammar grammar = (Grammar)theEObject;
				T result = caseGrammar(grammar);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.IGNORED_TOKEN:
			{
				IgnoredToken ignoredToken = (IgnoredToken)theEObject;
				T result = caseIgnoredToken(ignoredToken);
				if (result == null) result = caseGrammarElement(ignoredToken);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.VIRTUAL_LINK:
			{
				VirtualLink virtualLink = (VirtualLink)theEObject;
				T result = caseVirtualLink(virtualLink);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case GrammarPackage.PACKAGE:
			{
				grammar.Package package_ = (grammar.Package)theEObject;
				T result = casePackage(package_);
				if (result == null) result = caseGrammarElement(package_);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Token</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Token</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToken(Token object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Helper</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Helper</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseHelper(Helper object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRule(Rule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGrammarElement(GrammarElement object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Shift</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Shift</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseShift(Shift object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Reduce</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Reduce</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseReduce(Reduce object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Or</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Or</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOr(Or object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Link</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLink(Link object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Inline Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Inline Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInlineRule(InlineRule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Grammar</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Grammar</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGrammar(Grammar object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Ignored Token</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Ignored Token</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIgnoredToken(IgnoredToken object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Virtual Link</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Virtual Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVirtualLink(VirtualLink object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Package</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Package</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePackage(grammar.Package object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //GrammarSwitch
