/*******************************************************************************
 * Copyright (c) 2000, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.ftp;

import org.eclipse.core.runtime.*;
import org.eclipse.ftp.internal.FtpPlugin;

/**
 * FTP specific exception.
 * 
 * <p>
 * <b>Note:</b> This class/interface is part of an interim API that is still under 
 * development and expected to change significantly before reaching stability. 
 * It is being made available at this early stage to solicit feedback from pioneering 
 * adopters on the understanding that any code that uses this API will almost 
 * certainly be broken (repeatedly) as the API evolves.
 * </p>
 * 
 * @since 3.1
 */
public class FtpException extends CoreException {

	/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 1L;

    /**
	 * Create an FTP exception with the given status
	 * @param status the exception's status
	 */
	public FtpException(IStatus status) {
		super(status);
	}
	
	public FtpException(String message, int code) {
		this(new Status(IStatus.ERROR, FtpPlugin.ID, code, message, null));
	}

}
