/*******************************************************************************
 * Copyright (c) 2000, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.ftp.internal;

import org.eclipse.ftp.FtpException;
import org.eclipse.ftp.IDirectoryEntry;

/**
 * Abstract superclass of FTP diretory entry parsers
 */
public abstract class DirectoryEntryParser {

	/**
	 * Parse the entry line and return the resulting directory entry.
	 * A return value of <code>null</code> indicates that the parse failed.
	 * TODO: Could throw an exception to indicate?
	 * @param line
	 * @return
	 * @throws FtpException
	 */
	public abstract IDirectoryEntry parseEntry(String line) throws FtpException;

	public abstract boolean isReliable();
}
