/*******************************************************************************
 * Copyright (c) 2000, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.team.internal.webdav.ui.subscriber;

import org.eclipse.jface.viewers.ISelectionProvider;
import org.eclipse.team.core.synchronize.SyncInfoSet;
import org.eclipse.team.internal.target.subscriber.ITargetOperations;
import org.eclipse.team.internal.target.ui.PutAction;
import org.eclipse.team.internal.webdav.core.Policy;
import org.eclipse.team.internal.webdav.core.TeamWebDavPlugin;
import org.eclipse.team.ui.synchronize.ISynchronizePageConfiguration;

public class WebDavPutAction extends PutAction {

	protected WebDavPutAction(ISynchronizePageConfiguration configuration) {
		super(configuration, configuration.getSite().getSelectionProvider(), "WebDavPutAction.", Policy.getBundle()); //$NON-NLS-1$
	}

	public WebDavPutAction(ISynchronizePageConfiguration configuration, ISelectionProvider provider, String string) {
		super(configuration, provider, string, Policy.getBundle());
	}

	protected String getJobName(SyncInfoSet syncSet) {
		return Policy.bind("WebDavPutAction.0", new Integer(syncSet.size()).toString()); //$NON-NLS-1$
	}

	protected ITargetOperations getTargetOperations() {
		return TeamWebDavPlugin.getPlugin().getSubscriber().getTeamOperations();
	}

}
