/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.bus.core;

import java.util.HashSet;
import java.util.Set;

public class BasicServices
{
	// List of the id of the services that are considered as basic ones.
	private static Set<String> basicServicesId = new HashSet<String>();

	static
	{
		basicServicesId.add("org.topcased.service.rw.read");
		basicServicesId.add("org.topcased.service.rw.write");
		basicServicesId.add(IServiceCst.WRITE_EMF_XMI);
		basicServicesId.add(IServiceCst.READ_XMI_EMF);
		basicServicesId.add(IServiceCst.PUBLISH_METAMODEL);
	}

	/**
	 * This function is used to determine whether a service is a basic one or not
	 * 
	 * @param serviceId the id of the service
	 * @return true is the service is a basic one, false otherwise
	 */
	public static boolean isBasicService(String serviceId)
	{
		return basicServicesId.contains(serviceId);
	}
}
