/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.bus.core;

import java.util.Map;

/**
 * Interface defining the behavior of a "Topcased Service".<br>
 * For the moment only one method must be implemented.
 */
public interface IService
{
	/**
	 * The Topcased Bus launches serviceRun() method of a service
	 * 
	 * @param parameters : parameters Map (key = parameter name, value = Object parameter)
	 * @return an Object in order to chain service if it is required
	 */
	public Object serviceRun(Map<String, Object> parameters);
}
