/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.bus.core;

/**
 * Interface aimed to gather all the identifier of the main implemented Topcased services.<br>
 * Only the most useful services are listed here.
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 */
public interface IServiceCst
{
	public static final String TRANSFORMATION = "org.topcased.service.transformation";
	
	public static final String READ_XMI_EMF = "org.topcased.service.readxmiemf.read";
	
	public static final String WRITE_EMF_XMI = "org.topcased.service.writeemfxmi.write";
	
	public static final String CHANGE_URI = "org.topcased.service.changeuri";
	
	public static final String PUBLISH_METAMODEL = "org.topcased.service.publishmetamodel";
	
	public static final String OCL_CHECKER = "org.topcased.service.oclchecker.checkService";
	
	public static final String OCL_STATISTIC = "org.topcased.service.oclchecker.statisticService";
}
