/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.bus.core.parameter;

/**
 * This class gathers constants representing parameter name used during Topcased Service execution.<br>
 * Here must figure all the declarated service parameters defined in all extension points.
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 */
public final class ParameterCst
{

	/**
	 * Constant used in WriteEmfXmi, OCLChecker Services
	 */
	public static final String MODEL = "Model";
	
	/**
	 * Second constant used in WriteEmfXmi Service
	 */
	public static final String PATH_FILE_STRING = "PathFileString";
	
	/**
	 * First constant used in ReadXmiEmf Service
	 */
	public static final String XMI_FILE = "XMIFile";
	
	/**
	 * Constant used in the OCL checker service 
	 */
	public static final String OCL_RULE = "OCLRule";
	
	/**
	 * Constant used in the OCL statistic service 
	 */
	public static final String CONTEXT = "Context";
	
	/**
	 * Constant representing the URL to contact to join the MDDI registry.
	 */
	public final static String MODELBUS_REGISTRY = "registry_location";
	
}
