/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.externalbus.core;

/**
 * Handles the class ExternalParameter which is parameter of a ExternalService. It is defined by :
 * <ul>
 * <li>id : The identifier of the parameter</li>
 * <li>name : The name of the parameter</li>
 * <li>description : A short description</li>
 * <li>kind : Kind of the parameter</li>
 * </ul>
 * <br>
 */
public class ExternalParameter
{
	private String id = "";

	private String name = "";

	private String description = "";

	private String kind = "";

	/**
	 * Constructor
	 * 
	 * @param paramId : parameter id
	 * @param paramName : parameter name
	 * @param paramDescription : parameter description
	 * @param paramKind : parameter kind
	 */
	public ExternalParameter(String paramId, String paramName, String paramDescription, String paramKind)
	{
		id = paramId;
		name = paramName;
		description = paramDescription;
		kind = paramKind;
	}

	/**
	 * Gets the parameter <b>id</b> of this parameter
	 * 
	 * @return the attribute id
	 */
	public String getIdParam()
	{
		return id;
	}

	/**
	 * Gets the attribute <b>name</b> of this parameter
	 * 
	 * @return the attribute name
	 */
	public String getNameParam()
	{
		return name;
	}

	/**
	 * Gets the attribute <b>description</b> of this parameter
	 * 
	 * @return the attribute description
	 */
	public String getDescriptionParam()
	{
		return description;
	}

	/**
	 * Gets the attribute <b>kind</b> of this parameter
	 * 
	 * @return the attribute kind
	 */
	public String getKindParam()
	{
		return kind;
	}
}
