package org.topcased.facilities.dialogs;

import org.eclipse.core.runtime.IPath;

/**
 * This interface stores the constants used during the various Topcased wizard.<br>
 * It enables to reach some common icons and images.
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 */
public interface ITopcasedWizardConstants
{
    /**
     * Folder where are stored the images resources.
     */
    String IMG_FOLDER = "icons";

    /**
     * Main Topcased logo find in all Topcased Wizard (right top corner)
     */
    String TOPCASED_LOGO_PATH = IMG_FOLDER + IPath.SEPARATOR + "topcased-logo.gif";

    /**
     * File Image (used in T2P plug-in)
     */
    String FILE_IMG = IMG_FOLDER + IPath.SEPARATOR + "file.gif";

    /**
     * Directory Image (used in T2P plug-in)
     */
    String DIRECTORY_IMG = IMG_FOLDER + IPath.SEPARATOR + "directory.gif";
}
