/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.generator.services.generation;

/**
 * Final class containing constants used during the JET generation. 
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 */
public final class TopcasedBusServicesConstants
{
	/////////////////
	/// Keys  ///
	///////////////
	/**
	 * Key for the <i>First Name</i>
	 */
	public static final String FIRST_NAME_KEY = "firstname";

	/**
	 * Default value for the first name.
	 */
	public static final String FIRST_NAME_VALUE = "Donald";

	/**
	 * Key for the <i>Last Name</i>
	 */
	public static final String LAST_NAME_KEY = "lastname";

	/**
	 * Default value for the last name.
	 */
	public static final String LAST_NAME_VALUE = "Duck";
	
	/////////////////
	/// Folders  ///
	///////////////
	/**
	 * Constant representing the <i>source</i> folder.
	 */
	public static final String SOURCE_DIRECTORY = "src";
	
	/**
	 * Constant representing the <i>action</i> folder.
	 */
	public static final String ACTION_DIRECTORY = "actions";
	
	/**
	 * Constant representing the <i>services</i> folder.
	 */
	public static final String SERVICE_DIRECTORY = "services";
	
	/**
	 * Constant representing the <i>preferences</i> folder.
	 */
	public static final String PREFERENCE_DIRECTORY = "preferences";
	
	/**
	 * Constant representing the <i>dialog</i> folder.
	 */
	public static final String DIALOG_DIRECTORY = "dialog";
	
	///////////////
	/// Files  ///
	/////////////
	/**
	 * Constant representing the <i>plugin</i> file.
	 */
	public static final String PLUGIN_FILE = "Activator.java";
	
	/**
	 * Constant representing the <i>action</i> file.
	 */
	public static final String ACTION_FILE = "LaunchAction.java";
	
	/**
	 * Constant representing the <i>preferences</i> file.
	 */
	public static final String SERVICE_FILE = "SampleService.java";
	
	/**
	 * Constant representing the <i>Preference</i> file.
	 */
	public static final String PREFERENCE_FILE = "NewPreferencePage.java";
	
	/**
	 * Constant representing the <i>Dialog</i> file.
	 */
	public static final String DIALOG_FILE = "SampleDialog.java";
	
	/**
	 * Constant representing the <i>Dialog Constant</i> file.
	 */
	public static final String DIALOG_CST_FILE = "SampleDialogConstants.java";
	
	
	///////////////////
	/// Templates  ///
	/////////////////
	/**
	 * 
	 */
	public static final String PLUGIN_TEMPLATE_PATH = "templates/Activator.javajet";
	
	/**
	 * Constant representing the <i>Action</i> template file.
	 */
	public static final String ACTION_TEMPLATE_PATH = "templates/LaunchAction.javajet";
	
	/**
	 * Constant representing the <i>Service</i> template file.
	 */
	public static final String SERVICE_TEMPLATE_PATH = "templates/SampleService.javajet";
	
	/**
	 * Constant representing the <i>Preference</i> template file.
	 */
	public static final String PREFERENCE_TEMPLATE_PATH = "templates/NewPreferencePage.javajet";
	
	/**
	 * Constant representing the <i>Sample Dialog</i> template file.
	 */
	public static final String DIALOG_TEMPLATE_PATH = "templates/SampleDialog.javajet";
	
	/**
	 * Constant representing the <i>Sample Dialog Constant</i> template file.
	 */
	public static final String DIALOG_CST_TEMPLATE_PATH = "templates/SampleDialogConstants.javajet";
}
