/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), 
 *    Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies),
 *    Thomas Friol (Anyware Technologies)
 *    - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.commands;

import java.util.Map;

import org.eclipse.emf.ecore.EModelElement;

/**
 * A class defining a command to add resources to an EModelElement
 * documentation.<br/> Creation : 10 oct. 2005
 * 
 * @author <a href="mailto:thomas.friol@anyware-tech.com">Thomas FRIOL</a>
 */
public class AddDocumentationResourcesCommand extends AbstractDocumentationResourcesCommand
{
    public AddDocumentationResourcesCommand(EModelElement element, Map resources)
    {
        super(element, resources);
        setLabel("Add resources to EModelElement documentation");
    }

    public void execute()
    {
        redo();
    }

    public void redo()
    {
        addResources();
    }

    public void undo()
    {
        removeResources();
    }

}
