/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), 
 *    Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies),
 *    Thomas Friol (Anyware Technologies)
 *    - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.commands;

import org.eclipse.emf.common.util.BasicEMap;
import org.eclipse.gef.commands.Command;

/**
 * A class defining a command to edit a resource within an EModelElement
 * documentation.<br/> Creation : 10 oct. 2005
 * 
 * @author <a href="mailto:thomas.friol@anyware-tech.com">Thomas FRIOL</a>
 */
public class EditDocumentationResourcesCommand extends Command
{
    private BasicEMap.Entry resource;

    private String newResourceValue;

    private String oldResourceValue;

    public EditDocumentationResourcesCommand(BasicEMap.Entry resource, String newResourceValue)
    {
        super("Edit resource within EModelElement documentation");

        this.resource = resource;
        this.newResourceValue = newResourceValue;
    }

    public void execute()
    {
        oldResourceValue = (String) resource.getValue();
        redo();
    }

    public void redo()
    {
        resource.setValue(newResourceValue);
    }

    public void undo()
    {
        resource.setValue(oldResourceValue);
    }

}
