/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.ecore.ediagram;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.impl.EStringToStringMapEntryImpl;
import org.eclipse.emf.ecore.util.EcoreSwitch;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;

/**
 * This utility class allows to create a GraphElement associated with a Model
 * Object <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class EcoreCreationUtils extends AbstractCreationUtils
{
    /**
     * Constructor
     * 
     * @param diagramConf the Diagram Graphical Configurator
     */
    public EcoreCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private class GraphicEcoreSwitch extends EcoreSwitch<Object>
    {
        /** The presentation of the graphical element */
        private String presentation;

        /**
         * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicEcoreSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEPackage(org.eclipse.emf.ecore.EPackage)
         * @generated
         */
        public Object caseEPackage(org.eclipse.emf.ecore.EPackage object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEPackage(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEClass(org.eclipse.emf.ecore.EClass)
         * @generated
         */
        public Object caseEClass(org.eclipse.emf.ecore.EClass object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEClass(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEDataType(org.eclipse.emf.ecore.EDataType)
         * @generated
         */
        public Object caseEDataType(org.eclipse.emf.ecore.EDataType object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEDataType(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEEnum(org.eclipse.emf.ecore.EEnum)
         * @generated
         */
        public Object caseEEnum(org.eclipse.emf.ecore.EEnum object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEEnum(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEAnnotation(org.eclipse.emf.ecore.EAnnotation)
         * @generated
         */
        public Object caseEAnnotation(org.eclipse.emf.ecore.EAnnotation object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEAnnotation(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEOperation(org.eclipse.emf.ecore.EOperation)
         * @generated
         */
        public Object caseEOperation(org.eclipse.emf.ecore.EOperation object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEOperation(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEAttribute(org.eclipse.emf.ecore.EAttribute)
         * @generated
         */
        public Object caseEAttribute(org.eclipse.emf.ecore.EAttribute object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEAttribute(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEEnumLiteral(org.eclipse.emf.ecore.EEnumLiteral)
         * @generated
         */
        public Object caseEEnumLiteral(org.eclipse.emf.ecore.EEnumLiteral object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEEnumLiteral(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEStringToStringMapEntry(java.util.Map.Entry)
         * @generated NOT
         */
        public Object caseEStringToStringMapEntry(java.util.Map.Entry<String, String> object)
        {
            if ("default".equals(presentation) && object instanceof EStringToStringMapEntryImpl)
            {
                return createGraphElementEStringToStringMapEntry((EStringToStringMapEntryImpl) object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#caseEReference(org.eclipse.emf.ecore.EReference)
         * @generated
         */
        public Object caseEReference(org.eclipse.emf.ecore.EReference object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEReference(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.emf.ecore.util.EcoreSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated
     */
    public EObject createModelObject(EObject obj)
    {
        return obj;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;

        if ("http://www.eclipse.org/emf/2002/Ecore".equals(obj.eClass().getEPackage().getNsURI()))
        {
            graphElt = new GraphicEcoreSwitch(presentation).doSwitch(obj);
        }

        return (GraphElement) graphElt;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEPackage(org.eclipse.emf.ecore.EPackage element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementEClass(org.eclipse.emf.ecore.EClass element, String presentation)
    {
        GraphNode eClass = createGraphNode(element, presentation);
        GraphNode eAttributes = createGraphNode(element, EcorePackage.ECLASS__ESTRUCTURAL_FEATURES);
        GraphNode eOperations = createGraphNode(element, EcorePackage.ECLASS__EOPERATIONS);
        eAttributes.setContainer(eClass);
        eOperations.setContainer(eClass);
        return eClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEDataType(org.eclipse.emf.ecore.EDataType element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementEEnum(org.eclipse.emf.ecore.EEnum element, String presentation)
    {
        GraphNode eEnum = createGraphNode(element, presentation);
        GraphNode literals = createGraphNode(element, EcorePackage.EENUM__ELITERALS);
        literals.setContainer(eEnum);
        return eEnum;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementEAnnotation(org.eclipse.emf.ecore.EAnnotation element, String presentation)
    {
        GraphNode eAnnotation = createGraphNode(element, presentation);
        GraphNode details = createGraphNode(element, EcorePackage.EANNOTATION__DETAILS);
        details.setContainer(eAnnotation);
        return eAnnotation;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEOperation(org.eclipse.emf.ecore.EOperation element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEAttribute(org.eclipse.emf.ecore.EAttribute element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEEnumLiteral(org.eclipse.emf.ecore.EEnumLiteral element,
            String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementEStringToStringMapEntry(EStringToStringMapEntryImpl element,
            String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementEReference(org.eclipse.emf.ecore.EReference element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);

        // Create 2 edge objects to display the cardinality and the name of the
        // EReference
        EdgeObjectUV nameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        nameEdgeObjectUV.setId(EcoreEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectUV.setUDistance(20);
        nameEdgeObjectUV.setVDistance(20);
        graphEdge.getContained().add(nameEdgeObjectUV);

        EdgeObjectUV multiplicityEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        multiplicityEdgeObjectUV.setId(EcoreEdgeObjectConstants.MULTIPLICITY_EDGE_OBJECT_ID);
        multiplicityEdgeObjectUV.setUDistance(20);
        multiplicityEdgeObjectUV.setVDistance(-20);
        graphEdge.getContained().add(multiplicityEdgeObjectUV);

        return graphEdge;
    }

}
