/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.ecore.ediagram;

/**
 * A collection of Roles. Each identifier is used to key the EditPolicy.
 * Creation : 03 april 2005
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public interface EcoreEditPolicyConstants
{

    /** The key used to install an <i>EPackage</i> EditPolicy. */
    String EPACKAGE_EDITPOLICY = "EPackage EditPolicy";

    /** The key used to install an <i>EClass</i> EditPolicy. */
    String ECLASS_EDITPOLICY = "EClass EditPolicy";

    /** The key used to install an <i>EOperation</i> EditPolicy. */
    String EOPERATION_EDITPOLICY = "EOperation EditPolicy";

    /** The key used to install an <i>EAttribute</i> EditPolicy. */
    String EATTRIBUTE_EDITPOLICY = "EAttribute EditPolicy";

    /** The key used to install an <i>EDataType</i> EditPolicy. */
    String EDATATYPE_EDITPOLICY = "EDataType EditPolicy";

    /** The key used to install an <i>EEnum</i> EditPolicy. */
    String EENUM_EDITPOLICY = "EEnum EditPolicy";

    /** The key used to install an <i>EEnumLiteral</i> EditPolicy. */
    String EENUMLITERAL_EDITPOLICY = "EEnumLiteral EditPolicy";

    /** The key used to install an <i>EAnnotation</i> EditPolicy. */
    String EANNOTATION_EDITPOLICY = "EAnnotation EditPolicy";

    /** The key used to install an <i>EStringToStringMapEntry</i> EditPolicy. */
    String ESTRINGTOSTRINGMAPENTRY_EDITPOLICY = "EStringToStringMapEntry EditPolicy";

    /** The key used to install an <i>EModelElement</i> EditPolicy. */
    String EMODELELEMENT_EDITPOLICY = "EModelElement EditPolicy";

    /** The key used to install an <i>EReference</i> EditPolicy. */
    String EREFERENCE_EDITPOLICY = "EReference EditPolicy";

    /** The key used to install an <i>Inheritance</i> EditPolicy. */
    String INHERITANCE_EDITPOLICY = "Inheritance EditPolicy";

    /** The key used to install an <i>AnnotationLink</i> EditPolicy. */
    String ANNOTATIONLINK_EDITPOLICY = "AnnotationLink EditPolicy";

    /**
     * The key used to install a <i>Two-way Reference</i> EditPolicy.
     */
    String TWOWAYREFERENCEEDITPOLICY = "Two Way Reference EditPolicy";

    /**
     * The key used to install a <i>Delete Inheritance Link</i> EditPolicy.
     */
    String DELETE_INHERITANCE_LINK_EDITPOLICY = "Delete Inheritance Link EditPolicy";

}
