/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.ecore.ediagram.figures;

import org.eclipse.draw2d.AbstractBorder;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Insets;
import org.topcased.draw2d.figures.EditableLabel;
import org.topcased.draw2d.figures.Label;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class EDataTypeFigure extends org.topcased.draw2d.figures.ClassFigure
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EDataTypeFigure()
    {
        super();
    }

    /**
     * @see org.topcased.draw2d.figures.ClassFigure#drawFigure()
     */
    protected void drawFigure()
    {
        ToolbarLayout toolbarLayout = new ToolbarLayout();
        toolbarLayout.setMinorAlignment(ToolbarLayout.ALIGN_CENTER);
        toolbarLayout.setStretchMinorAxis(true);
        setBorder(new LineBorder());
        setLayoutManager(toolbarLayout);
        setOpaque(true);

        add(new Label("<<datatype>>"));
        setLabel(new EditableLabel());
        add(getLabel());

        setContentPane(new Figure());
        ToolbarLayout toolbarLayout2 = new ToolbarLayout();
        toolbarLayout2.setMinorAlignment(ToolbarLayout.ALIGN_CENTER);
        getContentPane().setLayoutManager(toolbarLayout2);
        getContentPane().setBorder(new DataTypeFigureBorder());
        add(getContentPane());
        getContentPane().add(new Label());
    }

    /**
     * Inner class that draw the Border of the DataTypeFigure
     * 
     */
    public static class DataTypeFigureBorder extends AbstractBorder
    {
        private static final Insets INSETS = new Insets(3);

        /**
         * Get the Insets of the Borders
         * 
         * @see org.eclipse.draw2d.Border#getInsets(org.eclipse.draw2d.IFigure)
         */
        public Insets getInsets(IFigure figure)
        {
            return INSETS;
        }

        /**
         * Draw the Borders
         * 
         * @see org.eclipse.draw2d.Border#paint(org.eclipse.draw2d.IFigure,
         *      org.eclipse.draw2d.Graphics, org.eclipse.draw2d.geometry.Insets)
         */
        public void paint(IFigure figure, Graphics graphics, Insets insets)
        {
            graphics.drawLine(getPaintRectangle(figure, insets).getTopLeft(), tempRect.getTopRight());
        }
    }

}
