/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.ecore.ediagram.policies;

import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EEnumLiteral;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreateRequest;
import org.topcased.modeler.commands.CreateGraphNodeCommand;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.ClassLayoutEditPolicy;
import org.topcased.modeler.utils.Utils;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class EEnumLayoutEditPolicy extends ClassLayoutEditPolicy
{
    /**
     * Default contructor.<br>
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EEnumLayoutEditPolicy()
    {
        super();
    }

    /**
     * @see org.topcased.modeler.edit.policies.ClassLayoutEditPolicy#getCreateCommand(org.eclipse.gef.requests.CreateRequest)
     */
    protected Command getCreateCommand(CreateRequest request)
    {
        Command command = super.getCreateCommand(request);

        // Automatically increment the EEnumLiteral value.
        if (command instanceof CreateGraphNodeCommand && request.getNewObject() instanceof GraphNode
                && Utils.getElement((GraphElement) request.getNewObject()) instanceof EEnumLiteral)
        {
            EEnumLiteral childLiteral = (EEnumLiteral) Utils.getElement((GraphElement) request.getNewObject());
            EEnum eEnum = (EEnum) Utils.getElement((GraphElement) getHost().getModel());
            int cpt = 0;

            // We search for the first available value
            while (eEnum.getEEnumLiteral(cpt) != null)
            {
                cpt++;
            }

            childLiteral.setValue(cpt);
        }

        return command;
    }

}