/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), 
 *    Mathieu Garcia (Anyware Technologies), 
 *    Jacques Lescot (Anyware Technologies),
 *    Thomas Friol (Anyware Technologies)
 *    - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.ecore.editor.outline;

import org.eclipse.emf.ecore.EPackage;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.swt.graphics.Image;
import org.topcased.modeler.ecore.EcoreImageRegistry;
import org.topcased.modeler.editor.outline.ModelLabelProvider;

/**
 * The label provider <br>
 * creation : 19 déc. 2005
 * 
 * @author <a href="mailto:david.sciamma@anyware-tech.com">David Sciamma</a>
 */
public class EcoreLabelProvider extends ModelLabelProvider
{

    /**
     * Constructor
     * 
     * @param delegatedProvider the ecore provider
     */
    public EcoreLabelProvider(ILabelProvider delegatedProvider)
    {
        super(delegatedProvider);
    }

    /**
     * @see org.topcased.modeler.editor.outline.ModelLabelProvider#getText(java.lang.Object)
     */
    public String getText(Object element)
    {
        if (element instanceof EPackage.Registry)
        {
            return "Registered Packages";
        }
        return super.getText(element);
    }

    /**
     * @see org.topcased.modeler.editor.outline.ModelLabelProvider#getImage(java.lang.Object)
     */
    public Image getImage(Object element)
    {
        if (element instanceof RegisteredPackage)
        {
            return EcoreImageRegistry.getImage("REGISTERED_PACKAGE");
        }
        return super.getImage(element);
    }
}
