/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), 
 *    Mathieu Garcia (Anyware Technologies), 
 *    Jacques Lescot (Anyware Technologies),
 *    Thomas Friol (Anyware Technologies)
 *    - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.ecore.editor.outline;

import org.eclipse.emf.ecore.EPackage;

/**
 * Helper class to allow lazy loading of a package in the outline <br>
 * creation : 19 déc. 2005
 * 
 * @author <a href="mailto:david.sciamma@anyware-tech.com">David Sciamma</a>
 */
public class RegisteredPackage
{
    private String uri;

    /**
     * Constructor
     * 
     * @param uri the package uri
     */
    public RegisteredPackage(String uri)
    {
        super();
        this.uri = uri;
    }

    /**
     * Returns the Ecore package associated with the current uri
     * 
     * @return the registered EPackage
     */
    public EPackage getEPackage()
    {
        return EPackage.Registry.INSTANCE.getEPackage(uri);
    }

    /**
     * @see java.lang.Object#toString()
     */
    public String toString()
    {
        return uri;
    }
}
