/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.ecore.providers;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.ecore.util.EcoreAdapterFactory;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.topcased.modeler.providers.ILabelFeatureProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers. The adapters generated by this
 * factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The adapters
 * also support Eclipse property sheets. Note that most of the adapters are shared among multiple instances. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class EcoreModelerProviderAdapterFactory extends EcoreAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
    /**
     * This keeps track of the root adapter factory that delegates to this adapter factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private Collection<Object> supportedTypes = new ArrayList<Object>();

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EAttribute} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EAttributeModelerProvider eattributeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EAnnotation} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EAnnotationModelerProvider eannotationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EClass} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClassModelerProvider eclassModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EClassifier} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClassifierModelerProvider eclassifierModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EDataType} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EDataTypeModelerProvider edatatypeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EEnum} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EEnumModelerProvider eenumModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EEnumLiteral} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EEnumLiteralModelerProvider eenumliteralModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EFactory} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EFactoryModelerProvider efactoryModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EModelElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EModelElementModelerProvider emodelelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.ENamedElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ENamedElementModelerProvider enamedelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EObject} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EObjectModelerProvider eobjectModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EOperation} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EOperationModelerProvider eoperationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EPackage} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EPackageModelerProvider epackageModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EParameter} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EParameterModelerProvider eparameterModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EReference} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EReferenceModelerProvider ereferenceModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.EStructuralFeature} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EStructuralFeatureModelerProvider estructuralfeatureModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.emf.ecore.ETypedElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ETypedElementModelerProvider etypedelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all org.eclipse.emf.ecore.EStringToStringMapEntry instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EStringToStringMapEntryModelerProvider estringtostringmapentryModelerProvider;

    /**
     * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EcoreModelerProviderAdapterFactory()
    {
        supportedTypes.add(ILabelFeatureProvider.class);
    }

    /**
     * This returns the root adapter factory that contains this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the root AdapterFactory
     * 
     * @generated
     */
    public ComposeableAdapterFactory getRootAdapterFactory()
    {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param parentAdapterFactory
     * 
     * @generated
     */
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
    {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param type the type to test
     * @return true if supported
     * 
     * @generated
     */
    public boolean isFactoryForType(Object type)
    {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the adapter. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @param notifier the notifier
     * @param type the object to adapt
     * @return the Adapter the created adatper
     * 
     * @generated
     */
    public Adapter adapt(Notifier notifier, Object type)
    {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param object the object to adapt
     * @param type the type to adapt
     * @return the adapted Object
     * 
     * @generated
     */
    public Object adapt(Object object, Object type)
    {
        if (isFactoryForType(type))
        {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class) || (((Class< ? >) type).isInstance(adapter)))
            {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param notifyChangedListener the listener to add
     * 
     * @generated
     */
    public void addListener(INotifyChangedListener notifyChangedListener)
    {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param notifyChangedListener the listener to remove
     * 
     * @generated
     */
    public void removeListener(INotifyChangedListener notifyChangedListener)
    {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @param notification
     * 
     * @generated
     */
    public void fireNotifyChanged(Notification notification)
    {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null)
        {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EAttribute}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEAttributeAdapter()
    {
        if (eattributeModelerProvider == null)
        {
            eattributeModelerProvider = new EAttributeModelerProvider(this);
        }

        return eattributeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EAnnotation}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEAnnotationAdapter()
    {
        if (eannotationModelerProvider == null)
        {
            eannotationModelerProvider = new EAnnotationModelerProvider(this);
        }

        return eannotationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EClass}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEClassAdapter()
    {
        if (eclassModelerProvider == null)
        {
            eclassModelerProvider = new EClassModelerProvider(this);
        }

        return eclassModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EClassifier}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEClassifierAdapter()
    {
        if (eclassifierModelerProvider == null)
        {
            eclassifierModelerProvider = new EClassifierModelerProvider(this);
        }

        return eclassifierModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EDataType}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEDataTypeAdapter()
    {
        if (edatatypeModelerProvider == null)
        {
            edatatypeModelerProvider = new EDataTypeModelerProvider(this);
        }

        return edatatypeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EEnum}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEEnumAdapter()
    {
        if (eenumModelerProvider == null)
        {
            eenumModelerProvider = new EEnumModelerProvider(this);
        }

        return eenumModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EEnumLiteral}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEEnumLiteralAdapter()
    {
        if (eenumliteralModelerProvider == null)
        {
            eenumliteralModelerProvider = new EEnumLiteralModelerProvider(this);
        }

        return eenumliteralModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EFactory}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEFactoryAdapter()
    {
        if (efactoryModelerProvider == null)
        {
            efactoryModelerProvider = new EFactoryModelerProvider(this);
        }

        return efactoryModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EModelElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEModelElementAdapter()
    {
        if (emodelelementModelerProvider == null)
        {
            emodelelementModelerProvider = new EModelElementModelerProvider(this);
        }

        return emodelelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.ENamedElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createENamedElementAdapter()
    {
        if (enamedelementModelerProvider == null)
        {
            enamedelementModelerProvider = new ENamedElementModelerProvider(this);
        }

        return enamedelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EObject}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEObjectAdapter()
    {
        if (eobjectModelerProvider == null)
        {
            eobjectModelerProvider = new EObjectModelerProvider(this);
        }

        return eobjectModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EOperation}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEOperationAdapter()
    {
        if (eoperationModelerProvider == null)
        {
            eoperationModelerProvider = new EOperationModelerProvider(this);
        }

        return eoperationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EPackage}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEPackageAdapter()
    {
        if (epackageModelerProvider == null)
        {
            epackageModelerProvider = new EPackageModelerProvider(this);
        }

        return epackageModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EParameter}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEParameterAdapter()
    {
        if (eparameterModelerProvider == null)
        {
            eparameterModelerProvider = new EParameterModelerProvider(this);
        }

        return eparameterModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EReference}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEReferenceAdapter()
    {
        if (ereferenceModelerProvider == null)
        {
            ereferenceModelerProvider = new EReferenceModelerProvider(this);
        }

        return ereferenceModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.EStructuralFeature}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEStructuralFeatureAdapter()
    {
        if (estructuralfeatureModelerProvider == null)
        {
            estructuralfeatureModelerProvider = new EStructuralFeatureModelerProvider(this);
        }

        return estructuralfeatureModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.emf.ecore.ETypedElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createETypedElementAdapter()
    {
        if (etypedelementModelerProvider == null)
        {
            etypedelementModelerProvider = new ETypedElementModelerProvider(this);
        }

        return etypedelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link java.util.Map.Entry}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEStringToStringMapEntryAdapter()
    {
        if (estringtostringmapentryModelerProvider == null)
        {
            estringtostringmapentryModelerProvider = new EStringToStringMapEntryModelerProvider(this);
        }

        return estringtostringmapentryModelerProvider;
    }

    /**
     * This disposes all of the item providers created by this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void dispose()
    {
        if (eattributeModelerProvider != null)
        {
            eattributeModelerProvider.dispose();
        }
        if (eannotationModelerProvider != null)
        {
            eannotationModelerProvider.dispose();
        }
        if (eclassModelerProvider != null)
        {
            eclassModelerProvider.dispose();
        }
        if (eclassifierModelerProvider != null)
        {
            eclassifierModelerProvider.dispose();
        }
        if (edatatypeModelerProvider != null)
        {
            edatatypeModelerProvider.dispose();
        }
        if (eenumModelerProvider != null)
        {
            eenumModelerProvider.dispose();
        }
        if (eenumliteralModelerProvider != null)
        {
            eenumliteralModelerProvider.dispose();
        }
        if (efactoryModelerProvider != null)
        {
            efactoryModelerProvider.dispose();
        }
        if (emodelelementModelerProvider != null)
        {
            emodelelementModelerProvider.dispose();
        }
        if (enamedelementModelerProvider != null)
        {
            enamedelementModelerProvider.dispose();
        }
        if (eobjectModelerProvider != null)
        {
            eobjectModelerProvider.dispose();
        }
        if (eoperationModelerProvider != null)
        {
            eoperationModelerProvider.dispose();
        }
        if (epackageModelerProvider != null)
        {
            epackageModelerProvider.dispose();
        }
        if (eparameterModelerProvider != null)
        {
            eparameterModelerProvider.dispose();
        }
        if (ereferenceModelerProvider != null)
        {
            ereferenceModelerProvider.dispose();
        }
        if (estructuralfeatureModelerProvider != null)
        {
            estructuralfeatureModelerProvider.dispose();
        }
        if (etypedelementModelerProvider != null)
        {
            etypedelementModelerProvider.dispose();
        }
        if (estringtostringmapentryModelerProvider != null)
        {
            estringtostringmapentryModelerProvider.dispose();
        }
    }

}
