/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies) - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.edit.policies;

import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;

/**
 * 
 * <br>
 * creation : 30 nov. 2004
 * 
 * @author <a href="mailto:david.sciamma@anyware-tech.com">David Sciamma </a>
 */
public class EdgeEndpointEditPolicy extends ConnectionEndpointEditPolicy
{
    /**
     * @see org.eclipse.gef.editpolicies.SelectionHandlesEditPolicy#addSelectionHandles()
     */
    protected void addSelectionHandles()
    {
        super.addSelectionHandles();
        getConnectionFigure().setLineWidth(2);
    }

    protected PolylineConnection getConnectionFigure()
    {
        return (PolylineConnection) getHostFigure();
    }

    protected void hideSelection()
    {
        super.hideSelection();
        getHostFigure().setFont(null);
        getHostFigure().invalidateTree();
    }

    protected void removeSelectionHandles()
    {
        super.removeSelectionHandles();
        getConnectionFigure().setLineWidth(0);
    }

    protected void showSelection()
    {
        super.showSelection();
        getHostFigure().validate();
        getHostFigure().invalidateTree();
    }

}
