/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies), Nicolas Lalev�e (Anyware
 *    Technologies) - initial API and implementation
 *******************************************************************************/

package org.topcased.modeler.editor.palette;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.topcased.modeler.commands.IDialogCommand;

/**
 * A ConnectionCreationTool that support dialog commands.
 * 
 */
public class ModelerConnectionCreationTool extends ConnectionCreationTool
{
    
    protected void executeCurrentCommand() {
        boolean ok = true;
        
        Command curCommand = getCurrentCommand();
        if (curCommand instanceof IDialogCommand)
        {
            ok = ((IDialogCommand) curCommand).openDialog();
        }
        if (ok && curCommand != null && curCommand.canExecute())
        {
            executeCommand(curCommand);
        }
        setCurrentCommand(null);
    }

}
