/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jacques Lescot (Anyware Technologies), - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.modeler.evaluator.ocl;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ocl.query.Query;
import org.eclipse.emf.ocl.query.QueryFactory;
import org.topcased.modeler.evaluator.IEvaluator;
import org.topcased.modeler.internal.ModelerPlugin;

/**
 * Validate an EObject with the EMF basic validation <br>
 * creation : 16 janv. 2006
 * 
 * @author <a href="mailto:david.sciamma@anyware-tech.com">David Sciamma</a>
 */
public class OCLEvaluator implements IEvaluator
{
    /**
     * @see org.topcased.modeler.evaluator.IEvaluator#eval(org.eclipse.emf.ecore.EObject, java.lang.String)
     */
    public boolean eval(EObject eObject, String rule)
    {
        boolean valid = false;

        try
        {
            Query query = QueryFactory.eINSTANCE.createQuery(rule, eObject.eClass());
            valid = query.check(eObject);
        }
        catch (IllegalArgumentException e)
        {
            ModelerPlugin.log(e.getLocalizedMessage(), IStatus.ERROR);
        }

        return valid;
    }

}
