/*******************************************************************************
 * Copyright (c) 2005 Anyware Technologies
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies) - initial API and implementation
 *******************************************************************************/

package org.topcased.modeler.export.internal;

import org.apache.batik.transcoder.image.ImageTranscoder;
import org.apache.batik.transcoder.image.PNGTranscoder;

/**
 * Export a diagram into a PNG file
 * 
 * @author <a href="david.sciamma@anyware-tech.com">David Sciamma</a>
 */
public class PNGExporter extends AbstractAWTImageExporter
{

    /**
     * @see org.topcased.modeler.export.internal.AbstractAWTImageExporter#createImageTranscoder()
     */
    protected ImageTranscoder createImageTranscoder()
    {
        return new PNGTranscoder();
    }
}
