/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies) - initial API and implementation
 ******************************************************************************/
package org.topcased.modeler.preferences;

/**
 * Constant definitions for plug-in preferences
 */
public class ModelerPreferenceConstants
{

    /** The default use uuid preference */
    public static final String P_USE_UUID = "useUUID";
    
    /** The list of the available PageFormat */
    public static final String P_PAGE_FORMATS = "PageFormats";

    /** The name of the default PageFormat */
    public static final String P_DEFAULT_PAGE_FORMAT = "defaultPageFormat";

    /** The list of the available PageMargin */
    public static final String P_PAGE_MARGINS = "PageMargins";

    /** The name of the default PageMargin */
    public static final String P_DEFAULT_PAGE_MARGIN = "defaultPageMargins";

    /** The default page orientation */
    public static final String P_ORIENTATION = "orientation";

    /** The default unit */
    public static final String P_DEFAULT_UNIT = "defaultUnit";

    /** The delimiter for PageFormats */
    public static final String PAGE_FORMATS_DELIMITER = "|";

    /** The delimiter for PageMargins */
    public static final String PAGE_MARGINS_DELIMITER = "|";

    /** The preference for the delete action dialog */
    public static final String DELETE_ACTION_CONFIRM = "deleteActionConfirm";

    /** The preference for the delete model action dialog */
    public static final String DELETE_MODEL_ACTION_CONFIRM = "deleteModelActionConfirm";

    /** The preference for the create child menu */
    public static final String CREATE_CHILD_MENU_PREF = "createChildMenuId";

    /** The preference for the outline show action */
    public static final String OUTLINE_SHOW_ACTION_PREF = "outlineShowAction";

    /** The preference for the outline sorter action */
    public static final String OUTLINE_SORTER_PREF = "outlineSorter";

    /** The preference for the outline filters action */
    public static final String FILTERS_PREF = "filtersList";

    /**
     * The default values for the PreferenceStore. Values are stored in pixels
     * (value in centimeter multiplied by 4)
     */
    public static final String DEFAULT_PAGE_FORMATS = PageFormat.A5 + PAGE_FORMATS_DELIMITER + PageFormat.A4
            + PAGE_FORMATS_DELIMITER + PageFormat.A3 + PAGE_FORMATS_DELIMITER + PageFormat.A2 + PAGE_FORMATS_DELIMITER
            + PageFormat.A1 + PAGE_FORMATS_DELIMITER + PageFormat.A0;

    public static final String DEFAULT_PAGE_FORMAT = "A4";

    public static final String DEFAULT_PAGE_MARGINS = PageMargin.NO_MARGIN + PAGE_MARGINS_DELIMITER
            + PageMargin.SMALL_MARGIN;

    public static final String DEFAULT_PAGE_MARGIN = "Small Margin";

    public static final String DEFAULT_UNIT = "pixel";

    public static final String DEFAULT_ORIENTATION = "portrait";

    public static final String P_CHECK_INTEGRITY = "CheckFileIntegrity";

    public static final String P_USE_ANTIALIAS = "UseAntialias";

    public static final String P_INITIALIZE_DIAGRAM = "InitializeDiagramContent";

}
