/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies) - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.sam;

/**
 * A collection of Roles. Each identifier is used to key the EditPolicy.
 * Creation : 03 april 2005
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public interface SAMEditPolicyConstants
{
    /**
     * The key used to install an <i>Edit Requirement</i> EditPolicy.
     */
    String EDIT_REQUIREMENT_EDITPOLICY = "Edit Requirement EditPolicy";
    
    /**
     * The key used to install an <i>Add New Port</i> EditPolicy.
     */
    String ADD_NEW_PORT_EDITPOLICY = "Add New Port";
    
    /**
     * The key used to install an <i>Inverse Ports</i> EditPolicy.
     */
    String INVERSE_PORTS_EDITPOLICY = "Inverse Ports";
    
    /**
     * The key used to install a <i>Rotate</i> EditPolicy.
     */
    String ROTATE_EDITPOLICY = "Rotate";
    
    /**
     * The key used to install a <i>Custom</i> EditPolicy.
     */
    String CUSTOM_EDITPOLICY = "Custom";
    
}
