/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies) - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.sam;

/**
 * This interface is used to define Property constants ("keys" and "values")
 * that are proper to the SAM graphical editor.
 * 
 * Creation : 29 sept. 2005
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public interface SAMPropertyConstants
{
    /** The type of a Datastore object */
    String DATASTORE_TYPE = "dataStoreType";
    
    /** The value corresponding to a LeftDataStore */
    String DATASTORE_TYPE_LEFT = "left";
    
    /** The value corresponding to a RightDataStore */
    String DATASTORE_TYPE_RIGHT = "right";
    
}
