/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies) - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.sam;

/**
 * created 12 avr. 2005
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 * 
 */
public interface SAMRequestConstants
{
    
    /**
     * Indicates that an edit Requirement request should be performed.
     * @deprecated Remove this dialog. Use the corresponding section in the Properties View
     */
    String REQ_EDIT_REQUIREMENT = "editRequirement";
    
    /**
     * Indicates that an add new port request should be performed.
     */
    String REQ_ADD_NEW_PORT = "addNewPort";
    
    /**
     * Indicates that an inverse Ports request should be performed.
     */
    String REQ_INVERSE_PORTS = "inversePorts";
    
    /**
     * Indicates that a Rotate request should be performed.
     */
    String REQ_ROTATE = "rotate";
}
