/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.automatondiagram;

import java.util.Iterator;

import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.resource.StringConverter;
import org.topcased.modeler.ModelerPropertyConstants;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.di.model.util.DIUtils;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.sam.util.SAMSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model
 * Object <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class AutomCreationUtils extends AbstractCreationUtils
{
    /**
     * Constructor
     * 
     * @param diagramConf the Diagram Graphical Configurator
     */
    public AutomCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private class GraphicSAMSwitch extends SAMSwitch
    {
        /** The presentation of the graphical element */
        private String presentation;
        
        /**
         * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicSAMSwitch(String presentation)
        {
            this.presentation = presentation;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseState(org.topcased.sam.State)
         * @generated
         */
        public Object caseState(org.topcased.sam.State object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementState(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseInitialState(org.topcased.sam.InitialState)
         * @generated
         */
        public Object caseInitialState(org.topcased.sam.InitialState object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInitialState(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseMacroState(org.topcased.sam.MacroState)
         * @generated
         */
        public Object caseMacroState(org.topcased.sam.MacroState object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementMacroState(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseMultiPort(org.topcased.sam.MultiPort)
         * @generated
         */
        public Object caseMultiPort(org.topcased.sam.MultiPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementMultiPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseInControlPort(org.topcased.sam.InControlPort)
         * @generated
         */
        public Object caseInControlPort(org.topcased.sam.InControlPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInControlPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseOutControlPort(org.topcased.sam.OutControlPort)
         * @generated
         */
        public Object caseOutControlPort(org.topcased.sam.OutControlPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementOutControlPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseInDataPort(org.topcased.sam.InDataPort)
         * @generated
         */
        public Object caseInDataPort(org.topcased.sam.InDataPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInDataPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseOutDataPort(org.topcased.sam.OutDataPort)
         * @generated
         */
        public Object caseOutDataPort(org.topcased.sam.OutDataPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementOutDataPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseTransition(org.topcased.sam.Transition)
         * @generated
         */
        public Object caseTransition(org.topcased.sam.Transition object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementTransition(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }
    
    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated
     */
    public EObject createModelObject(EObject obj)
    {
        return obj;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;
        
        if ("http://www.topcased.org/SAM/1.0".equals(obj.eClass().getEPackage().getNsURI()))
        {
            graphElt = new GraphicSAMSwitch(presentation).doSwitch(obj);
        }
        
        return (GraphElement) graphElt;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementState(org.topcased.sam.State element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInitialState(org.topcased.sam.InitialState element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementMacroState(org.topcased.sam.MacroState element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementMultiPort(org.topcased.sam.MultiPort element, String presentation)
    {
        GraphNode graphNode = createGraphNode(element, presentation);
        DIUtils.setProperty(graphNode, ModelerPropertyConstants.PORT_POSITION,
                StringConverter.asString(PositionConstants.LEFT));
        DIUtils.setProperty(graphNode, ModelerPropertyConstants.MULTIPORT_STATE, "false");
        
        for (Iterator iter = element.getListPort().iterator(); iter.hasNext();)
        {
            EObject port = (EObject) iter.next();
            GraphElement portNode = createGraphElement(port);
            DIUtils.setProperty(portNode, ModelerPropertyConstants.PORT_POSITION,
                    StringConverter.asString(PositionConstants.LEFT));
            graphNode.getContained().add(portNode);
        }
        
        return graphNode;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInControlPort(org.topcased.sam.InControlPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementOutControlPort(org.topcased.sam.OutControlPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInDataPort(org.topcased.sam.InDataPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementOutDataPort(org.topcased.sam.OutDataPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementTransition(org.topcased.sam.Transition element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset conditionEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        conditionEdgeObjectOffset.setId(AutomEdgeObjectConstants.CONDITION_EDGE_OBJECT_ID);
        conditionEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(conditionEdgeObjectOffset);
        EdgeObjectUV priorityEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        priorityEdgeObjectUV.setId(AutomEdgeObjectConstants.PRIORITY_EDGE_OBJECT_ID);
        priorityEdgeObjectUV.setUDistance(5);
        priorityEdgeObjectUV.setVDistance(10);
        graphEdge.getContained().add(priorityEdgeObjectUV);
        return graphEdge;
    }
    
}
