/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.automatondiagram;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteSeparator;
import org.eclipse.gef.requests.CreationFactory;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;
import org.topcased.sam.SAMPackage;

/**
 * Generated Palette Manager <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class AutomPaletteManager extends ModelerPaletteManager
{
    
    // declare all the palette categories of the diagram
    private PaletteDrawer objectsDrawer;
    
    private PaletteDrawer connectionsDrawer;
    
    private ICreationUtils creationUtils;
    
    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param utils the creation utils for the tools of the palette
     * @generated
     */
    public AutomPaletteManager(ICreationUtils utils)
    {
        super();
        this.creationUtils = utils;
    }
    
    /**
     * Creates the main categories of the palette <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected void createCategories()
    {
        createObjectsDrawer();
        createConnectionsDrawer();
    }
    
    /**
     * Updates the main categories of the palette <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected void updateCategories()
    {
        // deletion of the existing categories and creation of the updated
        // categories
        
        getRoot().remove(objectsDrawer);
        createObjectsDrawer();
        
        getRoot().remove(connectionsDrawer);
        createConnectionsDrawer();
    }
    
    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    private void createObjectsDrawer()
    {
        objectsDrawer = new PaletteDrawer("Objects", null);
        List entries = new ArrayList();
        
        CreationFactory factory;
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getState(), "default");
        entries.add(new ModelerCreationToolEntry("State", "State", factory,
                AutomImageRegistry.getImageDescriptor("STATE"), AutomImageRegistry.getImageDescriptor("STATE_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getInitialState(), "default");
        entries.add(new ModelerCreationToolEntry("InitialState", "InitialState", factory,
                AutomImageRegistry.getImageDescriptor("INITIALSTATE"),
                AutomImageRegistry.getImageDescriptor("INITIALSTATE_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getMacroState(), "default");
        entries.add(new ModelerCreationToolEntry("MacroState", "MacroState", factory,
                AutomImageRegistry.getImageDescriptor("MACROSTATE"),
                AutomImageRegistry.getImageDescriptor("MACROSTATE_LARGE")));
        
        entries.add(new PaletteSeparator());
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getMultiPort(), "default");
        entries.add(new ModelerCreationToolEntry("MultiPort", "MultiPort", factory,
                AutomImageRegistry.getImageDescriptor("MULTIPORT"),
                AutomImageRegistry.getImageDescriptor("MULTIPORT_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getInControlPort(), "default");
        entries.add(new ModelerCreationToolEntry("InControlPort", "InControlPort", factory,
                AutomImageRegistry.getImageDescriptor("INCONTROLPORT"),
                AutomImageRegistry.getImageDescriptor("INCONTROLPORT_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getOutControlPort(), "default");
        entries.add(new ModelerCreationToolEntry("OutControlPort", "OutControlPort", factory,
                AutomImageRegistry.getImageDescriptor("OUTCONTROLPORT"),
                AutomImageRegistry.getImageDescriptor("OUTCONTROLPORT_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getInDataPort(), "default");
        entries.add(new ModelerCreationToolEntry("InDataPort", "InDataPort", factory,
                AutomImageRegistry.getImageDescriptor("INDATAPORT"),
                AutomImageRegistry.getImageDescriptor("INDATAPORT_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getOutDataPort(), "default");
        entries.add(new ModelerCreationToolEntry("OutDataPort", "OutDataPort", factory,
                AutomImageRegistry.getImageDescriptor("OUTDATAPORT"),
                AutomImageRegistry.getImageDescriptor("OUTDATAPORT_LARGE")));
        
        objectsDrawer.addAll(entries);
        getRoot().add(objectsDrawer);
    }
    
    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createConnectionsDrawer()
    {
        connectionsDrawer = new PaletteDrawer("Connections", null);
        List entries = new ArrayList();
        
        CreationFactory factory;
        
        factory = new GraphElementCreationFactory(creationUtils, SAMPackage.eINSTANCE.getTransition(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Transition", "Transition", factory,
                AutomImageRegistry.getImageDescriptor("TRANSITION"),
                AutomImageRegistry.getImageDescriptor("TRANSITION_LARGE")));
        
        connectionsDrawer.addAll(entries);
        getRoot().add(connectionsDrawer);
    }
    
}
