/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.automatondiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.EMFGraphNodeEditPart;
import org.topcased.modeler.sam.automatondiagram.AutomEditPolicyConstants;
import org.topcased.modeler.sam.automatondiagram.figures.AbstractStateFigure;
import org.topcased.modeler.sam.automatondiagram.policies.TransitionEdgeCreationEditPolicy;

/**
 * The AbstractState object controller <!-- begin-user-doc --> <!-- end-user-doc
 * -->
 * 
 * @generated
 */
public class AbstractStateEditPart extends EMFGraphNodeEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public AbstractStateEditPart(GraphNode obj)
    {
        super(obj);
    }
    
    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        
        installEditPolicy(AutomEditPolicyConstants.TRANSITION_EDITPOLICY, new TransitionEdgeCreationEditPolicy());
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated
     */
    protected IFigure createFigure()
    {
        
        return new AbstractStateFigure();
    }
    
}