/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.automatondiagram.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.geometry.Rectangle;
import org.topcased.draw2d.figures.BorderedLabel;

/**
 * The figure to display a InitialState. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques Lescot </a>
 * @generated NOT
 */
public class InitialStateFigure extends BorderedLabel
{
    private static final int ROUND_CORNER = 10;
    
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public InitialStateFigure()
    {
        super();
    }
    
    /**
     * @see org.topcased.draw2d.figures.BorderedLabel#fillShape(org.eclipse.draw2d.Graphics)
     */
    protected void fillShape(Graphics graphics)
    {
        graphics.fillRoundRectangle(getBounds(), ROUND_CORNER, ROUND_CORNER);
    }
    
    /**
     * @see org.topcased.draw2d.figures.BorderedLabel#outlineShape(org.eclipse.draw2d.Graphics)
     */
    protected void outlineShape(Graphics graphics)
    {
        Rectangle r = getBounds();
        
        // Draw the inner rounded rectangle
        Rectangle f = Rectangle.SINGLETON;
        f.x = r.x + lineWidth / 2 + 5;
        f.y = r.y + lineWidth / 2 + 5;
        f.width = r.width - lineWidth - 10;
        f.height = r.height - lineWidth - 10;
        graphics.drawRoundRectangle(f, ROUND_CORNER, ROUND_CORNER);
        
        // Draw the outer rounded rectangle
        f.x = r.x + lineWidth / 2;
        f.y = r.y + lineWidth / 2;
        f.width = r.width - lineWidth;
        f.height = r.height - lineWidth;
        graphics.drawRoundRectangle(f, ROUND_CORNER, ROUND_CORNER);
    }
}
