/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.automatondiagram.figures;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.Locator;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.topcased.modeler.edit.locators.EdgeObjectOffsetLocator;
import org.topcased.modeler.figures.EdgeObjectEditableLabel;
import org.topcased.modeler.figures.EdgeObjectOffsetEditableLabel;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.figures.IEdgeObjectOffsetFigure;
import org.topcased.modeler.figures.IGraphEdgeFigure;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class TransitionFigure extends PolylineConnectionEx implements IGraphEdgeFigure, HandleBounds
{
    /**
     * @generated
     */
    private IEdgeObjectFigure conditionEdgeObject;
    
    /**
     * @generated
     */
    private Locator conditionLocator;
    
    /**
     * @generated
     */
    private IEdgeObjectFigure priorityEdgeObject;
    
    /**
     * @generated
     */
    private Locator priorityLocator;
    
    /**
     * The constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public TransitionFigure()
    {
        super();
        
        conditionEdgeObject = new EdgeObjectOffsetEditableLabel(this);
        conditionLocator = new EdgeObjectOffsetLocator((IEdgeObjectOffsetFigure) conditionEdgeObject);
        add(conditionEdgeObject, conditionLocator);
        
        priorityEdgeObject = new EdgeObjectEditableLabel(this);
        priorityLocator = new ConnectionEndpointLocator(this, false);
        add(priorityEdgeObject, priorityLocator);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getConditionEdgeObjectFigure()
    {
        return conditionEdgeObject;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getPriorityEdgeObjectFigure()
    {
        return priorityEdgeObject;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.figures.IGraphEdgeFigure#getLocator(org.topcased.modeler.figures.IEdgeObjectFigure)
     * @generated
     */
    public Locator getLocator(IEdgeObjectFigure edgeObjectfigure)
    {
        if (edgeObjectfigure == conditionEdgeObject)
        {
            return conditionLocator;
        }
        if (edgeObjectfigure == priorityEdgeObject)
        {
            return priorityLocator;
        }
        
        return null;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
     * @generated
     */
    public Rectangle getHandleBounds()
    {
        return getPoints().getBounds();
    }
}
