/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jacques Lescot (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.modeler.sam.internal.properties.sections;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.topcased.modeler.sam.util.InstancesUtil;
import org.topcased.sam.SAMPackage;
import org.topcased.tabbedproperties.sections.AbstractStringPropertySection;

/**
 * The section for the name property of a NamedItem Object.
 * 
 * It is disabled for editing when the currently edited object has its
 * IsInstanceOf reference set.
 * 
 * Creation 5 avr. 2006
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public class NamePropertySection extends AbstractStringPropertySection
{
	public NamePropertySection() {
	}	
	
    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Name:";
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     */
    protected EStructuralFeature getFeature()
    {
        return SAMPackage.eINSTANCE.getNamedItem_Name();
    }
}