/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jacques Lescot (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.modeler.sam.internal.properties.sections;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.topcased.sam.SAMPackage;
import org.topcased.sam.Transition;
import org.topcased.tabbedproperties.sections.AbstractIntegerPropertySection;

/**
 * The section for the priority property of a Transition Object.
 * 
 * Creation 5 avr. 2006
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public class PriorityPropertySection extends AbstractIntegerPropertySection
{
    /**
     * @see org.topcased.tabbedproperties.sections.AbstractIntegerPropertySection#getFeatureInteger()
     */
    protected Integer getFeatureInteger()
    {
        if (((Transition) getEObject()).getPriority() != null)
            return ((Transition) getEObject()).getPriority();
        else
            return new Integer(0);
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     */
    protected EStructuralFeature getFeature()
    {
        return SAMPackage.eINSTANCE.getTransition_Priority();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Priority:";
    }

}