/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jacques Lescot (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.sam.internal.properties.sections.filters;

import org.eclipse.jface.viewers.IFilter;
import org.topcased.modeler.sam.systemdiagram.edit.CompositionEditPart;
import org.topcased.modeler.sam.systemdiagram.edit.DecompositionEditPart;

/**
 * A Filter that check if the selected Element is associated with a SynchronisationGate model element<br>
 * 
 * Creation : 20 Nov. 2007
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public class SynchronisationGateFilter implements IFilter
{
    /**
     * @see org.eclipse.jface.viewers.IFilter#select(java.lang.Object)
     */
    public boolean select(Object toTest)
    {
        return toTest instanceof CompositionEditPart || toTest instanceof DecompositionEditPart;
    }

}
