/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.providers;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.EAttribute;
import org.topcased.modeler.providers.IDeletePartnerProvider;
import org.topcased.modeler.providers.ILabelFeatureProvider;
import org.topcased.sam.SAMPackage;
import org.topcased.sam.State;
import org.topcased.sam.Transition;

/**
 * This is the item provider adpater for a {@link org.topcased.sam.State}
 * object. <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated NOT
 */

public class StateModelerProvider extends AbstractStateModelerProvider implements ILabelFeatureProvider,
        IDeletePartnerProvider
{
    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param adapterFactory
     * 
     * @generated
     */
    public StateModelerProvider(AdapterFactory adapterFactory)
    {
        super(adapterFactory);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.providers.ILabelFeatureProvider#getLabelFeature(java.lang.Object)
     * @generated
     */
    public EAttribute getLabelFeature(Object object)
    {
        return SAMPackage.eINSTANCE.getNamedItem_Name();
    }
    
    /**
     * @see org.topcased.modeler.providers.IDeletePartnerProvider#getDeletePartners(java.lang.Object)
     */
    public List getDeletePartners(Object object)
    {
        ArrayList deletelist = new ArrayList();
        
        State state = (State) object;
        
        Iterator itLinks = state.getInlink().iterator();
        while (itLinks.hasNext())
        {
            Object obj = itLinks.next();
            if (obj instanceof Transition)
            {
                deletelist.add(obj);
            }
        }
        
        deletelist.addAll(super.getDeletePartners(object));
        
        return deletelist;
    }
}
