/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.providers;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.EAttribute;
import org.topcased.modeler.providers.IDeleteObjectProvider;
import org.topcased.modeler.providers.ILabelFeatureProvider;
import org.topcased.sam.SAMPackage;
import org.topcased.sam.System;

/**
 * This is the item provider adpater for a {@link org.topcased.sam.System}
 * object. <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */

public class SystemModelerProvider extends ModelContentModelerProvider implements ILabelFeatureProvider, IDeleteObjectProvider
{
    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param adapterFactory
     * 
     * @generated
     */
    public SystemModelerProvider(AdapterFactory adapterFactory)
    {
        super(adapterFactory);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.providers.ILabelFeatureProvider#getLabelFeature(java.lang.Object)
     * @generated
     */
    public EAttribute getLabelFeature(Object object)
    {
        return SAMPackage.eINSTANCE.getNamedItem_Name();
    }

    /**
     * @see org.topcased.modeler.providers.IDeleteObjectProvider#canBeDeleted(java.lang.Object)
     */
    public boolean canBeDeleted(Object object)
    {
        if (object instanceof org.topcased.sam.System)
        {
            return ((System) object).getParentModel() == null;
        }
        return false;
    }
}
