/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.systemdiagram;

import java.util.Iterator;

import org.eclipse.draw2d.PositionConstants;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.resource.StringConverter;
import org.topcased.modeler.ModelerPropertyConstants;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.di.model.util.DIUtils;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.sam.util.SAMSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model
 * Object <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class SystCreationUtils extends AbstractCreationUtils
{
    /**
     * Constructor
     * 
     * @param diagramConf the Diagram Graphical Configurator
     */
    public SystCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private class GraphicSAMSwitch extends SAMSwitch
    {
        /** The presentation of the graphical element */
        private String presentation;
        
        /**
         * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicSAMSwitch(String presentation)
        {
            this.presentation = presentation;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseSystem(org.topcased.sam.System)
         * @generated
         */
        public Object caseSystem(org.topcased.sam.System object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementSystem(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseAutomaton(org.topcased.sam.Automaton)
         * @generated
         */
        public Object caseAutomaton(org.topcased.sam.Automaton object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementAutomaton(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseDataStore(org.topcased.sam.DataStore)
         * @generated
         */
        public Object caseDataStore(org.topcased.sam.DataStore object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDataStore(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseComposition(org.topcased.sam.Composition)
         * @generated
         */
        public Object caseComposition(org.topcased.sam.Composition object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementComposition(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseDecomposition(org.topcased.sam.Decomposition)
         * @generated
         */
        public Object caseDecomposition(org.topcased.sam.Decomposition object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDecomposition(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseMultiPort(org.topcased.sam.MultiPort)
         * @generated
         */
        public Object caseMultiPort(org.topcased.sam.MultiPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementMultiPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseInControlPort(org.topcased.sam.InControlPort)
         * @generated
         */
        public Object caseInControlPort(org.topcased.sam.InControlPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInControlPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseOutControlPort(org.topcased.sam.OutControlPort)
         * @generated
         */
        public Object caseOutControlPort(org.topcased.sam.OutControlPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementOutControlPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseInDataPort(org.topcased.sam.InDataPort)
         * @generated
         */
        public Object caseInDataPort(org.topcased.sam.InDataPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInDataPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseOutDataPort(org.topcased.sam.OutDataPort)
         * @generated
         */
        public Object caseOutDataPort(org.topcased.sam.OutDataPort object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementOutDataPort(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseDataFlow(org.topcased.sam.DataFlow)
         * @generated
         */
        public Object caseDataFlow(org.topcased.sam.DataFlow object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDataFlow(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#caseControlFlow(org.topcased.sam.ControlFlow)
         * @generated
         */
        public Object caseControlFlow(org.topcased.sam.ControlFlow object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementControlFlow(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.topcased.sam.util.SAMSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }
    
    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated
     */
    public EObject createModelObject(EObject obj)
    {
        return obj;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;
        
        if ("http://www.topcased.org/SAM/1.0".equals(obj.eClass().getEPackage().getNsURI()))
        {
            graphElt = new GraphicSAMSwitch(presentation).doSwitch(obj);
        }
        
        return (GraphElement) graphElt;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementSystem(org.topcased.sam.System element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementAutomaton(org.topcased.sam.Automaton element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementDataStore(org.topcased.sam.DataStore element, String presentation)
    {
        GraphNode graphNode = createGraphNode(element, presentation);
        graphNode.getContained().add(createGraphNode(element.getIn()));
        graphNode.getContained().add(createGraphNode(element.getOut()));
        return graphNode;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementComposition(org.topcased.sam.Composition element, String presentation)
    {
        GraphNode graphNode = createGraphNode(element, presentation);
        graphNode.getContained().add(createGraphNode((EObject) element.getOut().get(0)));
        
        for (Iterator iter = element.getIn().iterator(); iter.hasNext();)
        {
            EObject port = (EObject) iter.next();
            graphNode.getContained().add(createGraphElement(port));
        }
        
        return graphNode;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementDecomposition(org.topcased.sam.Decomposition element, String presentation)
    {
        GraphNode graphNode = createGraphNode(element, presentation);
        graphNode.getContained().add(createGraphNode((EObject) element.getIn().get(0)));
        
        for (Iterator iter = element.getOut().iterator(); iter.hasNext();)
        {
            EObject port = (EObject) iter.next();
            graphNode.getContained().add(createGraphNode(port));
        }
        
        return graphNode;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementMultiPort(org.topcased.sam.MultiPort element, String presentation)
    {
        GraphNode graphNode = createGraphNode(element, presentation);
        DIUtils.setProperty(graphNode, ModelerPropertyConstants.PORT_POSITION,
                StringConverter.asString(PositionConstants.LEFT));
        DIUtils.setProperty(graphNode, ModelerPropertyConstants.MULTIPORT_STATE, "false");
        
        for (Iterator iter = element.getListPort().iterator(); iter.hasNext();)
        {
            EObject port = (EObject) iter.next();
            GraphElement portNode = createGraphElement(port);
            DIUtils.setProperty(portNode, ModelerPropertyConstants.PORT_POSITION,
                    StringConverter.asString(PositionConstants.LEFT));
            graphNode.getContained().add(portNode);
        }
        
        return graphNode;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInControlPort(org.topcased.sam.InControlPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementOutControlPort(org.topcased.sam.OutControlPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInDataPort(org.topcased.sam.InDataPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementOutDataPort(org.topcased.sam.OutDataPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDataFlow(org.topcased.sam.DataFlow element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        return graphEdge;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementControlFlow(org.topcased.sam.ControlFlow element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        return graphEdge;
    }
    
}
