/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware Technologies),
 *    Jacques Lescot (Anyware Technologies) - initial API and implementation
 *******************************************************************************/
package org.topcased.modeler.sam.systemdiagram.edit;

import org.eclipse.gef.tools.DirectEditManager;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.sam.SAMEditPolicyConstants;
import org.topcased.modeler.sam.edit.policies.CustomEditPolicy;
import org.topcased.modeler.utils.Utils;
import org.topcased.sam.Flow;

/**
 * The Flow Controller
 * 
 * Creation : 29 sept. 2005
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public class FlowEditPart extends EMFGraphEdgeEditPart
{
    /** The directEdit manager */
    protected DirectEditManager manager;
    
    /**
     * Constructor
     * 
     * @param model the graph object
     */
    public FlowEditPart(GraphEdge model)
    {
        super(model);
    }
    
    /**
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        
        installEditPolicy(SAMEditPolicyConstants.CUSTOM_EDITPOLICY, new CustomEditPolicy());
        
        installEditPolicy(ModelerEditPolicyConstants.CHANGE_BACKGROUND_COLOR_EDITPOLICY, null);
        installEditPolicy(ModelerEditPolicyConstants.CHANGE_FONT_EDITPOLICY, null);
    }
    
    /**
     * @return the model object
     */
    protected Flow getFlow()
    {
        return (Flow) Utils.getElement(getGraphEdge());
    }
}
