/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.systemdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPolicy;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.DiagramEditPart;
import org.topcased.modeler.editor.Modeler;
import org.topcased.modeler.editor.ModelerGraphicalViewer;
import org.topcased.modeler.sam.edit.policies.SAMDiagramLayoutEditPolicy;
import org.topcased.modeler.sam.systemdiagram.commands.RestorePortsCommand;
import org.topcased.modeler.sam.systemdiagram.figures.SystDiagramFigure;
import org.topcased.sam.SAMPackage;
import org.topcased.sam.System;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class SystDiagramEditPart extends DiagramEditPart
{
    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the root model element
     * @generated
     */
    public SystDiagramEditPart(Diagram model)
    {
        super(model);
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#getLayoutEditPolicy()
     * @generated NOT
     */
    protected EditPolicy getLayoutEditPolicy()
    {
        return new SAMDiagramLayoutEditPolicy();
    }
    
    private Modeler getModeler()
    {
        return ((ModelerGraphicalViewer) getViewer()).getModelerEditor();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    protected IFigure createFigure()
    {
        IFigure page = super.createFigure();
        
        // REV weird code ....use a command ?
        RestorePortsCommand restorePortsCommand = new RestorePortsCommand(getViewer().getEditDomain(),
                (GraphNode) getModel(), getModeler().getActiveConfiguration().getCreationUtils());
        if (restorePortsCommand != null && restorePortsCommand.canExecute())
        {
            restorePortsCommand.execute();
        }
        
        return page;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#createBodyFigure()
     * @generated
     */
    protected IFigure createBodyFigure()
    {
        return new SystDiagramFigure();
    }
    
    /**
     * @see org.topcased.modeler.edit.DiagramEditPart#handleModelChanged(org.eclipse.emf.common.notify.Notification)
     */
    protected void handleModelChanged(Notification msg)
    {
        if (msg.getNotifier() instanceof System)
        {
            switch (msg.getFeatureID(System.class))
            {
                case SAMPackage.SYSTEM__LIST_PORTS:
                case SAMPackage.SYSTEM__LIST_MULTI_PORT:
                    // update graphically all the ports that may have been added
                    // in the model so that they are synchronized
                    // REV weird code ....use a command ?
                    RestorePortsCommand restorePortsCommand = new RestorePortsCommand(
                            getViewer().getEditDomain(),
                            (GraphNode) getModel(),
                            ((ModelerGraphicalViewer) getViewer()).getModelerEditor().getActiveConfiguration().getCreationUtils());
                    if (restorePortsCommand != null && restorePortsCommand.canExecute())
                    {
                        restorePortsCommand.execute();
                    }
                    break;
            }
        }
        
        super.handleModelChanged(msg);
    }
}
