/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.systemdiagram.figures;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.geometry.Dimension;
import org.topcased.draw2d.figures.ContainerFigure;
import org.topcased.draw2d.layout.BorderAttachedLayout;
import org.topcased.draw2d.layout.GridData;

/**
 * The figure to display a Automaton. <!-- begin-user-doc --> <!-- end-user-doc
 * -->
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques Lescot </a>
 * @generated NOT
 */
public class AutomatonFigure extends ContainerFigure
{
    /**
     * Constructor
     */
    public AutomatonFigure()
    {
        super(GridData.GRAB_HORIZONTAL | GridData.HORIZONTAL_ALIGN_CENTER);
    }
    
    // /**
    // * @see org.topcased.modeler.figures.ModelerContainerFigure#createHeader()
    // */
    // protected IFigure createHeader()
    // {
    // EditableLabel mainFigure = new EditableLabel();
    // mainFigure.setLabelAlignment(PositionConstants.CENTER);
    // return new ComposedLabel((Label) null, mainFigure, null, false);
    // }
    
    /**
     * @see org.topcased.draw2d.figures.ContainerFigure#createContainer()
     */
    protected IFigure createContainer()
    {
        final int ROUND_CORNER = 20;
        
        RoundedRectangle container = new RoundedRectangle();
        container.setCornerDimensions(new Dimension(ROUND_CORNER, ROUND_CORNER));
        container.setLayoutManager(new BorderAttachedLayout());
        return container;
    }
    
}
