/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.sam.systemdiagram.figures;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.topcased.draw2d.figures.EditableLabel;
import org.topcased.draw2d.figures.IContainerFigure;
import org.topcased.draw2d.figures.ILabel;
import org.topcased.draw2d.figures.ILabelFigure;

/**
 * The figure to display a DataStore. <!-- begin-user-doc --> <!-- end-user-doc
 * -->
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques Lescot </a>
 * @generated NOT
 */
public class DataStoreFigure extends Figure implements IContainerFigure, ILabelFigure
{
    /** Define the default size of the figure (without the label) */
    private static final int DEFAULT_WIDTH = 60;
    
    private static final int DEFAULT_HEIGHT = 60;
    
    private ILabel header;
    
    private IFigure body;
    
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public DataStoreFigure()
    {
        ToolbarLayout toolbarLayout = new ToolbarLayout();
        toolbarLayout.setMinorAlignment(ToolbarLayout.ALIGN_CENTER);
        setLayoutManager(toolbarLayout);
        
        // create the content Figure
        body = new DataStore();
        add(body);
        
        header = new EditableLabel();
        add(header);
    }
    
    /**
     * @see org.topcased.draw2d.figures.ILabelFigure#getLabel()
     */
    public ILabel getLabel()
    {
        return header;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Container Figure
     * @generated
     */
    public IFigure getContentPane()
    {
        return body;
    }
    
    /**
     * Draw the DataStore
     * 
     * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
     */
    protected class DataStore extends Figure
    {
        
        /**
         * A class for drawing the Figure of a DataStore
         */
        public DataStore()
        {
            setLayoutManager(new XYLayout());
        }
        
        /**
         * @see org.eclipse.draw2d.Figure#paintFigure(org.eclipse.draw2d.Graphics)
         */
        protected void paintFigure(Graphics graphics)
        {
            super.paintFigure(graphics);
            
            graphics.pushState();
            
            // the reference point (translated for completely showing the line
            // of width 2)
            Point _top = getParent().getBounds().getTop().getTranslated(0, 1);
            
            // draw the 4 longer lines of the figure with a width of 2
            graphics.setLineWidth(2);
            
            graphics.drawLine(_top.x - 30, _top.y, _top.x + 30, _top.y);
            graphics.drawLine(_top.x - 6, _top.y + 58, _top.x - 6, _top.y + 8);
            graphics.drawLine(_top.x + 6, _top.y + 58, _top.x + 6, _top.y + 8);
            graphics.drawLine(_top.x - 30, _top.y + 58, _top.x + 30, _top.y + 58);
            
            // draw the two triangles we need to fill in black
            graphics.setLineWidth(1);
            graphics.drawRectangle(_top.x - 20, _top.y, 10, 10);
            graphics.drawRectangle(_top.x + 10, _top.y, 10, 10);
            
            graphics.popState();
        }
        
        /**
         * @see org.eclipse.draw2d.IFigure#getPreferredSize(int, int)
         */
        public Dimension getPreferredSize(int wHint, int hHint)
        {
            return new Dimension(DEFAULT_WIDTH, DEFAULT_HEIGHT);
        }
        
        /**
         * @see org.eclipse.draw2d.IFigure#getMinimumSize(int, int)
         */
        public Dimension getMinimumSize(int wHint, int hHint)
        {
            return new Dimension(DEFAULT_WIDTH, DEFAULT_HEIGHT);
        }
    }
    
}
