/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram;

import java.net.URL;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.gef.EditPartFactory;
import org.topcased.modeler.editor.IConfiguration;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.IPaletteManager;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.graphconf.exceptions.MissingGraphConfFileException;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ActorEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.AssociationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BehavioredClassifierEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BlockDefinitionEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BlockEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BlockPropertyEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ClassifierEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.CommentEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ConnectorEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ConstraintBlockEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ConstraintEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ContainmentEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.DataTypeEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.DependencyEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.DimensionEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ElementEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.EnumerationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.EnumerationLiteralEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.FlowPortEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.FlowPropertyEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.FlowSpecificationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.GeneralizationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.InterfaceEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.InterfaceRealizationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.NamedElementEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.OperationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.PortEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ProblemEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.PropertyEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.RationaleEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.TypeEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.UnitEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.UsageEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ValueTypeEditPart;

/**
 * A diagram configuration : manages Palette, EditPartFactory for this diagram.
 * <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class BlockDefConfiguration implements IConfiguration
{
    private BlockDefPaletteManager paletteManager;

    private BlockDefEditPartFactory editPartFactory;

    private BlockDefCreationUtils creationUtils;

    /**
     * The DiagramGraphConf that contains graphical informations on the
     * configuration
     */
    private DiagramGraphConf diagramGraphConf;

    /**
     * Constructor. Initialize Adapter factories.
     * 
     * @generated
     */
    public BlockDefConfiguration()
    {
        registerAdapters();
    }

    /**
     * Registers the Adapter Factories for all the EditParts
     * 
     * @generated
     */
    private void registerAdapters()
    {
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(BlockDefinitionEditPart.class,
                        org.topcased.sysml.BlockDefinition.class), BlockDefinitionEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(PortEditPart.class, org.eclipse.uml2.uml.Port.class),
                PortEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(FlowPortEditPart.class, org.topcased.sysml.FlowPort.class),
                FlowPortEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(FlowSpecificationEditPart.class,
                        org.topcased.sysml.FlowSpecification.class), FlowSpecificationEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(InterfaceEditPart.class, org.eclipse.uml2.uml.Interface.class),
                InterfaceEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(PropertyEditPart.class, org.eclipse.uml2.uml.Property.class),
                PropertyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(OperationEditPart.class, org.eclipse.uml2.uml.Operation.class),
                OperationEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ConstraintEditPart.class, org.eclipse.uml2.uml.Constraint.class),
                ConstraintEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(DataTypeEditPart.class, org.eclipse.uml2.uml.DataType.class),
                DataTypeEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(BlockEditPart.class, org.topcased.sysml.Block.class),
                BlockEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(GeneralizationEditPart.class,
                        org.eclipse.uml2.uml.Generalization.class), GeneralizationEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(DependencyEditPart.class, org.eclipse.uml2.uml.Dependency.class),
                DependencyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ConnectorEditPart.class, org.eclipse.uml2.uml.Connector.class),
                ConnectorEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(InterfaceRealizationEditPart.class,
                        org.eclipse.uml2.uml.InterfaceRealization.class), InterfaceRealizationEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(AssociationEditPart.class, org.eclipse.uml2.uml.Association.class),
                AssociationEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(FlowPropertyEditPart.class, org.topcased.sysml.FlowProperty.class),
                FlowPropertyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(BlockPropertyEditPart.class, org.topcased.sysml.BlockProperty.class),
                BlockPropertyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ActorEditPart.class, org.eclipse.uml2.uml.Actor.class),
                ActorEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ValueTypeEditPart.class, org.topcased.sysml.ValueType.class),
                ValueTypeEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(EnumerationEditPart.class, org.eclipse.uml2.uml.Enumeration.class),
                EnumerationEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(EnumerationLiteralEditPart.class,
                        org.eclipse.uml2.uml.EnumerationLiteral.class), EnumerationLiteralEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ConstraintBlockEditPart.class,
                        org.topcased.sysml.ConstraintBlock.class), ConstraintBlockEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ContainmentEditPart.class, org.topcased.sysml.Containment.class),
                ContainmentEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(CommentEditPart.class, org.eclipse.uml2.uml.Comment.class),
                CommentEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(RationaleEditPart.class, org.topcased.sysml.Rationale.class),
                RationaleEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ProblemEditPart.class, org.topcased.sysml.Problem.class),
                ProblemEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ElementEditPart.class, org.eclipse.uml2.uml.Element.class),
                ElementEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(TypeEditPart.class, org.eclipse.uml2.uml.Type.class),
                TypeEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(BehavioredClassifierEditPart.class,
                        org.eclipse.uml2.uml.BehavioredClassifier.class), BehavioredClassifierEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ClassifierEditPart.class, org.eclipse.uml2.uml.Classifier.class),
                ClassifierEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(NamedElementEditPart.class, org.eclipse.uml2.uml.NamedElement.class),
                NamedElementEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(UsageEditPart.class, org.eclipse.uml2.uml.Usage.class),
                UsageEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(UnitEditPart.class,
						org.topcased.sysml.Unit.class), UnitEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(DimensionEditPart.class,
						org.topcased.sysml.Dimension.class),
				DimensionEditPart.class);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getId()
     * @generated
     */
    public String getId()
    {
        return new String("org.topcased.modeler.sysml.blockdefinitiondiagram");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getName()
     * @generated
     */
    public String getName()
    {
        return new String("Block definition diagram");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getEditPartFactory()
     * @generated
     */
    public EditPartFactory getEditPartFactory()
    {
        if (editPartFactory == null)
        {
            editPartFactory = new BlockDefEditPartFactory();
        }

        return editPartFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getPaletteManager()
     * @generated
     */
    public IPaletteManager getPaletteManager()
    {
        if (paletteManager == null)
        {
            paletteManager = new BlockDefPaletteManager(getCreationUtils());
        }

        return paletteManager;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getCreationUtils()
     * @generated
     */
    public ICreationUtils getCreationUtils()
    {
        if (creationUtils == null)
        {
            creationUtils = new BlockDefCreationUtils(getDiagramGraphConf());
        }

        return creationUtils;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getDiagramGraphConf()
     * @generated
     */
    public DiagramGraphConf getDiagramGraphConf()
    {
        if (diagramGraphConf == null)
        {
            URL url = BlockDefPlugin.getDefault().getBundle().getResource(
                    "org/topcased/modeler/sysml/blockdefinitiondiagram/diagram.graphconf");
            if (url != null)
            {
                URI fileURI = URI.createURI(url.toString());
                ResourceSet resourceSet = new ResourceSetImpl();
                Resource resource = resourceSet.getResource(fileURI, true);
                if (resource != null && resource.getContents().get(0) instanceof DiagramGraphConf)
                {
                    diagramGraphConf = (DiagramGraphConf) resource.getContents().get(0);
                }
            }
            else
            {
                new MissingGraphConfFileException(
                        "The *.diagramgraphconf file can not be retrieved. Check if the path is correct in the Configuration class of your diagram.");
            }
        }

        return diagramGraphConf;
    }

}