/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.AggregationKind;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.Enumeration;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.Generalization;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.Usage;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.sysml.Block;
import org.topcased.sysml.BlockProperty;
import org.topcased.sysml.ConstraintBlock;
import org.topcased.sysml.Containment;
import org.topcased.sysml.FlowPort;
import org.topcased.sysml.FlowProperty;
import org.topcased.sysml.FlowSpecification;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.Unit;
import org.topcased.sysml.ValueType;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model
 * Object <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class BlockDefCreationUtils extends AbstractCreationUtils
{

    private static final int LABEL_OFFSET = 10;

    /**
     * Constructor
     * 
     * @param diagramConf the Diagram Graphical Configuration
     */
    public BlockDefCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private class GraphicSwitch extends SysMLSwitch
    {
        /** The presentation of the graphical element */
        private String presentation;

        /**
         * Constructor
         * 
         * @param presentation the presentation of the graphical element
         */
        public GraphicSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlock(org.topcased.sysml.Block)
         */
        public Object caseBlock(Block object)
        {
            return createGraphElementBlock(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlockProperty(org.topcased.sysml.BlockProperty)
         */
        public Object caseBlockProperty(BlockProperty object)
        {
            return createGraphElementBlockProperty(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProperty(org.eclipse.uml2.uml.Property)
         */
        public Object caseProperty(Property object)
        {
            return createGraphElementProperty(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseOperation(org.eclipse.uml2.uml.Operation)
         */
        public Object caseOperation(Operation object)
        {
            return createGraphElementOperation(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConstraint(org.eclipse.uml2.uml.Constraint)
         */
        public Object caseConstraint(Constraint object)
        {
            return createGraphElementConstraint(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseInterface(org.eclipse.uml2.uml.Interface)
         */
        public Object caseInterface(Interface object)
        {
            return createGraphElementInterface(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#casePort(org.eclipse.uml2.uml.Port)
         */
        public Object casePort(Port object)
        {
            return createGraphElementPort(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowSpecification(org.topcased.sysml.FlowSpecification)
         */
        public Object caseFlowSpecification(FlowSpecification object)
        {
            return createGraphElementFlowSpecification(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowProperty(org.topcased.sysml.FlowProperty)
         */
        public Object caseFlowProperty(FlowProperty object)
        {
            return createGraphElementFlowProperty(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowPort(org.topcased.sysml.FlowPort)
         */
        public Object caseFlowPort(FlowPort object)
        {
            return createGraphElementFlowPort(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseActor(org.eclipse.uml2.uml.Actor)
         */
        public Object caseActor(Actor object)
        {
            return createGraphElementActor(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDataType(org.eclipse.uml2.uml.DataType)
         */
        public Object caseDataType(DataType object)
        {
            return createGraphElementDataType(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseValueType(org.topcased.sysml.ValueType)
         */
        public Object caseValueType(ValueType object)
        {
            return createGraphElementValueType(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseEnumeration(org.eclipse.uml2.uml.Enumeration)
         */
        public Object caseEnumeration(Enumeration object)
        {
            return createGraphElementEnumeration(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseEnumerationLiteral(org.eclipse.uml2.uml.EnumerationLiteral)
         */
        public Object caseEnumerationLiteral(EnumerationLiteral object)
        {
            return createGraphElementEnumerationLiteral(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConstraintBlock(org.topcased.sysml.ConstraintBlock)
         */
        public Object caseConstraintBlock(ConstraintBlock object)
        {
            return createGraphElementConstraintBlock(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseAssociation(org.eclipse.uml2.uml.Association)
         */
        public Object caseAssociation(Association object)
        {
            return createGraphElementAssociation(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseGeneralization(org.eclipse.uml2.uml.Generalization)
         */
        public Object caseGeneralization(Generalization object)
        {
            return createGraphElementGeneralization(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization)
         */
        public Object caseInterfaceRealization(InterfaceRealization object)
        {
            return createGraphElementInterfaceRealization(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDependency(org.eclipse.uml2.uml.Dependency)
         */
        public Object caseDependency(Dependency object)
        {
            return createGraphElementDependency(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseUsage(org.eclipse.uml2.uml.Usage)
         */
        public Object caseUsage(Usage object)
        {
            return createGraphElementUsage(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConnector(org.eclipse.uml2.uml.Connector)
         */
        public Object caseConnector(Connector object)
        {
            return createGraphElementConnector(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseComment(Comment object)
        {
            return createGraphElementComment(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         */
        public Object caseRationale(Rationale object)
        {
            return createGraphElementRationale(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         */
        public Object caseProblem(Problem object)
        {
            return createGraphElementProblem(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseNamedElement(org.eclipse.uml2.uml.NamedElement)
         *      Added to enable to add NamedElement to the diagram
         */
//        public Object caseNamedElement(NamedElement object)
//        {
//            return createGraphElementNamedElement((NamedElement) object);
//        }
        
        public Object caseBehavioredClassifier(BehavioredClassifier object)
        {
        	return createGraphElementBehavioredClassifier((BehavioredClassifier)object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseContainment(org.eclipse.sysml.containment)
         *      Added to enable to add Containment to the diagram
         */
        public Object caseContainment(Containment object)
        {
            return createGraphElementContainment(object, presentation);
        }


		/**
		 * @see org.topcased.sysml.util.SysMLSwitch#caseUnit(org.topcased.sysml.Unit)
		 * @generated
		 */
		public Object caseUnit(org.topcased.sysml.Unit object) 
		{

			return createGraphElementUnit(object, presentation);
		}

		/**
		 * @see org.topcased.sysml.util.SysMLSwitch#caseDimension(org.topcased.sysml.Dimension)
		 * @generated
		 */
		public Object caseDimension(org.topcased.sysml.Dimension object) 
		{
			return createGraphElementDimension(object, presentation);

		}

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;

        graphElt = new GraphicSwitch(presentation).doSwitch(obj);
        return (GraphElement) graphElt;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementBlockProperty(org.topcased.sysml.BlockProperty element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementProperty(org.eclipse.uml2.uml.Property element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementOperation(org.eclipse.uml2.uml.Operation element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementConstraint(org.eclipse.uml2.uml.Constraint element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementInterface(org.eclipse.uml2.uml.Interface element, String presentation)
    {
        // TODO this snippet of code should be customized if it is not well
        // generated
        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode property = createGraphNode(element, UMLPackage.INTERFACE__OWNED_ATTRIBUTE, presentation);
        property.setContainer(nodeParent);

        GraphNode operation = createGraphNode(element, UMLPackage.INTERFACE__OWNED_OPERATION, presentation);
        operation.setContainer(nodeParent);

        return nodeParent;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementPort(org.eclipse.uml2.uml.Port element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementFlowProperty(org.topcased.sysml.FlowProperty element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementFlowPort(org.topcased.sysml.FlowPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementActor(org.eclipse.uml2.uml.Actor element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementValueType(org.topcased.sysml.ValueType element, String presentation)
    {
        // TODO this snippet of code should be customized if it is not well
        // generated
        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode property = createGraphNode(element, SysMLPackage.VALUE_TYPE__OWNED_ATTRIBUTE, presentation);
        property.setContainer(nodeParent);

        GraphNode operation = createGraphNode(element, SysMLPackage.VALUE_TYPE__OWNED_OPERATION, presentation);
        operation.setContainer(nodeParent);

        return nodeParent;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEnumeration(org.eclipse.uml2.uml.Enumeration element, String presentation)
    {
        // TODO this snippet of code should be customized if it is not well
        // generated
        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode enumerationliteral = createGraphNode(element, UMLPackage.ENUMERATION__OWNED_LITERAL, presentation);
        enumerationliteral.setContainer(nodeParent);

        return nodeParent;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEnumerationLiteral(org.eclipse.uml2.uml.EnumerationLiteral element,
            String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementConstraintBlock(org.topcased.sysml.ConstraintBlock element,
            String presentation)
    {
        // TODO this snippet of code should be customized if it is not well
        // generated
        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode constraint = createGraphNode(element, SysMLPackage.CONSTRAINT_BLOCK__OWNED_RULE, presentation);
        constraint.setContainer(nodeParent);

        GraphNode property = createGraphNode(element, SysMLPackage.CONSTRAINT_BLOCK__OWNED_ATTRIBUTE, presentation);
        property.setContainer(nodeParent);

        return nodeParent;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementGeneralization(org.eclipse.uml2.uml.Generalization element,
            String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization element,
            String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementUsage(org.eclipse.uml2.uml.Usage element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset blockusagestereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        blockusagestereotypeEdgeObjectOffset.setId(BlockDefEdgeObjectConstants.BLOCKUSAGESTEREOTYPE_EDGE_OBJECT_ID);
        blockusagestereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(blockusagestereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementConnector(org.eclipse.uml2.uml.Connector element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(BlockDefEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(nameEdgeObjectOffset);
        EdgeObjectUV portconnectorsrccountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        portconnectorsrccountEdgeObjectUV.setId(BlockDefEdgeObjectConstants.PORTCONNECTORSRCCOUNT_EDGE_OBJECT_ID);
        portconnectorsrccountEdgeObjectUV.setUDistance(0);
        portconnectorsrccountEdgeObjectUV.setVDistance(0);
        graphEdge.getContained().add(portconnectorsrccountEdgeObjectUV);
        EdgeObjectUV portconnectortargetcountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        portconnectortargetcountEdgeObjectUV.setId(BlockDefEdgeObjectConstants.PORTCONNECTORTARGETCOUNT_EDGE_OBJECT_ID);
        portconnectortargetcountEdgeObjectUV.setUDistance(0);
        portconnectortargetcountEdgeObjectUV.setVDistance(0);
        graphEdge.getContained().add(portconnectortargetcountEdgeObjectUV);
        return graphEdge;
    }
    
    /**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementUnit(
			org.topcased.sysml.Unit element, String presentation) {
		return createGraphNode(element, presentation);
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementDimension(
			org.topcased.sysml.Dimension element, String presentation) {
		return createGraphNode(element, presentation);
	}

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementContainment(org.topcased.sysml.Containment element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComment(org.eclipse.uml2.uml.Comment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementRationale(org.topcased.sysml.Rationale element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementProblem(org.topcased.sysml.Problem element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementBlock(Block element, String presentation)
    {
        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode blockproperty = createGraphNode(element, SysMLPackage.BLOCK__OWNED_ATTRIBUTE, presentation);
        blockproperty.setContainer(nodeParent);

        GraphNode operation = createGraphNode(element, SysMLPackage.BLOCK__OWNED_OPERATION, presentation);
        operation.setContainer(nodeParent);

        GraphNode constraint = createGraphNode(element, SysMLPackage.BLOCK__OWNED_RULE, presentation);
        constraint.setContainer(nodeParent);
        return nodeParent;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementFlowSpecification(FlowSpecification element, String presentation)
    {

        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode flowProperty = createGraphNode(element, SysMLPackage.FLOW_SPECIFICATION__OWNED_FLOW_PROPERTY,
                presentation);
        flowProperty.setContainer(nodeParent);

        return nodeParent;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementDataType(DataType element, String presentation)
    {

        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode property = createGraphNode(element, UMLPackage.DATA_TYPE__OWNED_ATTRIBUTE, presentation);
        property.setContainer(nodeParent);

        GraphNode operation = createGraphNode(element, UMLPackage.DATA_TYPE__OWNED_OPERATION, presentation);
        operation.setContainer(nodeParent);

        return nodeParent;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementAssociation(Association element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectUV sourcecountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        sourcecountEdgeObjectUV.setId(BlockDefEdgeObjectConstants.SOURCECOUNT_EDGE_OBJECT_ID);
        sourcecountEdgeObjectUV.setUDistance(LABEL_OFFSET);
        sourcecountEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        graphEdge.getContained().add(sourcecountEdgeObjectUV);
        EdgeObjectUV targetcountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        targetcountEdgeObjectUV.setId(BlockDefEdgeObjectConstants.TARGETCOUNT_EDGE_OBJECT_ID);
        targetcountEdgeObjectUV.setUDistance(LABEL_OFFSET);
        targetcountEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        graphEdge.getContained().add(targetcountEdgeObjectUV);
        EdgeObjectUV sourcenameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        sourcenameEdgeObjectUV.setId(BlockDefEdgeObjectConstants.SOURCENAME_EDGE_OBJECT_ID);
        sourcenameEdgeObjectUV.setUDistance(LABEL_OFFSET);
        sourcenameEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(sourcenameEdgeObjectUV);
        EdgeObjectUV targetnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        targetnameEdgeObjectUV.setId(BlockDefEdgeObjectConstants.TARGETNAME_EDGE_OBJECT_ID);
        targetnameEdgeObjectUV.setUDistance(LABEL_OFFSET);
        targetnameEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(targetnameEdgeObjectUV);
        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(BlockDefEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(nameEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementDependency(Dependency element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset blockdependencystereotypesEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        blockdependencystereotypesEdgeObjectOffset.setId(BlockDefEdgeObjectConstants.BLOCKDEPENDENCYSTEREOTYPES_EDGE_OBJECT_ID);
        blockdependencystereotypesEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(blockdependencystereotypesEdgeObjectOffset);
        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(BlockDefEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(nameEdgeObjectOffset);
        return graphEdge;
    }

    public GraphElement createGraphElementBehavioredClassifier(BehavioredClassifier element)
    {
        GraphNode nodeParent = createGraphNode(element);

        return nodeParent;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private class ModelSwitch extends SysMLSwitch {
        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlock(org.topcased.sysml.Block)
         */
        public Object caseBlock(Block object) {
            return createModelObjectBlock(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlockProperty(org.topcased.sysml.BlockProperty)
         */
        public Object caseBlockProperty(BlockProperty object) {
            return createModelObjectBlockProperty(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProperty(org.eclipse.uml2.uml.Property)
         */
        public Object caseProperty(Property object) {
            return createModelObjectProperty(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseOperation(org.eclipse.uml2.uml.Operation)
         */
        public Object caseOperation(Operation object) {
            return createModelObjectOperation(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConstraint(org.eclipse.uml2.uml.Constraint)
         */
        public Object caseConstraint(Constraint object) {
            return createModelObjectConstraint(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseInterface(org.eclipse.uml2.uml.Interface)
         */
        public Object caseInterface(Interface object) {
            return createModelObjectInterface(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#casePort(org.eclipse.uml2.uml.Port)
         */
        public Object casePort(Port object) {
            return createModelObjectPort(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowSpecification(org.topcased.sysml.FlowSpecification)
         */
        public Object caseFlowSpecification(FlowSpecification object) {
            return createModelObjectFlowSpecification(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowProperty(org.topcased.sysml.FlowProperty)
         */
        public Object caseFlowProperty(FlowProperty object) {
            return createModelObjectFlowProperty(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowPort(org.topcased.sysml.FlowPort)
         */
        public Object caseFlowPort(FlowPort object) {
            return createModelObjectFlowPort(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseActor(org.eclipse.uml2.uml.Actor)
         */
        public Object caseActor(Actor object) {
            return createModelObjectActor(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDataType(org.eclipse.uml2.uml.DataType)
         */
        public Object caseDataType(DataType object) {
            return createModelObjectDataType(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseValueType(org.topcased.sysml.ValueType)
         */
        public Object caseValueType(ValueType object) {
            return createModelObjectValueType(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseEnumeration(org.eclipse.uml2.uml.Enumeration)
         */
        public Object caseEnumeration(Enumeration object) {
            return createModelObjectEnumeration(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseEnumerationLiteral(org.eclipse.uml2.uml.EnumerationLiteral)
         */
        public Object caseEnumerationLiteral(EnumerationLiteral object) {
            return createModelObjectEnumerationLiteral(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConstraintBlock(org.topcased.sysml.ConstraintBlock)
         */
        public Object caseConstraintBlock(ConstraintBlock object) {
            return createModelObjectConstraintBlock(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseAssociation(org.eclipse.uml2.uml.Association)
         */
        public Object caseAssociation(Association object) {
            return createModelObjectAssociation(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseGeneralization(org.eclipse.uml2.uml.Generalization)
         */
        public Object caseGeneralization(Generalization object) {
            return createModelObjectGeneralization(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization)
         */
        public Object caseInterfaceRealization(InterfaceRealization object) {
            return createModelObjectInterfaceRealization(object);
        }
        
        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseUsage(org.eclipse.uml2.uml.Usage)
         */
        public Object caseUsage(Usage object) {
            return createModelObjectUsage(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDependency(org.eclipse.uml2.uml.Dependency)
         */
        public Object caseDependency(Dependency object) {
            return createModelObjectDependency(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConnector(org.eclipse.uml2.uml.Connector)
         */
        public Object caseConnector(Connector object) {
            return createModelObjectConnector(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseComment(Comment object) {
            return createModelObjectComment(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         */
        public Object caseRationale(Rationale object) {
            return createModelObjectRationale(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         */
        public Object caseProblem(Problem object) {
            return createModelObjectProblem(object);
        }
        
        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseUnit(org.topcased.sysml.Unit)
         */
        public Object caseUnit(Unit object) {
            return createModelObjectUnit(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDimension(org.topcased.sysml.Dimension))
         */
        public Object caseDimension(Dimension object) {
            return createModelObjectDimension(object);
        }
        
        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         */
        public Object defaultCase(EObject object) {
            return null;
        }
    }

    /**
     * Create the ModelObject with its initial children
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param obj the model object
     * @return the model object with its children
     */
    public EObject createModelObject(EObject obj) {
        Object eObject = new ModelSwitch().doSwitch(obj);
        return (EObject) eObject;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Block createModelObjectBlock(Block element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected BlockProperty createModelObjectBlockProperty(BlockProperty element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Property createModelObjectProperty(Property element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Operation createModelObjectOperation(Operation element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Constraint createModelObjectConstraint(Constraint element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Interface createModelObjectInterface(Interface element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Port createModelObjectPort(Port element) {
        element.setAggregation(AggregationKind.COMPOSITE_LITERAL);
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected FlowSpecification createModelObjectFlowSpecification(
            FlowSpecification element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected FlowProperty createModelObjectFlowProperty(FlowProperty element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected FlowPort createModelObjectFlowPort(FlowPort element) {
        element.setAggregation(AggregationKind.COMPOSITE_LITERAL);
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Actor createModelObjectActor(Actor element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected DataType createModelObjectDataType(DataType element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected ValueType createModelObjectValueType(ValueType element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Enumeration createModelObjectEnumeration(Enumeration element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected EnumerationLiteral createModelObjectEnumerationLiteral(
            EnumerationLiteral element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected ConstraintBlock createModelObjectConstraintBlock(
            ConstraintBlock element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Association createModelObjectAssociation(Association element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Generalization createModelObjectGeneralization(
            Generalization element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected InterfaceRealization createModelObjectInterfaceRealization(
            InterfaceRealization element) {
        return element;
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Usage createModelObjectUsage(Usage element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Dependency createModelObjectDependency(Dependency element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Connector createModelObjectConnector(Connector element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Comment createModelObjectComment(Comment element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Rationale createModelObjectRationale(Rationale element) {
        return element;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Problem createModelObjectProblem(Problem element) {
        return element;
    } 
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    
    protected Unit createModelObjectUnit(Unit element)
    {
    	return element;
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Dimension createModelObjectDimension(Dimension element)
    {
    	return element;
    }
}
