/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.Enumeration;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.Generalization;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.Usage;
import org.topcased.modeler.ModelerPropertyConstants;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.di.model.SimpleSemanticModelElement;
import org.topcased.modeler.di.model.util.DIUtils;
import org.topcased.modeler.edit.EListEditPart;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.EMFGraphNodeEditPart;
import org.topcased.modeler.edit.GraphEdgeEditPart;
import org.topcased.modeler.edit.GraphNodeEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ActorEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.AssociationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BehavioredClassifierEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BlockDefDiagramEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BlockDefinitionEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BlockEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.BlockPropertyEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ClassifierEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.CommentEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.CommentLinkEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ConnectorEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ConstraintBlockEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ConstraintEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ContainmentEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.DataTypeEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.DependencyEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.DimensionEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.EListBlockEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.EnumerationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.EnumerationLiteralEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.FlowPortEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.FlowPropertyEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.FlowSpecificationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.GeneralizationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.InterfaceEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.InterfaceRealizationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.NamedElementEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.OperationEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.PortEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ProblemEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.PropertyEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.RationaleEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.TypeEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.UnitEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.UsageEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.edit.ValueTypeEditPart;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * Part Factory : associates a model object to its controller. <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class BlockDefEditPartFactory implements EditPartFactory
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,java.lang.Object)
     * @generated NOT
     */
    public EditPart createEditPart(EditPart context, Object model)
    {
        if (model instanceof Diagram)
        {
            return new BlockDefDiagramEditPart((Diagram) model);
        }
        else if (model instanceof GraphNode)
        {
            final GraphNode node = (GraphNode) model;
            EObject element = Utils.getElement(node);
            if (element != null)
            {
                Object editPart = new NodeSysMLSwitch(node).doSwitch(element);
                return (EditPart) editPart;
            }

            if (node.getSemanticModel() instanceof SimpleSemanticModelElement)
            {
                // Manage the Element that are not associated with a model
                // object
            }
            return new GraphNodeEditPart(node);
        }
        else if (model instanceof GraphEdge)
        {
            final GraphEdge edge = (GraphEdge) model;
            EObject element = Utils.getElement(edge);
            if (element != null)
            {
                Object editPart = new EdgeSysMLSwitch(edge).doSwitch(element);
                return (EditPart) editPart;
            }

            if (edge.getSemanticModel() instanceof SimpleSemanticModelElement)
            {
                // Manage the Element that are not associated with a model
                // object
                if (BlockDefSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK.equals(((SimpleSemanticModelElement) edge.getSemanticModel()).getTypeInfo()))
                {
                    return new CommentLinkEditPart(edge);
                }
            }
            return new GraphEdgeEditPart(edge);
        }

        throw new IllegalStateException("No edit part matches with the '" + model.getClass().getName()
                + "' model element. Check BlockDefEditPartFactory#createEditPart(EditPart,Object) class");
    }

    /**
     * @generated NOT
     */
    private class NodeSysMLSwitch extends SysMLSwitch<Object>
    {
        /**
         * The graphical node
         * 
         * @generated
         */
        private GraphNode node;

        /**
         * Constructor
         * 
         * @param node the graphical node
         * @generated
         */
        public NodeSysMLSwitch(GraphNode node)
        {
            this.node = node;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlockDefinition(org.topcased.sysml.BlockDefinition)
         * @generated
         */
        public Object caseBlockDefinition(org.topcased.sysml.BlockDefinition object)
        {
            return new BlockDefinitionEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowPort(org.topcased.sysml.FlowPort)
         * @generated
         */
        public Object caseFlowPort(org.topcased.sysml.FlowPort object)
        {
            return new FlowPortEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowSpecification(org.topcased.sysml.FlowSpecification)
         * @generated
         */
        public Object caseFlowSpecification(org.topcased.sysml.FlowSpecification object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new FlowSpecificationEditPart(node);
            }
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlock(org.topcased.sysml.Block)
         * @generated NOT
         */
        public Object caseBlock(org.topcased.sysml.Block object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListBlockEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new BlockEditPart(node);
            }
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowProperty(org.topcased.sysml.FlowProperty)
         * @generated
         */
        public Object caseFlowProperty(org.topcased.sysml.FlowProperty object)
        {
            return new FlowPropertyEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlockProperty(org.topcased.sysml.BlockProperty)
         * @generated
         */
        public Object caseBlockProperty(org.topcased.sysml.BlockProperty object)
        {
            return new BlockPropertyEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseValueType(org.topcased.sysml.ValueType)
         * @generated
         */
        public Object caseValueType(org.topcased.sysml.ValueType object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new ValueTypeEditPart(node);
            }
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConstraintBlock(org.topcased.sysml.ConstraintBlock)
         * @generated
         */
        public Object caseConstraintBlock(org.topcased.sysml.ConstraintBlock object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new ConstraintBlockEditPart(node);
            }
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.topcased.sysml.Comment)
         */
        public Object caseComment(org.eclipse.uml2.uml.Comment object)
        {
            return new CommentEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         * @generated
         */
        public Object caseRationale(org.topcased.sysml.Rationale object)
        {
            return new RationaleEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         * @generated
         */
        public Object caseProblem(org.topcased.sysml.Problem object)
        {
            return new ProblemEditPart(node);
        }

        public Object caseEnumeration(Enumeration object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new EnumerationEditPart(node);
            }
        }

        public Object caseEnumerationLiteral(EnumerationLiteral object)
        {
            return new EnumerationLiteralEditPart(node);
        }

        public Object caseType(Type object)
        {
            return new TypeEditPart(node);
        }

        public Object caseBehavioredClassifier(BehavioredClassifier object)
        {
            return new BehavioredClassifierEditPart(node);
        }

        public Object caseClassifier(Classifier object)
        {
            return new ClassifierEditPart(node);
        }

        public Object caseNamedElement(NamedElement object)
        {
            return new NamedElementEditPart(node);
        }

        public Object casePort(Port object)
        {
            return new PortEditPart(node);
        }

        public Object caseInterface(Interface object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new InterfaceEditPart(node);
            }
        }

        public Object caseProperty(Property object)
        {
            return new PropertyEditPart(node);
        }

        public Object caseOperation(Operation object)
        {
            return new OperationEditPart(node);
        }

        public Object caseConstraint(Constraint object)
        {
            return new ConstraintEditPart(node);
        }

        public Object caseDataType(DataType object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new DataTypeEditPart(node);
            }
        }

        public Object caseActor(Actor object)
        {
            return new ActorEditPart(node);
        }
        
    	/**
		 * @see org.topcased.sysml.util.SysMLSwitch#caseUnit(org.topcased.sysml.Unit)
		 * @generated
		 */
		public Object caseUnit(org.topcased.sysml.Unit object) {
			return new UnitEditPart(node);
		}

		/**
		 * @see org.topcased.sysml.util.SysMLSwitch#caseDimension(org.topcased.sysml.Dimension)
		 * @generated
		 */
		public Object caseDimension(org.topcased.sysml.Dimension object) {
			return new DimensionEditPart(node);
		}

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return new EMFGraphNodeEditPart(node);
        }
    }

    /**
     * @generated
     */
    private class EdgeSysMLSwitch extends SysMLSwitch<Object>
    {
        /**
         * The graphical edge
         * 
         * @generated
         */
        private GraphEdge edge;

        /**
         * Constructor
         * 
         * @param edge the graphical edge
         * @generated
         */
        public EdgeSysMLSwitch(GraphEdge edge)
        {
            this.edge = edge;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseContainment(org.topcased.sysml.Containment)
         * @generated
         */
        public Object caseContainment(org.topcased.sysml.Containment object)
        {
            return new ContainmentEditPart(edge);
        }

        public Object caseGeneralization(Generalization object)
        {
            return new GeneralizationEditPart(edge);
        }

        public Object caseDependency(Dependency object)
        {
            return new DependencyEditPart(edge);
        }

        public Object caseConnector(Connector object)
        {
            return new ConnectorEditPart(edge);
        }

        public Object caseInterfaceRealization(InterfaceRealization object)
        {
            return new InterfaceRealizationEditPart(edge);
        }

        public Object caseAssociation(Association object)
        {
            return new AssociationEditPart(edge);
        }

        public Object caseUsage(Usage object)
        {
            return new UsageEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return new EMFGraphEdgeEditPart(edge);
        }
    }

}
