/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;
import org.topcased.modeler.sysml.blockdefinitiondiagram.BlockDefImageRegistry;
import org.topcased.sysml.SysMLPackage;

/**
 * Generated Palette Manager <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class BlockDefPaletteManager extends ModelerPaletteManager
{
    // declare all the palette categories of the diagram
    private PaletteDrawer objectsDrawer;

    private PaletteDrawer connectionsDrawer;

    private PaletteDrawer commentsDrawer;

    private ICreationUtils creationUtils;

    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param utils the creation utils for the tools of the palette
     * @generated
     */
    public BlockDefPaletteManager(ICreationUtils utils)
    {
        super();
        this.creationUtils = utils;
    }

    /**
     * Creates the main categories of the palette <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected void createCategories()
    {
        createObjectsDrawer();
        createConnectionsDrawer();
        createCommentsDrawer();
    }

    /**
     * Updates the main categories of the palette <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected void updateCategories()
    {
        // deletion of the existing categories and creation of the updated
        // categories

        getRoot().remove(objectsDrawer);
        createObjectsDrawer();

        getRoot().remove(connectionsDrawer);
        createConnectionsDrawer();

        getRoot().remove(commentsDrawer);
        createCommentsDrawer();
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createObjectsDrawer()
    {
        objectsDrawer = new PaletteDrawer("Objects", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getBlock(), "default");
        entries.add(new ModelerCreationToolEntry("Block", "Block", factory,
                BlockDefImageRegistry.getImageDescriptor("BLOCK"),
                BlockDefImageRegistry.getImageDescriptor("BLOCK_LARGE")));
        

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getConstraintBlock(), "default");
        entries.add(new ModelerCreationToolEntry("Constraint Block", "Constraint Block", factory,
                BlockDefImageRegistry.getImageDescriptor("CONSTRAINTBLOCK"),
                BlockDefImageRegistry.getImageDescriptor("CONSTRAINTBLOCK_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getBlockProperty(), "default");
        entries.add(new ModelerCreationToolEntry("Block Property", "Block Property", factory,
                BlockDefImageRegistry.getImageDescriptor("BLOCKPROPERTY"),
                BlockDefImageRegistry.getImageDescriptor("BLOCKPROPERTY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getProperty(), "default");
        entries.add(new ModelerCreationToolEntry("Property", "Property", factory,
                BlockDefImageRegistry.getImageDescriptor("PROPERTY"),
                BlockDefImageRegistry.getImageDescriptor("PROPERTY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getOperation(), "default");
        entries.add(new ModelerCreationToolEntry("Operation", "Operation", factory,
                BlockDefImageRegistry.getImageDescriptor("OPERATION"),
                BlockDefImageRegistry.getImageDescriptor("OPERATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getConstraint(), "default");
        entries.add(new ModelerCreationToolEntry("Constraint", "Constraint", factory,
                BlockDefImageRegistry.getImageDescriptor("CONSTRAINT"),
                BlockDefImageRegistry.getImageDescriptor("CONSTRAINT_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getPort(), "default");
        entries.add(new ModelerCreationToolEntry("Standard port", "Standard port", factory,
                BlockDefImageRegistry.getImageDescriptor("PORT"),
                BlockDefImageRegistry.getImageDescriptor("PORT_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getFlowPort(), "default");
        entries.add(new ModelerCreationToolEntry("Flow Port", "Flow Port", factory,
                BlockDefImageRegistry.getImageDescriptor("FLOWPORT"),
                BlockDefImageRegistry.getImageDescriptor("FLOWPORT_LARGE")));        

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getInterface(), "default");
        entries.add(new ModelerCreationToolEntry("Interface", "Interface", factory,
                BlockDefImageRegistry.getImageDescriptor("INTERFACE"),
                BlockDefImageRegistry.getImageDescriptor("INTERFACE_LARGE")));



        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getFlowSpecification(),
                "default");
        entries.add(new ModelerCreationToolEntry("Flow Specification", "Flow Specification", factory,
                BlockDefImageRegistry.getImageDescriptor("FLOWSPECIFICATION"),
                BlockDefImageRegistry.getImageDescriptor("FLOWSPECIFICATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getFlowProperty(), "default");
        entries.add(new ModelerCreationToolEntry("Flow Property", "Flow Property", factory,
                BlockDefImageRegistry.getImageDescriptor("FLOWPROPERTY"),
                BlockDefImageRegistry.getImageDescriptor("FLOWPROPERTY_LARGE")));

      

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getActor(), "default");
        entries.add(new ModelerCreationToolEntry("Actor", "Actor", factory,
                BlockDefImageRegistry.getImageDescriptor("ACTOR"),
                BlockDefImageRegistry.getImageDescriptor("ACTOR_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDataType(), "default");
        entries.add(new ModelerCreationToolEntry("Datatype", "Datatype", factory,
                BlockDefImageRegistry.getImageDescriptor("DATATYPE"),
                BlockDefImageRegistry.getImageDescriptor("DATATYPE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getValueType(), "default");
        entries.add(new ModelerCreationToolEntry("Value Type", "Value Type", factory,
                BlockDefImageRegistry.getImageDescriptor("VALUETYPE"),
                BlockDefImageRegistry.getImageDescriptor("VALUETYPE_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils,
                SysMLPackage.eINSTANCE.getUnit(), "default");
        entries.add(new ModelerCreationToolEntry("Unit", "Unit", factory,
                BlockDefImageRegistry.getImageDescriptor("UNIT"),
                BlockDefImageRegistry.getImageDescriptor("UNIT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils,
                SysMLPackage.eINSTANCE.getDimension(), "default");
        entries.add(new ModelerCreationToolEntry("Dimension", "Dimension",
                factory, BlockDefImageRegistry.getImageDescriptor("DIMENSION"),
                BlockDefImageRegistry.getImageDescriptor("DIMENSION_LARGE")));


        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getEnumeration(), "default");
        entries.add(new ModelerCreationToolEntry("Enumeration", "Enumeration", factory,
                BlockDefImageRegistry.getImageDescriptor("ENUMERATION"),
                BlockDefImageRegistry.getImageDescriptor("ENUMERATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getEnumerationLiteral(),
                "default");
        entries.add(new ModelerCreationToolEntry("Enumeration Literal", "Enumeration Literal", factory,
                BlockDefImageRegistry.getImageDescriptor("ENUMERATIONLITERAL"),
                BlockDefImageRegistry.getImageDescriptor("ENUMERATIONLITERAL_LARGE")));


    
        objectsDrawer.addAll(entries);
        getRoot().add(objectsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createConnectionsDrawer()
    {
        connectionsDrawer = new PaletteDrawer("Connections", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAssociation(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Association", "Association", factory,
                BlockDefImageRegistry.getImageDescriptor("ASSOCIATION"),
                BlockDefImageRegistry.getImageDescriptor("ASSOCIATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getGeneralization(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Generalization", "Generalization", factory,
                BlockDefImageRegistry.getImageDescriptor("GENERALIZATION"),
                BlockDefImageRegistry.getImageDescriptor("GENERALIZATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getInterfaceRealization(),
                "default");
        entries.add(new ModelerConnectionCreationToolEntry("InterfaceRealization", "InterfaceRealization", factory,
                BlockDefImageRegistry.getImageDescriptor("INTERFACEREALIZATION"),
                BlockDefImageRegistry.getImageDescriptor("INTERFACEREALIZATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getUsage(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Usage", "Usage", factory,
                BlockDefImageRegistry.getImageDescriptor("USAGE"),
                BlockDefImageRegistry.getImageDescriptor("USAGE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDependency(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Dependency", "Dependency", factory,
                BlockDefImageRegistry.getImageDescriptor("DEPENDENCY"),
                BlockDefImageRegistry.getImageDescriptor("DEPENDENCY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getConnector(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Connector", "Connector", factory,
                BlockDefImageRegistry.getImageDescriptor("CONNECTOR"),
                BlockDefImageRegistry.getImageDescriptor("CONNECTOR_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getContainment(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Containment", "Containment", factory,
                BlockDefImageRegistry.getImageDescriptor("CONTAINMENT"),
                BlockDefImageRegistry.getImageDescriptor("CONTAINMENT_LARGE")));

        connectionsDrawer.addAll(entries);
        getRoot().add(connectionsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createCommentsDrawer()
    {
        commentsDrawer = new PaletteDrawer("Comments", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getComment(), "default");
        entries.add(new ModelerCreationToolEntry("Comment", "Comment", factory,
                BlockDefImageRegistry.getImageDescriptor("COMMENT"),
                BlockDefImageRegistry.getImageDescriptor("COMMENT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getRationale(), "default");
        entries.add(new ModelerCreationToolEntry("Rationale", "Rationale", factory,
                BlockDefImageRegistry.getImageDescriptor("RATIONALE"),
                BlockDefImageRegistry.getImageDescriptor("RATIONALE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getProblem(), "default");
        entries.add(new ModelerCreationToolEntry("Problem", "Problem", factory,
                BlockDefImageRegistry.getImageDescriptor("PROBLEM"),
                BlockDefImageRegistry.getImageDescriptor("PROBLEM_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils,
                BlockDefSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK, "default", false);
        entries.add(new ModelerConnectionCreationToolEntry("Comment Link", "Comment Link", factory,
                BlockDefImageRegistry.getImageDescriptor("COMMENTLINK"),
                BlockDefImageRegistry.getImageDescriptor("COMMENTLINK_LARGE")));

        commentsDrawer.addAll(entries);
        getRoot().add(commentsDrawer);
    }

}
