/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.commands;

import org.eclipse.gef.EditDomain;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.UMLFactory;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.utils.LabelHelper;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.Block;
import org.topcased.sysml.PackageSYSML;
import org.topcased.sysml.SysMLFactory;

/**
 * Association edge creation command<br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class AssociationEdgeCreationCommand extends CreateTypedEdgeCommand
{

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @generated
     */
    public AssociationEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src)
    {
        this(domain, newObj, src, true);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @param needModelUpdate set it to true if the model need to be updated
     * @generated
     */
    public AssociationEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src, boolean needModelUpdate)
    {
        super(domain, newObj, src, needModelUpdate);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void redoModel()
    {
        // Retrieve source object and target object
        Type sourceObject = (Type) Utils.getElement(getSource());
        Type targetObject = (Type) Utils.getElement(getTarget());

        // Create the association and add it to the current block definition
        Association association = (Association) Utils.getElement(getEdge());

        PackageSYSML blockDef = (PackageSYSML) Utils.getDiagramModelObject(getSource());
        blockDef.getOwnedRelationships().add(association);

        // init the name of the association contained by the package
        String curName = LabelHelper.INSTANCE.getName(getEditDomain(), association);
        if (curName == null || curName.length() == 0)
        {
            LabelHelper.INSTANCE.initName(getEditDomain(), Utils.getElement(getEdge()).eContainer(), association);
        }

        // Create two properties that handle the link between the two object
        Property property1;
        if (targetObject instanceof Block)
            property1 = SysMLFactory.eINSTANCE.createBlockProperty();
        else
            property1 = UMLFactory.eINSTANCE.createProperty();
        property1.setName("source");
        property1.setType(sourceObject);

        Property property2;
        if (sourceObject instanceof Block)
            property2 = SysMLFactory.eINSTANCE.createBlockProperty();
        else
            property2 = UMLFactory.eINSTANCE.createProperty();
        property2.setName("target");
        property2.setType(targetObject);

        // Add the properties to the association
        association.getOwnedEnds().add(property1);
        association.getOwnedEnds().add(property2);

        // Add the Multiplicity of the Lower and Upper bound of the Property
        property1.setLower(1);
        property1.setUpper(1);

        property2.setLower(1);
        property2.setUpper(1);

        property1.setIsNavigable(false);
        property2.setIsNavigable(false);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void undoModel()
    {
        Association association = (Association) Utils.getElement(getEdge());
        // Remove Association ends
        Property property1 = ((Property) association.getMemberEnds().get(0));
        Property property2 = ((Property) association.getMemberEnds().get(1));
        property1.destroy();
        property2.destroy();
        // Remove the association from the block definition
        association.destroy();
    }

}