/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.commands;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditDomain;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.utils.Utils;

/**
 * InterfaceRealization edge creation command<br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class InterfaceRealizationEdgeCreationCommand extends CreateTypedEdgeCommand
{

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @generated
     */
    public InterfaceRealizationEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src)
    {
        this(domain, newObj, src, true);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @param needModelUpdate set it to true if the model need to be updated
     * @generated
     */
    public InterfaceRealizationEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src,
            boolean needModelUpdate)
    {
        super(domain, newObj, src, needModelUpdate);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void redoModel()
    {
        EObject containerEObject = getContainerEObject();

        if (containerEObject != null /*
                                         * &&
                                         * !"".equals(_data.getContainerRef())
                                         */)
        {
            initName(containerEObject);
        }

        // Retrieve source object and target object
        Interface targetObject = (Interface) Utils.getElement(getTarget());
        BehavioredClassifier sourceObject = (BehavioredClassifier) Utils.getElement(getSource());

        InterfaceRealization impl = (InterfaceRealization) Utils.getElement(getEdge());

        // Reference to the client must be set after setting reference to the
        // supplier
        // so that ports which are typed by the client can know the supplier
        // during notification
        impl.setContract(targetObject);
        impl.setImplementingClassifier(sourceObject);
        sourceObject.getInterfaceRealizations().add(impl);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void undoModel()
    {
        // Retrieve source object and target object
        BehavioredClassifier sourceObject = (BehavioredClassifier) Utils.getElement(getSource());

        InterfaceRealization impl = (InterfaceRealization) Utils.getElement(getEdge());

        sourceObject.getClientDependencies().remove(impl);
    }

}