/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.commands;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditDomain;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Usage;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.PackageSYSML;

/**
 * Usage edge creation command<br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class UsageEdgeCreationCommand extends CreateTypedEdgeCommand
{

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @generated
     */
    public UsageEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src)
    {
        this(domain, newObj, src, true);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @param needModelUpdate set it to true if the model need to be updated
     * @generated
     */
    public UsageEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src, boolean needModelUpdate)
    {
        super(domain, newObj, src, needModelUpdate);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void redoModel()
    {
        EObject containerEObject = getContainerEObject();

        // Retrieve source object and target object
        NamedElement targetObject = (NamedElement) Utils.getElement(getTarget());
        NamedElement sourceObject = (NamedElement) Utils.getElement(getSource());

        Usage usage = (Usage) Utils.getElement(getEdge());

        if (containerEObject instanceof PackageSYSML)
        {
            initName(containerEObject);
            ((PackageSYSML) containerEObject).getOwnedRelationships().add(usage);
        }

        usage.getSuppliers().add(targetObject);
        // Reference to the client must be set after setting reference to the
        // supplier
        // so that ports which are typed by the client can know the supplier
        // during notification
        usage.getClients().add(sourceObject);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void undoModel()
    {
        // Retrieve source object and target object
        NamedElement targetObject = (NamedElement) Utils.getElement(getTarget());
        NamedElement sourceObject = (NamedElement) Utils.getElement(getSource());

        Usage usage = (Usage) Utils.getElement(getEdge());

        usage.getClients().remove(sourceObject);
        usage.getSuppliers().remove(targetObject);

        EObject containerEObject = getContainerEObject();
        if (containerEObject instanceof PackageSYSML)
        {
            ((PackageSYSML) containerEObject).getOwnedRelationships().remove(usage);
        }
    }

}