/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import java.util.Iterator;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.draw2d.RotatableDecoration;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.AggregationKind;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.ValueSpecification;
import org.topcased.draw2d.figures.Label;
import org.topcased.modeler.ModelerColorConstants;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.EdgeObject;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.policies.EdgeObjectOffsetEditPolicy;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.sysml.blockdefinitiondiagram.BlockDefEdgeObjectConstants;
import org.topcased.modeler.sysml.blockdefinitiondiagram.BlockDefEditPolicyConstants;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.AssociationFigure;
import org.topcased.modeler.sysml.blockdefinitiondiagram.policies.AssociationEdgeObjectUVEditPolicy;
import org.topcased.modeler.sysml.blockdefinitiondiagram.policies.CommentLinkEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.blockdefinitiondiagram.util.AssociationHelper;
import org.topcased.modeler.sysml.util.SysMLTools;
import org.topcased.modeler.utils.Utils;

/**
 * Association controller <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class AssociationEditPart extends EMFGraphEdgeEditPart
{

    private RotatableDecoration srcDecor;

    private RotatableDecoration targetDecor;

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the graph object
     * @generated
     */
    public AssociationEditPart(GraphEdge model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        // Add a CommentLink Policy to this element
        installEditPolicy(BlockDefEditPolicyConstants.COMMENTLINK_EDITPOLICY, new CommentLinkEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_UV_EDITPOLICY,
                new AssociationEdgeObjectUVEditPolicy());
        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_OFFSET_EDITPOLICY, new EdgeObjectOffsetEditPolicy());

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Figure
     * @generated
     */
    protected IFigure createFigure()
    {
        AssociationFigure connection = new AssociationFigure();

        return connection;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#getEdgeObjectFigure(org.topcased.modeler.di.model.EdgeObject)
     * @generated
     */
    public IEdgeObjectFigure getEdgeObjectFigure(EdgeObject edgeObject)
    {
        if (BlockDefEdgeObjectConstants.SOURCECOUNT_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((AssociationFigure) getFigure()).getSourceCountEdgeObjectFigure();
        }
        if (BlockDefEdgeObjectConstants.TARGETCOUNT_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((AssociationFigure) getFigure()).getTargetCountEdgeObjectFigure();
        }
        if (BlockDefEdgeObjectConstants.SOURCENAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((AssociationFigure) getFigure()).getSourceNameEdgeObjectFigure();
        }
        if (BlockDefEdgeObjectConstants.TARGETNAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((AssociationFigure) getFigure()).getTargetNameEdgeObjectFigure();
        }
        if (BlockDefEdgeObjectConstants.NAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((AssociationFigure) getFigure()).getNameEdgeObjectFigure();
        }
        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void refreshEdgeObjects()
    {
        super.refreshEdgeObjects();

        Association association = (Association) Utils.getElement(getGraphEdge());

        // Check whether the association has its two Properties set
        if (association.isBinary())
        {
            if (((GraphEdge) getModel()).getAnchor().size() != 0)
            {
                updateSourceDecoration();
                updateTargetDecoration();
                updateSourceCountLabel();
                updateSourceNameLabel();
                updateTargetCountLabel();
                updateTargetNameLabel();
            }

            updateNameLabel();
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the srcName Label
     * 
     * @generated NOT
     */
    private void updateSourceNameLabel()
    {
        Label srcName = (Label) ((AssociationFigure) getFigure()).getSourceNameEdgeObjectFigure();

        Association association = (Association) Utils.getElement(getGraphEdge());
        AssociationHelper associationHelper = new AssociationHelper(association);
        boolean isOrdered = associationHelper.getAssociationFirstEndIsOrdered();

        String visibility = SysMLTools.getVisibilityNotation(associationHelper.getAssociationFirstEndVisibilityKind());

        if (isOrdered)
        {
            srcName.setText(visibility + " " + associationHelper.getAssociationFirstEndRole() + " {ordered}");
        }
        else
        {
            srcName.setText(visibility + " " + associationHelper.getAssociationFirstEndRole());
        }

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the srcCount Label
     * 
     * @generated NOT
     */
    private void updateSourceCountLabel()
    {
        Label srcCount = (Label) ((AssociationFigure) getFigure()).getSourceCountEdgeObjectFigure();

        Association association = (Association) Utils.getElement(getGraphEdge());
        AssociationHelper associationHelper = new AssociationHelper(association);

        String lowerBound = associationHelper.getAssociationFirstEndLowerBound();
        String upperBound = associationHelper.getAssociationFirstEndUpperBound();
        // boolean isOrdered =
        // associationHelper.getAssociationFirstEndIsOrdered();
        //
        // if (isOrdered)
        // {
        // if (lowerBound.equals(upperBound))
        // {
        // srcCount.setText("{" + lowerBound + "}");
        // }
        // else
        // {
        // srcCount.setText("{" + lowerBound + ".." + upperBound + "}");
        // }
        // }
        // else
        // {
        if (lowerBound.equals(upperBound))
        {
            srcCount.setText(lowerBound);
        }
        else
        {
            srcCount.setText(lowerBound + ".." + upperBound);
        }
        // }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the targetName Label
     * 
     * @generated NOT
     */
    private void updateTargetNameLabel()
    {
        Label targetName = (Label) ((AssociationFigure) getFigure()).getTargetNameEdgeObjectFigure();

        Association association = (Association) Utils.getElement(getGraphEdge());
        AssociationHelper associationHelper = new AssociationHelper(association);
        boolean isOrdered = associationHelper.getAssociationSecondEndIsOrdered();

        String visibility = SysMLTools.getVisibilityNotation(associationHelper.getAssociationSecondEndVisibilityKind());

        if (isOrdered)
        {
            targetName.setText(visibility + " " + associationHelper.getAssociationSecondEndRole() + " {ordered}");

        }
        else
        {
            targetName.setText(visibility + " " + associationHelper.getAssociationSecondEndRole());

        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the targetCount
     * Label
     * 
     * @generated NOT
     */
    private void updateTargetCountLabel()
    {
        Label targetCount = (Label) ((AssociationFigure) getFigure()).getTargetCountEdgeObjectFigure();

        Association association = (Association) Utils.getElement(getGraphEdge());
        AssociationHelper associationHelper = new AssociationHelper(association);

        String lowerBound = associationHelper.getAssociationSecondEndLowerBound();
        String upperBound = associationHelper.getAssociationSecondEndUpperBound();
        // boolean isOrdered =
        // associationHelper.getAssociationSecondEndIsOrdered();
        //
        // if (isOrdered)
        // {
        // if (lowerBound.equals(upperBound))
        // {
        // targetCount.setText("{" + lowerBound + "}");
        // }
        // else
        // {
        // targetCount.setText("{" + lowerBound + ".." + upperBound + "}");
        // }
        // }
        // else
        // {
        if (lowerBound.equals(upperBound))
        {
            targetCount.setText(lowerBound);
        }
        else
        {
            targetCount.setText(lowerBound + ".." + upperBound);
        }
        // }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the middleName Label
     * 
     * @generated NOT
     */
    private void updateNameLabel()
    {
        // Association association = (Association)
        // Utils.getElement(getGraphEdge());
        //
        // AssociationFigure fig = ((AssociationFigure) getFigure());
        // EdgeObjectOffsetEditableLabel label = (EdgeObjectOffsetEditableLabel)
        // fig.getNameEdgeObjectFigure();
        // label.setText(((Association)
        // getEObject()).getName()+SysMLTools.getStereotypeNotation(association));
        String stereotypes = SysMLTools.getStereotypesList((Association) getEObject());
        if (stereotypes.length() != 0)
        {
            stereotypes = ", " + stereotypes;
        }
        ((Label) ((AssociationFigure) getFigure()).getNameEdgeObjectFigure()).setText(
                ((Association) getEObject()).getName() + stereotypes);
    }

    /**
     * update the source decoration
     * 
     * @param graphicSourceIsModelSource
     */
    private void updateSourceDecoration()
    {
        Association association = (Association) Utils.getElement(getGraphEdge());

        AssociationHelper associationHelper = new AssociationHelper(association);

        boolean isNavigable = associationHelper.getAssociationFirstEndIsNavigable();
        // boolean otherIsNavigable =
        // associationHelper.getAssociationSecondEndIsNavigable();
        AggregationKind otherAggregationKind = associationHelper.getAssociationFirstEndAggregationKind();

        if (AggregationKind.COMPOSITE_LITERAL.equals(otherAggregationKind))
        {
            srcDecor = createCompositionDecoration();
        }
        else if (AggregationKind.SHARED_LITERAL.equals(otherAggregationKind))
        {
            srcDecor = createAggregationDecoration();
        }
        else if (isNavigable/* && !otherIsNavigable */)
        {
            srcDecor = createNavigableDecoration();
        }
        else
        {
            srcDecor = null;
        }
        ((PolylineConnection) getFigure()).setSourceDecoration(srcDecor);
    }

    /**
     * Update the target decoration
     * 
     * @param graphicTargetIsModelTarget
     */
    private void updateTargetDecoration()
    {
        Association association = (Association) Utils.getElement(getGraphEdge());

        AssociationHelper associationHelper = new AssociationHelper(association);

        boolean isNavigable = associationHelper.getAssociationSecondEndIsNavigable();
        // boolean otherIsNavigable =
        // associationHelper.getAssociationFirstEndIsNavigable();
        AggregationKind otherAggregationKind = associationHelper.getAssociationSecondEndAggregationKind();

        if (AggregationKind.COMPOSITE_LITERAL.equals(otherAggregationKind))
        {
            targetDecor = createCompositionDecoration();
        }
        else if (AggregationKind.SHARED_LITERAL.equals(otherAggregationKind))
        {
            targetDecor = createAggregationDecoration();
        }
        else if (isNavigable /* && !otherIsNavigable */)
        {
            targetDecor = createNavigableDecoration();
        }
        else
        {
            targetDecor = null;
        }
        ((PolylineConnection) getFigure()).setTargetDecoration(targetDecor);
    }

    /**
     * @return PolygonDecoration
     */
    private PolygonDecoration createCompositionDecoration()
    {
        PolygonDecoration decoration = new PolygonDecoration();
        PointList decorationPointList = new PointList();
        decorationPointList.addPoint(0, 0);
        decorationPointList.addPoint(-1, 1);
        decorationPointList.addPoint(-2, 0);
        decorationPointList.addPoint(-1, -1);
        decoration.setTemplate(decorationPointList);
        decoration.setScale(10, 5);
        return decoration;
    }

    /**
     * @return PolygonDecoration
     */
    private PolygonDecoration createAggregationDecoration()
    {
        PolygonDecoration decoration = new PolygonDecoration();
        PointList decorationPointList = new PointList();
        decorationPointList.addPoint(0, 0);
        decorationPointList.addPoint(-1, 1);
        decorationPointList.addPoint(-2, 0);
        decorationPointList.addPoint(-1, -1);
        decoration.setBackgroundColor(ModelerColorConstants.white);
        decoration.setTemplate(decorationPointList);
        decoration.setScale(10, 5);
        return decoration;
    }

    /**
     * @return PolylineDecoration
     */
    private PolylineDecoration createNavigableDecoration()
    {
        PolylineDecoration decoration = new PolylineDecoration();
        decoration.setScale(10, 5);
        return decoration;
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphEdgeEditPart#handleModelChanged(org.eclipse.emf.common.notify.Notification)
     */
    protected void handleModelChanged(Notification msg)
    {

        Object notifier = msg.getNotifier();
        Object newObject = msg.getNewValue();
        Object oldObject = msg.getOldValue();

        if (notifier instanceof Association)
        {
            if (notifier == getEObject())
            {
                switch (msg.getFeatureID(Association.class))
                {
                    case UMLPackage.ASSOCIATION__MEMBER_END:
                    case UMLPackage.ASSOCIATION__EANNOTATIONS:
                        updateModelListening(oldObject, newObject);
                        break;
                }
                super.handleModelChanged(msg);
            }
        }
        else if (notifier instanceof Property)
        {
            switch (msg.getFeatureID(Property.class))
            {
                case UMLPackage.PROPERTY__AGGREGATION:
                    updateSourceDecoration();
                    updateTargetDecoration();
                    break;
                case UMLPackage.PROPERTY__IS_ORDERED:
                    updateSourceNameLabel();
                    updateTargetNameLabel();
                    break;
                case UMLPackage.PROPERTY__VISIBILITY:
                case UMLPackage.PROPERTY__NAME:
                    updateSourceNameLabel();
                    updateTargetNameLabel();
                    break;
                case UMLPackage.PROPERTY__LOWER_VALUE:
                case UMLPackage.PROPERTY__UPPER_VALUE:
                case UMLPackage.PROPERTY__DEFAULT_VALUE:
                    updateModelListening(oldObject, newObject);
                    break;
            }
        }
        else if (notifier instanceof ValueSpecification)
        {
            updateSourceCountLabel();
            updateTargetCountLabel();
        }
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#activate()
     */
    public void activate()
    {
        super.activate();
        EObject model = getEObject();
        if (model instanceof Association)
        {
            listenProperties((Association) model);
        }
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#deactivate()
     */
    public void deactivate()
    {
        EObject model = getEObject();
        if (model instanceof Association)
        {
            unlistenProperties((Association) model);
        }
        super.deactivate();
    }

    /**
     * Listen to all the properties associated with the association
     * 
     * @param association the model object
     */
    private void listenProperties(Association association)
    {
        Iterator< ? > it = association.getMemberEnds().iterator();
        while (it.hasNext())
        {
            Property prop = (Property) it.next();

            // Only listen to object that are not yet listened
            if (!prop.eAdapters().contains(getModelListener()))
            {
                prop.eAdapters().add(getModelListener());
            }
            listenValues(prop);
        }
    }

    /**
     * Stop listening to all the redefined operations of the operation
     * 
     * @param association the model object
     */
    private void unlistenProperties(Association association)
    {
        Iterator< ? > it = association.getMemberEnds().iterator();
        while (it.hasNext())
        {
            Property prop = (Property) it.next();

            unlistenValues(prop);

            prop.eAdapters().remove(getModelListener());
        }
    }

    /**
     * Listen to the bounds of the property
     * 
     * @param property the model object
     */
    private void listenValues(Property property)
    {
        // Only listen to object that are not yet listened
        if (property.getLowerValue() != null && !property.getLowerValue().eAdapters().contains(getModelListener()))
        {
            property.getLowerValue().eAdapters().add(getModelListener());
        }
        if (property.getUpperValue() != null && !property.getUpperValue().eAdapters().contains(getModelListener()))
        {
            property.getUpperValue().eAdapters().add(getModelListener());
        }
        if (property.getDefaultValue() != null && !property.getDefaultValue().eAdapters().contains(getModelListener()))
        {
            property.getDefaultValue().eAdapters().add(getModelListener());
        }
    }

    /**
     * Stop listening to the bounds of the property
     * 
     * @param property the model object
     */
    private void unlistenValues(Property property)
    {
        if (property.getLowerValue() != null)
        {
            property.getLowerValue().eAdapters().remove(getModelListener());
        }
        if (property.getUpperValue() != null)
        {
            property.getUpperValue().eAdapters().remove(getModelListener());
        }
        if (property.getDefaultValue() != null)
        {
            property.getDefaultValue().eAdapters().remove(getModelListener());
        }
    }
}