/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.edit.policies.ResizableEditPolicy;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Display;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.Element;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.modeler.ModelerColorConstants;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.LabelDirectEditPolicy;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.sysml.blockdefinitiondiagram.BlockDefEditPolicyConstants;
import org.topcased.modeler.sysml.blockdefinitiondiagram.commands.BehavioredClassifierRestoreConnectionCommand;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.BehavioredClassifierFigure;
import org.topcased.modeler.sysml.blockdefinitiondiagram.policies.InterfaceRealizationEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.blockdefinitiondiagram.util.BlockTools;
import org.topcased.modeler.sysml.util.SysMLTools;
import org.topcased.modeler.utils.Utils;

/**
 * The BehavioredClassifier object controller <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class BehavioredClassifierEditPart extends ClassifierEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public BehavioredClassifierEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(BlockDefEditPolicyConstants.INTERFACEREALIZATION_EDITPOLICY,
                new InterfaceRealizationEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new BehavioredClassifierRestoreConnectionCommand(getHost());
            }
        });

        installEditPolicy(ModelerEditPolicyConstants.RESIZABLE_EDITPOLICY, new ResizableEditPolicy());

        installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LabelDirectEditPolicy());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated
     */
    protected IFigure createFigure()
    {

        return new BehavioredClassifierFigure();
    }

    protected void refreshHeaderLabel()
    {
        BehavioredClassifierFigure fig = (BehavioredClassifierFigure) getFigure();
        ComposedLabel lbl = (ComposedLabel) fig.getLabel();
        BehavioredClassifier elt = (BehavioredClassifier) Utils.getElement(getGraphNode());

        String stereotypes = SysMLTools.getStereotypesList(elt);
        if (stereotypes.length() != 0)
        {
            stereotypes = ", " + stereotypes;

        }
        lbl.setPrefix("<<" + elt.eClass().getName().toLowerCase() + stereotypes + ">>");

        if (elt.getName() != null)
        {
            lbl.setMain(elt.getName());
        }

        lbl.setSuffix(BlockTools.getFromNotation(elt, (Element) Utils.getElement((GraphElement) getParent().getModel())));
    }

    protected Font getDefaultFont()
    {
        FontData[] fData = Display.getDefault().getSystemFont().getFontData();
        fData[0].setStyle(SWT.BOLD);
        JFaceResources.getFontRegistry().put("BoldFont", fData);
        return JFaceResources.getFontRegistry().get("BoldFont");
    }

    protected Color getDefaultBackgroundColor()
    {
        return ModelerColorConstants.lightRed;
    }
}