/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.edit.DiagramEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.BlockDefDiagramFigure;
import org.topcased.modeler.sysml.blockdefinitiondiagram.policies.BlockDefDiagramLayoutEditPolicy;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.Block;
import org.topcased.sysml.PackageSYSML;
import org.topcased.sysml.ConstraintBlock;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class BlockDefDiagramEditPart extends DiagramEditPart
{

    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the root model element
     * @generated
     */
    public BlockDefDiagramEditPart(Diagram model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#getLayoutEditPolicy()
     * @generated
     */
    protected EditPolicy getLayoutEditPolicy()
    {
        return new BlockDefDiagramLayoutEditPolicy();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#createBodyFigure()
     * @generated
     */
    protected IFigure createBodyFigure()
    {
        return new BlockDefDiagramFigure();
    }

    /**
     * @see org.topcased.modeler.edit.DiagramEditPart#getHeaderDiagram()
     */
    protected String getHeaderDiagram()
    {
        if(Utils.getElement(getDiagram()) instanceof ConstraintBlock)
        {
            return "[constraintBlock] "+((ConstraintBlock) Utils.getElement(getDiagram())).getName() + " [" + getDiagram().getName() + "]";
        }
        else if(Utils.getElement(getDiagram()) instanceof ConstraintBlock)
        {
           return "[block] "+((Block) Utils.getElement(getDiagram())).getName() + " [" + getDiagram().getName() + "]";
            
        }   
        return "[package] "+((PackageSYSML) Utils.getElement(getDiagram())).getName() + " [" + getDiagram().getName() + "]";
    }

    /**
     * @see org.topcased.modeler.edit.DiagramEditPart#refreshTextAndFont()
     */
    protected void refreshTextAndFont()
    {
        super.refreshTextAndFont();
        getFigure().repaint();
    }
}