/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Laleve (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gef.EditPolicy;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.EListEditPart;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.EListBlockFigure;

/**
 * This edit part adds abilities for model objects linked with the
 * EStructuralFeature of an EMF object.
 * 
 * This edit part doesn't have layout edit policy Child creations are managed by
 * layout edit policy of parent edit part (a block edit part) in order to enable
 * to move ports
 */
public class EListBlockEditPart extends EListEditPart
{

    /**
     * Constructor
     * 
     * @param obj
     * @param feature the EStructuralFeature
     */
    public EListBlockEditPart(GraphNode obj, EStructuralFeature feature)
    {
        super(obj, feature);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(EditPolicy.LAYOUT_ROLE, null);
    }

    /**
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    protected IFigure createFigure()
    {
        return new EListBlockFigure();
    }

}
