/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Laleve (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gef.EditPolicy;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.sysml.blockdefinitiondiagram.policies.EListLayoutEditPolicy;

/**
 * This edit part adds abilities for model objects linked with the
 * EStructuralFeature of an EMF object.<br>
 * 
 * This edit part doesn't have the same layout edit policy than
 * org.topcased.modeler.edit.EListEditPart
 */
public class EListEditPart extends org.topcased.modeler.edit.EListEditPart
{
    /**
     * Constructor
     * 
     * @param obj
     * @param feature the EStructuralFeature
     */
    public EListEditPart(GraphNode obj, EStructuralFeature feature)
    {
        super(obj, feature);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(EditPolicy.LAYOUT_ROLE, new EListLayoutEditPolicy(getEStructuralFeature()));
    }
}
