/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.sysml.blockdefinitiondiagram.commands.FlowPortRestoreConnectionCommand;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.FlowPortFigure;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.PortFigure;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.FlowDirectionKind;
import org.topcased.sysml.FlowPort;

/**
 * The FlowPort object controller <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class FlowPortEditPart extends PortEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public FlowPortEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new FlowPortRestoreConnectionCommand(getHost());
            }
        });

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated
     */
    protected IFigure createFigure()
    {

        return new FlowPortFigure();
    }

    /**
     * Return the FlowPort model object
     * 
     * @return the FlowPort model object
     */
    public FlowPort getModelFlowPort()
    {
        return (FlowPort) Utils.getElement(getGraphNode());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#refreshVisuals()
     * @generated NOT
     */
    protected void refreshVisuals()
    {
        super.refreshVisuals();
        updatePortDirection();
        updatePortAtomicity();
        updatePortConjugation();
    }

    /**
     * Update port direction
     */
    protected void updatePortDirection()
    {
        int portType;
        switch (((FlowPort) getEObject()).getDirection().getValue())
        {
            case FlowDirectionKind.IN:
                portType = PortFigure.IN_PORT;
                break;
            case FlowDirectionKind.OUT:
                portType = PortFigure.OUT_PORT;
                break;
            default:
                portType = PortFigure.IN_OUT_PORT;
        }
        ((FlowPortFigure) getFigure()).setDirection(portType);
    }

    /**
     * Update port atomicity
     */
    public void updatePortAtomicity()
    {
        try
        {
            boolean isAtomic = ((FlowPort) getEObject()).isIsAtomic();
            ((FlowPortFigure) getFigure()).setIsAtomic(isAtomic);
        }
        catch (UnsupportedOperationException ex)
        {
            ((FlowPortFigure) getFigure()).setIsAtomic(true);
        }
    }

    /**
     * Update port conjugation
     */
    public void updatePortConjugation()
    {
        boolean isConjugated = ((FlowPort) getEObject()).isIsConjugated();
        ((FlowPortFigure) getFigure()).setIsConjugated(isConjugated);
    }

}