/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.uml2.uml.Property;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.LabelDirectEditPolicy;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.sysml.blockdefinitiondiagram.commands.FlowPropertyRestoreConnectionCommand;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.FlowPropertyFigure;
import org.topcased.modeler.sysml.util.SysMLTools;
import org.topcased.sysml.FlowProperty;

/**
 * The FlowProperty object controller <!-- begin-user-doc --> <!-- end-user-doc
 * -->
 * 
 * @generated
 */
public class FlowPropertyEditPart extends PropertyEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public FlowPropertyEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new FlowPropertyRestoreConnectionCommand(getHost());
            }
        });

        installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LabelDirectEditPolicy());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated
     */
    protected IFigure createFigure()
    {

        return new FlowPropertyFigure();
    }

    /**
     * @see org.topcased.modeler.sysml.blockdefinitiondiagram.edit.PropertyEditPart#getPropertyPrefix(org.eclipse.uml2.uml.Property)
     */
    protected String getPropertyPrefix(Property property)
    {
        StringBuffer prefix = new StringBuffer();

        prefix.append(SysMLTools.getStereotypeNotation(property));

        prefix.append(SysMLTools.getVisibilityNotation(property.getVisibility()));

        prefix.append(((FlowProperty) property).getDirection().getName());

        prefix.append(" ");

        if (property.isDerived())
        {
            prefix.append('/');
        }

        return prefix.toString();
    }

}