/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.edit.policies.ResizableEditPolicy;
import org.eclipse.uml2.uml.Element;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.LabelDirectEditPolicy;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.sysml.blockdefinitiondiagram.commands.FlowSpecificationRestoreConnectionCommand;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.FlowSpecificationFigure;
import org.topcased.modeler.sysml.blockdefinitiondiagram.policies.FlowSpecificationLayoutEditPolicy;
import org.topcased.modeler.sysml.blockdefinitiondiagram.util.BlockTools;
import org.topcased.modeler.sysml.util.SysMLTools;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.FlowSpecification;

/**
 * The FlowSpecification object controller <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class FlowSpecificationEditPart extends InterfaceEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public FlowSpecificationEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new FlowSpecificationRestoreConnectionCommand(getHost());
            }
        });

        ResizableEditPolicy resizableEditPolicy = new ResizableEditPolicy();
        resizableEditPolicy.setResizeDirections(PositionConstants.EAST_WEST);
        installEditPolicy(ModelerEditPolicyConstants.RESIZABLE_EDITPOLICY, resizableEditPolicy);

        installEditPolicy(EditPolicy.LAYOUT_ROLE, new FlowSpecificationLayoutEditPolicy());
        installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LabelDirectEditPolicy());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated
     */
    protected IFigure createFigure()
    {

        return new FlowSpecificationFigure();
    }

    protected void refreshHeaderLabel()
    {
        FlowSpecificationFigure fig = (FlowSpecificationFigure) getFigure();
        ComposedLabel lbl = (ComposedLabel) fig.getLabel();
        FlowSpecification interfacee = (FlowSpecification) Utils.getElement(getGraphNode());

        String stereotypes = SysMLTools.getStereotypesList(interfacee);
        if (stereotypes.length() != 0)
        {
            stereotypes = ", " + stereotypes;
        }
        lbl.setPrefix("<<flowSpecification" + stereotypes + ">>");

        if (interfacee.getName() != null)
        {
            lbl.setMain(interfacee.getName());
        }

        lbl.setSuffix(BlockTools.getFromNotation(interfacee,
                (Element) Utils.getElement((GraphElement) getParent().getModel())));
    }

}