/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.swt.SWT;
import org.eclipse.uml2.uml.Usage;
import org.topcased.draw2d.figures.Label;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.EdgeObject;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.policies.EdgeObjectOffsetEditPolicy;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.sysml.blockdefinitiondiagram.BlockDefEdgeObjectConstants;
import org.topcased.modeler.sysml.blockdefinitiondiagram.BlockDefEditPolicyConstants;
import org.topcased.modeler.sysml.blockdefinitiondiagram.figures.UsageFigure;
import org.topcased.modeler.sysml.blockdefinitiondiagram.policies.CommentLinkEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.util.SysMLTools;

/**
 * Usage controller <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class UsageEditPart extends EMFGraphEdgeEditPart
{

    private static final int LINE_ON = 10;

    private static final int LINE_OFF = 5;

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the graph object
     * @generated
     */
    public UsageEditPart(GraphEdge model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        // Add a CommentLink Policy to this element
        installEditPolicy(BlockDefEditPolicyConstants.COMMENTLINK_EDITPOLICY, new CommentLinkEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_OFFSET_EDITPOLICY, new EdgeObjectOffsetEditPolicy());

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Figure
     * @generated
     */
    protected IFigure createFigureGen()
    {
        UsageFigure connection = new UsageFigure();

        createTargetDecoration(connection);

        return connection;
    }

    /**
     * customize the line
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    protected IFigure createFigure()
    {
        UsageFigure connection = (UsageFigure) createFigureGen();
        connection.setLineStyle(SWT.LINE_CUSTOM);
        connection.setLineDash(new int[] {LINE_ON, LINE_OFF});
        return connection;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param connection the PolylineConnection
     * @generated
     */
    private void createTargetDecoration(PolylineConnection connection)
    {

        PolylineDecoration decoration = new PolylineDecoration();
        decoration.setScale(10, 5);
        connection.setTargetDecoration(decoration);

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#getEdgeObjectFigure(org.topcased.modeler.di.model.EdgeObject)
     * @generated
     */
    public IEdgeObjectFigure getEdgeObjectFigure(EdgeObject edgeObject)
    {
        if (BlockDefEdgeObjectConstants.BLOCKUSAGESTEREOTYPE_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((UsageFigure) getFigure()).getBlockUsageStereotypeEdgeObjectFigure();
        }
        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#refreshEdgeObjects()
     * @generated
     */
    protected void refreshEdgeObjects()
    {
        super.refreshEdgeObjects();
        updateBlockUsageStereotypeLabel();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * BlockUsageStereotype Label
     * 
     * @generated NOT
     */
    private void updateBlockUsageStereotypeLabel()
    {
        String stereotypes = SysMLTools.getStereotypesList((Usage) getEObject());
        if (stereotypes.length() != 0)
        {
            stereotypes = ", " + stereotypes;
        }
        stereotypes = "<<usage" + stereotypes + ">>";
        ((Label) ((UsageFigure) getFigure()).getBlockUsageStereotypeEdgeObjectFigure()).setText(stereotypes);
    }

}