/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.blockdefinitiondiagram.figures;

import org.eclipse.draw2d.AbstractBorder;
import org.eclipse.draw2d.CompoundBorder;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Insets;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.draw2d.figures.EditableLabel;
import org.topcased.draw2d.figures.IContainerFigure;
import org.topcased.draw2d.figures.ILabel;
import org.topcased.draw2d.figures.ILabelFigure;
import org.topcased.draw2d.figures.Label;

/**
 * @generated
 */
public class UnitFigure extends org.eclipse.draw2d.Figure implements
		IContainerFigure, ILabelFigure {
	
	private ILabel header; 
	
	private ILabel contentPane;
	/**
	 * Constructor
	 *
	 * @generated
	 */
	public UnitFigure() {
		super();
		drawFigure();
	}


    /**
     * @see org.topcased.draw2d.figures.ClassFigure#drawFigure()
     * @generated NOT
     */
    protected void drawFigure()
    {
        ToolbarLayout layout = new ToolbarLayout();
        setLayoutManager(layout);
        setBorder(new CompoundBorder(new LineBorder(), new MarginBorder(1)));
        setOpaque(true);
        header = createLabel();
        setLabel(new ComposedLabel(new Label(), new EditableLabel(), new Label(), false));
        add(getLabel());
        
        Figure unitDimensionFigure = new Figure();
        unitDimensionFigure.setLayoutManager(new ToolbarLayout());
        unitDimensionFigure.setBorder(new UnitDimensionBorder());
        contentPane = new ComposedLabel(new Label("Dimension:"), new Label(), null, true);
        unitDimensionFigure.add(contentPane);
        add(unitDimensionFigure);
    }


    /**
     * Create the main label of the class figure
     * 
     * @return the main label
     */
    protected ILabel createLabel()
    {
        EditableLabel lbl = new EditableLabel();
        lbl.setLabelAlignment(PositionConstants.LEFT);
        return lbl;
    }

    /**
     * Set the label figure
     * 
     * @param newLabel the new label Figure
     */
    protected void setLabel(ILabel newLabel)
    {
        header = newLabel;
    }

    /**
     * @see org.topcased.draw2d.figures.ILabelFigure#getLabel()
     */
    public ILabel getLabel()
    {
        return header;
    }
	/**
	 * @see org.topcased.draw2d.figures.IContainerFigure#getContentPane()
	 * @generated NOT
	 */
	public IFigure getContentPane() {
		return contentPane;
	}
	
	 public void setDimension(String dimension)
	    {
	        if (dimension != null && dimension.length() != 0)
	            this.contentPane.setText("\"" + dimension + "\"");
	        else
	            this.contentPane.setText("");
	    }
	
    private static class UnitDimensionBorder extends AbstractBorder
    {
        /**
         * @see org.eclipse.draw2d.Border#getInsets(org.eclipse.draw2d.IFigure)
         */
        public Insets getInsets(IFigure figure)
        {
            return new Insets(2, 2, 2, 2);
        }

        /**
         * @see org.eclipse.draw2d.Border#getInsets(org.eclipse.draw2d.IFigure)
         */
        public void paint(IFigure figure, Graphics graphics, Insets insets)
        {
            graphics.drawLine(figure.getBounds().getTopLeft(), figure.getBounds().getTopRight());
        }
    }

}