
package org.topcased.modeler.sysml.editor;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.IPageSite;
import org.topcased.modeler.editor.Modeler;
import org.topcased.modeler.editor.outline.DiagramsOutlinePage;
import org.topcased.modeler.editor.outline.ModelNavigator;

/**
 * The UML Outline is customized. It changes the context menu in the model navigator.
 * 
 */
public class SysMLOutlinePage extends DiagramsOutlinePage
{

    /**
     * Constructor
     * 
     * @param modeler the editor
     */
    public SysMLOutlinePage(Modeler modeler)
    {
        super(modeler);
    }

    /**
     * @see org.topcased.modeler.editor.outline.DiagramsOutlinePage#createNavigator(org.eclipse.swt.widgets.Composite,
     *      org.topcased.modeler.editor.Modeler, org.eclipse.ui.part.IPageSite)
     */
    protected ModelNavigator createNavigator(Composite parent, Modeler editor, IPageSite pageSite)
    {
        return new SysMLNavigator(parent, editor, pageSite);
    }
}
