package org.topcased.modeler.sysml.editor.properties.filters;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.jface.viewers.IFilter;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.utils.Utils;

public abstract class AbstractModelObjectFilter implements IFilter
{

    public boolean select(Object toTest)
    {
        if (toTest instanceof EditPart)
        {
            Object obj = ((EditPart) toTest).getModel();
            if (obj instanceof GraphElement)
            {
                GraphElement graphElt = (GraphElement) obj;
                EObject modelObject = Utils.getElement(graphElt);
                if (modelObject != null)
                {
                    return isValidModelObject(modelObject);
                }
            }
        }
        else if (toTest instanceof EObject)
        {
            return isValidModelObject((EObject) toTest);
        }
        return false;
    }

    protected abstract boolean isValidModelObject(EObject modelObjectToTest);

}
