package org.topcased.modeler.sysml.editor.properties.sections;

import java.util.List;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.topcased.sysml.FlowDirectionKind;
import org.topcased.sysml.FlowProperty;
import org.topcased.sysml.SysMLPackage;
import org.topcased.tabbedproperties.sections.AbstractEnumerationPropertySection;

public class FlowPropertyDirectionPropertySection extends AbstractEnumerationPropertySection
{

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractEnumerationPropertySection#getFeature()
     */
    protected EStructuralFeature getFeature()
    {
        return SysMLPackage.eINSTANCE.getFlowProperty_Direction();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractEnumerationPropertySection#getFeatureAsText()
     */
    protected String getFeatureAsText()
    {
        return ((FlowProperty) getEObject()).getDirection().getName();
        // return ((FlowProperty) eObject).getDirection().getName();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractEnumerationPropertySection#getFeatureValue(int)
     */
    protected Object getFeatureValue(int index)
    {
        return FlowDirectionKind.get(index);
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractEnumerationPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Direction:";
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractEnumerationPropertySection#isEqual(int)
     */
    protected boolean isEqual(int index)
    {
        return FlowDirectionKind.VALUES.get(index).equals(((FlowProperty) getEObject()).getDirection());
        // return FlowDirectionKind.VALUES.get(index).equals(((FlowProperty)
        // eObject).getDirection());
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractEnumerationPropertySection#getEnumerationFeatureValues()
     */
    protected String[] getEnumerationFeatureValues()
    {
        List< ? > values = FlowDirectionKind.VALUES;
        String[] ret = new String[values.size()];
        for (int i = 0; i < values.size(); i++)
        {
            ret[i] = ((FlowDirectionKind) values.get(i)).getName();
        }
        return ret;
    }

    // @Override
    protected Object getOldFeatureValue()
    {
        // TODO Auto-generated method stub
        return null;
    }
}
