package org.topcased.modeler.sysml.editor.properties.sections;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.uml2.uml.edit.providers.UMLItemProviderAdapterFactory;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.ValueType;
import org.topcased.sysml.provider.SysMLItemProviderAdapterFactory;
import org.topcased.tabbedproperties.sections.AbstractChooserPropertySection;

public class ValueTypeDimensionPropertySection extends AbstractChooserPropertySection
{

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractChooserPropertySection#getFeature()
     */
    protected EStructuralFeature getFeature()
    {
        return SysMLPackage.eINSTANCE.getValueType_Dimension();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractChooserPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Dimension:";
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractChooserPropertySection#getComboFeatureValues()
     */
    protected Object[] getComboFeatureValues()
    {
        return getChoices(getEObject(), SysMLPackage.eINSTANCE.getDimension());
        // return getChoices(eObject, SysMLPackage.eINSTANCE.getDimension());
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractChooserPropertySection#getLabelProvider()
     */
    // protected IBaseLabelProvider getLabelProvider()
    protected ILabelProvider getLabelProvider()
    {
        ComposedAdapterFactory factories = new ComposedAdapterFactory(new AdapterFactory[] {
                new UMLItemProviderAdapterFactory(), new SysMLItemProviderAdapterFactory()});
        return new AdapterFactoryLabelProvider(factories);
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractChooserPropertySection#getFeatureValue()
     */
    protected Object getFeatureValue()
    {
        return ((ValueType) getEObject()).getDimension();
        // return ((ValueType) eObject).getDimension();
    }
}
