/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram;

import java.net.URL;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.gef.EditPartFactory;
import org.topcased.modeler.editor.IConfiguration;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.IPaletteManager;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.graphconf.exceptions.MissingGraphConfFileException;
import org.topcased.modeler.sysml.internalblockdiagram.edit.BlockPropertyEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.CommentEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.ConnectorEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.DependencyEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.ElementEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.FlowPortEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.NamedElementEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.PortEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.ProblemEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.PropertyEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.RationaleEditPart;

/**
 * A diagram configuration : manages Palette, EditPartFactory for this diagram.
 * <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class InternalBlockConfiguration implements IConfiguration
{
    private InternalBlockPaletteManager paletteManager;

    private InternalBlockEditPartFactory editPartFactory;

    private InternalBlockCreationUtils creationUtils;

    /**
     * The DiagramGraphConf that contains graphical informations on the
     * configuration
     */
    private DiagramGraphConf diagramGraphConf;

    /**
     * Constructor. Initialize Adapter factories.
     * 
     * @generated
     */
    public InternalBlockConfiguration()
    {
        registerAdapters();
    }

    /**
     * Registers the Adapter Factories for all the EditParts
     * 
     * @generated
     */
    private void registerAdapters()
    {
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(BlockPropertyEditPart.class, org.topcased.sysml.BlockProperty.class),
                BlockPropertyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(PortEditPart.class, org.eclipse.uml2.uml.Port.class),
                PortEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(FlowPortEditPart.class, org.topcased.sysml.FlowPort.class),
                FlowPortEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ConnectorEditPart.class, org.eclipse.uml2.uml.Connector.class),
                ConnectorEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(CommentEditPart.class, org.eclipse.uml2.uml.Comment.class),
                CommentEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(RationaleEditPart.class, org.topcased.sysml.Rationale.class),
                RationaleEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ProblemEditPart.class, org.topcased.sysml.Problem.class),
                ProblemEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ElementEditPart.class, org.eclipse.uml2.uml.Element.class),
                ElementEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(PropertyEditPart.class, org.eclipse.uml2.uml.Property.class),
                PropertyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(DependencyEditPart.class, org.eclipse.uml2.uml.Dependency.class),
                DependencyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(NamedElementEditPart.class, org.eclipse.uml2.uml.NamedElement.class),
                NamedElementEditPart.class);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getId()
     * @generated
     */
    public String getId()
    {
        return new String("org.topcased.modeler.sysml.internalblockdiagram");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getName()
     * @generated
     */
    public String getName()
    {
        return new String("Internal block diagram");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getEditPartFactory()
     * @generated
     */
    public EditPartFactory getEditPartFactory()
    {
        if (editPartFactory == null)
        {
            editPartFactory = new InternalBlockEditPartFactory();
        }

        return editPartFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getPaletteManager()
     * @generated
     */
    public IPaletteManager getPaletteManager()
    {
        if (paletteManager == null)
        {
            paletteManager = new InternalBlockPaletteManager(getCreationUtils());
        }

        return paletteManager;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getCreationUtils()
     * @generated
     */
    public ICreationUtils getCreationUtils()
    {
        if (creationUtils == null)
        {
            creationUtils = new InternalBlockCreationUtils(getDiagramGraphConf());
        }

        return creationUtils;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getDiagramGraphConf()
     * @generated
     */
    public DiagramGraphConf getDiagramGraphConf()
    {
        if (diagramGraphConf == null)
        {
            URL url = InternalBlockPlugin.getDefault().getBundle().getResource(
                    "org/topcased/modeler/sysml/internalblockdiagram/diagram.graphconf");
            if (url != null)
            {
                URI fileURI = URI.createURI(url.toString());
                ResourceSet resourceSet = new ResourceSetImpl();
                Resource resource = resourceSet.getResource(fileURI, true);
                if (resource != null && resource.getContents().get(0) instanceof DiagramGraphConf)
                {
                    diagramGraphConf = (DiagramGraphConf) resource.getContents().get(0);
                }
            }
            else
            {
                new MissingGraphConfFileException(
                        "The *.diagramgraphconf file can not be retrieved. Check if the path is correct in the Configuration class of your diagram.");
            }
        }

        return diagramGraphConf;
    }

}