/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.AggregationKind;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Property;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.sysml.internalblockdiagram.InternalBlockEdgeObjectConstants;
import org.topcased.sysml.BlockProperty;
import org.topcased.sysml.FlowPort;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model
 * Object <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class InternalBlockCreationUtils extends AbstractCreationUtils
{

    /**
     * Constructor
     * 
     * @param diagramConf the Diagram Graphical Configuration
     */
    public InternalBlockCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * @generated
     */
    private class GraphicSysMLSwitch extends SysMLSwitch
    {
        /**
         * The presentation of the graphical element
         * 
         * @generated
         */
        private String presentation;

        /**
         * Constructor
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicSysMLSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlockProperty(org.topcased.sysml.BlockProperty)
         * @generated NOT
         */
        public Object caseBlockProperty(org.topcased.sysml.BlockProperty object)
        {
            return createGraphElementBlockProperty(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProperty(org.eclipse.uml2.uml.Property)
         */
        public Object caseProperty(Property object)
        {
            return createGraphElementProperty(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDependency(org.eclipse.uml2.uml.Dependency)
         */
        public Object caseDependency(Dependency object)
        {
            return createGraphElementDependency(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseComment(Comment object)
        {
            return createGraphElementComment(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#casePort(org.eclipse.uml2.uml.Port)
         */
        public Object casePort(Port object)
        {
            return createGraphElementPort(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowPort(org.topcased.sysml.FlowPort)
         * @generated NOT
         */
        public Object caseFlowPort(org.topcased.sysml.FlowPort object)
        {
            return createGraphElementFlowPort(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         * @generated NOT
         */
        public Object caseRationale(org.topcased.sysml.Rationale object)
        {
            return createGraphElementRationale(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         * @generated NOT
         */
        public Object caseProblem(org.topcased.sysml.Problem object)
        {
            return createGraphElementProblem(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConnector(org.eclipse.uml2.uml.Connector)
         */
        public Object caseConnector(Connector object)
        {
            return createGraphElementConnector(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated NOT
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = new GraphicSysMLSwitch(presentation).doSwitch(obj);
        return (GraphElement) graphElt;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementBlockProperty(org.topcased.sysml.BlockProperty element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementProperty(org.eclipse.uml2.uml.Property element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementFlowPort(org.topcased.sysml.FlowPort element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementPort(org.eclipse.uml2.uml.Port element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementConnector(org.eclipse.uml2.uml.Connector element, String presentation)
    {

        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(InternalBlockEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, -15));
        graphEdge.getContained().add(nameEdgeObjectOffset);
        
        EdgeObjectOffset itemFlowIconEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        itemFlowIconEdgeObjectOffset.setId(InternalBlockEdgeObjectConstants.CONNECTORITEMFLOWICON_EDGE_OBJECT_ID);
        itemFlowIconEdgeObjectOffset.setOffset(new Dimension(0, 0));
        itemFlowIconEdgeObjectOffset.setVisible(false);
        graphEdge.getContained().add(itemFlowIconEdgeObjectOffset);
        EdgeObjectOffset itemFlowNameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        itemFlowNameEdgeObjectOffset.setId(InternalBlockEdgeObjectConstants.CONNECTORITEMFLOWNAME_EDGE_OBJECT_ID);
        itemFlowNameEdgeObjectOffset.setOffset(new Dimension(0, 15));
        itemFlowNameEdgeObjectOffset.setVisible(false);
        graphEdge.getContained().add(itemFlowNameEdgeObjectOffset);
        
        EdgeObjectUV connectorsrccountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        connectorsrccountEdgeObjectUV.setId(InternalBlockEdgeObjectConstants.CONNECTORSRCCOUNT_EDGE_OBJECT_ID);
        connectorsrccountEdgeObjectUV.setUDistance(12);
        connectorsrccountEdgeObjectUV.setVDistance(12);
        
        graphEdge.getContained().add(connectorsrccountEdgeObjectUV);
        EdgeObjectUV connectorsrcnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        connectorsrcnameEdgeObjectUV.setId(InternalBlockEdgeObjectConstants.CONNECTORSRCNAME_EDGE_OBJECT_ID);
        connectorsrcnameEdgeObjectUV.setUDistance(10);
        connectorsrcnameEdgeObjectUV.setVDistance(10);
        graphEdge.getContained().add(connectorsrcnameEdgeObjectUV);
        EdgeObjectUV connectortargetcountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        connectortargetcountEdgeObjectUV.setId(InternalBlockEdgeObjectConstants.CONNECTORTARGETCOUNT_EDGE_OBJECT_ID);
        connectortargetcountEdgeObjectUV.setUDistance(10);
        connectortargetcountEdgeObjectUV.setVDistance(10);
        graphEdge.getContained().add(connectortargetcountEdgeObjectUV);
        EdgeObjectUV connectortargetnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        connectortargetnameEdgeObjectUV.setId(InternalBlockEdgeObjectConstants.CONNECTORTARGETNAME_EDGE_OBJECT_ID);
        connectortargetnameEdgeObjectUV.setUDistance(12);
        connectortargetnameEdgeObjectUV.setVDistance(12);
        graphEdge.getContained().add(connectortargetnameEdgeObjectUV);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementDependency(org.eclipse.uml2.uml.Dependency element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset dependencystereotypesEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        dependencystereotypesEdgeObjectOffset.setId(InternalBlockEdgeObjectConstants.DEPENDENCYSTEREOTYPES_EDGE_OBJECT_ID);
        dependencystereotypesEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(dependencystereotypesEdgeObjectOffset);
        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(InternalBlockEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(nameEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComment(org.eclipse.uml2.uml.Comment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementRationale(org.topcased.sysml.Rationale element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementProblem(org.topcased.sysml.Problem element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     */
    private class ModelSwitch extends SysMLSwitch
    {
        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlockProperty(org.topcased.sysml.BlockProperty)
         */
        public Object caseBlockProperty(BlockProperty object)
        {
            return createModelObjectBlockProperty(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProperty(org.eclipse.uml2.uml.Property)
         */
        public Object caseProperty(Property object)
        {
            return createModelObjectProperty(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowPort(org.topcased.sysml.FlowPort)
         */
        public Object caseFlowPort(FlowPort object)
        {
            return createModelObjectFlowPort(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#casePort(org.eclipse.uml2.uml.Port)
         */
        public Object casePort(Port object)
        {
            return createModelObjectPort(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConnector(org.eclipse.uml2.uml.Connector)
         */
        public Object caseConnector(Connector object)
        {
            return createModelObjectConnector(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDependency(org.eclipse.uml2.uml.Dependency)
         */
        public Object caseDependency(Dependency object)
        {
            return createModelObjectDependency(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseComment(Comment object)
        {
            return createModelObjectComment(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         */
        public Object caseRationale(Rationale object)
        {
            return createModelObjectRationale(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         */
        public Object caseProblem(Problem object)
        {
            return createModelObjectProblem(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated NOT
     */
    public EObject createModelObject(EObject obj)
    {
        Object eObject = new ModelSwitch().doSwitch(obj);
        return (EObject) eObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     * @generated NOT
     */
    protected BlockProperty createModelObjectBlockProperty(BlockProperty element)
    {
        element.setAggregation(AggregationKind.COMPOSITE_LITERAL);
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     * @generated NOT
     */
    protected FlowPort createModelObjectFlowPort(FlowPort element)
    {
        element.setAggregation(AggregationKind.COMPOSITE_LITERAL);
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     * @generated NOT
     */
    protected Port createModelObjectPort(Port element)
    {
        element.setAggregation(AggregationKind.COMPOSITE_LITERAL);
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Connector createModelObjectConnector(Connector element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Dependency createModelObjectDependency(Dependency element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Comment createModelObjectComment(Comment element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Rationale createModelObjectRationale(Rationale element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Problem createModelObjectProblem(Problem element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Property createModelObjectProperty(Property element)
    {
        return element;
    }

}
