/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Property;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.di.model.SimpleSemanticModelElement;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.EMFGraphNodeEditPart;
import org.topcased.modeler.edit.GraphEdgeEditPart;
import org.topcased.modeler.edit.GraphNodeEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.BlockPropertyEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.CommentEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.CommentLinkEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.ConnectorEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.DependencyEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.ElementEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.FlowPortEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.InternalBlockDiagramEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.NamedElementEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.PortEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.ProblemEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.PropertyEditPart;
import org.topcased.modeler.sysml.internalblockdiagram.edit.RationaleEditPart;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * Part Factory : associates a model object to its controller. <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class InternalBlockEditPartFactory implements EditPartFactory
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,java.lang.Object)
     * @generated NOT
     */
    public EditPart createEditPart(EditPart context, Object model)
    {
        if (model instanceof Diagram)
        {
            return new InternalBlockDiagramEditPart((Diagram) model);
        }
        else if (model instanceof GraphNode)
        {
            final GraphNode node = (GraphNode) model;
            EObject element = Utils.getElement(node);
            if (element != null)
            {
                Object editPart = new NodeSysMLSwitch(node).doSwitch(element);

                return (EditPart) editPart;
            }

            if (node.getSemanticModel() instanceof SimpleSemanticModelElement)
            {
                // Manage the Element that are not associated with a model
                // object
            }
            return new GraphNodeEditPart(node);
        }
        else if (model instanceof GraphEdge)
        {
            final GraphEdge edge = (GraphEdge) model;
            EObject element = Utils.getElement(edge);
            if (element != null)
            {
                Object editPart = new EdgeSysMLSwitch(edge).doSwitch(element);
                return (EditPart) editPart;
            }

            if (edge.getSemanticModel() instanceof SimpleSemanticModelElement)
            {
                // Manage the Element that are not associated with a model
                // object
                if (InternalBlockSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK.equals(((SimpleSemanticModelElement) edge.getSemanticModel()).getTypeInfo()))
                {
                    return new CommentLinkEditPart(edge);
                }
            }

            return new GraphEdgeEditPart(edge);
        }

        throw new IllegalStateException("No edit part matches with the '" + model.getClass().getName()
                + "' model element. Check InternalBlockEditPartFactory#createEditPart(EditPart,Object) class");
    }

    /**
     * @generated
     */
    private class NodeSysMLSwitch extends SysMLSwitch
    {
        /**
         * The graphical node
         * 
         * @generated
         */
        private GraphNode node;

        /**
         * Constructor
         * 
         * @param node the graphical node
         * @generated
         */
        public NodeSysMLSwitch(GraphNode node)
        {
            this.node = node;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseBlockProperty(org.topcased.sysml.BlockProperty)
         * @generated
         */
        public Object caseBlockProperty(org.topcased.sysml.BlockProperty object)
        {
            return new BlockPropertyEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseFlowPort(org.topcased.sysml.FlowPort)
         * @generated
         */
        public Object caseFlowPort(org.topcased.sysml.FlowPort object)
        {
            return new FlowPortEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         * @generated
         */
        public Object caseRationale(org.topcased.sysml.Rationale object)
        {
            return new RationaleEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         * @generated
         */
        public Object caseProblem(org.topcased.sysml.Problem object)
        {
            return new ProblemEditPart(node);
        }

        public Object caseComment(Comment object)
        {
            return new CommentEditPart(node);
        }

        public Object casePort(Port object)
        {
            return new PortEditPart(node);
        }

        public Object caseElement(Element object)
        {
            return new ElementEditPart(node);
        }

        public Object caseProperty(Property object)
        {
            return new PropertyEditPart(node);
        }

        public Object caseNamedElement(NamedElement object)
        {
            return new NamedElementEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return new EMFGraphNodeEditPart(node);
        }
    }

    /**
     * @generated
     */
    private class EdgeSysMLSwitch extends SysMLSwitch
    {
        /**
         * The graphical edge
         * 
         * @generated
         */
        private GraphEdge edge;

        /**
         * Constructor
         * 
         * @param edge the graphical edge
         * @generated
         */
        public EdgeSysMLSwitch(GraphEdge edge)
        {
            this.edge = edge;
        }

        public Object caseConnector(Connector object)
        {
            return new ConnectorEditPart(edge);
        }

        public Object caseDependency(Dependency object)
        {
            return new DependencyEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return new EMFGraphEdgeEditPart(edge);
        }
    }

}