/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;
import org.topcased.sysml.SysMLPackage;

/**
 * Generated Palette Manager <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class InternalBlockPaletteManager extends ModelerPaletteManager
{
    // declare all the palette categories of the diagram
    private PaletteDrawer objectsDrawer;

    private PaletteDrawer connectionsDrawer;

    private PaletteDrawer commentsDrawer;

    private ICreationUtils creationUtils;

    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param utils the creation utils for the tools of the palette
     * @generated
     */
    public InternalBlockPaletteManager(ICreationUtils utils)
    {
        super();
        this.creationUtils = utils;
    }

    /**
     * Creates the main categories of the palette <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected void createCategories()
    {
        createObjectsDrawer();
        createConnectionsDrawer();
        createCommentsDrawer();
    }

    /**
     * Updates the main categories of the palette <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected void updateCategories()
    {
        // deletion of the existing categories and creation of the updated
        // categories

        getRoot().remove(objectsDrawer);
        createObjectsDrawer();

        getRoot().remove(connectionsDrawer);
        createConnectionsDrawer();

        getRoot().remove(commentsDrawer);
        createCommentsDrawer();
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createObjectsDrawer()
    {
        objectsDrawer = new PaletteDrawer("Objects", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getBlockProperty(), "default");
        entries.add(new ModelerCreationToolEntry("Block Property", "Block Property", factory,
                InternalBlockImageRegistry.getImageDescriptor("BLOCKPROPERTY"),
                InternalBlockImageRegistry.getImageDescriptor("BLOCKPROPERTY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getProperty(), "default");
        entries.add(new ModelerCreationToolEntry("Property", "Property", factory,
                InternalBlockImageRegistry.getImageDescriptor("PROPERTY"),
                InternalBlockImageRegistry.getImageDescriptor("PROPERTY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getPort(), "default");
        entries.add(new ModelerCreationToolEntry("Standard Port", "Standard Port", factory,
                InternalBlockImageRegistry.getImageDescriptor("PORT"),
                InternalBlockImageRegistry.getImageDescriptor("PORT_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getFlowPort(), "default");
        entries.add(new ModelerCreationToolEntry("Flow Port", "Flow Port", factory,
                InternalBlockImageRegistry.getImageDescriptor("FLOWPORT"),
                InternalBlockImageRegistry.getImageDescriptor("FLOWPORT_LARGE")));


        objectsDrawer.addAll(entries);
        getRoot().add(objectsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createConnectionsDrawer()
    {
        connectionsDrawer = new PaletteDrawer("Connections", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getConnector(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Connector", "Connector", factory,
                InternalBlockImageRegistry.getImageDescriptor("CONNECTOR"),
                InternalBlockImageRegistry.getImageDescriptor("CONNECTOR_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDependency(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Dependency", "Dependency", factory,
                InternalBlockImageRegistry.getImageDescriptor("DEPENDENCY"),
                InternalBlockImageRegistry.getImageDescriptor("DEPENDENCY_LARGE")));

        connectionsDrawer.addAll(entries);
        getRoot().add(connectionsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createCommentsDrawer()
    {
        commentsDrawer = new PaletteDrawer("Comments", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getComment(), "default");
        entries.add(new ModelerCreationToolEntry("Comment", "Comment", factory,
                InternalBlockImageRegistry.getImageDescriptor("COMMENT"),
                InternalBlockImageRegistry.getImageDescriptor("COMMENT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getRationale(), "default");
        entries.add(new ModelerCreationToolEntry("Rationale", "Rationale", factory,
                InternalBlockImageRegistry.getImageDescriptor("RATIONALE"),
                InternalBlockImageRegistry.getImageDescriptor("RATIONALE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getProblem(), "default");
        entries.add(new ModelerCreationToolEntry("Problem", "Problem", factory,
                InternalBlockImageRegistry.getImageDescriptor("PROBLEM"),
                InternalBlockImageRegistry.getImageDescriptor("PROBLEM_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils,
                InternalBlockSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK, "default", false);
        entries.add(new ModelerConnectionCreationToolEntry("Comment Link", "Comment Link", factory,
                InternalBlockImageRegistry.getImageDescriptor("COMMENTLINK"),
                InternalBlockImageRegistry.getImageDescriptor("COMMENTLINK_LARGE")));

        commentsDrawer.addAll(entries);
        getRoot().add(commentsDrawer);
    }

}
