/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram.commands;

import org.eclipse.gef.EditDomain;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.NamedElement;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.sysml.internalblockdiagram.util.BlockTools;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.PackageSYSML;

/**
 * Dependency edge creation command<br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class DependencyEdgeCreationCommand extends CreateTypedEdgeCommand
{

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @generated
     */
    public DependencyEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src)
    {
        this(domain, newObj, src, true);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @param needModelUpdate set it to true if the model need to be updated
     * @generated
     */
    public DependencyEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src, boolean needModelUpdate)
    {
        super(domain, newObj, src, needModelUpdate);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void redoModel()
    {
        Dependency dependency = (Dependency) Utils.getElement(getEdge());

        // Retrieve source object and target object
        NamedElement targetObject = (NamedElement) Utils.getElement(getTarget());
        NamedElement sourceObject = (NamedElement) Utils.getElement(getSource());

        PackageSYSML containerEObject = BlockTools.getPackageSYSML(sourceObject);

        if (containerEObject != null)
        {
            initName(containerEObject);
            containerEObject.getOwnedRelationships().add(dependency);
        }
        dependency.getSuppliers().add(targetObject);
        dependency.getClients().add(sourceObject);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void undoModel()
    {
        Dependency dependency = (Dependency) Utils.getElement(getEdge());

        // Retrieve source object and target object
        NamedElement targetObject = (NamedElement) Utils.getElement(getTarget());
        NamedElement sourceObject = (NamedElement) Utils.getElement(getSource());

        dependency.getSuppliers().remove(targetObject);
        dependency.getClients().remove(sourceObject);

        PackageSYSML containerEObject = BlockTools.getPackageSYSML(sourceObject);
        if (containerEObject != null)
        {
            containerEObject.getOwnedRelationships().remove(dependency);
        }
    }

}