package org.topcased.modeler.sysml.internalblockdiagram.commands;


import java.util.Map;

import org.eclipse.gef.commands.Command;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.Type;
import org.topcased.modeler.figures.EdgeObjectOffsetEditableLabel;
import org.topcased.modeler.sysml.internalblockdiagram.dialogs.ItemFlowNameEditDialog;
import org.topcased.modeler.sysml.internalblockdiagram.util.BlockTools;

public class ItemFlowNameUpdateCommand extends Command
{
    private EdgeObjectOffsetEditableLabel _itemFlowNameFigure;
    
    private Connector _connector;
      
    private String _oldItemFlowName;
   
    
    private String _oldName;
    
    private String _name;
    
    private Type _type;
    
    private Type _oldType;
    
    private String _oldNameSecond;
    
    private String _nameSecond;
    
    private Type _typeSecond;
    
    private Type _oldTypeSecond;

    

    /**
     * Create a command for updating parameters on a given requirement
     * 
     * @param req the requirement to update
     * @param data the datas to set
     */
    public ItemFlowNameUpdateCommand(EdgeObjectOffsetEditableLabel itemFlowNameFigure, Connector connector,Map data)
    {
        _itemFlowNameFigure = itemFlowNameFigure;
        _connector = connector;
        _name = (String) data.get(ItemFlowNameEditDialog.ITEMFLOWNAME_RETURN_NAME);
        _type = (Type) data.get(ItemFlowNameEditDialog.ITEMFLOWNAME_RETURN_TYPE);
        _nameSecond = (String) data.get(ItemFlowNameEditDialog.ITEMFLOWNAMESECOND_RETURN_NAME);
        _typeSecond = (Type)data.get(ItemFlowNameEditDialog.ITEMFLOWNAMESECOND_RETURN_TYPE);
    }

    /**
     * Get the old values
     */
    protected void getOldValues()
    {
        _oldItemFlowName = _itemFlowNameFigure.getText();
        String[] nameDivided = _oldItemFlowName.split(":");
        if(nameDivided.length == 2)
        {
            _oldName = nameDivided[0];
            _oldType = BlockTools.getOldType(nameDivided[1],_connector);
        }
        else 
        {
            _oldName = _oldItemFlowName;
        }
        
    }

    /**
     * Set the values on the ItemFlow
     */
    protected void setValues()
    {
        // Perform update
        StringBuffer values = new StringBuffer();
        if (_type != null)
        {
            values.append(_name + ":" + _type.getName());
            if (_typeSecond != null)
            {
                values.append("        ");
            }
        }
        if (_typeSecond != null)
        {
            values.append(_nameSecond + ":" + _typeSecond.getName());
        }
        _itemFlowNameFigure.setText(values.toString());
    }

    /**
     * Switch the old and new values
     */
    protected void switchValues()
    {
        // Reverse old and new value
        String tempName = _name;
        _name = _oldName;
        _oldName = tempName;
        
        Type tempType = _type;
        _type = _oldType;
        _oldType = tempType;
        
        String tempNameSecond = _nameSecond;
        _nameSecond = _oldNameSecond;
        _oldNameSecond = tempNameSecond;
        
        Type tempTypeSecond = _typeSecond;
        _typeSecond = _oldTypeSecond;
        _oldTypeSecond = tempTypeSecond;
 
    }

    /**
     * Get the old values and set the new ones
     * 
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute()
    {
        getOldValues();
        setValues();
    }

    /**
     * Set the new values
     * 
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo()
    {
        switchValues();
        setValues();
    }

    /**
     * Set the old values
     * 
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo()
    {
        switchValues();
        setValues();
    }
    
}
