/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram.edit;

import java.util.Iterator;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.jface.window.Window;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.eclipse.uml2.uml.LiteralUnlimitedNatural;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.ValueSpecification;
import org.topcased.draw2d.figures.Label;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.EdgeObject;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.figures.EdgeObjectOffsetEditableLabel;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.sysml.SysMLPlugin;
import org.topcased.modeler.sysml.internalblockdiagram.InternalBlockEdgeObjectConstants;
import org.topcased.modeler.sysml.internalblockdiagram.InternalBlockEditPolicyConstants;
import org.topcased.modeler.sysml.internalblockdiagram.InternalBlockImageRegistry;
import org.topcased.modeler.sysml.internalblockdiagram.commands.ItemFlowNameUpdateCommand;
import org.topcased.modeler.sysml.internalblockdiagram.dialogs.ItemFlowNameEditDialog;
import org.topcased.modeler.sysml.internalblockdiagram.figures.ConnectorFigure;
import org.topcased.modeler.sysml.internalblockdiagram.policies.CommentLinkEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.internalblockdiagram.policies.ConnectorEdgeObjectOffSetEditPolicy;
import org.topcased.modeler.sysml.internalblockdiagram.policies.ConnectorEdgeObjectUVEditPolicy;
import org.topcased.modeler.sysml.util.SysMLTools;
import org.topcased.sysml.FlowDirectionKind;
import org.topcased.sysml.FlowPort;
import org.topcased.sysml.FlowSpecification;

/**
 * Connector controller <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ConnectorEditPart extends EMFGraphEdgeEditPart
{
    public static final int noFlow = 0;
    
    public static final int flowFromSourceToTarget = 1;
    
    public static final int flowFromTargetToSource = 2;
        
    public static final int flowInBothDirection = 3;
    
    private String iconFlowDirection="";
    

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the graph object
     * @generated
     */
    public ConnectorEditPart(GraphEdge model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        // Add a CommentLink Policy to this element
        installEditPolicy(InternalBlockEditPolicyConstants.COMMENTLINK_EDITPOLICY,
                new CommentLinkEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_UV_EDITPOLICY, new ConnectorEdgeObjectUVEditPolicy());
        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_OFFSET_EDITPOLICY, new ConnectorEdgeObjectOffSetEditPolicy());

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Figure
     * @generated
     */
    protected IFigure createFigure()
    {
        ConnectorFigure connection = new ConnectorFigure();
        connection.editPartlinked = this;
        return connection;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#getEdgeObjectFigure(org.topcased.modeler.di.model.EdgeObject)
     * @generated
     */
    public IEdgeObjectFigure getEdgeObjectFigure(EdgeObject edgeObject)
    {
        if (InternalBlockEdgeObjectConstants.NAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getNameEdgeObjectFigure();
        }
        if (InternalBlockEdgeObjectConstants.CONNECTORSRCCOUNT_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorSrcCountEdgeObjectFigure();
        }
        if (InternalBlockEdgeObjectConstants.CONNECTORSRCNAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorSrcNameEdgeObjectFigure();
        }
        if (InternalBlockEdgeObjectConstants.CONNECTORTARGETCOUNT_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorTargetCountEdgeObjectFigure();
        }
        if (InternalBlockEdgeObjectConstants.CONNECTORTARGETNAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorTargetNameEdgeObjectFigure();
        }
        if (InternalBlockEdgeObjectConstants.CONNECTORITEMFLOWICON_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorItemFlowIconEdgeObjectFigure();
        }
        if (InternalBlockEdgeObjectConstants.CONNECTORITEMFLOWNAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorItemFlowNameEdgeObjectFigure();
        }
        
        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#refreshEdgeObjects()
     * @generated
     */
    protected void refreshEdgeObjects()
    {
        super.refreshEdgeObjects();
        updateNameLabel();
        updateConnectorSrcCountLabel();
        updateConnectorSrcNameLabel();
        updateConnectorTargetCountLabel();
        updateConnectorTargetNameLabel();
        updateConnectorItemFlowIconLabel();
        updateConnectorItemFlowNameLabel();
    }

    
    private void updateConnectorItemFlowIconLabel()
    {
      updateItemFlowIcon((ConnectorFigure) getFigure());
    }
    
    private void  updateConnectorItemFlowNameLabel()
    {
        Connector connector = (Connector) getEObject();
        String label = "ItemFlowName";
        ((Label) ((ConnectorFigure) getFigure()).getConnectorItemFlowNameEdgeObjectFigure()).setText(label);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the name Label
     * 
     * @generated NOT
     */
    private void updateNameLabel()
    {
        Connector connector = (Connector) getEObject();
        String label = SysMLTools.getStereotypeNotation(connector) + connector.getName();
        if (connector.getType() != null)
            label += " : " + connector.getType().getName();
        ((Label) ((ConnectorFigure) getFigure()).getNameEdgeObjectFigure()).setText(label);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * ConnectorSrcCount Label
     * 
     * @generated NOT
     */
    private void updateConnectorSrcCountLabel()
    {
        Connector connector = (Connector) getEObject();
        Label srcCount = (Label) ((ConnectorFigure) getFigure()).getConnectorSrcCountEdgeObjectFigure();
        if (connector.getEnds().size() == 2)
        {
            ConnectorEnd firstEnd = (ConnectorEnd) connector.getEnds().get(0);
            String lower = Integer.toString(firstEnd.getLower());
            String upper = LiteralUnlimitedNatural.UNLIMITED == firstEnd.getUpper() ? "*"
                    : Integer.toString(firstEnd.getUpper());
            if (firstEnd.getLower() != firstEnd.getUpper() || firstEnd.getLower() != 1)
            {
                if (firstEnd.isOrdered())
                {
                    if (firstEnd.getLower() == firstEnd.getUpper())
                    {
                        srcCount.setText("{" + lower + "}");
                    }
                    else
                    {
                        srcCount.setText("{" + lower + ".." + upper + "}");
                    }
                }
                else
                {
                    if (firstEnd.getLower() == firstEnd.getUpper())
                    {
                        srcCount.setText(lower);
                    }
                    else
                    {
                        srcCount.setText(lower + ".." + upper);
                    }
                }
            }
            else
            {
                srcCount.setText("");
            }
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the ConnectorSrcName
     * Label
     * 
     * @generated
     */
    private void updateConnectorSrcNameLabel()
    {
        // TODO set the text to update
        // ((Label) ((ConnectorFigure)
        // getFigure()).getConnectorSrcNameEdgeObjectFigure()).setText(((Connector)
        // getEObject()).getConnectorSrcName());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * ConnectorTargetCount Label
     * 
     * @generated NOT
     */
    private void updateConnectorTargetCountLabel()
    {
        Connector connector = (Connector) getEObject();
        Label targetCount = (Label) ((ConnectorFigure) getFigure()).getConnectorTargetCountEdgeObjectFigure();
        if (connector.getEnds().size() == 2)
        {
            ConnectorEnd secondEnd = (ConnectorEnd) connector.getEnds().get(1);
            String lower = Integer.toString(secondEnd.getLower());
            String upper = LiteralUnlimitedNatural.UNLIMITED == secondEnd.getUpper() ? "*"
                    : Integer.toString(secondEnd.getUpper());
            if (secondEnd.getLower() != secondEnd.getUpper() || secondEnd.getLower() != 1)
            {
                if (secondEnd.isOrdered())
                {
                    if (secondEnd.getLower() == secondEnd.getUpper())
                    {
                        targetCount.setText("{" + lower + "}");
                    }
                    else
                    {
                        targetCount.setText("{" + lower + ".." + upper + "}");
                    }
                }
                else
                {
                    if (secondEnd.getLower() == secondEnd.getUpper())
                    {
                        targetCount.setText(lower);
                    }
                    else
                    {
                        targetCount.setText(lower + ".." + upper);
                    }
                }
            }
            else
            {
                targetCount.setText("");
            }
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * ConnectorTargetName Label
     * 
     * @generated
     */
    private void updateConnectorTargetNameLabel()
    {
        // TODO set the text to update
        // ((Label) ((ConnectorFigure)
        // getFigure()).getConnectorTargetNameEdgeObjectFigure()).setText(((Connector)
        // getEObject()).getConnectorTargetName());
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphEdgeEditPart#handleModelChanged(org.eclipse.emf.common.notify.Notification)
     */
    protected void handleModelChanged(Notification msg)
    {

        Object notifier = msg.getNotifier();
        Object newObject = msg.getNewValue();
        Object oldObject = msg.getOldValue();

        if (notifier instanceof Connector)
        {
            if (notifier == getEObject())
            {
                switch (msg.getFeatureID(Connector.class))
                {
                    case UMLPackage.CONNECTOR__END:
                        updateModelListening(oldObject, newObject);
                        break;
                }
                super.handleModelChanged(msg);
            }
        }
        else if (notifier instanceof ConnectorEnd)
        {
            switch (msg.getFeatureID(ConnectorEnd.class))
            {
                case UMLPackage.CONNECTOR_END__IS_ORDERED:
                    updateConnectorSrcCountLabel();
                    updateConnectorTargetCountLabel();
                    break;
                case UMLPackage.CONNECTOR_END__LOWER_VALUE:
                case UMLPackage.CONNECTOR_END__UPPER_VALUE:
                    updateModelListening(oldObject, newObject);
                    break;
            }
        }
        else if (notifier instanceof ValueSpecification)
        {
            updateConnectorSrcCountLabel();
            updateConnectorTargetCountLabel();
        }
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#activate()
     */
    public void activate()
    {
        super.activate();
        EObject model = getEObject();
        if (model instanceof Connector)
        {
            listenEnds((Connector) model);
        }
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#deactivate()
     */
    public void deactivate()
    {
        EObject model = getEObject();
        if (model instanceof Connector)
        {
            unlistenEnds((Connector) model);
        }
        super.deactivate();
    }

    private void listenEnds(Connector connector)
    {
        Iterator it = connector.getEnds().iterator();
        while (it.hasNext())
        {
            ConnectorEnd end = (ConnectorEnd) it.next();

            // Only listen to object that are not yet listened
            if (!end.eAdapters().contains(getModelListener()))
            {
                end.eAdapters().add(getModelListener());
            }
            listenValues(end);
        }
    }

    private void unlistenEnds(Connector connector)
    {
        Iterator it = connector.getEnds().iterator();
        while (it.hasNext())
        {
            ConnectorEnd end = (ConnectorEnd) it.next();

            unlistenValues(end);

            end.eAdapters().remove(getModelListener());
        }
    }

    /**
     * Listen to the bounds of the connector end
     * 
     * @param end the model object
     */
    private void listenValues(ConnectorEnd end)
    {
        // Only listen to object that are not yet listened
        if (end.getLowerValue() != null && !end.getLowerValue().eAdapters().contains(getModelListener()))
        {
            end.getLowerValue().eAdapters().add(getModelListener());
        }
        if (end.getUpperValue() != null && !end.getUpperValue().eAdapters().contains(getModelListener()))
        {
            end.getUpperValue().eAdapters().add(getModelListener());
        }
    }

    /**
     * Stop listening to the bounds of the connector end
     * 
     * @param end the model object
     */
    private void unlistenValues(ConnectorEnd end)
    {
        if (end.getLowerValue() != null)
        {
            end.getLowerValue().eAdapters().remove(getModelListener());
        }
        if (end.getUpperValue() != null)
        {
            end.getUpperValue().eAdapters().remove(getModelListener());
        }
    }
    

    /**
     * Update ItemFlowIcon according to the position of the connector
     * @param connectorFigure the ConnectorFigure
     */
    
    public void updateItemFlowIcon(ConnectorFigure connectorFigure)
    {
       if (isPointLocated(connectorFigure.getPoints()))
        {
            Label targetCount = (Label) ((ConnectorFigure) getFigure()).getConnectorItemFlowIconEdgeObjectFigure();        
            targetCount.setIcon(InternalBlockImageRegistry.getImage(getNameItemFlowIconImage(connectorFigure.getPoints().getPoint((connectorFigure.getPoints().size() / 2)-1), connectorFigure.getPoints().getPoint((connectorFigure.getPoints().size() / 2)))));  
        }
        else
        {
            if (connectorFigure.getPoints().size() > 2)
            {
                Label targetCount = (Label) ((ConnectorFigure) getFigure()).getConnectorItemFlowIconEdgeObjectFigure();        
                targetCount.setIcon(InternalBlockImageRegistry.getImage(getNameItemFlowIconImage(connectorFigure.getPoints().getPoint((connectorFigure.getPoints().size() / 2)-1), connectorFigure.getPoints().getPoint((connectorFigure.getPoints().size() / 2)))));  
            }
            else
            {
                Label targetCount = (Label) ((ConnectorFigure) getFigure()).getConnectorItemFlowIconEdgeObjectFigure();        
                targetCount.setIcon(InternalBlockImageRegistry.getImage(getNameItemFlowIconImage(connectorFigure.getPoints().getPoint(0),connectorFigure.getPoints().getPoint(1))));  
          
            }

        }
    }

    /**
     * Indicate if the EdgeObjectOffset is located on a point or between two
     * points.
     * 
     * @param listpoint the list of points of the connector
     * @return true if the EdgeObjectOffset is located on one of those point.
     *         False if EdgeObjectOffset is located between two points
     */
    private boolean isPointLocated(PointList listpoint)
    {
        if (listpoint.size() % 2 == 0)
        {
            return false;
        }
        else
        {
            return true;
        }

    }

    /**
     * Indicate if the flux flows from the source to the target or from the target to the source, or in both direction
     * 
     * @return int indicate the direction of the flux
     */
    private int getDirection()
    {
        int direction = noFlow;
        Connector connector = (Connector) getEObject();
        EList< ? > ends = connector.getEnds();

        if (ends.size() >= 2 && ((ConnectorEnd) ends.get(0)).getRole() != null
                && ((ConnectorEnd) ends.get(0)).getRole() instanceof FlowPort
                && ((ConnectorEnd) ends.get(1)).getRole() != null
                && ((ConnectorEnd) ends.get(1)).getRole() instanceof FlowPort)
        {
            FlowPort flowportSource = (FlowPort) ((ConnectorEnd) ends.get(0)).getRole();
            FlowPort flowportTarget = (FlowPort) ((ConnectorEnd) ends.get(1)).getRole();
            // Check if FlowPorts are not typed by a FlowSpecification
            if (!(flowportSource.getType() instanceof FlowSpecification) && !(flowportTarget.getType() instanceof FlowSpecification) )
            {
                if ((flowportSource.getDirection().equals(FlowDirectionKind.IN_LITERAL) && flowportTarget.getDirection().equals(
                        FlowDirectionKind.OUT_LITERAL))
                        || (flowportSource.getDirection().equals(FlowDirectionKind.IN_LITERAL) && flowportTarget.getDirection().equals(
                                FlowDirectionKind.INOUT_LITERAL))
                        || (flowportSource.getDirection().equals(FlowDirectionKind.INOUT_LITERAL) && flowportTarget.getDirection().equals(
                                FlowDirectionKind.OUT_LITERAL)))
                {
                    direction = flowFromSourceToTarget;
                }
                else if (flowportSource.getDirection().equals(FlowDirectionKind.OUT_LITERAL)
                        && flowportTarget.getDirection().equals(FlowDirectionKind.IN_LITERAL)
                        || (flowportSource.getDirection().equals(FlowDirectionKind.OUT_LITERAL) && flowportTarget.getDirection().equals(
                                FlowDirectionKind.INOUT_LITERAL))
                        || (flowportSource.getDirection().equals(FlowDirectionKind.INOUT_LITERAL) && flowportTarget.getDirection().equals(
                                FlowDirectionKind.IN_LITERAL)))
                {
                    direction = flowFromTargetToSource;
                }
                else if (flowportSource.getDirection().equals(FlowDirectionKind.INOUT_LITERAL)
                        && flowportTarget.getDirection().equals(FlowDirectionKind.INOUT_LITERAL))
                {
                    direction = flowInBothDirection;
                }
            }
            else if((flowportSource.getType() instanceof FlowSpecification) && (flowportTarget.getType() instanceof FlowSpecification))
            {
            	if((flowportSource.isIsConjugated() && !flowportTarget.isIsConjugated()) || (!flowportSource.isIsConjugated() && flowportTarget.isIsConjugated())) 
            	{
            		 direction = flowInBothDirection;
            	}
            }
        }
        return direction;
    }
    
    /**
     * Indicate the direction of the arrows according to the position of the two points and the direction of the flux
     * Initialize iconFlowDirection
     * @param firstPoint
     * @param secondPoint
     * @return
     */
    private String getNameItemFlowIconImage(Point firstPoint, Point secondPoint)
    {
        if((getDirection() == flowFromSourceToTarget && firstPoint.x == secondPoint.x && firstPoint.y > secondPoint.y)||
           (getDirection() == flowFromTargetToSource && firstPoint.x == secondPoint.x && firstPoint.y < secondPoint.y))
        { 
            iconFlowDirection = "ITEMFLOWDOWN";
            return "ITEMFLOWDOWN";
        }
        else if ((getDirection() == flowFromSourceToTarget && firstPoint.x == secondPoint.x && firstPoint.y < secondPoint.y)||
                (getDirection() == flowFromTargetToSource && firstPoint.x == secondPoint.x && firstPoint.y > secondPoint.y))
        {
            iconFlowDirection = "ITEMFLOWUP";
            return "ITEMFLOWUP";
        }
        else if ((getDirection() == flowFromSourceToTarget && firstPoint.x < secondPoint.x && firstPoint.y == secondPoint.y)||
                (getDirection() == flowFromTargetToSource && firstPoint.x > secondPoint.x && firstPoint.y == secondPoint.y))
        {
            iconFlowDirection = "ITEMFLOWLEFT";
            return "ITEMFLOWLEFT";
        }
        else if ((getDirection() == flowFromSourceToTarget && firstPoint.x > secondPoint.x && firstPoint.y == secondPoint.y)||
                (getDirection() == flowFromTargetToSource && firstPoint.x < secondPoint.x && firstPoint.y == secondPoint.y))
        {
            iconFlowDirection = "ITEMFLOWRIGHT";
            return "ITEMFLOWRIGHT";
        }
        else if ((getDirection() == flowInBothDirection && firstPoint.y == secondPoint.y))
        {
            iconFlowDirection = "ITEMFLOWBOTH";
            return "ITEMFLOWBOTH";
        }
        else if ((getDirection() == flowInBothDirection && firstPoint.x == secondPoint.x))
        {
            iconFlowDirection = "ITEMFLOWBOTHUPDOWN";
            return "ITEMFLOWBOTHUPDOWN";
        }
        return "ITEMFLOWERROR";
    }
    
    
    /**
     * @see org.eclipse.gef.editparts.AbstractEditPart#performRequest(Request)
     */
    public void performRequest(Request request)
    {
        if (request.getType() == RequestConstants.REQ_OPEN)
        {
            Connector connector = (Connector) getEObject();
            ConnectorFigure connectorFigure = (ConnectorFigure)getFigure();
            EList< ? > ends = connector.getEnds();

            if (ends.size() >= 2 && ((ConnectorEnd) ends.get(0)).getRole() != null
                    && ((ConnectorEnd) ends.get(0)).getRole() instanceof FlowPort
                    && ((ConnectorEnd) ends.get(1)).getRole() != null
                    && ((ConnectorEnd) ends.get(1)).getRole() instanceof FlowPort)
            {
                ItemFlowNameEditDialog itemFlowDlg = new ItemFlowNameEditDialog(connector,connectorFigure,
                        SysMLPlugin.getActiveWorkbenchShell(),iconFlowDirection);
                if (itemFlowDlg.open() == Window.OK)
                {
                    ItemFlowNameUpdateCommand command = new ItemFlowNameUpdateCommand((EdgeObjectOffsetEditableLabel)connectorFigure.getConnectorItemFlowNameEdgeObjectFigure(), connector,itemFlowDlg.getData());
                    getViewer().getEditDomain().getCommandStack().execute(command);
                }
            }
        }
        else
        {
            super.performRequest(request);
        }
    }
        
}