/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.LabelDirectEditPolicy;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.sysml.internalblockdiagram.commands.FlowPortRestoreConnectionCommand;
import org.topcased.modeler.sysml.internalblockdiagram.figures.FlowPortFigure;
import org.topcased.modeler.sysml.internalblockdiagram.figures.PortFigure;
import org.topcased.modeler.sysml.internalblockdiagram.figures.PortLabelledFigure;
import org.topcased.sysml.FlowDirectionKind;
import org.topcased.sysml.FlowPort;

/**
 * The FlowPort object controller <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class FlowPortEditPart extends PortEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public FlowPortEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new FlowPortRestoreConnectionCommand(getHost());
            }
        });

        installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LabelDirectEditPolicy());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated NOT
     */
    protected IFigure createFigure()
    {
        return new PortLabelledFigure(new FlowPortFigure());

    }

    private FlowPortFigure getFlowPortFigure()
    {
        PortLabelledFigure figure = (PortLabelledFigure) getFigure();
        return (FlowPortFigure) figure.getPortFigure();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#refreshVisuals()
     * @generated NOT
     */
    protected void refreshVisuals()
    {
        super.refreshVisuals();
        updatePortDirection();
        updatePortAtomicity();
        updatePortConjugation();
    }

    /**
     * Update port direction
     */
    protected void updatePortDirection()
    {
        int portType;
        switch (((FlowPort) getEObject()).getDirection().getValue())
        {
            case FlowDirectionKind.IN:
                portType = PortFigure.IN_PORT;
                break;
            case FlowDirectionKind.OUT:
                portType = PortFigure.OUT_PORT;
                break;
            default:
                portType = PortFigure.IN_OUT_PORT;
        }
        getFlowPortFigure().setDirection(portType);
    }

    /**
     * Update port atomicity
     */
    public void updatePortAtomicity()
    {
        try
        {
            boolean isAtomic = ((FlowPort) getEObject()).isIsAtomic();
            getFlowPortFigure().setIsAtomic(isAtomic);
        }
        catch (UnsupportedOperationException ex)
        {
            getFlowPortFigure().setIsAtomic(true);
        }
    }

    /**
     * Update port conjugation
     */
    public void updatePortConjugation()
    {
        boolean isConjugated = ((FlowPort) getEObject()).isIsConjugated();
        getFlowPortFigure().setIsConjugated(isConjugated);
    }
}