/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.edit.DiagramEditPart;
import org.topcased.modeler.editor.ModelerGraphicalViewer;
import org.topcased.modeler.sysml.internalblockdiagram.commands.RefreshPortsCommand;
import org.topcased.modeler.sysml.internalblockdiagram.figures.InternalBlockDiagramFigure;
import org.topcased.modeler.sysml.internalblockdiagram.policies.InternalBlockDiagramLayoutEditPolicy;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.Block;
import org.topcased.sysml.ConstraintBlock;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class InternalBlockDiagramEditPart extends DiagramEditPart
{

    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the root model element
     * @generated
     */
    public InternalBlockDiagramEditPart(Diagram model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#getLayoutEditPolicy()
     * @generated
     */
    protected EditPolicy getLayoutEditPolicy()
    {
        return new InternalBlockDiagramLayoutEditPolicy();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#createBodyFigure()
     * @generated
     */
    protected IFigure createBodyFigure()
    {
        return new InternalBlockDiagramFigure();
    }

    /**
     * @see org.topcased.modeler.edit.DiagramEditPart#getHeaderDiagram()
     */
    protected String getHeaderDiagram()
    {
        if(Utils.getElement(getDiagram()) instanceof ConstraintBlock){
            return "[constraintBlock] "+((ConstraintBlock) Utils.getElement(getDiagram())).getName() + " [" + getDiagram().getName() + "]";
        }
        return "[block] "+((Block) Utils.getElement(getDiagram())).getName() + " [" + getDiagram().getName() + "]";
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    protected IFigure createFigure()
    {
        IFigure page = super.createFigure();

        RefreshPortsCommand refreshPortsCommand = new RefreshPortsCommand(
                ((ModelerGraphicalViewer) getViewer()).getModelerEditor(), getDiagram());
        if (refreshPortsCommand != null && refreshPortsCommand.canExecute())
        {
            refreshPortsCommand.execute();
        }

        return page;
    }

    /**
     * @see org.topcased.modeler.edit.DiagramEditPart#refreshTextAndFont()
     */
    protected void refreshTextAndFont()
    {
        super.refreshTextAndFont();
        getFigure().repaint();
    }
}