/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram.figures;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LayoutManager;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.SWT;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.draw2d.figures.ILabel;
import org.topcased.draw2d.figures.Label;
import org.topcased.draw2d.layout.BorderAttachedLayout;


/**
 * Represents a < ? >Class Figure</b> that is a simple rectangle aimed to
 * contain other objects such as < ? >Interface, Port, Property and
 * CollaborationUse Figures</b>.
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 * @generated
 */
public class BlockPropertyFigure extends org.topcased.draw2d.figures.ContainerFigure
{
    /**
     * Constructor
     * 
     * @generated
     */
    public BlockPropertyFigure()
    {
        super();
    }

    /**
     * @see org.topcased.draw2d.figures.ContainerFigure#createContainer()
     * @generated
     */
    protected IFigure createContainer()
    {
        IFigure container = super.createContainer();
        container.setLayoutManager(new BorderAttachedLayout());
        return container;
    }

    private ILabel label;

    private IFigure contentPane;

    private IFigure innerRectangle;

    public static final int COMPOSITE_PROPERTY = 0;

    public static final int NON_COMPOSITE_PROPERTY = 1;

    private int type;

    /**
     * Creates the contents of the figure : by default, it creates a layout
     * manager, a header and a container
     * 
     * @generated NOT
     */
    public BlockPropertyFigure(int t)
    {
        LayoutManager layout = new StackLayout();
        setLayoutManager(layout);
        type = t;
        
        add(createBackgroundFigure());
        contentPane = new Figure();
        contentPane.setLayoutManager(new BorderAttachedLayout());
        add(contentPane);

        
    }

    protected void createContents()
    {

    }

    /**
     * Draws an inner rectangle that will be the real background figure. The
     * Anchor will be attached to this inner rectangle.<br>
     * 
     * @return the figure
     */
    protected IFigure createBackgroundFigure()
    {
        IFigure rectangle = new Figure();
        rectangle.setLayoutManager(new BorderLayout());
        rectangle.setBorder(new MarginBorder(7));

        innerRectangle = new RectangleFigure();
        innerRectangle.setOpaque(true);
        rectangle.add(innerRectangle, new Integer(PositionConstants.CENTER));

        ToolbarLayout toolbarLayout = new ToolbarLayout();
        toolbarLayout.setMinorAlignment(ToolbarLayout.ALIGN_CENTER);
        innerRectangle.setLayoutManager(toolbarLayout);

        IFigure innerLabelRectangle = new RectangleFigure();
        innerLabelRectangle.setBorder(new MarginBorder((new LineBorder()).getInsets(innerRectangle)));
        innerLabelRectangle.setLayoutManager(new BorderLayout());

        label = createLabel();
        innerLabelRectangle.add(label, new Integer(PositionConstants.CENTER));
        innerRectangle.add(innerLabelRectangle);
        //innerRectangle.add(label);
        
        if(type == BlockPropertyFigure.NON_COMPOSITE_PROPERTY){
        	((RectangleFigure)innerLabelRectangle).setLineStyle(SWT.LINE_DASH);
        	((RectangleFigure)innerRectangle).setLineStyle(SWT.LINE_DASH);
        }

        return rectangle;
    }

    /**
     * Returns the figure drawn behind the label. In this case, we only return
     * the inner rectangle drawn.
     * 
     * @return the background figure
     */
    public IFigure getBackgroundFigure()
    {
        return innerRectangle;
    }

    /**
     * Creates the label of the Figure.<br>
     * 
     * @return the label of the Figure
     */
    protected ILabel createLabel()
    {
        return new ComposedLabel(new Label(), new Label(), new Label(), true);
    }

    /**
     * @see org.topcased.draw2d.figures.ILabelFigure#getLabel()
     */
    public ILabel getLabel()
    {
        return label;
    }

    /**
     * @see org.topcased.draw2d.figures.IContainerFigure#getContentPane()
     */
    public IFigure getContentPane()
    {
        return contentPane;
    }

    /**
     * Change the type of the property
     * 
     * @param t the new type of the property (composite or not)
     */
    public void setType(int t)
    {
        type = t;
    }

}