/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.internalblockdiagram.policies;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.UnexecutableCommand;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy;
import org.topcased.modeler.sysml.internalblockdiagram.commands.CreatePortCommand;
import org.topcased.modeler.sysml.internalblockdiagram.commands.CreatePropertyCommand;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.BlockProperty;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class InternalBlockDiagramLayoutEditPolicy extends ModelerLayoutEditPolicy
{
    /**
     * Default contructor. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public InternalBlockDiagramLayoutEditPolicy()
    {
        super();
    }

    /**
     * @see org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy#isAttachedToBorder(GraphNode)
     */
    protected boolean isAttachedToBorder(GraphNode node)
    {
        return Utils.getElement(node) instanceof Port;
    }

    /**
     * @see org.topcased.modeleler.edit.policies.ModelerLayoutEditPolicy#isValid(org.eclipse.emf.ecore.EObject,
     *      org.eclipse.emf.ecore.EObject)
     */
    protected boolean isValid(EObject child, EObject parent)
    {
        if (child.eClass() == UMLPackage.eINSTANCE.getProperty())
            return false;
        return true;
    }
    
    /**
	 * Override the behavior were the Features component may not exist yet and should be created by the customized creation command
	 * 
	 * @see org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy#getCreateCommand(org.topcased.modeler.di.model.GraphNode,
	 *      org.topcased.modeler.di.model.GraphNode, org.eclipse.draw2d.geometry.Point, org.eclipse.draw2d.geometry.Dimension, int, boolean)
	 */
	protected Command getCreateCommand(GraphNode parent, GraphNode child, Point loc, Dimension dim, int pos, boolean needModelUpdate)
	{
		if (isValid(child, parent))
		{
			EditDomain domain = getHost().getViewer().getEditDomain();

			// get the EObjects of the model
			EObject parentEObject = Utils.getElement(parent);
			EObject childEObject = Utils.getElement(child);

			if (isValid(childEObject, parentEObject))
			{
				// handles Port object
				if (childEObject instanceof Port)
				{
					return new CreatePortCommand(domain, child, parent, loc, dim, pos, needModelUpdate);
				}
				
				// handles Property object
				if (childEObject instanceof BlockProperty)
				{
					return new CreatePropertyCommand(domain, child, parent, loc, dim, pos, needModelUpdate);
				}
	
				// default
				return super.getCreateCommand(parent, child, loc, dim, pos, needModelUpdate);
			}
		}

		return UnexecutableCommand.INSTANCE;
	}
}