/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies) - initial API and
 * implementation, Thomas Friol (Anyware Technologies)
 ******************************************************************************/

package org.topcased.modeler.sysml.internalblockdiagram.util;

import java.util.Collection;
import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.sysml.PackageSYSML;

public class BlockTools
{
    /**
     * Return the block definition in which an element is contained
     * 
     * @param element
     * @return the block definition
     */
    public static PackageSYSML getPackageSYSML(Element element)
    {
        if (element == null || element instanceof PackageSYSML)
            return (PackageSYSML) element;
        return getPackageSYSML(element.getOwner());
    }
    
    /**
     * Retrieve the type of an object according to its name
     * @param EObject the object
     * @param String the typeText 
     * @return Type the type of the object
     */
    public static Type getOldType(String typeText, EObject object)
    {
        Collection< EObject > reachableTypes = ItemPropertyDescriptor.getReachableObjectsOfType(object,
                UMLPackage.eINSTANCE.getType());
        Iterator<EObject> it = reachableTypes.iterator();
        while(it.hasNext())
        {
            Type type = (Type)it.next();
            if(type.getName().equals(typeText))
                return type;
            
        }
        return null;
    }
}
