/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.parametricdiagram;

import java.net.URL;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.gef.EditPartFactory;
import org.topcased.modeler.editor.IConfiguration;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.IPaletteManager;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.graphconf.exceptions.MissingGraphConfFileException;
import org.topcased.modeler.sysml.parametricdiagram.edit.CommentEditPart;
import org.topcased.modeler.sysml.parametricdiagram.edit.ConnectorEditPart;
import org.topcased.modeler.sysml.parametricdiagram.edit.ConstraintPropertyEditPart;
import org.topcased.modeler.sysml.parametricdiagram.edit.DependencyEditPart;
import org.topcased.modeler.sysml.parametricdiagram.edit.ElementEditPart;
import org.topcased.modeler.sysml.parametricdiagram.edit.NamedElementEditPart;
import org.topcased.modeler.sysml.parametricdiagram.edit.ProblemEditPart;
import org.topcased.modeler.sysml.parametricdiagram.edit.PropertyEditPart;
import org.topcased.modeler.sysml.parametricdiagram.edit.RationaleEditPart;

/**
 * A diagram configuration : manages Palette, EditPartFactory for this diagram.
 * 
 * @generated
 */
public class ParametricConfiguration implements IConfiguration
{
    /**
     * @generated
     */
    private ParametricPaletteManager paletteManager;

    /**
     * @generated
     */
    private ParametricEditPartFactory editPartFactory;

    /**
     * @generated
     */
    private ParametricCreationUtils creationUtils;

    /**
     * The DiagramGraphConf that contains graphical informations on the
     * configuration
     * 
     * @generated
     */
    private DiagramGraphConf diagramGraphConf;

    /**
     * Constructor. Initialize Adapter factories.
     * 
     * @generated
     */
    public ParametricConfiguration()
    {
        registerAdapters();
    }

    /**
     * Registers the Adapter Factories for all the EditParts
     * 
     * @generated
     */
    private void registerAdapters()
    {
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ElementEditPart.class, org.eclipse.uml2.uml.Element.class),
                ElementEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(NamedElementEditPart.class, org.eclipse.uml2.uml.NamedElement.class),
                NamedElementEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(PropertyEditPart.class, org.eclipse.uml2.uml.Property.class),
                PropertyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(CommentEditPart.class, org.eclipse.uml2.uml.Comment.class),
                CommentEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(RationaleEditPart.class, org.topcased.sysml.Rationale.class),
                RationaleEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ProblemEditPart.class, org.topcased.sysml.Problem.class),
                ProblemEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ConstraintPropertyEditPart.class,
                        org.topcased.sysml.ConstraintProperty.class), ConstraintPropertyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ConnectorEditPart.class, org.eclipse.uml2.uml.Connector.class),
                ConnectorEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(DependencyEditPart.class, org.eclipse.uml2.uml.Dependency.class),
                DependencyEditPart.class);
    }

    /**
     * @see org.topcased.modeler.editor.IConfiguration#getId()
     * @generated
     */
    public String getId()
    {
        return new String("org.topcased.modeler.sysml.parametricdiagram");
    }

    /**
     * @see org.topcased.modeler.editor.IConfiguration#getName()
     * @generated
     */
    public String getName()
    {
        return new String("Parametric Diagram");
    }

    /**
     * @see org.topcased.modeler.editor.IConfiguration#getEditPartFactory()
     * @generated
     */
    public EditPartFactory getEditPartFactory()
    {
        if (editPartFactory == null)
        {
            editPartFactory = new ParametricEditPartFactory();
        }

        return editPartFactory;
    }

    /**
     * @see org.topcased.modeler.editor.IConfiguration#getPaletteManager()
     * @generated
     */
    public IPaletteManager getPaletteManager()
    {
        if (paletteManager == null)
        {
            paletteManager = new ParametricPaletteManager(getCreationUtils());
        }

        return paletteManager;
    }

    /**
     * @see org.topcased.modeler.editor.IConfiguration#getCreationUtils()
     * @generated
     */
    public ICreationUtils getCreationUtils()
    {
        if (creationUtils == null)
        {
            creationUtils = new ParametricCreationUtils(getDiagramGraphConf());
        }

        return creationUtils;
    }

    /**
     * @see org.topcased.modeler.editor.IConfiguration#getDiagramGraphConf()
     * @generated
     */
    public DiagramGraphConf getDiagramGraphConf()
    {
        if (diagramGraphConf == null)
        {
            URL url = ParametricPlugin.getDefault().getBundle().getResource(
                    "org/topcased/modeler/sysml/parametricdiagram/diagram.graphconf");
            if (url != null)
            {
                URI fileURI = URI.createURI(url.toString());
                ResourceSet resourceSet = new ResourceSetImpl();
                Resource resource = resourceSet.getResource(fileURI, true);
                if (resource != null && resource.getContents().get(0) instanceof DiagramGraphConf)
                {
                    diagramGraphConf = (DiagramGraphConf) resource.getContents().get(0);
                }
            }
            else
            {
                new MissingGraphConfFileException(
                        "The *.diagramgraphconf file can not be retrieved. Check if the path is correct in the Configuration class of your diagram.");
            }
        }

        return diagramGraphConf;
    }

}