/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.parametricdiagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.Property;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.sysml.ConstraintProperty;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model
 * Object
 * 
 * @generated
 */
public class ParametricCreationUtils extends AbstractCreationUtils
{

    /**
     * Constructor
     * 
     * @param diagramConf the Diagram Graphical Configuration
     * @generated
     */
    public ParametricCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * @generated
     */
    private class GraphicSysMLSwitch extends SysMLSwitch
    {
        /**
         * The presentation of the graphical element
         * 
         * @generated
         */
        private String presentation;

        /**
         * Constructor
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicSysMLSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConstraintProperty(org.topcased.sysml.ConstraintProperty)
         * @generated NOT
         */
        public Object caseConstraintProperty(org.topcased.sysml.ConstraintProperty object)
        {
            return createGraphElementConstraintProperty(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         * @generated NOT
         */
        public Object caseRationale(org.topcased.sysml.Rationale object)
        {
            return createGraphElementRationale(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         * @generated NOT
         */
        public Object caseProblem(org.topcased.sysml.Problem object)
        {
            return createGraphElementProblem(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseComment(org.eclipse.uml2.uml.Comment object)
        {
            return createGraphElementComment(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProperty(org.eclipse.uml2.uml.Property)
         */
        public Object caseProperty(org.eclipse.uml2.uml.Property object)
        {
            return createGraphElementProperty(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConnector(org.eclipse.uml2.uml.Connector)
         */
        public Object caseConnector(Connector object)
        {
            return createGraphElementConnector(object, presentation);
        }

        public Object caseDependency(Dependency object)
        {
            return createGraphElementDependency(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated NOT
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = new GraphicSysMLSwitch(presentation).doSwitch(obj);
        return (GraphElement) graphElt;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementConstraintProperty(org.topcased.sysml.ConstraintProperty element,
            String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementProperty(org.eclipse.uml2.uml.Property element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementConnector(org.eclipse.uml2.uml.Connector element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(ParametricEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(nameEdgeObjectOffset);
        EdgeObjectUV connectorsrccountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        connectorsrccountEdgeObjectUV.setId(ParametricEdgeObjectConstants.CONNECTORSRCCOUNT_EDGE_OBJECT_ID);
        connectorsrccountEdgeObjectUV.setUDistance(0);
        connectorsrccountEdgeObjectUV.setVDistance(0);
        graphEdge.getContained().add(connectorsrccountEdgeObjectUV);
        EdgeObjectUV connectorsrcnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        connectorsrcnameEdgeObjectUV.setId(ParametricEdgeObjectConstants.CONNECTORSRCNAME_EDGE_OBJECT_ID);
        connectorsrcnameEdgeObjectUV.setUDistance(0);
        connectorsrcnameEdgeObjectUV.setVDistance(0);
        graphEdge.getContained().add(connectorsrcnameEdgeObjectUV);
        EdgeObjectUV connectortargetcountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        connectortargetcountEdgeObjectUV.setId(ParametricEdgeObjectConstants.CONNECTORTARGETCOUNT_EDGE_OBJECT_ID);
        connectortargetcountEdgeObjectUV.setUDistance(0);
        connectortargetcountEdgeObjectUV.setVDistance(0);
        graphEdge.getContained().add(connectortargetcountEdgeObjectUV);
        EdgeObjectUV connectortargetnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        connectortargetnameEdgeObjectUV.setId(ParametricEdgeObjectConstants.CONNECTORTARGETNAME_EDGE_OBJECT_ID);
        connectortargetnameEdgeObjectUV.setUDistance(0);
        connectortargetnameEdgeObjectUV.setVDistance(0);
        graphEdge.getContained().add(connectortargetnameEdgeObjectUV);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDependency(org.eclipse.uml2.uml.Dependency element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset dependencystereotypesEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        dependencystereotypesEdgeObjectOffset.setId(ParametricEdgeObjectConstants.DEPENDENCYSTEREOTYPES_EDGE_OBJECT_ID);
        dependencystereotypesEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(dependencystereotypesEdgeObjectOffset);
        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(ParametricEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(nameEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComment(org.eclipse.uml2.uml.Comment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementRationale(org.topcased.sysml.Rationale element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementProblem(org.topcased.sysml.Problem element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * 
     */
    private class ModelSwitch extends SysMLSwitch
    {
        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseComment(Comment object)
        {
            return createModelObjectComment(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConstraintProperty(org.topcased.sysml.ConstraintProperty)
         */
        public Object caseConstraintProperty(ConstraintProperty object)
        {
            return createModelObjectConstraintProperty(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseProperty(Property object)
        {
            return createModelObjectProperty(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseConnector(org.eclipse.uml2.uml.Connector)
         */
        public Object caseConnector(Connector object)
        {
            return createModelObjectConnector(object);
        }

        public Object caseDependency(Dependency object)
        {
            return createModelObjectDependency(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         */
        public Object caseRationale(Rationale object)
        {
            return createModelObjectRationale(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         */
        public Object caseProblem(Problem object)
        {
            return createModelObjectProblem(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }

    }

    /**
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Comment createModelObjectComment(Comment element)
    {
        return element;
    }

    /**
     * @param element the original model element
     */
    protected Property createModelObjectProperty(Property element)
    {
        return element;
    }

    /**
     * @param element the original model element
     * @return the complete Model Object
     */
    protected ConstraintProperty createModelObjectConstraintProperty(ConstraintProperty element)
    {
        return element;
    }

    /**
     * 
     */
    protected Connector createModelObjectConnector(Connector element)
    {
        return element;
    }

    /**
     * 
     */
    protected Dependency createModelObjectDependency(Dependency element)
    {
        return element;
    }

    /**
     * 
     */
    protected Rationale createModelObjectRationale(Rationale element)
    {
        return element;
    }

    /**
     * 
     */
    protected Problem createModelObjectProblem(Problem element)
    {
        return element;
    }

    /**
     * Create the ModelObject with its initial children
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated NOT
     */
    public EObject createModelObject(EObject obj)
    {
        Object eObject = new ModelSwitch().doSwitch(obj);
        return (EObject) eObject;
    }

}
