/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.parametricdiagram;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;
import org.topcased.sysml.SysMLPackage;

/**
 * Generated Palette Manager
 * 
 * @generated
 */
public class ParametricPaletteManager extends ModelerPaletteManager
{
    // declare all the palette categories of the diagram
    /**
     * @generated
     */
    private PaletteDrawer objectsDrawer;

    /**
     * @generated
     */
    private PaletteDrawer connectionsDrawer;

    /**
     * @generated
     */
    private PaletteDrawer commentsDrawer;

    /**
     * @generated
     */
    private ICreationUtils creationUtils;

    /**
     * The Constructor
     * 
     * @param utils the creation utils for the tools of the palette
     * @generated
     */
    public ParametricPaletteManager(ICreationUtils utils)
    {
        super();
        this.creationUtils = utils;
    }

    /**
     * Creates the main categories of the palette
     * 
     * @generated
     */
    protected void createCategories()
    {
        createObjectsDrawer();
        createConnectionsDrawer();
        createCommentsDrawer();
    }

    /**
     * Updates the main categories of the palette
     * 
     * @generated
     */
    protected void updateCategories()
    {
        // deletion of the existing categories and creation of the updated
        // categories

        getRoot().remove(objectsDrawer);
        createObjectsDrawer();

        getRoot().remove(connectionsDrawer);
        createConnectionsDrawer();

        getRoot().remove(commentsDrawer);
        createCommentsDrawer();
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure.
     * 
     * @generated
     */
    private void createObjectsDrawer()
    {
        objectsDrawer = new PaletteDrawer("Objects", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getConstraintProperty(),
                "default");
        entries.add(new ModelerCreationToolEntry("Constraint Property", "Constraint Property", factory,
                ParametricImageRegistry.getImageDescriptor("CONSTRAINTPROPERTY"),
                ParametricImageRegistry.getImageDescriptor("CONSTRAINTPROPERTY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getProperty(), "default");
        entries.add(new ModelerCreationToolEntry("Property", "Property", factory,
                ParametricImageRegistry.getImageDescriptor("PROPERTY"),
                ParametricImageRegistry.getImageDescriptor("PROPERTY_LARGE")));

        objectsDrawer.addAll(entries);
        getRoot().add(objectsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure.
     * 
     * @generated
     */
    private void createConnectionsDrawer()
    {
        connectionsDrawer = new PaletteDrawer("Connections", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getConnector(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Connector", "Connector", factory,
                ParametricImageRegistry.getImageDescriptor("CONNECTOR"),
                ParametricImageRegistry.getImageDescriptor("CONNECTOR_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDependency(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Dependency", "Dependency", factory,
                ParametricImageRegistry.getImageDescriptor("DEPENDENCY"),
                ParametricImageRegistry.getImageDescriptor("DEPENDENCY_LARGE")));

        connectionsDrawer.addAll(entries);
        getRoot().add(connectionsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure.
     * 
     * @generated
     */
    private void createCommentsDrawer()
    {
        commentsDrawer = new PaletteDrawer("Comments", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getComment(), "default");
        entries.add(new ModelerCreationToolEntry("Comment", "Comment", factory,
                ParametricImageRegistry.getImageDescriptor("COMMENT"),
                ParametricImageRegistry.getImageDescriptor("COMMENT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getRationale(), "default");
        entries.add(new ModelerCreationToolEntry("Rationale", "Rationale", factory,
                ParametricImageRegistry.getImageDescriptor("RATIONALE"),
                ParametricImageRegistry.getImageDescriptor("RATIONALE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getProblem(), "default");
        entries.add(new ModelerCreationToolEntry("Problem", "Problem", factory,
                ParametricImageRegistry.getImageDescriptor("PROBLEM"),
                ParametricImageRegistry.getImageDescriptor("PROBLEM_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils,
                ParametricSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK, "default", false);
        entries.add(new ModelerConnectionCreationToolEntry("Comment Link", "Comment Link", factory,
                ParametricImageRegistry.getImageDescriptor("COMMENTLINK"),
                ParametricImageRegistry.getImageDescriptor("COMMENTLINK_LARGE")));

        commentsDrawer.addAll(entries);
        getRoot().add(commentsDrawer);
    }

}
