/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.parametricdiagram.commands;

import org.eclipse.gef.EditDomain;
import org.eclipse.uml2.uml.ConnectableElement;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.eclipse.uml2.uml.ConnectorKind;
import org.eclipse.uml2.uml.StructuredClassifier;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.utils.LabelHelper;
import org.topcased.modeler.utils.Utils;

/**
 * Connector edge creation command<br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ConnectorEdgeCreationCommand extends CreateTypedEdgeCommand
{

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @generated
     */
    public ConnectorEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src)
    {
        this(domain, newObj, src, true);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @param needModelUpdate set it to true if the model need to be updated
     * @generated
     */
    public ConnectorEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src, boolean needModelUpdate)
    {
        super(domain, newObj, src, needModelUpdate);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void redoModel()
    {

        // Retrieve source object and target object
        ConnectableElement targetObject = (ConnectableElement) Utils.getElement(getTarget());
        ConnectableElement sourceObject = (ConnectableElement) Utils.getElement(getSource());

        // Get the connector and add it to the container
        Connector connector = (Connector) Utils.getElement(getEdge());

        if (sourceObject.eContainer() instanceof StructuredClassifier)
        {
            StructuredClassifier container = (StructuredClassifier) sourceObject.eContainer();

            container.getOwnedConnectors().add(connector);

            // init the name of the connector contained by the package
            LabelHelper labelHelper = new LabelHelper();
            String curName = labelHelper.getName(getEditDomain(), connector);
            if (curName == null || curName == "")
            {
                labelHelper.initName(getEditDomain(), container, connector);
            }

            // Create two connectorEnd that handle the link between the two
            // object
            ConnectorEnd end1 = connector.createEnd();
            end1.setRole(sourceObject);

            ConnectorEnd end2 = connector.createEnd();
            end2.setRole(targetObject);

            if (!sourceObject.eClass().equals(UMLPackage.eINSTANCE.getPort()))
            {
                connector.setKind(ConnectorKind.DELEGATION_LITERAL);
            }
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void undoModel()
    {
        // Remove the connector
        Connector connector = (Connector) Utils.getElement(getEdge());
        connector.destroy();
    }

}