/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.parametricdiagram.edit;

import java.util.Iterator;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.eclipse.uml2.uml.LiteralUnlimitedNatural;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.ValueSpecification;
import org.topcased.draw2d.figures.Label;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.EdgeObject;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.policies.EdgeObjectOffsetEditPolicy;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.sysml.parametricdiagram.ParametricEdgeObjectConstants;
import org.topcased.modeler.sysml.parametricdiagram.ParametricEditPolicyConstants;
import org.topcased.modeler.sysml.parametricdiagram.figures.ConnectorFigure;
import org.topcased.modeler.sysml.parametricdiagram.policies.CommentLinkEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.parametricdiagram.policies.ConnectorEdgeObjectUVEditPolicy;
import org.topcased.modeler.sysml.util.SysMLTools;

/**
 * Connector controller <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ConnectorEditPart extends EMFGraphEdgeEditPart
{

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the graph object
     * @generated
     */
    public ConnectorEditPart(GraphEdge model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        // Add a CommentLink Policy to this element
        installEditPolicy(ParametricEditPolicyConstants.COMMENTLINK_EDITPOLICY, new CommentLinkEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_UV_EDITPOLICY, new ConnectorEdgeObjectUVEditPolicy());
        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_OFFSET_EDITPOLICY, new EdgeObjectOffsetEditPolicy());

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Figure
     * @generated
     */
    protected IFigure createFigure()
    {
        ConnectorFigure connection = new ConnectorFigure();

        return connection;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#getEdgeObjectFigure(org.topcased.modeler.di.model.EdgeObject)
     * @generated
     */
    public IEdgeObjectFigure getEdgeObjectFigure(EdgeObject edgeObject)
    {
        if (ParametricEdgeObjectConstants.NAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getNameEdgeObjectFigure();
        }
        if (ParametricEdgeObjectConstants.CONNECTORSRCCOUNT_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorSrcCountEdgeObjectFigure();
        }
        if (ParametricEdgeObjectConstants.CONNECTORSRCNAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorSrcNameEdgeObjectFigure();
        }
        if (ParametricEdgeObjectConstants.CONNECTORTARGETCOUNT_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorTargetCountEdgeObjectFigure();
        }
        if (ParametricEdgeObjectConstants.CONNECTORTARGETNAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((ConnectorFigure) getFigure()).getConnectorTargetNameEdgeObjectFigure();
        }
        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#refreshEdgeObjects()
     * @generated
     */
    protected void refreshEdgeObjects()
    {
        super.refreshEdgeObjects();
        updateNameLabel();
        updateConnectorSrcCountLabel();
        updateConnectorSrcNameLabel();
        updateConnectorTargetCountLabel();
        updateConnectorTargetNameLabel();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the name Label
     * 
     * @generated NOT
     */
    private void updateNameLabel()
    {
        Connector connector = (Connector) getEObject();
        String label = SysMLTools.getStereotypeNotation(connector) + connector.getName();
        if (connector.getType() != null)
            label += " : " + connector.getType().getName();
        ((Label) ((ConnectorFigure) getFigure()).getNameEdgeObjectFigure()).setText(label);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * ConnectorSrcCount Label
     * 
     * @generated NOT
     */
    private void updateConnectorSrcCountLabel()
    {
        Connector connector = (Connector) getEObject();
        Label srcCount = (Label) ((ConnectorFigure) getFigure()).getConnectorSrcCountEdgeObjectFigure();
        if (connector.getEnds().size() == 2)
        {
            ConnectorEnd firstEnd = (ConnectorEnd) connector.getEnds().get(0);
            String lower = Integer.toString(firstEnd.getLower());
            String upper = LiteralUnlimitedNatural.UNLIMITED == firstEnd.getUpper() ? "*"
                    : Integer.toString(firstEnd.getUpper());
            if (firstEnd.getLower() != firstEnd.getUpper() || firstEnd.getLower() != 1)
            {
                if (firstEnd.isOrdered())
                {
                    if (firstEnd.getLower() == firstEnd.getUpper())
                    {
                        srcCount.setText("{" + lower + "}");
                    }
                    else
                    {
                        srcCount.setText("{" + lower + ".." + upper + "}");
                    }
                }
                else
                {
                    if (firstEnd.getLower() == firstEnd.getUpper())
                    {
                        srcCount.setText(lower);
                    }
                    else
                    {
                        srcCount.setText(lower + ".." + upper);
                    }
                }
            }
            else
            {
                srcCount.setText("");
            }
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the ConnectorSrcName
     * Label
     * 
     * @generated
     */
    private void updateConnectorSrcNameLabel()
    {
        // TODO set the text to update
        // ((Label) ((ConnectorFigure)
        // getFigure()).getConnectorSrcNameEdgeObjectFigure()).setText(((Connector)
        // getEObject()).getConnectorSrcName());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * ConnectorTargetCount Label
     * 
     * @generated NOT
     */
    private void updateConnectorTargetCountLabel()
    {
        Connector connector = (Connector) getEObject();
        Label targetCount = (Label) ((ConnectorFigure) getFigure()).getConnectorTargetCountEdgeObjectFigure();
        if (connector.getEnds().size() == 2)
        {
            ConnectorEnd secondEnd = (ConnectorEnd) connector.getEnds().get(1);
            String lower = Integer.toString(secondEnd.getLower());
            String upper = LiteralUnlimitedNatural.UNLIMITED == secondEnd.getUpper() ? "*"
                    : Integer.toString(secondEnd.getUpper());
            if (secondEnd.getLower() != secondEnd.getUpper() || secondEnd.getLower() != 1)
            {
                if (secondEnd.isOrdered())
                {
                    if (secondEnd.getLower() == secondEnd.getUpper())
                    {
                        targetCount.setText("{" + lower + "}");
                    }
                    else
                    {
                        targetCount.setText("{" + lower + ".." + upper + "}");
                    }
                }
                else
                {
                    if (secondEnd.getLower() == secondEnd.getUpper())
                    {
                        targetCount.setText(lower);
                    }
                    else
                    {
                        targetCount.setText(lower + ".." + upper);
                    }
                }
            }
            else
            {
                targetCount.setText("");
            }
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * ConnectorTargetName Label
     * 
     * @generated
     */
    private void updateConnectorTargetNameLabel()
    {
        // TODO set the text to update
        // ((Label) ((ConnectorFigure)
        // getFigure()).getConnectorTargetNameEdgeObjectFigure()).setText(((Connector)
        // getEObject()).getConnectorTargetName());
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphEdgeEditPart#handleModelChanged(org.eclipse.emf.common.notify.Notification)
     */
    protected void handleModelChanged(Notification msg)
    {

        Object notifier = msg.getNotifier();
        Object newObject = msg.getNewValue();
        Object oldObject = msg.getOldValue();

        if (notifier instanceof Connector)
        {
            if (notifier == getEObject())
            {
                switch (msg.getFeatureID(Connector.class))
                {
                    case UMLPackage.CONNECTOR__END:
                        updateModelListening(oldObject, newObject);
                        break;
                }
                super.handleModelChanged(msg);
            }
        }
        else if (notifier instanceof ConnectorEnd)
        {
            switch (msg.getFeatureID(ConnectorEnd.class))
            {
                case UMLPackage.CONNECTOR_END__IS_ORDERED:
                    updateConnectorSrcCountLabel();
                    updateConnectorTargetCountLabel();
                    break;
                case UMLPackage.CONNECTOR_END__LOWER_VALUE:
                case UMLPackage.CONNECTOR_END__UPPER_VALUE:
                    updateModelListening(oldObject, newObject);
                    break;
            }
        }
        else if (notifier instanceof ValueSpecification)
        {
            updateConnectorSrcCountLabel();
            updateConnectorTargetCountLabel();
        }
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#activate()
     */
    public void activate()
    {
        super.activate();
        EObject model = getEObject();
        if (model instanceof Connector)
        {
            listenEnds((Connector) model);
        }
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#deactivate()
     */
    public void deactivate()
    {
        EObject model = getEObject();
        if (model instanceof Connector)
        {
            unlistenEnds((Connector) model);
        }
        super.deactivate();
    }

    private void listenEnds(Connector connector)
    {
        Iterator it = connector.getEnds().iterator();
        while (it.hasNext())
        {
            ConnectorEnd end = (ConnectorEnd) it.next();

            // Only listen to object that are not yet listened
            if (!end.eAdapters().contains(getModelListener()))
            {
                end.eAdapters().add(getModelListener());
            }
            listenValues(end);
        }
    }

    private void unlistenEnds(Connector connector)
    {
        Iterator it = connector.getEnds().iterator();
        while (it.hasNext())
        {
            ConnectorEnd end = (ConnectorEnd) it.next();

            unlistenValues(end);

            end.eAdapters().remove(getModelListener());
        }
    }

    /**
     * Listen to the bounds of the connector end
     * 
     * @param end the model object
     */
    private void listenValues(ConnectorEnd end)
    {
        // Only listen to object that are not yet listened
        if (end.getLowerValue() != null && !end.getLowerValue().eAdapters().contains(getModelListener()))
        {
            end.getLowerValue().eAdapters().add(getModelListener());
        }
        if (end.getUpperValue() != null && !end.getUpperValue().eAdapters().contains(getModelListener()))
        {
            end.getUpperValue().eAdapters().add(getModelListener());
        }
    }

    /**
     * Stop listening to the bounds of the connector end
     * 
     * @param end the model object
     */
    private void unlistenValues(ConnectorEnd end)
    {
        if (end.getLowerValue() != null)
        {
            end.getLowerValue().eAdapters().remove(getModelListener());
        }
        if (end.getUpperValue() != null)
        {
            end.getUpperValue().eAdapters().remove(getModelListener());
        }
    }
}