/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.parametricdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.swt.SWT;
import org.eclipse.uml2.uml.Dependency;
import org.topcased.draw2d.figures.Label;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.EdgeObject;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.policies.EdgeObjectOffsetEditPolicy;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.sysml.parametricdiagram.ParametricEdgeObjectConstants;
import org.topcased.modeler.sysml.parametricdiagram.ParametricEditPolicyConstants;
import org.topcased.modeler.sysml.parametricdiagram.figures.DependencyFigure;
import org.topcased.modeler.sysml.parametricdiagram.policies.CommentLinkEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.util.SysMLTools;

/**
 * Dependency controller
 * 
 * @generated
 */
public class DependencyEditPart extends EMFGraphEdgeEditPart
{

    private static final int LINE_ON = 10;

    private static final int LINE_OFF = 5;

    /**
     * Constructor
     * 
     * @param model the graph object
     * @generated
     */
    public DependencyEditPart(GraphEdge model)
    {
        super(model);
    }

    /**
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        // Add a CommentLink Policy to this element
        installEditPolicy(ParametricEditPolicyConstants.COMMENTLINK_EDITPOLICY, new CommentLinkEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_OFFSET_EDITPOLICY, new EdgeObjectOffsetEditPolicy());

    }

    /**
     * customize the line
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated NOT
     */
    protected IFigure createFigure()
    {
        DependencyFigure connection = (DependencyFigure) createFigureGen();
        connection.setLineStyle(SWT.LINE_CUSTOM);
        connection.setLineDash(new int[] {LINE_ON, LINE_OFF});
        return connection;
    }

    /**
     * @return the Figure
     */
    protected IFigure createFigureGen()
    {
        DependencyFigure connection = new DependencyFigure();

        createTargetDecoration(connection);

        return connection;
    }

    /**
     * @param connection the PolylineConnection
     * @generated
     */
    private void createTargetDecoration(PolylineConnection connection)
    {

        PolylineDecoration decoration = new PolylineDecoration();
        decoration.setScale(10, 5);
        connection.setTargetDecoration(decoration);

    }

    /**
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#getEdgeObjectFigure(org.topcased.modeler.di.model.EdgeObject)
     * @generated
     */
    public IEdgeObjectFigure getEdgeObjectFigure(EdgeObject edgeObject)
    {
        if (ParametricEdgeObjectConstants.DEPENDENCYSTEREOTYPES_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((DependencyFigure) getFigure()).getDependencyStereotypesEdgeObjectFigure();
        }
        if (ParametricEdgeObjectConstants.NAME_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((DependencyFigure) getFigure()).getNameEdgeObjectFigure();
        }
        return null;
    }

    /**
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#refreshEdgeObjects()
     * @generated
     */
    protected void refreshEdgeObjects()
    {
        super.refreshEdgeObjects();
        updateDependencyStereotypesLabel();
        updateNameLabel();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * BlockDependencyStereotypes Label
     * 
     * @generated NOT
     */
    private void updateDependencyStereotypesLabel()
    {
        String stereotypes = SysMLTools.getStereotypeNotation((Dependency) getEObject());
        ((Label) ((DependencyFigure) getFigure()).getDependencyStereotypesEdgeObjectFigure()).setText(stereotypes);
    }

    /**
     * Update the name Label
     * 
     * @generated
     */
    private void updateNameLabel()
    {
        ((Label) ((DependencyFigure) getFigure()).getNameEdgeObjectFigure()).setText(((Dependency) getEObject()).getName());
    }

}