/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.parametricdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.LabelDirectEditPolicy;
import org.topcased.modeler.edit.policies.ResizableEditPolicy;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.sysml.parametricdiagram.ParametricEditPolicyConstants;
import org.topcased.modeler.sysml.parametricdiagram.commands.PropertyRestoreConnectionCommand;
import org.topcased.modeler.sysml.parametricdiagram.figures.PortLabelledFigure;
import org.topcased.modeler.sysml.parametricdiagram.figures.PropertyFigure;
import org.topcased.modeler.sysml.parametricdiagram.policies.ConnectorEdgeCreationEditPolicy;

/**
 * The Property object controller
 * 
 * @generated
 */
public class PropertyEditPart extends NamedElementEditPart
{
    /**
     * Constructor
     * 
     * @param obj the graph node
     * @generated
     */
    public PropertyEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles
     * 
     * @generated
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ParametricEditPolicyConstants.CONNECTOR_EDITPOLICY, new ConnectorEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new PropertyRestoreConnectionCommand(getHost());
            }
        });

        installEditPolicy(ModelerEditPolicyConstants.RESIZABLE_EDITPOLICY, new ResizableEditPolicy());

        installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LabelDirectEditPolicy());
    }

    /**
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated NOT
     * @author tlandre
     */
    protected IFigure createFigure()
    {
        return new PortLabelledFigure(new PropertyFigure());
    }

}