/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.modeler.sysml.providers;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.topcased.modeler.providers.ILabelFeatureProvider;
import org.topcased.sysml.util.SysMLAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support
 * Viewers. The adapters generated by this factory convert EMF adapter
 * notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets. Note that most of the
 * adapters are shared among multiple instances. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class SysMLModelerProviderAdapterFactory extends SysMLAdapterFactory implements ComposeableAdapterFactory,
        IChangeNotifier, IDisposable
{
    /**
     * This keeps track of the root adapter factory that delegates to this
     * adapter factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement
     * {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by
     * {@link #isFactoryForType isFactoryForType}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private Collection<Class<ILabelFeatureProvider>> supportedTypes = new ArrayList();

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Block} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private BlockModelerProvider blockModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.FlowPort} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private FlowPortModelerProvider flowportModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.ServicePort} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private ServicePortModelerProvider serviceportModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.FlowSpecification} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private FlowSpecificationModelerProvider flowspecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.BlockDefinition} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private BlockDefinitionModelerProvider blockdefinitionModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.PackageSYSML} instances.
     * 
     * @generated
     */
    private PackageSYSMLModelerProvider packagesysmlModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Requirement} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private RequirementModelerProvider requirementModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.TestCase} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private TestCaseModelerProvider testcaseModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.RequirementDefinition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RequirementDefinitionModelerProvider requirementdefinitionModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Satisfy} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private SatisfyModelerProvider satisfyModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.DeriveReqt} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private DeriveReqtModelerProvider derivereqtModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Verify} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private VerifyModelerProvider verifyModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Field} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private FieldModelerProvider fieldModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Rationale} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private RationaleModelerProvider rationaleModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Problem} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private ProblemModelerProvider problemModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.ValueType} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private ValueTypeModelerProvider valuetypeModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Dimension} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private DimensionModelerProvider dimensionModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Unit} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private UnitModelerProvider unitModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.BlockProperty} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private BlockPropertyModelerProvider blockpropertyModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.DistributedProperty} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DistributedPropertyModelerProvider distributedpropertyModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.ItemFlow} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private ItemFlowModelerProvider itemflowModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.FlowProperty} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private FlowPropertyModelerProvider flowpropertyModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.ConstraintBlock} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConstraintBlockModelerProvider constraintblockModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Trace} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private TraceModelerProvider traceModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Copy} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private CopyModelerProvider copyModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Refine} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private RefineModelerProvider refineModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.ConstraintProperty} instances.
     * 
     * @generated
     */
    private ConstraintPropertyModelerProvider constraintpropertyModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.Containment} instances.
     * 
     * @generated
     */
    private ContainmentModelerProvider containmentModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.RequirementRelated} instances.
     * 
     * @generated
     */
    private RequirementRelatedModelerProvider requirementrelatedModelerProvider;

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.ModelSYSML} instances.
     * 
     * @generated
     */
    private ModelSYSMLModelerProvider modelsysmlModelerProvider;

    /**
     * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    public SysMLModelerProviderAdapterFactory()
    {
        supportedTypes.add(ILabelFeatureProvider.class);
    }

    /**
     * This returns the root adapter factory that contains this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the root AdapterFactory
     * 
     * @generated
     */
    public ComposeableAdapterFactory getRootAdapterFactory()
    {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param parentAdapterFactory the new parent adapter factory
     * 
     * @generated
     */
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
    {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param type the type to test
     * @return true if supported
     * 
     * @generated
     */
    public boolean isFactoryForType(Object type)
    {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the
     * adapter. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param notifier the notifier
     * @param type the object to adapt
     * @return the Adapter the created adatper
     * 
     * @generated
     */
    public Adapter adapt(Notifier notifier, Object type)
    {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param object the object to adapt
     * @param type the type to adapt
     * @return the adapted Object
     * 
     * @generated
     */
    public Object adapt(Object object, Object type)
    {
        if (isFactoryForType(type))
        {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class) || (((Class) type).isInstance(adapter)))
            {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param notifyChangedListener the listener to add
     * 
     * @generated
     */
    public void addListener(INotifyChangedListener notifyChangedListener)
    {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param notifyChangedListener the listener to remove
     * 
     * @generated
     */
    public void removeListener(INotifyChangedListener notifyChangedListener)
    {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to
     * {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @param notification the notification to fire
     * 
     * @generated
     */
    public void fireNotifyChanged(Notification notification)
    {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null)
        {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Block}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createBlockAdapter()
    {
        if (blockModelerProvider == null)
        {
            blockModelerProvider = new BlockModelerProvider(this);
        }

        return blockModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.FlowPort}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFlowPortAdapter()
    {
        if (flowportModelerProvider == null)
        {
            flowportModelerProvider = new FlowPortModelerProvider(this);
        }

        return flowportModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.ServicePort}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createServicePortAdapter()
    {
        if (serviceportModelerProvider == null)
        {
            serviceportModelerProvider = new ServicePortModelerProvider(this);
        }

        return serviceportModelerProvider;
    }

    /**
     * This creates an adapter for a
     * {@link org.topcased.sysml.FlowSpecification}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFlowSpecificationAdapter()
    {
        if (flowspecificationModelerProvider == null)
        {
            flowspecificationModelerProvider = new FlowSpecificationModelerProvider(this);
        }

        return flowspecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.BlockDefinition}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createBlockDefinitionAdapter()
    {
        if (blockdefinitionModelerProvider == null)
        {
            blockdefinitionModelerProvider = new BlockDefinitionModelerProvider(this);
        }

        return blockdefinitionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.PackageSYSML}.
     * 
     * @return the Adapter
     * @generated
     */
    public Adapter createPackageSYSMLAdapter()
    {
        if (packagesysmlModelerProvider == null)
        {
            packagesysmlModelerProvider = new PackageSYSMLModelerProvider(this);
        }

        return packagesysmlModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Requirement}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRequirementAdapter()
    {
        if (requirementModelerProvider == null)
        {
            requirementModelerProvider = new RequirementModelerProvider(this);
        }

        return requirementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.TestCase}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTestCaseAdapter()
    {
        if (testcaseModelerProvider == null)
        {
            testcaseModelerProvider = new TestCaseModelerProvider(this);
        }

        return testcaseModelerProvider;
    }

    /**
     * This creates an adapter for a
     * {@link org.topcased.sysml.RequirementDefinition}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRequirementDefinitionAdapter()
    {
        if (requirementdefinitionModelerProvider == null)
        {
            requirementdefinitionModelerProvider = new RequirementDefinitionModelerProvider(this);
        }

        return requirementdefinitionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Satisfy}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSatisfyAdapter()
    {
        if (satisfyModelerProvider == null)
        {
            satisfyModelerProvider = new SatisfyModelerProvider(this);
        }

        return satisfyModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.DeriveReqt}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDeriveReqtAdapter()
    {
        if (derivereqtModelerProvider == null)
        {
            derivereqtModelerProvider = new DeriveReqtModelerProvider(this);
        }

        return derivereqtModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Verify}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createVerifyAdapter()
    {
        if (verifyModelerProvider == null)
        {
            verifyModelerProvider = new VerifyModelerProvider(this);
        }

        return verifyModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Field}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFieldAdapter()
    {
        if (fieldModelerProvider == null)
        {
            fieldModelerProvider = new FieldModelerProvider(this);
        }

        return fieldModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Rationale}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRationaleAdapter()
    {
        if (rationaleModelerProvider == null)
        {
            rationaleModelerProvider = new RationaleModelerProvider(this);
        }

        return rationaleModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Problem}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createProblemAdapter()
    {
        if (problemModelerProvider == null)
        {
            problemModelerProvider = new ProblemModelerProvider(this);
        }

        return problemModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.ValueType}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createValueTypeAdapter()
    {
        if (valuetypeModelerProvider == null)
        {
            valuetypeModelerProvider = new ValueTypeModelerProvider(this);
        }

        return valuetypeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Dimension}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDimensionAdapter()
    {
        if (dimensionModelerProvider == null)
        {
            dimensionModelerProvider = new DimensionModelerProvider(this);
        }

        return dimensionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Unit}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createUnitAdapter()
    {
        if (unitModelerProvider == null)
        {
            unitModelerProvider = new UnitModelerProvider(this);
        }

        return unitModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.BlockProperty}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createBlockPropertyAdapter()
    {
        if (blockpropertyModelerProvider == null)
        {
            blockpropertyModelerProvider = new BlockPropertyModelerProvider(this);
        }

        return blockpropertyModelerProvider;
    }

    /**
     * This creates an adapter for a
     * {@link org.topcased.sysml.DistributedProperty}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDistributedPropertyAdapter()
    {
        if (distributedpropertyModelerProvider == null)
        {
            distributedpropertyModelerProvider = new DistributedPropertyModelerProvider(this);
        }

        return distributedpropertyModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.ItemFlow}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createItemFlowAdapter()
    {
        if (itemflowModelerProvider == null)
        {
            itemflowModelerProvider = new ItemFlowModelerProvider(this);
        }

        return itemflowModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.FlowProperty}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFlowPropertyAdapter()
    {
        if (flowpropertyModelerProvider == null)
        {
            flowpropertyModelerProvider = new FlowPropertyModelerProvider(this);
        }

        return flowpropertyModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.ConstraintBlock}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConstraintBlockAdapter()
    {
        if (constraintblockModelerProvider == null)
        {
            constraintblockModelerProvider = new ConstraintBlockModelerProvider(this);
        }

        return constraintblockModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Trace}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTraceAdapter()
    {
        if (traceModelerProvider == null)
        {
            traceModelerProvider = new TraceModelerProvider(this);
        }

        return traceModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Copy}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCopyAdapter()
    {
        if (copyModelerProvider == null)
        {
            copyModelerProvider = new CopyModelerProvider(this);
        }

        return copyModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Refine}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRefineAdapter()
    {
        if (refineModelerProvider == null)
        {
            refineModelerProvider = new RefineModelerProvider(this);
        }

        return refineModelerProvider;
    }

    /**
     * This creates an adapter for a
     * {@link org.topcased.sysml.ConstraintProperty}.
     * 
     * @return the Adapter
     * @generated
     */
    public Adapter createConstraintPropertyAdapter()
    {
        if (constraintpropertyModelerProvider == null)
        {
            constraintpropertyModelerProvider = new ConstraintPropertyModelerProvider(this);
        }

        return constraintpropertyModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Containment}.
     * 
     * @return the Adapter
     * @generated
     */
    public Adapter createContainmentAdapter()
    {
        if (containmentModelerProvider == null)
        {
            containmentModelerProvider = new ContainmentModelerProvider(this);
        }

        return containmentModelerProvider;
    }

    /**
     * This creates an adapter for a
     * {@link org.topcased.sysml.RequirementRelated}.
     * 
     * @return the Adapter
     * @generated
     */
    public Adapter createRequirementRelatedAdapter()
    {
        if (requirementrelatedModelerProvider == null)
        {
            requirementrelatedModelerProvider = new RequirementRelatedModelerProvider(this);
        }

        return requirementrelatedModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.topcased.sysml.ModelSYSML}.
     * 
     * @return the Adapter
     * @generated
     */
    public Adapter createModelSYSMLAdapter()
    {
        if (modelsysmlModelerProvider == null)
        {
            modelsysmlModelerProvider = new ModelSYSMLModelerProvider(this);
        }

        return modelsysmlModelerProvider;
    }

    /**
     * This disposes all of the item providers created by this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void dispose()
    {
        if (blockModelerProvider != null)
        {
            blockModelerProvider.dispose();
        }
        if (flowportModelerProvider != null)
        {
            flowportModelerProvider.dispose();
        }
        if (serviceportModelerProvider != null)
        {
            serviceportModelerProvider.dispose();
        }
        if (flowspecificationModelerProvider != null)
        {
            flowspecificationModelerProvider.dispose();
        }
        if (blockdefinitionModelerProvider != null)
        {
            blockdefinitionModelerProvider.dispose();
        }
        if (packagesysmlModelerProvider != null)
        {
            packagesysmlModelerProvider.dispose();
        }
        if (requirementModelerProvider != null)
        {
            requirementModelerProvider.dispose();
        }
        if (testcaseModelerProvider != null)
        {
            testcaseModelerProvider.dispose();
        }
        if (requirementdefinitionModelerProvider != null)
        {
            requirementdefinitionModelerProvider.dispose();
        }
        if (satisfyModelerProvider != null)
        {
            satisfyModelerProvider.dispose();
        }
        if (derivereqtModelerProvider != null)
        {
            derivereqtModelerProvider.dispose();
        }
        if (verifyModelerProvider != null)
        {
            verifyModelerProvider.dispose();
        }
        if (fieldModelerProvider != null)
        {
            fieldModelerProvider.dispose();
        }
        if (rationaleModelerProvider != null)
        {
            rationaleModelerProvider.dispose();
        }
        if (problemModelerProvider != null)
        {
            problemModelerProvider.dispose();
        }
        if (valuetypeModelerProvider != null)
        {
            valuetypeModelerProvider.dispose();
        }
        if (dimensionModelerProvider != null)
        {
            dimensionModelerProvider.dispose();
        }
        if (unitModelerProvider != null)
        {
            unitModelerProvider.dispose();
        }
        if (blockpropertyModelerProvider != null)
        {
            blockpropertyModelerProvider.dispose();
        }
        if (distributedpropertyModelerProvider != null)
        {
            distributedpropertyModelerProvider.dispose();
        }
        if (itemflowModelerProvider != null)
        {
            itemflowModelerProvider.dispose();
        }
        if (flowpropertyModelerProvider != null)
        {
            flowpropertyModelerProvider.dispose();
        }
        if (constraintblockModelerProvider != null)
        {
            constraintblockModelerProvider.dispose();
        }
        if (traceModelerProvider != null)
        {
            traceModelerProvider.dispose();
        }
        if (copyModelerProvider != null)
        {
            copyModelerProvider.dispose();
        }
        if (refineModelerProvider != null)
        {
            refineModelerProvider.dispose();
        }
        if (constraintpropertyModelerProvider != null)
        {
            constraintpropertyModelerProvider.dispose();
        }
        if (containmentModelerProvider != null)
        {
            containmentModelerProvider.dispose();
        }
        if (requirementrelatedModelerProvider != null)
        {
            requirementrelatedModelerProvider.dispose();
        }
        if (modelsysmlModelerProvider != null)
        {
            modelsysmlModelerProvider.dispose();
        }
    }

}
