/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram;

import java.net.URL;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.gef.EditPartFactory;
import org.topcased.modeler.editor.IConfiguration;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.IPaletteManager;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.graphconf.exceptions.MissingGraphConfFileException;
import org.topcased.modeler.sysml.requirementdiagram.edit.CommentEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.ContainmentEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.CopyEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.DeriveReqtEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.ElementEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.FieldEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.NamedElementEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.ProblemEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.RationaleEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.RefineEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.RequirementEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.SatisfyEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.TestCaseEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.TraceEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.VerifyEditPart;

/**
 * A diagram configuration : manages Palette, EditPartFactory for this diagram.
 * <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class RequirementConfiguration implements IConfiguration
{
    private RequirementPaletteManager paletteManager;

    private RequirementEditPartFactory editPartFactory;

    private RequirementCreationUtils creationUtils;

    /**
     * The DiagramGraphConf that contains graphical informations on the
     * configuration
     */
    private DiagramGraphConf diagramGraphConf;

    /**
     * Constructor. Initialize Adapter factories.
     * 
     * @generated
     */
    public RequirementConfiguration()
    {
        registerAdapters();
    }

    /**
     * Registers the Adapter Factories for all the EditParts
     * 
     * @generated
     */
    private void registerAdapters()
    {
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(RequirementEditPart.class, org.topcased.sysml.Requirement.class),
                RequirementEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(TestCaseEditPart.class, org.topcased.sysml.TestCase.class),
                TestCaseEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(NamedElementEditPart.class, org.eclipse.uml2.uml.NamedElement.class),
                NamedElementEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ContainmentEditPart.class, org.topcased.sysml.Containment.class),
                ContainmentEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(SatisfyEditPart.class, org.topcased.sysml.Satisfy.class),
                SatisfyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(DeriveReqtEditPart.class, org.topcased.sysml.DeriveReqt.class),
                DeriveReqtEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(VerifyEditPart.class, org.topcased.sysml.Verify.class),
                VerifyEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(FieldEditPart.class, org.topcased.sysml.Field.class),
                FieldEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(CommentEditPart.class, org.eclipse.uml2.uml.Comment.class),
                CommentEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ElementEditPart.class, org.eclipse.uml2.uml.Element.class),
                ElementEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(ProblemEditPart.class, org.topcased.sysml.Problem.class),
                ProblemEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(RationaleEditPart.class, org.topcased.sysml.Rationale.class),
                RationaleEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(RefineEditPart.class, org.topcased.sysml.Refine.class),
                RefineEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(TraceEditPart.class, org.topcased.sysml.Trace.class),
                TraceEditPart.class);
        Platform.getAdapterManager().registerAdapters(
                new EditPart2ModelAdapterFactory(CopyEditPart.class, org.topcased.sysml.Copy.class), CopyEditPart.class);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getId()
     * @generated
     */
    public String getId()
    {
        return new String("org.topcased.modeler.sysml.requirementdiagram");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getName()
     * @generated
     */
    public String getName()
    {
        return new String("Requirement diagram");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getEditPartFactory()
     * @generated
     */
    public EditPartFactory getEditPartFactory()
    {
        if (editPartFactory == null)
        {
            editPartFactory = new RequirementEditPartFactory();
        }

        return editPartFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getPaletteManager()
     * @generated
     */
    public IPaletteManager getPaletteManager()
    {
        if (paletteManager == null)
        {
            paletteManager = new RequirementPaletteManager(getCreationUtils());
        }

        return paletteManager;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getCreationUtils()
     * @generated
     */
    public ICreationUtils getCreationUtils()
    {
        if (creationUtils == null)
        {
            creationUtils = new RequirementCreationUtils(getDiagramGraphConf());
        }

        return creationUtils;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getDiagramGraphConf()
     * @generated
     */
    public DiagramGraphConf getDiagramGraphConf()
    {
        if (diagramGraphConf == null)
        {
            URL url = RequirementPlugin.getDefault().getBundle().getResource(
                    "org/topcased/modeler/sysml/requirementdiagram/diagram.graphconf");
            if (url != null)
            {
                URI fileURI = URI.createURI(url.toString());
                ResourceSet resourceSet = new ResourceSetImpl();
                Resource resource = resourceSet.getResource(fileURI, true);
                if (resource != null && resource.getContents().get(0) instanceof DiagramGraphConf)
                {
                    diagramGraphConf = (DiagramGraphConf) resource.getContents().get(0);
                }
            }
            else
            {
                new MissingGraphConfFileException(
                        "The *.diagramgraphconf file can not be retrieved. Check if the path is correct in the Configuration class of your diagram.");
            }
        }

        return diagramGraphConf;
    }

}