/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.NamedElement;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.sysml.Containment;
import org.topcased.sysml.Copy;
import org.topcased.sysml.DeriveReqt;
import org.topcased.sysml.Field;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.Refine;
import org.topcased.sysml.Requirement;
import org.topcased.sysml.Satisfy;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.TestCase;
import org.topcased.sysml.Trace;
import org.topcased.sysml.Verify;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model
 * Object <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class RequirementCreationUtils extends AbstractCreationUtils
{

    /**
     * Constructor
     * 
     * @param diagramConf the Diagram Graphical Configuration
     */
    public RequirementCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * @generated
     */
    private class GraphicSysMLSwitch extends SysMLSwitch<Object>
    {
        /**
         * The presentation of the graphical element
         * 
         * @generated
         */
        private String presentation;

        /**
         * Constructor
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicSysMLSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRequirement(org.topcased.sysml.Requirement)
         * @generated
         */
        public Object caseRequirement(org.topcased.sysml.Requirement object)
        {
                return createGraphElementRequirement(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseField(org.topcased.sysml.Field)
         * @generated
         */
        public Object caseField(org.topcased.sysml.Field object)
        {
                return createGraphElementField(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseTestCase(org.topcased.sysml.TestCase)
         * @generated
         */
        public Object caseTestCase(org.topcased.sysml.TestCase object)
        {
                return createGraphElementTestCase(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseContainment(org.topcased.sysml.Containment)
         * @generated
         */
        public Object caseContainment(org.topcased.sysml.Containment object)
        {
                return createGraphElementContainment(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseSatisfy(org.topcased.sysml.Satisfy)
         * @generated
         */
        public Object caseSatisfy(org.topcased.sysml.Satisfy object)
        {
                return createGraphElementSatisfy(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDeriveReqt(org.topcased.sysml.DeriveReqt)
         * @generated
         */
        public Object caseDeriveReqt(org.topcased.sysml.DeriveReqt object)
        {
                return createGraphElementDeriveReqt(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseVerify(org.topcased.sysml.Verify)
         * @generated
         */
        public Object caseVerify(org.topcased.sysml.Verify object)
        {
            return createGraphElementVerify(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRefine(org.topcased.sysml.Refine)
         * @generated
         */
        public Object caseRefine(org.topcased.sysml.Refine object)
        {
                return createGraphElementRefine(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseCopy(org.topcased.sysml.Copy)
         * @generated
         */
        public Object caseCopy(org.topcased.sysml.Copy object)
        {
                return createGraphElementCopy(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseTrace(org.topcased.sysml.Trace)
         * @generated
         */
        public Object caseTrace(org.topcased.sysml.Trace object)
        {
                return createGraphElementTrace(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         * @generated
         */
        public Object caseRationale(org.topcased.sysml.Rationale object)
        {
                return createGraphElementRationale(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         * @generated
         */
        public Object caseProblem(org.topcased.sysml.Problem object)
        {
                return createGraphElementProblem(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         *      Added to enable to add Comment to the diagram
         */
        public Object caseComment(org.eclipse.uml2.uml.Comment object)
        {
            return createGraphElementComment(object, presentation);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseNamedElement(org.eclipse.uml2.uml.NamedElement)
         *      Added to enable to add NamedElement to the diagram
         */
        public Object caseNamedElement(NamedElement object)
        {
            return createGraphElementNamedElement((NamedElement) object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;
        graphElt = new GraphicSysMLSwitch(presentation).doSwitch(obj);

        return (GraphElement) graphElt;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementRequirement(org.topcased.sysml.Requirement element, String presentation)
    {
        // TODO this snippet of code should be customized if it is not well
        // generated
        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode field = createGraphNode(element, SysMLPackage.REQUIREMENT__EXTENDED_FIELD, presentation);
        field.setContainer(nodeParent);

        return nodeParent;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementField(org.topcased.sysml.Field element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementTestCase(org.topcased.sysml.TestCase element, String presentation)
    {
        // TODO this snippet of code should be customized if it is not well
        // generated
        GraphNode nodeParent = createGraphNode(element, presentation);

        return nodeParent;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementContainment(org.topcased.sysml.Containment element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementSatisfy(org.topcased.sysml.Satisfy element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset satisfystereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        satisfystereotypeEdgeObjectOffset.setId(RequirementEdgeObjectConstants.SATISFYSTEREOTYPE_EDGE_OBJECT_ID);
        satisfystereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(satisfystereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDeriveReqt(org.topcased.sysml.DeriveReqt element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset derivereqtstereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        derivereqtstereotypeEdgeObjectOffset.setId(RequirementEdgeObjectConstants.DERIVEREQTSTEREOTYPE_EDGE_OBJECT_ID);
        derivereqtstereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(derivereqtstereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementVerify(org.topcased.sysml.Verify element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset verifystereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        verifystereotypeEdgeObjectOffset.setId(RequirementEdgeObjectConstants.VERIFYSTEREOTYPE_EDGE_OBJECT_ID);
        verifystereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(verifystereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementRefine(org.topcased.sysml.Refine element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset refinestereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        refinestereotypeEdgeObjectOffset.setId(RequirementEdgeObjectConstants.REFINESTEREOTYPE_EDGE_OBJECT_ID);
        refinestereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(refinestereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementCopy(org.topcased.sysml.Copy element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset copystereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        copystereotypeEdgeObjectOffset.setId(RequirementEdgeObjectConstants.COPYSTEREOTYPE_EDGE_OBJECT_ID);
        copystereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(copystereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementTrace(org.topcased.sysml.Trace element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset tracestereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        tracestereotypeEdgeObjectOffset.setId(RequirementEdgeObjectConstants.TRACESTEREOTYPE_EDGE_OBJECT_ID);
        tracestereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(tracestereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComment(org.eclipse.uml2.uml.Comment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementRationale(org.topcased.sysml.Rationale element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementProblem(org.topcased.sysml.Problem element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> Enable to add external NamedElement to the
     * diagram <!-- end-user-doc -->
     * 
     * @param element
     * @return the complete GraphElement
     * @generated NOT
     */
    public GraphElement createGraphElementNamedElement(NamedElement element)
    {
        GraphNode nodeParent = createGraphNode(element);

        return nodeParent;
    }

    private class ModelSwitch extends SysMLSwitch<Object>

    {
        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRequirement(org.topcased.sysml.Requirement)
         */
        public Object caseRequirement(Requirement object)
        {
            return createModelObjectRequirement(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseField(org.topcased.sysml.Field)
         */
        public Object caseField(Field object)
        {
            return createModelObjectField(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseTestCase(org.topcased.sysml.TestCase)
         */
        public Object caseTestCase(TestCase object)
        {
            return createModelObjectTestCase(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseSatisfy(org.topcased.sysml.Satisfy)
         */
        public Object caseSatisfy(Satisfy object)
        {
            return createModelObjectSatisfy(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDeriveReqt(org.topcased.sysml.DeriveReqt)
         */
        public Object caseDeriveReqt(DeriveReqt object)
        {
            return createModelObjectDeriveReqt(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseVerify(org.topcased.sysml.Verify)
         */
        public Object caseVerify(Verify object)
        {
            return createModelObjectVerify(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRefine(org.topcased.sysml.Refine)
         */
        public Object caseRefine(Refine object)
        {
            return createModelObjectRefine(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseCopy(org.topcased.sysml.Copy)
         */
        public Object caseCopy(Copy object)
        {
            return createModelObjectCopy(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseTrace(org.topcased.sysml.Trace)
         */
        public Object caseTrace(Trace object)
        {
            return createModelObjectTrace(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseComment(Comment object)
        {
            return createModelObjectComment(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         */
        public Object caseRationale(Rationale object)
        {
            return createModelObjectRationale(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         */
        public Object caseProblem(Problem object)
        {
            return createModelObjectProblem(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseContainment(org.topcased.sysml.Containment)
         */
        public Object caseContainment(Containment object)
        {
            return createModelObjectContainment(object);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     */
    public EObject createModelObject(EObject obj)
    {
        Object eObject = new ModelSwitch().doSwitch(obj);
        return (EObject) eObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     * @generated NOT
     */
    protected Requirement createModelObjectRequirement(Requirement element)
    {
        element.setIsAbstract(true);
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Field createModelObjectField(Field element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected TestCase createModelObjectTestCase(TestCase element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Satisfy createModelObjectSatisfy(Satisfy element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected DeriveReqt createModelObjectDeriveReqt(DeriveReqt element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Verify createModelObjectVerify(Verify element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Refine createModelObjectRefine(Refine element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Copy createModelObjectCopy(Copy element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Trace createModelObjectTrace(Trace element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Comment createModelObjectComment(Comment element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Rationale createModelObjectRationale(Rationale element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Problem createModelObjectProblem(Problem element)
    {
        return element;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the original model element
     * @return the complete Model Object
     */
    protected Containment createModelObjectContainment(Containment element)
    {
        return element;
    }

}
