/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.NamedElement;
import org.topcased.modeler.ModelerPropertyConstants;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.di.model.SimpleSemanticModelElement;
import org.topcased.modeler.di.model.util.DIUtils;
import org.topcased.modeler.edit.EListEditPart;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.EMFGraphNodeEditPart;
import org.topcased.modeler.edit.GraphEdgeEditPart;
import org.topcased.modeler.edit.GraphNodeEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.CommentEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.CommentLinkEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.ContainmentEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.CopyEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.DeriveReqtEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.ElementEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.FieldEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.FieldListEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.NamedElementEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.ProblemEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.RationaleEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.RefineEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.RequirementDiagramEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.RequirementEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.SatisfyEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.TestCaseEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.TraceEditPart;
import org.topcased.modeler.sysml.requirementdiagram.edit.VerifyEditPart;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.Copy;
import org.topcased.sysml.DeriveReqt;
import org.topcased.sysml.Field;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.Refine;
import org.topcased.sysml.Requirement;
import org.topcased.sysml.Satisfy;
import org.topcased.sysml.TestCase;
import org.topcased.sysml.Trace;
import org.topcased.sysml.Verify;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * Part Factory : associates a model object to its controller. <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class RequirementEditPartFactory implements EditPartFactory
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,java.lang.Object)
     * @generated NOT
     */
    public EditPart createEditPart(EditPart context, Object model)
    {
        if (model instanceof Diagram)
        {
            return new RequirementDiagramEditPart((Diagram) model);
        }
        else if (model instanceof GraphNode)
        {
            final GraphNode node = (GraphNode) model;
            EObject element = Utils.getElement(node);
            if (element != null)
            {
                Object editPart = new SysMLSwitch<Object>()
                {
                    public Object caseRequirement(Requirement object)
                    {
                        String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
                        if (!"".equals(feature))
                        {
                            int featureID = Integer.parseInt(feature);
                            // FieldListEditPart doesn't have the same figure
                            // than a EListEditPart
                            return new FieldListEditPart(node, object.eClass().getEStructuralFeature(featureID));
                        }
                        else
                        {
                            return new RequirementEditPart(node);
                        }
                    }

                    public Object caseTestCase(TestCase object)
                    {
                        String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
                        if (!"".equals(feature))
                        {
                            int featureID = Integer.parseInt(feature);
                            return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
                        }
                        else
                        {
                            return new TestCaseEditPart(node);
                        }
                    }

                    public Object caseNamedElement(NamedElement object)
                    {
                        String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
                        if (!"".equals(feature))
                        {
                            int featureID = Integer.parseInt(feature);
                            return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
                        }
                        else
                        {
                            return new NamedElementEditPart(node);
                        }
                    }

                    public Object caseField(Field object)
                    {
                        return new FieldEditPart(node);
                    }

                    public Object caseComment(Comment object)
                    {
                        return new CommentEditPart(node);
                    }

                    public Object caseElement(Element object)
                    {
                        return new ElementEditPart(node);
                    }

                    public Object caseProblem(Problem object)
                    {
                        return new ProblemEditPart(node);
                    }

                    public Object caseRationale(Rationale object)
                    {
                        return new RationaleEditPart(node);
                    }

                    public Object defaultCase(EObject object)
                    {
                        return new EMFGraphNodeEditPart(node);
                    }
                }.doSwitch(element);

                return (EditPart) editPart;
            }

            if (node.getSemanticModel() instanceof SimpleSemanticModelElement)
            {
            }
            return new GraphNodeEditPart(node);
        }
        else if (model instanceof GraphEdge)
        {
            final GraphEdge edge = (GraphEdge) model;
            EObject element = Utils.getElement(edge);
            if (element != null)
            {
                Object editPart = new SysMLSwitch<Object>()
                {
                    public Object caseSatisfy(Satisfy object)
                    {
                        return new SatisfyEditPart(edge);
                    }

                    public Object caseDeriveReqt(DeriveReqt object)
                    {
                        return new DeriveReqtEditPart(edge);
                    }

                    public Object caseVerify(Verify object)
                    {
                        return new VerifyEditPart(edge);
                    }

                    public Object caseRefine(Refine object)
                    {
                        return new RefineEditPart(edge);
                    }

                    public Object caseTrace(Trace object)
                    {
                        return new TraceEditPart(edge);
                    }

                    public Object caseCopy(Copy object)
                    {
                        return new CopyEditPart(edge);
                    }

                    public Object caseContainment(org.topcased.sysml.Containment object)
                    {
                        return new ContainmentEditPart(edge);
                    }

                    public Object defaultCase(EObject object)
                    {
                        return new EMFGraphEdgeEditPart(edge);
                    }
                }.doSwitch(element);

                return (EditPart) editPart;
            }

            if (edge.getSemanticModel() instanceof SimpleSemanticModelElement)
            {
                if (RequirementSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK.equals(((SimpleSemanticModelElement) edge.getSemanticModel()).getTypeInfo()))
                    return new CommentLinkEditPart(edge);
            }

            return new GraphEdgeEditPart((GraphEdge) model);
        }

        throw new IllegalStateException("No edit part matches with the '" + model.getClass().getName()
                + "' model element. Check RequirementEditPartFactory#createEditPart(EditPart,Object) class");
    }

    /**
     * @generated
     */
    private class NodeSysMLSwitch extends SysMLSwitch
    {
        /**
         * The graphical node
         * 
         * @generated
         */
        private GraphNode node;

        /**
         * Constructor
         * 
         * @param node the graphical node
         * @generated
         */
        public NodeSysMLSwitch(GraphNode node)
        {
            this.node = node;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRequirement(org.topcased.sysml.Requirement)
         * @generated
         */
        public Object caseRequirement(org.topcased.sysml.Requirement object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new RequirementEditPart(node);
            }
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseTestCase(org.topcased.sysml.TestCase)
         * @generated
         */
        public Object caseTestCase(org.topcased.sysml.TestCase object)
        {
            String feature = DIUtils.getPropertyValue(node, ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID);
            if (!"".equals(feature))
            {
                int featureID = Integer.parseInt(feature);
                return new EListEditPart(node, object.eClass().getEStructuralFeature(featureID));
            }
            else
            {
                return new TestCaseEditPart(node);
            }
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseField(org.topcased.sysml.Field)
         * @generated
         */
        public Object caseField(org.topcased.sysml.Field object)
        {
            return new FieldEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseProblem(org.topcased.sysml.Problem)
         * @generated
         */
        public Object caseProblem(org.topcased.sysml.Problem object)
        {
            return new ProblemEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRationale(org.topcased.sysml.Rationale)
         * @generated
         */
        public Object caseRationale(org.topcased.sysml.Rationale object)
        {
            return new RationaleEditPart(node);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return new EMFGraphNodeEditPart(node);
        }
    }

    /**
     * @generated
     */
    private class EdgeSysMLSwitch extends SysMLSwitch
    {
        /**
         * The graphical edge
         * 
         * @generated
         */
        private GraphEdge edge;

        /**
         * Constructor
         * 
         * @param edge the graphical edge
         * @generated
         */
        public EdgeSysMLSwitch(GraphEdge edge)
        {
            this.edge = edge;
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseContainment(org.topcased.sysml.Containment)
         * @generated
         */
        public Object caseContainment(org.topcased.sysml.Containment object)
        {
            return new ContainmentEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseSatisfy(org.topcased.sysml.Satisfy)
         * @generated
         */
        public Object caseSatisfy(org.topcased.sysml.Satisfy object)
        {
            return new SatisfyEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseDeriveReqt(org.topcased.sysml.DeriveReqt)
         * @generated
         */
        public Object caseDeriveReqt(org.topcased.sysml.DeriveReqt object)
        {
            return new DeriveReqtEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseVerify(org.topcased.sysml.Verify)
         * @generated
         */
        public Object caseVerify(org.topcased.sysml.Verify object)
        {
            return new VerifyEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseRefine(org.topcased.sysml.Refine)
         * @generated
         */
        public Object caseRefine(org.topcased.sysml.Refine object)
        {
            return new RefineEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseTrace(org.topcased.sysml.Trace)
         * @generated
         */
        public Object caseTrace(org.topcased.sysml.Trace object)
        {
            return new TraceEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#caseCopy(org.topcased.sysml.Copy)
         * @generated
         */
        public Object caseCopy(org.topcased.sysml.Copy object)
        {
            return new CopyEditPart(edge);
        }

        /**
         * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return new EMFGraphEdgeEditPart(edge);
        }
    }

}