/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;
import org.topcased.sysml.SysMLPackage;

/**
 * Generated Palette Manager <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class RequirementPaletteManager extends ModelerPaletteManager
{
    // declare all the palette categories of the diagram
    private PaletteDrawer objectsDrawer;

    private PaletteDrawer connectionsDrawer;

    private PaletteDrawer commentsDrawer;

    private ICreationUtils creationUtils;

    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param utils the creation utils for the tools of the palette
     * @generated
     */
    public RequirementPaletteManager(ICreationUtils utils)
    {
        super();
        this.creationUtils = utils;
    }

    /**
     * Creates the main categories of the palette <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected void createCategories()
    {
        createObjectsDrawer();
        createConnectionsDrawer();
        createCommentsDrawer();
    }

    /**
     * Updates the main categories of the palette <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected void updateCategories()
    {
        // deletion of the existing categories and creation of the updated
        // categories

        getRoot().remove(objectsDrawer);
        createObjectsDrawer();

        getRoot().remove(connectionsDrawer);
        createConnectionsDrawer();

        getRoot().remove(commentsDrawer);
        createCommentsDrawer();
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createObjectsDrawer()
    {
        objectsDrawer = new PaletteDrawer("Objects", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getRequirement(), "default");
        entries.add(new ModelerCreationToolEntry("Requirement", "Requirement", factory,
                RequirementImageRegistry.getImageDescriptor("REQUIREMENT"),
                RequirementImageRegistry.getImageDescriptor("REQUIREMENT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getField(), "default");
        entries.add(new ModelerCreationToolEntry("Requirement Field", "Requirement Field", factory,
                RequirementImageRegistry.getImageDescriptor("FIELD"),
                RequirementImageRegistry.getImageDescriptor("FIELD_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getTestCase(), "default");
        entries.add(new ModelerCreationToolEntry("Test Case", "Test Case", factory,
                RequirementImageRegistry.getImageDescriptor("TESTCASE"),
                RequirementImageRegistry.getImageDescriptor("TESTCASE_LARGE")));

        objectsDrawer.addAll(entries);
        getRoot().add(objectsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createConnectionsDrawer()
    {
        connectionsDrawer = new PaletteDrawer("Connections", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getContainment(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Containment", "Containment", factory,
                RequirementImageRegistry.getImageDescriptor("CONTAINMENT"),
                RequirementImageRegistry.getImageDescriptor("CONTAINMENT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getSatisfy(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Satisfy", "Satisfy", factory,
                RequirementImageRegistry.getImageDescriptor("SATISFY"),
                RequirementImageRegistry.getImageDescriptor("SATISFY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getDeriveReqt(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("DeriveReqt", "DeriveReqt", factory,
                RequirementImageRegistry.getImageDescriptor("DERIVEREQT"),
                RequirementImageRegistry.getImageDescriptor("DERIVEREQT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getVerify(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Verify", "Verify", factory,
                RequirementImageRegistry.getImageDescriptor("VERIFY"),
                RequirementImageRegistry.getImageDescriptor("VERIFY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getRefine(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Refine", "Refine", factory,
                RequirementImageRegistry.getImageDescriptor("REFINE"),
                RequirementImageRegistry.getImageDescriptor("REFINE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getCopy(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Copy", "Copy", factory,
                RequirementImageRegistry.getImageDescriptor("COPY"),
                RequirementImageRegistry.getImageDescriptor("COPY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getTrace(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Trace", "Trace", factory,
                RequirementImageRegistry.getImageDescriptor("TRACE"),
                RequirementImageRegistry.getImageDescriptor("TRACE_LARGE")));

        connectionsDrawer.addAll(entries);
        getRoot().add(connectionsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each
     * figure. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private void createCommentsDrawer()
    {
        commentsDrawer = new PaletteDrawer("Comments", null);
        List entries = new ArrayList();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getComment(), "default");
        entries.add(new ModelerCreationToolEntry("Comment", "Comment", factory,
                RequirementImageRegistry.getImageDescriptor("COMMENT"),
                RequirementImageRegistry.getImageDescriptor("COMMENT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getRationale(), "default");
        entries.add(new ModelerCreationToolEntry("Rationale", "Rationale", factory,
                RequirementImageRegistry.getImageDescriptor("RATIONALE"),
                RequirementImageRegistry.getImageDescriptor("RATIONALE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, SysMLPackage.eINSTANCE.getProblem(), "default");
        entries.add(new ModelerCreationToolEntry("Problem", "Problem", factory,
                RequirementImageRegistry.getImageDescriptor("PROBLEM"),
                RequirementImageRegistry.getImageDescriptor("PROBLEM_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils,
                RequirementSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK, "default", false);
        entries.add(new ModelerConnectionCreationToolEntry("Comment Link", "Comment Link", factory,
                RequirementImageRegistry.getImageDescriptor("COMMENTLINK"),
                RequirementImageRegistry.getImageDescriptor("COMMENTLINK_LARGE")));

        commentsDrawer.addAll(entries);
        getRoot().add(commentsDrawer);
    }

}
