/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.draw2d.geometry.PointList;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.sysml.requirementdiagram.RequirementEditPolicyConstants;
import org.topcased.modeler.sysml.requirementdiagram.figures.ContainmentFigure;
import org.topcased.modeler.sysml.requirementdiagram.policies.CommentLinkEdgeCreationEditPolicy;

/**
 * Containment controller <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ContainmentEditPart extends EMFGraphEdgeEditPart
{

    /**
     * Constructort <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the graph object
     * @generated
     */
    public ContainmentEditPart(GraphEdge model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#createEditPolicies()
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        // Add a CommentLink Policy to this element
        installEditPolicy(RequirementEditPolicyConstants.COMMENTLINK_EDITPOLICY,
                new CommentLinkEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.CHANGE_FONT_EDITPOLICY, null);

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Figure
     * @generated NOT
     */
    protected IFigure createFigure()
    {
        ContainmentFigure connection = new ContainmentFigure();
        createSourceDecoration(connection);
        return connection;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param connection the PolylineConnection
     * @generated NOT
     */
    private void createSourceDecoration(PolylineConnection connection)
    {

        PolylineDecoration decoration = new PolylineDecoration();
        PointList decorationPointList = new PointList();

        // Circle and cross drawing
        decorationPointList.addPoint(-5, 5);
        decorationPointList.addPoint(-2, 4);
        decorationPointList.addPoint(-1, 3);
        decorationPointList.addPoint(0, 0);
        decorationPointList.addPoint(-1, -3);
        decorationPointList.addPoint(-2, -4);
        decorationPointList.addPoint(-5, -5);
        decorationPointList.addPoint(-5, 5);
        decorationPointList.addPoint(-8, 4);
        decorationPointList.addPoint(-9, 3);
        decorationPointList.addPoint(-10, 0);
        decorationPointList.addPoint(-9, -3);
        decorationPointList.addPoint(-8, -4);
        decorationPointList.addPoint(-5, -5);

        decoration.setTemplate(decorationPointList);
        decoration.setScale(1, 1);
        connection.setSourceDecoration(decoration);

    }

}