/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.swt.SWT;
import org.topcased.draw2d.figures.Label;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.EdgeObject;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.policies.EdgeObjectOffsetEditPolicy;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.sysml.requirementdiagram.RequirementEdgeObjectConstants;
import org.topcased.modeler.sysml.requirementdiagram.RequirementEditPolicyConstants;
import org.topcased.modeler.sysml.requirementdiagram.figures.CopyFigure;
import org.topcased.modeler.sysml.requirementdiagram.policies.CommentLinkEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.util.SysMLTools;
import org.topcased.sysml.Copy;

/**
 * Copy controller <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class CopyEditPart extends EMFGraphEdgeEditPart
{

    private static final int LINE_ON = 10;

    private static final int LINE_OFF = 5;

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the graph object
     * @generated
     */
    public CopyEditPart(GraphEdge model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        // Add a CommentLink Policy to this element
        installEditPolicy(RequirementEditPolicyConstants.COMMENTLINK_EDITPOLICY,
                new CommentLinkEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_OFFSET_EDITPOLICY, new EdgeObjectOffsetEditPolicy());

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Figure
     * @generated
     */
    protected IFigure createFigureGen()
    {
        CopyFigure connection = new CopyFigure();

        createTargetDecoration(connection);

        return connection;
    }

    /**
     * customize the line
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    protected IFigure createFigure()
    {
        CopyFigure connection = (CopyFigure) createFigureGen();
        connection.setLineStyle(SWT.LINE_CUSTOM);
        connection.setLineDash(new int[] {LINE_ON, LINE_OFF});
        return connection;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param connection the PolylineConnection
     * @generated
     */
    private void createTargetDecoration(PolylineConnection connection)
    {

        PolylineDecoration decoration = new PolylineDecoration();
        decoration.setScale(10, 5);
        connection.setTargetDecoration(decoration);

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#getEdgeObjectFigure(org.topcased.modeler.di.model.EdgeObject)
     * @generated
     */
    public IEdgeObjectFigure getEdgeObjectFigure(EdgeObject edgeObject)
    {
        if (RequirementEdgeObjectConstants.COPYSTEREOTYPE_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((CopyFigure) getFigure()).getCopyStereotypeEdgeObjectFigure();
        }
        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#refreshEdgeObjects()
     * @generated
     */
    protected void refreshEdgeObjects()
    {
        super.refreshEdgeObjects();
        updateCopyStereotypeLabel();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the copyStereotype
     * Label
     * 
     * @generated NOT
     */
    private void updateCopyStereotypeLabel()
    {
        String stereotypes = SysMLTools.getStereotypesList((Copy) getEObject());
        if (stereotypes.length() != 0)
        {
            stereotypes = ", " + stereotypes;
        }
        stereotypes = "<<copy" + stereotypes + ">>";
        ((Label) ((CopyFigure) getFigure()).getCopyStereotypeEdgeObjectFigure()).setText(stereotypes);
    }

}