/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.swt.SWT;
import org.topcased.draw2d.figures.Label;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.EdgeObject;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.policies.EdgeObjectOffsetEditPolicy;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.sysml.requirementdiagram.RequirementEdgeObjectConstants;
import org.topcased.modeler.sysml.requirementdiagram.RequirementEditPolicyConstants;
import org.topcased.modeler.sysml.requirementdiagram.figures.DeriveReqtFigure;
import org.topcased.modeler.sysml.requirementdiagram.policies.CommentLinkEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.util.SysMLTools;
import org.topcased.sysml.DeriveReqt;

/**
 * DeriveReqt controller <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class DeriveReqtEditPart extends EMFGraphEdgeEditPart
{

    private static final int LINE_ON = 10;

    private static final int LINE_OFF = 5;

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the graph object
     * @generated
     */
    public DeriveReqtEditPart(GraphEdge model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
        // Add a CommentLink Policy to this element
        installEditPolicy(RequirementEditPolicyConstants.COMMENTLINK_EDITPOLICY,
                new CommentLinkEdgeCreationEditPolicy());
        installEditPolicy(ModelerEditPolicyConstants.EDGE_OBJECTS_OFFSET_EDITPOLICY, new EdgeObjectOffsetEditPolicy());

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Figure
     * @generated
     */
    protected IFigure createFigureGen()
    {
        DeriveReqtFigure connection = new DeriveReqtFigure();

        createTargetDecoration(connection);

        return connection;
    }

    /**
     * customize the line
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    protected IFigure createFigure()
    {
        DeriveReqtFigure connection = (DeriveReqtFigure) createFigureGen();
        connection.setLineStyle(SWT.LINE_CUSTOM);
        connection.setLineDash(new int[] {LINE_ON, LINE_OFF});
        return connection;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param connection the PolylineConnection
     * @generated
     */
    private void createTargetDecoration(PolylineConnection connection)
    {

        PolylineDecoration decoration = new PolylineDecoration();
        decoration.setScale(10, 5);
        connection.setTargetDecoration(decoration);

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#getEdgeObjectFigure(org.topcased.modeler.di.model.EdgeObject)
     * @generated
     */
    public IEdgeObjectFigure getEdgeObjectFigure(EdgeObject edgeObject)
    {
        if (RequirementEdgeObjectConstants.DERIVEREQTSTEREOTYPE_EDGE_OBJECT_ID.equals(edgeObject.getId()))
        {
            return ((DeriveReqtFigure) getFigure()).getDeriveReqtStereotypeEdgeObjectFigure();
        }
        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.GraphEdgeEditPart#refreshEdgeObjects()
     * @generated
     */
    protected void refreshEdgeObjects()
    {
        super.refreshEdgeObjects();
        updateDeriveReqtStereotypeLabel();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc --> Update the
     * DeriveReqtStereotype Label
     * 
     * @generated NOT
     */
    private void updateDeriveReqtStereotypeLabel()
    {
        String stereotypes = SysMLTools.getStereotypesList((DeriveReqt) getEObject());
        if (stereotypes.length() != 0)
        {
            stereotypes = ", " + stereotypes;
        }
        stereotypes = "<<deriveReqt" + stereotypes + ">>";
        ((Label) ((DeriveReqtFigure) getFigure()).getDeriveReqtStereotypeEdgeObjectFigure()).setText(stereotypes);
    }

}