/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Laleve (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.sysml.requirementdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.EListEditPart;
import org.topcased.modeler.sysml.requirementdiagram.figures.FieldListFigure;

/**
 * This edit part adds abilities for model objects linked with the
 * EStructuralFeature of an EMF object.<br>
 * 
 * This edit part has a figure without borders contrary to the figure of a
 * org.topcased.modeler.edit.EListEditPart
 */
public class FieldListEditPart extends EListEditPart
{

    public FieldListEditPart(GraphNode obj, EStructuralFeature feature)
    {
        super(obj, feature);
    }

    /**
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    protected IFigure createFigure()
    {
        return new FieldListFigure();
    }
}
