/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.edit.policies.ResizableEditPolicy;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Display;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.NamedElement;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.modeler.ModelerColorConstants;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.LabelDirectEditPolicy;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.sysml.requirementdiagram.RequirementEditPolicyConstants;
import org.topcased.modeler.sysml.requirementdiagram.commands.NamedElementRestoreConnectionCommand;
import org.topcased.modeler.sysml.requirementdiagram.figures.NamedElementFigure;
import org.topcased.modeler.sysml.requirementdiagram.policies.RefineEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.requirementdiagram.policies.SatisfyEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.requirementdiagram.policies.TraceEdgeCreationEditPolicy;
import org.topcased.modeler.sysml.requirementdiagram.util.RequirementTools;
import org.topcased.modeler.sysml.util.SysMLTools;
import org.topcased.modeler.utils.Utils;

/**
 * The NamedElement object controller <!-- begin-user-doc --> <!-- end-user-doc
 * -->
 * 
 * @generated
 */
public class NamedElementEditPart extends ElementEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public NamedElementEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(RequirementEditPolicyConstants.SATISFY_EDITPOLICY, new SatisfyEdgeCreationEditPolicy());

        installEditPolicy(RequirementEditPolicyConstants.REFINE_EDITPOLICY, new RefineEdgeCreationEditPolicy());

        installEditPolicy(RequirementEditPolicyConstants.TRACE_EDITPOLICY, new TraceEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new NamedElementRestoreConnectionCommand(getHost());
            }
        });

        installEditPolicy(ModelerEditPolicyConstants.RESIZABLE_EDITPOLICY, new ResizableEditPolicy());

        installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LabelDirectEditPolicy());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated
     */
    protected IFigure createFigure()
    {

        return new NamedElementFigure();
    }

    protected void refreshHeaderLabel()
    {
        NamedElementFigure fig = (NamedElementFigure) getFigure();
        ComposedLabel lbl = (ComposedLabel) fig.getLabel();
        NamedElement elt = (NamedElement) Utils.getElement(getGraphNode());

        String stereotypes = SysMLTools.getStereotypesList(elt);
        if (stereotypes.length() != 0)
        {
            stereotypes = ", " + stereotypes;
        }
        lbl.setPrefix("<<" + elt.eClass().getName().toLowerCase() + stereotypes + ">>");

        if (elt.getName() != null)
        {
            lbl.setMain(elt.getName());
        }

        lbl.setSuffix(RequirementTools.getFromNotation(elt,
                (Element) Utils.getElement((GraphElement) getParent().getModel())));
    }

    protected Font getDefaultFont()
    {
        FontData[] fData = Display.getDefault().getSystemFont().getFontData();
        fData[0].setStyle(SWT.BOLD);
        JFaceResources.getFontRegistry().put("BoldFont", fData);
        return JFaceResources.getFontRegistry().get("BoldFont");
    }

    protected Color getDefaultBackgroundColor()
    {
        return ModelerColorConstants.lightRed;
    }
}