/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.requirementdiagram.figures;

import org.eclipse.draw2d.AbstractBorder;
import org.eclipse.draw2d.CompoundBorder;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.text.FlowPage;
import org.eclipse.draw2d.text.ParagraphTextLayout;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.draw2d.figures.EditableLabel;
import org.topcased.draw2d.figures.Label;
import org.topcased.draw2d.figures.TextFlow;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class RequirementFigure extends org.topcased.draw2d.figures.ClassFigure
{

    private ComposedLabel _idLabel;

    private ComposedLabel _sourceLabel;

    private TextFlow _textLabel;

    private ComposedLabel _kindLabel;

    private ComposedLabel _riskLabel;

    private ComposedLabel _verifyMethodLabel;

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RequirementFigure()
    {
        super();
    }

    /**
     * @see org.topcased.draw2d.figures.ClassFigure#drawFigure()
     * @generated NOT
     */
    protected void drawFigure()
    {
        // Add header figure
        ToolbarLayout layout = new ToolbarLayout();
        setLayoutManager(layout);
        setBorder(new CompoundBorder(new LineBorder(), new MarginBorder(1)));
        setOpaque(true);

        setLabel(new ComposedLabel(new Label(), new EditableLabel(), new Label(), false));
        add(getLabel());

        // Add figures holding attributes
        Figure attributeFigures = new Figure();
        attributeFigures.setLayoutManager(new ToolbarLayout());
        _idLabel = new ComposedLabel(new Label(), new Label(), null, true);
        _sourceLabel = new ComposedLabel(new Label(), new Label(), null, true);
        _textLabel = new TextFlow();
        _textLabel.setLayoutManager(new ParagraphTextLayout(_textLabel, ParagraphTextLayout.WORD_WRAP_SOFT));
        FlowPage flowPage = new FlowPage();
        flowPage.add(_textLabel);
        _kindLabel = new ComposedLabel(new Label(), new Label(), null, true);
        _riskLabel = new ComposedLabel(new Label(), new Label(), null, true);
        _verifyMethodLabel = new ComposedLabel(new Label(), new Label(), null, true);
        _idLabel.setPrefix("Id : ");
        _sourceLabel.setPrefix("Source : ");
        _kindLabel.setPrefix("Kind : ");
        _riskLabel.setPrefix("Risk : ");
        _verifyMethodLabel.setPrefix("Verify Method : ");

        attributeFigures.add(_idLabel);
        attributeFigures.add(_sourceLabel);
        attributeFigures.add(flowPage);
        attributeFigures.add(_kindLabel);
        attributeFigures.add(_riskLabel);
        attributeFigures.add(_verifyMethodLabel);
        attributeFigures.setBorder(new AttributeBorder());
        add(attributeFigures);

        // Add content pane figure
        setContentPane(new Figure());
        getContentPane().setLayoutManager(new ToolbarLayout());
        add(getContentPane());
    }

    /**
     * Set the identifier to display
     * 
     * @param id the identifier
     */
    public void setId(String id)
    {
        if (id != null && id.length() != 0)
            _idLabel.setText("\"" + id + "\"");
        else
            _idLabel.setText("");
    }

    /**
     * Set the source to display
     * 
     * @param source the source
     */
    public void setSource(String source)
    {
        if (source != null && source.length() != 0)
            _sourceLabel.setText("\"" + source + "\"");
        else
            _sourceLabel.setText("");
    }

    /**
     * Set the textual description to display
     * 
     * @param txt the textual description
     */
    public void setText(String txt)
    {
        String text = "";
        if (txt != null && txt.length() != 0)
            text = "\"" + txt + "\"";
        _textLabel.setText("Text : " + text);
    }

    /**
     * Set the kind to display
     * 
     * @param kind the kind
     */
    public void setKind(String kind)
    {
        if (kind != null && kind.length() != 0)
            _kindLabel.setText("\"" + kind + "\"");
    }

    /**
     * Set the risk to display
     * 
     * @param risk the risk
     */
    public void setRisk(String risk)
    {
        if (risk != null && risk.length() != 0)
            _riskLabel.setText("\"" + risk + "\"");
    }

    /**
     * Set the verify method to display
     * 
     * @param verifyMethod the verify method
     */
    public void setVerifyMethod(String verifyMethod)
    {
        if (verifyMethod != null && verifyMethod.length() != 0)
            _verifyMethodLabel.setText("\"" + verifyMethod + "\"");
    }

    private static class AttributeBorder extends AbstractBorder

    {
        /**
         * @see org.eclipse.draw2d.Border#getInsets(org.eclipse.draw2d.IFigure)
         */
        public Insets getInsets(IFigure figure)
        {
            return new Insets(2, 2, 2, 2);
        }

        /**
         * @see org.eclipse.draw2d.Border#getInsets(org.eclipse.draw2d.IFigure)
         */
        public void paint(IFigure figure, Graphics graphics, Insets insets)
        {
            graphics.drawLine(figure.getBounds().getTopLeft(), figure.getBounds().getTopRight());
        }
    }

}