/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.usecasediagram;

import java.net.URL;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.gef.EditPartFactory;
import org.topcased.modeler.editor.IConfiguration;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.IPaletteManager;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.graphconf.exceptions.MissingGraphConfFileException;
import org.topcased.modeler.sysml.usecasediagram.edit.PackageSYSMLEditPart;
import org.topcased.modeler.uml.alldiagram.edit.CommentEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.ActorEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.AssociationEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.ClassifierEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.ExtendEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.GeneralizationEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.IncludeEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.UseCaseEditPart;
/**
 * A diagram configuration : manages Palette, EditPartFactory for this diagram.
 *
 * @generated
 */
public class UseCaseConfiguration implements IConfiguration{
	/**
	 * @generated
	 */
	private UseCasePaletteManager paletteManager;

	/**
	 * @generated
	 */
	private UseCaseEditPartFactory editPartFactory;

	/**
	 * @generated
	 */
	private UseCaseCreationUtils creationUtils;

	/**
	 * The DiagramGraphConf that contains graphical informations on the configuration
	 * @generated
	 */
	private DiagramGraphConf diagramGraphConf;

	/**
	 * Constructor. Initialize Adapter factories.
	 *
	 * @generated
	 */
	public UseCaseConfiguration() {
		registerAdapters();
	}

	/**
	 * Registers the Adapter Factories for all the EditParts
	 *
	 * @generated
	 */
	private void registerAdapters() {
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(ClassifierEditPart.class,
						org.eclipse.uml2.uml.Classifier.class),
				ClassifierEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(PackageSYSMLEditPart.class,
						org.topcased.sysml.PackageSYSML.class),
				PackageSYSMLEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(ActorEditPart.class,
						org.eclipse.uml2.uml.Actor.class), ActorEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(UseCaseEditPart.class,
						org.eclipse.uml2.uml.UseCase.class),
				UseCaseEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(ExtendEditPart.class,
						org.eclipse.uml2.uml.Extend.class),
				ExtendEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(IncludeEditPart.class,
						org.eclipse.uml2.uml.Include.class),
				IncludeEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(AssociationEditPart.class,
						org.eclipse.uml2.uml.Association.class),
				AssociationEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(GeneralizationEditPart.class,
						org.eclipse.uml2.uml.Generalization.class),
				GeneralizationEditPart.class);
		Platform.getAdapterManager().registerAdapters(
				new EditPart2ModelAdapterFactory(CommentEditPart.class,
						org.eclipse.uml2.uml.Comment.class),
				CommentEditPart.class);
	}

	/**
	 * @see org.topcased.modeler.editor.IConfiguration#getId()
	 * @generated
	 */
	public String getId() {
		return new String("org.topcased.modeler.sysml.usecasediagram");
	}

	/**
	 * @see org.topcased.modeler.editor.IConfiguration#getName()
	 * @generated
	 */
	public String getName() {
		return new String("Use Case Diagram");
	}

	/**
	 * @see org.topcased.modeler.editor.IConfiguration#getEditPartFactory()
	 * @generated
	 */
	public EditPartFactory getEditPartFactory() {
		if (editPartFactory == null) {
			editPartFactory = new UseCaseEditPartFactory();
		}

		return editPartFactory;
	}

	/**
	 * @see org.topcased.modeler.editor.IConfiguration#getPaletteManager()
	 * @generated
	 */
	public IPaletteManager getPaletteManager() {
		if (paletteManager == null) 
		{
			paletteManager = new UseCasePaletteManager(getCreationUtils());
		}

		return paletteManager;
	}

	/**
	 * @see org.topcased.modeler.editor.IConfiguration#getCreationUtils()
	 * @generated
	 */
	public ICreationUtils getCreationUtils() {
		if (creationUtils == null) {
			creationUtils = new UseCaseCreationUtils(getDiagramGraphConf());
		}

		return creationUtils;
	}

	/**
	 * @see org.topcased.modeler.editor.IConfiguration#getDiagramGraphConf()
	 * @generated
	 */
	public DiagramGraphConf getDiagramGraphConf() {
		if (diagramGraphConf == null) {
			URL url = UseCasePlugin
					.getDefault()
					.getBundle()
					.getResource(
							"org/topcased/modeler/sysml/usecasediagram/diagram.graphconf");
			if (url != null) {
				URI fileURI = URI.createURI(url.toString());
				ResourceSet resourceSet = new ResourceSetImpl();
				Resource resource = resourceSet.getResource(fileURI, true);
				if (resource != null
						&& resource.getContents().get(0) instanceof DiagramGraphConf) {
					diagramGraphConf = (DiagramGraphConf) resource
							.getContents().get(0);
				}
			} else {
				new MissingGraphConfFileException(
						"The *.diagramgraphconf file can not be retrieved. Check if the path is correct in the Configuration class of your diagram.");
			}
		}

		return diagramGraphConf;
	}

}