/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.usecasediagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Extend;
import org.eclipse.uml2.uml.Generalization;
import org.eclipse.uml2.uml.Include;
import org.eclipse.uml2.uml.UseCase;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.uml.classdiagram.ClassEdgeObjectConstants;
import org.topcased.modeler.uml.usecasediagram.UseCaseEdgeObjectConstants;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model Object
 *
 * @generated
 */
public class UseCaseCreationUtils extends AbstractCreationUtils {

	private static final int LABEL_OFFSET = 10;
	/**
	 * Constructor
	 *
	 * @param diagramConf the Diagram Graphical Configuration
	 * @generated
	 */
	public UseCaseCreationUtils(DiagramGraphConf diagramConf) {
		super(diagramConf);
	}

	/**
	 * @generated NOT
	 */
	private class GraphicSysMLSwitch extends SysMLSwitch {
		/**
		 * The presentation of the graphical element
		 *
		 * @generated
		 */
		private String presentation;

		/**
		 * Constructor
		 *
		 * @param presentation the presentation of the graphical element
		 * @generated
		 */
		public GraphicSysMLSwitch(String presentation) {
			this.presentation = presentation;
		}

		/**
		 * @see org.topcased.sysml.util.SysMLSwitch#casePackageSYSML(org.topcased.sysml.PackageSYSML)
		 * @generated
		 */
		public Object casePackageSYSML(org.topcased.sysml.PackageSYSML object) {	
				return createGraphElementPackageSYSML(object, presentation);
		}
		
	    /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseActor(org.eclipse.uml2.uml.Actor)
         */
        public Object caseActor(Actor object)
        {
            return createGraphElementActor(object, presentation);
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseUseCase(org.eclipse.uml2.uml.UseCase)
         */
        public Object caseUseCase(UseCase object)
        {
            return createGraphElementUseCase(object, presentation);
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseAssociation(org.eclipse.uml2.uml.Association)
         */
        public Object caseAssociation(Association object)
        {
            return createGraphElementAssociation(object, presentation);
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseGeneralization(org.eclipse.uml2.uml.Generalization)
         */
        public Object caseGeneralization(Generalization object)
        {
            return createGraphElementGeneralization(object, presentation);
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseInclude(org.eclipse.uml2.uml.Include)
         */
        public Object caseInclude(Include object)
        {
            return createGraphElementInclude(object, presentation);
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseExtend(org.eclipse.uml2.uml.Extend)
         */
        public Object caseExtend(Extend object)
        {
            return createGraphElementExtend(object, presentation);
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         */
        public Object caseComment(Comment object)
        {
            return createGraphElementComment(object, presentation);
        }

		/**
		 * @see org.topcased.sysml.util.SysMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
		 * @generated
		 */
		public Object defaultCase(EObject object) {
			return null;
		}
	}

	/**
	 * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject, java.lang.String)
	 * @generated
	 */
	public GraphElement createGraphElement(EObject obj, String presentation) {
		Object graphElt = null;
			graphElt = new GraphicSysMLSwitch(presentation).doSwitch(obj);
		return (GraphElement) graphElt;
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementPackageSYSML(
			org.topcased.sysml.PackageSYSML element, String presentation) {
		return createGraphNode(element, presentation);
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementActor(
			org.eclipse.uml2.uml.Actor element, String presentation) {
		return createGraphNode(element, presentation);
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementUseCase(
			org.eclipse.uml2.uml.UseCase element, String presentation) {
		return createGraphNode(element, presentation);
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated NOT
	 */
	protected GraphElement createGraphElementAssociation(
			org.eclipse.uml2.uml.Association element, String presentation) {
GraphEdge graphEdge = createGraphEdge(element, presentation);
        
        EdgeObjectUV srccountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        srccountEdgeObjectUV.setId(ClassEdgeObjectConstants.SRCCOUNT_EDGE_OBJECT_ID);
        srccountEdgeObjectUV.setUDistance(LABEL_OFFSET);
        srccountEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        graphEdge.getContained().add(srccountEdgeObjectUV);
        
        EdgeObjectUV targetcountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        targetcountEdgeObjectUV.setId(ClassEdgeObjectConstants.TARGETCOUNT_EDGE_OBJECT_ID);
        targetcountEdgeObjectUV.setUDistance(LABEL_OFFSET);
        targetcountEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        graphEdge.getContained().add(targetcountEdgeObjectUV);

        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(UseCaseEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, 10));
        nameEdgeObjectOffset.setVisible(false);
        graphEdge.getContained().add(nameEdgeObjectOffset);

        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(UseCaseEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, -10));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);

        return graphEdge;
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementGeneralization(
			org.eclipse.uml2.uml.Generalization element, String presentation) {
		GraphEdge graphEdge = createGraphEdge(element, presentation);
		EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE
				.createEdgeObjectOffset();
		stereotypeEdgeObjectOffset
				.setId(UseCaseEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
		stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
		graphEdge.getContained().add(stereotypeEdgeObjectOffset);
		return graphEdge;
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementInclude(
			org.eclipse.uml2.uml.Include element, String presentation) {
		GraphEdge graphEdge = createGraphEdge(element, presentation);
		EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE
				.createEdgeObjectOffset();
		nameEdgeObjectOffset
				.setId(UseCaseEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
		nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
		graphEdge.getContained().add(nameEdgeObjectOffset);
		return graphEdge;
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementExtend(
			org.eclipse.uml2.uml.Extend element, String presentation) {
		GraphEdge graphEdge = createGraphEdge(element, presentation);
		EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE
				.createEdgeObjectOffset();
		nameEdgeObjectOffset
				.setId(UseCaseEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
		nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
		graphEdge.getContained().add(nameEdgeObjectOffset);
		EdgeObjectUV extensionEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE
				.createEdgeObjectUV();
		extensionEdgeObjectUV
				.setId(UseCaseEdgeObjectConstants.EXTENSION_EDGE_OBJECT_ID);
		extensionEdgeObjectUV.setUDistance(0);
		extensionEdgeObjectUV.setVDistance(0);
		graphEdge.getContained().add(extensionEdgeObjectUV);
		return graphEdge;
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementComment(
			org.eclipse.uml2.uml.Comment element, String presentation) {
		return createGraphNode(element, presentation);
	}

	/**
	 * Create the ModelObject with its initial children
	 * 
	 * @param obj the model object
	 * @return the model object with its children
	 * @generated
	 */
	public EObject createModelObject(EObject obj) {
		return obj;
	}

}
