/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.usecasediagram;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Extend;
import org.eclipse.uml2.uml.Generalization;
import org.eclipse.uml2.uml.Include;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.UseCase;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.di.model.SimpleSemanticModelElement;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.EMFGraphNodeEditPart;
import org.topcased.modeler.edit.GraphEdgeEditPart;
import org.topcased.modeler.sysml.usecasediagram.edit.ActorEditPart;
import org.topcased.modeler.sysml.usecasediagram.edit.AssociationEditPart;
import org.topcased.modeler.sysml.usecasediagram.edit.PackageSYSMLEditPart;
import org.topcased.modeler.sysml.usecasediagram.edit.UseCaseDiagramEditPart;
import org.topcased.modeler.sysml.usecasediagram.edit.UseCaseEditPart;
import org.topcased.modeler.uml.alldiagram.edit.CommentEditPart;
import org.topcased.modeler.uml.alldiagram.edit.CommentLinkEditPart;
import org.topcased.modeler.uml.usecasediagram.UseCaseSimpleObjectConstants;
import org.topcased.modeler.uml.usecasediagram.edit.ClassifierEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.ExtendEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.GeneralizationEditPart;
import org.topcased.modeler.uml.usecasediagram.edit.IncludeEditPart;
import org.topcased.modeler.utils.Utils;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * Part Factory : associates a model object to its controller. <br>
 *
 * @generated
 */
public class UseCaseEditPartFactory implements EditPartFactory {
	/**
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,java.lang.Object)
	 * @generated NOT
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof Diagram) {
			return new UseCaseDiagramEditPart((Diagram) model);
		} else if (model instanceof GraphNode) {
			final GraphNode node = (GraphNode) model;
			EObject element = Utils.getElement(node);
			if (element != null) {
				Object editPart = new SysMLSwitch()
                {
                    public Object caseClassifier(Classifier object)
                    {
                        return new ClassifierEditPart(node);
                    }

                    public Object casePackage(Package object)
                    {
                        return new PackageSYSMLEditPart(node);
                    }

                    public Object caseActor(Actor object)
                    {
                        return new ActorEditPart(node);
                    }

                    public Object caseUseCase(UseCase object)
                    {
                        return new UseCaseEditPart(node);
                    }

                    public Object caseComment(Comment object)
                    {
                        return new CommentEditPart(node);
                    }

                    public Object defaultCase(EObject object)
                    {
                        return new EMFGraphNodeEditPart(node);
                    }
                }.doSwitch(element);
                return (EditPart) editPart;
            }
		} else if (model instanceof GraphEdge) {
			final GraphEdge edge = (GraphEdge) model;
			EObject element = Utils.getElement(edge);
			if(element != null)
            {
                Object editPart = new SysMLSwitch()
                {
                    public Object caseExtend(Extend object)
                    {
                        return new ExtendEditPart(edge);
                    }

                    public Object caseInclude(Include object)
                    {
                        return new IncludeEditPart(edge);
                    }

                    public Object caseAssociation(Association object)
                    {
                        return new AssociationEditPart(edge);
                    }

                    public Object caseGeneralization(Generalization object)
                    {
                        return new GeneralizationEditPart(edge);
                    }

                    public Object defaultCase(EObject object)
                    {
                        return new EMFGraphEdgeEditPart(edge);
                    }
                }.doSwitch(element);
                return (EditPart) editPart;
			}

			if (edge.getSemanticModel() instanceof SimpleSemanticModelElement) {
				// Manage the Element that are not associated with a model object
				if (UseCaseSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK
						.equals(((SimpleSemanticModelElement) edge
								.getSemanticModel()).getTypeInfo())) {
					return new CommentLinkEditPart(edge);
				}
			}

			return new GraphEdgeEditPart(edge);
		}

		throw new IllegalStateException(
				"No edit part matches with the '"
						+ model.getClass().getName()
						+ "' model element. Check UseCaseEditPartFactory#createEditPart(EditPart,Object) class");
	}



}