/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.usecasediagram;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;
import org.topcased.modeler.uml.UMLImageRegistry;
import org.topcased.modeler.uml.usecasediagram.UseCaseSimpleObjectConstants;
import org.topcased.sysml.SysMLPackage;

/**
 * Generated Palette Manager
 *
 * @generated
 */
public class UseCasePaletteManager extends ModelerPaletteManager {
	// declare all the palette categories of the diagram
	/**
	 * @generated
	 */
	private PaletteDrawer objectsDrawer;
	/**
	 * @generated
	 */
	private PaletteDrawer connectionsDrawer;
	/**
	 * @generated
	 */
	private PaletteDrawer commentDrawer;

	/**
	 * @generated
	 */
	private ICreationUtils creationUtils;

	/**
	 * The Constructor
	 *
	 * @param utils the creation utils for the tools of the palette 
	 * @generated
	 */
	public UseCasePaletteManager(ICreationUtils utils) {
		super();
		this.creationUtils = utils;
	}

	/**
	 * Creates the main categories of the palette
	 *
	 * @generated
	 */
	protected void createCategories() {
		createObjectsDrawer();
		createConnectionsDrawer();
		createCommentDrawer();
	}

	/**
	 * Updates the main categories of the palette
	 *
	 * @generated
	 */
	protected void updateCategories() {
		// deletion of the existing categories and creation of the updated categories

		getRoot().remove(objectsDrawer);
		createObjectsDrawer();

		getRoot().remove(connectionsDrawer);
		createConnectionsDrawer();

		getRoot().remove(commentDrawer);
		createCommentDrawer();
	}

	/**
	 * Creates the Palette container containing all the Palette entries for each figure.
	 *
	 * @generated
	 */
	private void createObjectsDrawer() {
		objectsDrawer = new PaletteDrawer("Objects", null);
		List entries = new ArrayList();

		CreationFactory factory;

		factory = new GraphElementCreationFactory(creationUtils,
				SysMLPackage.eINSTANCE.getPackageSYSML(), "default");
		entries.add(new ModelerCreationToolEntry("Package", "Package", factory,
				UMLImageRegistry.getImageDescriptor("PACKAGE"),
				UMLImageRegistry.getImageDescriptor("PACKAGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				UMLPackage.eINSTANCE.getActor(), "default");
		entries.add(new ModelerCreationToolEntry("Actor", "Actor", factory,
				UMLImageRegistry.getImageDescriptor("ACTOR"),
				UMLImageRegistry.getImageDescriptor("ACTOR_LARGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				UMLPackage.eINSTANCE.getUseCase(), "default");
		entries.add(new ModelerCreationToolEntry("Use Case", "Use Case",
				factory, UMLImageRegistry.getImageDescriptor("USECASE"),
				UMLImageRegistry.getImageDescriptor("USECASE_LARGE")));

		objectsDrawer.addAll(entries);
		getRoot().add(objectsDrawer);
	}

	/**
	 * Creates the Palette container containing all the Palette entries for each figure.
	 *
	 * @generated
	 */
	private void createConnectionsDrawer() {
		connectionsDrawer = new PaletteDrawer("Connections", null);
		List entries = new ArrayList();

		CreationFactory factory;

		factory = new GraphElementCreationFactory(creationUtils,
				UMLPackage.eINSTANCE.getAssociation(), "default");
		entries.add(new ModelerConnectionCreationToolEntry("Association",
				"Association", factory, UMLImageRegistry
						.getImageDescriptor("ASSOCIATION"),
						UMLImageRegistry.getImageDescriptor("ASSOCIATION_LARGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				UMLPackage.eINSTANCE.getGeneralization(), "default");
		entries
				.add(new ModelerConnectionCreationToolEntry("Generalization",
						"Generalization", factory, UMLImageRegistry
								.getImageDescriptor("GENERALIZATION"),
								UMLImageRegistry
								.getImageDescriptor("GENERALIZATION_LARGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				UMLPackage.eINSTANCE.getInclude(), "default");
		entries.add(new ModelerConnectionCreationToolEntry("Include",
				"Include", factory, UMLImageRegistry
						.getImageDescriptor("INCLUDE"), UMLImageRegistry
						.getImageDescriptor("INCLUDE_LARGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				UMLPackage.eINSTANCE.getExtend(), "default");
		entries.add(new ModelerConnectionCreationToolEntry("Extend", "Extend",
				factory, UMLImageRegistry.getImageDescriptor("EXTEND"),
				UMLImageRegistry.getImageDescriptor("EXTEND_LARGE")));

		connectionsDrawer.addAll(entries);
		getRoot().add(connectionsDrawer);
	}

	/**
	 * Creates the Palette container containing all the Palette entries for each figure.
	 *
	 * @generated
	 */
	private void createCommentDrawer() {
		commentDrawer = new PaletteDrawer("Comment", null);
		List entries = new ArrayList();

		CreationFactory factory;

		factory = new GraphElementCreationFactory(creationUtils,
				UMLPackage.eINSTANCE.getComment(), "default");
		entries.add(new ModelerCreationToolEntry("Comment", "Comment", factory,
				UMLImageRegistry.getImageDescriptor("COMMENT"),
				UMLImageRegistry.getImageDescriptor("COMMENT_LARGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				UseCaseSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK,
				"default", false);
		entries.add(new ModelerConnectionCreationToolEntry("Comment Link",
				"Comment Link", factory, UMLImageRegistry
						.getImageDescriptor("COMMENTLINK"),
						UMLImageRegistry.getImageDescriptor("COMMENTLINK_LARGE")));

		commentDrawer.addAll(entries);
		getRoot().add(commentDrawer);
	}

}
