/*******************************************************************************
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.usecasediagram.commands;

import org.eclipse.gef.EditDomain;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.UMLFactory;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.utils.LabelHelper;
import org.topcased.modeler.utils.Utils;

/**
 * Association edge creation command<br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class AssociationEdgeCreationCommand extends CreateTypedEdgeCommand
{
	
	  private Association association;

	    private Type sourceObject;

	    private Type targetObject;


    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @generated
     */
    public AssociationEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src)
    {
        this(domain, newObj, src, true);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @param needModelUpdate set it to true if the model need to be updated
     * @generated
     */
    public AssociationEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src, boolean needModelUpdate)
    {
        super(domain, newObj, src, needModelUpdate);
    }


    public void execute()
    {
        // Create the association and add it to the current package
        association = (Association) Utils.getElement(getEdge());

        // Retrieve source object and target object
        sourceObject = (Type) Utils.getElement(getSource());
        targetObject = (Type) Utils.getElement(getTarget());


      // Create two properties that handle the link between the two object
      Property property1 = UMLFactory.eINSTANCE.createProperty();
      property1.setName("source");
      property1.setType(sourceObject);

      Property property2 = UMLFactory.eINSTANCE.createProperty();
      property2.setName("target");
      property2.setType(targetObject);

      // Add the properties to the association
      association.getOwnedEnds().add(property1);
      association.getOwnedEnds().add(property2);

      // Add the Multiplicity of the Lower and Upper bound of the Property
      property1.setLower(1);
      property1.setUpper(1);

      property2.setLower(1);
      property2.setUpper(1);

      property1.setIsNavigable(false);
      property2.setIsNavigable(false);
      
      super.execute();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void redoModel()
    {
        // Add the Association to the current package
        sourceObject.getPackage().getPackagedElements().add(association);

        // init the name of the association contained by the package
        String curName = LabelHelper.INSTANCE.getName(getEditDomain(), association);
        if (curName == null || curName.length() == 0)
        {
            LabelHelper.INSTANCE.initName(getEditDomain(), Utils.getElement(getEdge()).eContainer(), association);
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void undoModel()
    {
        // Remove the association from the package
        sourceObject.getPackage().getPackagedElements().remove(association);
    }
}