/*******************************************************************************
 * 
 * Copyright AIRBUS FRANCE, 2005. All rights reserved.
 * 
 * This document and all information contained herein is the sole property of
 * AIRBUS FRANCE. No intellectual property rights are granted by the delivery of
 * this document or the disclosure of its content.
 * 
 ******************************************************************************/
package org.topcased.modeler.sysml.util;

import org.eclipse.emf.ecore.EObject;
import org.topcased.sysml.util.SysMLSwitch;

/**
 * A customized SysMLSwitch.<br>
 * It works the same as the SysMLSwitch but
 * it does not proceed up the inheritance hierarchy.
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * @generated
 */
public class ExactSysMLSwitch extends SysMLSwitch
{

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Block</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseBlock(org.topcased.sysml.Block object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Flow Port</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseFlowPort(org.topcased.sysml.FlowPort object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Service Port</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseServicePort(org.topcased.sysml.ServicePort object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Flow Specification</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseFlowSpecification(org.topcased.sysml.FlowSpecification object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Block Definition</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseBlockDefinition(org.topcased.sysml.BlockDefinition object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Package SYSML</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object casePackageSYSML(org.topcased.sysml.PackageSYSML object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Requirement</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseRequirement(org.topcased.sysml.Requirement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Test Case</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseTestCase(org.topcased.sysml.TestCase object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Requirement Definition</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseRequirementDefinition(org.topcased.sysml.RequirementDefinition object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Satisfy</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseSatisfy(org.topcased.sysml.Satisfy object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Derive Reqt</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseDeriveReqt(org.topcased.sysml.DeriveReqt object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Verify</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseVerify(org.topcased.sysml.Verify object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Field</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseField(org.topcased.sysml.Field object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Rationale</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseRationale(org.topcased.sysml.Rationale object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Problem</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseProblem(org.topcased.sysml.Problem object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Value Type</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseValueType(org.topcased.sysml.ValueType object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Dimension</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseDimension(org.topcased.sysml.Dimension object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Unit</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseUnit(org.topcased.sysml.Unit object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Block Property</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseBlockProperty(org.topcased.sysml.BlockProperty object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Distributed Property</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseDistributedProperty(org.topcased.sysml.DistributedProperty object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Item Flow</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseItemFlow(org.topcased.sysml.ItemFlow object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Flow Property</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseFlowProperty(org.topcased.sysml.FlowProperty object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Constraint Block</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseConstraintBlock(org.topcased.sysml.ConstraintBlock object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Trace</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseTrace(org.topcased.sysml.Trace object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Copy</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseCopy(org.topcased.sysml.Copy object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Refine</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseRefine(org.topcased.sysml.Refine object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Constraint Property</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseConstraintProperty(org.topcased.sysml.ConstraintProperty object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Containment</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseContainment(org.topcased.sysml.Containment object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Requirement Related</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseRequirementRelated(org.topcased.sysml.RequirementRelated object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Model SYSML</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseModelSYSML(org.topcased.sysml.ModelSYSML object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>EModel Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseEModelElement(org.eclipse.emf.ecore.EModelElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseElement(org.eclipse.uml2.uml.Element object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Named Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseNamedElement(org.eclipse.uml2.uml.NamedElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Namespace</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseNamespace(org.eclipse.uml2.uml.Namespace object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Redefinable Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseRedefinableElement(org.eclipse.uml2.uml.RedefinableElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Parameterable Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseParameterableElement(org.eclipse.uml2.uml.ParameterableElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Packageable Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object casePackageableElement(org.eclipse.uml2.uml.PackageableElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Type</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseType(org.eclipse.uml2.uml.Type object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Templateable Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseTemplateableElement(org.eclipse.uml2.uml.TemplateableElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Classifier</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseClassifier(org.eclipse.uml2.uml.Classifier object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Structured Classifier</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseStructuredClassifier(org.eclipse.uml2.uml.StructuredClassifier object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Encapsulated Classifier</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseEncapsulatedClassifier(org.eclipse.uml2.uml.EncapsulatedClassifier object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Behaviored Classifier</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseBehavioredClassifier(org.eclipse.uml2.uml.BehavioredClassifier object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Class</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseClass(org.eclipse.uml2.uml.Class object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Feature</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseFeature(org.eclipse.uml2.uml.Feature object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Typed Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseTypedElement(org.eclipse.uml2.uml.TypedElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Multiplicity Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseMultiplicityElement(org.eclipse.uml2.uml.MultiplicityElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Structural Feature</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseStructuralFeature(org.eclipse.uml2.uml.StructuralFeature object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Connectable Element</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseConnectableElement(org.eclipse.uml2.uml.ConnectableElement object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Deployment Target</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseDeploymentTarget(org.eclipse.uml2.uml.DeploymentTarget object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Property</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseProperty(org.eclipse.uml2.uml.Property object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Port</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object casePort(org.eclipse.uml2.uml.Port object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Interface</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseInterface(org.eclipse.uml2.uml.Interface object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Package</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object casePackage(org.eclipse.uml2.uml.Package object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Behavior</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseBehavior(org.eclipse.uml2.uml.Behavior object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Relationship</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseRelationship(org.eclipse.uml2.uml.Relationship object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Directed Relationship</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseDirectedRelationship(org.eclipse.uml2.uml.DirectedRelationship object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Dependency</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseDependency(org.eclipse.uml2.uml.Dependency object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Abstraction</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseAbstraction(org.eclipse.uml2.uml.Abstraction object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Realization</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseRealization(org.eclipse.uml2.uml.Realization object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Comment</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseComment(org.eclipse.uml2.uml.Comment object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Data Type</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseDataType(org.eclipse.uml2.uml.DataType object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an exact instance of '<em>Information Flow</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object caseInformationFlow(org.eclipse.uml2.uml.InformationFlow object)
    {
        return object;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the given object.
     * @generated
     */
    public Object defaultCase(EObject object)
    {
        return object;
    }
}
