/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram;

import java.net.URL;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.gef.EditPartFactory;
import org.topcased.modeler.editor.IConfiguration;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.IPaletteManager;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.graphconf.exceptions.MissingGraphConfFileException;
import org.topcased.modeler.uml.activitydiagram.edit.AcceptEventActionEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ActionEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ActivityFinalNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ActivityNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ActivityParameterNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ActivityPartitionEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.CallBehaviorActionEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.CallOperationActionEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.CentralBufferNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ControlFlowEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ControlNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.DataStoreNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.DecisionNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ExceptionHandlerEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ExecutableNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ExpansionNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ExpansionRegionEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.FlowFinalNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ForkNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.InitialNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.InputPinEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.JoinNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.MergeNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ObjectFlowEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.ObjectNodeEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.OutputPinEditPart;
import org.topcased.modeler.uml.activitydiagram.edit.SendSignalActionEditPart;
import org.topcased.modeler.uml.alldiagram.edit.CommentEditPart;
import org.topcased.modeler.uml.alldiagram.edit.ElementEditPart;

/**
 * A diagram configuration : manages Palette, EditPartFactory for this diagram. <br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ActivityConfiguration implements IConfiguration
{
    private ActivityPaletteManager paletteManager;

    private ActivityEditPartFactory editPartFactory;

    private ActivityCreationUtils creationUtils;

    /**
     * The DiagramGraphConf that contains graphical informations on the configuration
     */
    private DiagramGraphConf diagramGraphConf;

    /**
     * Constructor. Initialize Adapter factories.
     * 
     * @generated
     */
    public ActivityConfiguration()
    {
        registerAdapters();
    }

    /**
     * Registers the Adapter Factories for all the EditParts
     * 
     * @generated
     */
    private void registerAdapters()
    {
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ElementEditPart.class, org.eclipse.uml2.uml.Element.class), ElementEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ActivityNodeEditPart.class, org.eclipse.uml2.uml.ActivityNode.class), ActivityNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ControlNodeEditPart.class, org.eclipse.uml2.uml.ControlNode.class), ControlNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ObjectNodeEditPart.class, org.eclipse.uml2.uml.ObjectNode.class), ObjectNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(InitialNodeEditPart.class, org.eclipse.uml2.uml.InitialNode.class), InitialNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(DecisionNodeEditPart.class, org.eclipse.uml2.uml.DecisionNode.class), DecisionNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(MergeNodeEditPart.class, org.eclipse.uml2.uml.MergeNode.class), MergeNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ForkNodeEditPart.class, org.eclipse.uml2.uml.ForkNode.class), ForkNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(JoinNodeEditPart.class, org.eclipse.uml2.uml.JoinNode.class), JoinNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ActivityFinalNodeEditPart.class, org.eclipse.uml2.uml.ActivityFinalNode.class), ActivityFinalNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(FlowFinalNodeEditPart.class, org.eclipse.uml2.uml.FlowFinalNode.class), FlowFinalNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(CentralBufferNodeEditPart.class, org.eclipse.uml2.uml.CentralBufferNode.class), CentralBufferNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(DataStoreNodeEditPart.class, org.eclipse.uml2.uml.DataStoreNode.class), DataStoreNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ActivityParameterNodeEditPart.class, org.eclipse.uml2.uml.ActivityParameterNode.class),
                ActivityParameterNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ExpansionNodeEditPart.class, org.eclipse.uml2.uml.ExpansionNode.class), ExpansionNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ExecutableNodeEditPart.class, org.eclipse.uml2.uml.ExecutableNode.class), ExecutableNodeEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ActivityPartitionEditPart.class, org.eclipse.uml2.uml.ActivityPartition.class), ActivityPartitionEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ExceptionHandlerEditPart.class, org.eclipse.uml2.uml.ExceptionHandler.class), ExceptionHandlerEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ControlFlowEditPart.class, org.eclipse.uml2.uml.ControlFlow.class), ControlFlowEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ObjectFlowEditPart.class, org.eclipse.uml2.uml.ObjectFlow.class), ObjectFlowEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(CommentEditPart.class, org.eclipse.uml2.uml.Comment.class), CommentEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ActionEditPart.class, org.eclipse.uml2.uml.Action.class), ActionEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(CallBehaviorActionEditPart.class, org.eclipse.uml2.uml.CallBehaviorAction.class),
                CallBehaviorActionEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(CallOperationActionEditPart.class, org.eclipse.uml2.uml.CallOperationAction.class),
                CallOperationActionEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(SendSignalActionEditPart.class, org.eclipse.uml2.uml.SendSignalAction.class), SendSignalActionEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(AcceptEventActionEditPart.class, org.eclipse.uml2.uml.AcceptEventAction.class), AcceptEventActionEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(ExpansionRegionEditPart.class, org.eclipse.uml2.uml.ExpansionRegion.class), ExpansionRegionEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(InputPinEditPart.class, org.eclipse.uml2.uml.InputPin.class), InputPinEditPart.class);
        Platform.getAdapterManager().registerAdapters(new EditPart2ModelAdapterFactory(OutputPinEditPart.class, org.eclipse.uml2.uml.OutputPin.class), OutputPinEditPart.class);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getId()
     * @generated
     */
    public String getId()
    {
        return new String("org.topcased.modeler.uml.activitydiagram");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getName()
     * @generated
     */
    public String getName()
    {
        return new String("Activity Diagram");
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getEditPartFactory()
     * @generated
     */
    public EditPartFactory getEditPartFactory()
    {
        if (editPartFactory == null)
        {
            editPartFactory = new ActivityEditPartFactory();
        }

        return editPartFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getPaletteManager()
     * @generated
     */
    public IPaletteManager getPaletteManager()
    {
        if (paletteManager == null)
        {
            paletteManager = new ActivityPaletteManager(getCreationUtils());
        }

        return paletteManager;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getCreationUtils()
     * @generated
     */
    public ICreationUtils getCreationUtils()
    {
        if (creationUtils == null)
        {
            creationUtils = new ActivityCreationUtils(getDiagramGraphConf());
        }

        return creationUtils;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.IConfiguration#getDiagramGraphConf()
     * @generated
     */
    public DiagramGraphConf getDiagramGraphConf()
    {
        if (diagramGraphConf == null)
        {
            URL url = ActivityPlugin.getDefault().getBundle().getResource("org/topcased/modeler/uml/activitydiagram/diagram.graphconf");
            if (url != null)
            {
                URI fileURI = URI.createURI(url.toString());
                ResourceSet resourceSet = new ResourceSetImpl();
                Resource resource = resourceSet.getResource(fileURI, true);
                if (resource != null && resource.getContents().get(0) instanceof DiagramGraphConf)
                {
                    diagramGraphConf = (DiagramGraphConf) resource.getContents().get(0);
                }
            }
            else
            {
                new MissingGraphConfFileException("The *.diagramgraphconf file can not be retrieved. Check if the path is correct in the Configuration class of your diagram.");
            }
        }

        return diagramGraphConf;
    }

}