/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.uml.alldiagram.ExactUMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model Object <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class ActivityCreationUtils extends AbstractCreationUtils
{
    private static final int LABEL_OFFSET = 6;

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param diagramConf the Diagram Graphical Configuration
     * @generated
     */
    public ActivityCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private class GraphicUMLSwitch extends ExactUMLSwitch
    {
        /** The presentation of the graphical element */
        private String presentation;

        /**
         * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicUMLSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseExpansionRegion(org.eclipse.uml2.uml.ExpansionRegion)
         * @generated
         */
        public GraphElement caseExpansionRegion(org.eclipse.uml2.uml.ExpansionRegion object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementExpansionRegion(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseActivityPartition(org.eclipse.uml2.uml.ActivityPartition)
         * @generated
         */
        public GraphElement caseActivityPartition(org.eclipse.uml2.uml.ActivityPartition object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementActivityPartition(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseInitialNode(org.eclipse.uml2.uml.InitialNode)
         * @generated
         */
        public GraphElement caseInitialNode(org.eclipse.uml2.uml.InitialNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInitialNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDecisionNode(org.eclipse.uml2.uml.DecisionNode)
         * @generated
         */
        public GraphElement caseDecisionNode(org.eclipse.uml2.uml.DecisionNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDecisionNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseMergeNode(org.eclipse.uml2.uml.MergeNode)
         * @generated
         */
        public GraphElement caseMergeNode(org.eclipse.uml2.uml.MergeNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementMergeNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseForkNode(org.eclipse.uml2.uml.ForkNode)
         * @generated
         */
        public GraphElement caseForkNode(org.eclipse.uml2.uml.ForkNode object)
        {
            if ("default".equals(presentation) || "horizontal".equals(presentation))
            {
                return createGraphElementForkNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseJoinNode(org.eclipse.uml2.uml.JoinNode)
         * @generated
         */
        public GraphElement caseJoinNode(org.eclipse.uml2.uml.JoinNode object)
        {
            if ("default".equals(presentation) || "horizontal".equals(presentation))
            {
                return createGraphElementJoinNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseActivityFinalNode(org.eclipse.uml2.uml.ActivityFinalNode)
         * @generated
         */
        public GraphElement caseActivityFinalNode(org.eclipse.uml2.uml.ActivityFinalNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementActivityFinalNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseFlowFinalNode(org.eclipse.uml2.uml.FlowFinalNode)
         * @generated
         */
        public GraphElement caseFlowFinalNode(org.eclipse.uml2.uml.FlowFinalNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementFlowFinalNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseCallBehaviorAction(org.eclipse.uml2.uml.CallBehaviorAction)
         * @generated
         */
        public GraphElement caseCallBehaviorAction(org.eclipse.uml2.uml.CallBehaviorAction object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementCallBehaviorAction(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseCallOperationAction(org.eclipse.uml2.uml.CallOperationAction)
         * @generated
         */
        public GraphElement caseCallOperationAction(org.eclipse.uml2.uml.CallOperationAction object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementCallOperationAction(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseSendSignalAction(org.eclipse.uml2.uml.SendSignalAction)
         * @generated
         */
        public GraphElement caseSendSignalAction(org.eclipse.uml2.uml.SendSignalAction object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementSendSignalAction(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseAcceptEventAction(org.eclipse.uml2.uml.AcceptEventAction)
         * @generated
         */
        public GraphElement caseAcceptEventAction(org.eclipse.uml2.uml.AcceptEventAction object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementAcceptEventAction(object, presentation);
            }
            return null;
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseAction(org.eclipse.uml2.uml.Action)
         * @generated
         */
        public GraphElement caseAction(org.eclipse.uml2.uml.Action object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementAction(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseActivityParameterNode(org.eclipse.uml2.uml.ActivityParameterNode)
         * @generated
         */
        public GraphElement caseActivityParameterNode(org.eclipse.uml2.uml.ActivityParameterNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementActivityParameterNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseCentralBufferNode(org.eclipse.uml2.uml.CentralBufferNode)
         * @generated
         */
        public GraphElement caseCentralBufferNode(org.eclipse.uml2.uml.CentralBufferNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementCentralBufferNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDataStoreNode(org.eclipse.uml2.uml.DataStoreNode)
         * @generated
         */
        public GraphElement caseDataStoreNode(org.eclipse.uml2.uml.DataStoreNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDataStoreNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseExpansionNode(org.eclipse.uml2.uml.ExpansionNode)
         * @generated
         */
        public GraphElement caseExpansionNode(org.eclipse.uml2.uml.ExpansionNode object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementExpansionNode(object, presentation);
            }
            return null;
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseInputPin(org.eclipse.uml2.uml.InputPin)
         * @generated
         */
        public GraphElement caseInputPin(org.eclipse.uml2.uml.InputPin object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInputPin(object, presentation);
            }
            return null;
        }

        /**
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseOutputPin(org.eclipse.uml2.uml.OutputPin)
         * @generated
         */
        public GraphElement caseOutputPin(org.eclipse.uml2.uml.OutputPin object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementOutputPin(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseControlFlow(org.eclipse.uml2.uml.ControlFlow)
         * @generated
         */
        public GraphElement caseControlFlow(org.eclipse.uml2.uml.ControlFlow object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementControlFlow(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseObjectFlow(org.eclipse.uml2.uml.ObjectFlow)
         * @generated
         */
        public GraphElement caseObjectFlow(org.eclipse.uml2.uml.ObjectFlow object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementObjectFlow(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseExceptionHandler(org.eclipse.uml2.uml.ExceptionHandler)
         * @generated
         */
        public GraphElement caseExceptionHandler(org.eclipse.uml2.uml.ExceptionHandler object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementExceptionHandler(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         * @generated
         */
        public GraphElement caseComment(org.eclipse.uml2.uml.Comment object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementComment(object, presentation);
            }
            return null;
        }

        public GraphElement caseAcceptCallAction(org.eclipse.uml2.uml.AcceptCallAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseClearAssociationAction(org.eclipse.uml2.uml.ClearAssociationAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseCreateObjectAction(org.eclipse.uml2.uml.CreateObjectAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseDestroyObjectAction(org.eclipse.uml2.uml.DestroyObjectAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseBroadcastSignalAction(org.eclipse.uml2.uml.BroadcastSignalAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseSendObjectAction(org.eclipse.uml2.uml.SendObjectAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReadLinkAction(org.eclipse.uml2.uml.ReadLinkAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseCreateLinkAction(org.eclipse.uml2.uml.CreateLinkAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseCreateLinkObjectAction(org.eclipse.uml2.uml.CreateLinkObjectAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseDestroyLinkAction(org.eclipse.uml2.uml.DestroyLinkAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseOpaqueAction(org.eclipse.uml2.uml.OpaqueAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseRaiseExceptionAction(org.eclipse.uml2.uml.RaiseExceptionAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReadExtentAction(org.eclipse.uml2.uml.ReadExtentAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReadIsClassifiedObjectAction(org.eclipse.uml2.uml.ReadIsClassifiedObjectAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReadLinkObjectEndAction(org.eclipse.uml2.uml.ReadLinkObjectEndAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReadLinkObjectEndQualifierAction(org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReadSelfAction(org.eclipse.uml2.uml.ReadSelfAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReclassifyObjectAction(org.eclipse.uml2.uml.ReclassifyObjectAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReduceAction(org.eclipse.uml2.uml.ReduceAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReplyAction(org.eclipse.uml2.uml.ReplyAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseStartClassifierBehaviorAction(org.eclipse.uml2.uml.StartClassifierBehaviorAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseClearStructuralFeatureAction(org.eclipse.uml2.uml.ClearStructuralFeatureAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReadStructuralFeatureAction(org.eclipse.uml2.uml.ReadStructuralFeatureAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseAddStructuralFeatureValueAction(org.eclipse.uml2.uml.AddStructuralFeatureValueAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseRemoveStructuralFeatureValueAction(org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseStructuredActivityNode(org.eclipse.uml2.uml.StructuredActivityNode object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseConditionalNode(org.eclipse.uml2.uml.ConditionalNode object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseLoopNode(org.eclipse.uml2.uml.LoopNode object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseSequenceNode(org.eclipse.uml2.uml.SequenceNode object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseTestIdentityAction(org.eclipse.uml2.uml.TestIdentityAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseUnmarshallAction(org.eclipse.uml2.uml.UnmarshallAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseValueSpecificationAction(org.eclipse.uml2.uml.ValueSpecificationAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseClearVariableAction(org.eclipse.uml2.uml.ClearVariableAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseReadVariableAction(org.eclipse.uml2.uml.ReadVariableAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseAddVariableValueAction(org.eclipse.uml2.uml.AddVariableValueAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }
        public GraphElement caseRemoveVariableValueAction(org.eclipse.uml2.uml.RemoveVariableValueAction object) { if ("default".equals(presentation)) { return createGraphElementAction(object, presentation); } return null; }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public GraphElement defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;

        if ("http://www.eclipse.org/uml2/2.1.0/UML".equals(obj.eClass().getEPackage().getNsURI()))
        {
            graphElt = new GraphicUMLSwitch(presentation).doSwitch(obj);
        }

        if (graphElt instanceof GraphElement)
        {
            return (GraphElement) graphElt;
        }

        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementExpansionRegion(org.eclipse.uml2.uml.ExpansionRegion element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementActivityPartition(org.eclipse.uml2.uml.ActivityPartition element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInitialNode(org.eclipse.uml2.uml.InitialNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDecisionNode(org.eclipse.uml2.uml.DecisionNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementMergeNode(org.eclipse.uml2.uml.MergeNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementForkNode(org.eclipse.uml2.uml.ForkNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementJoinNode(org.eclipse.uml2.uml.JoinNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementActivityFinalNode(org.eclipse.uml2.uml.ActivityFinalNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementFlowFinalNode(org.eclipse.uml2.uml.FlowFinalNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementCallBehaviorAction(org.eclipse.uml2.uml.CallBehaviorAction element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementCallOperationAction(org.eclipse.uml2.uml.CallOperationAction element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementSendSignalAction(org.eclipse.uml2.uml.SendSignalAction element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementAcceptEventAction(org.eclipse.uml2.uml.AcceptEventAction element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementAction(org.eclipse.uml2.uml.Action element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementActivityParameterNode(org.eclipse.uml2.uml.ActivityParameterNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementCentralBufferNode(org.eclipse.uml2.uml.CentralBufferNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDataStoreNode(org.eclipse.uml2.uml.DataStoreNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementExpansionNode(org.eclipse.uml2.uml.ExpansionNode element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInputPin(org.eclipse.uml2.uml.InputPin element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementOutputPin(org.eclipse.uml2.uml.OutputPin element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementControlFlow(org.eclipse.uml2.uml.ControlFlow element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);

        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ActivityEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);

        EdgeObjectUV guardEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        guardEdgeObjectUV.setId(ActivityEdgeObjectConstants.GUARD_EDGE_OBJECT_ID);
        guardEdgeObjectUV.setUDistance(LABEL_OFFSET);
        guardEdgeObjectUV.setVDistance(LABEL_OFFSET);
        guardEdgeObjectUV.setVisible(false);
        graphEdge.getContained().add(guardEdgeObjectUV);

        EdgeObjectUV weightEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        weightEdgeObjectUV.setId(ActivityEdgeObjectConstants.WEIGHT_EDGE_OBJECT_ID);
        weightEdgeObjectUV.setUDistance(LABEL_OFFSET);
        weightEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        weightEdgeObjectUV.setVisible(false);
        graphEdge.getContained().add(weightEdgeObjectUV);

        EdgeObjectUV nameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        nameEdgeObjectUV.setId(ActivityEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectUV.setUDistance(LABEL_OFFSET);
        nameEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(nameEdgeObjectUV);

        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementObjectFlow(org.eclipse.uml2.uml.ObjectFlow element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);

        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ActivityEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);

        EdgeObjectUV guardEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        guardEdgeObjectUV.setId(ActivityEdgeObjectConstants.GUARD_EDGE_OBJECT_ID);
        guardEdgeObjectUV.setUDistance(LABEL_OFFSET);
        guardEdgeObjectUV.setVDistance(LABEL_OFFSET);
        guardEdgeObjectUV.setVisible(false);
        graphEdge.getContained().add(guardEdgeObjectUV);

        EdgeObjectUV weightEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        weightEdgeObjectUV.setId(ActivityEdgeObjectConstants.WEIGHT_EDGE_OBJECT_ID);
        weightEdgeObjectUV.setUDistance(LABEL_OFFSET);
        weightEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        weightEdgeObjectUV.setVisible(false);
        graphEdge.getContained().add(weightEdgeObjectUV);

        EdgeObjectUV nameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        nameEdgeObjectUV.setId(ActivityEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectUV.setUDistance(LABEL_OFFSET);
        nameEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(nameEdgeObjectUV);

        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementExceptionHandler(org.eclipse.uml2.uml.ExceptionHandler element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectUV exceptiontypeEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        exceptiontypeEdgeObjectUV.setId(ActivityEdgeObjectConstants.EXCEPTIONTYPE_EDGE_OBJECT_ID);
        exceptiontypeEdgeObjectUV.setUDistance(LABEL_OFFSET);
        exceptiontypeEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(exceptiontypeEdgeObjectUV);
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ActivityEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComment(org.eclipse.uml2.uml.Comment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated
     */
    public EObject createModelObject(EObject obj)
    {
        return obj;
    }

}
