/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram;

/**
 * A collection of Roles. Each identifier is used to key the EditPolicy. <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public interface ActivityEditPolicyConstants
{

    /** The key used to install an <i>Element</i> EditPolicy. */
    String ELEMENT_EDITPOLICY = "Element EditPolicy";

    /** The key used to install an <i>ActivityNode</i> EditPolicy. */
    String ACTIVITYNODE_EDITPOLICY = "ActivityNode EditPolicy";

    /** The key used to install an <i>ControlNode</i> EditPolicy. */
    String CONTROLNODE_EDITPOLICY = "ControlNode EditPolicy";

    /** The key used to install an <i>ObjectNode</i> EditPolicy. */
    String OBJECTNODE_EDITPOLICY = "ObjectNode EditPolicy";

    /** The key used to install an <i>InitialNode</i> EditPolicy. */
    String INITIALNODE_EDITPOLICY = "InitialNode EditPolicy";

    /** The key used to install an <i>DecisionNode</i> EditPolicy. */
    String DECISIONNODE_EDITPOLICY = "DecisionNode EditPolicy";

    /** The key used to install an <i>MergeNode</i> EditPolicy. */
    String MERGENODE_EDITPOLICY = "MergeNode EditPolicy";

    /** The key used to install an <i>ForkNode</i> EditPolicy. */
    String FORKNODE_EDITPOLICY = "ForkNode EditPolicy";

    /** The key used to install an <i>JoinNode</i> EditPolicy. */
    String JOINNODE_EDITPOLICY = "JoinNode EditPolicy";

    /** The key used to install an <i>ActivityFinalNode</i> EditPolicy. */
    String ACTIVITYFINALNODE_EDITPOLICY = "ActivityFinalNode EditPolicy";

    /** The key used to install an <i>FlowFinalNode</i> EditPolicy. */
    String FLOWFINALNODE_EDITPOLICY = "FlowFinalNode EditPolicy";

    /** The key used to install an <i>CentralBufferNode</i> EditPolicy. */
    String CENTRALBUFFERNODE_EDITPOLICY = "CentralBufferNode EditPolicy";

    /** The key used to install an <i>DataStoreNode</i> EditPolicy. */
    String DATASTORENODE_EDITPOLICY = "DataStoreNode EditPolicy";

    /** The key used to install an <i>ActivityParameterNode</i> EditPolicy. */
    String ACTIVITYPARAMETERNODE_EDITPOLICY = "ActivityParameterNode EditPolicy";

    /** The key used to install an <i>ExpansionNode</i> EditPolicy. */
    String EXPANSIONNODE_EDITPOLICY = "ExpansionNode EditPolicy";

    /** The key used to install an <i>ExecutableNode</i> EditPolicy. */
    String EXECUTABLENODE_EDITPOLICY = "ExecutableNode EditPolicy";

    /** The key used to install an <i>Action</i> EditPolicy. */
    String ACTION_EDITPOLICY = "Action EditPolicy";

    /** The key used to install an <i>CallBehaviorAction</i> EditPolicy. */
    String CALLBEHAVIORACTION_EDITPOLICY = "CallBehaviorAction EditPolicy";

    /** The key used to install an <i>CallOperationAction</i> EditPolicy. */
    String CALLOPERATIONACTION_EDITPOLICY = "CallOperationAction EditPolicy";

    /** The key used to install an <i>ExpansionRegion</i> EditPolicy. */
    String EXPANSIONREGION_EDITPOLICY = "ExpansionRegion EditPolicy";

    /**
     * The key used to install an <i>InputPin</i> EditPolicy.
     * 
     * @generated
     */
    String INPUTPIN_EDITPOLICY = "InputPin EditPolicy";

    /**
     * The key used to install an <i>OutputPin</i> EditPolicy.
     * 
     * @generated
     */
    String OUTPUTPIN_EDITPOLICY = "OutputPin EditPolicy";

    /** The key used to install an <i>ActivityPartition</i> EditPolicy. */
    String ACTIVITYPARTITION_EDITPOLICY = "ActivityPartition EditPolicy";

    /** The key used to install an <i>ExceptionHandler</i> EditPolicy. */
    String EXCEPTIONHANDLER_EDITPOLICY = "ExceptionHandler EditPolicy";

    /** The key used to install an <i>ControlFlow</i> EditPolicy. */
    String CONTROLFLOW_EDITPOLICY = "ControlFlow EditPolicy";

    /** The key used to install an <i>ObjectFlow</i> EditPolicy. */
    String OBJECTFLOW_EDITPOLICY = "ObjectFlow EditPolicy";

    /** The key used to install an <i>Comment</i> EditPolicy. */
    String COMMENT_EDITPOLICY = "Comment EditPolicy";

    /** The key used to install an <i>CommentLink</i> EditPolicy. */
    String COMMENTLINK_EDITPOLICY = "CommentLink EditPolicy";

    /** The key used to install an <i>SendSignalAction</i> EditPolicy. */
    String SENDSIGNALACTION_EDITPOLICY = "SendSignalAction EditPolicy";

    /** The key used to install an <i>AcceptEventAction</i> EditPolicy. */
    String ACCEPTEVENTACTION_EDITPOLICY = "AcceptEventAction EditPolicy";

}