/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteEntry;
import org.eclipse.gef.palette.PaletteStack;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.uml2.uml.ActivityParameterNode;
import org.eclipse.uml2.uml.CentralBufferNode;
import org.eclipse.uml2.uml.ControlFlow;
import org.eclipse.uml2.uml.DataStoreNode;
import org.eclipse.uml2.uml.ExpansionNode;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.LiteralBoolean;
import org.eclipse.uml2.uml.LiteralInteger;
import org.eclipse.uml2.uml.LiteralUnlimitedNatural;
import org.eclipse.uml2.uml.ObjectFlow;
import org.eclipse.uml2.uml.OutputPin;
import org.eclipse.uml2.uml.UMLFactory;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;

/**
 * Generated Palette Manager <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ActivityPaletteManager extends ModelerPaletteManager
{
    // declare all the palette categories of the diagram
    private PaletteDrawer commonDrawer;

    private PaletteDrawer controlDrawer;

    private PaletteDrawer actionsDrawer;

    private PaletteDrawer objectDrawer;

    private PaletteDrawer connectionsDrawer;

    private PaletteDrawer commentDrawer;

    private ICreationUtils creationUtils;

    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param utils the creation utils for the tools of the palette
     * @generated
     */
    public ActivityPaletteManager(ICreationUtils utils)
    {
        super();
        this.creationUtils = utils;
    }

    /**
     * Creates the main categories of the palette <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createCategories()
    {
        createCommonDrawer();
        createControlDrawer();
        createActionsDrawer();
        createObjectDrawer();
        createConnectionsDrawer();
        createCommentDrawer();
    }

    /**
     * Updates the main categories of the palette <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void updateCategories()
    {
        // deletion of the existing categories and creation of the updated categories

        getRoot().remove(commonDrawer);
        createCommonDrawer();

        getRoot().remove(controlDrawer);
        createControlDrawer();

        getRoot().remove(actionsDrawer);
        createActionsDrawer();

        getRoot().remove(objectDrawer);
        createObjectDrawer();

        getRoot().remove(connectionsDrawer);
        createConnectionsDrawer();

        getRoot().remove(commentDrawer);
        createCommentDrawer();
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private void createCommonDrawer()
    {
        commonDrawer = new PaletteDrawer("Common", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getActivityPartition(), "default");
        entries.add(new ModelerCreationToolEntry("Activity Partition", "Activity Partition", factory, ActivityImageRegistry.getImageDescriptor("ACTIVITYPARTITION"),
                ActivityImageRegistry.getImageDescriptor("ACTIVITYPARTITION_LARGE")));

        commonDrawer.addAll(entries);
        getRoot().add(commonDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private void createControlDrawer()
    {
        controlDrawer = new PaletteDrawer("Control", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getInitialNode(), "default");
        entries.add(new ModelerCreationToolEntry("Initial Node", "Initial Node", factory, ActivityImageRegistry.getImageDescriptor("INITIALNODE"),
                ActivityImageRegistry.getImageDescriptor("INITIALNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDecisionNode(), "default");
        entries.add(new ModelerCreationToolEntry("Decision Node", "Decision Node", factory, ActivityImageRegistry.getImageDescriptor("DECISIONNODE"),
                ActivityImageRegistry.getImageDescriptor("DECISIONNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getMergeNode(), "default");
        entries.add(new ModelerCreationToolEntry("Merge Node", "Merge Node", factory, ActivityImageRegistry.getImageDescriptor("MERGENODE"),
                ActivityImageRegistry.getImageDescriptor("MERGENODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getForkNode(), "default");
        entries.add(new ModelerCreationToolEntry("Fork Node", "Fork Node", factory, ActivityImageRegistry.getImageDescriptor("FORKNODE"), ActivityImageRegistry.getImageDescriptor("FORKNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getJoinNode(), "default");
        entries.add(new ModelerCreationToolEntry("Join Node", "Join Node", factory, ActivityImageRegistry.getImageDescriptor("JOINNODE"), ActivityImageRegistry.getImageDescriptor("JOINNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getActivityFinalNode(), "default");
        entries.add(new ModelerCreationToolEntry("Activity Final", "Activity Final", factory, ActivityImageRegistry.getImageDescriptor("ACTIVITYFINALNODE"),
                ActivityImageRegistry.getImageDescriptor("ACTIVITYFINALNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getFlowFinalNode(), "default");
        entries.add(new ModelerCreationToolEntry("Flow Final", "Flow Final", factory, ActivityImageRegistry.getImageDescriptor("FLOWFINALNODE"),
                ActivityImageRegistry.getImageDescriptor("FLOWFINALNODE_LARGE")));

        controlDrawer.addAll(entries);
        getRoot().add(controlDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated NOT
     */
    private void createActionsDrawer()
    {
        actionsDrawer = new PaletteDrawer("Actions", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();
        CreationFactory factory;
        PaletteEntry defaultPaletteEntry;

        PaletteStack invocationActionsStack = new PaletteStack("Call Behavior Action", "Call Behavior Action", ActivityImageRegistry.getImageDescriptor("CALLBEHAVIORACTION"));
        PaletteStack linkActionsStack = new PaletteStack("Read Link Action", "Read Link Action", ActivityImageRegistry.getImageDescriptor("READLINKACTION"));
        PaletteStack structuralFeatureActionsStack = new PaletteStack("Read Structural Feature Action", "Read Structural Feature Action",
                ActivityImageRegistry.getImageDescriptor("READSTRUCTURALFEATUREACTION"));
        PaletteStack structuredActivityNodesStack = new PaletteStack("Expansion Region", "Expansion Region", ActivityImageRegistry.getImageDescriptor("EXPANSIONREGION"));
        PaletteStack variableActionsStack = new PaletteStack("Read Variable Action", "Read Variable Action", ActivityImageRegistry.getImageDescriptor("READVARIABLEACTION"));
        PaletteStack otherActionsStack = new PaletteStack("Accept Event Action", "Accept Event Action", ActivityImageRegistry.getImageDescriptor("ACCEPTEVENTACTION"));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAcceptEventAction(), "default");
        defaultPaletteEntry = new ModelerCreationToolEntry("Accept Event Action", "Accept Event Action", factory, ActivityImageRegistry.getImageDescriptor("ACCEPTEVENTACTION"),
                ActivityImageRegistry.getImageDescriptor("ACCEPTEVENTACTION_LARGE"));
        otherActionsStack.add(defaultPaletteEntry);
        otherActionsStack.setActiveEntry(defaultPaletteEntry);

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAcceptCallAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Accept Call Action", "Accept Call Action", factory, ActivityImageRegistry.getImageDescriptor("ACCEPTCALLACTION"),
                ActivityImageRegistry.getImageDescriptor("ACCEPTCALLACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getClearAssociationAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Clear Association Action", "Clear Association Action", factory, ActivityImageRegistry.getImageDescriptor("CLEARASSOCIATIONACTION"),
                ActivityImageRegistry.getImageDescriptor("CLEARASSOCIATIONACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getCreateObjectAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Create Object Action", "Create Object Action", factory, ActivityImageRegistry.getImageDescriptor("CREATEOBJECTACTION"),
                ActivityImageRegistry.getImageDescriptor("CREATEOBJECTACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDestroyObjectAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Destroy Object Action", "Destroy Object Action", factory, ActivityImageRegistry.getImageDescriptor("DESTROYOBJECTACTION"),
                ActivityImageRegistry.getImageDescriptor("DESTROYOBJECTACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getBroadcastSignalAction(), "default");
        invocationActionsStack.add(new ModelerCreationToolEntry("Broadcast Signal Action", "Broadcast Signal Action", factory, ActivityImageRegistry.getImageDescriptor("BROADCASTSIGNALACTION"),
                ActivityImageRegistry.getImageDescriptor("BROADCASTSIGNALACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getCallBehaviorAction(), "default");
        defaultPaletteEntry = new ModelerCreationToolEntry("Call Behavior Action", "Call Behavior Action", factory, ActivityImageRegistry.getImageDescriptor("CALLBEHAVIORACTION"),
                ActivityImageRegistry.getImageDescriptor("CALLBEHAVIORACTION_LARGE"));
        invocationActionsStack.add(defaultPaletteEntry);
        invocationActionsStack.setActiveEntry(defaultPaletteEntry);

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getCallOperationAction(), "default");
        invocationActionsStack.add(new ModelerCreationToolEntry("Call Operation Action", "Call Operation Action", factory, ActivityImageRegistry.getImageDescriptor("CALLOPERATIONACTION"),
                ActivityImageRegistry.getImageDescriptor("CALLOPERATIONACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getSendObjectAction(), "default");
        invocationActionsStack.add(new ModelerCreationToolEntry("Send Object Action", "Send Object Action", factory, ActivityImageRegistry.getImageDescriptor("SENDOBJECTACTION"),
                ActivityImageRegistry.getImageDescriptor("SENDOBJECTACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getSendSignalAction(), "default");
        invocationActionsStack.add(new ModelerCreationToolEntry("Send Signal Action", "Send Signal Action", factory, ActivityImageRegistry.getImageDescriptor("SENDSIGNALACTION"),
                ActivityImageRegistry.getImageDescriptor("SENDSIGNALACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReadLinkAction(), "default");
        defaultPaletteEntry = new ModelerCreationToolEntry("Read Link Action", "Read Link Action", factory, ActivityImageRegistry.getImageDescriptor("READLINKACTION"),
                ActivityImageRegistry.getImageDescriptor("READLINKACTION_LARGE"));
        linkActionsStack.add(defaultPaletteEntry);
        linkActionsStack.setActiveEntry(defaultPaletteEntry);

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getCreateLinkAction(), "default");
        linkActionsStack.add(new ModelerCreationToolEntry("Create Link Action", "Create Link Action", factory, ActivityImageRegistry.getImageDescriptor("CREATELINKACTION"),
                ActivityImageRegistry.getImageDescriptor("CREATELINKACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getCreateLinkObjectAction(), "default");
        linkActionsStack.add(new ModelerCreationToolEntry("Create Link Object Action", "Create Link Object Action", factory, ActivityImageRegistry.getImageDescriptor("CREATELINKOBJECTACTION"),
                ActivityImageRegistry.getImageDescriptor("CREATELINKOBJECTACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDestroyLinkAction(), "default");
        linkActionsStack.add(new ModelerCreationToolEntry("Destroy Link Action", "Destroy Link Action", factory, ActivityImageRegistry.getImageDescriptor("DESTROYLINKACTION"),
                ActivityImageRegistry.getImageDescriptor("DESTROYLINKACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getOpaqueAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Opaque Action", "Opaque Action", factory, ActivityImageRegistry.getImageDescriptor("OPAQUEACTION"),
                ActivityImageRegistry.getImageDescriptor("OPAQUEACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getRaiseExceptionAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Raise Exception Action", "Raise Exception Action", factory, ActivityImageRegistry.getImageDescriptor("RAISEEXCEPTIONACTION"),
                ActivityImageRegistry.getImageDescriptor("RAISEEXCEPTIONACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReadExtentAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Read Extent Action", "Read Extent Action", factory, ActivityImageRegistry.getImageDescriptor("READEXTENTACTION"),
                ActivityImageRegistry.getImageDescriptor("READEXTENTACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReadIsClassifiedObjectAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Read Is Classified Object Action", "Read Is Classified Object Action", factory,
                ActivityImageRegistry.getImageDescriptor("READISCLASSIFIEDOBJECTACTION"), ActivityImageRegistry.getImageDescriptor("READISCLASSIFIEDOBJECTACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReadLinkObjectEndAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Read Link Object End Action", "Read Link Object End Action", factory, ActivityImageRegistry.getImageDescriptor("READLINKOBJECTENDACTION"),
                ActivityImageRegistry.getImageDescriptor("READLINKOBJECTENDACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReadLinkObjectEndQualifierAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Read Link Object End Qualifier Action", "Read Link Object End Qualifier Action", factory,
                ActivityImageRegistry.getImageDescriptor("READLINKOBJECTENDQUALIFIERACTION"), ActivityImageRegistry.getImageDescriptor("READLINKOBJECTENDQUALIFIERACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReadSelfAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Read Self Action", "Read Self Action", factory, ActivityImageRegistry.getImageDescriptor("READSELFACTION"),
                ActivityImageRegistry.getImageDescriptor("READSELFACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReclassifyObjectAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Reclassify Object Action", "Reclassify Object Action", factory, ActivityImageRegistry.getImageDescriptor("RECLASSIFYOBJECTACTION"),
                ActivityImageRegistry.getImageDescriptor("RECLASSIFYOBJECTACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReduceAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Reduce Action", "Reduce Action", factory, ActivityImageRegistry.getImageDescriptor("REDUCEACTION"),
                ActivityImageRegistry.getImageDescriptor("REDUCEACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReplyAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Reply Action", "Reply Action", factory, ActivityImageRegistry.getImageDescriptor("REPLYACTION"),
                ActivityImageRegistry.getImageDescriptor("REPLYACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getStartClassifierBehaviorAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Start Classifier Behavior Action", "Start Classifier Behavior Action", factory,
                ActivityImageRegistry.getImageDescriptor("STARTCLASSIFIERBEHAVIORACTION"), ActivityImageRegistry.getImageDescriptor("STARTCLASSIFIERBEHAVIORACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getClearStructuralFeatureAction(), "default");
        structuralFeatureActionsStack.add(new ModelerCreationToolEntry("Clear Structural Feature Action", "Clear Structural Feature Action", factory,
                ActivityImageRegistry.getImageDescriptor("CLEARSTRUCTURALFEATUREACTION"), ActivityImageRegistry.getImageDescriptor("CLEARSTRUCTURALFEATUREACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReadStructuralFeatureAction(), "default");
        defaultPaletteEntry = new ModelerCreationToolEntry("Read Structural Feature Action", "Read Structural Feature Action", factory,
                ActivityImageRegistry.getImageDescriptor("READSTRUCTURALFEATUREACTION"), ActivityImageRegistry.getImageDescriptor("READSTRUCTURALFEATUREACTION_LARGE"));
        structuralFeatureActionsStack.add(defaultPaletteEntry);
        structuralFeatureActionsStack.setActiveEntry(defaultPaletteEntry);

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAddStructuralFeatureValueAction(), "default");
        structuralFeatureActionsStack.add(new ModelerCreationToolEntry("Add Structural Feature Value Action", "Add Structural Feature Value Action", factory,
                ActivityImageRegistry.getImageDescriptor("ADDSTRUCTURALFEATUREVALUEACTION"), ActivityImageRegistry.getImageDescriptor("ADDSTRUCTURALFEATUREVALUEACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getRemoveStructuralFeatureValueAction(), "default");
        structuralFeatureActionsStack.add(new ModelerCreationToolEntry("Remove Structural Feature Value Action", "Remove Structural Feature Value Action", factory,
                ActivityImageRegistry.getImageDescriptor("REMOVESTRUCTURALFEATUREVALUEACTION"), ActivityImageRegistry.getImageDescriptor("REMOVESTRUCTURALFEATUREVALUEACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getStructuredActivityNode(), "default");
        structuredActivityNodesStack.add(new ModelerCreationToolEntry("Structured Activity Node", "Structured Activity Node", factory, ActivityImageRegistry.getImageDescriptor("STRUCTUREDACTIVITY"),
                ActivityImageRegistry.getImageDescriptor("STRUCTUREDACTIVITY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getConditionalNode(), "default");
        structuredActivityNodesStack.add(new ModelerCreationToolEntry("Conditional Node", "Conditional Node", factory, ActivityImageRegistry.getImageDescriptor("CONDITIONALNODE"),
                ActivityImageRegistry.getImageDescriptor("CONDITIONALNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getExpansionRegion(), "default");
        defaultPaletteEntry = new ModelerCreationToolEntry("Expansion Region", "Expansion Region", factory, ActivityImageRegistry.getImageDescriptor("EXPANSIONREGION"),
                ActivityImageRegistry.getImageDescriptor("EXPANSIONREGION_LARGE"));
        structuredActivityNodesStack.add(defaultPaletteEntry);
        structuredActivityNodesStack.setActiveEntry(defaultPaletteEntry);

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getLoopNode(), "default");
        structuredActivityNodesStack.add(new ModelerCreationToolEntry("Loop Node", "Loop Node", factory, ActivityImageRegistry.getImageDescriptor("LOOPNODE"),
                ActivityImageRegistry.getImageDescriptor("LOOPNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getSequenceNode(), "default");
        structuredActivityNodesStack.add(new ModelerCreationToolEntry("Sequence Node", "Sequence Node", factory, ActivityImageRegistry.getImageDescriptor("SEQUENCENODE"),
                ActivityImageRegistry.getImageDescriptor("SEQUENCENODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getTestIdentityAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Test Identity Action", "Test Identity Action", factory, ActivityImageRegistry.getImageDescriptor("TESTIDENTITYACTION"),
                ActivityImageRegistry.getImageDescriptor("TESTIDENTITYACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getUnmarshallAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Unmarshall Action", "Unmarshall Action", factory, ActivityImageRegistry.getImageDescriptor("UNMARSHALLACTION"),
                ActivityImageRegistry.getImageDescriptor("UNMARSHALLACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getValueSpecificationAction(), "default");
        otherActionsStack.add(new ModelerCreationToolEntry("Value Specification Action", "Value Specification Action", factory, ActivityImageRegistry.getImageDescriptor("VALUESPECIFICATIONACTION"),
                ActivityImageRegistry.getImageDescriptor("VALUESPECIFICATIONACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getClearVariableAction(), "default");
        variableActionsStack.add(new ModelerCreationToolEntry("Clear Variable Action", "Clear Variable Action", factory, ActivityImageRegistry.getImageDescriptor("CLEARVARIABLEACTION"),
                ActivityImageRegistry.getImageDescriptor("CLEARVARIABLEACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getReadVariableAction(), "default");
        defaultPaletteEntry = new ModelerCreationToolEntry("Read Variable Action", "Read Variable Action", factory, ActivityImageRegistry.getImageDescriptor("READVARIABLEACTION"),
                ActivityImageRegistry.getImageDescriptor("READVARIABLEACTION_LARGE"));
        variableActionsStack.add(defaultPaletteEntry);
        variableActionsStack.setActiveEntry(defaultPaletteEntry);

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAddVariableValueAction(), "default");
        variableActionsStack.add(new ModelerCreationToolEntry("Add Variable Value Action", "Add Variable Value Action", factory, ActivityImageRegistry.getImageDescriptor("ADDVARIABLEVALUEACTION"),
                ActivityImageRegistry.getImageDescriptor("ADDVARIABLEVALUEACTION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getRemoveVariableValueAction(), "default");
        variableActionsStack.add(new ModelerCreationToolEntry("Remove Variable Value Action", "Remove Variable Value Action", factory,
                ActivityImageRegistry.getImageDescriptor("REMOVEVARIABLEVALUEACTION"), ActivityImageRegistry.getImageDescriptor("REMOVEVARIABLEVALUEACTION_LARGE")));

        entries.add(invocationActionsStack);
        entries.add(linkActionsStack);
        entries.add(structuralFeatureActionsStack);
        entries.add(structuredActivityNodesStack);
        entries.add(variableActionsStack);
        entries.add(otherActionsStack);

        actionsDrawer.addAll(entries);
        getRoot().add(actionsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private void createObjectDrawer()
    {
        objectDrawer = new PaletteDrawer("Object", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getActivityParameterNode(), "default")
        {
            public EObject getNewModelObject()
            {
                ActivityParameterNode element = (ActivityParameterNode) super.getNewModelObject();
                LiteralUnlimitedNatural upperBound = UMLFactory.eINSTANCE.createLiteralUnlimitedNatural();
                upperBound.setValue(-1);
                element.setUpperBound(upperBound);
                return element;
            }
        };
        entries.add(new ModelerCreationToolEntry("Activity Parameter", "Activity Parameter", factory, ActivityImageRegistry.getImageDescriptor("ACTIVITYPARAMETERNODE"),
                ActivityImageRegistry.getImageDescriptor("ACTIVITYPARAMETERNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getCentralBufferNode(), "default")
        {
            public EObject getNewModelObject()
            {
                CentralBufferNode element = (CentralBufferNode) super.getNewModelObject();
                LiteralUnlimitedNatural upperBound = UMLFactory.eINSTANCE.createLiteralUnlimitedNatural();
                upperBound.setValue(-1);
                element.setUpperBound(upperBound);
                return element;
            }
        };
        entries.add(new ModelerCreationToolEntry("Central Buffer", "Central Buffer", factory, ActivityImageRegistry.getImageDescriptor("CENTRALBUFFERNODE"),
                ActivityImageRegistry.getImageDescriptor("CENTRALBUFFERNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDataStoreNode(), "default")
        {
            public EObject getNewModelObject()
            {
                DataStoreNode element = (DataStoreNode) super.getNewModelObject();
                LiteralUnlimitedNatural upperBound = UMLFactory.eINSTANCE.createLiteralUnlimitedNatural();
                upperBound.setValue(-1);
                element.setUpperBound(upperBound);
                return element;
            }
        };
        entries.add(new ModelerCreationToolEntry("DataStore", "DataStore", factory, ActivityImageRegistry.getImageDescriptor("DATASTORENODE"),
                ActivityImageRegistry.getImageDescriptor("DATASTORENODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getExpansionNode(), "default")
        {
            public EObject getNewModelObject()
            {
                ExpansionNode element = (ExpansionNode) super.getNewModelObject();
                LiteralUnlimitedNatural upperBound = UMLFactory.eINSTANCE.createLiteralUnlimitedNatural();
                upperBound.setValue(-1);
                element.setUpperBound(upperBound);
                return element;
            }
        };
        entries.add(new ModelerCreationToolEntry("Expansion", "Expansion", factory, ActivityImageRegistry.getImageDescriptor("EXPANSIONNODE"),
                ActivityImageRegistry.getImageDescriptor("EXPANSIONNODE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getInputPin(), "default")
        {
            public EObject getNewModelObject()
            {
                InputPin element = (InputPin) super.getNewModelObject();
                LiteralUnlimitedNatural upperBound = UMLFactory.eINSTANCE.createLiteralUnlimitedNatural();
                upperBound.setValue(-1);
                element.setUpperBound(upperBound);
                return element;
            }
        };
        entries.add(new ModelerCreationToolEntry("Input Pin", "Input Pin", factory, ActivityImageRegistry.getImageDescriptor("INPUTPIN"), ActivityImageRegistry.getImageDescriptor("INPUTPIN_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getOutputPin(), "default")
        {
            public EObject getNewModelObject()
            {
                OutputPin element = (OutputPin) super.getNewModelObject();
                LiteralUnlimitedNatural upperBound = UMLFactory.eINSTANCE.createLiteralUnlimitedNatural();
                upperBound.setValue(-1);
                element.setUpperBound(upperBound);
                return element;
            }
        };
        entries.add(new ModelerCreationToolEntry("Output Pin", "Output Pin", factory, ActivityImageRegistry.getImageDescriptor("OUTPUTPIN"),
                ActivityImageRegistry.getImageDescriptor("OUTPUTPIN_LARGE")));

        objectDrawer.addAll(entries);
        getRoot().add(objectDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private void createConnectionsDrawer()
    {
        connectionsDrawer = new PaletteDrawer("Connections", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getControlFlow(), "default")
        {
            public EObject getNewModelObject()
            {
                ControlFlow element = (ControlFlow) super.getNewModelObject();
                LiteralBoolean guard = UMLFactory.eINSTANCE.createLiteralBoolean();
                LiteralInteger weight = UMLFactory.eINSTANCE.createLiteralInteger();
                guard.setValue(true);
                weight.setValue(1);
                element.setGuard(guard);
                element.setWeight(weight);
                return element;
            }
        };
        entries.add(new ModelerConnectionCreationToolEntry("Control Flow", "Control Flow", factory, ActivityImageRegistry.getImageDescriptor("CONTROLFLOW"),
                ActivityImageRegistry.getImageDescriptor("CONTROLFLOW_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getObjectFlow(), "default")
        {
            public EObject getNewModelObject()
            {
                ObjectFlow element = (ObjectFlow) super.getNewModelObject();
                LiteralBoolean guard = UMLFactory.eINSTANCE.createLiteralBoolean();
                LiteralInteger weight = UMLFactory.eINSTANCE.createLiteralInteger();
                guard.setValue(true);
                weight.setValue(1);
                element.setGuard(guard);
                element.setWeight(weight);
                return element;
            }
        };
        entries.add(new ModelerConnectionCreationToolEntry("Object Flow", "Object Flow", factory, ActivityImageRegistry.getImageDescriptor("OBJECTFLOW"),
                ActivityImageRegistry.getImageDescriptor("OBJECTFLOW_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getExceptionHandler(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Exception Handler", "Exception Handler", factory, ActivityImageRegistry.getImageDescriptor("EXCEPTIONHANDLER"),
                ActivityImageRegistry.getImageDescriptor("EXCEPTIONHANDLER_LARGE")));

        connectionsDrawer.addAll(entries);
        getRoot().add(connectionsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private void createCommentDrawer()
    {
        commentDrawer = new PaletteDrawer("Comment", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getComment(), "default");
        entries.add(new ModelerCreationToolEntry("Comment", "Comment", factory, ActivityImageRegistry.getImageDescriptor("COMMENT"), ActivityImageRegistry.getImageDescriptor("COMMENT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, ActivitySimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK, "default", false);
        entries.add(new ModelerConnectionCreationToolEntry("Comment Link", "Comment Link", factory, ActivityImageRegistry.getImageDescriptor("COMMENTLINK"),
                ActivityImageRegistry.getImageDescriptor("COMMENTLINK_LARGE")));

        commentDrawer.addAll(entries);
        getRoot().add(commentDrawer);
    }

}
