/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.uml2.uml.Element;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.PortEditPart;
import org.topcased.modeler.edit.policies.LabelDirectEditPolicy;
import org.topcased.modeler.edit.policies.ResizableEditPolicy;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.uml.UMLLabel;
import org.topcased.modeler.uml.activitydiagram.ActivityEditPolicyConstants;
import org.topcased.modeler.uml.activitydiagram.commands.ActivityParameterNodeRestoreConnectionCommand;
import org.topcased.modeler.uml.activitydiagram.figures.ActivityParameterNodeFigure;
import org.topcased.modeler.uml.activitydiagram.policies.ControlFlowEdgeCreationEditPolicy;
import org.topcased.modeler.uml.activitydiagram.policies.ExceptionHandlerEdgeCreationEditPolicy;
import org.topcased.modeler.uml.activitydiagram.policies.ObjectFlowEdgeCreationEditPolicy;

/**
 * The ActivityParameterNode object controller <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated NOT
 */
public class ActivityParameterNodeEditPart extends PortEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public ActivityParameterNodeEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ActivityEditPolicyConstants.CONTROLFLOW_EDITPOLICY, new ControlFlowEdgeCreationEditPolicy());
        installEditPolicy(ActivityEditPolicyConstants.OBJECTFLOW_EDITPOLICY, new ObjectFlowEdgeCreationEditPolicy());
        installEditPolicy(ActivityEditPolicyConstants.EXCEPTIONHANDLER_EDITPOLICY, new ExceptionHandlerEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new ActivityParameterNodeRestoreConnectionCommand(getHost());
            }
        });

        installEditPolicy(ModelerEditPolicyConstants.RESIZABLE_EDITPOLICY, new ResizableEditPolicy());

        installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LabelDirectEditPolicy());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated NOT
     */
    protected IFigure createFigure()
    {
        return new ActivityParameterNodeFigure();
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#refreshHeaderLabel()
     */
    protected void refreshHeaderLabel()
    {
        ComposedLabel composedLabel = (ComposedLabel) getLabel();

        // Update the stereotype label
        composedLabel.setPrefix(UMLLabel.getStereotypesNotation((Element) getEObject()));

        super.refreshHeaderLabel();
    }
}