/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Operation;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.draw2d.figures.EditableLabel;
import org.topcased.draw2d.figures.ILabel;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.uml.UMLLabel;

/**
 * The CallOperationAction object controller <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class CallOperationActionEditPart extends ActionEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public CallOperationActionEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated NOT
     */
    protected IFigure createFigure()
    {
        return super.createFigure();
    }

    /**
     * @see org.topcased.modeler.uml.activitydiagram.edit.ActionEditPart#refreshHeaderLabel()
     */
    @Override
    protected void refreshHeaderLabel()
    {
        ComposedLabel composedLabel = (ComposedLabel) getLabel();

        // Update the stereotype label
        composedLabel.setPrefix(UMLLabel.getStereotypesNotation((Element) getEObject()));

        // Bug#1236 : Display the operation name when relevant
        Operation operation = ((CallOperationAction) getEObject()).getOperation();
        if (operation != null && operation.getName() != null && !"".equals(operation.getName()))
        {
            composedLabel.setMain(operation.getName());
        }
        else
        {
            composedLabel.setMain(((CallOperationAction) getEObject()).getName());
        }
    }

    /**
     * @see org.topcased.modeler.edit.GraphNodeEditPart#getEditableLabel()
     */
    @Override
    public ILabel getEditableLabel()
    {
        Operation operation = ((CallOperationAction) getEObject()).getOperation();
        if (operation != null && operation.getName() != null && !"".equals(operation.getName()))
        {
            return null;
        }
        else
        {
            return super.getEditableLabel();
        }
    }

    /**
     * @see org.topcased.modeler.edit.GraphNodeEditPart#setSelected(int)
     */
    @Override
    public void setSelected(int value)
    {
        super.setSelected(value);

        Operation operation = ((CallOperationAction) getEObject()).getOperation();
        if (operation != null && operation.getName() != null && !"".equals(operation.getName()))
        {
            if (getLabel() instanceof EditableLabel)
            {
                EditableLabel lbl = (EditableLabel) getLabel();
                lbl.setSelected(false);
            }
            else if (getLabel() instanceof ComposedLabel)
            {
                ComposedLabel lbl = (ComposedLabel) getLabel();
                lbl.setSelected(false);
            }
        }
        else
        {
            if (getLabel() instanceof EditableLabel)
            {
                EditableLabel lbl = (EditableLabel) getLabel();
                lbl.setSelected(value != 0);
            }
            else if (getLabel() instanceof ComposedLabel)
            {
                ComposedLabel lbl = (ComposedLabel) getLabel();
                lbl.setSelected(value != 0);
            }
        }
    }
}