/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.uml2.uml.ExpansionKind;
import org.eclipse.uml2.uml.ExpansionRegion;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.uml.activitydiagram.commands.ExpansionRegionRestoreConnectionCommand;
import org.topcased.modeler.uml.activitydiagram.figures.ExpansionRegionFigure;
import org.topcased.modeler.uml.activitydiagram.policies.ExpansionRegionLayoutEditPolicy;

/**
 * The ExpansionRegion object controller <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ExpansionRegionEditPart extends ActionEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public ExpansionRegionEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new ExpansionRegionRestoreConnectionCommand(getHost());
            }
        });
        installEditPolicy(EditPolicy.LAYOUT_ROLE, new ExpansionRegionLayoutEditPolicy());

    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated NOT
     */
    protected IFigure createFigure()
    {
        return new ExpansionRegionFigure(((ExpansionRegion) getEObject()).getMode().getName());
    }

    /**
     * @see org.topcased.modeler.edit.EMFGraphNodeEditPart#handleModelChanged(org.eclipse.emf.common.notify.Notification)
     */
    protected void handleModelChanged(Notification msg)
    {
        Object newObject = msg.getNewValue();

        if (msg.getNotifier() instanceof ExpansionRegion)
        {
            // Handle the refresh of the Figure when the user changes the Mode
            // of the ExpansionRegion
            if (newObject instanceof ExpansionKind && ((ExpansionRegion) msg.getNotifier()).getMode() != msg.getOldValue())
            {
                ((ExpansionRegionFigure) getFigure()).setMode(((ExpansionRegion) msg.getNotifier()).getMode());
            }
        }
        super.handleModelChanged(msg);
    }

    /**
     * @see org.topcased.modeler.uml.activitydiagram.edit.ActionEditPart#refreshHeaderLabel()
     */
    protected void refreshHeaderLabel()
    {
        // Do nothing
    }

    /**
     * @see org.topcased.modeler.edit.GraphNodeEditPart#getAnchorableFigure()
     */
    protected IFigure getAnchorableFigure()
    {
        return ((ExpansionRegionFigure) getFigure()).getAnchorableFigure();
    }
}