/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.uml.activitydiagram.ActivityEditPolicyConstants;
import org.topcased.modeler.uml.activitydiagram.commands.InputPinRestoreConnectionCommand;
import org.topcased.modeler.uml.activitydiagram.figures.InputPinFigure;
import org.topcased.modeler.uml.activitydiagram.policies.ControlFlowEdgeCreationEditPolicy;
import org.topcased.modeler.uml.activitydiagram.policies.ExceptionHandlerEdgeCreationEditPolicy;
import org.topcased.modeler.uml.activitydiagram.policies.ObjectFlowEdgeCreationEditPolicy;

/**
 * The InputPin object controller
 * 
 * @generated
 */
public class InputPinEditPart extends org.topcased.modeler.edit.PortEditPart
{
    /**
     * Constructor
     * 
     * @param obj the graph node
     * @generated
     */
    public InputPinEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles
     * 
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ActivityEditPolicyConstants.CONTROLFLOW_EDITPOLICY, new ControlFlowEdgeCreationEditPolicy());
        installEditPolicy(ActivityEditPolicyConstants.OBJECTFLOW_EDITPOLICY, new ObjectFlowEdgeCreationEditPolicy());

        installEditPolicy(ActivityEditPolicyConstants.EXCEPTIONHANDLER_EDITPOLICY, new ExceptionHandlerEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new InputPinRestoreConnectionCommand(getHost());
            }
        });

    }

    /**
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated
     */
    protected IFigure createFigure()
    {

        return new InputPinFigure();
    }

}