/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.edit;

import org.eclipse.gef.commands.Command;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.uml.activitydiagram.ActivityEditPolicyConstants;
import org.topcased.modeler.uml.activitydiagram.commands.ObjectNodeRestoreConnectionCommand;
import org.topcased.modeler.uml.activitydiagram.policies.ExceptionHandlerEdgeCreationEditPolicy;

/**
 * The ObjectNode object controller <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated NOT
 */
public abstract class ObjectNodeEditPart extends ActivityNodeEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public ObjectNodeEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(ActivityEditPolicyConstants.EXCEPTIONHANDLER_EDITPOLICY, new ExceptionHandlerEdgeCreationEditPolicy());

        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new ObjectNodeRestoreConnectionCommand(getHost());
            }
        });
    }

}