/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.draw2d.geometry.Rectangle;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated NOT
 */
public class AcceptEventActionFigure extends ActionFigure
{
    private static final int ARROW_SIZE = 10;

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public AcceptEventActionFigure()
    {
        super();
    }

    /**
     * @see org.topcased.modeler.uml.activitydiagram.figures.ActionFigure#createBackgroundFigure()
     */
    protected IFigure createBackgroundFigure()
    {
        return new Shape()
        {
            /**
             * @see org.eclipse.draw2d.Shape#fillShape(org.eclipse.draw2d.Graphics)
             */
            protected void fillShape(Graphics graphics)
            {
                PointList pl = new PointList();
                pl.addPoint(getBounds().getTopLeft());
                pl.addPoint(getBounds().getTopRight());
                pl.addPoint(getBounds().getBottomRight());
                pl.addPoint(getBounds().getBottomLeft());
                pl.addPoint(getBounds().getLeft().getTranslated(ARROW_SIZE, 0));

                graphics.fillPolygon(pl);
            }

            /**
             * @see org.eclipse.draw2d.Shape#outlineShape(org.eclipse.draw2d.Graphics)
             */
            protected void outlineShape(Graphics graphics)
            {
                Rectangle f = Rectangle.SINGLETON;
                Rectangle r = getBounds();
                f.x = r.x + lineWidth / 2;
                f.y = r.y + lineWidth / 2;
                f.width = r.width - lineWidth;
                f.height = r.height - lineWidth;

                PointList pl = new PointList();
                pl.addPoint(f.getTopLeft());
                pl.addPoint(f.getTopRight());
                pl.addPoint(f.getBottomRight());
                pl.addPoint(f.getBottomLeft());
                pl.addPoint(f.getLeft().getTranslated(ARROW_SIZE, 0));

                graphics.drawPolygon(pl);
            }
        };
    }

}