/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.figures;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LayoutManager;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;
import org.topcased.draw2d.figures.ComposedLabel;
import org.topcased.draw2d.figures.EditableLabel;
import org.topcased.draw2d.figures.IContainerFigure;
import org.topcased.draw2d.figures.ILabel;
import org.topcased.draw2d.figures.ILabelFigure;
import org.topcased.draw2d.figures.Label;
import org.topcased.draw2d.layout.BorderAttachedLayout;
import org.topcased.draw2d.layout.CenterLayout;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated NOT
 */
public class ActionFigure extends Figure implements IContainerFigure, ILabelFigure, HandleBounds
{
    private ILabel label;

    private IFigure contentPane;

    private IFigure innerRectangle;

    /**
     * Constructor <!-- begin-user-doc --> Creates the contents of the figure : by defauft, it creates a layout manager,
     * a header and a container <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public ActionFigure()
    {
        LayoutManager layout = new StackLayout();
        setLayoutManager(layout);

        IFigure outerRectangle = new Figure();
        outerRectangle.setLayoutManager(new StackLayout());
        outerRectangle.setBorder(new MarginBorder(10));
        outerRectangle.setOpaque(false);

        innerRectangle = createBackgroundFigure();
        innerRectangle.setLayoutManager(new CenterLayout());
        innerRectangle.setOpaque(true);
        outerRectangle.add(innerRectangle);

        label = new ComposedLabel(new Label(), new EditableLabel(), null, false);
        label.setOpaque(false);
        innerRectangle.add(label);

        add(outerRectangle);

        contentPane = new Figure();
        contentPane.setOpaque(false);
        contentPane.setLayoutManager(new BorderAttachedLayout());
        add(contentPane);
    }

    /**
     * Draw the backgroundFigure that should be used as the real border. The Anchor will be attached to this inner
     * Figure.<br>
     * This Figure will then be used as the container of the Label of the Action that will be centered.<br>
     * By default, return a RoundedRectangle, but subclasses may override this to draw their own figure.
     * 
     * @return the figure
     */
    protected IFigure createBackgroundFigure()
    {
        return new RoundedRectangle();
    }

    /**
     * Returns the figure drawn behind the label. In this case, we only return the inner rectangle drawn.
     * 
     * @return the background figure
     */
    public IFigure getBackgroundFigure()
    {
        return innerRectangle;
    }

    /**
     * @see org.topcased.draw2d.figures.ILabelFigure#getLabel()
     */
    public ILabel getLabel()
    {
        return label;
    }

    /**
     * @see org.topcased.draw2d.figures.IContainerFigure#getContentPane()
     */
    public IFigure getContentPane()
    {
        return contentPane;
    }

    /**
     * @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
     */
    public Rectangle getHandleBounds()
    {
        // return innerRectangle.getBounds();
        return getBounds();
    }

}