/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.figures;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.Locator;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.topcased.modeler.edit.locators.EdgeObjectOffsetLocator;
import org.topcased.modeler.figures.EdgeObjectEditableLabel;
import org.topcased.modeler.figures.EdgeObjectOffsetEditableLabel;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.figures.IEdgeObjectOffsetFigure;
import org.topcased.modeler.figures.IGraphEdgeFigure;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ActivityEdgeFigure extends PolylineConnectionEx implements IGraphEdgeFigure, HandleBounds
{

    /**
     * @generated
     */
    private IEdgeObjectFigure stereotypeEdgeObject;

    /**
     * @generated
     */
    private Locator stereotypeLocator;

    /**
     * @generated
     */
    private IEdgeObjectFigure guardEdgeObject;

    /**
     * @generated
     */
    private Locator guardLocator;

    /**
     * @generated
     */
    private IEdgeObjectFigure nameEdgeObject;

    /**
     * @generated
     */
    private Locator nameLocator;

    /**
     * @generated
     */
    private IEdgeObjectFigure weightEdgeObject;

    /**
     * @generated
     */
    private Locator weightLocator;

    /**
     * The constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public ActivityEdgeFigure()
    {
        super();

        stereotypeEdgeObject = new EdgeObjectOffsetEditableLabel(this);
        stereotypeLocator = new EdgeObjectOffsetLocator((IEdgeObjectOffsetFigure) stereotypeEdgeObject);
        add(stereotypeEdgeObject, stereotypeLocator);

        guardEdgeObject = new EdgeObjectEditableLabel(this);
        guardLocator = new ConnectionEndpointLocator(this, false);
        add(guardEdgeObject, guardLocator);

        nameEdgeObject = new EdgeObjectEditableLabel(this);
        nameLocator = new ConnectionEndpointLocator(this, true);
        add(nameEdgeObject, nameLocator);

        weightEdgeObject = new EdgeObjectEditableLabel(this);
        weightLocator = new ConnectionEndpointLocator(this, false);
        add(weightEdgeObject, weightLocator);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getStereotypeEdgeObjectFigure()
    {
        return stereotypeEdgeObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getGuardEdgeObjectFigure()
    {
        return guardEdgeObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getNameEdgeObjectFigure()
    {
        return nameEdgeObject;
    }

    /**
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getWeightEdgeObjectFigure()
    {
        return weightEdgeObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.figures.IGraphEdgeFigure#getLocator(org.topcased.modeler.figures.IEdgeObjectFigure)
     * @generated
     */
    public Locator getLocator(IEdgeObjectFigure edgeObjectfigure)
    {
        if (edgeObjectfigure == stereotypeEdgeObject)
        {
            return stereotypeLocator;
        }
        if (edgeObjectfigure == guardEdgeObject)
        {
            return guardLocator;
        }
        if (edgeObjectfigure == nameEdgeObject)
        {
            return nameLocator;
        }
        if (edgeObjectfigure == weightEdgeObject)
        {
            return weightLocator;
        }

        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
     * @generated
     */
    public Rectangle getHandleBounds()
    {
        return getPoints().getBounds();
    }
}