/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated NOT
 */
public class CallBehaviorActionFigure extends ActionFigure
{

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CallBehaviorActionFigure()
    {
        super();
    }

    /**
     * @see org.topcased.modeler.uml.activitydiagram.figures.ActionFigure#createBackgroundFigure()
     */
    protected IFigure createBackgroundFigure()
    {
        return new Shape()
        {
            /** The width and height radii applied to each corner. */
            private Dimension corner = new Dimension(10, 10);

            /**
             * @see org.eclipse.draw2d.Shape#outlineShape(org.eclipse.draw2d.Graphics)
             */
            protected void outlineShape(Graphics graphics)
            {
                Rectangle f = Rectangle.SINGLETON;
                Rectangle r = getBounds();
                f.x = r.x + lineWidth / 2;
                f.y = r.y + lineWidth / 2;
                f.width = r.width - lineWidth;
                f.height = r.height - lineWidth;
                graphics.drawRoundRectangle(f, corner.width, corner.height);

                // Draw the Behavior icon in the bottom right corner of the RoundRectangle
                Point center = f.getBottomRight().getTranslated(-12, -12);

                graphics.drawLine(center.getTranslated(-5, 7), center.getTranslated(-5, 0));
                graphics.drawLine(center.getTranslated(-5, 0), center.getTranslated(5, 0));
                graphics.drawLine(center.getTranslated(5, 0), center.getTranslated(5, 7));
                graphics.drawLine(center.getTranslated(0, 7), center.getTranslated(0, -7));
            }

            /**
             * @see org.eclipse.draw2d.Shape#fillShape(org.eclipse.draw2d.Graphics)
             */
            protected void fillShape(Graphics graphics)
            {
                graphics.fillRoundRectangle(getBounds(), corner.width, corner.height);
            }
        };
    }
}