/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.activitydiagram.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.geometry.Rectangle;

/**
 * @generated
 */
public class OutputPinFigure extends org.topcased.draw2d.figures.PortFigure
{
    private static final int WIDTH_SPACE = 2;

    private static final int HEIGHT_SPACE = 4;

    /**
     * Constructor
     * 
     * @generated NOT
     */
    public OutputPinFigure()
    {
        super();
    }

    /**
     * @see org.topcased.draw2d.figures.PortFigure#outlineShape(org.eclipse.draw2d.Graphics)
     */
    protected void outlineShape(Graphics graphics)
    {
        Rectangle r = getBounds();
        int x = r.x + lineWidth / 2;
        int y = r.y + lineWidth / 2;
        int w = r.width - Math.max(1, lineWidth);
        int h = r.height - Math.max(1, lineWidth);
        graphics.drawRectangle(x, y, w, h);

        switch (getPosition())
        {
            case PositionConstants.RIGHT:
                graphics.drawLine(r.getRight().getTranslated(-WIDTH_SPACE, 0), r.getLeft().getTranslated(WIDTH_SPACE, 0));
                graphics.drawLine(r.getRight().getTranslated(-WIDTH_SPACE, 0), r.getBottom().getTranslated(0, -HEIGHT_SPACE));
                graphics.drawLine(r.getRight().getTranslated(-WIDTH_SPACE, 0), r.getTop().getTranslated(0, HEIGHT_SPACE));
                break;
            case PositionConstants.BOTTOM:
                graphics.drawLine(r.getBottom().getTranslated(0, -WIDTH_SPACE), r.getTop().getTranslated(0, WIDTH_SPACE));
                graphics.drawLine(r.getBottom().getTranslated(0, -WIDTH_SPACE), r.getLeft().getTranslated(HEIGHT_SPACE, 0));
                graphics.drawLine(r.getBottom().getTranslated(0, -WIDTH_SPACE), r.getRight().getTranslated(-HEIGHT_SPACE, 0));
                break;
            case PositionConstants.TOP:
                graphics.drawLine(r.getTop().getTranslated(0, WIDTH_SPACE), r.getBottom().getTranslated(0, -WIDTH_SPACE));
                graphics.drawLine(r.getTop().getTranslated(0, WIDTH_SPACE), r.getRight().getTranslated(-HEIGHT_SPACE, 0));
                graphics.drawLine(r.getTop().getTranslated(0, WIDTH_SPACE), r.getLeft().getTranslated(HEIGHT_SPACE, 0));
                break;
            default:
                graphics.drawLine(r.getLeft().getTranslated(WIDTH_SPACE, 0), r.getRight().getTranslated(-WIDTH_SPACE, 0));
                graphics.drawLine(r.getLeft().getTranslated(WIDTH_SPACE, 0), r.getTop().getTranslated(0, HEIGHT_SPACE));
                graphics.drawLine(r.getLeft().getTranslated(WIDTH_SPACE, 0), r.getBottom().getTranslated(0, -HEIGHT_SPACE));
                break;
        }
    }
}