/*******************************************************************************
 * 
 * Copyright AIRBUS FRANCE, 2005. All rights reserved.
 * 
 * This document and all information contained herein is the sole property of
 * AIRBUS FRANCE. No intellectual property rights are granted by the delivery of
 * this document or the disclosure of its content.
 * 
 ******************************************************************************/
package org.topcased.modeler.uml.alldiagram;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.util.UMLSwitch;

/**
 * A customized UMLSwitch.<br>
 * It works the same as the UMLSwitch but
 * it does not proceed up the inheritance hierarchy.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ExactUMLSwitch extends UMLSwitch {

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Comment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseComment(org.eclipse.uml2.uml.Comment object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseElement(org.eclipse.uml2.uml.Element object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Package</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePackage(org.eclipse.uml2.uml.Package object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Packageable Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePackageableElement(
			org.eclipse.uml2.uml.PackageableElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Named Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseNamedElement(org.eclipse.uml2.uml.NamedElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Dependency</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDependency(org.eclipse.uml2.uml.Dependency object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Directed Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDirectedRelationship(
			org.eclipse.uml2.uml.DirectedRelationship object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseRelationship(org.eclipse.uml2.uml.Relationship object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Namespace</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseNamespace(org.eclipse.uml2.uml.Namespace object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Element Import</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseElementImport(org.eclipse.uml2.uml.ElementImport object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Package Import</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePackageImport(org.eclipse.uml2.uml.PackageImport object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseConstraint(org.eclipse.uml2.uml.Constraint object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Value Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseValueSpecification(
			org.eclipse.uml2.uml.ValueSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Typed Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTypedElement(org.eclipse.uml2.uml.TypedElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseType(org.eclipse.uml2.uml.Type object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Association</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAssociation(org.eclipse.uml2.uml.Association object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Classifier</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseClassifier(org.eclipse.uml2.uml.Classifier object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Redefinable Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseRedefinableElement(
			org.eclipse.uml2.uml.RedefinableElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Templateable Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTemplateableElement(
			org.eclipse.uml2.uml.TemplateableElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Template Binding</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTemplateBinding(
			org.eclipse.uml2.uml.TemplateBinding object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Template Signature</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTemplateSignature(
			org.eclipse.uml2.uml.TemplateSignature object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Template Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTemplateParameter(
			org.eclipse.uml2.uml.TemplateParameter object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Parameterable Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseParameterableElement(
			org.eclipse.uml2.uml.ParameterableElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Template Parameter Substitution</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTemplateParameterSubstitution(
			org.eclipse.uml2.uml.TemplateParameterSubstitution object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Generalization</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseGeneralization(org.eclipse.uml2.uml.Generalization object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Generalization Set</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseGeneralizationSet(
			org.eclipse.uml2.uml.GeneralizationSet object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Feature</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseFeature(org.eclipse.uml2.uml.Feature object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Substitution</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSubstitution(org.eclipse.uml2.uml.Substitution object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Realization</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseRealization(org.eclipse.uml2.uml.Realization object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Abstraction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAbstraction(org.eclipse.uml2.uml.Abstraction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Opaque Expression</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseOpaqueExpression(
			org.eclipse.uml2.uml.OpaqueExpression object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseParameter(org.eclipse.uml2.uml.Parameter object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Multiplicity Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseMultiplicityElement(
			org.eclipse.uml2.uml.MultiplicityElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Connectable Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseConnectableElement(
			org.eclipse.uml2.uml.ConnectableElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Connectable Element Template Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseConnectableElementTemplateParameter(
			org.eclipse.uml2.uml.ConnectableElementTemplateParameter object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Connector End</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseConnectorEnd(org.eclipse.uml2.uml.ConnectorEnd object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Property</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseProperty(org.eclipse.uml2.uml.Property object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Deployment Target</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDeploymentTarget(
			org.eclipse.uml2.uml.DeploymentTarget object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Deployment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDeployment(org.eclipse.uml2.uml.Deployment object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Deployed Artifact</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDeployedArtifact(
			org.eclipse.uml2.uml.DeployedArtifact object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Deployment Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDeploymentSpecification(
			org.eclipse.uml2.uml.DeploymentSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Artifact</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseArtifact(org.eclipse.uml2.uml.Artifact object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Manifestation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseManifestation(org.eclipse.uml2.uml.Manifestation object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Operation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseOperation(org.eclipse.uml2.uml.Operation object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Behavioral Feature</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseBehavioralFeature(
			org.eclipse.uml2.uml.BehavioralFeature object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Behavior</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseBehavior(org.eclipse.uml2.uml.Behavior object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Class</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseClass(org.eclipse.uml2.uml.Class object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Behaviored Classifier</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseBehavioredClassifier(
			org.eclipse.uml2.uml.BehavioredClassifier object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interface Realization</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInterfaceRealization(
			org.eclipse.uml2.uml.InterfaceRealization object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interface</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInterface(org.eclipse.uml2.uml.Interface object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Reception</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReception(org.eclipse.uml2.uml.Reception object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Signal</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSignal(org.eclipse.uml2.uml.Signal object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Protocol State Machine</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseProtocolStateMachine(
			org.eclipse.uml2.uml.ProtocolStateMachine object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>State Machine</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStateMachine(org.eclipse.uml2.uml.StateMachine object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Region</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseRegion(org.eclipse.uml2.uml.Region object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Vertex</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseVertex(org.eclipse.uml2.uml.Vertex object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Transition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTransition(org.eclipse.uml2.uml.Transition object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Trigger</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTrigger(org.eclipse.uml2.uml.Trigger object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseEvent(org.eclipse.uml2.uml.Event object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Port</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePort(org.eclipse.uml2.uml.Port object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>State</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseState(org.eclipse.uml2.uml.State object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Connection Point Reference</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseConnectionPointReference(
			org.eclipse.uml2.uml.ConnectionPointReference object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Pseudostate</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePseudostate(org.eclipse.uml2.uml.Pseudostate object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Protocol Conformance</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseProtocolConformance(
			org.eclipse.uml2.uml.ProtocolConformance object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Encapsulated Classifier</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseEncapsulatedClassifier(
			org.eclipse.uml2.uml.EncapsulatedClassifier object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Structured Classifier</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStructuredClassifier(
			org.eclipse.uml2.uml.StructuredClassifier object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Connector</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseConnector(org.eclipse.uml2.uml.Connector object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Extension</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExtension(org.eclipse.uml2.uml.Extension object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Extension End</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExtensionEnd(org.eclipse.uml2.uml.ExtensionEnd object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Stereotype</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStereotype(org.eclipse.uml2.uml.Stereotype object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Image</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseImage(org.eclipse.uml2.uml.Image object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Profile</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseProfile(org.eclipse.uml2.uml.Profile object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Model</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseModel(org.eclipse.uml2.uml.Model object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Parameter Set</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseParameterSet(org.eclipse.uml2.uml.ParameterSet object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Data Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDataType(org.eclipse.uml2.uml.DataType object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Operation Template Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseOperationTemplateParameter(
			org.eclipse.uml2.uml.OperationTemplateParameter object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Structural Feature</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStructuralFeature(
			org.eclipse.uml2.uml.StructuralFeature object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Collaboration Use</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCollaborationUse(
			org.eclipse.uml2.uml.CollaborationUse object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Collaboration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCollaboration(org.eclipse.uml2.uml.Collaboration object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Use Case</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseUseCase(org.eclipse.uml2.uml.UseCase object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Include</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInclude(org.eclipse.uml2.uml.Include object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Extend</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExtend(org.eclipse.uml2.uml.Extend object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Extension Point</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExtensionPoint(org.eclipse.uml2.uml.ExtensionPoint object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Redefinable Template Signature</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseRedefinableTemplateSignature(
			org.eclipse.uml2.uml.RedefinableTemplateSignature object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Classifier Template Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseClassifierTemplateParameter(
			org.eclipse.uml2.uml.ClassifierTemplateParameter object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>String Expression</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStringExpression(
			org.eclipse.uml2.uml.StringExpression object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Expression</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExpression(org.eclipse.uml2.uml.Expression object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Usage</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseUsage(org.eclipse.uml2.uml.Usage object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Package Merge</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePackageMerge(org.eclipse.uml2.uml.PackageMerge object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Profile Application</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseProfileApplication(
			org.eclipse.uml2.uml.ProfileApplication object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseEnumeration(org.eclipse.uml2.uml.Enumeration object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Enumeration Literal</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseEnumerationLiteral(
			org.eclipse.uml2.uml.EnumerationLiteral object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Instance Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInstanceSpecification(
			org.eclipse.uml2.uml.InstanceSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Slot</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSlot(org.eclipse.uml2.uml.Slot object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Primitive Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePrimitiveType(org.eclipse.uml2.uml.PrimitiveType object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Literal Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLiteralSpecification(
			org.eclipse.uml2.uml.LiteralSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Literal Integer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLiteralInteger(org.eclipse.uml2.uml.LiteralInteger object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Literal String</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLiteralString(org.eclipse.uml2.uml.LiteralString object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Literal Boolean</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLiteralBoolean(org.eclipse.uml2.uml.LiteralBoolean object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Literal Null</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLiteralNull(org.eclipse.uml2.uml.LiteralNull object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Instance Value</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInstanceValue(org.eclipse.uml2.uml.InstanceValue object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Literal Unlimited Natural</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLiteralUnlimitedNatural(
			org.eclipse.uml2.uml.LiteralUnlimitedNatural object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Opaque Behavior</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseOpaqueBehavior(org.eclipse.uml2.uml.OpaqueBehavior object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Function Behavior</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseFunctionBehavior(
			org.eclipse.uml2.uml.FunctionBehavior object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Opaque Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseOpaqueAction(org.eclipse.uml2.uml.OpaqueAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAction(org.eclipse.uml2.uml.Action object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Executable Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExecutableNode(org.eclipse.uml2.uml.ExecutableNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Activity Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActivityNode(org.eclipse.uml2.uml.ActivityNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Structured Activity Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStructuredActivityNode(
			org.eclipse.uml2.uml.StructuredActivityNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Activity Group</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActivityGroup(org.eclipse.uml2.uml.ActivityGroup object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Activity</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActivity(org.eclipse.uml2.uml.Activity object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Variable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseVariable(org.eclipse.uml2.uml.Variable object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Activity Edge</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActivityEdge(org.eclipse.uml2.uml.ActivityEdge object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Activity Partition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActivityPartition(
			org.eclipse.uml2.uml.ActivityPartition object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interruptible Activity Region</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInterruptibleActivityRegion(
			org.eclipse.uml2.uml.InterruptibleActivityRegion object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Exception Handler</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExceptionHandler(
			org.eclipse.uml2.uml.ExceptionHandler object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Object Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseObjectNode(org.eclipse.uml2.uml.ObjectNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Output Pin</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseOutputPin(org.eclipse.uml2.uml.OutputPin object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Pin</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePin(org.eclipse.uml2.uml.Pin object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Input Pin</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInputPin(org.eclipse.uml2.uml.InputPin object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Call Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCallAction(org.eclipse.uml2.uml.CallAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Invocation Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInvocationAction(
			org.eclipse.uml2.uml.InvocationAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Send Signal Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSendSignalAction(
			org.eclipse.uml2.uml.SendSignalAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Call Operation Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCallOperationAction(
			org.eclipse.uml2.uml.CallOperationAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Call Behavior Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCallBehaviorAction(
			org.eclipse.uml2.uml.CallBehaviorAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Sequence Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSequenceNode(org.eclipse.uml2.uml.SequenceNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Control Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseControlNode(org.eclipse.uml2.uml.ControlNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Control Flow</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseControlFlow(org.eclipse.uml2.uml.ControlFlow object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Initial Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInitialNode(org.eclipse.uml2.uml.InitialNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Activity Parameter Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActivityParameterNode(
			org.eclipse.uml2.uml.ActivityParameterNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Value Pin</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseValuePin(org.eclipse.uml2.uml.ValuePin object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Message</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseMessage(org.eclipse.uml2.uml.Message object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Message End</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseMessageEnd(org.eclipse.uml2.uml.MessageEnd object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interaction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInteraction(org.eclipse.uml2.uml.Interaction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interaction Fragment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInteractionFragment(
			org.eclipse.uml2.uml.InteractionFragment object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Lifeline</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLifeline(org.eclipse.uml2.uml.Lifeline object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Part Decomposition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object casePartDecomposition(
			org.eclipse.uml2.uml.PartDecomposition object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interaction Use</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInteractionUse(org.eclipse.uml2.uml.InteractionUse object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Gate</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseGate(org.eclipse.uml2.uml.Gate object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>General Ordering</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseGeneralOrdering(
			org.eclipse.uml2.uml.GeneralOrdering object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Occurrence Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseOccurrenceSpecification(
			org.eclipse.uml2.uml.OccurrenceSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interaction Operand</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInteractionOperand(
			org.eclipse.uml2.uml.InteractionOperand object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interaction Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInteractionConstraint(
			org.eclipse.uml2.uml.InteractionConstraint object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Execution Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExecutionSpecification(
			org.eclipse.uml2.uml.ExecutionSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>State Invariant</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStateInvariant(org.eclipse.uml2.uml.StateInvariant object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Action Execution Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActionExecutionSpecification(
			org.eclipse.uml2.uml.ActionExecutionSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Behavior Execution Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseBehaviorExecutionSpecification(
			org.eclipse.uml2.uml.BehaviorExecutionSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Execution Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExecutionEvent(org.eclipse.uml2.uml.ExecutionEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Creation Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCreationEvent(org.eclipse.uml2.uml.CreationEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Destruction Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDestructionEvent(
			org.eclipse.uml2.uml.DestructionEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Send Operation Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSendOperationEvent(
			org.eclipse.uml2.uml.SendOperationEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Message Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseMessageEvent(org.eclipse.uml2.uml.MessageEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Send Signal Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSendSignalEvent(
			org.eclipse.uml2.uml.SendSignalEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Message Occurrence Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseMessageOccurrenceSpecification(
			org.eclipse.uml2.uml.MessageOccurrenceSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Execution Occurrence Specification</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExecutionOccurrenceSpecification(
			org.eclipse.uml2.uml.ExecutionOccurrenceSpecification object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Receive Operation Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReceiveOperationEvent(
			org.eclipse.uml2.uml.ReceiveOperationEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Receive Signal Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReceiveSignalEvent(
			org.eclipse.uml2.uml.ReceiveSignalEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Actor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActor(org.eclipse.uml2.uml.Actor object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Call Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCallEvent(org.eclipse.uml2.uml.CallEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Change Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseChangeEvent(org.eclipse.uml2.uml.ChangeEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Signal Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSignalEvent(org.eclipse.uml2.uml.SignalEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Any Receive Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAnyReceiveEvent(
			org.eclipse.uml2.uml.AnyReceiveEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Fork Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseForkNode(org.eclipse.uml2.uml.ForkNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Flow Final Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseFlowFinalNode(org.eclipse.uml2.uml.FlowFinalNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Final Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseFinalNode(org.eclipse.uml2.uml.FinalNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Central Buffer Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCentralBufferNode(
			org.eclipse.uml2.uml.CentralBufferNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Merge Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseMergeNode(org.eclipse.uml2.uml.MergeNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Decision Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDecisionNode(org.eclipse.uml2.uml.DecisionNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Activity Final Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActivityFinalNode(
			org.eclipse.uml2.uml.ActivityFinalNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Component Realization</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseComponentRealization(
			org.eclipse.uml2.uml.ComponentRealization object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Component</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseComponent(org.eclipse.uml2.uml.Component object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseNode(org.eclipse.uml2.uml.Node object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Device</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDevice(org.eclipse.uml2.uml.Device object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Execution Environment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExecutionEnvironment(
			org.eclipse.uml2.uml.ExecutionEnvironment object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Communication Path</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCommunicationPath(
			org.eclipse.uml2.uml.CommunicationPath object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Combined Fragment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCombinedFragment(
			org.eclipse.uml2.uml.CombinedFragment object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Continuation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseContinuation(org.eclipse.uml2.uml.Continuation object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Consider Ignore Fragment</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseConsiderIgnoreFragment(
			org.eclipse.uml2.uml.ConsiderIgnoreFragment object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Create Object Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCreateObjectAction(
			org.eclipse.uml2.uml.CreateObjectAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Destroy Object Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDestroyObjectAction(
			org.eclipse.uml2.uml.DestroyObjectAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Test Identity Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTestIdentityAction(
			org.eclipse.uml2.uml.TestIdentityAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Read Self Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReadSelfAction(org.eclipse.uml2.uml.ReadSelfAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Structural Feature Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStructuralFeatureAction(
			org.eclipse.uml2.uml.StructuralFeatureAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Read Structural Feature Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReadStructuralFeatureAction(
			org.eclipse.uml2.uml.ReadStructuralFeatureAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Write Structural Feature Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseWriteStructuralFeatureAction(
			org.eclipse.uml2.uml.WriteStructuralFeatureAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Clear Structural Feature Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseClearStructuralFeatureAction(
			org.eclipse.uml2.uml.ClearStructuralFeatureAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Remove Structural Feature Value Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseRemoveStructuralFeatureValueAction(
			org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Add Structural Feature Value Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAddStructuralFeatureValueAction(
			org.eclipse.uml2.uml.AddStructuralFeatureValueAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Link Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLinkAction(org.eclipse.uml2.uml.LinkAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Link End Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLinkEndData(org.eclipse.uml2.uml.LinkEndData object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Qualifier Value</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseQualifierValue(org.eclipse.uml2.uml.QualifierValue object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Read Link Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReadLinkAction(org.eclipse.uml2.uml.ReadLinkAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Link End Creation Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLinkEndCreationData(
			org.eclipse.uml2.uml.LinkEndCreationData object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Create Link Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCreateLinkAction(
			org.eclipse.uml2.uml.CreateLinkAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Write Link Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseWriteLinkAction(
			org.eclipse.uml2.uml.WriteLinkAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Destroy Link Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDestroyLinkAction(
			org.eclipse.uml2.uml.DestroyLinkAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Link End Destruction Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLinkEndDestructionData(
			org.eclipse.uml2.uml.LinkEndDestructionData object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Clear Association Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseClearAssociationAction(
			org.eclipse.uml2.uml.ClearAssociationAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Broadcast Signal Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseBroadcastSignalAction(
			org.eclipse.uml2.uml.BroadcastSignalAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Send Object Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseSendObjectAction(
			org.eclipse.uml2.uml.SendObjectAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Value Specification Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseValueSpecificationAction(
			org.eclipse.uml2.uml.ValueSpecificationAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Time Expression</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTimeExpression(org.eclipse.uml2.uml.TimeExpression object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Observation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseObservation(org.eclipse.uml2.uml.Observation object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Duration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDuration(org.eclipse.uml2.uml.Duration object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Duration Interval</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDurationInterval(
			org.eclipse.uml2.uml.DurationInterval object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interval</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInterval(org.eclipse.uml2.uml.Interval object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Time Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTimeConstraint(org.eclipse.uml2.uml.TimeConstraint object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Interval Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseIntervalConstraint(
			org.eclipse.uml2.uml.IntervalConstraint object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Time Interval</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTimeInterval(org.eclipse.uml2.uml.TimeInterval object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Duration Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDurationConstraint(
			org.eclipse.uml2.uml.DurationConstraint object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Time Observation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTimeObservation(
			org.eclipse.uml2.uml.TimeObservation object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Duration Observation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDurationObservation(
			org.eclipse.uml2.uml.DurationObservation object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Final State</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseFinalState(org.eclipse.uml2.uml.FinalState object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Time Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseTimeEvent(org.eclipse.uml2.uml.TimeEvent object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Variable Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseVariableAction(org.eclipse.uml2.uml.VariableAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Read Variable Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReadVariableAction(
			org.eclipse.uml2.uml.ReadVariableAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Write Variable Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseWriteVariableAction(
			org.eclipse.uml2.uml.WriteVariableAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Clear Variable Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseClearVariableAction(
			org.eclipse.uml2.uml.ClearVariableAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Add Variable Value Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAddVariableValueAction(
			org.eclipse.uml2.uml.AddVariableValueAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Remove Variable Value Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseRemoveVariableValueAction(
			org.eclipse.uml2.uml.RemoveVariableValueAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Raise Exception Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseRaiseExceptionAction(
			org.eclipse.uml2.uml.RaiseExceptionAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Action Input Pin</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseActionInputPin(org.eclipse.uml2.uml.ActionInputPin object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Information Item</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInformationItem(
			org.eclipse.uml2.uml.InformationItem object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Information Flow</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseInformationFlow(
			org.eclipse.uml2.uml.InformationFlow object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Read Extent Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReadExtentAction(
			org.eclipse.uml2.uml.ReadExtentAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Reclassify Object Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReclassifyObjectAction(
			org.eclipse.uml2.uml.ReclassifyObjectAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Read Is Classified Object Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReadIsClassifiedObjectAction(
			org.eclipse.uml2.uml.ReadIsClassifiedObjectAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Start Classifier Behavior Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseStartClassifierBehaviorAction(
			org.eclipse.uml2.uml.StartClassifierBehaviorAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Read Link Object End Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReadLinkObjectEndAction(
			org.eclipse.uml2.uml.ReadLinkObjectEndAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Read Link Object End Qualifier Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReadLinkObjectEndQualifierAction(
			org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Create Link Object Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseCreateLinkObjectAction(
			org.eclipse.uml2.uml.CreateLinkObjectAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Accept Event Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAcceptEventAction(
			org.eclipse.uml2.uml.AcceptEventAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Accept Call Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAcceptCallAction(
			org.eclipse.uml2.uml.AcceptCallAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Reply Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReplyAction(org.eclipse.uml2.uml.ReplyAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Unmarshall Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseUnmarshallAction(
			org.eclipse.uml2.uml.UnmarshallAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Reduce Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseReduceAction(org.eclipse.uml2.uml.ReduceAction object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Join Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseJoinNode(org.eclipse.uml2.uml.JoinNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Data Store Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseDataStoreNode(org.eclipse.uml2.uml.DataStoreNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Object Flow</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseObjectFlow(org.eclipse.uml2.uml.ObjectFlow object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Conditional Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseConditionalNode(
			org.eclipse.uml2.uml.ConditionalNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Clause</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseClause(org.eclipse.uml2.uml.Clause object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Loop Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseLoopNode(org.eclipse.uml2.uml.LoopNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Expansion Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExpansionNode(org.eclipse.uml2.uml.ExpansionNode object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Expansion Region</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseExpansionRegion(
			org.eclipse.uml2.uml.ExpansionRegion object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Protocol Transition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseProtocolTransition(
			org.eclipse.uml2.uml.ProtocolTransition object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>Association Class</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseAssociationClass(
			org.eclipse.uml2.uml.AssociationClass object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an exact instance of '<em>EModel Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object caseEModelElement(org.eclipse.emf.ecore.EModelElement object) {
		return object;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the given object.
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return object;
	}
}
