/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.classdiagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.EdgeObjectUV;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.uml.alldiagram.ExactUMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model Object <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class ClassCreationUtils extends AbstractCreationUtils
{

    private static final int LABEL_OFFSET = 10;

    /**
     * Constructor
     * 
     * @param diagramConf the Diagram Graphical Configuration
     */
    public ClassCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private class GraphicUMLSwitch extends ExactUMLSwitch
    {
        /** The presentation of the graphical element */
        private String presentation;

        /**
         * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicUMLSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#casePackage(org.eclipse.uml2.uml.Package)
         * @generated
         */
        public Object casePackage(org.eclipse.uml2.uml.Package object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementPackage(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseClass(org.eclipse.uml2.uml.Class)
         * @generated
         */
        public Object caseClass(org.eclipse.uml2.uml.Class object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementClass(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDataType(org.eclipse.uml2.uml.DataType)
         * @generated
         */
        public Object caseDataType(org.eclipse.uml2.uml.DataType object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDataType(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseInterface(org.eclipse.uml2.uml.Interface)
         * @generated
         */
        public Object caseInterface(org.eclipse.uml2.uml.Interface object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInterface(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseOperation(org.eclipse.uml2.uml.Operation)
         * @generated
         */
        public Object caseOperation(org.eclipse.uml2.uml.Operation object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementOperation(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseProperty(org.eclipse.uml2.uml.Property)
         * @generated
         */
        public Object caseProperty(org.eclipse.uml2.uml.Property object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementProperty(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseInstanceSpecification(org.eclipse.uml2.uml.InstanceSpecification)
         * @generated
         */
        public Object caseInstanceSpecification(org.eclipse.uml2.uml.InstanceSpecification object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInstanceSpecification(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseSlot(org.eclipse.uml2.uml.Slot)
         * @generated
         */
        public Object caseSlot(org.eclipse.uml2.uml.Slot object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementSlot(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseEnumeration(org.eclipse.uml2.uml.Enumeration)
         * @generated
         */
        public Object caseEnumeration(org.eclipse.uml2.uml.Enumeration object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEnumeration(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseEnumerationLiteral(org.eclipse.uml2.uml.EnumerationLiteral)
         * @generated
         */
        public Object caseEnumerationLiteral(org.eclipse.uml2.uml.EnumerationLiteral object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementEnumerationLiteral(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#casePrimitiveType(org.eclipse.uml2.uml.PrimitiveType)
         * @generated
         */
        public Object casePrimitiveType(org.eclipse.uml2.uml.PrimitiveType object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementPrimitiveType(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseAssociation(org.eclipse.uml2.uml.Association)
         * @generated
         */
        public Object caseAssociation(org.eclipse.uml2.uml.Association object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementAssociation(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseAssociationClass(org.eclipse.uml2.uml.AssociationClass)
         * @generated
         */
        public Object caseAssociationClass(org.eclipse.uml2.uml.AssociationClass object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementAssociationClass(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseGeneralization(org.eclipse.uml2.uml.Generalization)
         * @generated
         */
        public Object caseGeneralization(org.eclipse.uml2.uml.Generalization object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementGeneralization(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization)
         * @generated
         */
        public Object caseInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInterfaceRealization(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDependency(org.eclipse.uml2.uml.Dependency)
         * @generated
         */
        public Object caseDependency(org.eclipse.uml2.uml.Dependency object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDependency(object, presentation);
            }
            return null;
        }
        
        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDependency(org.eclipse.uml2.uml.Dependency)
         * @generated
         */
        public Object caseUsage(org.eclipse.uml2.uml.Usage object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementUsage(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#casePackageImport(org.eclipse.uml2.uml.PackageImport)
         * @generated
         */
        public Object casePackageImport(org.eclipse.uml2.uml.PackageImport object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementPackageImport(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#casePackageMerge(org.eclipse.uml2.uml.PackageMerge)
         * @generated
         */
        public Object casePackageMerge(org.eclipse.uml2.uml.PackageMerge object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementPackageMerge(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         * @generated
         */
        public Object caseComment(org.eclipse.uml2.uml.Comment object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementComment(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;

        if ("http://www.eclipse.org/uml2/2.1.0/UML".equals(obj.eClass().getEPackage().getNsURI()))
        {
            graphElt = new GraphicUMLSwitch(presentation).doSwitch(obj);
        }
        
        if (graphElt instanceof GraphElement)
        {
            return (GraphElement) graphElt;
        }

        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementPackage(org.eclipse.uml2.uml.Package element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementClass(org.eclipse.uml2.uml.Class element, String presentation)
    {
        GraphNode nodeClass = createGraphNode(element, presentation);
        GraphNode attributes = createGraphNode(element, UMLPackage.CLASS__OWNED_ATTRIBUTE);
        GraphNode operations = createGraphNode(element, UMLPackage.CLASS__OWNED_OPERATION);
        attributes.setContainer(nodeClass);
        operations.setContainer(nodeClass);
        return nodeClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementDataType(org.eclipse.uml2.uml.DataType element, String presentation)
    {
        GraphNode nodeDataType = createGraphNode(element, presentation);
        GraphNode attributes = createGraphNode(element, UMLPackage.DATA_TYPE__OWNED_ATTRIBUTE);
        GraphNode operations = createGraphNode(element, UMLPackage.DATA_TYPE__OWNED_OPERATION);
        attributes.setContainer(nodeDataType);
        operations.setContainer(nodeDataType);
        return nodeDataType;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementInterface(org.eclipse.uml2.uml.Interface element, String presentation)
    {
        GraphNode nodeInterface = createGraphNode(element, presentation);
        GraphNode attributes = createGraphNode(element, UMLPackage.INTERFACE__OWNED_ATTRIBUTE);
        GraphNode operations = createGraphNode(element, UMLPackage.INTERFACE__OWNED_OPERATION);
        attributes.setContainer(nodeInterface);
        operations.setContainer(nodeInterface);
        return nodeInterface;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementOperation(org.eclipse.uml2.uml.Operation element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementProperty(org.eclipse.uml2.uml.Property element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementInstanceSpecification(org.eclipse.uml2.uml.InstanceSpecification element, String presentation)
    {
        GraphNode nodeParent = createGraphNode(element, presentation);
        GraphNode values = createGraphNode(element, UMLPackage.INSTANCE_SPECIFICATION__SLOT);
        values.setContainer(nodeParent);
        return nodeParent;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementSlot(org.eclipse.uml2.uml.Slot element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEnumeration(org.eclipse.uml2.uml.Enumeration element, String presentation)
    {
        // TODO this snippet of code should be customized if it is not well
        // generated
        GraphNode nodeParent = createGraphNode(element, presentation);

        GraphNode enumerationliteral = createGraphNode(element, UMLPackage.ENUMERATION__OWNED_LITERAL, presentation);
        enumerationliteral.setContainer(nodeParent);

        return nodeParent;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementEnumerationLiteral(org.eclipse.uml2.uml.EnumerationLiteral element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementPrimitiveType(org.eclipse.uml2.uml.PrimitiveType element, String presentation)
    {
        GraphNode nodeParent = createGraphNode(element, presentation);
        GraphNode property = createGraphNode(element, UMLPackage.PRIMITIVE_TYPE__OWNED_ATTRIBUTE, presentation);
        GraphNode operation = createGraphNode(element, UMLPackage.PRIMITIVE_TYPE__OWNED_OPERATION, presentation);
        property.setContainer(nodeParent);
        operation.setContainer(nodeParent);
        return nodeParent;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementAssociation(org.eclipse.uml2.uml.Association element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        
        EdgeObjectUV srcnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        srcnameEdgeObjectUV.setId(ClassEdgeObjectConstants.SRCNAME_EDGE_OBJECT_ID);
        srcnameEdgeObjectUV.setUDistance(LABEL_OFFSET);
        srcnameEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(srcnameEdgeObjectUV);
        
        EdgeObjectUV srccountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        srccountEdgeObjectUV.setId(ClassEdgeObjectConstants.SRCCOUNT_EDGE_OBJECT_ID);
        srccountEdgeObjectUV.setUDistance(LABEL_OFFSET);
        srccountEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        graphEdge.getContained().add(srccountEdgeObjectUV);
        
        EdgeObjectUV targetnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        targetnameEdgeObjectUV.setId(ClassEdgeObjectConstants.TARGETNAME_EDGE_OBJECT_ID);
        targetnameEdgeObjectUV.setUDistance(LABEL_OFFSET);
        targetnameEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(targetnameEdgeObjectUV);
        
        EdgeObjectUV targetcountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        targetcountEdgeObjectUV.setId(ClassEdgeObjectConstants.TARGETCOUNT_EDGE_OBJECT_ID);
        targetcountEdgeObjectUV.setUDistance(LABEL_OFFSET);
        targetcountEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        graphEdge.getContained().add(targetcountEdgeObjectUV);
        
        EdgeObjectOffset middlenameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        middlenameEdgeObjectOffset.setId(ClassEdgeObjectConstants.MIDDLENAME_EDGE_OBJECT_ID);
        middlenameEdgeObjectOffset.setOffset(new Dimension(0, 10));
        middlenameEdgeObjectOffset.setVisible(false);
        graphEdge.getContained().add(middlenameEdgeObjectOffset);
        
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ClassEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, -10));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated NOT
     */
    protected GraphElement createGraphElementAssociationClass(org.eclipse.uml2.uml.AssociationClass element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        
        EdgeObjectUV srcnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        srcnameEdgeObjectUV.setId(ClassEdgeObjectConstants.SRCNAME_EDGE_OBJECT_ID);
        srcnameEdgeObjectUV.setUDistance(LABEL_OFFSET);
        srcnameEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(srcnameEdgeObjectUV);
        
        EdgeObjectUV srccountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        srccountEdgeObjectUV.setId(ClassEdgeObjectConstants.SRCCOUNT_EDGE_OBJECT_ID);
        srccountEdgeObjectUV.setUDistance(LABEL_OFFSET);
        srccountEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        graphEdge.getContained().add(srccountEdgeObjectUV);
        
        EdgeObjectUV targetnameEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        targetnameEdgeObjectUV.setId(ClassEdgeObjectConstants.TARGETNAME_EDGE_OBJECT_ID);
        targetnameEdgeObjectUV.setUDistance(LABEL_OFFSET);
        targetnameEdgeObjectUV.setVDistance(LABEL_OFFSET);
        graphEdge.getContained().add(targetnameEdgeObjectUV);
        
        EdgeObjectUV targetcountEdgeObjectUV = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectUV();
        targetcountEdgeObjectUV.setId(ClassEdgeObjectConstants.TARGETCOUNT_EDGE_OBJECT_ID);
        targetcountEdgeObjectUV.setUDistance(LABEL_OFFSET);
        targetcountEdgeObjectUV.setVDistance(-LABEL_OFFSET);
        graphEdge.getContained().add(targetcountEdgeObjectUV);
        
        EdgeObjectOffset middlenameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        middlenameEdgeObjectOffset.setId(ClassEdgeObjectConstants.MIDDLENAME_EDGE_OBJECT_ID);
        middlenameEdgeObjectOffset.setOffset(new Dimension(0, 20));
        middlenameEdgeObjectOffset.setVisible(false);
        graphEdge.getContained().add(middlenameEdgeObjectOffset);
        
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ClassEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        
        // Associate the GraphNode that is used to represent the Class node of
        // the AssociationClass
        GraphNode nodeClass = createGraphNode(element);
        nodeClass.setPosition(new Point(50, 50));
        nodeClass.setSize(new Dimension(100, -1));
        nodeClass.setContainer(graphEdge);
        GraphNode attributes = createGraphNode(element, UMLPackage.ASSOCIATION_CLASS__OWNED_ATTRIBUTE);
        GraphNode operations = createGraphNode(element, UMLPackage.ASSOCIATION_CLASS__OWNED_OPERATION);
        attributes.setContainer(nodeClass);
        operations.setContainer(nodeClass);

        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementGeneralization(org.eclipse.uml2.uml.Generalization element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ClassEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ClassEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDependency(org.eclipse.uml2.uml.Dependency element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ClassEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        return graphEdge;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementUsage(org.eclipse.uml2.uml.Usage element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ClassEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        
        EdgeObjectOffset middlenameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        middlenameEdgeObjectOffset.setId(ClassEdgeObjectConstants.MIDDLENAME_EDGE_OBJECT_ID);
        middlenameEdgeObjectOffset.setOffset(new Dimension(0, 20));
        graphEdge.getContained().add(middlenameEdgeObjectOffset);
        
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementPackageImport(org.eclipse.uml2.uml.PackageImport element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset visibilityEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        visibilityEdgeObjectOffset.setId(ClassEdgeObjectConstants.VISIBILITY_EDGE_OBJECT_ID);
        visibilityEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(visibilityEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementPackageMerge(org.eclipse.uml2.uml.PackageMerge element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset mergeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        mergeEdgeObjectOffset.setId(ClassEdgeObjectConstants.MERGE_EDGE_OBJECT_ID);
        mergeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(mergeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComment(org.eclipse.uml2.uml.Comment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated
     */
    public EObject createModelObject(EObject obj)
    {
        return obj;
    }

}
