/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.classdiagram;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteEntry;
import org.eclipse.gef.palette.PaletteStack;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.uml2.uml.AggregationKind;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.UMLFactory;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;

/**
 * Generated Palette Manager <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ClassPaletteManager extends ModelerPaletteManager
{
    // declare all the palette categories of the diagram
    private PaletteDrawer objectsDrawer;

    private PaletteDrawer connectionsDrawer;

    private PaletteDrawer commentDrawer;

    private ICreationUtils creationUtils;

    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param utils the creation utils for the tools of the palette
     * @generated
     */
    public ClassPaletteManager(ICreationUtils utils)
    {
        super();
        this.creationUtils = utils;
    }

    /**
     * Creates the main categories of the palette <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createCategories()
    {
        createObjectsDrawer();
        createConnectionsDrawer();
        createCommentDrawer();
    }

    /**
     * Updates the main categories of the palette <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void updateCategories()
    {
        // deletion of the existing categories and creation of the updated
        // categories

        getRoot().remove(objectsDrawer);
        createObjectsDrawer();

        getRoot().remove(connectionsDrawer);
        createConnectionsDrawer();

        getRoot().remove(commentDrawer);
        createCommentDrawer();
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private void createObjectsDrawer()
    {
        objectsDrawer = new PaletteDrawer("Objects", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getPackage(), "default");
        entries.add(new ModelerCreationToolEntry("Package", "Package", factory, ClassImageRegistry.getImageDescriptor("PACKAGE"), ClassImageRegistry.getImageDescriptor("PACKAGE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getClass_(), "default");
        entries.add(new ModelerCreationToolEntry("Class", "Class", factory, ClassImageRegistry.getImageDescriptor("CLASS"), ClassImageRegistry.getImageDescriptor("CLASS_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDataType(), "default");
        entries.add(new ModelerCreationToolEntry("DataType", "DataType", factory, ClassImageRegistry.getImageDescriptor("DATATYPE"), ClassImageRegistry.getImageDescriptor("DATATYPE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getInterface(), "default");
        entries.add(new ModelerCreationToolEntry("Interface", "Interface", factory, ClassImageRegistry.getImageDescriptor("INTERFACE"), ClassImageRegistry.getImageDescriptor("INTERFACE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getOperation(), "default");
        entries.add(new ModelerCreationToolEntry("Operation", "Operation", factory, ClassImageRegistry.getImageDescriptor("OPERATION"), ClassImageRegistry.getImageDescriptor("OPERATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getProperty(), "default");
        entries.add(new ModelerCreationToolEntry("Property", "Property", factory, ClassImageRegistry.getImageDescriptor("PROPERTY"), ClassImageRegistry.getImageDescriptor("PROPERTY_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getInstanceSpecification(), "default");
        entries.add(new ModelerCreationToolEntry("InstanceSpecification", "InstanceSpecification", factory, ClassImageRegistry.getImageDescriptor("INSTANCESPECIFICATION"),
                ClassImageRegistry.getImageDescriptor("INSTANCESPECIFICATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getSlot(), "default");
        entries.add(new ModelerCreationToolEntry("Slot", "Slot", factory, ClassImageRegistry.getImageDescriptor("SLOT"), ClassImageRegistry.getImageDescriptor("SLOT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getEnumeration(), "default");
        entries.add(new ModelerCreationToolEntry("Enumeration", "Enumeration", factory, ClassImageRegistry.getImageDescriptor("ENUMERATION"),
                ClassImageRegistry.getImageDescriptor("ENUMERATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getEnumerationLiteral(), "default");
        entries.add(new ModelerCreationToolEntry("Enumeration Literal", "Enumeration Literal", factory, ClassImageRegistry.getImageDescriptor("ENUMERATIONLITERAL"),
                ClassImageRegistry.getImageDescriptor("ENUMERATIONLITERAL_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getPrimitiveType(), "default");
        entries.add(new ModelerCreationToolEntry("Primitive Type", "Primitive Type", factory, ClassImageRegistry.getImageDescriptor("PRIMITIVETYPE"),
                ClassImageRegistry.getImageDescriptor("PRIMITIVETYPE_LARGE")));

        objectsDrawer.addAll(entries);
        getRoot().add(objectsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated NOT
     */
    private void createConnectionsDrawer()
    {
        connectionsDrawer = new PaletteDrawer("Connections", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();

        CreationFactory factory;

        PaletteStack associationStack = new PaletteStack("Association", "Association", ClassImageRegistry.getImageDescriptor("ASSOCIATION"));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAssociation(), "default")
        {
            public EObject getNewModelObject()
            {
                Association element = (Association) super.getNewModelObject();
                Property property1 = UMLFactory.eINSTANCE.createProperty();
                property1.setName("source");
                property1.setLower(1);
                property1.setUpper(1);

                Property property2 = UMLFactory.eINSTANCE.createProperty();
                property2.setName("target");
                property2.setLower(1);
                property2.setUpper(1);

                element.getOwnedEnds().add(property1);
                element.getOwnedEnds().add(property2);
                return element;
            }
        };
        associationStack.add(new ModelerConnectionCreationToolEntry("Association", "Association", factory, ClassImageRegistry.getImageDescriptor("ASSOCIATION"),
                ClassImageRegistry.getImageDescriptor("ASSOCIATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAssociation(), "default")
        {
            public EObject getNewModelObject()
            {
                Association element = (Association) super.getNewModelObject();
                Property property1 = UMLFactory.eINSTANCE.createProperty();
                property1.setName("source");
                property1.setLower(1);
                property1.setUpper(1);

                Property property2 = UMLFactory.eINSTANCE.createProperty();
                property2.setName("target");
                property2.setLower(1);
                property2.setUpper(1);

                element.getOwnedEnds().add(property1);
                element.getOwnedEnds().add(property2);

                // The isNavigable property should be set after the property is attached to the Association.
                property2.setIsNavigable(true);
                return element;
            }
        };
        associationStack.add(new ModelerConnectionCreationToolEntry("Association (UniDir.)", "Association (UniDir.)", factory, ClassImageRegistry.getImageDescriptor("ASSOCIATION_UNIDIRECTIONAL"),
                ClassImageRegistry.getImageDescriptor("ASSOCIATION_UNIDIRECTIONAL_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAssociation(), "default")
        {
            public EObject getNewModelObject()
            {
                Association element = (Association) super.getNewModelObject();
                Property property1 = UMLFactory.eINSTANCE.createProperty();
                property1.setName("source");
                property1.setLower(1);
                property1.setUpper(1);

                Property property2 = UMLFactory.eINSTANCE.createProperty();
                property2.setName("target");
                property2.setLower(1);
                property2.setUpper(1);
                property2.setAggregation(AggregationKind.COMPOSITE_LITERAL);

                element.getOwnedEnds().add(property1);
                element.getOwnedEnds().add(property2);
                return element;
            }
        };
        associationStack.add(new ModelerConnectionCreationToolEntry("Association (Composite)", "Association (Composite)", factory, ClassImageRegistry.getImageDescriptor("ASSOCIATION_COMPOSITE"),
                ClassImageRegistry.getImageDescriptor("ASSOCIATION_COMPOSITE_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getAssociation(), "default")
        {
            public EObject getNewModelObject()
            {
                Association element = (Association) super.getNewModelObject();
                Property property1 = UMLFactory.eINSTANCE.createProperty();
                property1.setName("source");
                property1.setLower(1);
                property1.setUpper(1);

                Property property2 = UMLFactory.eINSTANCE.createProperty();
                property2.setName("target");
                property2.setLower(1);
                property2.setUpper(1);
                property2.setAggregation(AggregationKind.SHARED_LITERAL);

                element.getOwnedEnds().add(property1);
                element.getOwnedEnds().add(property2);
                return element;
            }
        };
        associationStack.add(new ModelerConnectionCreationToolEntry("Association (Shared)", "Association (Shared)", factory, ClassImageRegistry.getImageDescriptor("ASSOCIATION_SHARED"),
                ClassImageRegistry.getImageDescriptor("ASSOCIATION_SHARED_LARGE")));

        entries.add(associationStack);

        // factory = new GraphElementCreationFactory(creationUtils,
        // UMLPackage.eINSTANCE.getAssociationClass(), "default")
        // {
        // public EObject getNewModelObject()
        // {
        // AssociationClass element = (AssociationClass)
        // super.getNewModelObject();
        // Property property1 = UMLFactory.eINSTANCE.createProperty();
        // property1.setName("source");
        // property1.setLower(1);
        // property1.setUpper(1);
        //
        // Property property2 = UMLFactory.eINSTANCE.createProperty();
        // property2.setName("target");
        // property2.setLower(1);
        // property2.setUpper(1);
        //
        // element.getOwnedEnds().add(property1);
        // element.getOwnedEnds().add(property2);
        // return element;
        // }
        // };
        // entries.add(new
        // ModelerConnectionCreationToolEntry("AssociationClass",
        // "AssociationClass", factory,
        // ClassImageRegistry.getImageDescriptor("ASSOCIATIONCLASS"),
        // ClassImageRegistry.getImageDescriptor("ASSOCIATIONCLASS_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getGeneralization(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Generalization", "Generalization", factory, ClassImageRegistry.getImageDescriptor("GENERALIZATION"),
                ClassImageRegistry.getImageDescriptor("GENERALIZATION_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getInterfaceRealization(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("InterfaceRealization", "InterfaceRealization", factory, ClassImageRegistry.getImageDescriptor("INTERFACEREALIZATION"),
                ClassImageRegistry.getImageDescriptor("INTERFACEREALIZATION_LARGE")));

        PaletteStack dependencyStack = new PaletteStack("Dependency", "Dependency", ClassImageRegistry.getImageDescriptor("DEPENDENCY"));
        
        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getDependency(), "default");
        dependencyStack.add(new ModelerConnectionCreationToolEntry("Dependency", "Dependency", factory, ClassImageRegistry.getImageDescriptor("DEPENDENCY"),
                ClassImageRegistry.getImageDescriptor("DEPENDENCY_LARGE")));
        
        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getUsage(), "default");
        dependencyStack.add(new ModelerConnectionCreationToolEntry("Usage", "Usage", factory, ClassImageRegistry.getImageDescriptor("USAGE"),
                ClassImageRegistry.getImageDescriptor("USAGE_LARGE")));
        
        entries.add(dependencyStack);

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getPackageImport(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Package Import", "Package Import", factory, ClassImageRegistry.getImageDescriptor("PACKAGEIMPORT"),
                ClassImageRegistry.getImageDescriptor("PACKAGEIMPORT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getPackageMerge(), "default");
        entries.add(new ModelerConnectionCreationToolEntry("Package Merge", "Package Merge", factory, ClassImageRegistry.getImageDescriptor("PACKAGEMERGE"),
                ClassImageRegistry.getImageDescriptor("PACKAGEMERGE_LARGE")));

        connectionsDrawer.addAll(entries);
        getRoot().add(connectionsDrawer);
    }

    /**
     * Creates the Palette container containing all the Palette entries for each figure. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private void createCommentDrawer()
    {
        commentDrawer = new PaletteDrawer("Comment", null);
        List<PaletteEntry> entries = new ArrayList<PaletteEntry>();

        CreationFactory factory;

        factory = new GraphElementCreationFactory(creationUtils, UMLPackage.eINSTANCE.getComment(), "default");
        entries.add(new ModelerCreationToolEntry("Comment", "Comment", factory, ClassImageRegistry.getImageDescriptor("COMMENT"), ClassImageRegistry.getImageDescriptor("COMMENT_LARGE")));

        factory = new GraphElementCreationFactory(creationUtils, ClassSimpleObjectConstants.SIMPLE_OBJECT_COMMENTLINK, "default", false);
        entries.add(new ModelerConnectionCreationToolEntry("Comment link", "Comment link", factory, ClassImageRegistry.getImageDescriptor("COMMENTLINK"),
                ClassImageRegistry.getImageDescriptor("COMMENTLINK_LARGE")));

        commentDrawer.addAll(entries);
        getRoot().add(commentDrawer);
    }

}
