/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.classdiagram.figures;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.Locator;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.topcased.modeler.edit.locators.EdgeObjectOffsetLocator;
import org.topcased.modeler.figures.EdgeObjectEditableLabel;
import org.topcased.modeler.figures.EdgeObjectOffsetEditableLabel;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.figures.IEdgeObjectOffsetFigure;
import org.topcased.modeler.figures.IGraphEdgeFigure;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class AssociationClassFigure extends PolylineConnectionEx implements IGraphEdgeFigure, HandleBounds
{

    /**
     * @generated
     */
    private IEdgeObjectFigure srcNameEdgeObject;

    /**
     * @generated
     */
    private Locator srcNameLocator;

    /**
     * @generated
     */
    private IEdgeObjectFigure srcCountEdgeObject;

    /**
     * @generated
     */
    private Locator srcCountLocator;

    /**
     * @generated
     */
    private IEdgeObjectFigure targetNameEdgeObject;

    /**
     * @generated
     */
    private Locator targetNameLocator;

    /**
     * @generated
     */
    private IEdgeObjectFigure targetCountEdgeObject;

    /**
     * @generated
     */
    private Locator targetCountLocator;

    /**
     * @generated
     */
    private IEdgeObjectFigure middleNameEdgeObject;

    /**
     * @generated
     */
    private Locator middleNameLocator;

    /**
     * The constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public AssociationClassFigure()
    {
        super();

        srcNameEdgeObject = new EdgeObjectEditableLabel(this);
        srcNameLocator = new ConnectionEndpointLocator(this, false);
        add(srcNameEdgeObject, srcNameLocator);

        srcCountEdgeObject = new EdgeObjectEditableLabel(this);
        srcCountLocator = new ConnectionEndpointLocator(this, false);
        add(srcCountEdgeObject, srcCountLocator);

        targetNameEdgeObject = new EdgeObjectEditableLabel(this);
        targetNameLocator = new ConnectionEndpointLocator(this, true);
        add(targetNameEdgeObject, targetNameLocator);

        targetCountEdgeObject = new EdgeObjectEditableLabel(this);
        targetCountLocator = new ConnectionEndpointLocator(this, true);
        add(targetCountEdgeObject, targetCountLocator);

        middleNameEdgeObject = new EdgeObjectOffsetEditableLabel(this);
        middleNameLocator = new EdgeObjectOffsetLocator((IEdgeObjectOffsetFigure) middleNameEdgeObject);
        add(middleNameEdgeObject, middleNameLocator);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getSrcNameEdgeObjectFigure()
    {
        return srcNameEdgeObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getSrcCountEdgeObjectFigure()
    {
        return srcCountEdgeObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getTargetNameEdgeObjectFigure()
    {
        return targetNameEdgeObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getTargetCountEdgeObjectFigure()
    {
        return targetCountEdgeObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the object figure
     * @generated
     */
    public IEdgeObjectFigure getMiddleNameEdgeObjectFigure()
    {
        return middleNameEdgeObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.figures.IGraphEdgeFigure#getLocator(org.topcased.modeler.figures.IEdgeObjectFigure)
     * @generated
     */
    public Locator getLocator(IEdgeObjectFigure edgeObjectfigure)
    {
        if (edgeObjectfigure == srcNameEdgeObject)
        {
            return srcNameLocator;
        }
        if (edgeObjectfigure == srcCountEdgeObject)
        {
            return srcCountLocator;
        }
        if (edgeObjectfigure == targetNameEdgeObject)
        {
            return targetNameLocator;
        }
        if (edgeObjectfigure == targetCountEdgeObject)
        {
            return targetCountLocator;
        }
        if (edgeObjectfigure == middleNameEdgeObject)
        {
            return middleNameLocator;
        }

        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
     * @generated
     */
    public Rectangle getHandleBounds()
    {
        return getPoints().getBounds();
    }
}