/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.componentdiagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.uml.alldiagram.ExactUMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model Object <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class ComponentCreationUtils extends AbstractCreationUtils
{

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param diagramConf the Diagram Graphical Configuration
     * @generated
     */
    public ComponentCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private class GraphicUMLSwitch extends ExactUMLSwitch
    {
        /** The presentation of the graphical element */
        private String presentation;

        /**
         * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicUMLSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseComponent(org.eclipse.uml2.uml.Component)
         * @generated
         */
        public Object caseComponent(org.eclipse.uml2.uml.Component object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementComponent(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseInterface(org.eclipse.uml2.uml.Interface)
         * @generated
         */
        public Object caseInterface(org.eclipse.uml2.uml.Interface object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInterface(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#casePort(org.eclipse.uml2.uml.Port)
         * @generated
         */
        public Object casePort(org.eclipse.uml2.uml.Port object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementPort(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseComponentRealization(org.eclipse.uml2.uml.ComponentRealization)
         * @generated
         */
        public Object caseComponentRealization(org.eclipse.uml2.uml.ComponentRealization object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementComponentRealization(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization)
         * @generated
         */
        public Object caseInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementInterfaceRealization(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseUsage(org.eclipse.uml2.uml.Usage)
         * @generated
         */
        public Object caseUsage(org.eclipse.uml2.uml.Usage object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementUsage(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         * @generated
         */
        public Object caseComment(org.eclipse.uml2.uml.Comment object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementComment(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;

        if ("http://www.eclipse.org/uml2/2.1.0/UML".equals(obj.eClass().getEPackage().getNsURI()))
        {
            graphElt = new GraphicUMLSwitch(presentation).doSwitch(obj);
        }

        if (graphElt instanceof GraphElement)
        {
            return (GraphElement) graphElt;
        }

        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComponent(org.eclipse.uml2.uml.Component element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInterface(org.eclipse.uml2.uml.Interface element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementPort(org.eclipse.uml2.uml.Port element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComponentRealization(org.eclipse.uml2.uml.ComponentRealization element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(ComponentEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementInterfaceRealization(org.eclipse.uml2.uml.InterfaceRealization element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementUsage(org.eclipse.uml2.uml.Usage element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComment(org.eclipse.uml2.uml.Comment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated
     */
    public EObject createModelObject(EObject obj)
    {
        return obj;
    }

}
