/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.componentdiagram.commands;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditDomain;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Usage;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.utils.Utils;

/**
 * Usage edge creation command<br>
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class UsageEdgeCreationCommand extends CreateTypedEdgeCommand
{

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @generated
     */
    public UsageEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src)
    {
        this(domain, newObj, src, true);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param domain the edit domain
     * @param newObj the graph edge of the new connection
     * @param src the graph element of the source
     * @param needModelUpdate set it to true if the model need to be updated
     * @generated
     */
    public UsageEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src, boolean needModelUpdate)
    {
        super(domain, newObj, src, needModelUpdate);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void redoModel()
    {
        // To specify that a Port (say P1) "requires" an interface (say I1) :
        // - the source Port P1 must be first initialized with a Class (say C1)
        // - the "Usage" relationship is then created between C1 and the target Interface I1
        EObject srcElt = Utils.getElement(getSource());
        Interface interfaceElt = (Interface) Utils.getElement(getTarget());
        Usage usageElt = (Usage) Utils.getElement(getEdge());

        if (srcElt instanceof Port && ((Port) srcElt).getType() instanceof org.eclipse.uml2.uml.Class)
        {
            usageElt.getClients().add(((Port) srcElt).getType());
            usageElt.getSuppliers().add(interfaceElt);
            ((Port) srcElt).getNearestPackage().getPackagedElements().add(usageElt);
        }

        else
        {
            super.redoModel();
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void undoModel()
    {
        EObject srcElt = Utils.getElement(getSource());
        Interface interfaceElt = (Interface) Utils.getElement(getTarget());
        Usage usageElt = (Usage) Utils.getElement(getEdge());

        if (srcElt instanceof Port && ((Port) srcElt).getType() instanceof org.eclipse.uml2.uml.Class)
        {
            usageElt.getClients().remove(((Port) srcElt).getType());
            usageElt.getSuppliers().remove(interfaceElt);
            ((Port) srcElt).getNearestPackage().getPackagedElements().remove(usageElt);
        }

        else
        {
            super.undoModel();
        }
    }

}