/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.componentdiagram.policies;

import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.Port;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy;
import org.topcased.modeler.utils.Utils;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ComponentDiagramLayoutEditPolicy extends ModelerLayoutEditPolicy
{
    /**
     * Default contructor.<br>
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public ComponentDiagramLayoutEditPolicy()
    {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy#isAttachedToBorder(org.topcased.modeler.di.model.GraphNode)
     * @generated NOT
     */
    protected boolean isAttachedToBorder(GraphNode node)
    {
        if (Utils.getElement(node) instanceof Port)
        {
            return true;
        }
        return super.isAttachedToBorder(node);
    }

    /**
     * The same Interface may be displayed several time in the same Component
     * 
     * @see org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy#isSeveralDisplayAllowed(org.topcased.modeler.di.model.GraphNode,
     *      org.topcased.modeler.di.model.GraphNode, boolean)
     */
    protected boolean isSeveralDisplayAllowed(GraphNode parent, GraphNode child, boolean needModelUpdate)
    {
        return Utils.getElement(child) instanceof Interface;
    }

    /**
     * Enable to display Interfaces that are not contained directly by the Component
     * 
     * @see org.topcased.modeler.edit.policies.ModelerLayoutEditPolicy#isExternalObjectAllowed(org.topcased.modeler.di.model.GraphNode,
     *      org.topcased.modeler.di.model.GraphNode)
     */
    protected boolean isExternalObjectAllowed(GraphNode parent, GraphNode child)
    {
        return Utils.getElement(child) instanceof Interface;
    }
}