/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.commands;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditDomain;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Usage;
import org.topcased.modeler.commands.CreateTypedEdgeCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.utils.Utils;

/**
 * Usage edge creation command
 * 
 * @generated
 */
public class UsageEdgeCreationCommand extends CreateTypedEdgeCommand
{

	/**
	 * @param domain the edit domain
	 * @param newObj the graph edge of the new connection
	 * @param src the graph element of the source
	 * @generated
	 */
	public UsageEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src)
	{
		this(domain, newObj, src, true);
	}

	/**
	 * @param domain the edit domain
	 * @param newObj the graph edge of the new connection
	 * @param src the graph element of the source
	 * @param needModelUpdate set it to true if the model need to be updated
	 * @generated
	 */
	public UsageEdgeCreationCommand(EditDomain domain, GraphEdge newObj, GraphElement src, boolean needModelUpdate)
	{
		super(domain, newObj, src, needModelUpdate);
	}
	
	/**
	 * @see org.topcased.modeler.commands.CreateGraphEdgeCommand#execute()
	 * @generated NOT
	 */
	public void execute()
	{
		super.execute();
		
		// at this step, the client value is not the good one
		Usage usage  = (Usage) Utils.getElement(getEdge());
		usage.getClients().clear();
		
		// its value depends on the case : either the port is on the Class or on a Property
		EObject container = Utils.getElement(getSource().getContainer());
		if (container instanceof Property)
		{
			usage.getClients().add((NamedElement) ((Property) container).getType());
		}

		if (container instanceof Class) 
		{
			usage.getClients().add((NamedElement) container);
		}
	}
	
	/**
	 * @generated
	 */
	protected void redoModel()
	{
		super.redoModel();
	}

	/**
	 * @generated
	 */
	protected void undoModel()
	{
		super.undoModel();
	}
}