/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.common.dialog;

import org.eclipse.swt.widgets.Shell;
import org.eclipse.uml2.uml.StructuredClassifier;

/**
 * A Dialog used to create a new 'Type' or reference an existing 'Type' during the creation of a Port.
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 */
public class ReferencePortDialog extends ReferencePropertyDialog
{
	
	/**
     * Creates the Dialog window to select a Classifier to associate with the current Port.
     * 
     * @param class the class that contains the State
     * @param parentShell the parent Shell
     */
    public ReferencePortDialog(StructuredClassifier structuredClass_, Shell parentShell_)
    {
        super(structuredClass_, parentShell_);
        type = "Port";
    }
}
