/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.common.util;

import java.util.List;

import org.eclipse.uml2.uml.Collaboration;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Model;
import org.topcased.modeler.uml.UMLTools;

/**
 * This class will be useful to find all the 'Collaboration' in the model
 * It takes into account the full model exploration<br>
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 */
public final class CollaborationHelper
{
	
	/**
	 * The default constructor
	 */
	public CollaborationHelper()
	{
		// no default constructor
	}
	
	/**
	 * Gets all the 'Collaboration' instance of the model
	 * 
	 * @param container The element to search in
	 * @return The list containing all the 'Collaboration' referenced in the current model.
	 */
	public static List<Element> getAvailableCollaboration(Model model)
	{
		return UMLTools.getAllObjects(model, Collaboration.class);
	}
}
