/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.uml2.uml.NamedElement;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.edit.DiagramEditPart;
import org.topcased.modeler.uml.compositestructuresdiagram.figures.CompositeStructuresDiagramFigure;
import org.topcased.modeler.uml.compositestructuresdiagram.policies.CompositeStructuresDiagramLayoutEditPolicy;
import org.topcased.modeler.utils.Utils;

/**
 * @generated
 */
public class CompositeStructuresDiagramEditPart extends DiagramEditPart
{

	/**
	 * The Constructor
	 * 
	 * @param model the root model element
	 * @generated
	 */
	public CompositeStructuresDiagramEditPart(Diagram model)
	{
		super(model);
	}

	/**
	 * @see org.topcased.modeler.edit.DiagramEditPart#getLayoutEditPolicy()
	 * @generated
	 */
	protected EditPolicy getLayoutEditPolicy()
	{
		return new CompositeStructuresDiagramLayoutEditPolicy();
	}

	/**
	 * @see org.topcased.modeler.edit.DiagramEditPart#createBodyFigure()
	 * @generated
	 */
	protected IFigure createBodyFigure()
	{
		return new CompositeStructuresDiagramFigure();
	}

	/** 
	 * @see org.topcased.modeler.edit.DiagramEditPart#getHeaderDiagram()
	 * @generated NOT
	 */
	protected String getHeaderDiagram()
	{
		return ((NamedElement) Utils.getElement(getDiagram())).getName();
	}
}