/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.uml.compositestructuresdiagram.figures.UsageFigure;
import org.topcased.modeler.uml.compositestructuresdiagram.figures.internal.HalfCircleDecoration;

/**
 * Usage controller
 * 
 * @generated
 */
public class UsageEditPart extends EMFGraphEdgeEditPart
{
	/**
	 * Constructor
	 * 
	 * @param model the graph object
	 * @generated
	 */
	public UsageEditPart(GraphEdge model)
	{
		super(model);
	}

	/**
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 * @generated
	 */
	protected void createEditPolicies()
	{
		super.createEditPolicies();

		installEditPolicy(ModelerEditPolicyConstants.CHANGE_FONT_EDITPOLICY, null);
	}

	/**
	 * @return the Figure
	 * @generated NOT
	 */
	protected IFigure createFigure()
	{
		UsageFigure connection = new UsageFigure();

		createTargetDecoration(connection);

		return connection;
	}

	/**
	 * @param connection the PolylineConnection
	 * @generated NOT
	 */
	private void createTargetDecoration(PolylineConnection connection)
	{
		connection.setTargetDecoration(new HalfCircleDecoration(connection));
	}
}