/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.figures;


import org.topcased.modeler.uml.figure.UMLDiagramFigure;

/**
 * The main figure aims to display a Composite Structures Diagram.
 *
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 */
public class CompositeStructuresDiagramFigure extends UMLDiagramFigure 
{
	/**
	 * Constant indicating the diagram type.
	 */
	private static final String PREFIX_TEXT = "composite structure "; 
	
	/**
	 * Constructor
	 */
	public CompositeStructuresDiagramFigure()
	{
		super();
	}
	
	/**
	 * Gets the prefix part of the diagram title.
	 * 
	 * @return The prefix part of the diagram title
	 */
	protected String getPrefixText()
	{
		return PREFIX_TEXT;
	}
}
