/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.figures;

import org.eclipse.draw2d.ConnectionEndpointLocator;
import org.eclipse.draw2d.Locator;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.topcased.modeler.edit.locators.EdgeObjectOffsetLocator;
import org.topcased.modeler.figures.EdgeObjectEditableLabel;
import org.topcased.modeler.figures.EdgeObjectOffsetEditableLabel;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.figures.IEdgeObjectOffsetFigure;
import org.topcased.modeler.figures.IGraphEdgeFigure;

/**
 * Represents a 'Connector' Figure.<br>
 * The multiplicities labels are attached to the start point and the end point.<br>
 * 
 * @author <a href="mailto:sebastien.gabel@c-s.fr">Sebastien GABEL</a>
 */
public class ConnectorFigure extends PolylineConnectionEx implements IGraphEdgeFigure, HandleBounds
{

	/**
	 * @generated
	 */
	private IEdgeObjectFigure srcCountEdgeObject;

	/**
	 * @generated
	 */
	private Locator srcCountLocator;

	/**
	 * @generated
	 */
	private IEdgeObjectFigure targetCountEdgeObject;

	/**
	 * @generated
	 */
	private Locator targetCountLocator;

	/**
	 * @generated
	 */
	private IEdgeObjectFigure middleNameEdgeObject;

	/**
	 * @generated
	 */
	private Locator middleNameLocator;

	/**
	 * The constructor
	 * 
	 * @generated
	 */
	public ConnectorFigure()
	{
		super();

		srcCountEdgeObject = new EdgeObjectEditableLabel(this);
		srcCountLocator = new ConnectionEndpointLocator(this, false);
		add(srcCountEdgeObject, srcCountLocator);

		targetCountEdgeObject = new EdgeObjectEditableLabel(this);
		targetCountLocator = new ConnectionEndpointLocator(this, true);
		add(targetCountEdgeObject, targetCountLocator);

		middleNameEdgeObject = new EdgeObjectOffsetEditableLabel(this);
		middleNameLocator = new EdgeObjectOffsetLocator((IEdgeObjectOffsetFigure) middleNameEdgeObject);
		add(middleNameEdgeObject, middleNameLocator);
	}

	/**
	 * @return the object figure
	 * @generated
	 */
	public IEdgeObjectFigure getSrcCountEdgeObjectFigure()
	{
		return srcCountEdgeObject;
	}

	/**
	 * @return the object figure
	 * @generated
	 */
	public IEdgeObjectFigure getTargetCountEdgeObjectFigure()
	{
		return targetCountEdgeObject;
	}

	/**
	 * @return the object figure
	 * @generated
	 */
	public IEdgeObjectFigure getMiddleNameEdgeObjectFigure()
	{
		return middleNameEdgeObject;
	}

	/**
	 * @see org.topcased.modeler.figures.IGraphEdgeFigure#getLocator(org.topcased.modeler.figures.IEdgeObjectFigure)
	 * @generated
	 */
	public Locator getLocator(IEdgeObjectFigure edgeObjectfigure)
	{
		if (edgeObjectfigure == srcCountEdgeObject)
		{
			return srcCountLocator;
		}
		if (edgeObjectfigure == targetCountEdgeObject)
		{
			return targetCountLocator;
		}
		if (edgeObjectfigure == middleNameEdgeObject) 
		{
			return middleNameLocator;
		}
		
		return null;
	}

	/**
	 * @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
	 * @generated
	 */
	public Rectangle getHandleBounds()
	{
		return getPoints().getBounds();
	}
}