/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.modeler.uml.compositestructuresdiagram.policies;

import org.topcased.modeler.edit.policies.EdgeObjectUVEditPolicy;
import org.topcased.modeler.figures.IEdgeObjectFigure;
import org.topcased.modeler.uml.compositestructuresdiagram.figures.ConnectorFigure;

/**
 * An edit policy to select and move the name and the cardinality label relative to the EReference connection.
 *
 * @generated
 */
public class ConnectorEdgeObjectUVEditPolicy extends EdgeObjectUVEditPolicy {
	
	/**
	 * @see org.topcased.modeler.edit.policies.EdgeObjectUVEditPolicy#isEnd(org.topcased.modeler.figures.IEdgeObjectFigure)
	 * @generated
	 */
	protected boolean isEnd(IEdgeObjectFigure figure)
	{
		ConnectorFigure connectorFigure = (ConnectorFigure) getHostFigure();

		if (figure == connectorFigure.getSrcCountEdgeObjectFigure()) {
			return false;
		}
		if (figure == connectorFigure.getTargetCountEdgeObjectFigure()) {
			return true;
		}

		return true;
	}

}
