/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.deploymentdiagram;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.ecore.EObject;
import org.topcased.modeler.di.model.DiagramInterchangeFactory;
import org.topcased.modeler.di.model.EdgeObjectOffset;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.graphconf.DiagramGraphConf;
import org.topcased.modeler.uml.alldiagram.ExactUMLSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model Object <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class DeploymentCreationUtils extends AbstractCreationUtils
{

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param diagramConf the Diagram Graphical Configuration
     * @generated
     */
    public DeploymentCreationUtils(DiagramGraphConf diagramConf)
    {
        super(diagramConf);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private class GraphicUMLSwitch extends ExactUMLSwitch
    {
        /** The presentation of the graphical element */
        private String presentation;

        /**
         * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @param presentation the presentation of the graphical element
         * @generated
         */
        public GraphicUMLSwitch(String presentation)
        {
            this.presentation = presentation;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseNode(org.eclipse.uml2.uml.Node)
         * @generated
         */
        public Object caseNode(org.eclipse.uml2.uml.Node object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementNode(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDevice(org.eclipse.uml2.uml.Device)
         * @generated
         */
        public Object caseDevice(org.eclipse.uml2.uml.Device object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDevice(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseExecutionEnvironment(org.eclipse.uml2.uml.ExecutionEnvironment)
         * @generated
         */
        public Object caseExecutionEnvironment(org.eclipse.uml2.uml.ExecutionEnvironment object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementExecutionEnvironment(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseArtifact(org.eclipse.uml2.uml.Artifact)
         * @generated
         */
        public Object caseArtifact(org.eclipse.uml2.uml.Artifact object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementArtifact(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDeploymentSpecification(org.eclipse.uml2.uml.DeploymentSpecification)
         * @generated
         */
        public Object caseDeploymentSpecification(org.eclipse.uml2.uml.DeploymentSpecification object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDeploymentSpecification(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDeployment(org.eclipse.uml2.uml.Deployment)
         * @generated
         */
        public Object caseDeployment(org.eclipse.uml2.uml.Deployment object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDeployment(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseManifestation(org.eclipse.uml2.uml.Manifestation)
         * @generated
         */
        public Object caseManifestation(org.eclipse.uml2.uml.Manifestation object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementManifestation(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseCommunicationPath(org.eclipse.uml2.uml.CommunicationPath)
         * @generated
         */
        public Object caseCommunicationPath(org.eclipse.uml2.uml.CommunicationPath object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementCommunicationPath(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseDependency(org.eclipse.uml2.uml.Dependency)
         * @generated
         */
        public Object caseDependency(org.eclipse.uml2.uml.Dependency object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementDependency(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#caseComment(org.eclipse.uml2.uml.Comment)
         * @generated
         */
        public Object caseComment(org.eclipse.uml2.uml.Comment object)
        {
            if ("default".equals(presentation))
            {
                return createGraphElementComment(object, presentation);
            }
            return null;
        }

        /**
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * 
         * @see org.eclipse.uml2.uml.util.UMLSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
         * @generated
         */
        public Object defaultCase(EObject object)
        {
            return null;
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject,
     *      java.lang.String)
     * @generated
     */
    public GraphElement createGraphElement(EObject obj, String presentation)
    {
        Object graphElt = null;

        if ("http://www.eclipse.org/uml2/2.1.0/UML".equals(obj.eClass().getEPackage().getNsURI()))
        {
            graphElt = new GraphicUMLSwitch(presentation).doSwitch(obj);
        }

        if (graphElt instanceof GraphElement)
        {
            return (GraphElement) graphElt;
        }

        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementNode(org.eclipse.uml2.uml.Node element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDevice(org.eclipse.uml2.uml.Device element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementExecutionEnvironment(org.eclipse.uml2.uml.ExecutionEnvironment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementArtifact(org.eclipse.uml2.uml.Artifact element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDeploymentSpecification(org.eclipse.uml2.uml.DeploymentSpecification element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDeployment(org.eclipse.uml2.uml.Deployment element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset deployEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        deployEdgeObjectOffset.setId(DeploymentEdgeObjectConstants.DEPLOY_EDGE_OBJECT_ID);
        deployEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(deployEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementManifestation(org.eclipse.uml2.uml.Manifestation element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset manifestEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        manifestEdgeObjectOffset.setId(DeploymentEdgeObjectConstants.MANIFEST_EDGE_OBJECT_ID);
        manifestEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(manifestEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementCommunicationPath(org.eclipse.uml2.uml.CommunicationPath element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset nameEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        nameEdgeObjectOffset.setId(DeploymentEdgeObjectConstants.NAME_EDGE_OBJECT_ID);
        nameEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(nameEdgeObjectOffset);
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(DeploymentEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, -20));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementDependency(org.eclipse.uml2.uml.Dependency element, String presentation)
    {
        GraphEdge graphEdge = createGraphEdge(element, presentation);
        EdgeObjectOffset stereotypeEdgeObjectOffset = DiagramInterchangeFactory.eINSTANCE.createEdgeObjectOffset();
        stereotypeEdgeObjectOffset.setId(DeploymentEdgeObjectConstants.STEREOTYPE_EDGE_OBJECT_ID);
        stereotypeEdgeObjectOffset.setOffset(new Dimension(0, 0));
        graphEdge.getContained().add(stereotypeEdgeObjectOffset);
        return graphEdge;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param element the model element
     * @param presentation the presentation of the graphical element
     * @return the complete GraphElement
     * @generated
     */
    protected GraphElement createGraphElementComment(org.eclipse.uml2.uml.Comment element, String presentation)
    {
        return createGraphNode(element, presentation);
    }

    /**
     * Create the ModelObject with its initial children <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the model object
     * @return the model object with its children
     * @generated
     */
    public EObject createModelObject(EObject obj)
    {
        return obj;
    }

}
