/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jacques Lescot (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.modeler.uml.deploymentdiagram.figures;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.StackLayout;
import org.topcased.draw2d.figures.Label;

/**
 * Create the header figure of the Artifact. The header will contain a centered label with the text
 * "&lt;&lt;artifact&gt;&gt;" and an artifact icon displayed in the right hand corner of the artifact figure.
 * 
 * Creation 24 juil. 06
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public class HeaderArtifact extends Figure
{
    /**
     * Constructor
     */
    public HeaderArtifact()
    {
        setLayoutManager(new StackLayout());

        add(new Label("<<artifact>>"));

        IFigure iconContainer = new Figure();
        iconContainer.setLayoutManager(new BorderLayout());
        IFigure artifactIcon = new ArtifactIcon();
        artifactIcon.setSize(15, 20);
        iconContainer.add(artifactIcon, new Integer(PositionConstants.RIGHT));
        add(iconContainer);
    }

}
