/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware Technologies),
 *   Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware Technologies),
 *   Nicolas Lalev�e (Anyware Technologies) - initial API and implementation 
 ******************************************************************************/

package org.topcased.modeler.uml.editor;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.views.contentoutline.IContentOutlinePage;
import org.eclipse.uml2.uml.edit.providers.UMLItemProviderAdapterFactory;
import org.topcased.modeler.documentation.EAnnotationDocPage;
import org.topcased.modeler.documentation.IDocPage;
import org.topcased.modeler.editor.Modeler;
import org.topcased.modeler.uml.UMLPlugin;
import org.topcased.modeler.uml.editor.outline.UMLOutlinePage;

/**
 * Generated Model editor <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class UMLEditor extends Modeler
{
    /**
     * @see org.topcased.modeler.editor.Modeler#getAdapterFactories() <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected List<AdapterFactory> getAdapterFactories()
    {
        List<AdapterFactory> factories = new ArrayList<AdapterFactory>();
        factories.add(new UMLItemProviderAdapterFactory());
        factories.add(new org.topcased.modeler.uml.providers.UMLModelerProviderAdapterFactory());
        factories.addAll(super.getAdapterFactories());

        return factories;
    }

    /**
     * @see org.topcased.modeler.editor.Modeler#getId()
     * @generated
     */
    public String getId()
    {
        return "org.topcased.modeler.uml.editor.UMLEditor";
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.Modeler#getAdapter(java.lang.Class)
     * @generated
     */
    public Object getAdapter(Class type)
    {
        if (type == IDocPage.class)
        {
            return new EAnnotationDocPage(getCommandStack());
        }
        return super.getAdapter(type);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.editor.Modeler#getPreferenceStore()
     * @generated
     */
    public IPreferenceStore getPreferenceStore()
    {
        return UMLPlugin.getDefault().getPreferenceStore();
    }

    /**
     * Customize the Outline
     * 
     * @see org.topcased.modeler.editor.Modeler#createOutlinePage()
     */
    protected IContentOutlinePage createOutlinePage()
    {
        return new UMLOutlinePage(this);
    }

    /**
     * @see org.eclipse.gef.ui.parts.GraphicalEditorWithPalette#getInitialPaletteSize()
     */
    protected int getInitialPaletteSize()
    {
        return 200;
    }
}
