/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Lalevée (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.uml.sequencediagram.commands;

import org.eclipse.draw2d.geometry.Rectangle;
import org.topcased.draw2d.layout.PortConstraint;
import org.topcased.modeler.commands.ChangeBoundsCommand;
import org.topcased.modeler.di.model.GraphNode;

/**
 * Command to change the bounds of the execution and update the event order
 * 
 * @author <a href="mailto:nicolas.lalevee@anyware-tech.com">Nicolas Lalevée</a>
 * 
 */
public class ExecutionChangeBoundsCommand extends ChangeBoundsCommand
{
    /**
     * Constructor
     * 
     * @param node the node to resize
     * @param constraint the new rectangle that contain the figure
     */
    public ExecutionChangeBoundsCommand(GraphNode node, Rectangle constraint)
    {
        super(node, constraint);
    }

    /**
     * Constructor
     * 
     * @param node the node to resize
     * @param constraint the port constraint
     */
    public ExecutionChangeBoundsCommand(GraphNode node, PortConstraint constraint)
    {
        super(node, constraint);
    }

    /**
     * 
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo()
    {
        super.redo();
        // TODO manage the event order
    }

    /**
     * 
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo()
    {
        super.undo();
        // TODO manage the event order
    }
}
