/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Lalevée (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.uml.sequencediagram.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.geometry.Rectangle;
import org.topcased.draw2d.figures.ILabel;
import org.topcased.draw2d.figures.Label;
import org.topcased.draw2d.layout.GridLayout;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class CombinedFragmentFigure extends org.eclipse.draw2d.Figure
{
    private static final int HEADER_MARGIN = 5;

    private ILabel header;

    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public CombinedFragmentFigure()
    {
        super();

        GridLayout gridLayout = new GridLayout();
        setLayoutManager(gridLayout);
        setBorder(new LineBorder());

        header = new Label();
        ((Label) header).setLabelAlignment(PositionConstants.LEFT);
        add(header);
    }

    /**
     * return the Label that is used to display the InteractionOperator notation
     * 
     * @return the ILabel
     */
    public ILabel getLabel()
    {
        return header;
    }

    /**
     * Do special painting for the header
     * 
     * @see org.eclipse.draw2d.Figure#paintFigure(org.eclipse.draw2d.Graphics)
     */
    protected void paintFigure(Graphics graphics)
    {
        graphics.pushState();
        // TODO : Transparency should be enabled depending on the Advanced Mode
        // that is selected in the PreferenceStore
        // graphics.setAlpha(30);

        Rectangle headerBounds = getLabel().getBounds();
        // graphics.fillRectangle(getBounds());

        int x1 = headerBounds.x - HEADER_MARGIN;
        int x2 = x1 + headerBounds.width + 2 * HEADER_MARGIN;
        int y1 = headerBounds.y - HEADER_MARGIN;
        int y2 = headerBounds.y + headerBounds.height + HEADER_MARGIN;

        int corner = (headerBounds.height + 2 * HEADER_MARGIN) / 4;

        graphics.setLineWidth(1);
        graphics.drawLine(x1, y2, x2, y2);
        graphics.drawLine(x2, y2, x2 + corner, y2 - corner * 2);
        graphics.drawLine(x2 + corner, y2 - corner * 2, x2 + corner, y1);
        graphics.popState();
    }

}