/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Lalevée (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.modeler.uml.sequencediagram.policies;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.edit.GraphEdgeEditPart;
import org.topcased.modeler.uml.sequencediagram.commands.reconnect.MessageMoveCommand;

/**
 * The edit policy that manage the move of messages
 * 
 * @author <a href="mailto:nicolas.lalevee@anyware-tech.com">Nicolas Lalevée</a>
 * 
 */
public class MoveMessageEditPolicy extends MoveGraphEdgeEditPolicy
{

    /**
     * Return the move message command
     * 
     * @see org.topcased.modeler.uml.sequencediagram.policies.MoveGraphEdgeEditPolicy#getCommand(org.topcased.modeler.edit.GraphEdgeEditPart,
     *      org.eclipse.draw2d.geometry.Point, org.eclipse.draw2d.geometry.Point)
     */
    protected Command getCommand(GraphEdgeEditPart edgeEdit, Point initialLoc, Point loc)
    {
        return new MessageMoveCommand(edgeEdit, initialLoc, loc);
    }

}
