// ------------------------------------------------
// $Id: ValueSpecificationContentProvider.java,v 1.1 2007-05-24 15:31:57 jako Exp $
// (c) Anyware Technologies 2007 www.anyware-tech.com
// ------------------------------------------------
package org.topcased.modeler.uml.sequencediagram.providers;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.uml2.uml.Message;

/**
 * Content provider returning the message arguments when the inputElement is a
 * {@link Message}.
 * 
 * @author jrme
 */
public class ValueSpecificationContentProvider implements IStructuredContentProvider
{
    /**
     * 
     * 
     * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
     */
    public Object[] getElements(Object inputElement)
    {
        if (inputElement instanceof Message)
        {
            return ((Message) inputElement).getArguments().toArray();
        }

        return new Object[0];
    }

    public void dispose()
    {
        // nothing to do
    }

    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {
    }
}
