/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.statemachinediagram;

/**
 * A collection of Roles. Each identifier is used to key the EditPolicy. <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public interface STMEditPolicyConstants
{

    /** The key used to install an <i>Element</i> EditPolicy. */
    String ELEMENT_EDITPOLICY = "Element EditPolicy";

    /** The key used to install an <i>Region</i> EditPolicy. */
    String REGION_EDITPOLICY = "Region EditPolicy";

    /** The key used to install an <i>Vertex</i> EditPolicy. */
    String VERTEX_EDITPOLICY = "Vertex EditPolicy";

    /** The key used to install an <i>State</i> EditPolicy. */
    String STATE_EDITPOLICY = "State EditPolicy";

    /** The key used to install an <i>CompositeState</i> EditPolicy. */
    String COMPOSITESTATE_EDITPOLICY = "CompositeState EditPolicy";

    /** The key used to install an <i>SubmachineState</i> EditPolicy. */
    String SUBMACHINESTATE_EDITPOLICY = "SubmachineState EditPolicy";

    /** The key used to install an <i>FinalState</i> EditPolicy. */
    String FINALSTATE_EDITPOLICY = "FinalState EditPolicy";

    /** The key used to install an <i>Transition</i> EditPolicy. */
    String TRANSITION_EDITPOLICY = "Transition EditPolicy";

    /** The key used to install an <i>PseudostateInitial</i> EditPolicy. */
    String PSEUDOSTATEINITIAL_EDITPOLICY = "PseudostateInitial EditPolicy";

    /** The key used to install an <i>PseudostateDeepHistory</i> EditPolicy. */
    String PSEUDOSTATEDEEPHISTORY_EDITPOLICY = "PseudostateDeepHistory EditPolicy";

    /** The key used to install an <i>PseudostateShallowHistory</i> EditPolicy. */
    String PSEUDOSTATESHALLOWHISTORY_EDITPOLICY = "PseudostateShallowHistory EditPolicy";

    /** The key used to install an <i>PseudostateJoin</i> EditPolicy. */
    String PSEUDOSTATEJOIN_EDITPOLICY = "PseudostateJoin EditPolicy";

    /** The key used to install an <i>PseudostateFork</i> EditPolicy. */
    String PSEUDOSTATEFORK_EDITPOLICY = "PseudostateFork EditPolicy";

    /** The key used to install an <i>PseudostateJunction</i> EditPolicy. */
    String PSEUDOSTATEJUNCTION_EDITPOLICY = "PseudostateJunction EditPolicy";

    /** The key used to install an <i>PseudostateChoice</i> EditPolicy. */
    String PSEUDOSTATECHOICE_EDITPOLICY = "PseudostateChoice EditPolicy";

    /** The key used to install an <i>PseudostateEntryPoint</i> EditPolicy. */
    String PSEUDOSTATEENTRYPOINT_EDITPOLICY = "PseudostateEntryPoint EditPolicy";

    /** The key used to install an <i>PseudostateExitPoint</i> EditPolicy. */
    String PSEUDOSTATEEXITPOINT_EDITPOLICY = "PseudostateExitPoint EditPolicy";

    /** The key used to install an <i>PseudostateTerminate</i> EditPolicy. */
    String PSEUDOSTATETERMINATE_EDITPOLICY = "PseudostateTerminate EditPolicy";

    /** The key used to install an <i>ConnectionPointReference</i> EditPolicy. */
    String CONNECTIONPOINTREFERENCE_EDITPOLICY = "ConnectionPointReference EditPolicy";

    /** The key used to install an <i>Comment</i> EditPolicy. */
    String COMMENT_EDITPOLICY = "Comment EditPolicy";

    /** The key used to install an <i>CommentLink</i> EditPolicy. */
    String COMMENTLINK_EDITPOLICY = "CommentLink EditPolicy";

}