/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.statemachinediagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.uml2.uml.ConnectionPointReference;
import org.eclipse.uml2.uml.UMLPackage;
import org.topcased.draw2d.figures.LabelledPortFigure;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.LabelDirectEditPolicy;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.modeler.uml.statemachinediagram.STMEditPolicyConstants;
import org.topcased.modeler.uml.statemachinediagram.commands.ConnectionPointReferenceRestoreConnectionCommand;
import org.topcased.modeler.uml.statemachinediagram.figures.ConnectionPointReferenceFigure;
import org.topcased.modeler.uml.statemachinediagram.policies.TransitionEdgeCreationEditPolicy;

/**
 * The ConnectionPointReference object controller <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ConnectionPointReferenceEditPart extends org.topcased.modeler.edit.PortEditPart
{
    /**
     * Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param obj the graph node
     * @generated
     */
    public ConnectionPointReferenceEditPart(GraphNode obj)
    {
        super(obj);
    }

    /**
     * Creates edit policies and associates these with roles <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void createEditPolicies()
    {
        super.createEditPolicies();

        installEditPolicy(STMEditPolicyConstants.TRANSITION_EDITPOLICY, new TransitionEdgeCreationEditPolicy());
        installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY, new RestoreEditPolicy()
        {
            protected Command getRestoreConnectionsCommand(RestoreConnectionsRequest request)
            {
                return new ConnectionPointReferenceRestoreConnectionCommand(getHost());
            }
        });

        installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LabelDirectEditPolicy());
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     * @generated NOT
     */
    protected IFigure createFigure()
    {
        return new LabelledPortFigure(new ConnectionPointReferenceFigure(!((ConnectionPointReference) getEObject()).getEntries().isEmpty(),
                !((ConnectionPointReference) getEObject()).getExits().isEmpty()));
    }

    /**
     * @see org.topcased.modeler.edit.GraphNodeEditPart#handleModelChanged(org.eclipse.emf.common.notify.Notification)
     */
    protected void handleModelChanged(Notification msg)
    {
        if (msg.getNotifier() instanceof ConnectionPointReference)
        {
            switch (msg.getFeatureID(ConnectionPointReference.class))
            {
                case UMLPackage.CONNECTION_POINT_REFERENCE__ENTRY:
                case UMLPackage.CONNECTION_POINT_REFERENCE__EXIT:
                    ((ConnectionPointReferenceFigure) getPortFigure()).setEntryPoint(!((ConnectionPointReference) getEObject()).getEntries().isEmpty());
                    ((ConnectionPointReferenceFigure) getPortFigure()).setExitPoint(!((ConnectionPointReference) getEObject()).getExits().isEmpty());
                    refreshVisuals();
                    break;
                default:
                    break;
            }
        }

        super.handleModelChanged(msg);
    }

}