/*******************************************************************************
 * Copyright (c) 2006 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package org.topcased.modeler.uml.statemachinediagram.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.uml2.uml.StateMachine;
import org.topcased.modeler.commands.CreateGraphNodeCommand;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.DiagramEditPart;
import org.topcased.modeler.editor.ModelerGraphicalViewer;
import org.topcased.modeler.uml.statemachinediagram.figures.STMDiagramFigure;
import org.topcased.modeler.uml.statemachinediagram.policies.STMDiagramLayoutEditPolicy;

/**
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class STMDiagramEditPart extends DiagramEditPart
{

    /**
     * The Constructor <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param model the root model element
     * @generated
     */
    public STMDiagramEditPart(Diagram model)
    {
        super(model);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#getLayoutEditPolicy()
     * @generated
     */
    protected EditPolicy getLayoutEditPolicy()
    {
        return new STMDiagramLayoutEditPolicy();
    }

    /**
     * @see org.topcased.modeler.edit.DiagramEditPart#createFigure()
     */
    @Override
    protected IFigure createFigure()
    {
        // Initialize the diagram with an empty Region if needed. This is mainly use for the creation of a STM diagram
        // when a Package is selected : the STM is created as well as the Region in the model, but the Region is not
        // graphically present. A further command would consist in synchronizing the Regions of a STM.
        if (((Diagram) getModel()).getContained().isEmpty() && !((StateMachine) getEObject()).getRegions().isEmpty())
        {
            GraphElement gElt = ((ModelerGraphicalViewer) getViewer()).getModelerEditor().getActiveConfiguration().getCreationUtils().createGraphElement(
                    ((StateMachine) getEObject()).getRegions().get(0));
            CreateGraphNodeCommand command = new CreateGraphNodeCommand(getViewer().getEditDomain(), (GraphNode) gElt, (GraphNode) getModel(), null, null, null, false);
            if ((command != null) && command.canExecute())
            {
                command.execute();
            }
        }

        return super.createFigure();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#createBodyFigure()
     * @generated
     */
    protected IFigure createBodyFigure()
    {
        return new STMDiagramFigure();
    }

    /**
     * The label is the name of the diagram
     * 
     * @see org.topcased.modeler.edit.DiagramEditPart#getHeaderDiagram()
     */
    protected String getHeaderDiagram()
    {
        return ((StateMachine) getEObject()).getName();
    }

}