package org.topcased.modeler.uml.statemachinediagram.internal.properties.sections;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.ui.celleditor.FeatureEditorDialog;
import org.eclipse.jface.viewers.IBaseLabelProvider;
import org.eclipse.swt.widgets.Display;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.edit.providers.UMLItemProviderAdapterFactory;
import org.topcased.tabbedproperties.AbstractTabbedPropertySheetPage;
import org.topcased.tabbedproperties.providers.TabbedPropertiesLabelProvider;
import org.topcased.tabbedproperties.sections.AbstractListPropertySection;

/**
 * TODO : Comment this class
 */
public class ConnectionPointsSection extends AbstractListPropertySection
{

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#getLabelProvider()
     */
    protected IBaseLabelProvider getLabelProvider()
    {
        return new TabbedPropertiesLabelProvider(new UMLItemProviderAdapterFactory());
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#getListValues()
     */
    protected Object getListValues()
    {
        return ((State) getEObject()).getConnectionPoints();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     */
    protected EStructuralFeature getFeature()
    {
        return UMLPackage.eINSTANCE.getState_ConnectionPoint();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Entry Points";
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#addElement()
     */
    protected void addElement()
    {
        final Collection choiceOfValues = ItemPropertyDescriptor.getReachableObjectsOfType(getEObject(), UMLPackage.eINSTANCE.getPseudostate());
        final FeatureEditorDialog dialog = new FeatureEditorDialog(Display.getDefault().getActiveShell(), new TabbedPropertiesLabelProvider(new ComposedAdapterFactory(
                AbstractTabbedPropertySheetPage.getPrincipalAdapterFactories())), getEObject(), getFeature(), "Choose the objects to add", new ArrayList(choiceOfValues));
        dialog.open();
        List newElements = dialog.getResult();
        List l = (List) getEObject().eGet(getFeature());
        List result = new ArrayList();
        for (Iterator iter = newElements.iterator(); iter.hasNext();)
        {
            Object o = iter.next();
            if (!l.contains(o))
            {
                result.add(o);
            }
        }

        CompoundCommand ccommand = new CompoundCommand();
        for (Iterator iter = result.iterator(); iter.hasNext();)
        {
            EObject element = (EObject) iter.next();
            ccommand.append(AddCommand.create(getEditingDomain(), getEObject(), getFeature(), element));
        }
        getEditingDomain().getCommandStack().execute(ccommand);
    }
}
