package org.topcased.modeler.uml.statemachinediagram.internal.properties.sections;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.command.CompoundCommand;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.ui.celleditor.FeatureEditorDialog;
import org.eclipse.jface.viewers.IBaseLabelProvider;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.uml2.uml.ConnectionPointReference;
import org.eclipse.uml2.uml.Pseudostate;
import org.eclipse.uml2.uml.PseudostateKind;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.edit.providers.UMLItemProviderAdapterFactory;
import org.topcased.tabbedproperties.providers.TabbedPropertiesLabelProvider;
import org.topcased.tabbedproperties.sections.AbstractListPropertySection;

/**
 * TODO : Comment this class
 */
public class ExitPointsSection extends AbstractListPropertySection
{

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#getLabelProvider()
     */
    protected IBaseLabelProvider getLabelProvider()
    {
        return new TabbedPropertiesLabelProvider(new UMLItemProviderAdapterFactory());
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#getListValues()
     */
    protected Object getListValues()
    {
        return ((ConnectionPointReference) getEObject()).getExits();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     */
    protected EStructuralFeature getFeature()
    {
        return UMLPackage.eINSTANCE.getConnectionPointReference_Exit();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Exit Points";
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractListPropertySection#addElement()
     */
    protected void addElement()
    {
        Collection choiceOfValues = ItemPropertyDescriptor.getReachableObjectsOfType(getEObject(), UMLPackage.eINSTANCE.getPseudostate());
        choiceOfValues = purgeExitPoints(choiceOfValues);
        FeatureEditorDialog dialog = new FeatureEditorDialog(Display.getDefault().getActiveShell(), (ILabelProvider) getLabelProvider(), getEObject(), getFeature(), "Choose the objects to add",
                new ArrayList(choiceOfValues));
        dialog.open();
        if (dialog.getReturnCode() == Window.OK)
        {
            List newElements = dialog.getResult();
            List l = (List) getEObject().eGet(getFeature());
            List result = new ArrayList();
            for (Iterator iter = newElements.iterator(); iter.hasNext();)
            {
                Object o = iter.next();
                if (!l.contains(o))
                {
                    result.add(o);
                }
            }

            CompoundCommand ccommand = new CompoundCommand();
            for (Iterator iter = result.iterator(); iter.hasNext();)
            {
                EObject element = (EObject) iter.next();
                ccommand.append(AddCommand.create(getEditingDomain(), getEObject(), getFeature(), element));
            }
            getEditingDomain().getCommandStack().execute(ccommand);
        }
    }

    private Collection purgeExitPoints(Collection c)
    {
        // The second test will be done later
        Collection result = new ArrayList();
        for (Iterator iter = c.iterator(); iter.hasNext();)
        {
            Pseudostate element = (Pseudostate) iter.next();
            if (element.getKind().equals(PseudostateKind.EXIT_POINT_LITERAL)
            /*
             * && ((ConnectionPointReference) getEObject()).getState().getSubmachine().equals(element.getStateMachine())
             */)
            {
                result.add(element);
            }
        }
        return result;
    }
}
