/*******************************************************************************
 * Copyright (c) 2006 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jacques Lescot (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.modeler.uml.statemachinediagram.internal.properties.sections.filters;

import org.eclipse.jface.viewers.IFilter;
import org.topcased.modeler.uml.statemachinediagram.edit.PseudostateForkEditPart;
import org.topcased.modeler.uml.statemachinediagram.edit.PseudostateJoinEditPart;

/**
 * A Filter that check if the selected Element is a CompositeStateEditPart<br>
 * 
 * Creation 25 oct. 06
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public class ForkAndJoinFilter implements IFilter
{
    /**
     * @see org.eclipse.jface.viewers.IFilter#select(java.lang.Object)
     */
    public boolean select(Object toTest)
    {
        return toTest instanceof PseudostateForkEditPart || toTest instanceof PseudostateJoinEditPart;
    }

}
