package org.topcased.modeler.uml.statemachinediagram.internal.properties.sections.filters;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.viewers.IFilter;
import org.eclipse.uml2.uml.FinalState;
import org.eclipse.uml2.uml.State;
import org.topcased.tabbedproperties.utils.ObjectAdapter;

/**
 * A Filter used to check whether the selected object is adaptable to an EObject. This model object should then be an
 * instanceof a State element, but not a FinalState element.
 * 
 * Creation 19 déc. 06
 * 
 * @author <a href="mailto:jacques.lescot@anyware-tech.com">Jacques LESCOT</a>
 */
public class StateFilter implements IFilter
{
    /**
     * @see org.eclipse.jface.viewers.IFilter#select(Object)
     */
    public boolean select(Object toTest)
    {
        EObject adaptedObject = ObjectAdapter.adaptObject(toTest);
        return adaptedObject instanceof State && !(adaptedObject instanceof FinalState);
    }

}
