/**
 * <copyright>
 * </copyright>
 *
 * $Id: AbstractState.java,v 1.13 2007-04-12 08:33:33 jako Exp $
 */
package org.topcased.sam;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Abstract State</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <!-- begin-model-doc --> Abstraction of the states that can be contained by an Automaton. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.topcased.sam.AbstractState#getParentState <em>Parent State</em>}</li>
 * <li>{@link org.topcased.sam.AbstractState#getParentAutomaton <em>Parent Automaton</em>}</li>
 * <li>{@link org.topcased.sam.AbstractState#getOutlink <em>Outlink</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.topcased.sam.SAMPackage#getAbstractState()
 * @model abstract="true"
 * @generated
 */
public interface AbstractState extends NamedItem
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>Parent State</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.MacroState#getComposition <em>Composition</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent State</em>' container reference isn't clear, there really should be more of
     * a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent State</em>' container reference.
     * @see #setParentState(MacroState)
     * @see org.topcased.sam.SAMPackage#getAbstractState_ParentState()
     * @see org.topcased.sam.MacroState#getComposition
     * @model opposite="composition" resolveProxies="false"
     * @generated
     */
    MacroState getParentState();

    /**
     * Sets the value of the '{@link org.topcased.sam.AbstractState#getParentState <em>Parent State</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent State</em>' container reference.
     * @see #getParentState()
     * @generated
     */
    void setParentState(MacroState value);

    /**
     * Returns the value of the '<em><b>Parent Automaton</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.Automaton#getListStates <em>List States</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent Automaton</em>' container reference isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent Automaton</em>' container reference.
     * @see #setParentAutomaton(Automaton)
     * @see org.topcased.sam.SAMPackage#getAbstractState_ParentAutomaton()
     * @see org.topcased.sam.Automaton#getListStates
     * @model opposite="listStates" resolveProxies="false"
     * @generated
     */
    Automaton getParentAutomaton();

    /**
     * Sets the value of the '{@link org.topcased.sam.AbstractState#getParentAutomaton <em>Parent Automaton</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent Automaton</em>' container reference.
     * @see #getParentAutomaton()
     * @generated
     */
    void setParentAutomaton(Automaton value);

    /**
     * Returns the value of the '<em><b>Outlink</b></em>' reference list.
     * The list contents are of type {@link org.topcased.sam.Transition}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.Transition#getSource <em>Source</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Outlink</em>' reference list isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Outlink</em>' reference list.
     * @see org.topcased.sam.SAMPackage#getAbstractState_Outlink()
     * @see org.topcased.sam.Transition#getSource
     * @model type="org.topcased.sam.Transition" opposite="source" resolveProxies="false"
     * @generated
     */
    EList<Transition> getOutlink();

} // AbstractState
