/**
 * <copyright>
 * </copyright>
 *
 * $Id: Automaton.java,v 1.12 2007-04-12 08:33:30 jako Exp $
 */
package org.topcased.sam;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Automaton</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represents an automaton component, consisting of a set of states linked by transitions.
 * An automaton cannot produce data, but it can output its current state, so only one OutDataPort is possible.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.topcased.sam.Automaton#getListTransitions <em>List Transitions</em>}</li>
 *   <li>{@link org.topcased.sam.Automaton#getListPorts <em>List Ports</em>}</li>
 *   <li>{@link org.topcased.sam.Automaton#getListStates <em>List States</em>}</li>
 *   <li>{@link org.topcased.sam.Automaton#getIsInstanceOf <em>Is Instance Of</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.topcased.sam.SAMPackage#getAutomaton()
 * @model
 * @generated
 */
public interface Automaton extends ModelContent
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>List Transitions</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.Transition}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.Transition#getParentAutomaton <em>Parent Automaton</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>List Transitions</em>' containment reference list isn't clear, there really should
     * be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>List Transitions</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getAutomaton_ListTransitions()
     * @see org.topcased.sam.Transition#getParentAutomaton
     * @model type="org.topcased.sam.Transition" opposite="parentAutomaton" containment="true"
     * @generated
     */
    EList<Transition> getListTransitions();

    /**
     * Returns the value of the '<em><b>List Ports</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.Port}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.Port#getParentAutomaton <em>Parent Automaton</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>List Ports</em>' containment reference list isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>List Ports</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getAutomaton_ListPorts()
     * @see org.topcased.sam.Port#getParentAutomaton
     * @model type="org.topcased.sam.Port" opposite="parentAutomaton" containment="true"
     * @generated
     */
    EList<Port> getListPorts();

    /**
     * Returns the value of the '<em><b>List States</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.AbstractState}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.AbstractState#getParentAutomaton <em>Parent Automaton</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>List States</em>' containment reference list isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>List States</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getAutomaton_ListStates()
     * @see org.topcased.sam.AbstractState#getParentAutomaton
     * @model type="org.topcased.sam.AbstractState" opposite="parentAutomaton" containment="true" required="true"
     * @generated
     */
    EList<AbstractState> getListStates();

    /**
     * Returns the value of the '<em><b>Is Instance Of</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Is Instance Of</em>' reference isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Is Instance Of</em>' reference.
     * @see #setIsInstanceOf(Automaton)
     * @see org.topcased.sam.SAMPackage#getAutomaton_IsInstanceOf()
     * @model
     * @generated
     */
    Automaton getIsInstanceOf();

    /**
     * Sets the value of the '{@link org.topcased.sam.Automaton#getIsInstanceOf <em>Is Instance Of</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Is Instance Of</em>' reference.
     * @see #getIsInstanceOf()
     * @generated
     */
    void setIsInstanceOf(Automaton value);

} // Automaton
