/**
 * <copyright>
 * </copyright>
 *
 * $Id: DataFlow.java,v 1.13 2007-04-12 08:33:35 jako Exp $
 */
package org.topcased.sam;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Data Flow</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A data flow is a flow carrying data between systems or to an automaton.
 * It cannot come from an autumaton.
 * the Data can be stored, or retrieve, into, or from, a data store, and composed into one or decomposed from one data flow.
 * This class represent the link used to give data between 2 components.
 * Note : a DataFlow is scalar typed. See ControlFlow.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.topcased.sam.DataFlow#getType <em>Type</em>}</li>
 *   <li>{@link org.topcased.sam.DataFlow#getSource <em>Source</em>}</li>
 *   <li>{@link org.topcased.sam.DataFlow#getDest <em>Dest</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.topcased.sam.SAMPackage#getDataFlow()
 * @model
 * @generated
 */
public interface DataFlow extends Flow
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>Type</b></em>' attribute.
     * The literals are from the enumeration {@link org.topcased.sam.DataType}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Type</em>' attribute isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Type</em>' attribute.
     * @see org.topcased.sam.DataType
     * @see #setType(DataType)
     * @see org.topcased.sam.SAMPackage#getDataFlow_Type()
     * @model
     * @generated
     */
    DataType getType();

    /**
     * Sets the value of the '{@link org.topcased.sam.DataFlow#getType <em>Type</em>}' attribute.
     * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Type</em>' attribute.
     * @see org.topcased.sam.DataType
     * @see #getType()
     * @generated
     */
    void setType(DataType value);

    /**
     * Returns the value of the '<em><b>Source</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Source</em>' reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Source</em>' reference.
     * @see #setSource(DataPort)
     * @see org.topcased.sam.SAMPackage#getDataFlow_Source()
     * @model resolveProxies="false" required="true"
     * @generated
     */
    DataPort getSource();

    /**
     * Sets the value of the '{@link org.topcased.sam.DataFlow#getSource <em>Source</em>}' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Source</em>' reference.
     * @see #getSource()
     * @generated
     */
    void setSource(DataPort value);

    /**
     * Returns the value of the '<em><b>Dest</b></em>' reference list.
     * The list contents are of type {@link org.topcased.sam.DataPort}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Dest</em>' reference list isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Dest</em>' reference list.
     * @see org.topcased.sam.SAMPackage#getDataFlow_Dest()
     * @model type="org.topcased.sam.DataPort" resolveProxies="false" required="true"
     * @generated
     */
    EList<DataPort> getDest();

} // DataFlow
