/**
 * <copyright>
 * </copyright>
 *
 * $Id: DataStore.java,v 1.13 2007-04-12 08:33:32 jako Exp $
 */
package org.topcased.sam;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Data Store</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A data store is a component used to store data that can be retrieved later.
 * This class represent a general data store, not precising where the entry point is.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.topcased.sam.DataStore#getParentSystem <em>Parent System</em>}</li>
 *   <li>{@link org.topcased.sam.DataStore#getIn <em>In</em>}</li>
 *   <li>{@link org.topcased.sam.DataStore#getOut <em>Out</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.topcased.sam.SAMPackage#getDataStore()
 * @model
 * @generated
 */
public interface DataStore extends NamedItem
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>Parent System</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.System#getListStores <em>List Stores</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent System</em>' container reference isn't clear, there really should be more
     * of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent System</em>' container reference.
     * @see #setParentSystem(org.topcased.sam.System)
     * @see org.topcased.sam.SAMPackage#getDataStore_ParentSystem()
     * @see org.topcased.sam.System#getListStores
     * @model opposite="listStores" resolveProxies="false" required="true"
     * @generated
     */
    org.topcased.sam.System getParentSystem();

    /**
     * Sets the value of the '{@link org.topcased.sam.DataStore#getParentSystem <em>Parent System</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent System</em>' container reference.
     * @see #getParentSystem()
     * @generated
     */
    void setParentSystem(org.topcased.sam.System value);

    /**
     * Returns the value of the '<em><b>In</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.InDataPort#getParentDataStore <em>Parent Data Store</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>In</em>' containment reference isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>In</em>' containment reference.
     * @see #setIn(InDataPort)
     * @see org.topcased.sam.SAMPackage#getDataStore_In()
     * @see org.topcased.sam.InDataPort#getParentDataStore
     * @model opposite="parentDataStore" containment="true" required="true"
     * @generated
     */
    InDataPort getIn();

    /**
     * Sets the value of the '{@link org.topcased.sam.DataStore#getIn <em>In</em>}' containment reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>In</em>' containment reference.
     * @see #getIn()
     * @generated
     */
    void setIn(InDataPort value);

    /**
     * Returns the value of the '<em><b>Out</b></em>' containment reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.OutDataPort#getParentDataStore <em>Parent Data Store</em>}'.
     * <!-- begin-user-doc
     * -->
     * <p>
     * If the meaning of the '<em>Out</em>' containment reference isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Out</em>' containment reference.
     * @see #setOut(OutDataPort)
     * @see org.topcased.sam.SAMPackage#getDataStore_Out()
     * @see org.topcased.sam.OutDataPort#getParentDataStore
     * @model opposite="parentDataStore" containment="true" required="true"
     * @generated
     */
    OutDataPort getOut();

    /**
     * Sets the value of the '{@link org.topcased.sam.DataStore#getOut <em>Out</em>}' containment reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Out</em>' containment reference.
     * @see #getOut()
     * @generated
     */
    void setOut(OutDataPort value);

} // DataStore
