/**
 * <copyright>
 * </copyright>
 *
 * $Id: DataType.java,v 1.9 2007-04-12 08:33:29 jako Exp $
 */
package org.topcased.sam;

import static org.topcased.sam.DataType.BOOLEAN;
import static org.topcased.sam.DataType.DOUBLE;
import static org.topcased.sam.DataType.FLOAT;
import static org.topcased.sam.DataType.INTEGER;
import static org.topcased.sam.DataType.REAL;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em><b>Data Type</b></em>', and
 * utility methods for working with them. <!-- end-user-doc -->
 * @see org.topcased.sam.SAMPackage#getDataType()
 * @model
 * @generated
 */
public enum DataType implements Enumerator {
    /**
     * The '<em><b>Integer</b></em>' literal object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #INTEGER
     * @generated
     * @ordered
     */
    INTEGER_LITERAL(0, "Integer", "Integer"),
    /**
     * The '<em><b>Real</b></em>' literal object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #REAL
     * @generated
     * @ordered
     */
    REAL_LITERAL(1, "Real", "Real"),
    /**
     * The '<em><b>Float</b></em>' literal object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #FLOAT
     * @generated
     * @ordered
     */
    FLOAT_LITERAL(2, "Float", "Float"),
    /**
     * The '<em><b>Double</b></em>' literal object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #DOUBLE
     * @generated
     * @ordered
     */
    DOUBLE_LITERAL(3, "Double", "Double"),
    /**
     * The '<em><b>Boolean</b></em>' literal object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #BOOLEAN
     * @generated
     * @ordered
     */
    BOOLEAN_LITERAL(4, "Boolean", "Boolean");
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final String copyright = "";

    /**
     * The '<em><b>Integer</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Integer</b></em>' literal object isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #INTEGER_LITERAL
     * @model name="Integer"
     * @generated
     * @ordered
     */
    public static final int INTEGER = 0;

    /**
     * The '<em><b>Real</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Real</b></em>' literal object isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #REAL_LITERAL
     * @model name="Real"
     * @generated
     * @ordered
     */
    public static final int REAL = 1;

    /**
     * The '<em><b>Float</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Float</b></em>' literal object isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #FLOAT_LITERAL
     * @model name="Float"
     * @generated
     * @ordered
     */
    public static final int FLOAT = 2;

    /**
     * The '<em><b>Double</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Double</b></em>' literal object isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #DOUBLE_LITERAL
     * @model name="Double"
     * @generated
     * @ordered
     */
    public static final int DOUBLE = 3;

    /**
     * The '<em><b>Boolean</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Boolean</b></em>' literal object isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #BOOLEAN_LITERAL
     * @model name="Boolean"
     * @generated
     * @ordered
     */
    public static final int BOOLEAN = 4;

    /**
     * An array of all the '<em><b>Data Type</b></em>' enumerators.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private static final DataType[] VALUES_ARRAY = new DataType[] {INTEGER_LITERAL, REAL_LITERAL, FLOAT_LITERAL, DOUBLE_LITERAL, BOOLEAN_LITERAL,};

    /**
     * A public read-only list of all the '<em><b>Data Type</b></em>' enumerators.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public static final List<DataType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
     * Returns the '<em><b>Data Type</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static DataType get(String literal)
    {
        for (int i = 0; i < VALUES_ARRAY.length; ++i)
        {
            DataType result = VALUES_ARRAY[i];
            if (result.toString().equals(literal))
            {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Data Type</b></em>' literal with the specified name.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public static DataType getByName(String name)
    {
        for (int i = 0; i < VALUES_ARRAY.length; ++i)
        {
            DataType result = VALUES_ARRAY[i];
            if (result.getName().equals(name))
            {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Data Type</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static DataType get(int value)
    {
        switch (value)
        {
            case INTEGER:
                return INTEGER_LITERAL;
            case REAL:
                return REAL_LITERAL;
            case FLOAT:
                return FLOAT_LITERAL;
            case DOUBLE:
                return DOUBLE_LITERAL;
            case BOOLEAN:
                return BOOLEAN_LITERAL;
        }
        return null;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final int value;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final String name;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final String literal;

    /**
     * Only this class can construct instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private DataType(int value, String name, String literal)
    {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public int getValue()
    {
        return value;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String getName()
    {
        return name;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String getLiteral()
    {
        return literal;
    }

    /**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    @Override
    public String toString()
    {
        return literal;
    }
}
