/**
 * <copyright>
 * </copyright>
 *
 * $Id: InDataPort.java,v 1.13 2007-04-12 08:33:36 jako Exp $
 */
package org.topcased.sam;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>In Data Port</b></em>'. <!-- end-user-doc
 * -->
 * 
 * <!-- begin-model-doc --> This class represents a kind of port. It allows a data flow to bring some data into the
 * component containing this port. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.topcased.sam.InDataPort#getParentSync <em>Parent Sync</em>}</li>
 * <li>{@link org.topcased.sam.InDataPort#getParentDataStore <em>Parent Data Store</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.topcased.sam.SAMPackage#getInDataPort()
 * @model
 * @generated
 */
public interface InDataPort extends DataPort, InputPort
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>Parent Sync</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.SynchronisationGate#getIn <em>In</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent Sync</em>' container reference isn't clear, there really should be more of
     * a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent Sync</em>' container reference.
     * @see #setParentSync(SynchronisationGate)
     * @see org.topcased.sam.SAMPackage#getInDataPort_ParentSync()
     * @see org.topcased.sam.SynchronisationGate#getIn
     * @model opposite="in" resolveProxies="false"
     * @generated
     */
    SynchronisationGate getParentSync();

    /**
     * Sets the value of the '{@link org.topcased.sam.InDataPort#getParentSync <em>Parent Sync</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent Sync</em>' container reference.
     * @see #getParentSync()
     * @generated
     */
    void setParentSync(SynchronisationGate value);

    /**
     * Returns the value of the '<em><b>Parent Data Store</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.DataStore#getIn <em>In</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent Data Store</em>' container reference isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent Data Store</em>' container reference.
     * @see #setParentDataStore(DataStore)
     * @see org.topcased.sam.SAMPackage#getInDataPort_ParentDataStore()
     * @see org.topcased.sam.DataStore#getIn
     * @model opposite="in" resolveProxies="false"
     * @generated
     */
    DataStore getParentDataStore();

    /**
     * Sets the value of the '{@link org.topcased.sam.InDataPort#getParentDataStore <em>Parent Data Store</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent Data Store</em>' container reference.
     * @see #getParentDataStore()
     * @generated
     */
    void setParentDataStore(DataStore value);

} // InDataPort
