/**
 * <copyright>
 * </copyright>
 *
 * $Id: Port.java,v 1.14 2007-04-12 08:33:36 jako Exp $
 */
package org.topcased.sam;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Port</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represents the generalization of the different kind of ports.
 * A port allows the input or output of information in or from components.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.topcased.sam.Port#getParentSystem <em>Parent System</em>}</li>
 *   <li>{@link org.topcased.sam.Port#getOutlink <em>Outlink</em>}</li>
 *   <li>{@link org.topcased.sam.Port#getInlink <em>Inlink</em>}</li>
 *   <li>{@link org.topcased.sam.Port#getParentAutomaton <em>Parent Automaton</em>}</li>
 *   <li>{@link org.topcased.sam.Port#getParentMultiPort <em>Parent Multi Port</em>}</li>
 *   <li>{@link org.topcased.sam.Port#getIsInstanceOf <em>Is Instance Of</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.topcased.sam.SAMPackage#getPort()
 * @model abstract="true"
 * @generated
 */
public interface Port extends NamedItem
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>Parent System</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.System#getListPorts <em>List Ports</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent System</em>' container reference isn't clear, there really should be more
     * of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent System</em>' container reference.
     * @see #setParentSystem(org.topcased.sam.System)
     * @see org.topcased.sam.SAMPackage#getPort_ParentSystem()
     * @see org.topcased.sam.System#getListPorts
     * @model opposite="listPorts" resolveProxies="false"
     * @generated
     */
    org.topcased.sam.System getParentSystem();

    /**
     * Sets the value of the '{@link org.topcased.sam.Port#getParentSystem <em>Parent System</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent System</em>' container reference.
     * @see #getParentSystem()
     * @generated
     */
    void setParentSystem(org.topcased.sam.System value);

    /**
     * Returns the value of the '<em><b>Outlink</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Outlink</em>' reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Outlink</em>' reference.
     * @see #setOutlink(Flow)
     * @see org.topcased.sam.SAMPackage#getPort_Outlink()
     * @model
     * @generated
     */
    Flow getOutlink();

    /**
     * Sets the value of the '{@link org.topcased.sam.Port#getOutlink <em>Outlink</em>}' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Outlink</em>' reference.
     * @see #getOutlink()
     * @generated
     */
    void setOutlink(Flow value);

    /**
     * Returns the value of the '<em><b>Inlink</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Inlink</em>' reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Inlink</em>' reference.
     * @see #setInlink(Flow)
     * @see org.topcased.sam.SAMPackage#getPort_Inlink()
     * @model
     * @generated
     */
    Flow getInlink();

    /**
     * Sets the value of the '{@link org.topcased.sam.Port#getInlink <em>Inlink</em>}' reference.
     * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Inlink</em>' reference.
     * @see #getInlink()
     * @generated
     */
    void setInlink(Flow value);

    /**
     * Returns the value of the '<em><b>Parent Automaton</b></em>' container reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.Automaton#getListPorts <em>List Ports</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent Automaton</em>' container reference isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent Automaton</em>' container reference.
     * @see #setParentAutomaton(Automaton)
     * @see org.topcased.sam.SAMPackage#getPort_ParentAutomaton()
     * @see org.topcased.sam.Automaton#getListPorts
     * @model opposite="listPorts" resolveProxies="false"
     * @generated
     */
    Automaton getParentAutomaton();

    /**
     * Sets the value of the '{@link org.topcased.sam.Port#getParentAutomaton <em>Parent Automaton</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent Automaton</em>' container reference.
     * @see #getParentAutomaton()
     * @generated
     */
    void setParentAutomaton(Automaton value);

    /**
     * Returns the value of the '<em><b>Parent Multi Port</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent Multi Port</em>' reference isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent Multi Port</em>' reference.
     * @see #setParentMultiPort(MultiPort)
     * @see org.topcased.sam.SAMPackage#getPort_ParentMultiPort()
     * @model resolveProxies="false"
     * @generated
     */
    MultiPort getParentMultiPort();

    /**
     * Sets the value of the '{@link org.topcased.sam.Port#getParentMultiPort <em>Parent Multi Port</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent Multi Port</em>' reference.
     * @see #getParentMultiPort()
     * @generated
     */
    void setParentMultiPort(MultiPort value);

    /**
     * Returns the value of the '<em><b>Is Instance Of</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Is Instance Of</em>' reference isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Is Instance Of</em>' reference.
     * @see #setIsInstanceOf(Port)
     * @see org.topcased.sam.SAMPackage#getPort_IsInstanceOf()
     * @model
     * @generated
     */
    Port getIsInstanceOf();

    /**
     * Sets the value of the '{@link org.topcased.sam.Port#getIsInstanceOf <em>Is Instance Of</em>}' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Is Instance Of</em>' reference.
     * @see #getIsInstanceOf()
     * @generated
     */
    void setIsInstanceOf(Port value);

} // Port
