/**
 * <copyright>
 * </copyright>
 *
 * $Id: SynchronisationGate.java,v 1.13 2007-04-12 08:33:31 jako Exp $
 */
package org.topcased.sam;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Synchronisation Gate</b></em>'. <!--
 * end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A flow synchronisation, represented with a bar, is a way to group or split data with several data flow.
 * One flow contain all the data, and the other flows a part of this data only.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.topcased.sam.SynchronisationGate#getParentSystem <em>Parent System</em>}</li>
 *   <li>{@link org.topcased.sam.SynchronisationGate#getOut <em>Out</em>}</li>
 *   <li>{@link org.topcased.sam.SynchronisationGate#getIn <em>In</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.topcased.sam.SAMPackage#getSynchronisationGate()
 * @model abstract="true"
 * @generated
 */
public interface SynchronisationGate extends IdentifiedItem
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>Parent System</b></em>' container reference. It is bidirectional and its
     * opposite is '{@link org.topcased.sam.System#getListSynchronisation <em>List Synchronisation</em>}'. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent System</em>' container reference isn't clear, there really should be more
     * of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Parent System</em>' container reference.
     * @see #setParentSystem(org.topcased.sam.System)
     * @see org.topcased.sam.SAMPackage#getSynchronisationGate_ParentSystem()
     * @see org.topcased.sam.System#getListSynchronisation
     * @model opposite="listSynchronisation" resolveProxies="false" required="true"
     * @generated
     */
    org.topcased.sam.System getParentSystem();

    /**
     * Sets the value of the '{@link org.topcased.sam.SynchronisationGate#getParentSystem <em>Parent System</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent System</em>' container reference.
     * @see #getParentSystem()
     * @generated
     */
    void setParentSystem(org.topcased.sam.System value);

    /**
     * Returns the value of the '<em><b>Out</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.OutDataPort}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.OutDataPort#getParentSync <em>Parent Sync</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Out</em>' containment reference list isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Out</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getSynchronisationGate_Out()
     * @see org.topcased.sam.OutDataPort#getParentSync
     * @model type="org.topcased.sam.OutDataPort" opposite="parentSync" containment="true" required="true"
     * @generated
     */
    EList<OutDataPort> getOut();

    /**
     * Returns the value of the '<em><b>In</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.InDataPort}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.InDataPort#getParentSync <em>Parent Sync</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>In</em>' containment reference list isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>In</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getSynchronisationGate_In()
     * @see org.topcased.sam.InDataPort#getParentSync
     * @model type="org.topcased.sam.InDataPort" opposite="parentSync" containment="true" required="true"
     * @generated
     */
    EList<InDataPort> getIn();

} // SynchronisationGate
