/**
 * <copyright>
 * </copyright>
 *
 * $Id: System.java,v 1.13 2007-04-12 08:33:33 jako Exp $
 */
package org.topcased.sam;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>System</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represent either the system to modelize and the subsystems it is composed of.
 * 
 * A simple function will represented as a system composed of no component.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.topcased.sam.System#getListPorts <em>List Ports</em>}</li>
 *   <li>{@link org.topcased.sam.System#getListStores <em>List Stores</em>}</li>
 *   <li>{@link org.topcased.sam.System#getListSynchronisation <em>List Synchronisation</em>}</li>
 *   <li>{@link org.topcased.sam.System#getListFlows <em>List Flows</em>}</li>
 *   <li>{@link org.topcased.sam.System#getListElements <em>List Elements</em>}</li>
 *   <li>{@link org.topcased.sam.System#getIsInstanceOf <em>Is Instance Of</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.topcased.sam.SAMPackage#getSystem()
 * @model
 * @generated
 */
public interface System extends ModelContent
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>List Ports</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.Port}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.Port#getParentSystem <em>Parent System</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>List Ports</em>' containment reference list isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>List Ports</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getSystem_ListPorts()
     * @see org.topcased.sam.Port#getParentSystem
     * @model type="org.topcased.sam.Port" opposite="parentSystem" containment="true"
     * @generated
     */
    EList<Port> getListPorts();

    /**
     * Returns the value of the '<em><b>List Stores</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.DataStore}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.DataStore#getParentSystem <em>Parent System</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>List Stores</em>' containment reference list isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>List Stores</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getSystem_ListStores()
     * @see org.topcased.sam.DataStore#getParentSystem
     * @model type="org.topcased.sam.DataStore" opposite="parentSystem" containment="true"
     * @generated
     */
    EList<DataStore> getListStores();

    /**
     * Returns the value of the '<em><b>List Synchronisation</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.SynchronisationGate}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.SynchronisationGate#getParentSystem <em>Parent System</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>List Synchronisation</em>' containment reference list isn't clear, there really
     * should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>List Synchronisation</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getSystem_ListSynchronisation()
     * @see org.topcased.sam.SynchronisationGate#getParentSystem
     * @model type="org.topcased.sam.SynchronisationGate" opposite="parentSystem" containment="true"
     * @generated
     */
    EList<SynchronisationGate> getListSynchronisation();

    /**
     * Returns the value of the '<em><b>List Flows</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.Flow}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.Flow#getParentSystem <em>Parent System</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>List Flows</em>' containment reference list isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>List Flows</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getSystem_ListFlows()
     * @see org.topcased.sam.Flow#getParentSystem
     * @model type="org.topcased.sam.Flow" opposite="parentSystem" containment="true"
     * @generated
     */
    EList<Flow> getListFlows();

    /**
     * Returns the value of the '<em><b>List Elements</b></em>' containment reference list.
     * The list contents are of type {@link org.topcased.sam.ModelContent}.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.ModelContent#getParentSystem <em>Parent System</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>List Elements</em>' containment reference list isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>List Elements</em>' containment reference list.
     * @see org.topcased.sam.SAMPackage#getSystem_ListElements()
     * @see org.topcased.sam.ModelContent#getParentSystem
     * @model type="org.topcased.sam.ModelContent" opposite="parentSystem" containment="true" resolveProxies="true"
     * @generated
     */
    EList<ModelContent> getListElements();

    /**
     * Returns the value of the '<em><b>Is Instance Of</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Is Instance Of</em>' reference isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Is Instance Of</em>' reference.
     * @see #setIsInstanceOf(System)
     * @see org.topcased.sam.SAMPackage#getSystem_IsInstanceOf()
     * @model
     * @generated
     */
    System getIsInstanceOf();

    /**
     * Sets the value of the '{@link org.topcased.sam.System#getIsInstanceOf <em>Is Instance Of</em>}' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Is Instance Of</em>' reference.
     * @see #getIsInstanceOf()
     * @generated
     */
    void setIsInstanceOf(System value);

} // System
