/**
 * <copyright>
 * </copyright>
 *
 * $Id: Transition.java,v 1.13 2007-04-12 08:33:36 jako Exp $
 */
package org.topcased.sam;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Transition</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A transition represents the link between 2 states of an automaton.
 * 
 * The condition attribute represents the event/condition string.
 * 
 * The priority is used only is there are multiple link outgoing from one state.
 * 
 * A transition outgoing from a macro-state has a greater priority than its internal transitions. 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.topcased.sam.Transition#getCondition <em>Condition</em>}</li>
 *   <li>{@link org.topcased.sam.Transition#getEmission <em>Emission</em>}</li>
 *   <li>{@link org.topcased.sam.Transition#getPriority <em>Priority</em>}</li>
 *   <li>{@link org.topcased.sam.Transition#getDest <em>Dest</em>}</li>
 *   <li>{@link org.topcased.sam.Transition#getParentAutomaton <em>Parent Automaton</em>}</li>
 *   <li>{@link org.topcased.sam.Transition#getSource <em>Source</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.topcased.sam.SAMPackage#getTransition()
 * @model
 * @generated
 */
public interface Transition extends IdentifiedItem
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    String copyright = "";

    /**
     * Returns the value of the '<em><b>Condition</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Condition</em>' attribute isn't clear, there really should be more of a
     * description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Condition</em>' attribute.
     * @see #setCondition(String)
     * @see org.topcased.sam.SAMPackage#getTransition_Condition()
     * @model
     * @generated
     */
    String getCondition();

    /**
     * Sets the value of the '{@link org.topcased.sam.Transition#getCondition <em>Condition</em>}' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Condition</em>' attribute.
     * @see #getCondition()
     * @generated
     */
    void setCondition(String value);

    /**
     * Returns the value of the '<em><b>Emission</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Emission</em>' attribute isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Emission</em>' attribute.
     * @see #setEmission(String)
     * @see org.topcased.sam.SAMPackage#getTransition_Emission()
     * @model
     * @generated
     */
    String getEmission();

    /**
     * Sets the value of the '{@link org.topcased.sam.Transition#getEmission <em>Emission</em>}' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Emission</em>' attribute.
     * @see #getEmission()
     * @generated
     */
    void setEmission(String value);

    /**
     * Returns the value of the '<em><b>Priority</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Priority</em>' attribute isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Priority</em>' attribute.
     * @see #setPriority(Integer)
     * @see org.topcased.sam.SAMPackage#getTransition_Priority()
     * @model
     * @generated
     */
    Integer getPriority();

    /**
     * Sets the value of the '{@link org.topcased.sam.Transition#getPriority <em>Priority</em>}' attribute. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Priority</em>' attribute.
     * @see #getPriority()
     * @generated
     */
    void setPriority(Integer value);

    /**
     * Returns the value of the '<em><b>Dest</b></em>' reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.State#getInlink <em>Inlink</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Dest</em>' reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Dest</em>' reference.
     * @see #setDest(State)
     * @see org.topcased.sam.SAMPackage#getTransition_Dest()
     * @see org.topcased.sam.State#getInlink
     * @model opposite="inlink" resolveProxies="false" required="true"
     * @generated
     */
    State getDest();

    /**
     * Sets the value of the '{@link org.topcased.sam.Transition#getDest <em>Dest</em>}' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Dest</em>' reference.
     * @see #getDest()
     * @generated
     */
    void setDest(State value);

    /**
     * Returns the value of the '<em><b>Parent Automaton</b></em>' container reference. It is bidirectional and its
     * opposite is '{@link org.topcased.sam.Automaton#getListTransitions <em>List Transitions</em>}'. <!--
     * begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent Automaton</em>' container reference isn't clear, there really should be
     * more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Parent Automaton</em>' container reference.
     * @see #setParentAutomaton(Automaton)
     * @see org.topcased.sam.SAMPackage#getTransition_ParentAutomaton()
     * @see org.topcased.sam.Automaton#getListTransitions
     * @model opposite="listTransitions" resolveProxies="false" required="true"
     * @generated
     */
    Automaton getParentAutomaton();

    /**
     * Sets the value of the '{@link org.topcased.sam.Transition#getParentAutomaton <em>Parent Automaton</em>}' container reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the new value of the '<em>Parent Automaton</em>' container reference.
     * @see #getParentAutomaton()
     * @generated
     */
    void setParentAutomaton(Automaton value);

    /**
     * Returns the value of the '<em><b>Source</b></em>' reference.
     * It is bidirectional and its opposite is '{@link org.topcased.sam.AbstractState#getOutlink <em>Outlink</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Source</em>' reference isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Source</em>' reference.
     * @see #setSource(AbstractState)
     * @see org.topcased.sam.SAMPackage#getTransition_Source()
     * @see org.topcased.sam.AbstractState#getOutlink
     * @model opposite="outlink" resolveProxies="false" required="true"
     * @generated
     */
    AbstractState getSource();

    /**
     * Sets the value of the '{@link org.topcased.sam.Transition#getSource <em>Source</em>}' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Source</em>' reference.
     * @see #getSource()
     * @generated
     */
    void setSource(AbstractState value);

} // Transition
