/**
 * <copyright>
 * </copyright>
 *
 * $Id: SAMFactoryImpl.java,v 1.12 2007-04-12 08:33:45 jako Exp $
 */
package org.topcased.sam.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.topcased.sam.Automaton;
import org.topcased.sam.Composition;
import org.topcased.sam.ControlFlow;
import org.topcased.sam.DataFlow;
import org.topcased.sam.DataStore;
import org.topcased.sam.DataType;
import org.topcased.sam.Decomposition;
import org.topcased.sam.InControlPort;
import org.topcased.sam.InDataPort;
import org.topcased.sam.InitialState;
import org.topcased.sam.MacroState;
import org.topcased.sam.Model;
import org.topcased.sam.MultiPort;
import org.topcased.sam.OutControlPort;
import org.topcased.sam.OutDataPort;
import org.topcased.sam.SAMFactory;
import org.topcased.sam.SAMPackage;
import org.topcased.sam.State;
import org.topcased.sam.Transition;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!-- end-user-doc -->
 * @generated
 */
public class SAMFactoryImpl extends EFactoryImpl implements SAMFactory
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final String copyright = "";

    /**
     * Creates the default factory implementation.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static SAMFactory init()
    {
        try
        {
            SAMFactory theSAMFactory = (SAMFactory) EPackage.Registry.INSTANCE.getEFactory("http://www.topcased.org/SAM/1.0");
            if (theSAMFactory != null)
            {
                return theSAMFactory;
            }
        }
        catch (Exception exception)
        {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new SAMFactoryImpl();
    }

    /**
     * Creates an instance of the factory.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SAMFactoryImpl()
    {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EObject create(EClass eClass)
    {
        switch (eClass.getClassifierID())
        {
            case SAMPackage.AUTOMATON:
                return createAutomaton();
            case SAMPackage.INITIAL_STATE:
                return createInitialState();
            case SAMPackage.MACRO_STATE:
                return createMacroState();
            case SAMPackage.STATE:
                return createState();
            case SAMPackage.TRANSITION:
                return createTransition();
            case SAMPackage.IN_CONTROL_PORT:
                return createInControlPort();
            case SAMPackage.IN_DATA_PORT:
                return createInDataPort();
            case SAMPackage.OUT_CONTROL_PORT:
                return createOutControlPort();
            case SAMPackage.OUT_DATA_PORT:
                return createOutDataPort();
            case SAMPackage.COMPOSITION:
                return createComposition();
            case SAMPackage.CONTROL_FLOW:
                return createControlFlow();
            case SAMPackage.DATA_FLOW:
                return createDataFlow();
            case SAMPackage.DATA_STORE:
                return createDataStore();
            case SAMPackage.DECOMPOSITION:
                return createDecomposition();
            case SAMPackage.SYSTEM:
                return createSystem();
            case SAMPackage.MODEL:
                return createModel();
            case SAMPackage.MULTI_PORT:
                return createMultiPort();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object createFromString(EDataType eDataType, String initialValue)
    {
        switch (eDataType.getClassifierID())
        {
            case SAMPackage.DATA_TYPE:
                return createDataTypeFromString(eDataType, initialValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String convertToString(EDataType eDataType, Object instanceValue)
    {
        switch (eDataType.getClassifierID())
        {
            case SAMPackage.DATA_TYPE:
                return convertDataTypeToString(eDataType, instanceValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public Automaton createAutomaton()
    {
        AutomatonImpl automaton = new AutomatonImpl();
        return automaton;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public InitialState createInitialState()
    {
        InitialStateImpl initialState = new InitialStateImpl();
        return initialState;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MacroState createMacroState()
    {
        MacroStateImpl macroState = new MacroStateImpl();
        return macroState;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public State createState()
    {
        StateImpl state = new StateImpl();
        return state;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public Transition createTransition()
    {
        TransitionImpl transition = new TransitionImpl();
        return transition;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public InControlPort createInControlPort()
    {
        InControlPortImpl inControlPort = new InControlPortImpl();
        return inControlPort;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public InDataPort createInDataPort()
    {
        InDataPortImpl inDataPort = new InDataPortImpl();
        return inDataPort;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public OutControlPort createOutControlPort()
    {
        OutControlPortImpl outControlPort = new OutControlPortImpl();
        return outControlPort;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public OutDataPort createOutDataPort()
    {
        OutDataPortImpl outDataPort = new OutDataPortImpl();
        return outDataPort;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public Composition createComposition()
    {
        CompositionImpl composition = new CompositionImpl();
        return composition;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public ControlFlow createControlFlow()
    {
        ControlFlowImpl controlFlow = new ControlFlowImpl();
        return controlFlow;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public DataFlow createDataFlow()
    {
        DataFlowImpl dataFlow = new DataFlowImpl();
        return dataFlow;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public DataStore createDataStore()
    {
        DataStoreImpl dataStore = new DataStoreImpl();
        return dataStore;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public Decomposition createDecomposition()
    {
        DecompositionImpl decomposition = new DecompositionImpl();
        return decomposition;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public org.topcased.sam.System createSystem()
    {
        SystemImpl system = new SystemImpl();
        return system;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public Model createModel()
    {
        ModelImpl model = new ModelImpl();
        return model;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MultiPort createMultiPort()
    {
        MultiPortImpl multiPort = new MultiPortImpl();
        return multiPort;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public DataType createDataTypeFromString(EDataType eDataType, String initialValue)
    {
        DataType result = DataType.get(initialValue);
        if (result == null)
            throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String convertDataTypeToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SAMPackage getSAMPackage()
    {
        return (SAMPackage) getEPackage();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @deprecated
     * @generated
     */
    @Deprecated
    public static SAMPackage getPackage()
    {
        return SAMPackage.eINSTANCE;
    }

} // SAMFactoryImpl
