/**
 * <copyright>
 * </copyright>
 *
 * $Id: SAMItemProviderAdapterFactory.java,v 1.12 2007-04-12 08:33:56 jako Exp $
 */
package org.topcased.sam.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.topcased.sam.util.SAMAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers. The adapters generated by this
 * factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The adapters
 * also support Eclipse property sheets. Note that most of the adapters are shared among multiple instances. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class SAMItemProviderAdapterFactory extends SAMAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final String copyright = "";

    /**
     * This keeps track of the root adapter factory that delegates to this adapter factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected Collection<Object> supportedTypes = new ArrayList<Object>();

    /**
     * This constructs an instance.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SAMItemProviderAdapterFactory()
    {
        supportedTypes.add(IEditingDomainItemProvider.class);
        supportedTypes.add(IStructuredItemContentProvider.class);
        supportedTypes.add(ITreeItemContentProvider.class);
        supportedTypes.add(IItemLabelProvider.class);
        supportedTypes.add(IItemPropertySource.class);
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.Automaton} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected AutomatonItemProvider automatonItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.Automaton}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAutomatonAdapter()
    {
        if (automatonItemProvider == null)
        {
            automatonItemProvider = new AutomatonItemProvider(this);
        }

        return automatonItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.InitialState} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected InitialStateItemProvider initialStateItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.InitialState}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Adapter createInitialStateAdapter()
    {
        if (initialStateItemProvider == null)
        {
            initialStateItemProvider = new InitialStateItemProvider(this);
        }

        return initialStateItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.MacroState} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected MacroStateItemProvider macroStateItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.MacroState}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createMacroStateAdapter()
    {
        if (macroStateItemProvider == null)
        {
            macroStateItemProvider = new MacroStateItemProvider(this);
        }

        return macroStateItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.State} instances.
     * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * @generated
     */
    protected StateItemProvider stateItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.State}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStateAdapter()
    {
        if (stateItemProvider == null)
        {
            stateItemProvider = new StateItemProvider(this);
        }

        return stateItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.Transition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected TransitionItemProvider transitionItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.Transition}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTransitionAdapter()
    {
        if (transitionItemProvider == null)
        {
            transitionItemProvider = new TransitionItemProvider(this);
        }

        return transitionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.InControlPort} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected InControlPortItemProvider inControlPortItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.InControlPort}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Adapter createInControlPortAdapter()
    {
        if (inControlPortItemProvider == null)
        {
            inControlPortItemProvider = new InControlPortItemProvider(this);
        }

        return inControlPortItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.InDataPort} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected InDataPortItemProvider inDataPortItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.InDataPort}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createInDataPortAdapter()
    {
        if (inDataPortItemProvider == null)
        {
            inDataPortItemProvider = new InDataPortItemProvider(this);
        }

        return inDataPortItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.OutControlPort} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected OutControlPortItemProvider outControlPortItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.OutControlPort}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Adapter createOutControlPortAdapter()
    {
        if (outControlPortItemProvider == null)
        {
            outControlPortItemProvider = new OutControlPortItemProvider(this);
        }

        return outControlPortItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.OutDataPort} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected OutDataPortItemProvider outDataPortItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.OutDataPort}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Adapter createOutDataPortAdapter()
    {
        if (outDataPortItemProvider == null)
        {
            outDataPortItemProvider = new OutDataPortItemProvider(this);
        }

        return outDataPortItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.Composition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CompositionItemProvider compositionItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.Composition}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Adapter createCompositionAdapter()
    {
        if (compositionItemProvider == null)
        {
            compositionItemProvider = new CompositionItemProvider(this);
        }

        return compositionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.ControlFlow} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ControlFlowItemProvider controlFlowItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.ControlFlow}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Adapter createControlFlowAdapter()
    {
        if (controlFlowItemProvider == null)
        {
            controlFlowItemProvider = new ControlFlowItemProvider(this);
        }

        return controlFlowItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.DataFlow} instances.
     * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * @generated
     */
    protected DataFlowItemProvider dataFlowItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.DataFlow}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDataFlowAdapter()
    {
        if (dataFlowItemProvider == null)
        {
            dataFlowItemProvider = new DataFlowItemProvider(this);
        }

        return dataFlowItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.DataStore} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected DataStoreItemProvider dataStoreItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.DataStore}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDataStoreAdapter()
    {
        if (dataStoreItemProvider == null)
        {
            dataStoreItemProvider = new DataStoreItemProvider(this);
        }

        return dataStoreItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.Decomposition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected DecompositionItemProvider decompositionItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.Decomposition}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Adapter createDecompositionAdapter()
    {
        if (decompositionItemProvider == null)
        {
            decompositionItemProvider = new DecompositionItemProvider(this);
        }

        return decompositionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.System} instances.
     * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * @generated
     */
    protected SystemItemProvider systemItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.System}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSystemAdapter()
    {
        if (systemItemProvider == null)
        {
            systemItemProvider = new SystemItemProvider(this);
        }

        return systemItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.Model} instances.
     * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * @generated
     */
    protected ModelItemProvider modelItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.Model}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createModelAdapter()
    {
        if (modelItemProvider == null)
        {
            modelItemProvider = new ModelItemProvider(this);
        }

        return modelItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link org.topcased.sam.MultiPort} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected MultiPortItemProvider multiPortItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sam.MultiPort}.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createMultiPortAdapter()
    {
        if (multiPortItemProvider == null)
        {
            multiPortItemProvider = new MultiPortItemProvider(this);
        }

        return multiPortItemProvider;
    }

    /**
     * This returns the root adapter factory that contains this factory.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public ComposeableAdapterFactory getRootAdapterFactory()
    {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
    {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object type)
    {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the adapter.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    @Override
    public Adapter adapt(Notifier notifier, Object type)
    {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object adapt(Object object, Object type)
    {
        if (isFactoryForType(type))
        {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class) || (((Class< ? >) type).isInstance(adapter)))
            {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void addListener(INotifyChangedListener notifyChangedListener)
    {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void removeListener(INotifyChangedListener notifyChangedListener)
    {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public void fireNotifyChanged(Notification notification)
    {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null)
        {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This disposes all of the item providers created by this factory. 
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void dispose()
    {
        if (automatonItemProvider != null)
            automatonItemProvider.dispose();
        if (initialStateItemProvider != null)
            initialStateItemProvider.dispose();
        if (macroStateItemProvider != null)
            macroStateItemProvider.dispose();
        if (stateItemProvider != null)
            stateItemProvider.dispose();
        if (transitionItemProvider != null)
            transitionItemProvider.dispose();
        if (inControlPortItemProvider != null)
            inControlPortItemProvider.dispose();
        if (inDataPortItemProvider != null)
            inDataPortItemProvider.dispose();
        if (outControlPortItemProvider != null)
            outControlPortItemProvider.dispose();
        if (outDataPortItemProvider != null)
            outDataPortItemProvider.dispose();
        if (compositionItemProvider != null)
            compositionItemProvider.dispose();
        if (controlFlowItemProvider != null)
            controlFlowItemProvider.dispose();
        if (dataFlowItemProvider != null)
            dataFlowItemProvider.dispose();
        if (dataStoreItemProvider != null)
            dataStoreItemProvider.dispose();
        if (decompositionItemProvider != null)
            decompositionItemProvider.dispose();
        if (systemItemProvider != null)
            systemItemProvider.dispose();
        if (modelItemProvider != null)
            modelItemProvider.dispose();
        if (multiPortItemProvider != null)
            multiPortItemProvider.dispose();
    }

}
