/**
 * <copyright>
 * </copyright>
 *
 * $Id: SystemItemProvider.java,v 1.12 2007-04-12 08:33:56 jako Exp $
 */
package org.topcased.sam.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.topcased.sam.SAMFactory;
import org.topcased.sam.SAMPackage;
import org.topcased.sam.SAMPlugin;

/**
 * This is the item provider adapter for a {@link org.topcased.sam.System} object.
 * <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * @generated
 */
public class SystemItemProvider extends ModelContentItemProvider implements IEditingDomainItemProvider, IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider,
        IItemPropertySource
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final String copyright = "";

    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SystemItemProvider(AdapterFactory adapterFactory)
    {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
    {
        if (itemPropertyDescriptors == null)
        {
            super.getPropertyDescriptors(object);

            addIsInstanceOfPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Is Instance Of feature.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected void addIsInstanceOfPropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
                getString("_UI_System_isInstanceOf_feature"), getString("_UI_PropertyDescriptor_description", "_UI_System_isInstanceOf_feature", "_UI_System_type"),
                SAMPackage.Literals.SYSTEM__IS_INSTANCE_OF, true, false, true, null, null, null));
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    @Override
    public Collection< ? extends EStructuralFeature> getChildrenFeatures(Object object)
    {
        if (childrenFeatures == null)
        {
            super.getChildrenFeatures(object);
            childrenFeatures.add(SAMPackage.Literals.SYSTEM__LIST_PORTS);
            childrenFeatures.add(SAMPackage.Literals.SYSTEM__LIST_STORES);
            childrenFeatures.add(SAMPackage.Literals.SYSTEM__LIST_SYNCHRONISATION);
            childrenFeatures.add(SAMPackage.Literals.SYSTEM__LIST_FLOWS);
            childrenFeatures.add(SAMPackage.Literals.SYSTEM__LIST_ELEMENTS);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child)
    {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns System.gif.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object)
    {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/System"));
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object)
    {
        String label = ((org.topcased.sam.System) object).getName();
        return label == null || label.length() == 0 ? getString("_UI_System_type") : getString("_UI_System_type") + " " + label;
    }

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached children and by creating
     * a viewer notification, which it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification)
    {
        updateChildren(notification);

        switch (notification.getFeatureID(org.topcased.sam.System.class))
        {
            case SAMPackage.SYSTEM__IS_INSTANCE_OF:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
                return;
            case SAMPackage.SYSTEM__LIST_PORTS:
            case SAMPackage.SYSTEM__LIST_STORES:
            case SAMPackage.SYSTEM__LIST_SYNCHRONISATION:
            case SAMPackage.SYSTEM__LIST_FLOWS:
            case SAMPackage.SYSTEM__LIST_ELEMENTS:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
    {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_PORTS, SAMFactory.eINSTANCE.createInControlPort()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_PORTS, SAMFactory.eINSTANCE.createInDataPort()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_PORTS, SAMFactory.eINSTANCE.createOutControlPort()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_PORTS, SAMFactory.eINSTANCE.createOutDataPort()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_STORES, SAMFactory.eINSTANCE.createDataStore()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_SYNCHRONISATION, SAMFactory.eINSTANCE.createComposition()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_SYNCHRONISATION, SAMFactory.eINSTANCE.createDecomposition()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_FLOWS, SAMFactory.eINSTANCE.createControlFlow()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_FLOWS, SAMFactory.eINSTANCE.createDataFlow()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_ELEMENTS, SAMFactory.eINSTANCE.createAutomaton()));

        newChildDescriptors.add(createChildParameter(SAMPackage.Literals.SYSTEM__LIST_ELEMENTS, SAMFactory.eINSTANCE.createSystem()));
    }

    /**
     * Return the resource locator for this item provider's resources.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator()
    {
        return SAMPlugin.INSTANCE;
    }

}
