/**
 * <copyright>
 * </copyright>
 *
 * $Id: SAMAdapterFactory.java,v 1.12 2007-04-12 08:33:59 jako Exp $
 */
package org.topcased.sam.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.EObject;
import org.topcased.sam.AbstractState;
import org.topcased.sam.Automaton;
import org.topcased.sam.Composition;
import org.topcased.sam.ControlFlow;
import org.topcased.sam.ControlPort;
import org.topcased.sam.DataFlow;
import org.topcased.sam.DataPort;
import org.topcased.sam.DataStore;
import org.topcased.sam.Decomposition;
import org.topcased.sam.Flow;
import org.topcased.sam.IdentifiedItem;
import org.topcased.sam.InControlPort;
import org.topcased.sam.InDataPort;
import org.topcased.sam.InitialState;
import org.topcased.sam.InputPort;
import org.topcased.sam.MacroState;
import org.topcased.sam.Model;
import org.topcased.sam.ModelContent;
import org.topcased.sam.MultiPort;
import org.topcased.sam.NamedItem;
import org.topcased.sam.OutControlPort;
import org.topcased.sam.OutDataPort;
import org.topcased.sam.OutputPort;
import org.topcased.sam.Port;
import org.topcased.sam.SAMPackage;
import org.topcased.sam.State;
import org.topcased.sam.SynchronisationGate;
import org.topcased.sam.Transition;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides an adapter <code>createXXX</code>
 * method for each class of the model. <!-- end-user-doc -->
 * @see org.topcased.sam.SAMPackage
 * @generated
 */
public class SAMAdapterFactory extends AdapterFactoryImpl
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final String copyright = "";

    /**
     * The cached model package.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected static SAMPackage modelPackage;

    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SAMAdapterFactory()
    {
        if (modelPackage == null)
        {
            modelPackage = SAMPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc --> This
     * implementation returns <code>true</code> if the object is either the model's package or is an instance object
     * of the model. <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object object)
    {
        if (object == modelPackage)
        {
            return true;
        }
        if (object instanceof EObject)
        {
            return ((EObject) object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch the delegates to the <code>createXXX</code> methods.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected SAMSwitch<Adapter> modelSwitch = new SAMSwitch<Adapter>()
    {
        @Override
        public Adapter caseAbstractState(AbstractState object)
        {
            return createAbstractStateAdapter();
        }

        @Override
        public Adapter caseAutomaton(Automaton object)
        {
            return createAutomatonAdapter();
        }

        @Override
        public Adapter caseInitialState(InitialState object)
        {
            return createInitialStateAdapter();
        }

        @Override
        public Adapter caseMacroState(MacroState object)
        {
            return createMacroStateAdapter();
        }

        @Override
        public Adapter caseState(State object)
        {
            return createStateAdapter();
        }

        @Override
        public Adapter caseTransition(Transition object)
        {
            return createTransitionAdapter();
        }

        @Override
        public Adapter caseControlPort(ControlPort object)
        {
            return createControlPortAdapter();
        }

        @Override
        public Adapter caseDataPort(DataPort object)
        {
            return createDataPortAdapter();
        }

        @Override
        public Adapter caseInControlPort(InControlPort object)
        {
            return createInControlPortAdapter();
        }

        @Override
        public Adapter caseInDataPort(InDataPort object)
        {
            return createInDataPortAdapter();
        }

        @Override
        public Adapter caseInputPort(InputPort object)
        {
            return createInputPortAdapter();
        }

        @Override
        public Adapter caseOutControlPort(OutControlPort object)
        {
            return createOutControlPortAdapter();
        }

        @Override
        public Adapter caseOutDataPort(OutDataPort object)
        {
            return createOutDataPortAdapter();
        }

        @Override
        public Adapter caseOutputPort(OutputPort object)
        {
            return createOutputPortAdapter();
        }

        @Override
        public Adapter casePort(Port object)
        {
            return createPortAdapter();
        }

        @Override
        public Adapter caseComposition(Composition object)
        {
            return createCompositionAdapter();
        }

        @Override
        public Adapter caseControlFlow(ControlFlow object)
        {
            return createControlFlowAdapter();
        }

        @Override
        public Adapter caseDataFlow(DataFlow object)
        {
            return createDataFlowAdapter();
        }

        @Override
        public Adapter caseDataStore(DataStore object)
        {
            return createDataStoreAdapter();
        }

        @Override
        public Adapter caseDecomposition(Decomposition object)
        {
            return createDecompositionAdapter();
        }

        @Override
        public Adapter caseFlow(Flow object)
        {
            return createFlowAdapter();
        }

        @Override
        public Adapter caseSynchronisationGate(SynchronisationGate object)
        {
            return createSynchronisationGateAdapter();
        }

        @Override
        public Adapter caseSystem(org.topcased.sam.System object)
        {
            return createSystemAdapter();
        }

        @Override
        public Adapter caseModel(Model object)
        {
            return createModelAdapter();
        }

        @Override
        public Adapter caseModelContent(ModelContent object)
        {
            return createModelContentAdapter();
        }

        @Override
        public Adapter caseIdentifiedItem(IdentifiedItem object)
        {
            return createIdentifiedItemAdapter();
        }

        @Override
        public Adapter caseNamedItem(NamedItem object)
        {
            return createNamedItemAdapter();
        }

        @Override
        public Adapter caseMultiPort(MultiPort object)
        {
            return createMultiPortAdapter();
        }

        @Override
        public Adapter caseEModelElement(EModelElement object)
        {
            return createEModelElementAdapter();
        }

        @Override
        public Adapter defaultCase(EObject object)
        {
            return createEObjectAdapter();
        }
    };

    /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    @Override
    public Adapter createAdapter(Notifier target)
    {
        return modelSwitch.doSwitch((EObject) target);
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.AbstractState <em>Abstract State</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.AbstractState
     * @generated
     */
    public Adapter createAbstractStateAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.Automaton <em>Automaton</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.Automaton
     * @generated
     */
    public Adapter createAutomatonAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.InitialState <em>Initial State</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.InitialState
     * @generated
     */
    public Adapter createInitialStateAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.MacroState <em>Macro State</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.MacroState
     * @generated
     */
    public Adapter createMacroStateAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.State <em>State</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.State
     * @generated
     */
    public Adapter createStateAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.Transition <em>Transition</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.Transition
     * @generated
     */
    public Adapter createTransitionAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.ControlPort <em>Control Port</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.ControlPort
     * @generated
     */
    public Adapter createControlPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.DataPort <em>Data Port</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.DataPort
     * @generated
     */
    public Adapter createDataPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.InControlPort <em>In Control Port</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.InControlPort
     * @generated
     */
    public Adapter createInControlPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.InDataPort <em>In Data Port</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.InDataPort
     * @generated
     */
    public Adapter createInDataPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.InputPort <em>Input Port</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.InputPort
     * @generated
     */
    public Adapter createInputPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.OutControlPort <em>Out Control Port</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.OutControlPort
     * @generated
     */
    public Adapter createOutControlPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.OutDataPort <em>Out Data Port</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.OutDataPort
     * @generated
     */
    public Adapter createOutDataPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.OutputPort <em>Output Port</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.OutputPort
     * @generated
     */
    public Adapter createOutputPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.Port <em>Port</em>}'.
     * <!-- begin-user-doc
     * --> This default implementation returns null so that we can easily ignore cases; it's useful to ignore a case
     * when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.Port
     * @generated
     */
    public Adapter createPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.Composition <em>Composition</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.Composition
     * @generated
     */
    public Adapter createCompositionAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.ControlFlow <em>Control Flow</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.ControlFlow
     * @generated
     */
    public Adapter createControlFlowAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.DataFlow <em>Data Flow</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.DataFlow
     * @generated
     */
    public Adapter createDataFlowAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.DataStore <em>Data Store</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.DataStore
     * @generated
     */
    public Adapter createDataStoreAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.Decomposition <em>Decomposition</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.Decomposition
     * @generated
     */
    public Adapter createDecompositionAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.Flow <em>Flow</em>}'.
     * <!-- begin-user-doc
     * --> This default implementation returns null so that we can easily ignore cases; it's useful to ignore a case
     * when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.Flow
     * @generated
     */
    public Adapter createFlowAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.SynchronisationGate <em>Synchronisation Gate</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.SynchronisationGate
     * @generated
     */
    public Adapter createSynchronisationGateAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.System <em>System</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.System
     * @generated
     */
    public Adapter createSystemAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.Model <em>Model</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.Model
     * @generated
     */
    public Adapter createModelAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.ModelContent <em>Model Content</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.ModelContent
     * @generated
     */
    public Adapter createModelContentAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.IdentifiedItem <em>Identified Item</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.topcased.sam.IdentifiedItem
     * @generated
     */
    public Adapter createIdentifiedItemAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.NamedItem <em>Named Item</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.NamedItem
     * @generated
     */
    public Adapter createNamedItemAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.topcased.sam.MultiPort <em>Multi Port</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful to
     * ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see org.topcased.sam.MultiPort
     * @generated
     */
    public Adapter createMultiPortAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link org.eclipse.emf.ecore.EModelElement <em>EModel Element</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that we can easily ignore cases; it's useful
     * to ignore a case when inheritance will catch all the cases anyway. <!-- end-user-doc -->
     * @return the new adapter.
     * @see org.eclipse.emf.ecore.EModelElement
     * @generated
     */
    public Adapter createEModelElementAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc --> This default implementation returns null.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter()
    {
        return null;
    }

} // SAMAdapterFactory
