/**
 * <copyright>
 * </copyright>
 *
 * $Id: SAMSwitch.java,v 1.12 2007-04-12 08:33:58 jako Exp $
 */
package org.topcased.sam.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.EObject;
import org.topcased.sam.AbstractState;
import org.topcased.sam.Automaton;
import org.topcased.sam.Composition;
import org.topcased.sam.ControlFlow;
import org.topcased.sam.ControlPort;
import org.topcased.sam.DataFlow;
import org.topcased.sam.DataPort;
import org.topcased.sam.DataStore;
import org.topcased.sam.Decomposition;
import org.topcased.sam.Flow;
import org.topcased.sam.IdentifiedItem;
import org.topcased.sam.InControlPort;
import org.topcased.sam.InDataPort;
import org.topcased.sam.InitialState;
import org.topcased.sam.InputPort;
import org.topcased.sam.MacroState;
import org.topcased.sam.Model;
import org.topcased.sam.ModelContent;
import org.topcased.sam.MultiPort;
import org.topcased.sam.NamedItem;
import org.topcased.sam.OutControlPort;
import org.topcased.sam.OutDataPort;
import org.topcased.sam.OutputPort;
import org.topcased.sam.Port;
import org.topcased.sam.SAMPackage;
import org.topcased.sam.State;
import org.topcased.sam.SynchronisationGate;
import org.topcased.sam.Transition;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance hierarchy. It supports the call
 * {@link #doSwitch(EObject) doSwitch(object)} to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the inheritance hierarchy until a non-null result is
 * returned, which is the result of the switch. <!-- end-user-doc -->
 * @see org.topcased.sam.SAMPackage
 * @generated
 */
public class SAMSwitch<T>
{
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final String copyright = "";

    /**
     * The cached model package
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected static SAMPackage modelPackage;

    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SAMSwitch()
    {
        if (modelPackage == null)
        {
            modelPackage = SAMPackage.eINSTANCE;
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    public T doSwitch(EObject theEObject)
    {
        return doSwitch(theEObject.eClass(), theEObject);
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    protected T doSwitch(EClass theEClass, EObject theEObject)
    {
        if (theEClass.eContainer() == modelPackage)
        {
            return doSwitch(theEClass.getClassifierID(), theEObject);
        }
        else
        {
            List<EClass> eSuperTypes = theEClass.getESuperTypes();
            return eSuperTypes.isEmpty() ? defaultCase(theEObject) : doSwitch(eSuperTypes.get(0), theEObject);
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    protected T doSwitch(int classifierID, EObject theEObject)
    {
        switch (classifierID)
        {
            case SAMPackage.ABSTRACT_STATE: {
                AbstractState abstractState = (AbstractState) theEObject;
                T result = caseAbstractState(abstractState);
                if (result == null)
                    result = caseNamedItem(abstractState);
                if (result == null)
                    result = caseIdentifiedItem(abstractState);
                if (result == null)
                    result = caseEModelElement(abstractState);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.AUTOMATON: {
                Automaton automaton = (Automaton) theEObject;
                T result = caseAutomaton(automaton);
                if (result == null)
                    result = caseModelContent(automaton);
                if (result == null)
                    result = caseNamedItem(automaton);
                if (result == null)
                    result = caseIdentifiedItem(automaton);
                if (result == null)
                    result = caseEModelElement(automaton);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.INITIAL_STATE: {
                InitialState initialState = (InitialState) theEObject;
                T result = caseInitialState(initialState);
                if (result == null)
                    result = caseState(initialState);
                if (result == null)
                    result = caseAbstractState(initialState);
                if (result == null)
                    result = caseNamedItem(initialState);
                if (result == null)
                    result = caseIdentifiedItem(initialState);
                if (result == null)
                    result = caseEModelElement(initialState);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.MACRO_STATE: {
                MacroState macroState = (MacroState) theEObject;
                T result = caseMacroState(macroState);
                if (result == null)
                    result = caseAbstractState(macroState);
                if (result == null)
                    result = caseNamedItem(macroState);
                if (result == null)
                    result = caseIdentifiedItem(macroState);
                if (result == null)
                    result = caseEModelElement(macroState);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.STATE: {
                State state = (State) theEObject;
                T result = caseState(state);
                if (result == null)
                    result = caseAbstractState(state);
                if (result == null)
                    result = caseNamedItem(state);
                if (result == null)
                    result = caseIdentifiedItem(state);
                if (result == null)
                    result = caseEModelElement(state);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.TRANSITION: {
                Transition transition = (Transition) theEObject;
                T result = caseTransition(transition);
                if (result == null)
                    result = caseIdentifiedItem(transition);
                if (result == null)
                    result = caseEModelElement(transition);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.CONTROL_PORT: {
                ControlPort controlPort = (ControlPort) theEObject;
                T result = caseControlPort(controlPort);
                if (result == null)
                    result = casePort(controlPort);
                if (result == null)
                    result = caseNamedItem(controlPort);
                if (result == null)
                    result = caseIdentifiedItem(controlPort);
                if (result == null)
                    result = caseEModelElement(controlPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.DATA_PORT: {
                DataPort dataPort = (DataPort) theEObject;
                T result = caseDataPort(dataPort);
                if (result == null)
                    result = casePort(dataPort);
                if (result == null)
                    result = caseNamedItem(dataPort);
                if (result == null)
                    result = caseIdentifiedItem(dataPort);
                if (result == null)
                    result = caseEModelElement(dataPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.IN_CONTROL_PORT: {
                InControlPort inControlPort = (InControlPort) theEObject;
                T result = caseInControlPort(inControlPort);
                if (result == null)
                    result = caseControlPort(inControlPort);
                if (result == null)
                    result = caseInputPort(inControlPort);
                if (result == null)
                    result = casePort(inControlPort);
                if (result == null)
                    result = caseNamedItem(inControlPort);
                if (result == null)
                    result = caseIdentifiedItem(inControlPort);
                if (result == null)
                    result = caseEModelElement(inControlPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.IN_DATA_PORT: {
                InDataPort inDataPort = (InDataPort) theEObject;
                T result = caseInDataPort(inDataPort);
                if (result == null)
                    result = caseDataPort(inDataPort);
                if (result == null)
                    result = caseInputPort(inDataPort);
                if (result == null)
                    result = casePort(inDataPort);
                if (result == null)
                    result = caseNamedItem(inDataPort);
                if (result == null)
                    result = caseIdentifiedItem(inDataPort);
                if (result == null)
                    result = caseEModelElement(inDataPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.INPUT_PORT: {
                InputPort inputPort = (InputPort) theEObject;
                T result = caseInputPort(inputPort);
                if (result == null)
                    result = casePort(inputPort);
                if (result == null)
                    result = caseNamedItem(inputPort);
                if (result == null)
                    result = caseIdentifiedItem(inputPort);
                if (result == null)
                    result = caseEModelElement(inputPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.OUT_CONTROL_PORT: {
                OutControlPort outControlPort = (OutControlPort) theEObject;
                T result = caseOutControlPort(outControlPort);
                if (result == null)
                    result = caseControlPort(outControlPort);
                if (result == null)
                    result = caseOutputPort(outControlPort);
                if (result == null)
                    result = casePort(outControlPort);
                if (result == null)
                    result = caseNamedItem(outControlPort);
                if (result == null)
                    result = caseIdentifiedItem(outControlPort);
                if (result == null)
                    result = caseEModelElement(outControlPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.OUT_DATA_PORT: {
                OutDataPort outDataPort = (OutDataPort) theEObject;
                T result = caseOutDataPort(outDataPort);
                if (result == null)
                    result = caseDataPort(outDataPort);
                if (result == null)
                    result = caseOutputPort(outDataPort);
                if (result == null)
                    result = casePort(outDataPort);
                if (result == null)
                    result = caseNamedItem(outDataPort);
                if (result == null)
                    result = caseIdentifiedItem(outDataPort);
                if (result == null)
                    result = caseEModelElement(outDataPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.OUTPUT_PORT: {
                OutputPort outputPort = (OutputPort) theEObject;
                T result = caseOutputPort(outputPort);
                if (result == null)
                    result = casePort(outputPort);
                if (result == null)
                    result = caseNamedItem(outputPort);
                if (result == null)
                    result = caseIdentifiedItem(outputPort);
                if (result == null)
                    result = caseEModelElement(outputPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.PORT: {
                Port port = (Port) theEObject;
                T result = casePort(port);
                if (result == null)
                    result = caseNamedItem(port);
                if (result == null)
                    result = caseIdentifiedItem(port);
                if (result == null)
                    result = caseEModelElement(port);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.COMPOSITION: {
                Composition composition = (Composition) theEObject;
                T result = caseComposition(composition);
                if (result == null)
                    result = caseSynchronisationGate(composition);
                if (result == null)
                    result = caseIdentifiedItem(composition);
                if (result == null)
                    result = caseEModelElement(composition);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.CONTROL_FLOW: {
                ControlFlow controlFlow = (ControlFlow) theEObject;
                T result = caseControlFlow(controlFlow);
                if (result == null)
                    result = caseFlow(controlFlow);
                if (result == null)
                    result = caseNamedItem(controlFlow);
                if (result == null)
                    result = caseIdentifiedItem(controlFlow);
                if (result == null)
                    result = caseEModelElement(controlFlow);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.DATA_FLOW: {
                DataFlow dataFlow = (DataFlow) theEObject;
                T result = caseDataFlow(dataFlow);
                if (result == null)
                    result = caseFlow(dataFlow);
                if (result == null)
                    result = caseNamedItem(dataFlow);
                if (result == null)
                    result = caseIdentifiedItem(dataFlow);
                if (result == null)
                    result = caseEModelElement(dataFlow);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.DATA_STORE: {
                DataStore dataStore = (DataStore) theEObject;
                T result = caseDataStore(dataStore);
                if (result == null)
                    result = caseNamedItem(dataStore);
                if (result == null)
                    result = caseIdentifiedItem(dataStore);
                if (result == null)
                    result = caseEModelElement(dataStore);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.DECOMPOSITION: {
                Decomposition decomposition = (Decomposition) theEObject;
                T result = caseDecomposition(decomposition);
                if (result == null)
                    result = caseSynchronisationGate(decomposition);
                if (result == null)
                    result = caseIdentifiedItem(decomposition);
                if (result == null)
                    result = caseEModelElement(decomposition);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.FLOW: {
                Flow flow = (Flow) theEObject;
                T result = caseFlow(flow);
                if (result == null)
                    result = caseNamedItem(flow);
                if (result == null)
                    result = caseIdentifiedItem(flow);
                if (result == null)
                    result = caseEModelElement(flow);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.SYNCHRONISATION_GATE: {
                SynchronisationGate synchronisationGate = (SynchronisationGate) theEObject;
                T result = caseSynchronisationGate(synchronisationGate);
                if (result == null)
                    result = caseIdentifiedItem(synchronisationGate);
                if (result == null)
                    result = caseEModelElement(synchronisationGate);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.SYSTEM: {
                org.topcased.sam.System system = (org.topcased.sam.System) theEObject;
                T result = caseSystem(system);
                if (result == null)
                    result = caseModelContent(system);
                if (result == null)
                    result = caseNamedItem(system);
                if (result == null)
                    result = caseIdentifiedItem(system);
                if (result == null)
                    result = caseEModelElement(system);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.MODEL: {
                Model model = (Model) theEObject;
                T result = caseModel(model);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.MODEL_CONTENT: {
                ModelContent modelContent = (ModelContent) theEObject;
                T result = caseModelContent(modelContent);
                if (result == null)
                    result = caseNamedItem(modelContent);
                if (result == null)
                    result = caseIdentifiedItem(modelContent);
                if (result == null)
                    result = caseEModelElement(modelContent);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.IDENTIFIED_ITEM: {
                IdentifiedItem identifiedItem = (IdentifiedItem) theEObject;
                T result = caseIdentifiedItem(identifiedItem);
                if (result == null)
                    result = caseEModelElement(identifiedItem);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.NAMED_ITEM: {
                NamedItem namedItem = (NamedItem) theEObject;
                T result = caseNamedItem(namedItem);
                if (result == null)
                    result = caseIdentifiedItem(namedItem);
                if (result == null)
                    result = caseEModelElement(namedItem);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case SAMPackage.MULTI_PORT: {
                MultiPort multiPort = (MultiPort) theEObject;
                T result = caseMultiPort(multiPort);
                if (result == null)
                    result = caseNamedItem(multiPort);
                if (result == null)
                    result = caseIdentifiedItem(multiPort);
                if (result == null)
                    result = caseEModelElement(multiPort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            default:
                return defaultCase(theEObject);
        }
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Abstract State</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Abstract State</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAbstractState(AbstractState object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Automaton</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Automaton</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAutomaton(Automaton object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Initial State</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Initial State</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseInitialState(InitialState object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Macro State</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Macro State</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMacroState(MacroState object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>State</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>State</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseState(State object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Transition</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Transition</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseTransition(Transition object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Control Port</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Control Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseControlPort(ControlPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Data Port</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Data Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseDataPort(DataPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>In Control Port</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>In Control Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseInControlPort(InControlPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>In Data Port</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>In Data Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseInDataPort(InDataPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Input Port</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Input Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseInputPort(InputPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Out Control Port</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Out Control Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseOutControlPort(OutControlPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Out Data Port</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Out Data Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseOutDataPort(OutDataPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Output Port</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Output Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseOutputPort(OutputPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Port</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T casePort(Port object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Composition</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Composition</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseComposition(Composition object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Control Flow</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Control Flow</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseControlFlow(ControlFlow object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Data Flow</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Data Flow</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseDataFlow(DataFlow object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Data Store</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Data Store</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseDataStore(DataStore object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Decomposition</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Decomposition</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseDecomposition(Decomposition object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Flow</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Flow</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseFlow(Flow object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Synchronisation Gate</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Synchronisation Gate</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSynchronisationGate(SynchronisationGate object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>System</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>System</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSystem(org.topcased.sam.System object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Model</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Model</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseModel(Model object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Model Content</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Model Content</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseModelContent(ModelContent object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Identified Item</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Identified Item</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseIdentifiedItem(IdentifiedItem object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Named Item</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Named Item</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseNamedItem(NamedItem object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>Multi Port</em>'. <!-- begin-user-doc
     * --> This implementation returns null; returning a non-null result will terminate the switch. <!-- end-user-doc
     * -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>Multi Port</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMultiPort(MultiPort object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>EModel Element</em>'. <!--
     * begin-user-doc --> This implementation returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>EModel Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseEModelElement(EModelElement object)
    {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null; returning a non-null result will terminate the switch, but this is the last
     * case anyway. <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    public T defaultCase(EObject object)
    {
        return null;
    }

} // SAMSwitch
