/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.core.engine;

import java.util.HashMap;
import java.util.Map;

/**
 * All classes wanting to provide parameters to model search queries should implement this interface.
 * It allows users to set arbitrary parameters and retrieve it from specific queries implementations.
 * 
 * @author lucas.bigeardel@anyware-tech.com
 *
 */
public interface IModelSearchQueryParameterProvider {
	Map<String, Object> dataMap = new HashMap<String, Object>();
	String getQuery();
	Map<String, Object> getData();
	
}
