/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.core.engine;

import java.util.List;

import org.eclipse.core.resources.IResource;

public interface IModelSearchScope {
	public List<IResource> getParticipants();
	public void addParticipant(IResource resource);
	public void addParticipants(IResource[] resources);
	public void removeParticipant(IResource resource);
	public void removeParticipants(IResource[] resources);
	public List<IResource> findPartcipant(Class<? extends Object> clazz);
}
