/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * ModelExtensibleSearchResultEntry.java
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.core.engine;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.core.resources.IFile;

/**
 * Defines a single model search query result entry.
 * 
 * @author lucas.bigeardel@anyware-tech.com
 *
 */
public class ModelExtensibleSearchResultEntry {
	private IFile modelFile;
    private Object result;
    private Collection <Object> matches;

    public ModelExtensibleSearchResultEntry(IFile file, Object source) {
        modelFile = file;
        result = source;
        matches = new ArrayList <Object>();
    }
    public void setMatchingFeatures(Collection <Object> matches) {
        this.matches = matches;
    }
    public void appendMatchingFeatures(Collection <Object> matches) {
        matches.addAll(matches);
    }
    public void addMatchingFeature(Object match) {
        matches.add(match);
    }
    public Object getSource() {
        return result;
    }
    public Collection <Object> getMatches() {
        return matches;
    }
    public IFile getFile() {
        return modelFile;
    }
}
