/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.core.engine;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.eclipse.core.resources.IResource;

public final class ModelSearchScope implements IModelSearchScope {
	List<IResource> particpants;
	public ModelSearchScope() {
		particpants = new ArrayList<IResource>();
	}
	public void addParticipant(IResource resource) {
		particpants.add(resource);		
	}
	public List<IResource> findPartcipant(Class<? extends Object> clazz) {
		ArrayList<IResource> subList = new ArrayList<IResource>();
		for (IResource resource : particpants) {
			if (resource.getClass().equals(clazz)) {
				subList.add(resource);
			}
		}
		return subList;
	}
	public List<IResource> getParticipants() {
		return particpants;
	}
	public void removeParticipant(IResource resource) {
		particpants.remove(resource);		
	}
	public void addParticipants(IResource[] resources) {
		particpants.addAll(Arrays.asList(resources))	;	
	}
	public void removeParticipants(IResource[] resources) {
		particpants.removeAll(Arrays.asList(resources))	;	
	}
}
