/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * IModelSearchQueryProvider.java
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.core.factories;

import org.topcased.search.core.engine.AbstractModelExtensibleSearchParameters;
import org.topcased.search.core.engine.AbstractModelExtensibleSearchQuery;

/**
 * Classes wanting to create AbstractModelExtensibleSearchQuery instances should implement this interface.
 * 
 * @author lucas.bigeardel@anyware-tech.com
 *
 */
public interface IModelSearchQueryFactory {
	/**
	 * Creates a new Model Search Query from given parameters.
	 * 
	 * @param p Model Search Query parameters
	 * @return newly created AbstractModelExtensibleSearchQuery instance.
	 */
	public AbstractModelExtensibleSearchQuery createModelSearchQuery(AbstractModelExtensibleSearchParameters p);
}
