/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.core.factories;

import org.topcased.search.core.engine.AbstractModelExtensibleSearchParameters;

/**
 * Classes wanting to create AbstractModelExtensibleSearchParameters instances should implement this interface.
 * 
 * @author lucas.bigeardel@anyware-tech.com
 *
 */
public interface IModelSearchQueryParametersFactory {
	/**
	 * Creates a new Model Search Query Parameters from given parameters.
	 * 
	 * @param p Model Search Query parameters
	 */
	AbstractModelExtensibleSearchParameters createSearchQueryParameters();
}
