/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.ecore.ui.areas;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.provider.EcoreItemProviderAdapterFactory;
import org.eclipse.emf.edit.provider.resource.ResourceItemProviderAdapterFactory;
import org.eclipse.swt.widgets.Composite;
import org.topcased.search.ecore.ui.providers.EcoreMetaModelParticipantsItemProvider;
import org.topcased.search.ui.areas.AbstractModelSearchParticipantArea;
import org.topcased.search.ui.areas.IModelSearchParticipantArea;
import org.topcased.search.ui.pages.ModelExtensibleSearchPage;
import org.topcased.search.ui.providers.AbstractMetaModelParticipantsItemProvider;

/**
 * <p>
 * Provide a list of all ECore meta elements particpating to the search.
 * </p>
 * <p>
 * Allows user to select into which meta-element the search query will look into.
 * </p>
 * 
 * 
 * @author lucas.bigeardel@anyware-tech.com
 */
public final class ECoreModelSearchParticipantArea extends AbstractModelSearchParticipantArea implements IModelSearchParticipantArea {
	public ECoreModelSearchParticipantArea(Composite parent, ModelExtensibleSearchPage page, int style) {
		super(parent, page, style);
	}
	public List<AdapterFactory> getMetaElementComposeableAdapterFactories() {
		List<AdapterFactory> composeableAdapterFactories = new ArrayList<AdapterFactory>();
		composeableAdapterFactories.add(new EcoreItemProviderAdapterFactory());
		composeableAdapterFactories.add(new ResourceItemProviderAdapterFactory());
		return composeableAdapterFactories;
	}
	@Override
	public AbstractMetaModelParticipantsItemProvider getMetaModelParticipantsItemProvider() {
		return new EcoreMetaModelParticipantsItemProvider();
	}
}
