/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.ecore.utils;

import org.eclipse.core.resources.IResource;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * Convenience ecore based model loader class.
 *  
 * @author lucas.bigeardel@anyware-tech.com
 *
 */
public final class ECoreModelLoaderUtil {
	 public final static EObject openFile(IResource file, boolean resolve)  {
        URI uri = URI.createPlatformResourceURI(file.getFullPath().toString(), false);
        Resource resource = getResourceSet().getResource(uri, true);
        if (resolve)
        {
            EcoreUtil.resolveAll(getResourceSet());
        }
        return resource.getContents().get(0);
	 }
	 public final static  ResourceSet getResourceSet() {
		 return new ResourceSetImpl();
	 }
}
