/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.ui.areas;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.ui.part.EditorPart;

/**
 * Defines entity responsible of tree editor selection handling.
 * 
 * In other words users defines here how the search result double clicked will be handled in 
 * terms of corresponding editor selection.
 *  
 * @author lucas.bigeardel@anyware-tech.com
 *
 */
public interface IModelElementEditorSelectionHandler {
	public boolean isCompatibleModelElementEditorSelectionHandler(EditorPart part);
	public IStatus handleModelSearchElementSelection(EditorPart part, Object selection);
}
