/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.ui.areas;

import org.eclipse.swt.widgets.Control;
import org.topcased.search.core.engine.IModelSearchQueryParameterProvider;

public interface IModelSearchArea extends IModelSearchQueryParameterProvider {
	Control getControl();

	/**
	 * User wanting Model Search Area to be set up with previous user selections should override 
	 * this method after he/she did the save one, which will be more than usefull ... ^^
	 */
	void loadDialogSettings();

	/**
	 * User wanting Model Search Area to be set up with previous user selections should override 
	 * this method after he/she did the save one, which will be more than usefull ... ^^
	 */
	void storeDialogSettings();
	
	void prepare();
	
	boolean validateStatus();
}
