/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.ui.areas;

import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.EClassifier;
import org.topcased.search.ui.providers.AbstractMetaModelParticipantsItemProvider;

/**
 * This interface describes the contracts to implments for a ModelSearchArea.
 * 
 * In order, to fill discriminable meta-elements list user <b>MUST</b> implement following methods.
 * 
 * @author Lucas
 *
 */
public interface IModelSearchParticipantArea extends IModelSearchArea {
	public List<EClassifier> getSelectedParticipants();
	public List<AdapterFactory> getMetaElementComposeableAdapterFactories();
	public AbstractMetaModelParticipantsItemProvider getMetaModelParticipantsItemProvider();
}
