/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.uml2.ui.areas;

import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.topcased.search.ui.areas.IModelSearchQueryArea;

public class OCLModelSearchQueryArea extends Composite implements IModelSearchQueryArea {
	Label searchQueryLabel;
	Text searchQueryText;
	
	public OCLModelSearchQueryArea(Composite parent, int style) {
		super(parent, style);
		setLayout(new GridLayout(2, false));
		setLayoutData(new GridData(GridData.FILL_BOTH));
		
		GridData gridData = new GridData();
		gridData.horizontalSpan = 2;
		
		searchQueryLabel = new Label(this, SWT.NONE);
		searchQueryLabel.setText("OCL query:");
		searchQueryLabel.setLayoutData(gridData);
		
		gridData = new GridData(GridData.FILL_BOTH);
		
		searchQueryText = new Text(this, SWT.MULTI|SWT.BORDER);
		searchQueryText.setLayoutData(gridData);
	}

	public Control getControl() {
		return this;
	}

	public Map<String, Object> getData() {
		dataMap.clear();
		return dataMap;
	}
	public String getQuery() {
		return searchQueryText.getText();
	}
	public void loadDialogSettings() {}
	public void storeDialogSettings() {}
	public void prepare() {}
	public boolean validateStatus() {
		return true;
	}
}
