/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.uml2.ui.areas;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.provider.EcoreItemProviderAdapterFactory;
import org.eclipse.emf.edit.provider.resource.ResourceItemProviderAdapterFactory;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.uml2.uml.edit.providers.UMLItemProviderAdapterFactory;
import org.topcased.search.ui.areas.AbstractModelSearchParticipantArea;
import org.topcased.search.ui.areas.IModelSearchParticipantArea;
import org.topcased.search.ui.pages.ModelExtensibleSearchPage;
import org.topcased.search.ui.providers.AbstractMetaModelParticipantsItemProvider;
import org.topcased.search.uml2.ui.providers.UML2MetaModelParticipantsItemProvider;

public final class UML2ModelSearchParticipantArea extends AbstractModelSearchParticipantArea implements IModelSearchParticipantArea {
	public UML2ModelSearchParticipantArea(Composite parent, ModelExtensibleSearchPage page, int style) {
		super(parent, page, style);
	}
	
	public List<AdapterFactory> getMetaElementComposeableAdapterFactories() {
		List<AdapterFactory> composeableAdapterFactories = new ArrayList<AdapterFactory>();
		composeableAdapterFactories.add(new EcoreItemProviderAdapterFactory());
		composeableAdapterFactories.add(new UMLItemProviderAdapterFactory());
		composeableAdapterFactories.add(new ResourceItemProviderAdapterFactory());
		return composeableAdapterFactories;
	}
	@Override
	public AbstractMetaModelParticipantsItemProvider getMetaModelParticipantsItemProvider() {
		return new UML2MetaModelParticipantsItemProvider();
	}
}
