/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.uml2.ui.factories;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.topcased.search.ui.areas.IModelSearchArea;
import org.topcased.search.ui.areas.IModelSearchAreaFactory;
import org.topcased.search.ui.pages.ModelExtensibleSearchPage;
import org.topcased.search.uml2.ui.areas.UML2ModelSearchParticipantArea;

/**
 * Factory responsible to create UM2 Model Search Participant Area.
 * 
 * @author 
 *
 */
public class UML2ModelSearchParticipantAreaFactory implements IModelSearchAreaFactory {
	public IModelSearchArea createArea(Composite parent, ModelExtensibleSearchPage searchPage) {
		return new UML2ModelSearchParticipantArea(parent, searchPage, SWT.NONE);
	}
}
