/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Lucas Bigeardel (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/

package org.topcased.search.uml2.ui.handlers;

import java.util.Arrays;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.ui.part.EditorPart;
import org.eclipse.uml2.uml.editor.presentation.UMLEditor;
import org.topcased.search.ui.areas.IModelElementEditorSelectionHandler;

/**
 * Defines entity responsible of tree editor selection handling.
 * 
 * In other words users defines here how the search result double clicked will be handled in 
 * terms of corresponding editor selection.
 *  
 * @author lucas.bigeardel@anyware-tech.com
 *
 */
public class UML2EditorSelectionHandler implements IModelElementEditorSelectionHandler {

	public IStatus handleModelSearchElementSelection(EditorPart part, Object selection) {
		if (part instanceof UMLEditor) {
			((UMLEditor)part).setSelectionToViewer(Arrays.asList(new Object[]{selection}));
		}
		return null;
	}

	public boolean isCompatibleModelElementEditorSelectionHandler(EditorPart part) {
		return part instanceof UMLEditor;
	}
}
