/*******************************************************************************
* Copyright (c) 2005 AIRBUS FRANCE.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), 
*    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
*******************************************************************************/ 
package org.topcased.service.comparison;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
 
public class ObjectComparison {
	private String title = "Comparison Results"; 
	private EObject element=null;
	private boolean originSource = false;
	private String whyNew = new String();
	private List sons = new ArrayList();
	
	public ObjectComparison() {
	}
	
	public ObjectComparison(EObject anElement, boolean source, String reason) {
		this.element = anElement;
		this.originSource=source;
		this.whyNew=reason;
		this.sons=anElement.eContents();
	}
		
	public EObject getEObject() {
		return this.element;
	}
	
	public List getSons() {
		return this.sons;
	}
	
	public boolean getOrigin() {
		return this.originSource;
	}
	
	public void setOrigin(boolean provenance) {
		this.originSource=provenance;
	}
	
	public void setReason(String reason) {
		this.whyNew = reason;
	}
	
	public String getReason() {
		return this.whyNew;
	}
	
	public String getTitle() {
		return this.title;
	}
	
	public void setSons(ObjectComparison son) {
		this.sons.add(son);
	}
}
