/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************/ 
package org.topcased.service.comparison.dnd;

import org.eclipse.swt.widgets.Tree;

public class SourceTargetFacilities 
{
	private Tree sourceTree;
	private Tree destinationTree;
	private static SourceTargetFacilities facility = new SourceTargetFacilities();

	/**
	 * Constructor SourceTargetFacilities
	 */
	private SourceTargetFacilities() 
	{
		sourceTree = null;
		destinationTree = null;
	}

	/**
	 * Getter of the shared instance 
	 * @return the shared object 
	 */
	public static SourceTargetFacilities getInstance() 
	{
		return facility;
	}

	/**
	 * Getter for the source Tree
	 * @return
	 */
	public Tree getSourceTree() 
	{
		return this.sourceTree;
	}

	/**
	 * Getter for the destination Tree
	 * @return the Destination Tree
	 */
	public Tree getDestinationTree() 
	{
		return this.destinationTree;
	}

	/**
	 * Setter for the source Tree
	 * @param source the source Tree to set
	 */
	public void setSourceTree(Tree source) 
	{
		sourceTree = source;
	}

	/**
	 * Setter for the destination Tree
	 * @param destination the destination Tree to set
	 */
	public void setDestinationTree(Tree destination) 
	{
		destinationTree = destination;
	}
}
