package org.topcased.service.comparison.listener;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.topcased.service.comparison.ComparedETreeModel;
import org.topcased.service.comparison.ETreeModel;
import org.topcased.service.comparison.ModelComparator;

public class ComparisonListener implements SelectionListener {
	
	private boolean isInitialise = false; 
	private Tree tree1 = null;
	private Tree tree2 = null;
	private Tree tree3 = null;
	private Map treeMap1 = null;
	private Map treeMap2 = null;
	private TreeViewer treeViewer = null;
	private TreeViewer treeViewer2 = null;
	
	
	public ComparisonListener(boolean _isInitialise,
			Tree _tree1, Tree _tree2, Tree _tree3,
			TreeViewer _treeViewer, TreeViewer _treeViewer2) {
		isInitialise = _isInitialise;
		tree1 = _tree1;
		tree2 = _tree2;
		tree3 = _tree3;
		treeMap1 = new HashMap();
		treeMap2 = new HashMap();
		treeViewer = _treeViewer;
		treeViewer2 = _treeViewer2;
	}

	public void widgetSelected(SelectionEvent e) {
		if (!isInitialise){
			initMaps(); 
			isInitialise = true;
		}
		
		TreeItem items []=tree3.getSelection();
		if ((items != null) && (items.length > 0)){
			//tree2.
			EObject eobj1 = ((ComparedETreeModel)items[0].getData()).getObjectComparison().getEObject();
			if (eobj1 != null)
			{
				String uidEobj1 = ModelComparator.getInstance().getUid(eobj1);
			 	
				Object treeItem1 = treeMap1.get(eobj1);
				Iterator it = treeMap1.keySet().iterator();
				while (it.hasNext() && treeItem1 == null)
				{
					EObject key = (EObject) it.next();
					if (uidEobj1.equals(ModelComparator.getInstance().getUid(key)) )
					{
						// le getData ne correspond pas  la key
						treeItem1 = treeMap1.get(key);
					}
				}
				
				if (treeItem1 != null)
				{
					tree1.setSelection(new TreeItem[]{(TreeItem)treeItem1});
					tree1.redraw();						
				}
				
				Object treeItem2 = treeMap2.get(eobj1);
				it = treeMap2.keySet().iterator();
				while (it.hasNext()&& treeItem2 == null)
				{
					EObject key = (EObject) it.next();
					if ( uidEobj1.equals(ModelComparator.getInstance().getUid(key)) )
					{
						treeItem2 = treeMap2.get(key);
					}
				}
				
				if (treeItem2 != null){
					tree2.setSelection(new TreeItem[]{(TreeItem)treeItem2});
					tree2.redraw();
				}
			}
		}

	}

	public void widgetDefaultSelected(SelectionEvent e) {
		// TODO Auto-generated method stub

	}

	public void initMaps(){
		
		treeMap1 = new HashMap();
		for (int i = 0; i < tree1.getItems().length; i++) {
			treeMap1.putAll(chargeArbreGraphique(treeMap1,tree1.getItems()[i],treeViewer));				
		}
		
		treeMap2 = new HashMap();
		for (int i = 0; i < tree2.getItems().length; i++) {
			treeMap2.putAll(chargeArbreGraphique(treeMap2,tree2.getItems()[i],treeViewer2));				
		}
		
	}
	
	private Map chargeArbreGraphique(Map treeMap, TreeItem treeItem, TreeViewer treeviewer) {
		TreeItem [] fils = treeItem.getItems();	
		
		if (((ETreeModel)treeItem.getData())!= null && ((ETreeModel)treeItem.getData()).getEobject()!= null) {
			treeMap.put(((ETreeModel)treeItem.getData()).getEobject(),treeItem);
		}
		if (fils != null) {
			for (int i = 0; i < fils.length; i++) {
				if (((ETreeModel)fils[i].getData()) != null && ((ETreeModel)fils[i].getData()).getEobject() != null) {
					treeMap.put(((ETreeModel)fils[i].getData()).getEobject(),fils[i]);
				}
				treeMap.putAll(chargeArbreGraphique(treeMap,fils[i],treeviewer));
			}
		}
		return treeMap; 
	}
	
	
}
