/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), S�bastien Gabel (CS)
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *********************************************************************************************/
package org.topcased.service.oclchecker.services;

import java.util.Map;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.widgets.Display;
import org.topcased.bus.core.CorePlugin;
import org.topcased.bus.core.IService;
import org.topcased.service.oclchecker.dialogs.CheckerDialog;

public class OCLCheckerDialogService implements IService
{

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.topcased.bus.core.IService#serviceRun(java.lang.Object[])
	 */
	public Object serviceRun(Object[] parameters)
	{
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.topcased.bus.core.IService#serviceRun(java.util.Map)
	 */
	public Object serviceRun(Map<String,Object> parameters)
	{
		if (parameters.size() > 1)
		{
			CorePlugin.log("The Ocl Check Model Correctness Service may only have one parameter : 'Model'.", IStatus.ERROR);
			return null;
		}

		if (parameters.containsKey("Model") && !(parameters.get("Model") instanceof EObject))
		{
			CorePlugin.log("The 'Model' parameter must be an EObject.", IStatus.ERROR);
			return null;
		}

		CheckerDialog dialog;
		if (parameters.containsKey("Model"))
		{
			dialog = new CheckerDialog(Display.getCurrent().getActiveShell(), (EObject) parameters.get("Model"));
		}
		else
		{
			dialog = new CheckerDialog(Display.getCurrent().getActiveShell());
		}
		dialog.open();

		return null;
	}

}
