/*******************************************************************************
* Copyright (c) 2005 AIRBUS FRANCE.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), 
*    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
*******************************************************************************/ 
package org.topcased.service.plugincustomization.epf;

import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;
import org.topcased.service.plugincustomization.epf.exportwizard.PreferencesFileExportPage;
import org.topcased.service.plugincustomization.epf.exportwizard.PreferencesFileExportWizard;

/**
 * Plugs on a Eclipse wizard "Export Eclipse". Permit to create the Eclipse
 * Preferences File (.epf) and take path of the created file.
 * 
 */
public class CreateEpf
{    
    /**
     * Plug on a Eclipse wizard "Export Eclpise" to create '.epf' file TODO
     * WARNING : Take pathEPF using a class copied and modified from
     * org.eclipse.ui.internal.wizard.preferences
     * 
     * @return path of Eclipse Preferences File created by the Wizard.
     */
    public String runNew()
    {
        String pathDestination = "";
        Shell shell = new Shell();
        PreferencesFileExportWizard wizardExportEPF = new PreferencesFileExportWizard();
        new WizardDialog(shell, wizardExportEPF).open();

        // Get epf path
        IWizardPage iWizardpage = wizardExportEPF.getPage("preferencesExportPage1");
        PreferencesFileExportPage page1 = (PreferencesFileExportPage) iWizardpage;
        pathDestination = page1.getEpfFilePath();
        return pathDestination;
    }
}
