/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.service.plugincustomization.services;

import java.util.Map;

import org.eclipse.core.runtime.IStatus;
import org.topcased.bus.core.CorePlugin;
import org.topcased.bus.core.IService;
import org.topcased.service.plugincustomization.PlugincustomizationPlugin;
import org.topcased.service.plugincustomization.epf.CreateEpf;

/**
 * EclipsePreferencesCreation is a SERVICE on the bus. It permits to create an
 * Eclipse Preferences File (.epf) using an Eclipse Wizard
 * 
 */
public class EclipsePreferencesCreation implements IService
{
    /**
     * @see org.topcased.bus.core.IService#serviceRun(java.util.Map)
     */
    public Object serviceRun(Map<String, Object> parameters)
    {
        // Bloc Declaration
        String pathEPF = "";

        // Map null
        if (parameters != null)
        {
            // SERVICE CREATE EPF CREATION
            pathEPF = new CreateEpf().runNew();
            CorePlugin.log(this.getClass(), PlugincustomizationPlugin.getResourceString("EclipsePreferencesCreation.log.epf.creation"), IStatus.INFO);
        }
        else
        {
            CorePlugin.log(this.getClass(), PlugincustomizationPlugin.getResourceString("EclipsePreferencesCreation.log.epf.notcreation"), IStatus.ERROR);
        }
        return pathEPF;
    }
}
