/*******************************************************************************
* Copyright (c) 2005 AIRBUS FRANCE.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), 
*    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
*******************************************************************************/ 
package org.topcased.service.projecttotemplate.infos;

/**
 * InfosFile contains - a file name 'fileName', - a file path 'filePath'
 * 
 */
public class InfosFile
{
    // File name
    private String fileName = "";

    // File path
    private String filePath = "";

    /**
     * Constructor
     */
    public InfosFile()
    {
        // do noting
    }

    /**
     * Constructor
     * 
     * @param nameFile
     * @param pathFile
     */
    public InfosFile(String nameFile, String pathFile)
    {
        fileName = nameFile;
        filePath = pathFile;
    }

    /**
     * Sets file name fileName
     * 
     * @param nameFile
     */
    public void setFileName(String nameFile)
    {
        fileName = nameFile;
    }

    /**
     * @return file name fileName
     */
    public String getFileName()
    {
        return fileName;
    }

    /**
     * Sets file path filePath
     * 
     * @param pathFile
     */
    public void setFilePath(String pathFile)
    {
        filePath = pathFile;
    }

    /**
     * @return file path filePath
     */
    public String getFilePath()
    {
        return filePath;
    }
}
