/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.service.transformation.services;

import java.util.Map;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IStatus;
import org.topcased.bus.core.CorePlugin;
import org.topcased.bus.core.IService;
import org.topcased.service.transformation.Transformation;

public class TransformationService implements IService
{
	/**
	 * @see org.topcased.bus.core.IService#serviceRun(java.util.Map)
	 */
	public Object serviceRun(Map<String, Object> parameters)
	{

		if (!parameters.containsKey("Id"))
		{
			CorePlugin.log("The parameter Id must be set.", IStatus.ERROR);
		}

		if (!parameters.containsKey("Models"))
		{
			CorePlugin.log("The parameter Models must be set.", IStatus.ERROR);
		}

		if (!parameters.containsKey("ProjectPath"))
		{
			CorePlugin.log("The parameter ProjectPath must be set.", IStatus.ERROR);
		}

		if (!parameters.containsKey("IsXml"))
		{
			CorePlugin.log("The parameter IsXml must be set.", IStatus.ERROR);
		}

		if (!(parameters.get("Id") instanceof String))
		{
			CorePlugin.log("The parameter Id must be a String.", IStatus.ERROR);
		}

		if (!(parameters.get("Models") instanceof Map))
		{
			CorePlugin.log("The parameter Models must be a Map.", IStatus.ERROR);
		}

		if (!(parameters.get("ProjectPath") instanceof IPath))
		{
			CorePlugin.log("The parameter ProjectPath must be a IPath.", IStatus.ERROR);
		}

		if (!(parameters.get("IsXml") instanceof Boolean))
		{
			CorePlugin.log("The parameter IsXml must be a Boolean.", IStatus.ERROR);
		}

		CorePlugin.log("Entering Transformation service.", IStatus.INFO);

		String id = (String) parameters.get("Id");
		Map<String, String> models = (Map<String, String>) parameters.get("Models");
		IPath projectPath = (IPath) parameters.get("ProjectPath");
		Boolean isXml = (Boolean) parameters.get("IsXml");

		new Transformation(id, models, projectPath, isXml.booleanValue(), null);

		CorePlugin.log("Leaving Transformation service.", IStatus.INFO);

		return null;
	}
}
