/*******************************************************************************
* Copyright (c) 2005 AIRBUS FRANCE.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), 
*    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
*******************************************************************************/ 
package org.topcased.service.updatesite;

/**
 *
 * This class groups all properties, about a category,
 * necessary to create the 'site.xml' file
 */
public class InfoCategorySite
{
    private String name;

    private String label;

    private String description = "";

    /**
     * Constructor
     * 
     * @param name
     * @param label
     */
    public InfoCategorySite(String name, String label)
    {
        this.name = name;
        this.label = label;
    }

    /**
     * Constructor
     * 
     * @param name
     * @param label
     * @param desc
     */
    public InfoCategorySite(String name, String label, String desc)
    {
        this(name, label);
        this.description = desc;
    }

    /**
     * @return Returns the description.
     */
    public String getDescription()
    {
        return description;
    }

    /**
     * @param description The description to set.
     */
    public void setDescription(String description)
    {
        this.description = description;
    }

    /**
     * @return Returns the label.
     */
    public String getLabel()
    {
        return label;
    }

    /**
     * @param label The label to set.
     */
    public void setLabel(String label)
    {
        this.label = label;
    }

    /**
     * @return Returns the name.
     */
    public String getName()
    {
        return name;
    }

    /**
     * @param name The name to set.
     */
    public void setName(String name)
    {
        this.name = name;
    }
}
