/*******************************************************************************
* Copyright (c) 2005 AIRBUS FRANCE.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), 
*    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
*******************************************************************************/ 
package org.topcased.service.updatesite;

/**
 *
 * This class groups all properties, about a feature,
 * necessary to create the 'site.xml' file
 */
public class InfoFeatureSite
{
    private String m_URL = "";

    private String m_id = "";

    private String m_version;

    private String m_os = "";

    private String m_ws = "";

    private String m_nl = "";

    private String m_arch = "";

    private String m_patch = "false";

    private String m_category = "";

    /**
     * Constructor
     * 
     * @param URL
     * @param version
     * @param id
     */
    public InfoFeatureSite(String URL, String version, String id)
    {
        m_URL = URL;
        m_version = version;
        m_id = id;
    }

    /**
     * @return Returns the arch.
     */
    public String getArch()
    {
        return m_arch;
    }

    /**
     * @param arch The arch to set.
     */
    public void setArch(String arch)
    {
        m_arch = arch;
    }

    /**
     * @return Returns the id.
     */
    public String getId()
    {
        return m_id;
    }

    /**
     * @param id The id to set.
     */
    public void setId(String id)
    {
        m_id = id;
    }

    /**
     * @return Returns the nl.
     */
    public String getNl()
    {
        return m_nl;
    }

    /**
     * @param nl The nl to set.
     */
    public void setNl(String nl)
    {
        m_nl = nl;
    }

    /**
     * @return Returns the os.
     */
    public String getOs()
    {
        return m_os;
    }

    /**
     * @param os The os to set.
     */
    public void setOs(String os_)
    {
        m_os = os_;
    }

    /**
     * @return Returns the patch.
     */
    public String getPatch()
    {
        return m_patch;
    }

    /**
     * @param patch_ The patch to set.
     */
    public void setPatch(String patch)
    {
        m_patch = patch;
    }

    /**
     * @return Returns the uRL.
     */
    public String getURL()
    {
        return m_URL;
    }

    /**
     * @param url The uRL to set.
     */
    public void setURL(String url)
    {
        m_URL = url;
    }

    /**
     * @return Returns the version.
     */
    public String getVersion()
    {
        return m_version;
    }

    /**
     * @param version The version to set.
     */
    public void setVersion(String version)
    {
        m_version = version;
    }

    /**
     * @return Returns the ws.
     */
    public String getWs()
    {
        return m_ws;
    }

    /**
     * @param ws The ws to set.
     */
    public void setWs(String ws)
    {
        m_ws = ws;
    }

    /**
     * @return Returns the category.
     */
    public String getCategory()
    {
        return m_category;
    }

    /**
     * @param category The category to set.
     */
    public void setCategory(String category)
    {
        m_category = category;
    }
}
