/*******************************************************************************
* Copyright (c) 2005 AIRBUS FRANCE.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), 
*    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
*******************************************************************************/ 
package org.topcased.service.updatesite;

/**
 * All informations which can be find in the file 'feature.xml' 
 * at the tag '<import>'
 * <br>
 */
public class InfosImport
{
    private String plugin = "";
    private String feature= "";
    private String version = "";
    private String match = "";
    private String patch = "";
    private boolean requires = false;
    
    /**
     * Constructor
     * @param pluginImport
     * @param featureImport
     * @param versionImport
     * @param matchImport
     * @param patchImport
     * @param requiresImport
     */
    public InfosImport(String pluginImport, String featureImport, String versionImport, 
            String matchImport, String patchImport, boolean requiresImport){
        plugin = pluginImport;
        feature = featureImport;
        version = versionImport;
        match = matchImport;
        patch = patchImport;
        requires = requiresImport;
    }

    /**
     * Get plugin
     * @return import plugin
     */
    public String getPluginImport(){
        return plugin;
    }
    
    /**
     * Get feature
     * @return import feature
     */
    public String getFeatureImport(){
        return feature;
    }
    
    /**
     * Get version
     * @return import version
     */
    public String getVersionImport(){
        return version;
    }
    
    /**
     * Get match
     * @return import match
     */
    public String getMatchImport(){
        String result = match;
        if (match.equals(""))
            result = "compatible";
        return result;
    }
    
    /**
     * Get patch
     * @return import patch
     */
    public String getPatchImport(){
        String result = patch;
        if (patch.equals(""))
            result = "false";
        return result;
    }
    
    /**
     * Return 'true' if the import is requires
     * @return import requires
     */
    public boolean isRequiresImport(){
        return requires;
    }
    
}
