package org.topcased.service.updatesite;

import com.sshtools.j2ssh.authentication.KBIPrompt;
import com.sshtools.j2ssh.authentication.KBIRequestHandler;

/**
 * This class avoids to use a GUI for entering SSH passwords.
 * This solution is the best because the user don't have to enter his/her password two times.
 * The user password is taken since the information entered on the connect page. 
 *
 */
public class UpdateSiteKBIRequestHandler implements KBIRequestHandler 
{
    private UpdateSiteWizard wizard; 
    
    /**
     * Constructor
     * @param theWizard The current wizard
     */
    public UpdateSiteKBIRequestHandler(UpdateSiteWizard theWizard)
    {
    	wizard = theWizard;
    }
    
    /**
	* This method provides the user password entered during the connect page to the SSH server. 
	*
	* @param name
	* @param instruction
	* @param prompts
	*/
    public void showPrompts(String name, String instruction, KBIPrompt[] prompts)
    {
        if (prompts != null)
        {
       		// Send the response to the server
        	prompts[0].setResponse(wizard.getPassword());
        }
    }
}