/*******************************************************************************
* Copyright (c) 2005 AIRBUS FRANCE.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), 
*    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
*******************************************************************************/ 
package org.topcased.service.updatesiteproject;

/**
 * All informations which can be find in the file 'feature.xml' 
 * at the tag '<plugin>'
 * <br>
 */
public class InfosPlugin
{

    private String id = "";
    private String downloadSize= "";
    private String installSize = "";
    private String fragment = "";
    private String version = "";
    private String ws = "";
    private String os = "";
    private String arch = "";
    private String nl = "";
    private String unpack = "";
    
    
    /**
     * Constructor
     * @param idPlugin
     * @param downloadSizePlugin
     * @param installSizePlugin
     * @param fragmentPlugin
     * @param versionPlugin
     * @param wsPlugin
     * @param osPlugin
     * @param archPlugin
     * @param nlPlugin 
     * @param unpackPlugin 
     */
    public InfosPlugin(String idPlugin, String downloadSizePlugin,String installSizePlugin,
            String fragmentPlugin,String versionPlugin, String wsPlugin, String osPlugin,
            String archPlugin,String nlPlugin,  String unpackPlugin){
        id=idPlugin;
        downloadSize=downloadSizePlugin;
        installSize=installSizePlugin;
        fragment=fragmentPlugin;
        version=versionPlugin;
        ws=wsPlugin;
        os=osPlugin;
        arch=archPlugin;
        nl = nlPlugin;
        unpack = unpackPlugin;
    }


    
    /**
     * Get id
     * @return plugin id
     */
    public String getIdPlugin(){
        return id;
    }
    
    /**
     * Get version
     * @return plugin version
     */
    public String getVersionPlugin(){
        return version;
    }
    
    /**
     * Get installSize
     * @return plugin installSize
     */
    public String getInstallSizePlugin(){
        return installSize;
    }
    
    /**
     * Get downloadSize
     * @return plugin downloadSize
     */
    public String getDownloadSizePlugin(){
        return downloadSize;
    }
   
    /**
     * Get fragment
     * @return plugin fragment
     */
    public String getFragmentPlugin(){
        String result = fragment;
        if (fragment.equals("")){
            result = "false";
        }
        return result;
    }
    
    /**
     * Get os
     * @return plugin os
     */
    public String getOsPlugin(){
        return os;
    }
    
    
    /**
     * Get ws
     * @return plugin ws
     */
    public String getWsPlugin(){
        return ws;
    }
    
    /**
     * Get arch
     * @return plugin arch
     */
    public String getArchPlugin(){
        return arch;
    }
    
    
    /**
     * Get nl
     * @return plugin nl
     */
    public String getNlPlugin(){
        return nl;
    }
    
    /**
     * Get unpack
     * @return plugin unpack
     */
    public String getUnpackPlugin(){
        String result = unpack;
        if (unpack.equals("")){
            result = "true";
        }
        return result;
    }
  
    
}
