package org.topcased.service.updatesiteproject;

import com.sshtools.j2ssh.authentication.KBIPrompt;
import com.sshtools.j2ssh.authentication.KBIRequestHandler;

/**
 * This class avoids to use a GUI for entering SSH passwords.
 * This solution is the best because the user don't have to enter his/her password two times.
 * The user password is taken since the information entered on the connect page. 
 *
 */
public class UpdateSiteProjectKBIRequestHandler implements KBIRequestHandler 
{
    private UpdateSiteProjectWizard wizard; 
    
    public UpdateSiteProjectKBIRequestHandler(UpdateSiteProjectWizard wizard)
    {
    	this.wizard = wizard;
    }
    
    /**
	* This method provides to the SSH server the user password entered during the connect page. 
	*
	* @param name
	* @param instruction
	* @param prompts
	*/
    public void showPrompts(String name, String instruction, KBIPrompt[] prompts)
    {
        if (prompts != null)
        {
       		// Send the response to the server
        	prompts[0].setResponse(wizard.getPassword());
        }
    }
}