/**
 * <copyright> </copyright>
 * 
 * $Id: FlowDirectionKind.java,v 1.2 2007-05-22 08:51:18 tlandre Exp $
 */
package org.topcased.sysml;

import static org.topcased.sysml.FlowDirectionKind.IN;
import static org.topcased.sysml.FlowDirectionKind.INOUT;
import static org.topcased.sysml.FlowDirectionKind.OUT;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em> < ? >Flow Direction Kind</b></em>',
 * and utility methods for working with them. <!-- end-user-doc -->
 * @see org.topcased.sysml.SysMLPackage#getFlowDirectionKind()
 * @model
 * @generated
 */
public enum FlowDirectionKind implements Enumerator {
    /**
	 * The '<em><b>Inout</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #INOUT
	 * @generated
	 * @ordered
	 */
    INOUT_LITERAL(0, "inout", "inout"),
    /**
	 * The '<em><b>In</b></em>' literal object.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #IN
	 * @generated
	 * @ordered
	 */
    IN_LITERAL(1, "in", "in"),
    /**
	 * The '<em><b>Out</b></em>' literal object.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #OUT
	 * @generated
	 * @ordered
	 */
    OUT_LITERAL(2, "out", "out");
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * The '<em><b>Inout</b></em>' literal value.
	 * <!-- begin-user-doc --> < ? >
     * If the meaning of '<em> < ? >Inout</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #INOUT_LITERAL
	 * @model name="inout"
	 *        annotation="http://www.topcased.org/uuid uuid='1146668553267200'"
	 * @generated
	 * @ordered
	 */
    public static final int INOUT = 0;

    /**
	 * The '<em><b>In</b></em>' literal value.
	 * <!-- begin-user-doc --> < ? >
     * If the meaning of '<em> < ? >In</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #IN_LITERAL
	 * @model name="in"
	 *        annotation="http://www.topcased.org/uuid uuid='1146668553298201'"
	 * @generated
	 * @ordered
	 */
    public static final int IN = 1;

    /**
	 * The '<em><b>Out</b></em>' literal value.
	 * <!-- begin-user-doc --> < ? >
     * If the meaning of '<em> < ? >Out</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #OUT_LITERAL
	 * @model name="out"
	 *        annotation="http://www.topcased.org/uuid uuid='1146668553314202'"
	 * @generated
	 * @ordered
	 */
    public static final int OUT = 2;

    /**
	 * An array of all the '<em><b>Flow Direction Kind</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private static final FlowDirectionKind[] VALUES_ARRAY = new FlowDirectionKind[] {
			INOUT_LITERAL,
			IN_LITERAL,
			OUT_LITERAL,
		};

    /**
	 * A public read-only list of all the '<em><b>Flow Direction Kind</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final List<FlowDirectionKind> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
	 * Returns the '<em><b>Flow Direction Kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static FlowDirectionKind get(String literal)
    {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FlowDirectionKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Flow Direction Kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static FlowDirectionKind getByName(String name)
    {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FlowDirectionKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Flow Direction Kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static FlowDirectionKind get(int value)
    {
		switch (value) {
			case INOUT: return INOUT_LITERAL;
			case IN: return IN_LITERAL;
			case OUT: return OUT_LITERAL;
		}
		return null;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final int value;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String name;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String literal;

    /**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    private FlowDirectionKind(int value, String name, String literal)
    {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public int getValue()
    {
	  return value;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName()
    {
	  return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getLiteral()
    {
	  return literal;
	}

    /**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString()
    {
		return literal;
	}
}
