/**
 * <copyright> </copyright>
 * 
 * $Id: RequirementKind.java,v 1.2 2007-05-22 08:50:40 tlandre Exp $
 */
package org.topcased.sysml;

import static org.topcased.sysml.RequirementKind.FUNCTIONAL;
import static org.topcased.sysml.RequirementKind.INTERFACE;
import static org.topcased.sysml.RequirementKind.PERFORMANCE;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em> < ? >Requirement Kind</b></em>',
 * and utility methods for working with them. <!-- end-user-doc -->
 * @see org.topcased.sysml.SysMLPackage#getRequirementKind()
 * @model
 * @generated
 */
public enum RequirementKind implements Enumerator {
    /**
     * The '<em> < ? >Functional</b></em>' literal object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #FUNCTIONAL
     * @generated
     * @ordered
     */
    FUNCTIONAL_LITERAL(0, "Functional", "Functional"),
    /**
     * The '<em> < ? >Performance</b></em>' literal object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #PERFORMANCE
     * @generated
     * @ordered
     */
    PERFORMANCE_LITERAL(1, "Performance", "Performance"),
    /**
     * The '<em> < ? >Interface</b></em>' literal object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #INTERFACE
     * @generated
     * @ordered
     */
    INTERFACE_LITERAL(2, "Interface", "Interface");
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
     * The '<em> < ? >Functional</b></em>' literal value. <!--
     * begin-user-doc --> < ? > If the meaning of '<em> < ? >Functional</b></em>'
     * literal object isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #FUNCTIONAL_LITERAL
     * @model name="Functional" annotation="http://www.topcased.org/uuid
     *        uuid='114129629366459'"
     * @generated
     * @ordered
     */
    public static final int FUNCTIONAL = 0;

    /**
     * The '<em> < ? >Performance</b></em>' literal value. <!--
     * begin-user-doc --> < ? > If the meaning of '<em> < ? >Performance</b></em>'
     * literal object isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #PERFORMANCE_LITERAL
     * @model name="Performance" annotation="http://www.topcased.org/uuid
     *        uuid='114129629366460'"
     * @generated
     * @ordered
     */
    public static final int PERFORMANCE = 1;

    /**
	 * The '<em><b>Interface</b></em>' literal value.
	 * <!-- begin-user-doc
     * --> < ? > If the meaning of '<em> < ? >Interface</b></em>' literal
     * object isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #INTERFACE_LITERAL
	 * @model name="Interface"
	 *        annotation="http://www.topcased.org/uuid uuid='114129629367961'"
	 * @generated
	 * @ordered
	 */
    public static final int INTERFACE = 2;

    /**
	 * An array of all the '<em><b>Requirement Kind</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private static final RequirementKind[] VALUES_ARRAY = new RequirementKind[] {
			FUNCTIONAL_LITERAL,
			PERFORMANCE_LITERAL,
			INTERFACE_LITERAL,
		};

    /**
	 * A public read-only list of all the '<em><b>Requirement Kind</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final List<RequirementKind> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
	 * Returns the '<em><b>Requirement Kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static RequirementKind get(String literal)
    {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RequirementKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Requirement Kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static RequirementKind getByName(String name)
    {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			RequirementKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Requirement Kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static RequirementKind get(int value)
    {
		switch (value) {
			case FUNCTIONAL: return FUNCTIONAL_LITERAL;
			case PERFORMANCE: return PERFORMANCE_LITERAL;
			case INTERFACE: return INTERFACE_LITERAL;
		}
		return null;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final int value;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String name;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String literal;

    /**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    private RequirementKind(int value, String name, String literal)
    {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public int getValue()
    {
	  return value;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName()
    {
	  return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getLiteral()
    {
	  return literal;
	}

    /**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString()
    {
		return literal;
	}
}
