/**
 * <copyright> </copyright>
 * 
 * $Id: VerdictKind.java,v 1.2 2007-05-22 08:52:40 tlandre Exp $
 */
package org.topcased.sysml;

import static org.topcased.sysml.VerdictKind.ERROR;
import static org.topcased.sysml.VerdictKind.FAIL;
import static org.topcased.sysml.VerdictKind.INCONCLUSIVE;
import static org.topcased.sysml.VerdictKind.PASS;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em> < ? >Verdict Kind</b></em>',
 * and utility methods for working with them. <!-- end-user-doc -->
 * @see org.topcased.sysml.SysMLPackage#getVerdictKind()
 * @model
 * @generated
 */
public enum VerdictKind implements Enumerator {
    /**
	 * The '<em><b>Pass</b></em>' literal object.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #PASS
	 * @generated
	 * @ordered
	 */
    PASS_LITERAL(0, "Pass", "Pass"),
    /**
	 * The '<em><b>Fail</b></em>' literal object.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #FAIL
	 * @generated
	 * @ordered
	 */
    FAIL_LITERAL(1, "Fail", "Fail"),
    /**
     * The '<em> < ? >Inconclusive</b></em>' literal object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #INCONCLUSIVE
     * @generated
     * @ordered
     */
    INCONCLUSIVE_LITERAL(2, "Inconclusive", "Inconclusive"),
    /**
	 * The '<em><b>Error</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #ERROR
	 * @generated
	 * @ordered
	 */
    ERROR_LITERAL(3, "Error", "Error");
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * The '<em><b>Pass</b></em>' literal value.
	 * <!-- begin-user-doc --> < ? >
     * If the meaning of '<em> < ? >Pass</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #PASS_LITERAL
	 * @model name="Pass"
	 *        annotation="http://www.topcased.org/uuid uuid='1141307207468112'"
	 * @generated
	 * @ordered
	 */
    public static final int PASS = 0;

    /**
	 * The '<em><b>Fail</b></em>' literal value.
	 * <!-- begin-user-doc --> < ? >
     * If the meaning of '<em> < ? >Fail</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #FAIL_LITERAL
	 * @model name="Fail"
	 *        annotation="http://www.topcased.org/uuid uuid='1141307207484113'"
	 * @generated
	 * @ordered
	 */
    public static final int FAIL = 1;

    /**
     * The '<em> < ? >Inconclusive</b></em>' literal value. <!--
     * begin-user-doc --> < ? > If the meaning of '<em> < ? >Inconclusive</b></em>'
     * literal object isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #INCONCLUSIVE_LITERAL
     * @model name="Inconclusive" annotation="http://www.topcased.org/uuid
     *        uuid='1141307207515114'"
     * @generated
     * @ordered
     */
    public static final int INCONCLUSIVE = 2;

    /**
	 * The '<em><b>Error</b></em>' literal value.
	 * <!-- begin-user-doc --> < ? >
     * If the meaning of '<em> < ? >Error</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #ERROR_LITERAL
	 * @model name="Error"
	 *        annotation="http://www.topcased.org/uuid uuid='1141307207531115'"
	 * @generated
	 * @ordered
	 */
    public static final int ERROR = 3;

    /**
	 * An array of all the '<em><b>Verdict Kind</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private static final VerdictKind[] VALUES_ARRAY = new VerdictKind[] {
			PASS_LITERAL,
			FAIL_LITERAL,
			INCONCLUSIVE_LITERAL,
			ERROR_LITERAL,
		};

    /**
	 * A public read-only list of all the '<em><b>Verdict Kind</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final List<VerdictKind> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
	 * Returns the '<em><b>Verdict Kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static VerdictKind get(String literal)
    {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			VerdictKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Verdict Kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static VerdictKind getByName(String name)
    {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			VerdictKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Verdict Kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static VerdictKind get(int value)
    {
		switch (value) {
			case PASS: return PASS_LITERAL;
			case FAIL: return FAIL_LITERAL;
			case INCONCLUSIVE: return INCONCLUSIVE_LITERAL;
			case ERROR: return ERROR_LITERAL;
		}
		return null;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final int value;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String name;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String literal;

    /**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    private VerdictKind(int value, String name, String literal)
    {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public int getValue()
    {
	  return value;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName()
    {
	  return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getLiteral()
    {
	  return literal;
	}

    /**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString()
    {
		return literal;
	}
}
