/**
 * <copyright> </copyright>
 * 
 * $Id: VerifyMethodKind.java,v 1.2 2007-05-22 08:51:26 tlandre Exp $
 */
package org.topcased.sysml;

import static org.topcased.sysml.VerifyMethodKind.ANALYSIS;
import static org.topcased.sysml.VerifyMethodKind.DEMONSTRATION;
import static org.topcased.sysml.VerifyMethodKind.INSPECTION;
import static org.topcased.sysml.VerifyMethodKind.TEST;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '<em> < ? >Verify Method Kind</b></em>',
 * and utility methods for working with them. <!-- end-user-doc -->
 * @see org.topcased.sysml.SysMLPackage#getVerifyMethodKind()
 * @model
 * @generated
 */
public enum VerifyMethodKind implements Enumerator {
    /**
	 * The '<em><b>Analysis</b></em>' literal object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @see #ANALYSIS
	 * @generated
	 * @ordered
	 */
    ANALYSIS_LITERAL(0, "Analysis", "Analysis"),
    /**
     * The '<em> < ? >Demonstration</b></em>' literal object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #DEMONSTRATION
     * @generated
     * @ordered
     */
    DEMONSTRATION_LITERAL(1, "Demonstration", "Demonstration"),
    /**
     * The '<em> < ? >Inspection</b></em>' literal object. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #INSPECTION
     * @generated
     * @ordered
     */
    INSPECTION_LITERAL(2, "Inspection", "Inspection"),
    /**
	 * The '<em><b>Test</b></em>' literal object.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #TEST
	 * @generated
	 * @ordered
	 */
    TEST_LITERAL(3, "Test", "Test");
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * The '<em><b>Analysis</b></em>' literal value.
	 * <!-- begin-user-doc
     * --> < ? > If the meaning of '<em> < ? >Analysis</b></em>' literal
     * object isn't clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #ANALYSIS_LITERAL
	 * @model name="Analysis"
	 *        annotation="http://www.topcased.org/uuid uuid='114129646150799'"
	 * @generated
	 * @ordered
	 */
    public static final int ANALYSIS = 0;

    /**
     * The '<em> < ? >Demonstration</b></em>' literal value. <!--
     * begin-user-doc --> < ? > If the meaning of '<em> < ? >Demonstration</b></em>'
     * literal object isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #DEMONSTRATION_LITERAL
     * @model name="Demonstration" annotation="http://www.topcased.org/uuid
     *        uuid='1141296461507100'"
     * @generated
     * @ordered
     */
    public static final int DEMONSTRATION = 1;

    /**
     * The '<em> < ? >Inspection</b></em>' literal value. <!--
     * begin-user-doc --> < ? > If the meaning of '<em> < ? >Inspection</b></em>'
     * literal object isn't clear, there really should be more of a description
     * here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @see #INSPECTION_LITERAL
     * @model name="Inspection" annotation="http://www.topcased.org/uuid
     *        uuid='1141296461523101'"
     * @generated
     * @ordered
     */
    public static final int INSPECTION = 2;

    /**
	 * The '<em><b>Test</b></em>' literal value.
	 * <!-- begin-user-doc --> < ? >
     * If the meaning of '<em> < ? >Test</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @see #TEST_LITERAL
	 * @model name="Test"
	 *        annotation="http://www.topcased.org/uuid uuid='1141296461539102'"
	 * @generated
	 * @ordered
	 */
    public static final int TEST = 3;

    /**
	 * An array of all the '<em><b>Verify Method Kind</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private static final VerifyMethodKind[] VALUES_ARRAY = new VerifyMethodKind[] {
			ANALYSIS_LITERAL,
			DEMONSTRATION_LITERAL,
			INSPECTION_LITERAL,
			TEST_LITERAL,
		};

    /**
	 * A public read-only list of all the '<em><b>Verify Method Kind</b></em>' enumerators.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final List<VerifyMethodKind> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
	 * Returns the '<em><b>Verify Method Kind</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static VerifyMethodKind get(String literal)
    {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			VerifyMethodKind result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Verify Method Kind</b></em>' literal with the specified name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static VerifyMethodKind getByName(String name)
    {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			VerifyMethodKind result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

    /**
	 * Returns the '<em><b>Verify Method Kind</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static VerifyMethodKind get(int value)
    {
		switch (value) {
			case ANALYSIS: return ANALYSIS_LITERAL;
			case DEMONSTRATION: return DEMONSTRATION_LITERAL;
			case INSPECTION: return INSPECTION_LITERAL;
			case TEST: return TEST_LITERAL;
		}
		return null;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final int value;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String name;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    private final String literal;

    /**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    private VerifyMethodKind(int value, String name, String literal)
    {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public int getValue()
    {
	  return value;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getName()
    {
	  return name;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String getLiteral()
    {
	  return literal;
	}

    /**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString()
    {
		return literal;
	}
}
