package org.topcased.sysml.impl;

import java.util.List;

import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.internal.operations.PropertyOperations;
import org.topcased.sysml.BlockProperty;

public class BlockPropertyOperations extends PropertyOperations
{

    public static void setIsNavigable(BlockProperty property, boolean navigable)
    {

        if (null == property)
        {
            throw new IllegalArgumentException(String.valueOf(property));
        }

        Association association = property.getAssociation();

        if (null == association || !association.isBinary())
        {
            throw new IllegalArgumentException(String.valueOf(property));
        }
        if (navigable != isNavigable(property))
        {

            if (navigable)
            {
                List ownedAttributes = getOwnedAttributes(getOtherEnd(property).getType());

                if (null == ownedAttributes)
                {
                    throw new IllegalArgumentException(String.valueOf(navigable));
                }
                else
                {
                    ownedAttributes.add(property);
                }
            }
            else
            {
                association.getOwnedEnds().add(property);
            }
        }
    }
}
