/**
 * <copyright> </copyright>
 * 
 * $Id: FlowPortImpl.java,v 1.2 2007-05-22 08:45:40 tlandre Exp $
 */
package org.topcased.sysml.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreEList;
import org.eclipse.uml2.uml.ConnectableElement;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.internal.impl.PortImpl;
import org.topcased.sysml.Block;
import org.topcased.sysml.FlowDirectionKind;
import org.topcased.sysml.FlowPort;
import org.topcased.sysml.FlowSpecification;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.util.SysMLUtils;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em> < ? >Flow Port</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.topcased.sysml.impl.FlowPortImpl#getDirection <em>Direction</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.FlowPortImpl#isIsConjugated <em>Is Conjugated</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.FlowPortImpl#isIsAtomic <em>Is Atomic</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FlowPortImpl extends PortImpl implements FlowPort
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * The default value of the '{@link #getDirection() <em>Direction</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDirection()
	 * @generated
	 * @ordered
	 */
    protected static final FlowDirectionKind DIRECTION_EDEFAULT = FlowDirectionKind.INOUT_LITERAL;

    /**
	 * The cached value of the '{@link #getDirection() <em>Direction</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDirection()
	 * @generated
	 * @ordered
	 */
    protected FlowDirectionKind direction = DIRECTION_EDEFAULT;

    /**
	 * The default value of the '{@link #isIsConjugated() <em>Is Conjugated</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isIsConjugated()
	 * @generated
	 * @ordered
	 */
    protected static final boolean IS_CONJUGATED_EDEFAULT = false;

    /**
	 * The cached value of the '{@link #isIsConjugated() <em>Is Conjugated</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isIsConjugated()
	 * @generated
	 * @ordered
	 */
    protected boolean isConjugated = IS_CONJUGATED_EDEFAULT;

    /**
	 * The default value of the '{@link #isIsAtomic() <em>Is Atomic</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isIsAtomic()
	 * @generated
	 * @ordered
	 */
    protected static final boolean IS_ATOMIC_EDEFAULT = true;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected FlowPortImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass()
    {
		return SysMLPackage.Literals.FLOW_PORT;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public FlowDirectionKind getDirection()
    {
		return direction;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setDirection(FlowDirectionKind newDirection)
    {
		FlowDirectionKind oldDirection = direction;
		direction = newDirection == null ? DIRECTION_EDEFAULT : newDirection;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SysMLPackage.FLOW_PORT__DIRECTION, oldDirection, direction));
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public boolean isIsConjugated()
    {
		return isConjugated;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void setIsConjugated(boolean newIsConjugated)
    {
		boolean oldIsConjugated = isConjugated;
		isConjugated = newIsConjugated;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SysMLPackage.FLOW_PORT__IS_CONJUGATED, oldIsConjugated, isConjugated));
	}

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public boolean isIsAtomic()
    {
        if (type instanceof FlowSpecification)
            return false;

        else if (type instanceof Block || type instanceof Signal || type instanceof DataType)
            return true;

        // IsAtomic value cannot be computed
        return IS_ATOMIC_EDEFAULT;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public boolean validateConnectedPortsCompatibility()
    {
        EList connectedElts = SysMLUtils.getConnectedElements(this);
        for (int i = 0; i < connectedElts.size(); i++)
        {
            ConnectableElement connectedElt = (ConnectableElement) connectedElts.get(i);
            if (connectedElt instanceof FlowPort)
            {
                boolean valid = SysMLUtils.validateFlowPortsCompatibility(this, (FlowPort) connectedElt);
                if (!valid)
                    return false;
            }
            else
            {
                return false;
            }
        }
        return true;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public boolean validateType()
    {
        return (type instanceof FlowSpecification || type instanceof Block || type instanceof Signal || type instanceof DataType);
    }

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
		switch (featureID) {
			case SysMLPackage.FLOW_PORT__DIRECTION:
				return getDirection();
			case SysMLPackage.FLOW_PORT__IS_CONJUGATED:
				return isIsConjugated() ? Boolean.TRUE : Boolean.FALSE;
			case SysMLPackage.FLOW_PORT__IS_ATOMIC:
				return isIsAtomic() ? Boolean.TRUE : Boolean.FALSE;
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue)
    {
		switch (featureID) {
			case SysMLPackage.FLOW_PORT__DIRECTION:
				setDirection((FlowDirectionKind)newValue);
				return;
			case SysMLPackage.FLOW_PORT__IS_CONJUGATED:
				setIsConjugated(((Boolean)newValue).booleanValue());
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID)
    {
		switch (featureID) {
			case SysMLPackage.FLOW_PORT__DIRECTION:
				setDirection(DIRECTION_EDEFAULT);
				return;
			case SysMLPackage.FLOW_PORT__IS_CONJUGATED:
				setIsConjugated(IS_CONJUGATED_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID)
    {
		switch (featureID) {
			case SysMLPackage.FLOW_PORT__DIRECTION:
				return direction != DIRECTION_EDEFAULT;
			case SysMLPackage.FLOW_PORT__IS_CONJUGATED:
				return isConjugated != IS_CONJUGATED_EDEFAULT;
			case SysMLPackage.FLOW_PORT__IS_ATOMIC:
				return isIsAtomic() != IS_ATOMIC_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString()
    {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (direction: ");
		result.append(direction);
		result.append(", isConjugated: ");
		result.append(isConjugated);
		result.append(')');
		return result.toString();
	}

    /**
     * @see org.eclipse.uml2.Port#getProvideds()
     */
    public EList getProvideds()
    {
        // No provided interfaces for a flow port
        return new EcoreEList.UnmodifiableEList(this, UMLPackage.eINSTANCE.getPort_Provided(), 0, null);
    }

    /**
     * @see org.eclipse.uml2.Port#getRequireds()
     */
    public EList getRequireds()
    {
        // No required interfaces for a flow port
        return new EcoreEList.UnmodifiableEList(this, UMLPackage.eINSTANCE.getPort_Required(), 0, null);
    }

} // FlowPortImpl
