/**
 * <copyright> </copyright>
 * 
 * $Id: PackageSYSMLImpl.java,v 1.3 2007-06-22 08:51:20 tlandre Exp $
 */
package org.topcased.sysml.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.GeneralizationSet;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.Relationship;
import org.eclipse.uml2.uml.internal.impl.PackageImpl;
import org.topcased.sysml.Block;
import org.topcased.sysml.BlockDefinition;
import org.topcased.sysml.ItemFlow;
import org.topcased.sysml.PackageSYSML;
import org.topcased.sysml.Requirement;
import org.topcased.sysml.RequirementDefinition;
import org.topcased.sysml.Satisfy;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.TestCase;
import org.topcased.sysml.Trace;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em> < ? >Package SYSML</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedBlockDefinition <em>Owned Block Definition</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedRequirementDefinition <em>Owned Requirement Definition</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedSatisfy <em>Owned Satisfy</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedTestCase <em>Owned Test Case</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedTraceDependency <em>Owned Trace Dependency</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedRequirement <em>Owned Requirement</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedItemFlow <em>Owned Item Flow</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedInterfaces <em>Owned Interfaces</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedGenSet <em>Owned Gen Set</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedActors <em>Owned Actors</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedBlocks <em>Owned Blocks</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedDataTypes <em>Owned Data Types</em>}</li>
 *   <li>{@link org.topcased.sysml.impl.PackageSYSMLImpl#getOwnedRelationships <em>Owned Relationships</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class PackageSYSMLImpl extends PackageImpl implements PackageSYSML
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * The cached value of the '{@link #getOwnedBlockDefinition() <em>Owned Block Definition</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getOwnedBlockDefinition()
	 * @generated
	 * @ordered
	 */
    protected EList<BlockDefinition> ownedBlockDefinition;

    /**
	 * The cached value of the '{@link #getOwnedRequirementDefinition() <em>Owned Requirement Definition</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getOwnedRequirementDefinition()
	 * @generated
	 * @ordered
	 */
    protected EList<RequirementDefinition> ownedRequirementDefinition;

    /**
	 * The cached value of the '{@link #getOwnedSatisfy() <em>Owned Satisfy</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedSatisfy()
	 * @generated
	 * @ordered
	 */
	protected EList<Satisfy> ownedSatisfy;

				/**
	 * The cached value of the '{@link #getOwnedTestCase() <em>Owned Test Case</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedTestCase()
	 * @generated
	 * @ordered
	 */
	protected EList<TestCase> ownedTestCase;

				/**
	 * The cached value of the '{@link #getOwnedTraceDependency() <em>Owned Trace Dependency</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedTraceDependency()
	 * @generated
	 * @ordered
	 */
	protected EList<Trace> ownedTraceDependency;

				/**
	 * The cached value of the '{@link #getOwnedRequirement() <em>Owned Requirement</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedRequirement()
	 * @generated
	 * @ordered
	 */
	protected EList<Requirement> ownedRequirement;

				/**
	 * The cached value of the '{@link #getOwnedItemFlow() <em>Owned Item Flow</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedItemFlow()
	 * @generated
	 * @ordered
	 */
	protected EList<ItemFlow> ownedItemFlow;

				/**
	 * The cached value of the '{@link #getOwnedInterfaces() <em>Owned Interfaces</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedInterfaces()
	 * @generated
	 * @ordered
	 */
	protected EList<Interface> ownedInterfaces;

				/**
	 * The cached value of the '{@link #getOwnedGenSet() <em>Owned Gen Set</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedGenSet()
	 * @generated
	 * @ordered
	 */
	protected EList<GeneralizationSet> ownedGenSet;

				/**
	 * The cached value of the '{@link #getOwnedActors() <em>Owned Actors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedActors()
	 * @generated
	 * @ordered
	 */
	protected EList<Actor> ownedActors;

				/**
	 * The cached value of the '{@link #getOwnedBlocks() <em>Owned Blocks</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedBlocks()
	 * @generated
	 * @ordered
	 */
	protected EList<Block> ownedBlocks;

				/**
	 * The cached value of the '{@link #getOwnedDataTypes() <em>Owned Data Types</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedDataTypes()
	 * @generated
	 * @ordered
	 */
	protected EList<DataType> ownedDataTypes;

				/**
	 * The cached value of the '{@link #getOwnedRelationships() <em>Owned Relationships</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOwnedRelationships()
	 * @generated
	 * @ordered
	 */
	protected EList<Relationship> ownedRelationships;

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected PackageSYSMLImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass()
    {
		return SysMLPackage.Literals.PACKAGE_SYSML;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<BlockDefinition> getOwnedBlockDefinition()
    {
		if (ownedBlockDefinition == null) {
			ownedBlockDefinition = new EObjectContainmentEList<BlockDefinition>(BlockDefinition.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_BLOCK_DEFINITION);
		}
		return ownedBlockDefinition;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public EList<RequirementDefinition> getOwnedRequirementDefinition()
    {
		if (ownedRequirementDefinition == null) {
			ownedRequirementDefinition = new EObjectContainmentEList<RequirementDefinition>(RequirementDefinition.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT_DEFINITION);
		}
		return ownedRequirementDefinition;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Satisfy> getOwnedSatisfy() {
		if (ownedSatisfy == null) {
			ownedSatisfy = new EObjectContainmentEList<Satisfy>(Satisfy.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_SATISFY);
		}
		return ownedSatisfy;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TestCase> getOwnedTestCase() {
		if (ownedTestCase == null) {
			ownedTestCase = new EObjectContainmentEList<TestCase>(TestCase.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_TEST_CASE);
		}
		return ownedTestCase;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Trace> getOwnedTraceDependency() {
		if (ownedTraceDependency == null) {
			ownedTraceDependency = new EObjectContainmentEList<Trace>(Trace.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_TRACE_DEPENDENCY);
		}
		return ownedTraceDependency;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Requirement> getOwnedRequirement() {
		if (ownedRequirement == null) {
			ownedRequirement = new EObjectContainmentEList<Requirement>(Requirement.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT);
		}
		return ownedRequirement;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ItemFlow> getOwnedItemFlow() {
		if (ownedItemFlow == null) {
			ownedItemFlow = new EObjectContainmentEList<ItemFlow>(ItemFlow.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_ITEM_FLOW);
		}
		return ownedItemFlow;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Interface> getOwnedInterfaces() {
		if (ownedInterfaces == null) {
			ownedInterfaces = new EObjectContainmentEList<Interface>(Interface.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_INTERFACES);
		}
		return ownedInterfaces;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GeneralizationSet> getOwnedGenSet() {
		if (ownedGenSet == null) {
			ownedGenSet = new EObjectContainmentEList<GeneralizationSet>(GeneralizationSet.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_GEN_SET);
		}
		return ownedGenSet;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Actor> getOwnedActors() {
		if (ownedActors == null) {
			ownedActors = new EObjectContainmentEList<Actor>(Actor.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_ACTORS);
		}
		return ownedActors;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Block> getOwnedBlocks() {
		if (ownedBlocks == null) {
			ownedBlocks = new EObjectContainmentEList<Block>(Block.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_BLOCKS);
		}
		return ownedBlocks;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DataType> getOwnedDataTypes() {
		if (ownedDataTypes == null) {
			ownedDataTypes = new EObjectContainmentEList<DataType>(DataType.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_DATA_TYPES);
		}
		return ownedDataTypes;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relationship> getOwnedRelationships() {
		if (ownedRelationships == null) {
			ownedRelationships = new EObjectContainmentEList<Relationship>(Relationship.class, this, SysMLPackage.PACKAGE_SYSML__OWNED_RELATIONSHIPS);
		}
		return ownedRelationships;
	}

				/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCK_DEFINITION:
				return ((InternalEList<?>)getOwnedBlockDefinition()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT_DEFINITION:
				return ((InternalEList<?>)getOwnedRequirementDefinition()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_SATISFY:
				return ((InternalEList<?>)getOwnedSatisfy()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_TEST_CASE:
				return ((InternalEList<?>)getOwnedTestCase()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_TRACE_DEPENDENCY:
				return ((InternalEList<?>)getOwnedTraceDependency()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT:
				return ((InternalEList<?>)getOwnedRequirement()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_ITEM_FLOW:
				return ((InternalEList<?>)getOwnedItemFlow()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_INTERFACES:
				return ((InternalEList<?>)getOwnedInterfaces()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_GEN_SET:
				return ((InternalEList<?>)getOwnedGenSet()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_ACTORS:
				return ((InternalEList<?>)getOwnedActors()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCKS:
				return ((InternalEList<?>)getOwnedBlocks()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_DATA_TYPES:
				return ((InternalEList<?>)getOwnedDataTypes()).basicRemove(otherEnd, msgs);
			case SysMLPackage.PACKAGE_SYSML__OWNED_RELATIONSHIPS:
				return ((InternalEList<?>)getOwnedRelationships()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
		switch (featureID) {
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCK_DEFINITION:
				return getOwnedBlockDefinition();
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT_DEFINITION:
				return getOwnedRequirementDefinition();
			case SysMLPackage.PACKAGE_SYSML__OWNED_SATISFY:
				return getOwnedSatisfy();
			case SysMLPackage.PACKAGE_SYSML__OWNED_TEST_CASE:
				return getOwnedTestCase();
			case SysMLPackage.PACKAGE_SYSML__OWNED_TRACE_DEPENDENCY:
				return getOwnedTraceDependency();
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT:
				return getOwnedRequirement();
			case SysMLPackage.PACKAGE_SYSML__OWNED_ITEM_FLOW:
				return getOwnedItemFlow();
			case SysMLPackage.PACKAGE_SYSML__OWNED_INTERFACES:
				return getOwnedInterfaces();
			case SysMLPackage.PACKAGE_SYSML__OWNED_GEN_SET:
				return getOwnedGenSet();
			case SysMLPackage.PACKAGE_SYSML__OWNED_ACTORS:
				return getOwnedActors();
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCKS:
				return getOwnedBlocks();
			case SysMLPackage.PACKAGE_SYSML__OWNED_DATA_TYPES:
				return getOwnedDataTypes();
			case SysMLPackage.PACKAGE_SYSML__OWNED_RELATIONSHIPS:
				return getOwnedRelationships();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue)
    {
		switch (featureID) {
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCK_DEFINITION:
				getOwnedBlockDefinition().clear();
				getOwnedBlockDefinition().addAll((Collection<? extends BlockDefinition>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT_DEFINITION:
				getOwnedRequirementDefinition().clear();
				getOwnedRequirementDefinition().addAll((Collection<? extends RequirementDefinition>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_SATISFY:
				getOwnedSatisfy().clear();
				getOwnedSatisfy().addAll((Collection<? extends Satisfy>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_TEST_CASE:
				getOwnedTestCase().clear();
				getOwnedTestCase().addAll((Collection<? extends TestCase>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_TRACE_DEPENDENCY:
				getOwnedTraceDependency().clear();
				getOwnedTraceDependency().addAll((Collection<? extends Trace>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT:
				getOwnedRequirement().clear();
				getOwnedRequirement().addAll((Collection<? extends Requirement>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_ITEM_FLOW:
				getOwnedItemFlow().clear();
				getOwnedItemFlow().addAll((Collection<? extends ItemFlow>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_INTERFACES:
				getOwnedInterfaces().clear();
				getOwnedInterfaces().addAll((Collection<? extends Interface>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_GEN_SET:
				getOwnedGenSet().clear();
				getOwnedGenSet().addAll((Collection<? extends GeneralizationSet>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_ACTORS:
				getOwnedActors().clear();
				getOwnedActors().addAll((Collection<? extends Actor>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCKS:
				getOwnedBlocks().clear();
				getOwnedBlocks().addAll((Collection<? extends Block>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_DATA_TYPES:
				getOwnedDataTypes().clear();
				getOwnedDataTypes().addAll((Collection<? extends DataType>)newValue);
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_RELATIONSHIPS:
				getOwnedRelationships().clear();
				getOwnedRelationships().addAll((Collection<? extends Relationship>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID)
    {
		switch (featureID) {
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCK_DEFINITION:
				getOwnedBlockDefinition().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT_DEFINITION:
				getOwnedRequirementDefinition().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_SATISFY:
				getOwnedSatisfy().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_TEST_CASE:
				getOwnedTestCase().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_TRACE_DEPENDENCY:
				getOwnedTraceDependency().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT:
				getOwnedRequirement().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_ITEM_FLOW:
				getOwnedItemFlow().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_INTERFACES:
				getOwnedInterfaces().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_GEN_SET:
				getOwnedGenSet().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_ACTORS:
				getOwnedActors().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCKS:
				getOwnedBlocks().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_DATA_TYPES:
				getOwnedDataTypes().clear();
				return;
			case SysMLPackage.PACKAGE_SYSML__OWNED_RELATIONSHIPS:
				getOwnedRelationships().clear();
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID)
    {
		switch (featureID) {
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCK_DEFINITION:
				return ownedBlockDefinition != null && !ownedBlockDefinition.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT_DEFINITION:
				return ownedRequirementDefinition != null && !ownedRequirementDefinition.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_SATISFY:
				return ownedSatisfy != null && !ownedSatisfy.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_TEST_CASE:
				return ownedTestCase != null && !ownedTestCase.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_TRACE_DEPENDENCY:
				return ownedTraceDependency != null && !ownedTraceDependency.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_REQUIREMENT:
				return ownedRequirement != null && !ownedRequirement.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_ITEM_FLOW:
				return ownedItemFlow != null && !ownedItemFlow.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_INTERFACES:
				return ownedInterfaces != null && !ownedInterfaces.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_GEN_SET:
				return ownedGenSet != null && !ownedGenSet.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_ACTORS:
				return ownedActors != null && !ownedActors.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_BLOCKS:
				return ownedBlocks != null && !ownedBlocks.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_DATA_TYPES:
				return ownedDataTypes != null && !ownedDataTypes.isEmpty();
			case SysMLPackage.PACKAGE_SYSML__OWNED_RELATIONSHIPS:
				return ownedRelationships != null && !ownedRelationships.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} // PackageSYSMLImpl
