/**
 * <copyright> </copyright>
 * 
 * $Id: SysMLFactoryImpl.java,v 1.2 2007-05-22 08:45:22 tlandre Exp $
 */
package org.topcased.sysml.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.topcased.sysml.Block;
import org.topcased.sysml.BlockDefinition;
import org.topcased.sysml.BlockProperty;
import org.topcased.sysml.ConstraintBlock;
import org.topcased.sysml.ConstraintProperty;
import org.topcased.sysml.Containment;
import org.topcased.sysml.Copy;
import org.topcased.sysml.DeriveReqt;
import org.topcased.sysml.Dimension;
import org.topcased.sysml.DistributedProperty;
import org.topcased.sysml.Field;
import org.topcased.sysml.FlowDirectionKind;
import org.topcased.sysml.FlowPort;
import org.topcased.sysml.FlowProperty;
import org.topcased.sysml.FlowSpecification;
import org.topcased.sysml.ItemFlow;
import org.topcased.sysml.ModelSYSML;
import org.topcased.sysml.PackageSYSML;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.Refine;
import org.topcased.sysml.Requirement;
import org.topcased.sysml.RequirementDefinition;
import org.topcased.sysml.RequirementKind;
import org.topcased.sysml.RequirementRelated;
import org.topcased.sysml.RiskKind;
import org.topcased.sysml.Satisfy;
import org.topcased.sysml.ServicePort;
import org.topcased.sysml.SysMLFactory;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.TestCase;
import org.topcased.sysml.Trace;
import org.topcased.sysml.Unit;
import org.topcased.sysml.ValueType;
import org.topcased.sysml.VerdictKind;
import org.topcased.sysml.Verify;
import org.topcased.sysml.VerifyMethodKind;

/**
 * <!-- begin-user-doc --> An implementation of the model  < ? >Factory</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class SysMLFactoryImpl extends EFactoryImpl implements SysMLFactory
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public static SysMLFactory init()
    {
		try {
			SysMLFactory theSysMLFactory = (SysMLFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.topcased.org/1.0/sysML"); 
			if (theSysMLFactory != null) {
				return theSysMLFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new SysMLFactoryImpl();
	}

    /**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public SysMLFactoryImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public EObject create(EClass eClass)
    {
		switch (eClass.getClassifierID()) {
			case SysMLPackage.BLOCK: return createBlock();
			case SysMLPackage.FLOW_PORT: return createFlowPort();
			case SysMLPackage.SERVICE_PORT: return createServicePort();
			case SysMLPackage.FLOW_SPECIFICATION: return createFlowSpecification();
			case SysMLPackage.BLOCK_DEFINITION: return createBlockDefinition();
			case SysMLPackage.PACKAGE_SYSML: return createPackageSYSML();
			case SysMLPackage.REQUIREMENT: return createRequirement();
			case SysMLPackage.TEST_CASE: return createTestCase();
			case SysMLPackage.REQUIREMENT_DEFINITION: return createRequirementDefinition();
			case SysMLPackage.SATISFY: return createSatisfy();
			case SysMLPackage.DERIVE_REQT: return createDeriveReqt();
			case SysMLPackage.VERIFY: return createVerify();
			case SysMLPackage.FIELD: return createField();
			case SysMLPackage.RATIONALE: return createRationale();
			case SysMLPackage.PROBLEM: return createProblem();
			case SysMLPackage.VALUE_TYPE: return createValueType();
			case SysMLPackage.DIMENSION: return createDimension();
			case SysMLPackage.UNIT: return createUnit();
			case SysMLPackage.BLOCK_PROPERTY: return createBlockProperty();
			case SysMLPackage.DISTRIBUTED_PROPERTY: return createDistributedProperty();
			case SysMLPackage.ITEM_FLOW: return createItemFlow();
			case SysMLPackage.FLOW_PROPERTY: return createFlowProperty();
			case SysMLPackage.CONSTRAINT_BLOCK: return createConstraintBlock();
			case SysMLPackage.TRACE: return createTrace();
			case SysMLPackage.COPY: return createCopy();
			case SysMLPackage.REFINE: return createRefine();
			case SysMLPackage.CONSTRAINT_PROPERTY: return createConstraintProperty();
			case SysMLPackage.CONTAINMENT: return createContainment();
			case SysMLPackage.REQUIREMENT_RELATED: return createRequirementRelated();
			case SysMLPackage.MODEL_SYSML: return createModelSYSML();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object createFromString(EDataType eDataType, String initialValue)
    {
		switch (eDataType.getClassifierID()) {
			case SysMLPackage.REQUIREMENT_KIND:
				return createRequirementKindFromString(eDataType, initialValue);
			case SysMLPackage.RISK_KIND:
				return createRiskKindFromString(eDataType, initialValue);
			case SysMLPackage.VERIFY_METHOD_KIND:
				return createVerifyMethodKindFromString(eDataType, initialValue);
			case SysMLPackage.VERDICT_KIND:
				return createVerdictKindFromString(eDataType, initialValue);
			case SysMLPackage.FLOW_DIRECTION_KIND:
				return createFlowDirectionKindFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String convertToString(EDataType eDataType, Object instanceValue)
    {
		switch (eDataType.getClassifierID()) {
			case SysMLPackage.REQUIREMENT_KIND:
				return convertRequirementKindToString(eDataType, instanceValue);
			case SysMLPackage.RISK_KIND:
				return convertRiskKindToString(eDataType, instanceValue);
			case SysMLPackage.VERIFY_METHOD_KIND:
				return convertVerifyMethodKindToString(eDataType, instanceValue);
			case SysMLPackage.VERDICT_KIND:
				return convertVerdictKindToString(eDataType, instanceValue);
			case SysMLPackage.FLOW_DIRECTION_KIND:
				return convertFlowDirectionKindToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Block createBlock()
    {
		BlockImpl block = new BlockImpl();
		return block;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public FlowPort createFlowPort()
    {
		FlowPortImpl flowPort = new FlowPortImpl();
		return flowPort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ServicePort createServicePort()
    {
		ServicePortImpl servicePort = new ServicePortImpl();
		return servicePort;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public FlowSpecification createFlowSpecification()
    {
		FlowSpecificationImpl flowSpecification = new FlowSpecificationImpl();
		return flowSpecification;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public BlockDefinition createBlockDefinition()
    {
		BlockDefinitionImpl blockDefinition = new BlockDefinitionImpl();
		return blockDefinition;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public PackageSYSML createPackageSYSML()
    {
		PackageSYSMLImpl packageSYSML = new PackageSYSMLImpl();
		return packageSYSML;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Requirement createRequirement()
    {
		RequirementImpl requirement = new RequirementImpl();
		return requirement;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public TestCase createTestCase()
    {
		TestCaseImpl testCase = new TestCaseImpl();
		return testCase;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RequirementDefinition createRequirementDefinition()
    {
		RequirementDefinitionImpl requirementDefinition = new RequirementDefinitionImpl();
		return requirementDefinition;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Satisfy createSatisfy()
    {
		SatisfyImpl satisfy = new SatisfyImpl();
		return satisfy;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DeriveReqt createDeriveReqt()
    {
		DeriveReqtImpl deriveReqt = new DeriveReqtImpl();
		return deriveReqt;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Verify createVerify()
    {
		VerifyImpl verify = new VerifyImpl();
		return verify;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Field createField()
    {
		FieldImpl field = new FieldImpl();
		return field;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Rationale createRationale()
    {
		RationaleImpl rationale = new RationaleImpl();
		return rationale;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Problem createProblem()
    {
		ProblemImpl problem = new ProblemImpl();
		return problem;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ValueType createValueType()
    {
		ValueTypeImpl valueType = new ValueTypeImpl();
		return valueType;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Dimension createDimension()
    {
		DimensionImpl dimension = new DimensionImpl();
		return dimension;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Unit createUnit()
    {
		UnitImpl unit = new UnitImpl();
		return unit;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public BlockProperty createBlockProperty()
    {
		BlockPropertyImpl blockProperty = new BlockPropertyImpl();
		return blockProperty;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public DistributedProperty createDistributedProperty()
    {
		DistributedPropertyImpl distributedProperty = new DistributedPropertyImpl();
		return distributedProperty;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ItemFlow createItemFlow()
    {
		ItemFlowImpl itemFlow = new ItemFlowImpl();
		return itemFlow;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public FlowProperty createFlowProperty()
    {
		FlowPropertyImpl flowProperty = new FlowPropertyImpl();
		return flowProperty;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ConstraintBlock createConstraintBlock()
    {
		ConstraintBlockImpl constraintBlock = new ConstraintBlockImpl();
		return constraintBlock;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Trace createTrace()
    {
		TraceImpl trace = new TraceImpl();
		return trace;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Copy createCopy()
    {
		CopyImpl copy = new CopyImpl();
		return copy;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Refine createRefine()
    {
		RefineImpl refine = new RefineImpl();
		return refine;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ConstraintProperty createConstraintProperty()
    {
		ConstraintPropertyImpl constraintProperty = new ConstraintPropertyImpl();
		return constraintProperty;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public Containment createContainment()
    {
		ContainmentImpl containment = new ContainmentImpl();
		return containment;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RequirementRelated createRequirementRelated()
    {
		RequirementRelatedImpl requirementRelated = new RequirementRelatedImpl();
		return requirementRelated;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public ModelSYSML createModelSYSML()
    {
		ModelSYSMLImpl modelSYSML = new ModelSYSMLImpl();
		return modelSYSML;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RequirementKind createRequirementKindFromString(EDataType eDataType, String initialValue)
    {
		RequirementKind result = RequirementKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String convertRequirementKindToString(EDataType eDataType, Object instanceValue)
    {
		return instanceValue == null ? null : instanceValue.toString();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public RiskKind createRiskKindFromString(EDataType eDataType, String initialValue)
    {
		RiskKind result = RiskKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String convertRiskKindToString(EDataType eDataType, Object instanceValue)
    {
		return instanceValue == null ? null : instanceValue.toString();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public VerifyMethodKind createVerifyMethodKindFromString(EDataType eDataType, String initialValue)
    {
		VerifyMethodKind result = VerifyMethodKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String convertVerifyMethodKindToString(EDataType eDataType, Object instanceValue)
    {
		return instanceValue == null ? null : instanceValue.toString();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public VerdictKind createVerdictKindFromString(EDataType eDataType, String initialValue)
    {
		VerdictKind result = VerdictKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String convertVerdictKindToString(EDataType eDataType, Object instanceValue)
    {
		return instanceValue == null ? null : instanceValue.toString();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public FlowDirectionKind createFlowDirectionKindFromString(EDataType eDataType, String initialValue)
    {
		FlowDirectionKind result = FlowDirectionKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public String convertFlowDirectionKindToString(EDataType eDataType, Object instanceValue)
    {
		return instanceValue == null ? null : instanceValue.toString();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public SysMLPackage getSysMLPackage()
    {
		return (SysMLPackage)getEPackage();
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
    @Deprecated
    public static SysMLPackage getPackage()
    {
		return SysMLPackage.eINSTANCE;
	}

} // SysMLFactoryImpl
