/**
 * <copyright> </copyright>
 * 
 * $Id: BlockPropertyItemProvider.java,v 1.3 2007-06-20 14:27:29 tlandre Exp $
 */
package org.topcased.sysml.provider;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.common.util.UniqueEList;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.uml2.common.util.UML2Util;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.edit.providers.PropertyItemProvider;
import org.eclipse.uml2.uml.util.UMLUtil;
import org.topcased.sysml.BlockProperty;

/**
 * This is the item provider adapter for a {@link org.topcased.sysml.BlockProperty} object.
 * <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * @generated
 */
public class BlockPropertyItemProvider extends PropertyItemProvider implements IEditingDomainItemProvider,
        IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public BlockPropertyItemProvider(AdapterFactory adapterFactory)
    {
		super(adapterFactory);
	}

    /**
     * This returns the property descriptors for the adapted class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
    {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

    /**
     * This returns BlockProperty.gif. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Object getImage(Object object)
    {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/BlockProperty"));
	}

    /**
     * This returns the label text for the adapted class. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public String getText(Object object)
    {
//        return appendLabel(appendType(appendKeywords(new StringBuffer(), object), "_UI_BlockProperty_type"), object).toString(); //$NON-NLS-1$
		StringBuffer text = appendType(appendKeywords(new StringBuffer(),
				object), "_UI_BlockProperty_type"); //$NON-NLS-1$

			BlockProperty blockproperty = (BlockProperty) object;
			Type type = blockproperty.getType();

			if (blockproperty.isDerived()) {
				appendString(text, "/"); //$NON-NLS-1$
			}

			String label = blockproperty.getLabel(shouldTranslate());

			if (!UML2Util.isEmpty(label)) {
				appendString(text, label);
			} else if (blockproperty.getAssociation() != null && type != null) {
				String typeName = type.getName();

				if (!UML2Util.isEmpty(typeName)) {
					appendString(text, Character.toLowerCase(typeName.charAt(0))
						+ typeName.substring(1));
				}
			}

			if (type != null) {
				String typeLabel = type.getLabel(shouldTranslate());

				if (!UMLUtil.isEmpty(typeLabel)) {
					appendString(text, ": " + typeLabel); //$NON-NLS-1$
				}
			}

			return text.toString();
    }

    /**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    @Override
    public void notifyChanged(Notification notification)
    {
		updateChildren(notification);
		super.notifyChanged(notification);
	}

    /**
     * This adds to the collection of
     * {@link org.eclipse.emf.edit.command.CommandParameter}s describing all of
     * the children that can be created under this object. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object)
    {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        removeQualifierChildDescriptors(newChildDescriptors);
    }

    /**
     * This returns the label text for
     * {@link org.eclipse.emf.edit.command.CreateChildCommand}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection)
    {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == UMLPackage.Literals.NAMED_ELEMENT__NAME_EXPRESSION ||
			childFeature == UMLPackage.Literals.MULTIPLICITY_ELEMENT__UPPER_VALUE ||
			childFeature == UMLPackage.Literals.MULTIPLICITY_ELEMENT__LOWER_VALUE ||
			childFeature == UMLPackage.Literals.PROPERTY__DEFAULT_VALUE;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

    /**
     * Return the resource locator for this item provider's resources. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator()
    {
		return SysMLEditPlugin.INSTANCE;
	}

    private void removeQualifierChildDescriptors(Collection childDescriptors)
    {
        EList toRemove = new UniqueEList();
        for (Iterator it = childDescriptors.iterator(); it.hasNext();)
        {
            CommandParameter cp = (CommandParameter) it.next();
            if (cp.feature.equals(UMLPackage.Literals.PROPERTY__QUALIFIER))
                toRemove.add(cp);
        }
        childDescriptors.removeAll(toRemove);
    }
}
