/**
 * <copyright> </copyright>
 * 
 * $Id: ContainmentItemProvider.java,v 1.4 2007-06-22 08:51:20 tlandre Exp $
 */
package org.topcased.sysml.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.edit.providers.DependencyItemProvider;
import org.topcased.sysml.Block;
import org.topcased.sysml.Containment;
import org.topcased.sysml.PackageSYSML;
import org.topcased.sysml.Requirement;


/**
 * This is the item provider adapter for a {@link org.topcased.sysml.Containment} object.
 * <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * @generated
 */
public class ContainmentItemProvider extends DependencyItemProvider implements IEditingDomainItemProvider,
        IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource
{

    private EObject oldContainer;

    private EReference oldReference;

    private Element targetObject;

    private Element sourceObject;

    private Element finalObject;

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
     * This constructs an instance from a factory and a notifier. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public ContainmentItemProvider(AdapterFactory adapterFactory)
    {
		super(adapterFactory);
	}

    /**
     * This returns the property descriptors for the adapted class. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
    {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

    /**
     * This returns Containment.gif. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public Object getImage(Object object)
    {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Containment"));
	}

    /**
     * This returns the label text for the adapted class. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    @Override
    public String getText(Object object)
    {
        return appendLabel(appendType(appendKeywords(new StringBuffer(), object), "_UI_Containment_type"), object).toString(); //$NON-NLS-1$
    }

    /**
     * This handles model notifications by calling {@link #updateChildren} to
     * update any cached children and by creating a viewer notification, which
     * it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated NOT
     */
    @Override
    public void notifyChanged(Notification notification)
    {
        updateChildren(notification);
        // If it is a DELETE Event
        if (notification.getEventType() == 4)
        {
            Containment containObject = (Containment) notification.getNotifier();
            targetObject = (Element) containObject.getSupplier(null);
            if (targetObject != null)
            {
                if (targetObject.getOwner() != null)
                {
                    sourceObject = (Element) targetObject.getOwner();
                    finalObject = sourceObject;
                    do
                    {
                        if (finalObject.getOwner() instanceof PackageSYSML)
                        {
                            oldContainer = finalObject.eContainer();
                            oldReference = finalObject.eContainmentFeature();
                        }
                        finalObject = finalObject.getOwner();

                    }
                    while (oldContainer == null && oldReference == null);
                    // Remove targetObject from sourceObject nested classifiers
                    if(sourceObject instanceof Requirement)
                    {
                        Requirement sourceObjectReq = (Requirement)sourceObject;
                        sourceObjectReq.getNestedClassifiers().remove(targetObject);
                    }
                    else if (sourceObject instanceof Block)
                    {
                        Block sourceObjectBlock = (Block)sourceObject;
                        sourceObjectBlock.getNestedClassifiers().remove(targetObject);
                    }
                   
                    if (oldReference.isMany())
                    {
                        EList containerList = oldContainer.eClass().getEAllStructuralFeatures().contains(oldReference) && oldReference.isMany() ? (EList) oldContainer.eGet(oldReference) : null;
                        if (containerList != null)
                        {
                            containerList.add(targetObject);
                        }
                    }
                    else
                    {
                        oldContainer.eSet(oldReference, targetObject);
                    }
                }
            }
//            else if (targetObject == null)
//            {
//                if (containObject.getClient(null) instanceof Requirement)
//                {
//                    sourceObject = (Requirement) containObject.getClient(null);
//                    Element test2 = sourceObject;
//                    System.out.println(sourceObject.getName().toString());
//                    boolean test = false;
//
//                    // Error here when deleting multiple containment from a
//                    // requirement
//                    while (test2 instanceof Requirement && test == false)
//                    {
//                        System.out.println(((RequirementItemProvider) this.adapterFactory.adapt(test2, test2)).delete);
//                        if (!((RequirementItemProvider) this.adapterFactory.adapt(test2, test2)).delete)
//                        {
//                            test = true;
//                        }
//                        test2 =  test2.getOwner();
//     
//                    }
//                    if (test == false)
//                    {
//                        containObject.destroy();
//                    }
//
//                }
//            }

        }
        // If it is a ADD Event
        if (notification.getEventType() == 3)
        {
            if (sourceObject != null && targetObject != null)
            {
                if(sourceObject instanceof Requirement)
                {
                    Requirement sourceObjectReq = (Requirement)sourceObject;
                    sourceObjectReq.getNestedClassifiers().add((Classifier)targetObject);
                }
                else if (sourceObject instanceof Block)
                {
                    Block sourceObjectBlock = (Block)sourceObject;
                    sourceObjectBlock.getNestedClassifiers().add((Classifier) targetObject);
                }
            }
        }
        super.notifyChanged(notification);
    }

    /**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
    {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

    /**
     * Return the resource locator for this item provider's resources. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator()
    {
		return SysMLEditPlugin.INSTANCE;
	}

}
