/**
 * <copyright> </copyright>
 * 
 * $Id: SysMLItemProviderAdapterFactory.java,v 1.1 2006/10/29 16:16:06
 * fscaravetti Exp $
 */
package org.topcased.sysml.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.uml2.common.edit.provider.IItemQualifiedTextProvider;
import org.eclipse.uml2.uml.edit.providers.UMLItemProviderAdapterFactory;
import org.topcased.sysml.util.SysMLAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * @generated
 */
public class SysMLItemProviderAdapterFactory extends SysMLAdapterFactory implements ComposeableAdapterFactory,
        IChangeNotifier, IDisposable
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement
     * {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    protected Collection<Object> supportedTypes = new ArrayList<Object>();

    /**
     * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated NOT
     */
    public SysMLItemProviderAdapterFactory()
    {
        supportedTypes.add(IEditingDomainItemProvider.class);
        supportedTypes.add(IStructuredItemContentProvider.class);
        supportedTypes.add(ITreeItemContentProvider.class);
        supportedTypes.add(IItemLabelProvider.class);
        supportedTypes.add(IItemPropertySource.class);

        // Added to supported types
        supportedTypes.add(IItemQualifiedTextProvider.class);
    }

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Block} instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    protected BlockItemProvider blockItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Block}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createBlockAdapter()
    {
		if (blockItemProvider == null) {
			blockItemProvider = new BlockItemProvider(this);
		}

		return blockItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.FlowPort} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected FlowPortItemProvider flowPortItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.FlowPort}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createFlowPortAdapter()
    {
		if (flowPortItemProvider == null) {
			flowPortItemProvider = new FlowPortItemProvider(this);
		}

		return flowPortItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.ServicePort} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ServicePortItemProvider servicePortItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.ServicePort}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createServicePortAdapter()
    {
		if (servicePortItemProvider == null) {
			servicePortItemProvider = new ServicePortItemProvider(this);
		}

		return servicePortItemProvider;
	}

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.FlowSpecification} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected FlowSpecificationItemProvider flowSpecificationItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.FlowSpecification}.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createFlowSpecificationAdapter()
    {
		if (flowSpecificationItemProvider == null) {
			flowSpecificationItemProvider = new FlowSpecificationItemProvider(this);
		}

		return flowSpecificationItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.BlockDefinition} instances.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected BlockDefinitionItemProvider blockDefinitionItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.BlockDefinition}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createBlockDefinitionAdapter()
    {
		if (blockDefinitionItemProvider == null) {
			blockDefinitionItemProvider = new BlockDefinitionItemProvider(this);
		}

		return blockDefinitionItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.PackageSYSML} instances.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected PackageSYSMLItemProvider packageSYSMLItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.PackageSYSML}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createPackageSYSMLAdapter()
    {
		if (packageSYSMLItemProvider == null) {
			packageSYSMLItemProvider = new PackageSYSMLItemProvider(this);
		}

		return packageSYSMLItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Requirement} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected RequirementItemProvider requirementItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.Requirement}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createRequirementAdapter()
    {
		if (requirementItemProvider == null) {
			requirementItemProvider = new RequirementItemProvider(this);
		}

		return requirementItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.TestCase} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected TestCaseItemProvider testCaseItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.TestCase}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createTestCaseAdapter()
    {
		if (testCaseItemProvider == null) {
			testCaseItemProvider = new TestCaseItemProvider(this);
		}

		return testCaseItemProvider;
	}

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.RequirementDefinition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected RequirementDefinitionItemProvider requirementDefinitionItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.RequirementDefinition}.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createRequirementDefinitionAdapter()
    {
		if (requirementDefinitionItemProvider == null) {
			requirementDefinitionItemProvider = new RequirementDefinitionItemProvider(this);
		}

		return requirementDefinitionItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Satisfy} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected SatisfyItemProvider satisfyItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Satisfy}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createSatisfyAdapter()
    {
		if (satisfyItemProvider == null) {
			satisfyItemProvider = new SatisfyItemProvider(this);
		}

		return satisfyItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.DeriveReqt} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected DeriveReqtItemProvider deriveReqtItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.DeriveReqt}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createDeriveReqtAdapter()
    {
		if (deriveReqtItemProvider == null) {
			deriveReqtItemProvider = new DeriveReqtItemProvider(this);
		}

		return deriveReqtItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Verify} instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    protected VerifyItemProvider verifyItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Verify}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createVerifyAdapter()
    {
		if (verifyItemProvider == null) {
			verifyItemProvider = new VerifyItemProvider(this);
		}

		return verifyItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Field} instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    protected FieldItemProvider fieldItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Field}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createFieldAdapter()
    {
		if (fieldItemProvider == null) {
			fieldItemProvider = new FieldItemProvider(this);
		}

		return fieldItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Rationale} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected RationaleItemProvider rationaleItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Rationale}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createRationaleAdapter()
    {
		if (rationaleItemProvider == null) {
			rationaleItemProvider = new RationaleItemProvider(this);
		}

		return rationaleItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Problem} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ProblemItemProvider problemItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Problem}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createProblemAdapter()
    {
		if (problemItemProvider == null) {
			problemItemProvider = new ProblemItemProvider(this);
		}

		return problemItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.ValueType} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ValueTypeItemProvider valueTypeItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.ValueType}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createValueTypeAdapter()
    {
		if (valueTypeItemProvider == null) {
			valueTypeItemProvider = new ValueTypeItemProvider(this);
		}

		return valueTypeItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Dimension} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected DimensionItemProvider dimensionItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Dimension}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createDimensionAdapter()
    {
		if (dimensionItemProvider == null) {
			dimensionItemProvider = new DimensionItemProvider(this);
		}

		return dimensionItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Unit} instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    protected UnitItemProvider unitItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Unit}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createUnitAdapter()
    {
		if (unitItemProvider == null) {
			unitItemProvider = new UnitItemProvider(this);
		}

		return unitItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.BlockProperty} instances.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected BlockPropertyItemProvider blockPropertyItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.BlockProperty}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createBlockPropertyAdapter()
    {
		if (blockPropertyItemProvider == null) {
			blockPropertyItemProvider = new BlockPropertyItemProvider(this);
		}

		return blockPropertyItemProvider;
	}

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.DistributedProperty} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected DistributedPropertyItemProvider distributedPropertyItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.DistributedProperty}.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createDistributedPropertyAdapter()
    {
		if (distributedPropertyItemProvider == null) {
			distributedPropertyItemProvider = new DistributedPropertyItemProvider(this);
		}

		return distributedPropertyItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.ItemFlow} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ItemFlowItemProvider itemFlowItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.ItemFlow}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createItemFlowAdapter()
    {
		if (itemFlowItemProvider == null) {
			itemFlowItemProvider = new ItemFlowItemProvider(this);
		}

		return itemFlowItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.FlowProperty} instances.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected FlowPropertyItemProvider flowPropertyItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.FlowProperty}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createFlowPropertyAdapter()
    {
		if (flowPropertyItemProvider == null) {
			flowPropertyItemProvider = new FlowPropertyItemProvider(this);
		}

		return flowPropertyItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.ConstraintBlock} instances.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @generated
	 */
    protected ConstraintBlockItemProvider constraintBlockItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.ConstraintBlock}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createConstraintBlockAdapter()
    {
		if (constraintBlockItemProvider == null) {
			constraintBlockItemProvider = new ConstraintBlockItemProvider(this);
		}

		return constraintBlockItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Trace} instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    protected TraceItemProvider traceItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Trace}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createTraceAdapter()
    {
		if (traceItemProvider == null) {
			traceItemProvider = new TraceItemProvider(this);
		}

		return traceItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Copy} instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    protected CopyItemProvider copyItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Copy}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createCopyAdapter()
    {
		if (copyItemProvider == null) {
			copyItemProvider = new CopyItemProvider(this);
		}

		return copyItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Refine} instances.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    protected RefineItemProvider refineItemProvider;

    /**
     * This creates an adapter for a {@link org.topcased.sysml.Refine}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createRefineAdapter()
    {
		if (refineItemProvider == null) {
			refineItemProvider = new RefineItemProvider(this);
		}

		return refineItemProvider;
	}

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.ConstraintProperty} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ConstraintPropertyItemProvider constraintPropertyItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.ConstraintProperty}.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createConstraintPropertyAdapter()
    {
		if (constraintPropertyItemProvider == null) {
			constraintPropertyItemProvider = new ConstraintPropertyItemProvider(this);
		}

		return constraintPropertyItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.Containment} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ContainmentItemProvider containmentItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.Containment}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createContainmentAdapter()
    {
		if (containmentItemProvider == null) {
			containmentItemProvider = new ContainmentItemProvider(this);
		}

		return containmentItemProvider;
	}

    /**
     * This keeps track of the one adapter used for all
     * {@link org.topcased.sysml.RequirementRelated} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected RequirementRelatedItemProvider requirementRelatedItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.RequirementRelated}.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createRequirementRelatedAdapter()
    {
		if (requirementRelatedItemProvider == null) {
			requirementRelatedItemProvider = new RequirementRelatedItemProvider(this);
		}

		return requirementRelatedItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link org.topcased.sysml.ModelSYSML} instances.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected ModelSYSMLItemProvider modelSYSMLItemProvider;

    /**
	 * This creates an adapter for a {@link org.topcased.sysml.ModelSYSML}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter createModelSYSMLAdapter()
    {
		if (modelSYSMLItemProvider == null) {
			modelSYSMLItemProvider = new ModelSYSMLItemProvider(this);
		}

		return modelSYSMLItemProvider;
	}

    /**
     * This returns the root adapter factory that contains this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public ComposeableAdapterFactory getRootAdapterFactory()
    {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

    /**
     * This sets the composed adapter factory that contains this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
    {
		this.parentAdapterFactory = parentAdapterFactory;
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean isFactoryForType(Object type)
    {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

    /**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Adapter adapt(Notifier notifier, Object type)
    {
		return super.adapt(notifier, this);
	}

    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object adapt(Object object, Object type)
    {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

    /**
	 * This adds a listener.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void addListener(INotifyChangedListener notifyChangedListener)
    {
		changeNotifier.addListener(notifyChangedListener);
	}

    /**
	 * This removes a listener.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public void removeListener(INotifyChangedListener notifyChangedListener)
    {
		changeNotifier.removeListener(notifyChangedListener);
	}

    /**
     * This delegates to {@link #changeNotifier} and to
     * {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    public void fireNotifyChanged(Notification notification)
    {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

    /**
     * This disposes all of the item providers created by this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void dispose()
    {
		if (blockItemProvider != null) blockItemProvider.dispose();
		if (flowPortItemProvider != null) flowPortItemProvider.dispose();
		if (servicePortItemProvider != null) servicePortItemProvider.dispose();
		if (flowSpecificationItemProvider != null) flowSpecificationItemProvider.dispose();
		if (blockDefinitionItemProvider != null) blockDefinitionItemProvider.dispose();
		if (packageSYSMLItemProvider != null) packageSYSMLItemProvider.dispose();
		if (requirementItemProvider != null) requirementItemProvider.dispose();
		if (testCaseItemProvider != null) testCaseItemProvider.dispose();
		if (requirementDefinitionItemProvider != null) requirementDefinitionItemProvider.dispose();
		if (satisfyItemProvider != null) satisfyItemProvider.dispose();
		if (deriveReqtItemProvider != null) deriveReqtItemProvider.dispose();
		if (verifyItemProvider != null) verifyItemProvider.dispose();
		if (fieldItemProvider != null) fieldItemProvider.dispose();
		if (rationaleItemProvider != null) rationaleItemProvider.dispose();
		if (problemItemProvider != null) problemItemProvider.dispose();
		if (valueTypeItemProvider != null) valueTypeItemProvider.dispose();
		if (dimensionItemProvider != null) dimensionItemProvider.dispose();
		if (unitItemProvider != null) unitItemProvider.dispose();
		if (blockPropertyItemProvider != null) blockPropertyItemProvider.dispose();
		if (distributedPropertyItemProvider != null) distributedPropertyItemProvider.dispose();
		if (itemFlowItemProvider != null) itemFlowItemProvider.dispose();
		if (flowPropertyItemProvider != null) flowPropertyItemProvider.dispose();
		if (constraintBlockItemProvider != null) constraintBlockItemProvider.dispose();
		if (traceItemProvider != null) traceItemProvider.dispose();
		if (copyItemProvider != null) copyItemProvider.dispose();
		if (refineItemProvider != null) refineItemProvider.dispose();
		if (constraintPropertyItemProvider != null) constraintPropertyItemProvider.dispose();
		if (containmentItemProvider != null) containmentItemProvider.dispose();
		if (requirementRelatedItemProvider != null) requirementRelatedItemProvider.dispose();
		if (modelSYSMLItemProvider != null) modelSYSMLItemProvider.dispose();
	}

    /**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated NOT
	 */
    @Override
    public Adapter createAdapter(Notifier target)
    {
		Adapter adapter = super.createAdapter(target);
		return adapter == null
			? (new UMLItemProviderAdapterFactory()).createStereotypeApplicationAdapter()
			: adapter;
	}
    
}
