/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
******************************************************************************/

package org.topcased.sysml.tools;

import org.eclipse.uml2.uml.Element;
import org.topcased.sysml.PackageSYSML;



/**
 * The Class SysMLRequirementsTools.
 */
public class SysMLRequirementsTools
{

    /**
     * Return the requirement definition in which an element is contained.
     * 
     * @param element Element
     * @return the requirement definition
     */
    public static PackageSYSML getPackageSYSML(Element element)
    {
        if (element == null || element instanceof PackageSYSML)
            return (PackageSYSML) element;
        return getPackageSYSML(element.getOwner());
    }

}
