package org.topcased.sysml.tools;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.eclipse.jface.resource.ImageDescriptor;
import org.osgi.framework.BundleContext;

/**
 * The main plugin class to be used in the desktop.
 */
public class SysMLToolsPlugin extends AbstractUIPlugin
{

    // The shared instance.
    private static SysMLToolsPlugin plugin;

    /**
     * The constructor.
     */
    public SysMLToolsPlugin()
    {
        plugin = this;
    }

    /**
     * This method is called upon plug-in activation
     * 
     * @param context BundleContext
     * @throws Exception exception
     */
    public void start(BundleContext context) throws Exception
    {
        super.start(context);
    }

    /**
     * This method is called when the plug-in is stopped
     * 
     * @param context BundleContext
     * @throws Exception exception
     */
    public void stop(BundleContext context) throws Exception
    {
        super.stop(context);
        plugin = null;
    }

    /**
     * This method returns the plugin
     * 
     * @return the shared instance.
     */
    public static SysMLToolsPlugin getDefault()
    {
        return plugin;
    }

    /**
     * Returns an image descriptor for the image file at the given plug-in
     * relative path.
     * 
     * @param path the path
     * @return the image descriptor
     */
    public static ImageDescriptor getImageDescriptor(String path)
    {
        return AbstractUIPlugin.imageDescriptorFromPlugin("org.topcased.sysml.tools", path);
    }
}
