/**
 * <copyright> </copyright>
 * 
 * $Id: SysMLAdapterFactory.java,v 1.2 2007-05-22 08:53:39 tlandre Exp $
 */
package org.topcased.sysml.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Abstraction;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.ConnectableElement;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.DeploymentTarget;
import org.eclipse.uml2.uml.DirectedRelationship;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.EncapsulatedClassifier;
import org.eclipse.uml2.uml.Feature;
import org.eclipse.uml2.uml.InformationFlow;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.MultiplicityElement;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.PackageableElement;
import org.eclipse.uml2.uml.ParameterableElement;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Realization;
import org.eclipse.uml2.uml.RedefinableElement;
import org.eclipse.uml2.uml.Relationship;
import org.eclipse.uml2.uml.StructuralFeature;
import org.eclipse.uml2.uml.StructuredClassifier;
import org.eclipse.uml2.uml.TemplateableElement;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.TypedElement;
import org.topcased.sysml.Block;
import org.topcased.sysml.BlockDefinition;
import org.topcased.sysml.BlockProperty;
import org.topcased.sysml.ConstraintBlock;
import org.topcased.sysml.ConstraintProperty;
import org.topcased.sysml.Containment;
import org.topcased.sysml.Copy;
import org.topcased.sysml.DeriveReqt;
import org.topcased.sysml.Dimension;
import org.topcased.sysml.DistributedProperty;
import org.topcased.sysml.Field;
import org.topcased.sysml.FlowPort;
import org.topcased.sysml.FlowProperty;
import org.topcased.sysml.FlowSpecification;
import org.topcased.sysml.ItemFlow;
import org.topcased.sysml.ModelSYSML;
import org.topcased.sysml.PackageSYSML;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.Refine;
import org.topcased.sysml.Requirement;
import org.topcased.sysml.RequirementDefinition;
import org.topcased.sysml.RequirementRelated;
import org.topcased.sysml.Satisfy;
import org.topcased.sysml.ServicePort;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.TestCase;
import org.topcased.sysml.Trace;
import org.topcased.sysml.Unit;
import org.topcased.sysml.ValueType;
import org.topcased.sysml.Verify;

/**
 * <!-- begin-user-doc --> The  < ? >Adapter Factory</b> for the model. It
 * provides an adapter <code>createXXX</code> method for each class of the
 * model. <!-- end-user-doc -->
 * @see org.topcased.sysml.SysMLPackage
 * @generated
 */
public class SysMLAdapterFactory extends AdapterFactoryImpl
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";

    /**
	 * The cached model package.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    protected static SysMLPackage modelPackage;

    /**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc --> <!--
     * end-user-doc -->
	 * @generated
	 */
    public SysMLAdapterFactory()
    {
		if (modelPackage == null) {
			modelPackage = SysMLPackage.eINSTANCE;
		}
	}

    /**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code>
     * if the object is either the model's package or is an instance object of
     * the model. <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
    @Override
    public boolean isFactoryForType(Object object)
    {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

    /**
     * The switch the delegates to the <code>createXXX</code> methods. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SysMLSwitch<Adapter> modelSwitch =
        new SysMLSwitch<Adapter>() {
			@Override
			public Adapter caseBlock(Block object) {
				return createBlockAdapter();
			}
			@Override
			public Adapter caseFlowPort(FlowPort object) {
				return createFlowPortAdapter();
			}
			@Override
			public Adapter caseServicePort(ServicePort object) {
				return createServicePortAdapter();
			}
			@Override
			public Adapter caseFlowSpecification(FlowSpecification object) {
				return createFlowSpecificationAdapter();
			}
			@Override
			public Adapter caseBlockDefinition(BlockDefinition object) {
				return createBlockDefinitionAdapter();
			}
			@Override
			public Adapter casePackageSYSML(PackageSYSML object) {
				return createPackageSYSMLAdapter();
			}
			@Override
			public Adapter caseRequirement(Requirement object) {
				return createRequirementAdapter();
			}
			@Override
			public Adapter caseTestCase(TestCase object) {
				return createTestCaseAdapter();
			}
			@Override
			public Adapter caseRequirementDefinition(RequirementDefinition object) {
				return createRequirementDefinitionAdapter();
			}
			@Override
			public Adapter caseSatisfy(Satisfy object) {
				return createSatisfyAdapter();
			}
			@Override
			public Adapter caseDeriveReqt(DeriveReqt object) {
				return createDeriveReqtAdapter();
			}
			@Override
			public Adapter caseVerify(Verify object) {
				return createVerifyAdapter();
			}
			@Override
			public Adapter caseField(Field object) {
				return createFieldAdapter();
			}
			@Override
			public Adapter caseRationale(Rationale object) {
				return createRationaleAdapter();
			}
			@Override
			public Adapter caseProblem(Problem object) {
				return createProblemAdapter();
			}
			@Override
			public Adapter caseValueType(ValueType object) {
				return createValueTypeAdapter();
			}
			@Override
			public Adapter caseDimension(Dimension object) {
				return createDimensionAdapter();
			}
			@Override
			public Adapter caseUnit(Unit object) {
				return createUnitAdapter();
			}
			@Override
			public Adapter caseBlockProperty(BlockProperty object) {
				return createBlockPropertyAdapter();
			}
			@Override
			public Adapter caseDistributedProperty(DistributedProperty object) {
				return createDistributedPropertyAdapter();
			}
			@Override
			public Adapter caseItemFlow(ItemFlow object) {
				return createItemFlowAdapter();
			}
			@Override
			public Adapter caseFlowProperty(FlowProperty object) {
				return createFlowPropertyAdapter();
			}
			@Override
			public Adapter caseConstraintBlock(ConstraintBlock object) {
				return createConstraintBlockAdapter();
			}
			@Override
			public Adapter caseTrace(Trace object) {
				return createTraceAdapter();
			}
			@Override
			public Adapter caseCopy(Copy object) {
				return createCopyAdapter();
			}
			@Override
			public Adapter caseRefine(Refine object) {
				return createRefineAdapter();
			}
			@Override
			public Adapter caseConstraintProperty(ConstraintProperty object) {
				return createConstraintPropertyAdapter();
			}
			@Override
			public Adapter caseContainment(Containment object) {
				return createContainmentAdapter();
			}
			@Override
			public Adapter caseRequirementRelated(RequirementRelated object) {
				return createRequirementRelatedAdapter();
			}
			@Override
			public Adapter caseModelSYSML(ModelSYSML object) {
				return createModelSYSMLAdapter();
			}
			@Override
			public Adapter caseEModelElement(EModelElement object) {
				return createEModelElementAdapter();
			}
			@Override
			public Adapter caseElement(Element object) {
				return createElementAdapter();
			}
			@Override
			public Adapter caseNamedElement(NamedElement object) {
				return createNamedElementAdapter();
			}
			@Override
			public Adapter caseNamespace(Namespace object) {
				return createNamespaceAdapter();
			}
			@Override
			public Adapter caseRedefinableElement(RedefinableElement object) {
				return createRedefinableElementAdapter();
			}
			@Override
			public Adapter caseParameterableElement(ParameterableElement object) {
				return createParameterableElementAdapter();
			}
			@Override
			public Adapter casePackageableElement(PackageableElement object) {
				return createPackageableElementAdapter();
			}
			@Override
			public Adapter caseType(Type object) {
				return createTypeAdapter();
			}
			@Override
			public Adapter caseTemplateableElement(TemplateableElement object) {
				return createTemplateableElementAdapter();
			}
			@Override
			public Adapter caseClassifier(Classifier object) {
				return createClassifierAdapter();
			}
			@Override
			public Adapter caseStructuredClassifier(StructuredClassifier object) {
				return createStructuredClassifierAdapter();
			}
			@Override
			public Adapter caseEncapsulatedClassifier(EncapsulatedClassifier object) {
				return createEncapsulatedClassifierAdapter();
			}
			@Override
			public Adapter caseBehavioredClassifier(BehavioredClassifier object) {
				return createBehavioredClassifierAdapter();
			}
			@Override
			public Adapter caseClass(org.eclipse.uml2.uml.Class object) {
				return createClassAdapter();
			}
			@Override
			public Adapter caseFeature(Feature object) {
				return createFeatureAdapter();
			}
			@Override
			public Adapter caseTypedElement(TypedElement object) {
				return createTypedElementAdapter();
			}
			@Override
			public Adapter caseMultiplicityElement(MultiplicityElement object) {
				return createMultiplicityElementAdapter();
			}
			@Override
			public Adapter caseStructuralFeature(StructuralFeature object) {
				return createStructuralFeatureAdapter();
			}
			@Override
			public Adapter caseConnectableElement(ConnectableElement object) {
				return createConnectableElementAdapter();
			}
			@Override
			public Adapter caseDeploymentTarget(DeploymentTarget object) {
				return createDeploymentTargetAdapter();
			}
			@Override
			public Adapter caseProperty(Property object) {
				return createPropertyAdapter();
			}
			@Override
			public Adapter casePort(Port object) {
				return createPortAdapter();
			}
			@Override
			public Adapter caseInterface(Interface object) {
				return createInterfaceAdapter();
			}
			@Override
			public Adapter casePackage(org.eclipse.uml2.uml.Package object) {
				return createPackageAdapter();
			}
			@Override
			public Adapter caseBehavior(Behavior object) {
				return createBehaviorAdapter();
			}
			@Override
			public Adapter caseRelationship(Relationship object) {
				return createRelationshipAdapter();
			}
			@Override
			public Adapter caseDirectedRelationship(DirectedRelationship object) {
				return createDirectedRelationshipAdapter();
			}
			@Override
			public Adapter caseDependency(Dependency object) {
				return createDependencyAdapter();
			}
			@Override
			public Adapter caseAbstraction(Abstraction object) {
				return createAbstractionAdapter();
			}
			@Override
			public Adapter caseRealization(Realization object) {
				return createRealizationAdapter();
			}
			@Override
			public Adapter caseComment(Comment object) {
				return createCommentAdapter();
			}
			@Override
			public Adapter caseDataType(DataType object) {
				return createDataTypeAdapter();
			}
			@Override
			public Adapter caseInformationFlow(InformationFlow object) {
				return createInformationFlowAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

    /**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc
     * --> <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
    @Override
    public Adapter createAdapter(Notifier target)
    {
		return modelSwitch.doSwitch((EObject)target);
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Block <em>Block</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Block
	 * @generated
	 */
    public Adapter createBlockAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.FlowPort <em>Flow Port</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.FlowPort
	 * @generated
	 */
    public Adapter createFlowPortAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.ServicePort <em>Service Port</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.ServicePort
	 * @generated
	 */
    public Adapter createServicePortAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.FlowSpecification <em>Flow Specification</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.FlowSpecification
	 * @generated
	 */
    public Adapter createFlowSpecificationAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.BlockDefinition <em>Block Definition</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.BlockDefinition
	 * @generated
	 */
    public Adapter createBlockDefinitionAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.PackageSYSML <em>Package SYSML</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.PackageSYSML
	 * @generated
	 */
    public Adapter createPackageSYSMLAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Requirement <em>Requirement</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Requirement
	 * @generated
	 */
    public Adapter createRequirementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.TestCase <em>Test Case</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.TestCase
	 * @generated
	 */
    public Adapter createTestCaseAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.RequirementDefinition <em>Requirement Definition</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.RequirementDefinition
	 * @generated
	 */
    public Adapter createRequirementDefinitionAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Satisfy <em>Satisfy</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Satisfy
	 * @generated
	 */
    public Adapter createSatisfyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.DeriveReqt <em>Derive Reqt</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.DeriveReqt
	 * @generated
	 */
    public Adapter createDeriveReqtAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Verify <em>Verify</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Verify
	 * @generated
	 */
    public Adapter createVerifyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Field <em>Field</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Field
	 * @generated
	 */
    public Adapter createFieldAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Rationale <em>Rationale</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Rationale
	 * @generated
	 */
    public Adapter createRationaleAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Problem <em>Problem</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Problem
	 * @generated
	 */
    public Adapter createProblemAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.ValueType <em>Value Type</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.ValueType
	 * @generated
	 */
    public Adapter createValueTypeAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Dimension <em>Dimension</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Dimension
	 * @generated
	 */
    public Adapter createDimensionAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Unit <em>Unit</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Unit
	 * @generated
	 */
    public Adapter createUnitAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.BlockProperty <em>Block Property</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.BlockProperty
	 * @generated
	 */
    public Adapter createBlockPropertyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.DistributedProperty <em>Distributed Property</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.DistributedProperty
	 * @generated
	 */
    public Adapter createDistributedPropertyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.ItemFlow <em>Item Flow</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.ItemFlow
	 * @generated
	 */
    public Adapter createItemFlowAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.FlowProperty <em>Flow Property</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.FlowProperty
	 * @generated
	 */
    public Adapter createFlowPropertyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.ConstraintBlock <em>Constraint Block</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.ConstraintBlock
	 * @generated
	 */
    public Adapter createConstraintBlockAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Trace <em>Trace</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Trace
	 * @generated
	 */
    public Adapter createTraceAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Copy <em>Copy</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Copy
	 * @generated
	 */
    public Adapter createCopyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Refine <em>Refine</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Refine
	 * @generated
	 */
    public Adapter createRefineAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.ConstraintProperty <em>Constraint Property</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.ConstraintProperty
	 * @generated
	 */
    public Adapter createConstraintPropertyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.Containment <em>Containment</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.Containment
	 * @generated
	 */
    public Adapter createContainmentAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.RequirementRelated <em>Requirement Related</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.RequirementRelated
	 * @generated
	 */
    public Adapter createRequirementRelatedAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.topcased.sysml.ModelSYSML <em>Model SYSML</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.topcased.sysml.ModelSYSML
	 * @generated
	 */
    public Adapter createModelSYSMLAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.emf.ecore.EModelElement <em>EModel Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.emf.ecore.EModelElement
	 * @generated
	 */
    public Adapter createEModelElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Element <em>Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Element
	 * @generated
	 */
    public Adapter createElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.NamedElement <em>Named Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.NamedElement
	 * @generated
	 */
    public Adapter createNamedElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Namespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Namespace
	 * @generated
	 */
    public Adapter createNamespaceAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.RedefinableElement <em>Redefinable Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.RedefinableElement
	 * @generated
	 */
    public Adapter createRedefinableElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.ParameterableElement <em>Parameterable Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.ParameterableElement
	 * @generated
	 */
    public Adapter createParameterableElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.PackageableElement <em>Packageable Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.PackageableElement
	 * @generated
	 */
    public Adapter createPackageableElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Type <em>Type</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Type
	 * @generated
	 */
    public Adapter createTypeAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.TemplateableElement <em>Templateable Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.TemplateableElement
	 * @generated
	 */
    public Adapter createTemplateableElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Classifier <em>Classifier</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Classifier
	 * @generated
	 */
    public Adapter createClassifierAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.StructuredClassifier <em>Structured Classifier</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.StructuredClassifier
	 * @generated
	 */
    public Adapter createStructuredClassifierAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.EncapsulatedClassifier <em>Encapsulated Classifier</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.EncapsulatedClassifier
	 * @generated
	 */
    public Adapter createEncapsulatedClassifierAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.BehavioredClassifier <em>Behaviored Classifier</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.BehavioredClassifier
	 * @generated
	 */
    public Adapter createBehavioredClassifierAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Class <em>Class</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Class
	 * @generated
	 */
    public Adapter createClassAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Feature <em>Feature</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Feature
	 * @generated
	 */
    public Adapter createFeatureAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.TypedElement <em>Typed Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.TypedElement
	 * @generated
	 */
    public Adapter createTypedElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.MultiplicityElement <em>Multiplicity Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.MultiplicityElement
	 * @generated
	 */
    public Adapter createMultiplicityElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.StructuralFeature <em>Structural Feature</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.StructuralFeature
	 * @generated
	 */
    public Adapter createStructuralFeatureAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.ConnectableElement <em>Connectable Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.ConnectableElement
	 * @generated
	 */
    public Adapter createConnectableElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.DeploymentTarget <em>Deployment Target</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.DeploymentTarget
	 * @generated
	 */
    public Adapter createDeploymentTargetAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Property <em>Property</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Property
	 * @generated
	 */
    public Adapter createPropertyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Port <em>Port</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Port
	 * @generated
	 */
    public Adapter createPortAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Interface <em>Interface</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Interface
	 * @generated
	 */
    public Adapter createInterfaceAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Package <em>Package</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Package
	 * @generated
	 */
    public Adapter createPackageAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Behavior <em>Behavior</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Behavior
	 * @generated
	 */
    public Adapter createBehaviorAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Relationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Relationship
	 * @generated
	 */
    public Adapter createRelationshipAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.DirectedRelationship <em>Directed Relationship</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.DirectedRelationship
	 * @generated
	 */
    public Adapter createDirectedRelationshipAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Dependency <em>Dependency</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Dependency
	 * @generated
	 */
    public Adapter createDependencyAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Abstraction <em>Abstraction</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Abstraction
	 * @generated
	 */
    public Adapter createAbstractionAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Realization <em>Realization</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Realization
	 * @generated
	 */
    public Adapter createRealizationAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.Comment <em>Comment</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.Comment
	 * @generated
	 */
    public Adapter createCommentAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.DataType <em>Data Type</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.DataType
	 * @generated
	 */
    public Adapter createDataTypeAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link org.eclipse.uml2.uml.InformationFlow <em>Information Flow</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.uml2.uml.InformationFlow
	 * @generated
	 */
    public Adapter createInformationFlowAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc --> This
     * default implementation returns null. <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
    public Adapter createEObjectAdapter()
    {
		return null;
	}

} // SysMLAdapterFactory
