/**
 * 
 */
package org.topcased.sysml.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EModelElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Abstraction;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.ConnectableElement;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.DeploymentTarget;
import org.eclipse.uml2.uml.DirectedRelationship;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.EncapsulatedClassifier;
import org.eclipse.uml2.uml.Feature;
import org.eclipse.uml2.uml.InformationFlow;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.MultiplicityElement;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.PackageableElement;
import org.eclipse.uml2.uml.ParameterableElement;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Realization;
import org.eclipse.uml2.uml.RedefinableElement;
import org.eclipse.uml2.uml.Relationship;
import org.eclipse.uml2.uml.StructuralFeature;
import org.eclipse.uml2.uml.StructuredClassifier;
import org.eclipse.uml2.uml.TemplateableElement;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.TypedElement;
import org.eclipse.uml2.uml.util.UMLSwitch;
import org.topcased.sysml.Block;
import org.topcased.sysml.BlockDefinition;
import org.topcased.sysml.BlockProperty;
import org.topcased.sysml.ConstraintBlock;
import org.topcased.sysml.ConstraintProperty;
import org.topcased.sysml.Containment;
import org.topcased.sysml.Copy;
import org.topcased.sysml.DeriveReqt;
import org.topcased.sysml.Dimension;
import org.topcased.sysml.DistributedProperty;
import org.topcased.sysml.Field;
import org.topcased.sysml.FlowPort;
import org.topcased.sysml.FlowProperty;
import org.topcased.sysml.FlowSpecification;
import org.topcased.sysml.ItemFlow;
import org.topcased.sysml.ModelSYSML;
import org.topcased.sysml.PackageSYSML;
import org.topcased.sysml.Problem;
import org.topcased.sysml.Rationale;
import org.topcased.sysml.Refine;
import org.topcased.sysml.Requirement;
import org.topcased.sysml.RequirementDefinition;
import org.topcased.sysml.RequirementRelated;
import org.topcased.sysml.Satisfy;
import org.topcased.sysml.ServicePort;
import org.topcased.sysml.SysMLPackage;
import org.topcased.sysml.TestCase;
import org.topcased.sysml.Trace;
import org.topcased.sysml.Unit;
import org.topcased.sysml.ValueType;
import org.topcased.sysml.Verify;

/**
 * <!-- begin-user-doc --> The < ? >Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * @see org.topcased.sysml.SysMLPackage
 * @generated
 */
public class SysMLSwitch<T> extends UMLSwitch<T>
{
    /**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
    public static final String copyright = "";


	/**
     * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    protected static SysMLPackage sysmlmodelPackage;

    /**
     * Creates an instance of the switch. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated NOT
     */
    public SysMLSwitch()
    {
        if (sysmlmodelPackage == null)
        {
            sysmlmodelPackage = SysMLPackage.eINSTANCE;
        }
    }

    /**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
    public T doSwitch(EObject theEObject)
    {
		return doSwitch(theEObject.eClass(), theEObject);
	}

    /**
     * Calls <code>caseXXX</code> for each class of the model until one
     * returns a non null result; it yields that result. <!-- begin-user-doc -->
     * If the element is an UML2 element, we call doSwitch on UML2Switch <!--
     * end-user-doc -->
     * 
     * @return the first non-null result returned by a <code>caseXXX</code>
     *         call.
     * @generated NOT
     */
    protected T doSwitch(EClass theEClass, EObject theEObject)
    {
        if (theEClass.eContainer() == sysmlmodelPackage)
        {
            return doSwitch(theEClass.getClassifierID(), theEObject);
        }
        else if (theEClass.eContainer() == modelPackage)
        {
            return super.doSwitch(theEClass.getClassifierID(), theEObject);
        }
        else
        {
            List<EClass> eSuperTypes = theEClass.getESuperTypes();
            return eSuperTypes.isEmpty() ? defaultCase(theEObject) : doSwitch(eSuperTypes.get(0), theEObject);
        }
    }

    /**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
    protected T doSwitch(int classifierID, EObject theEObject)
    {
		switch (classifierID) {
			case SysMLPackage.BLOCK: {
				Block block = (Block)theEObject;
				T result = caseBlock(block);
				if (result == null) result = caseClass(block);
				if (result == null) result = caseEncapsulatedClassifier(block);
				if (result == null) result = caseBehavioredClassifier(block);
				if (result == null) result = caseStructuredClassifier(block);
				if (result == null) result = caseClassifier(block);
				if (result == null) result = caseNamespace(block);
				if (result == null) result = caseRedefinableElement(block);
				if (result == null) result = caseType(block);
				if (result == null) result = caseTemplateableElement(block);
				if (result == null) result = caseNamedElement(block);
				if (result == null) result = casePackageableElement(block);
				if (result == null) result = caseElement(block);
				if (result == null) result = caseParameterableElement(block);
				if (result == null) result = caseEModelElement(block);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.FLOW_PORT: {
				FlowPort flowPort = (FlowPort)theEObject;
				T result = caseFlowPort(flowPort);
				if (result == null) result = casePort(flowPort);
				if (result == null) result = caseProperty(flowPort);
				if (result == null) result = caseStructuralFeature(flowPort);
				if (result == null) result = caseConnectableElement(flowPort);
				if (result == null) result = caseDeploymentTarget(flowPort);
				if (result == null) result = caseTemplateableElement(flowPort);
				if (result == null) result = caseFeature(flowPort);
				if (result == null) result = caseTypedElement(flowPort);
				if (result == null) result = caseMultiplicityElement(flowPort);
				if (result == null) result = caseParameterableElement(flowPort);
				if (result == null) result = caseNamedElement(flowPort);
				if (result == null) result = caseElement(flowPort);
				if (result == null) result = caseRedefinableElement(flowPort);
				if (result == null) result = caseEModelElement(flowPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.SERVICE_PORT: {
				ServicePort servicePort = (ServicePort)theEObject;
				T result = caseServicePort(servicePort);
				if (result == null) result = casePort(servicePort);
				if (result == null) result = caseProperty(servicePort);
				if (result == null) result = caseStructuralFeature(servicePort);
				if (result == null) result = caseConnectableElement(servicePort);
				if (result == null) result = caseDeploymentTarget(servicePort);
				if (result == null) result = caseTemplateableElement(servicePort);
				if (result == null) result = caseFeature(servicePort);
				if (result == null) result = caseTypedElement(servicePort);
				if (result == null) result = caseMultiplicityElement(servicePort);
				if (result == null) result = caseParameterableElement(servicePort);
				if (result == null) result = caseNamedElement(servicePort);
				if (result == null) result = caseElement(servicePort);
				if (result == null) result = caseRedefinableElement(servicePort);
				if (result == null) result = caseEModelElement(servicePort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.FLOW_SPECIFICATION: {
				FlowSpecification flowSpecification = (FlowSpecification)theEObject;
				T result = caseFlowSpecification(flowSpecification);
				if (result == null) result = caseInterface(flowSpecification);
				if (result == null) result = caseClassifier(flowSpecification);
				if (result == null) result = caseNamespace(flowSpecification);
				if (result == null) result = caseRedefinableElement(flowSpecification);
				if (result == null) result = caseType(flowSpecification);
				if (result == null) result = caseTemplateableElement(flowSpecification);
				if (result == null) result = caseNamedElement(flowSpecification);
				if (result == null) result = casePackageableElement(flowSpecification);
				if (result == null) result = caseElement(flowSpecification);
				if (result == null) result = caseParameterableElement(flowSpecification);
				if (result == null) result = caseEModelElement(flowSpecification);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.BLOCK_DEFINITION: {
				BlockDefinition blockDefinition = (BlockDefinition)theEObject;
				T result = caseBlockDefinition(blockDefinition);
				if (result == null) result = casePackageSYSML(blockDefinition);
				if (result == null) result = casePackage(blockDefinition);
				if (result == null) result = caseNamespace(blockDefinition);
				if (result == null) result = casePackageableElement(blockDefinition);
				if (result == null) result = caseTemplateableElement(blockDefinition);
				if (result == null) result = caseNamedElement(blockDefinition);
				if (result == null) result = caseParameterableElement(blockDefinition);
				if (result == null) result = caseElement(blockDefinition);
				if (result == null) result = caseEModelElement(blockDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.PACKAGE_SYSML: {
				PackageSYSML packageSYSML = (PackageSYSML)theEObject;
				T result = casePackageSYSML(packageSYSML);
				if (result == null) result = casePackage(packageSYSML);
				if (result == null) result = caseNamespace(packageSYSML);
				if (result == null) result = casePackageableElement(packageSYSML);
				if (result == null) result = caseTemplateableElement(packageSYSML);
				if (result == null) result = caseNamedElement(packageSYSML);
				if (result == null) result = caseParameterableElement(packageSYSML);
				if (result == null) result = caseElement(packageSYSML);
				if (result == null) result = caseEModelElement(packageSYSML);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.REQUIREMENT: {
				Requirement requirement = (Requirement)theEObject;
				T result = caseRequirement(requirement);
				if (result == null) result = caseClass(requirement);
				if (result == null) result = caseEncapsulatedClassifier(requirement);
				if (result == null) result = caseBehavioredClassifier(requirement);
				if (result == null) result = caseStructuredClassifier(requirement);
				if (result == null) result = caseClassifier(requirement);
				if (result == null) result = caseNamespace(requirement);
				if (result == null) result = caseRedefinableElement(requirement);
				if (result == null) result = caseType(requirement);
				if (result == null) result = caseTemplateableElement(requirement);
				if (result == null) result = caseNamedElement(requirement);
				if (result == null) result = casePackageableElement(requirement);
				if (result == null) result = caseElement(requirement);
				if (result == null) result = caseParameterableElement(requirement);
				if (result == null) result = caseEModelElement(requirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.TEST_CASE: {
				TestCase testCase = (TestCase)theEObject;
				T result = caseTestCase(testCase);
				if (result == null) result = caseBehavior(testCase);
				if (result == null) result = caseClass(testCase);
				if (result == null) result = caseEncapsulatedClassifier(testCase);
				if (result == null) result = caseBehavioredClassifier(testCase);
				if (result == null) result = caseStructuredClassifier(testCase);
				if (result == null) result = caseClassifier(testCase);
				if (result == null) result = caseNamespace(testCase);
				if (result == null) result = caseRedefinableElement(testCase);
				if (result == null) result = caseType(testCase);
				if (result == null) result = caseTemplateableElement(testCase);
				if (result == null) result = caseNamedElement(testCase);
				if (result == null) result = casePackageableElement(testCase);
				if (result == null) result = caseElement(testCase);
				if (result == null) result = caseParameterableElement(testCase);
				if (result == null) result = caseEModelElement(testCase);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.REQUIREMENT_DEFINITION: {
				RequirementDefinition requirementDefinition = (RequirementDefinition)theEObject;
				T result = caseRequirementDefinition(requirementDefinition);
				if (result == null) result = casePackageSYSML(requirementDefinition);
				if (result == null) result = casePackage(requirementDefinition);
				if (result == null) result = caseNamespace(requirementDefinition);
				if (result == null) result = casePackageableElement(requirementDefinition);
				if (result == null) result = caseTemplateableElement(requirementDefinition);
				if (result == null) result = caseNamedElement(requirementDefinition);
				if (result == null) result = caseParameterableElement(requirementDefinition);
				if (result == null) result = caseElement(requirementDefinition);
				if (result == null) result = caseEModelElement(requirementDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.SATISFY: {
				Satisfy satisfy = (Satisfy)theEObject;
				T result = caseSatisfy(satisfy);
				if (result == null) result = caseRealization(satisfy);
				if (result == null) result = caseAbstraction(satisfy);
				if (result == null) result = caseDependency(satisfy);
				if (result == null) result = casePackageableElement(satisfy);
				if (result == null) result = caseDirectedRelationship(satisfy);
				if (result == null) result = caseNamedElement(satisfy);
				if (result == null) result = caseParameterableElement(satisfy);
				if (result == null) result = caseRelationship(satisfy);
				if (result == null) result = caseElement(satisfy);
				if (result == null) result = caseEModelElement(satisfy);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.DERIVE_REQT: {
				DeriveReqt deriveReqt = (DeriveReqt)theEObject;
				T result = caseDeriveReqt(deriveReqt);
				if (result == null) result = caseTrace(deriveReqt);
				if (result == null) result = caseDependency(deriveReqt);
				if (result == null) result = casePackageableElement(deriveReqt);
				if (result == null) result = caseDirectedRelationship(deriveReqt);
				if (result == null) result = caseNamedElement(deriveReqt);
				if (result == null) result = caseParameterableElement(deriveReqt);
				if (result == null) result = caseRelationship(deriveReqt);
				if (result == null) result = caseElement(deriveReqt);
				if (result == null) result = caseEModelElement(deriveReqt);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.VERIFY: {
				Verify verify = (Verify)theEObject;
				T result = caseVerify(verify);
				if (result == null) result = caseTrace(verify);
				if (result == null) result = caseDependency(verify);
				if (result == null) result = casePackageableElement(verify);
				if (result == null) result = caseDirectedRelationship(verify);
				if (result == null) result = caseNamedElement(verify);
				if (result == null) result = caseParameterableElement(verify);
				if (result == null) result = caseRelationship(verify);
				if (result == null) result = caseElement(verify);
				if (result == null) result = caseEModelElement(verify);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.FIELD: {
				Field field = (Field)theEObject;
				T result = caseField(field);
				if (result == null) result = caseElement(field);
				if (result == null) result = caseEModelElement(field);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.RATIONALE: {
				Rationale rationale = (Rationale)theEObject;
				T result = caseRationale(rationale);
				if (result == null) result = caseComment(rationale);
				if (result == null) result = caseElement(rationale);
				if (result == null) result = caseEModelElement(rationale);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.PROBLEM: {
				Problem problem = (Problem)theEObject;
				T result = caseProblem(problem);
				if (result == null) result = caseComment(problem);
				if (result == null) result = caseElement(problem);
				if (result == null) result = caseEModelElement(problem);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.VALUE_TYPE: {
				ValueType valueType = (ValueType)theEObject;
				T result = caseValueType(valueType);
				if (result == null) result = caseDataType(valueType);
				if (result == null) result = caseClassifier(valueType);
				if (result == null) result = caseNamespace(valueType);
				if (result == null) result = caseRedefinableElement(valueType);
				if (result == null) result = caseType(valueType);
				if (result == null) result = caseTemplateableElement(valueType);
				if (result == null) result = caseNamedElement(valueType);
				if (result == null) result = casePackageableElement(valueType);
				if (result == null) result = caseElement(valueType);
				if (result == null) result = caseParameterableElement(valueType);
				if (result == null) result = caseEModelElement(valueType);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.DIMENSION: {
				Dimension dimension = (Dimension)theEObject;
				T result = caseDimension(dimension);
				if (result == null) result = caseValueType(dimension);
				if (result == null) result = caseDataType(dimension);
				if (result == null) result = caseClassifier(dimension);
				if (result == null) result = caseNamespace(dimension);
				if (result == null) result = caseRedefinableElement(dimension);
				if (result == null) result = caseType(dimension);
				if (result == null) result = caseTemplateableElement(dimension);
				if (result == null) result = caseNamedElement(dimension);
				if (result == null) result = casePackageableElement(dimension);
				if (result == null) result = caseElement(dimension);
				if (result == null) result = caseParameterableElement(dimension);
				if (result == null) result = caseEModelElement(dimension);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.UNIT: {
				Unit unit = (Unit)theEObject;
				T result = caseUnit(unit);
				if (result == null) result = caseValueType(unit);
				if (result == null) result = caseDataType(unit);
				if (result == null) result = caseClassifier(unit);
				if (result == null) result = caseNamespace(unit);
				if (result == null) result = caseRedefinableElement(unit);
				if (result == null) result = caseType(unit);
				if (result == null) result = caseTemplateableElement(unit);
				if (result == null) result = caseNamedElement(unit);
				if (result == null) result = casePackageableElement(unit);
				if (result == null) result = caseElement(unit);
				if (result == null) result = caseParameterableElement(unit);
				if (result == null) result = caseEModelElement(unit);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.BLOCK_PROPERTY: {
				BlockProperty blockProperty = (BlockProperty)theEObject;
				T result = caseBlockProperty(blockProperty);
				if (result == null) result = caseProperty(blockProperty);
				if (result == null) result = caseStructuralFeature(blockProperty);
				if (result == null) result = caseConnectableElement(blockProperty);
				if (result == null) result = caseDeploymentTarget(blockProperty);
				if (result == null) result = caseTemplateableElement(blockProperty);
				if (result == null) result = caseFeature(blockProperty);
				if (result == null) result = caseTypedElement(blockProperty);
				if (result == null) result = caseMultiplicityElement(blockProperty);
				if (result == null) result = caseParameterableElement(blockProperty);
				if (result == null) result = caseNamedElement(blockProperty);
				if (result == null) result = caseElement(blockProperty);
				if (result == null) result = caseRedefinableElement(blockProperty);
				if (result == null) result = caseEModelElement(blockProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.DISTRIBUTED_PROPERTY: {
				DistributedProperty distributedProperty = (DistributedProperty)theEObject;
				T result = caseDistributedProperty(distributedProperty);
				if (result == null) result = caseBlockProperty(distributedProperty);
				if (result == null) result = caseProperty(distributedProperty);
				if (result == null) result = caseStructuralFeature(distributedProperty);
				if (result == null) result = caseConnectableElement(distributedProperty);
				if (result == null) result = caseDeploymentTarget(distributedProperty);
				if (result == null) result = caseTemplateableElement(distributedProperty);
				if (result == null) result = caseFeature(distributedProperty);
				if (result == null) result = caseTypedElement(distributedProperty);
				if (result == null) result = caseMultiplicityElement(distributedProperty);
				if (result == null) result = caseParameterableElement(distributedProperty);
				if (result == null) result = caseNamedElement(distributedProperty);
				if (result == null) result = caseElement(distributedProperty);
				if (result == null) result = caseRedefinableElement(distributedProperty);
				if (result == null) result = caseEModelElement(distributedProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.ITEM_FLOW: {
				ItemFlow itemFlow = (ItemFlow)theEObject;
				T result = caseItemFlow(itemFlow);
				if (result == null) result = caseInformationFlow(itemFlow);
				if (result == null) result = casePackageableElement(itemFlow);
				if (result == null) result = caseDirectedRelationship(itemFlow);
				if (result == null) result = caseNamedElement(itemFlow);
				if (result == null) result = caseParameterableElement(itemFlow);
				if (result == null) result = caseRelationship(itemFlow);
				if (result == null) result = caseElement(itemFlow);
				if (result == null) result = caseEModelElement(itemFlow);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.FLOW_PROPERTY: {
				FlowProperty flowProperty = (FlowProperty)theEObject;
				T result = caseFlowProperty(flowProperty);
				if (result == null) result = caseProperty(flowProperty);
				if (result == null) result = caseStructuralFeature(flowProperty);
				if (result == null) result = caseConnectableElement(flowProperty);
				if (result == null) result = caseDeploymentTarget(flowProperty);
				if (result == null) result = caseTemplateableElement(flowProperty);
				if (result == null) result = caseFeature(flowProperty);
				if (result == null) result = caseTypedElement(flowProperty);
				if (result == null) result = caseMultiplicityElement(flowProperty);
				if (result == null) result = caseParameterableElement(flowProperty);
				if (result == null) result = caseNamedElement(flowProperty);
				if (result == null) result = caseElement(flowProperty);
				if (result == null) result = caseRedefinableElement(flowProperty);
				if (result == null) result = caseEModelElement(flowProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.CONSTRAINT_BLOCK: {
				ConstraintBlock constraintBlock = (ConstraintBlock)theEObject;
				T result = caseConstraintBlock(constraintBlock);
				if (result == null) result = caseBlock(constraintBlock);
				if (result == null) result = caseClass(constraintBlock);
				if (result == null) result = caseEncapsulatedClassifier(constraintBlock);
				if (result == null) result = caseBehavioredClassifier(constraintBlock);
				if (result == null) result = caseStructuredClassifier(constraintBlock);
				if (result == null) result = caseClassifier(constraintBlock);
				if (result == null) result = caseNamespace(constraintBlock);
				if (result == null) result = caseRedefinableElement(constraintBlock);
				if (result == null) result = caseType(constraintBlock);
				if (result == null) result = caseTemplateableElement(constraintBlock);
				if (result == null) result = caseNamedElement(constraintBlock);
				if (result == null) result = casePackageableElement(constraintBlock);
				if (result == null) result = caseElement(constraintBlock);
				if (result == null) result = caseParameterableElement(constraintBlock);
				if (result == null) result = caseEModelElement(constraintBlock);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.TRACE: {
				Trace trace = (Trace)theEObject;
				T result = caseTrace(trace);
				if (result == null) result = caseDependency(trace);
				if (result == null) result = casePackageableElement(trace);
				if (result == null) result = caseDirectedRelationship(trace);
				if (result == null) result = caseNamedElement(trace);
				if (result == null) result = caseParameterableElement(trace);
				if (result == null) result = caseRelationship(trace);
				if (result == null) result = caseElement(trace);
				if (result == null) result = caseEModelElement(trace);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.COPY: {
				Copy copy = (Copy)theEObject;
				T result = caseCopy(copy);
				if (result == null) result = caseTrace(copy);
				if (result == null) result = caseDependency(copy);
				if (result == null) result = casePackageableElement(copy);
				if (result == null) result = caseDirectedRelationship(copy);
				if (result == null) result = caseNamedElement(copy);
				if (result == null) result = caseParameterableElement(copy);
				if (result == null) result = caseRelationship(copy);
				if (result == null) result = caseElement(copy);
				if (result == null) result = caseEModelElement(copy);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.REFINE: {
				Refine refine = (Refine)theEObject;
				T result = caseRefine(refine);
				if (result == null) result = caseTrace(refine);
				if (result == null) result = caseDependency(refine);
				if (result == null) result = casePackageableElement(refine);
				if (result == null) result = caseDirectedRelationship(refine);
				if (result == null) result = caseNamedElement(refine);
				if (result == null) result = caseParameterableElement(refine);
				if (result == null) result = caseRelationship(refine);
				if (result == null) result = caseElement(refine);
				if (result == null) result = caseEModelElement(refine);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.CONSTRAINT_PROPERTY: {
				ConstraintProperty constraintProperty = (ConstraintProperty)theEObject;
				T result = caseConstraintProperty(constraintProperty);
				if (result == null) result = caseBlockProperty(constraintProperty);
				if (result == null) result = caseProperty(constraintProperty);
				if (result == null) result = caseStructuralFeature(constraintProperty);
				if (result == null) result = caseConnectableElement(constraintProperty);
				if (result == null) result = caseDeploymentTarget(constraintProperty);
				if (result == null) result = caseTemplateableElement(constraintProperty);
				if (result == null) result = caseFeature(constraintProperty);
				if (result == null) result = caseTypedElement(constraintProperty);
				if (result == null) result = caseMultiplicityElement(constraintProperty);
				if (result == null) result = caseParameterableElement(constraintProperty);
				if (result == null) result = caseNamedElement(constraintProperty);
				if (result == null) result = caseElement(constraintProperty);
				if (result == null) result = caseRedefinableElement(constraintProperty);
				if (result == null) result = caseEModelElement(constraintProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.CONTAINMENT: {
				Containment containment = (Containment)theEObject;
				T result = caseContainment(containment);
				if (result == null) result = caseDependency(containment);
				if (result == null) result = casePackageableElement(containment);
				if (result == null) result = caseDirectedRelationship(containment);
				if (result == null) result = caseNamedElement(containment);
				if (result == null) result = caseParameterableElement(containment);
				if (result == null) result = caseRelationship(containment);
				if (result == null) result = caseElement(containment);
				if (result == null) result = caseEModelElement(containment);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.REQUIREMENT_RELATED: {
				RequirementRelated requirementRelated = (RequirementRelated)theEObject;
				T result = caseRequirementRelated(requirementRelated);
				if (result == null) result = caseNamedElement(requirementRelated);
				if (result == null) result = caseElement(requirementRelated);
				if (result == null) result = caseEModelElement(requirementRelated);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SysMLPackage.MODEL_SYSML: {
				ModelSYSML modelSYSML = (ModelSYSML)theEObject;
				T result = caseModelSYSML(modelSYSML);
				if (result == null) result = casePackageSYSML(modelSYSML);
				if (result == null) result = casePackage(modelSYSML);
				if (result == null) result = caseNamespace(modelSYSML);
				if (result == null) result = casePackageableElement(modelSYSML);
				if (result == null) result = caseTemplateableElement(modelSYSML);
				if (result == null) result = caseNamedElement(modelSYSML);
				if (result == null) result = caseParameterableElement(modelSYSML);
				if (result == null) result = caseElement(modelSYSML);
				if (result == null) result = caseEModelElement(modelSYSML);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Block</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Block</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseBlock(Block object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Flow Port</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Flow Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseFlowPort(FlowPort object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Service Port</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Service Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseServicePort(ServicePort object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Flow Specification</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Flow Specification</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseFlowSpecification(FlowSpecification object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Block Definition</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Block Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseBlockDefinition(BlockDefinition object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Package SYSML</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Package SYSML</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T casePackageSYSML(PackageSYSML object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Requirement</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRequirement(Requirement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Test Case</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Test Case</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseTestCase(TestCase object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Requirement Definition</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Requirement Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRequirementDefinition(RequirementDefinition object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Satisfy</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Satisfy</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseSatisfy(Satisfy object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Derive Reqt</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Derive Reqt</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDeriveReqt(DeriveReqt object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Verify</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Verify</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseVerify(Verify object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Field</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Field</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseField(Field object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Rationale</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Rationale</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRationale(Rationale object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Problem</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Problem</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseProblem(Problem object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Value Type</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Value Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseValueType(ValueType object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Dimension</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Dimension</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDimension(Dimension object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Unit</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Unit</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseUnit(Unit object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Block Property</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Block Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseBlockProperty(BlockProperty object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Distributed Property</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Distributed Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDistributedProperty(DistributedProperty object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Item Flow</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Item Flow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseItemFlow(ItemFlow object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Flow Property</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Flow Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseFlowProperty(FlowProperty object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Constraint Block</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Constraint Block</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseConstraintBlock(ConstraintBlock object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Trace</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Trace</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseTrace(Trace object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Copy</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Copy</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseCopy(Copy object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Refine</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Refine</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRefine(Refine object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Constraint Property</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Constraint Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseConstraintProperty(ConstraintProperty object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Containment</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Containment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseContainment(Containment object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Requirement Related</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Requirement Related</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRequirementRelated(RequirementRelated object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Model SYSML</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Model SYSML</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseModelSYSML(ModelSYSML object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>EModel Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EModel Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseEModelElement(EModelElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseElement(Element object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Named Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseNamedElement(NamedElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Namespace</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Namespace</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseNamespace(Namespace object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Redefinable Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Redefinable Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRedefinableElement(RedefinableElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Parameterable Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Parameterable Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseParameterableElement(ParameterableElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Packageable Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Packageable Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T casePackageableElement(PackageableElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Type</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseType(Type object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Templateable Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Templateable Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseTemplateableElement(TemplateableElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Classifier</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Classifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseClassifier(Classifier object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Structured Classifier</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Structured Classifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseStructuredClassifier(StructuredClassifier object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Encapsulated Classifier</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Encapsulated Classifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseEncapsulatedClassifier(EncapsulatedClassifier object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Behaviored Classifier</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Behaviored Classifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseBehavioredClassifier(BehavioredClassifier object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Class</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Class</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseClass(org.eclipse.uml2.uml.Class object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Feature</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Feature</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseFeature(Feature object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Typed Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Typed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseTypedElement(TypedElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Multiplicity Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Multiplicity Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseMultiplicityElement(MultiplicityElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Structural Feature</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Structural Feature</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseStructuralFeature(StructuralFeature object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Connectable Element</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Connectable Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseConnectableElement(ConnectableElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Deployment Target</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Deployment Target</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDeploymentTarget(DeploymentTarget object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Property</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseProperty(Property object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Port</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T casePort(Port object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Interface</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Interface</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseInterface(Interface object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Package</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Package</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T casePackage(org.eclipse.uml2.uml.Package object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Behavior</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Behavior</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseBehavior(Behavior object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Relationship</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Relationship</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRelationship(Relationship object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Directed Relationship</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Directed Relationship</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDirectedRelationship(DirectedRelationship object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Dependency</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Dependency</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDependency(Dependency object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Abstraction</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Abstraction</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseAbstraction(Abstraction object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Realization</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Realization</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseRealization(Realization object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Comment</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Comment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseComment(Comment object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Data Type</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Data Type</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseDataType(DataType object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Information Flow</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Information Flow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
    public T caseInformationFlow(InformationFlow object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc --> This implementation returns null; returning a
     * non-null result will terminate the switch, but this is the last case
     * anyway. <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
    public T defaultCase(EObject object)
    {
		return null;
	}

} // SysMLSwitch
