package org.topcased.sysml.util;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.UniqueEList;
import org.eclipse.uml2.uml.ConnectableElement;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.topcased.sysml.FlowPort;

public class SysMLUtils
{
    /**
     * Return the elements which are connected to a connectable element
     * 
     * @param elt the connectable element
     * @return the list of connected elements (a list of ConnectableElement)
     */
    public static EList getConnectedElements(ConnectableElement elt)
    {
        EList result = new UniqueEList();
        for (int i = 0; i < elt.getEnds().size(); i++)
        {
            ConnectorEnd end = (ConnectorEnd) elt.getEnds().get(i);
            if (end.eContainer() instanceof Connector)
            {
                Connector conn = (Connector) end.eContainer();
                for (int j = 0; j < conn.getEnds().size(); j++)
                {
                    ConnectorEnd ce = (ConnectorEnd) conn.getEnds().get(j);
                    if (ce != end && ce.getRole() != null)
                        result.add(ce.getRole());
                }
            }
        }
        return result;
    }

    /**
     * Verify that two flow ports are compatible (i.e. they have type, direction
     * and name matching)
     * 
     * @param fp1
     * @param fp2
     * @return
     */
    public static boolean validateFlowPortsCompatibility(FlowPort fp1, FlowPort fp2)
    {
        return validateFlowPortsTypeCompatibility(fp1, fp2) && validateFlowPortsDirectionCompatibility(fp1, fp2)
                && validateFlowPortsNameCompatibility(fp1, fp2);
    }

    private static boolean validateFlowPortsTypeCompatibility(FlowPort fp1, FlowPort fp2)
    {
        return true;
    }

    private static boolean validateFlowPortsDirectionCompatibility(FlowPort fp1, FlowPort fp2)
    {
        return true;
    }

    private static boolean validateFlowPortsNameCompatibility(FlowPort fp1, FlowPort fp2)
    {
        return true;
    }
}
