/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Jacques Lescot (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.toolkit;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IStartup;

/**
 * @author david
 * 
 */
public class CheckConfiguration implements IStartup
{

    /**
     * @see org.eclipse.ui.IStartup#earlyStartup()
     */
    public void earlyStartup()
    {
        Display.getDefault().syncExec(new Runnable()
        {
            public void run()
            {
                // Check whether a JVM 1.5 or 1.6 is installed
                if (!(System.getProperty("java.version").startsWith("1.5") || System.getProperty("java.version").startsWith("1.6")))
                {
                    // Open a warning message indicating that a JRE 1.5 should be used with Topcased
                    MessageDialog.openWarning(Display.getDefault().getActiveShell(), "JVM Requirement for TOPCASED",
                            "It seems that you are not using a JRE 1.5 or greater. TOPCASED environment requires a JRE 1.5 or greater to correctly work.");
                }
            }
        });
    }

}
