package org.topcased.traceability.analyzers.openOffice;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import tte.analyzers.IAnalyzer;
import tte.exceptions.AnalyzerMethodException;
import tte.exceptions.ConversionException;
import tte.exceptions.EditionException;
import ttm.Document;
import ttm.Element;

public class OpenOfficeAnalyzer implements IAnalyzer {

	private static List<String> CONVERT_METHODS = initConvertMethods();
	private static List<String> EDIT_METHODS = initEditMethods();

	private static List<String> initConvertMethods() {
		List<String> list = new ArrayList<String>();
		list.add(0, "OpenOfficeWriterConversion_0.1.0");
		return list;
	}

	private static List<String> initEditMethods() {
		List<String> list = new ArrayList<String>();
		list.add(0, "OpenOfficeWriterEdition_0.1.0");
		return list;
	}

	public void executeConversionMethodID(String id, File inFile, File outFile,
			String conversionDefaultArguments, Document document)
			throws AnalyzerMethodException, ConversionException {

		switch (CONVERT_METHODS.indexOf(id)) {
		case 0:
			String args = "";
			if (conversionDefaultArguments != null)
				args = conversionDefaultArguments + " ";

			ODTConverter.convertDocumentToTRAMwayFormat_0_1_0(inFile, outFile,
					args + document.getAnalyzerArguments(), document);
			break;
		default:
			throw new AnalyzerMethodException(
					"Cannot find method which id is '" + id + "'");
		}
	}

	public void executeEditionMethodID(String id, Document document,
			Element element) throws AnalyzerMethodException, EditionException {

		switch (EDIT_METHODS.indexOf(id)) {

		case 0:
			ODTEditor.editElement(document, element);
			break;
		default:
			throw new AnalyzerMethodException(
					"Cannot find method which id is '" + id + "'");
		}
	}

}
