package org.topcased.traceability.hmi.actions;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IViewActionDelegate;
import org.topcased.traceability.hmi.TtmImageRegistry;
import org.topcased.traceability.hmi.TtmPlugin;

import tte.impl.Engine;
import ttm.Project;

public class PrintRulesReportActionDelegate extends ProjectActionDelegate  implements IEditorActionDelegate, IViewActionDelegate, Runnable
{    
	 public PrintRulesReportActionDelegate()
	 {
	      this(null);
	 }
	
    /**
     * Constructor with the selectedProject used by the action
     * @param selectedProject
     */
    public PrintRulesReportActionDelegate(Project selectedProject)
    {
    	super("Print Rules Report",TtmImageRegistry.getImageDescriptor("PRINT_RULES_REPORT_ACTION"));
    }
    
	@Override
	protected IRunnableWithProgress createAction() {
		return new PrintRulesReportAction();
	}

    
    class PrintRulesReportAction implements IRunnableWithProgress {
    	
    	public void run(IProgressMonitor monitor)
        {
    		Project p = getSelectedProject(); 
            if( p != null)
            {
            	final Engine engine = new Engine();
    			
            	Display.getDefault().syncExec(new Runnable() {
            		public void run() {
                    	FileDialog d = new FileDialog(Display.getDefault().getActiveShell(), SWT.SAVE);
                    	d.setFilterExtensions(new String[]{"*.xml"});
                    	String fileName = d.open();
                    	if (fileName != null) {
                    		try {
                				engine.printRulesReport(getSelectedProject(), fileName);
                				refreshNavigationView();
                			} catch (Exception e) {
                				MessageDialog.openError(TtmPlugin.getActiveWorkbenchShell(), "Report printing", e.getMessage());
            				}
                    	}
            		}
            	});
            }
        }
    	
    }


}
