package org.topcased.traceability.hmi.editor;

import java.util.HashMap;

import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.ui.actions.ActionRegistry;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuManager;
import org.topcased.modeler.editor.ModelerContextMenuProvider;
import org.topcased.traceability.hmi.modeler.actions.DeleteCoverPointAction;

public class TtmContextMenuManager extends ModelerContextMenuProvider {
	
	private HashMap<String, IAction> actionsMap;

	public TtmContextMenuManager(EditPartViewer viewer, ActionRegistry registry) {
		super(viewer, registry);
		actionsMap = new HashMap<String, IAction>();
	}

	@Override
	public void buildContextMenu(IMenuManager manager) {
		super.buildContextMenu(manager);
		/*
		IAction action;
		Set<String> actionIds = actionsMap.keySet();
		for (Iterator<String> it = actionIds.iterator() ; it.hasNext() ; ) {
			
			String id = it.next();
			
			action = getActionRegistry().getAction(id);
			if (action != null && action.isEnabled()) {
				manager.appendToGroup(GEFActionConstants.GROUP_EDIT, action);
			}
			
		}
		*/
		
		IAction action;
		action = getActionRegistry().getAction(DeleteCoverPointAction.ID);
		if (action.isEnabled()) {
			manager.appendToGroup(GEFActionConstants.GROUP_EDIT, action);
		}
		
		
	}
	
	public void addAction(String id, IAction action) {
		actionsMap.put(id, action);
	}
	
}
