/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.editor;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.ContextMenuProvider;
import org.eclipse.gef.ui.actions.ActionRegistry;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.ui.views.contentoutline.IContentOutlinePage;
import org.topcased.modeler.documentation.EAnnotationDocPage;
import org.topcased.modeler.documentation.IDocPage;
import org.topcased.modeler.editor.Modeler;
import org.topcased.modeler.editor.ModelerGraphicalViewer;
import org.topcased.traceability.hmi.TtmPlugin;
import org.topcased.traceability.hmi.modeler.actions.DeleteCoverPointAction;
import org.topcased.traceability.hmi.providers.TtmModelerProviderAdapterFactory;
import org.topcased.traceability.hmi.ui.outline.TtmOutlinePage;

/**
 * Generated Model editor
 *
 * @generated
 */
public class TtmEditor extends Modeler {

	@Override
	protected void createActions() {
        super.createActions();
        
        IAction action = new DeleteCoverPointAction(this);
        ActionRegistry registry = getActionRegistry();
        registry.registerAction(action);
        getSelectionActions().add(action.getId());
        
        
	}
	
	/**
	 * @see org.topcased.modeler.editor.Modeler#getAdapterFactories()
	 * @generated
	 */
	protected List getAdapterFactories() {
		List factories = new ArrayList();
		factories.add(new ttm.provider.TtmItemProviderAdapterFactory());
		factories
				.add(new TtmModelerProviderAdapterFactory());

		factories.addAll(super.getAdapterFactories());

		return factories;
	}

	/**
	 * @see org.topcased.modeler.editor.Modeler#getId()
	 */
	public String getId() {
		return new String("org.topcased.traceability.hmi.editor.TtmEditor");
	}

	/**
	 * @see org.topcased.modeler.editor.Modeler#getAdapter(java.lang.Class)
	 * @generated
	 */
	public Object getAdapter(Class type) {
		if (type == IDocPage.class) {
			return new EAnnotationDocPage(getCommandStack());
		}
		return super.getAdapter(type);
	}

	/**
	 * @see org.topcased.modeler.editor.Modeler#getPreferenceStore()
	 * @generated
	 */
	public IPreferenceStore getPreferenceStore() {
		return TtmPlugin.getDefault().getPreferenceStore();
	}

	@Override
    protected IContentOutlinePage createOutlinePage()
    {     
        return new TtmOutlinePage(this);
    } 

	@Override
	protected ContextMenuProvider getContextMenuProvider(
			ModelerGraphicalViewer viewer) {
		return new TtmContextMenuManager(viewer, getActionRegistry());
	}
	
    /**
     * @see org.topcased.modeler.editor.Modeler#configureGraphicalViewer()
     */
    protected void configureGraphicalViewer()
    {
        super.configureGraphicalViewer();

        IAction deleteImplementLinkAction = getActionRegistry().getAction(DeleteCoverPointAction.ID);
        getGraphicalViewer().addSelectionChangedListener((ISelectionChangedListener) deleteImplementLinkAction);
    }
	
}
