/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.modeler;

import org.eclipse.emf.ecore.EObject;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.editor.AbstractCreationUtils;
import org.topcased.modeler.evaluator.EvaluatorException;
import org.topcased.modeler.evaluator.extension.EvaluatorsManager;
import org.topcased.modeler.graphconf.DiagramGraphConf;

import ttm.util.TtmSwitch;

/**
 * This utility class allows to create a GraphElement associated with a Model Object
 *
 * @generated
 */
public class TWCreationUtils extends AbstractCreationUtils {

	/**
	 * Constructor
	 *
	 * @param diagramConf the Diagram Graphical Configuration
	 * @generated
	 */
	public TWCreationUtils(DiagramGraphConf diagramConf) {
		super(diagramConf);
	}

	/**
	 * @generated
	 */
	private class GraphicTtmSwitch extends TtmSwitch {
		/**
		 * The presentation of the graphical element
		 *
		 * @generated
		 */
		private String presentation;

		/**
		 * Constructor
		 *
		 * @param presentation the presentation of the graphical element
		 * @generated
		 */
		public GraphicTtmSwitch(String presentation) {
			this.presentation = presentation;
		}

		/**
		 * @see ttm.util.TtmSwitch#caseDocument(ttm.Document)
		 * @generated
		 */
		public Object caseDocument(ttm.Document object) {
			if ("default".equals(presentation)) {
				return createGraphElementDocument(object, presentation);
			}
			return null;
		}

		/**
		 * @see ttm.util.TtmSwitch#caseCoverPoint(ttm.CoverPoint)
		 * @generated
		 */
		public Object caseCoverPoint(ttm.CoverPoint object) {
			try {
				if ("default".equals(presentation)
						&& EvaluatorsManager.getInstance().evaluate(object,
								"self.andCover=false", "ocl")) {
					return createGraphElementOrCoverPoint(object, presentation);
				}
			} catch (EvaluatorException ee) {
				TWPlugin.log(ee);
			}
			try {
				if ("default".equals(presentation)
						&& EvaluatorsManager.getInstance().evaluate(object,
								"self.andCover=true", "ocl")) {
					return createGraphElementAndCoverPoint(object, presentation);
				}
			} catch (EvaluatorException ee) {
				TWPlugin.log(ee);
			}
			return null;
		}

		/**
		 * @see ttm.util.TtmSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
		 * @generated
		 */
		public Object defaultCase(EObject object) {
			return null;
		}
	}

	/**
	 * @see org.topcased.modeler.editor.ICreationUtils#createGraphElement(org.eclipse.emf.ecore.EObject, java.lang.String)
	 * @generated
	 */
	public GraphElement createGraphElement(EObject obj, String presentation) {
		Object graphElt = null;

		if ("http://org.topcased.traceability.model".equals(obj.eClass()
				.getEPackage().getNsURI())) {
			graphElt = new GraphicTtmSwitch(presentation).doSwitch(obj);
		}

		return (GraphElement) graphElt;
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementDocument(ttm.Document element,
			String presentation) {
		return createGraphNode(element, presentation);
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementOrCoverPoint(
			ttm.CoverPoint element, String presentation) {
		return createGraphNode(element, presentation);
	}

	/**
	 * @param element the model element
	 * @param presentation the presentation of the graphical element
	 * @return the complete GraphElement
	 * @generated
	 */
	protected GraphElement createGraphElementAndCoverPoint(
			ttm.CoverPoint element, String presentation) {
		return createGraphNode(element, presentation);
	}

	/**
	 * Create the ModelObject with its initial children
	 * 
	 * @param obj the model object
	 * @return the model object with its children
	 * @generated
	 */
	public EObject createModelObject(EObject obj) {
		return obj;
	}

}
