/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.modeler;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.topcased.modeler.di.model.Diagram;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.di.model.SimpleSemanticModelElement;
import org.topcased.modeler.edit.EMFGraphEdgeEditPart;
import org.topcased.modeler.edit.EMFGraphNodeEditPart;
import org.topcased.modeler.edit.GraphEdgeEditPart;
import org.topcased.modeler.edit.GraphNodeEditPart;
import org.topcased.modeler.evaluator.EvaluatorException;
import org.topcased.modeler.evaluator.extension.EvaluatorsManager;
import org.topcased.modeler.utils.Utils;
import org.topcased.traceability.hmi.modeler.edit.AndCoverPointEditPart;
import org.topcased.traceability.hmi.modeler.edit.CoverPointEditPart;
import org.topcased.traceability.hmi.modeler.edit.CoversEditPart;
import org.topcased.traceability.hmi.modeler.edit.DocumentEditPart;
import org.topcased.traceability.hmi.modeler.edit.OrCoverPointEditPart;
import org.topcased.traceability.hmi.modeler.edit.TWDiagramEditPart;

import ttm.util.TtmSwitch;

/**
 * Part Factory : associates a model object to its controller. <br>
 *
 * @generated
 */
public class TWEditPartFactory implements EditPartFactory {
	/**
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,java.lang.Object)
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof Diagram) {
			return new TWDiagramEditPart((Diagram) model);
		} else if (model instanceof GraphNode) {
			final GraphNode node = (GraphNode) model;
			EObject element = Utils.getElement(node);
			if (element != null) {
								if ("http://org.topcased.traceability.model".equals(element
						.eClass().getEPackage().getNsURI())) {
					return (EditPart) new NodeTtmSwitch(node).doSwitch(element);
				}
	            return new EMFGraphNodeEditPart(node);
			}

			if (node.getSemanticModel() instanceof SimpleSemanticModelElement) {
				// Manage the Element that are not associated with a model object
			}
			return new GraphNodeEditPart(node);
		} else if (model instanceof GraphEdge) {
			final GraphEdge edge = (GraphEdge) model;
			EObject element = Utils.getElement(edge);
			if (element != null) {
				if ("http://org.topcased.traceability.model".equals(element
						.eClass().getEPackage().getNsURI())) {
					return (EditPart) new EdgeTtmSwitch(edge).doSwitch(element);
				}
	            return new EMFGraphEdgeEditPart(edge);
			}

			if (edge.getSemanticModel() instanceof SimpleSemanticModelElement) {
				// Manage the Element that are not associated with a model object
				if (TWSimpleObjectConstants.SIMPLE_OBJECT_COVERS
						.equals(((SimpleSemanticModelElement) edge
								.getSemanticModel()).getTypeInfo())) {
					return new CoversEditPart(edge);
				}
			}

			return new GraphEdgeEditPart(edge);
		}

		throw new IllegalStateException(
				"No edit part matches with the '"
						+ model.getClass().getName()
						+ "' model element. Check TWEditPartFactory#createEditPart(EditPart,Object) class");
	}

	/**
	 * @generated
	 */
	private class NodeTtmSwitch extends TtmSwitch {
		/**
		 * The graphical node
		 * @generated
		 */
		private GraphNode node;

		/**
		 * Constructor
		 * 
		 * @param node the graphical node
		 * @generated
		 */
		public NodeTtmSwitch(GraphNode node) {
			this.node = node;
		}

		/**
		 * @see ttm.util.TtmSwitch#caseDocument(ttm.Document)
		 * @generated
		 */
		public Object caseDocument(ttm.Document object) {
			return new DocumentEditPart(node);
		}

		/**
		 * @see ttm.util.TtmSwitch#caseCoverPoint(ttm.CoverPoint)
		 * @generated
		 */
		public Object caseCoverPoint(ttm.CoverPoint object) {
			try {
				if (EvaluatorsManager.getInstance().evaluate(object,
						"self.andCover=false", "ocl")) {
					return new OrCoverPointEditPart(node);
				}
			} catch (EvaluatorException ee) {
				TWPlugin.log(ee);
			}
			try {
				if (EvaluatorsManager.getInstance().evaluate(object,
						"self.andCover=true", "ocl")) {
					return new AndCoverPointEditPart(node);
				}
			} catch (EvaluatorException ee) {
				TWPlugin.log(ee);
			}
			return new CoverPointEditPart(node);
		}

		/**
		 * @see ttm.util.TtmSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
		 * @generated
		 */
		public Object defaultCase(EObject object) {
			return new EMFGraphNodeEditPart(node);
		}
	}

	/**
	 * @generated
	 */
	private class EdgeTtmSwitch extends TtmSwitch {
		/**
		 * The graphical edge
		 * @generated
		 */
		private GraphEdge edge;

		/**
		 * Constructor
		 * 
		 * @param edge the graphical edge
		 * @generated
		 */
		public EdgeTtmSwitch(GraphEdge edge) {
			this.edge = edge;
		}

		/**
		 * @see ttm.util.TtmSwitch#defaultCase(org.eclipse.emf.ecore.EObject)
		 * @generated
		 */
		public Object defaultCase(EObject object) {
			return new EMFGraphEdgeEditPart(edge);
		}
	}

}