/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.modeler;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.requests.CreationFactory;
import org.topcased.modeler.editor.GraphElementCreationFactory;
import org.topcased.modeler.editor.ICreationUtils;
import org.topcased.modeler.editor.palette.ModelerConnectionCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerCreationToolEntry;
import org.topcased.modeler.editor.palette.ModelerPaletteManager;

import ttm.CoverPoint;
import ttm.TtmPackage;

/**
 * Generated Palette Manager
 *
 * @generated
 */
public class TWPaletteManager extends ModelerPaletteManager {
	// declare all the palette categories of the diagram
	/**
	 * @generated
	 */
	private PaletteDrawer objectsDrawer;

	/**
	 * @generated
	 */
	private ICreationUtils creationUtils;

	/**
	 * The Constructor
	 *
	 * @param utils the creation utils for the tools of the palette 
	 * @generated
	 */
	public TWPaletteManager(ICreationUtils utils) {
		super();
		this.creationUtils = utils;
	}

	/**
	 * Creates the main categories of the palette
	 *
	 * @generated
	 */
	protected void createCategories() {
		createObjectsDrawer();
	}

	/**
	 * Updates the main categories of the palette
	 *
	 * @generated
	 */
	protected void updateCategories() {
		// deletion of the existing categories and creation of the updated categories

		getRoot().remove(objectsDrawer);
		createObjectsDrawer();
	}

	/**
	 * Creates the Palette container containing all the Palette entries for each figure.
	 *
	 * @generated NOT
	 */
	private void createObjectsDrawer() {
		objectsDrawer = new PaletteDrawer("Objects", null);
		List entries = new ArrayList();

		CreationFactory factory;

		factory = new GraphElementCreationFactory(creationUtils,
				TtmPackage.eINSTANCE.getDocument(), "default");
		entries.add(new ModelerCreationToolEntry("Document", "Document",
				factory, TWImageRegistry.getImageDescriptor("DOCUMENT"),
				TWImageRegistry.getImageDescriptor("DOCUMENT_LARGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				TWSimpleObjectConstants.SIMPLE_OBJECT_COVERS, "default", false);
		entries.add(new ModelerConnectionCreationToolEntry("Covers", "Covers",
				factory, TWImageRegistry.getImageDescriptor("COVERS"),
				TWImageRegistry.getImageDescriptor("COVERS_LARGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				TtmPackage.eINSTANCE.getCoverPoint(), "default") {
			public EObject getNewModelObject() {
				CoverPoint element = (CoverPoint) super.getNewModelObject();
				element.setAndCover(false);
				return element;
			}
		};
		entries.add(new ModelerCreationToolEntry("Or Cover Point",
				"Or Cover Point", factory, TWImageRegistry
						.getImageDescriptor("ORCOVERPOINT"), TWImageRegistry
						.getImageDescriptor("ORCOVERPOINT_LARGE")));

		factory = new GraphElementCreationFactory(creationUtils,
				TtmPackage.eINSTANCE.getCoverPoint(), "default") {
			public EObject getNewModelObject() {
				CoverPoint element = (CoverPoint) super.getNewModelObject();
				element.setAndCover(true);
				return element;
			}
		};
		entries.add(new ModelerCreationToolEntry("And Cover Point",
				"And Cover Point", factory, TWImageRegistry
						.getImageDescriptor("ANDCOVERPOINT"), TWImageRegistry
						.getImageDescriptor("ANDCOVERPOINT_LARGE")));

		objectsDrawer.addAll(entries);
		getRoot().add(objectsDrawer);
	}

}
