package org.topcased.traceability.hmi.modeler.actions;

import org.eclipse.emf.common.util.EList;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.WorkbenchPartAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.ui.IWorkbenchPart;
import org.topcased.modeler.edit.EMFGraphNodeEditPart;
import org.topcased.traceability.hmi.modeler.TtmRequestConstants;
import org.topcased.traceability.hmi.modeler.edit.CoversEditPart;

import ttm.CoverPoint;
import ttm.Document;

public class DeleteCoverPointAction extends WorkbenchPartAction implements ISelectionChangedListener{

		public static final String ID = "Delete Cover Point";

		public DeleteCoverPointAction(IWorkbenchPart arg0) {
			super(arg0);
			// TODO Auto-generated constructor stub
		}

		@Override
		protected boolean calculateEnabled() {
			return coversEditPart != null;
		}

		/**
	     * The EditPart object
	     */
	    private CoversEditPart coversEditPart;
		
		public void selectionChanged(SelectionChangedEvent event) {
						
			ISelection s = event.getSelection();
	        if (!(s instanceof IStructuredSelection))
	        {
	            return;
	        }
	        IStructuredSelection selection = (IStructuredSelection) s;
	        coversEditPart = null;

	        if (selection != null && selection.size() == 1)
	        {
	            Object obj = selection.getFirstElement();
	            if (obj instanceof CoversEditPart)
	            {
	                coversEditPart = (CoversEditPart) obj;
	            }
	        }

	        refresh();
			
		}
				@Override
		public void run() {

			
			if (coversEditPart!=null) {
				
							
				Document doc  = (Document) (((EMFGraphNodeEditPart) coversEditPart.getSource()).getEObject());
				CoverPoint cp  = (CoverPoint) (((EMFGraphNodeEditPart) coversEditPart.getTarget()).getEObject());
				
				EList edgeObjects = coversEditPart.getEdgeObjects();
				
				EList connectedDocuments = cp.getConnectedDocuments();
				connectedDocuments.remove(doc);
			
				
				Request request = new Request(TtmRequestConstants.REQ_DELETE_COVER_LINK);
				Command command = coversEditPart.getCommand(request);
				
				getCommandStack().execute(command);
				
			}
			
		}
		
		protected void init()
	    {
	        setId(DeleteCoverPointAction.ID);
	        setText("Delete From Model");
	    }
		
		@Override
		public String getId() {
			return ID;
		}
		
	}