/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.modeler.commands;

import java.util.Iterator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.topcased.modeler.ModelerPropertyConstants;
import org.topcased.modeler.commands.AbstractRestoreConnectionCommand;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.di.model.GraphElement;
import org.topcased.modeler.di.model.util.DIUtils;
import org.topcased.modeler.utils.Utils;
import org.topcased.traceability.hmi.modeler.TWSimpleObjectConstants;

import ttm.CoverPoint;
import ttm.Document;

/**
 * Document restore connection command
 * 
 * @generated
 */
public class DocumentRestoreConnectionCommand extends
		AbstractRestoreConnectionCommand {
	/**
	 * @param part the EditPart that is restored
	 * @generated
	 */
	public DocumentRestoreConnectionCommand(EditPart part) {
		super(part);
	}

	/**
	 * @see org.topcased.modeler.commands.AbstractRestoreConnectionCommand#initializeCommands()
	 * @generated
	 */
	protected void initializeCommands() {

		GraphElement elt = getGraphElement();
		EObject eltObject = Utils.getElement(elt);

		if (eltObject instanceof Document) {
			Iterator itDiagContents = getModeler().getActiveDiagram()
					.eAllContents();
			while (itDiagContents.hasNext()) {
				Object obj = itDiagContents.next();
				// FIXME Change the way to handle EList GraphNodes
				if (obj instanceof GraphElement
						&& DIUtils
								.getProperty(
										(GraphElement) obj,
										ModelerPropertyConstants.ESTRUCTURAL_FEATURE_ID) == null) {
					boolean autoRef = obj.equals(elt);
					GraphElement elt2 = (GraphElement) obj;
					EObject eltObject2 = Utils.getElement(elt2);
					if (eltObject2 instanceof CoverPoint) {
						if (autoRef) {
							// autoRef not allowed
						} else {
							// if the elt is the source of the edge or if it is the target and that the SourceTargetCouple is reversible
							createCoversFromDocumentToCoverPoint(elt, elt2);
						}
					}
				}
			}
		}
	}

	/**
	 * @param srcElt the source element
	 * @param targetElt the target element
	 * @generated
	 */
	private void createCoversFromDocumentToCoverPoint(GraphElement srcElt,
			GraphElement targetElt) {
		Document sourceObject = (Document) Utils.getElement(srcElt);
		CoverPoint targetObject = (CoverPoint) Utils.getElement(targetElt);

		if (targetObject.getConnectedDocuments().contains(sourceObject)) {
			// check if the relation does not exists yet
			if (getExistingEdges(srcElt, targetElt,
					TWSimpleObjectConstants.SIMPLE_OBJECT_COVERS).size() == 0) {
				GraphEdge edge = Utils
						.createGraphEdge(TWSimpleObjectConstants.SIMPLE_OBJECT_COVERS);
				CoversEdgeCreationCommand cmd = new CoversEdgeCreationCommand(
						null, edge, srcElt, false);
				cmd.setTarget(targetElt);
				add(cmd);
			}
		}
	}

}