/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.modeler.edit;

import org.eclipse.gef.commands.Command;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.traceability.hmi.modeler.TWEditPolicyConstants;
import org.topcased.traceability.hmi.modeler.commands.AndCoverPointRestoreConnectionCommand;
import org.topcased.traceability.hmi.modeler.policies.CoversEdgeCreationEditPolicy;

/**
 * The AndCoverPoint object controller
 *
 * @generated
 */
public class AndCoverPointEditPart extends
		CommonCoverPointEditPart {
	/**
	 * Constructor
	 *
	 * @param obj the graph node
	 * @generated
	 */
	public AndCoverPointEditPart(GraphNode obj) {
		super(obj);
	}

	/**
	 * Creates edit policies and associates these with roles
	 *
	 * @generated NOT
	 */
	protected void createEditPolicies() {
		super.createEditPolicies();

		installEditPolicy(TWEditPolicyConstants.COVERS_EDITPOLICY, new CoversEdgeCreationEditPolicy());
		
		installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY,
				new RestoreEditPolicy() {
					protected Command getRestoreConnectionsCommand(
							RestoreConnectionsRequest request) {
						return new AndCoverPointRestoreConnectionCommand(
								getHost());
					}
				});

	}
	
}