package org.topcased.traceability.hmi.modeler.edit;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.swt.graphics.Color;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.PortEditPart;
import org.topcased.traceability.hmi.modeler.figures.AndCoverPointFigure;
import org.topcased.traceability.hmi.modeler.figures.CommonCoverPointFigure;
import org.topcased.traceability.hmi.modeler.figures.OrCoverPointFigure;

import ttm.CoverPoint;

public class CommonCoverPointEditPart extends PortEditPart {

	public CommonCoverPointEditPart(GraphNode obj) {
		// TODO Auto-generated constructor stub
		super(obj);
	}

	/**
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 * @generated
	 */
	protected IFigure createFigure() {
		IFigure res = null;
		EObject object = getEObject();
		
		if (object instanceof CoverPoint) {
			CoverPoint cp = (CoverPoint) object;
			
			if (cp.isAndCover()) {
				res = new AndCoverPointFigure();
			} else {
				res = new OrCoverPointFigure();
			}
		}
	
		return res;
	}
	
	@Override
	protected void refreshVisuals() {

		// TODO Auto-generated method stub
		super.refreshVisuals();
		
		CommonCoverPointFigure figure = (CommonCoverPointFigure) getFigure();
		figure.setIsAnd(getCoverPoint().isAndCover());
		figure.repaint();
		
	}
	
	@Override
	protected void refreshColors() {
		
		/*
		// Refresh the background color of the graphical element
        Color backgroundColor = Utils.getBackgroundColor(getGraphNode());
        if (backgroundColor == null)
        {
            backgroundColor = getDefaultBackgroundColor();
        }
        getFigure().setBackgroundColor(backgroundColor);

        // Refresh the foreground color of the graphical element
        Color foregroundColor = Utils.getForegroundColor(getGraphNode());
        if (foregroundColor == null)
        {
            foregroundColor = getDefaultForegroundColor();
        }
        getFigure().setForegroundColor(foregroundColor);	
        */

		// AndCoverPointEditPart and = new AndCoverPointEditPart(getGraphNode()); 
		
		Color andNodeBackgroundColor = ColorConstants.lightBlue;
		Color orNodeBackgroundColor = ColorConstants.yellow;
				
		
		if (getCoverPoint().isAndCover()) {
			getFigure().setBackgroundColor(andNodeBackgroundColor);
		} else {
			getFigure().setBackgroundColor(orNodeBackgroundColor);
		}
		
		getFigure().setForegroundColor(ColorConstants.black);
		
		
	}
	
	protected CoverPoint getCoverPoint() {
		EObject object = getEObject();
		CoverPoint res = null;
		if (object instanceof CoverPoint) {
			res  = (CoverPoint) object;
		}
		return res;
	}
	
	
	
}