/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.modeler.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphNode;
import org.topcased.modeler.edit.policies.RestoreEditPolicy;
import org.topcased.modeler.requests.RestoreConnectionsRequest;
import org.topcased.traceability.hmi.modeler.TWEditPolicyConstants;
import org.topcased.traceability.hmi.modeler.commands.CoverPointRestoreConnectionCommand;
import org.topcased.traceability.hmi.modeler.figures.CoverPointFigure;
import org.topcased.traceability.hmi.modeler.policies.CoversEdgeCreationEditPolicy;

/**
 * The CoverPoint object controller
 *
 * @generated
 */
public class CoverPointEditPart extends org.topcased.modeler.edit.PortEditPart {
	/**
	 * Constructor
	 *
	 * @param obj the graph node
	 * @generated
	 */
	public CoverPointEditPart(GraphNode obj) {
		super(obj);
	}

	/**
	 * Creates edit policies and associates these with roles
	 *
	 * @generated
	 */
	protected void createEditPolicies() {
		super.createEditPolicies();

		installEditPolicy(TWEditPolicyConstants.COVERS_EDITPOLICY,
				new CoversEdgeCreationEditPolicy());

		installEditPolicy(ModelerEditPolicyConstants.RESTORE_EDITPOLICY,
				new RestoreEditPolicy() {
					protected Command getRestoreConnectionsCommand(
							RestoreConnectionsRequest request) {
						return new CoverPointRestoreConnectionCommand(getHost());
					}
				});

	}

	/**
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 * @generated
	 */
	protected IFigure createFigure() {

		return new CoverPointFigure();
	}

}