/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.modeler.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.topcased.modeler.ModelerEditPolicyConstants;
import org.topcased.modeler.di.model.GraphEdge;
import org.topcased.modeler.edit.GraphEdgeEditPart;
import org.topcased.traceability.hmi.modeler.TtmRequestConstants;
import org.topcased.traceability.hmi.modeler.commands.DeleteCoverLinkCommand;
import org.topcased.traceability.hmi.modeler.figures.CoversFigure;

/**
 * Covers controller
 *
 * @generated
 */
public class CoversEditPart extends GraphEdgeEditPart {

	/**
	 * Constructor
	 *
	 * @param model the graph object
	 * @generated
	 */
	public CoversEditPart(GraphEdge model) {
		super(model);
	}

	/**
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 * @generated
	 */
	protected void createEditPolicies() {
		super.createEditPolicies();

		installEditPolicy(ModelerEditPolicyConstants.CHANGE_FONT_EDITPOLICY,
				null);

	}

	/**
	 * @return the Figure
	 * @generated
	 */
	protected IFigure createFigure() {
		CoversFigure connection = new CoversFigure();

		createTargetDecoration(connection);

		return connection;
	}

	/**
	 * @param connection the PolylineConnection
	 * @generated
	 */
	private void createTargetDecoration(PolylineConnection connection) {

		PolylineDecoration decoration = new PolylineDecoration();
		decoration.setScale(10, 5);
		connection.setTargetDecoration(decoration);

	}

	@Override
	public Command getCommand(Request request) {
		Command result = null;
		if (request.getType().equals(TtmRequestConstants.REQ_DELETE_COVER_LINK)) {
			DeleteCoverLinkCommand delete = new DeleteCoverLinkCommand();
			delete.setPartToBeDeleted(this.getModel());
			result = delete;
		} else {
			result = super.getCommand(request);
		}
		return result;
	}
	
}