//------------------------------------------------
// $Id: FilenameSection.java,v 1.1 2007-05-22 10:23:54 matg Exp $
// (c) Anyware Technologies 2007    www.anyware-tech.com
//------------------------------------------------
package org.topcased.traceability.hmi.properties.document;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.topcased.tabbedproperties.sections.AbstractFileChooserPropertySection;

import ttm.TtmPackage;

/**
 * 
 * Section use to display the Filename property of a Document
 * <br>
 * creation : 5 avr. 07
 *
 * @author <a href="mailto:mickael.gerard@anyware-tech.com">Mickael Gerard</a>
 */
public class FilenameSection extends AbstractFileChooserPropertySection
{
   

    @Override
    protected String getLabelText()
    {      
        return "Filename";
    }

    @Override
    protected String getFeatureValue()
    {        
        String string = getEObject() == null ? null : (String) getEObject().eGet(getFeature());
        if (string == null)
        {
            return "";
        }
        return string;
    }

    @Override
    protected EStructuralFeature getFeature()
    {        
        return TtmPackage.eINSTANCE.getDocument_Filename();
    }
    
    
    @Override
    public boolean isCheckFileExistence()
    {
        return true;
    }
    
    @Override
    public boolean cannotBeBlank()
    {
         return true;
    }
}
