/*******************************************************************************
 * No CopyrightText Defined in the configurator file.
 ******************************************************************************/
package org.topcased.traceability.hmi.providers;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.topcased.modeler.providers.ILabelFeatureProvider;

import ttm.util.TtmAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers. The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The adapters also support Eclipse property sheets. Note that most of the adapters are shared among multiple instances.
 * 
 * @generated
 */
public class TtmModelerProviderAdapterFactory extends TtmAdapterFactory
		implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * 
	 * @generated
	 */
	private ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * 
	 * @generated
	 */
	private IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * 
	 * @generated
	 */
	private Collection supportedTypes = new ArrayList();

	/**
	 * This keeps track of the one adapter used for all {@link ttm.Document} instances.
	 * 
	 * @generated
	 */
	private DocumentModelerProvider documentModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.Section} instances.
	 * 
	 * @generated
	 */
	private SectionModelerProvider sectionModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.HierarchicalElement} instances.
	 * 
	 * @generated
	 */
	private HierarchicalElementModelerProvider hierarchicalelementModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.IdentifiedElement} instances.
	 * 
	 * @generated
	 */
	private IdentifiedElementModelerProvider identifiedelementModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.Text} instances.
	 * 
	 * @generated
	 */
	private TextModelerProvider textModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.Attribute} instances.
	 * 
	 * @generated
	 */
	private AttributeModelerProvider attributeModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.Requirement} instances.
	 * 
	 * @generated
	 */
	private RequirementModelerProvider requirementModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.CoverLink} instances.
	 * 
	 * @generated
	 */
	private CoverLinkModelerProvider coverlinkModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.NavigationLink} instances.
	 * 
	 * @generated
	 */
	private NavigationLinkModelerProvider navigationlinkModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.AbstractLink} instances.
	 * 
	 * @generated
	 */
	private AbstractLinkModelerProvider abstractlinkModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.Project} instances.
	 * 
	 * @generated
	 */
	private ProjectModelerProvider projectModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.Element} instances.
	 * 
	 * @generated
	 */
	private ElementModelerProvider elementModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.RuleInstance} instances.
	 * 
	 * @generated
	 */
	private RuleInstanceModelerProvider ruleinstanceModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.AttributeOwner} instances.
	 * 
	 * @generated
	 */
	private AttributeOwnerModelerProvider attributeownerModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.Rule} instances.
	 * 
	 * @generated
	 */
	private RuleModelerProvider ruleModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.CoverageResult} instances.
	 * 
	 * @generated
	 */
	private CoverageResultModelerProvider coverageresultModelerProvider;

	/**
	 * This keeps track of the one adapter used for all {@link ttm.CoverPoint} instances.
	 * 
	 * @generated
	 */
	private CoverPointModelerProvider coverpointModelerProvider;

	/**
	 * This constructs an instance.
	 * 
	 * @generated
	 */
	public TtmModelerProviderAdapterFactory() {
		supportedTypes.add(ILabelFeatureProvider.class);
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 *
	 * @return the root AdapterFactory
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory
				.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 *
	 * @param parentAdapterFactory the new parent adapter factory
	 * @generated
	 */
	public void setParentAdapterFactory(
			ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * @param type the type to test
	 * @return true if supported
	 * 
	 * @generated
	 */
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 *
	 * @param notifier the notifier
	 * @param type the object to adapt
	 * @return the Adapter the created adatper
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * @param object the object to adapt
	 * @param type the type to adapt
	 * @return the adapted Object
	 * @generated
	 */
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class)
					|| (((Class) type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 *
	 * @param notifyChangedListener the listener to add
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 *
	 * @param notifyChangedListener the listener to remove
	 * 
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 *
	 * @param notification the notification to fire
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This creates an adapter for a {@link ttm.Document}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createDocumentAdapter() {
		if (documentModelerProvider == null) {
			documentModelerProvider = new DocumentModelerProvider(this);
		}

		return documentModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.Section}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createSectionAdapter() {
		if (sectionModelerProvider == null) {
			sectionModelerProvider = new SectionModelerProvider(this);
		}

		return sectionModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.HierarchicalElement}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createHierarchicalElementAdapter() {
		if (hierarchicalelementModelerProvider == null) {
			hierarchicalelementModelerProvider = new HierarchicalElementModelerProvider(
					this);
		}

		return hierarchicalelementModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.IdentifiedElement}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createIdentifiedElementAdapter() {
		if (identifiedelementModelerProvider == null) {
			identifiedelementModelerProvider = new IdentifiedElementModelerProvider(
					this);
		}

		return identifiedelementModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.Text}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createTextAdapter() {
		if (textModelerProvider == null) {
			textModelerProvider = new TextModelerProvider(this);
		}

		return textModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.Attribute}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAttributeAdapter() {
		if (attributeModelerProvider == null) {
			attributeModelerProvider = new AttributeModelerProvider(this);
		}

		return attributeModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.Requirement}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createRequirementAdapter() {
		if (requirementModelerProvider == null) {
			requirementModelerProvider = new RequirementModelerProvider(this);
		}

		return requirementModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.CoverLink}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCoverLinkAdapter() {
		if (coverlinkModelerProvider == null) {
			coverlinkModelerProvider = new CoverLinkModelerProvider(this);
		}

		return coverlinkModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.NavigationLink}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createNavigationLinkAdapter() {
		if (navigationlinkModelerProvider == null) {
			navigationlinkModelerProvider = new NavigationLinkModelerProvider(
					this);
		}

		return navigationlinkModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.AbstractLink}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAbstractLinkAdapter() {
		if (abstractlinkModelerProvider == null) {
			abstractlinkModelerProvider = new AbstractLinkModelerProvider(this);
		}

		return abstractlinkModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.Project}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createProjectAdapter() {
		if (projectModelerProvider == null) {
			projectModelerProvider = new ProjectModelerProvider(this);
		}

		return projectModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.Element}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createElementAdapter() {
		if (elementModelerProvider == null) {
			elementModelerProvider = new ElementModelerProvider(this);
		}

		return elementModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.RuleInstance}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createRuleInstanceAdapter() {
		if (ruleinstanceModelerProvider == null) {
			ruleinstanceModelerProvider = new RuleInstanceModelerProvider(this);
		}

		return ruleinstanceModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.AttributeOwner}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createAttributeOwnerAdapter() {
		if (attributeownerModelerProvider == null) {
			attributeownerModelerProvider = new AttributeOwnerModelerProvider(
					this);
		}

		return attributeownerModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.Rule}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createRuleAdapter() {
		if (ruleModelerProvider == null) {
			ruleModelerProvider = new RuleModelerProvider(this);
		}

		return ruleModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.CoverageResult}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCoverageResultAdapter() {
		if (coverageresultModelerProvider == null) {
			coverageresultModelerProvider = new CoverageResultModelerProvider(
					this);
		}

		return coverageresultModelerProvider;
	}

	/**
	 * This creates an adapter for a {@link ttm.CoverPoint}.
	 *
	 * @return the Adapter
	 * @generated
	 */
	public Adapter createCoverPointAdapter() {
		if (coverpointModelerProvider == null) {
			coverpointModelerProvider = new CoverPointModelerProvider(this);
		}

		return coverpointModelerProvider;
	}

	/**
	 * This disposes all of the item providers created by this factory.
	 * 
	 * @generated
	 */
	public void dispose() {
		if (documentModelerProvider != null) {
			documentModelerProvider.dispose();
		}
		if (sectionModelerProvider != null) {
			sectionModelerProvider.dispose();
		}
		if (hierarchicalelementModelerProvider != null) {
			hierarchicalelementModelerProvider.dispose();
		}
		if (identifiedelementModelerProvider != null) {
			identifiedelementModelerProvider.dispose();
		}
		if (textModelerProvider != null) {
			textModelerProvider.dispose();
		}
		if (attributeModelerProvider != null) {
			attributeModelerProvider.dispose();
		}
		if (requirementModelerProvider != null) {
			requirementModelerProvider.dispose();
		}
		if (coverlinkModelerProvider != null) {
			coverlinkModelerProvider.dispose();
		}
		if (navigationlinkModelerProvider != null) {
			navigationlinkModelerProvider.dispose();
		}
		if (abstractlinkModelerProvider != null) {
			abstractlinkModelerProvider.dispose();
		}
		if (projectModelerProvider != null) {
			projectModelerProvider.dispose();
		}
		if (elementModelerProvider != null) {
			elementModelerProvider.dispose();
		}
		if (ruleinstanceModelerProvider != null) {
			ruleinstanceModelerProvider.dispose();
		}
		if (attributeownerModelerProvider != null) {
			attributeownerModelerProvider.dispose();
		}
		if (ruleModelerProvider != null) {
			ruleModelerProvider.dispose();
		}
		if (coverageresultModelerProvider != null) {
			coverageresultModelerProvider.dispose();
		}
		if (coverpointModelerProvider != null) {
			coverpointModelerProvider.dispose();
		}
	}

}
