/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors: Mathieu Garcia (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.traceability.hmi.ui.form.provider;

import org.topcased.traceability.hmi.util.MClass;

import ttm.Requirement;
import ttm.Section;

/**
 * Created on 21 fvr. 07
 * 
 * @author <a href="mailto:mathieu.garcia@anyware-tech.com">Mathieu Garcia</a>
 * 
 * Label provider for viewer about requirements
 * 
 */
public class ImpactTraceabilityViewLabelProvider extends TraceabilityViewLabelProvider
{


    /**
     * @see org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
     */
    public String getText(Object element)
    {
    	switch (MClass.convert(element))
        {
            case SECTION:
                return ((Section) element).getIdent() + " (" + ((Section) element).getDocument().getIdent() + ")"; 
            case REQUIREMENT:
                    return ((Requirement) element).getIdent() + " (" + ((Requirement) element).getDocument().getIdent() + ")";
            case INFO:
                return (String) element;
        }
        return super.getText(element);
    }

}
