/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors: Mathieu Garcia (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.traceability.hmi.ui.form.provider;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.topcased.traceability.hmi.TtmImageRegistry;
import org.topcased.traceability.hmi.util.TraceabilityConstants;

import ttm.Rule;
import ttm.RuleInstance;

/**
 * Created on 21 fvr. 07
 * 
 * @author <a href="mailto:mathieu.garcia@anyware-tech.com">Mathieu Garcia</a>
 * 
 * Label provider for report section
 * 
 */
public class ReportViewLabelProvider extends LabelProvider
{

    /**
     * @see org.eclipse.jface.viewers.LabelProvider#getImage(java.lang.Object)
     */
    public Image getImage(Object element)
    {
        if (element instanceof Rule)
        {
            if (((Rule) element).getRuleInstances().isEmpty())
            {
                return TtmImageRegistry.getImage(TraceabilityConstants.RULE_OK_KEY);
            }
            else
            {
                return TtmImageRegistry.getImage(TraceabilityConstants.RULE_KO_KEY);
            }
        }
        if (element instanceof RuleInstance)
        {
            return TtmImageRegistry.getImage(TraceabilityConstants.REQUIREMENT_IMAGE_KEY);
        }
        return super.getImage(element);
    }

    /**
     * @see org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
     */
    public String getText(Object element)
    {
        if (element instanceof Rule)
        {
            return ((Rule) element).getName();
        }
        else if (element instanceof RuleInstance)
        {
            return ((RuleInstance) element).getDisplayMessage();
        }
        return super.getText(element);
    }

}
