package org.topcased.traceability.hmi.ui.form.provider.table;

import org.eclipse.swt.graphics.Image;
import org.topcased.traceability.hmi.ui.form.provider.TraceabilityViewLabelProvider;
import org.topcased.traceability.hmi.ui.util.IColumnObjectLabelProvider;
import org.topcased.traceability.hmi.util.ModelHelper;

import ttm.Element;
import ttm.Requirement;

public class RequirementTableViewLabelProvider extends TraceabilityViewLabelProvider implements IColumnObjectLabelProvider {

	public Image getColumnImage(Object object, int index) {
		if (object instanceof Element) {
			Element element = (Element)object;
			switch (index) {
				case 0:
					return super.getImage(element.getDocument());
			}
		}
		return null;
	}

	public String getColumnText(Object a, int index) {
		// TODO : Factor with the same method that is in getColumnObject ... 
		String res = null;
		if (a instanceof Requirement) {
			res = getRequirementColumnString((Requirement) a, index);
		}
		
		return res;
	}

	@Override
	public String getText(Object element) {
		// TODO Auto-generated method stub
		return super.getText(element);
	}

	public Object getColumnObject(Object a, int index) {
		// TODO : Factor this 
		Object res = null;
		if (a instanceof Requirement) {
			
			res = getRequirementColumnString((Requirement) a, index);
						
		}
		
		return res;
		
	}

	
	
	private String getRequirementColumnString(Requirement r, int index) {
		String res = null;
		switch (index) {
		case 0:
			res = r.getDocument().getIdent();
			break;
		case 1:
			res = r.getIdent();
			break;
		case 2:
			res = ModelHelper.getRequirementText(r);
			break;
		default:
			break;
		}
		return res;
	}

}
