package org.topcased.traceability.hmi.ui.outline;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.FeatureMap;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.edit.provider.IWrapperItemProvider;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.IPageSite;
import org.topcased.modeler.editor.Modeler;
import org.topcased.modeler.editor.outline.IOutlineMenuConstants;
import org.topcased.modeler.editor.outline.ModelNavigator;
import org.topcased.traceability.hmi.actions.AnalyseActionDelegate;

import ttm.Project;

/**
 * 
 * This class is used to add action to the popupMenu
 * <br>
 * creation : 13 mars 07
 *
 * @author <a href="mailto:mickael.gerard@anyware-tech.com">Mickael Gerard</a>
 */
public class TtmModelNavigator extends ModelNavigator
{

    public TtmModelNavigator(Composite parent, Modeler editor, IPageSite pageSite)
    {
        super(parent, editor, pageSite);       
    }
    
    @Override
    protected void createSingleSelectionMenu(IMenuManager manager, Object selection)
    {     
    	
        EObject selectedObject = null;
        IMenuManager tracaMenu = null;

        if (selection instanceof EObject)
        {
            selectedObject = (EObject) selection;
        }
        else if (selection instanceof IWrapperItemProvider || selection instanceof FeatureMap.Entry)
        {
            selectedObject = (EObject) AdapterFactoryEditingDomain.unwrap(selection);
        }
        
        if (selectedObject instanceof Project)
        {
            tracaMenu = new MenuManager("Tracability");                        
            tracaMenu.add(new AnalyseActionDelegate((Project)selectedObject));
           // tracaMenu.add(new PrintRulesReportActionDelegate((Project)selectedObject));
            manager.appendToGroup(IOutlineMenuConstants.NEW_GROUP, tracaMenu);            
        }     
    }

}
