/*******************************************************************************
 * Copyright (c) 2007 Anyware Technologies. All rights reserved. This program
 * and the accompanying materials are made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution, and is
 * available at http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors: Mathieu Garcia (Anyware Technologies) - initial API and
 * implementation
 ******************************************************************************/
package org.topcased.traceability.hmi.util;

import ttm.Rule;

/**
 * Created on 21 fvr. 07
 * 
 * @author <a href="mailto:mathieu.garcia@anyware-tech.com">Mathieu Garcia</a>
 * 
 * An helper arround rules
 * 
 */
public class RuleHelper
{

    /**
     * Convert the given rule name as the matching docorator key
     * 
     * @param rule
     * @return the decorator key
     */
    public static String getDecoratorKey(Rule rule)
    {
        return rule.getName().toUpperCase().replaceAll(" ", "_").concat("_DECORATOR");
    }

    /**
     * Convert the given rule name as the matching image key
     * 
     * @param rule
     * @return the image key
     */
    public static String getImageKey(Rule rule)
    {
        return rule.getName().toUpperCase().replaceAll(" ", "_");
    }

}
