/******************************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Christophe Le Camus (CS), Marion Feau (CS), Guillaume Jolly (CS), Sbastien Gabel (CS) 
 *    Petre Bazavan (AEIC), Vincent Combet (CS) - initial API and implementation
 *******************************************************************************************/
package org.topcased.web.server.SOAP;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.IStartup;
import org.topcased.externalbus.core.CorePlugin;
import org.topcased.web.server.ServerPlugin;
import org.topcased.web.server.preferences.TopcasedServerPreferencePage;

/**
 * Launching of the SOAP Server at start-up.
 * 
 * @author <a href="mailto:david.brouard@c-s.fr">David BROUARD</a>
 */
public class SOAPServerAutoLaunch implements IStartup
{

	/**
	 * @see org.eclipse.ui.IStartup#earlyStartup()
	 */
	public void earlyStartup()
	{
		IPreferenceStore store = ServerPlugin.getDefault().getPreferenceStore();
		int portNumber = store.getInt(TopcasedServerPreferencePage.PORT_VALUE);
		if (portNumber != 0)
		{
			new SOAPServer(portNumber);
			CorePlugin.log(ServerPlugin.getResourceString("ServerPlugin.Server.Lanched") + String.valueOf(portNumber), IStatus.INFO);
		}
		else
		{
			CorePlugin.log(ServerPlugin.getResourceString("ServerPlugin.Server.NotLanched"), IStatus.WARNING);
		}
	}
}
