package tte;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Plugin;
import org.eclipse.core.runtime.Status;
import org.osgi.framework.BundleContext;

/**
 * The main plugin class to be used in the desktop.
 */
public class TTEnginePlugin extends Plugin {

    /**
     * The shared instance.
     */
    private static TTEnginePlugin plugin;
    
    public static final String PLUGIN_ID = "org.topcased.traceability.engine";
    
    
    public static final String DOCUMENT_ANALYSER_EXT_ID = "documentAnalyzers";

    /**
     * The constructor.
     */
    public TTEnginePlugin() {
        plugin = this;
    }

    /**
     * This method is called upon plug-in activation.
     * @param context is the context used within the plugin
     * @throws Exception when errors occured during starting action
     */
    public final void start(final BundleContext context) throws Exception {
        super.start(context);
    }

    /**
     * This method is called when the plug-in is stopped.
     * @param context is the context used within the plugin
     * @throws Exception when errors occured during stoping action
     */
    public final void stop(final BundleContext context) throws Exception {
        super.stop(context);
        plugin = null;
    }

    /**
     * Returns the shared instance.
     * @return the plugin
     */
    public static TTEnginePlugin getDefault() {
        return plugin;
    }
    
    /*
     * Information methods
     */
    
	public static void displayError(String string, Exception e) {
		plugin.getLog().log(new Status(IStatus.ERROR,
				plugin.getBundle().getSymbolicName(),
				IStatus.ERROR, string, e));
		
	}

}
