package tte.analyzers;

import org.eclipse.core.runtime.IConfigurationElement;

abstract class AbstractExtendedClass {

    /**
     * Gets an attribute which name is in parameter,  from the configElement.
     * @param configElement structure of element from the extension analysis
     * @param name of the requested attribute
     * @param defaultValue if the attribute do not have a value
     * @return the value of the attribute which name is in parameter
     */
    protected static String getAttribute(
            final IConfigurationElement configElement,
            final String name,
            final String defaultValue) {
        String value = configElement.getAttribute(name);
        if (value != null) {
            return value;
        }
        if (defaultValue != null) {
            return defaultValue;
        }
        throw new IllegalArgumentException("Missing \""
                                             + name
                                             + "\" attribute");
    }

}
