package tte.exceptions;

/**
 * Exception class for analysis exceptions.
 *
 */
/**
 * @author laurentlb
 *
 */
/**
 * @author laurentlb
 *
 */
public final class AnalysisException extends Exception {

    /**
     * serial version UID.
     */
    private static final long serialVersionUID = 1611091118866223023L;

    /**
     * Creates a new instance of AnalysisException.
     * @param message is the information concerning the exception
     * @param level is the level of the exception
     */
    public AnalysisException(final String message, final int level) {
        super(getMessageFromLevel(message, level));
    }

    /**
     * Creates a new instance of AnalysisException.
     * @param message is the information concerning the exception
     */
    public AnalysisException(final String message) {
        super(message);
    }

    /**
     * Gets message from the level.
     * @param message of the exception
     * @param level of the exception
     * @return the message depending on the level
     */
    private static String getMessageFromLevel(final String message,
            final int level) {
        switch (level) {
            case 1 :
                return "Error: " + message;
            case 2 :
                return "Warning: " + message;
            default :
                return "Info: " + message;
            }
    }

}
