package tte.exceptions;

import org.eclipse.emf.common.util.URI;

/**
 * Exception raised when the loading of resource failed.
 *
 */
public class ResourceLoadingException extends Exception {

    /**
     * exception serialVersionUID.
     */
    private static final long serialVersionUID = 3034725835588985293L;

    /**
     * Creates an instance of loading Exception with the resource URI.
     * @param uri is the URI of the resource that is tried be loaded
     */
    public ResourceLoadingException(final URI uri) {
        super("Problem during the load of " + uri.toFileString());
    }
}
