//------------------------------------------------
// $Id: ConversionMethodExtension.java,v 1.1 2007-05-03 13:13:30 mickael Exp $
// (c) Anyware Technologies 2007    www.anyware-tech.com
//------------------------------------------------
package tte.extension;

/**
 * 
 * This class represents a ConversionMethod Extension
 * <br>
 * creation : 10 avr. 07
 *
 * @author <a href="mailto:mickael.gerard@anyware-tech.com">Mickael Gerard</a>
 */
public class ConversionMethodExtension
{
    
    private String name;
    
    private String version;
    
    private String arguments;
    
    
    /**
     * Empty Constructors
     */
    public ConversionMethodExtension()
    {
        this(null,null,null);
    }

    public ConversionMethodExtension(String name, String version, String arguments)
    {
        super();
        this.name = name;
        this.version = version;
        this.arguments = arguments;
    }

    protected String getName()
    {
        return name;
    }

    protected void setName(String name)
    {
        this.name = name;
    }

    protected String getVersion()
    {
        return version;
    }

    protected void setVersion(String version)
    {
        this.version = version;
    }

    protected String getArguments()
    {
        return arguments;
    }

    protected void setArguments(String arguments)
    {
        this.arguments = arguments;
    }
    
    
    public String getIdentification()
    {
        return getName()+"_"+getVersion();
    }
    
    /**
     * @return String use for displaying the DocumentAnalyser
     */
    public String getDisplayIdentification()
    {
        return getName()+" ("+getVersion()+")";
    }
    
    
}
