package tte.rules;

import ttm.Element;
import ttm.Project;

/**
 * Interface the must be implemented to develop an actionClass
 *  for a RulesSet extension.
 *
 */
public interface IRule {

    /**
     * Method to implement to indicate how the rule is raised for element.
     * @param elt the element that is checked with the rule
     * @param project the project that can be needed
     *  to determine if the rule should raised
     * @return if the Rule is raised
     */
    Boolean isRaisedForElement(Element elt, Project project);

    /**
     * Method that can be implemented to customize
     *  the displayed message when the rule is raised.
     * @param elt the element that owns thr Rule
     * @return the displayed message for the rule on the element
     */
    String getDisplayMessageForElement(Element elt);

}
