/**
 * <copyright>
 * </copyright>
 *
 * $Id: Document.java,v 1.3 2007-05-16 15:10:54 llebars Exp $
 */
package ttm;

import java.io.PrintStream;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Document</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ttm.Document#getAnalyzerID <em>Analyzer ID</em>}</li>
 *   <li>{@link ttm.Document#getLastModifiedDate <em>Last Modified Date</em>}</li>
 *   <li>{@link ttm.Document#getFilename <em>Filename</em>}</li>
 *   <li>{@link ttm.Document#isCoversItself <em>Covers Itself</em>}</li>
 *   <li>{@link ttm.Document#getProject <em>Project</em>}</li>
 *   <li>{@link ttm.Document#getCoverPoints <em>Cover Points</em>}</li>
 *   <li>{@link ttm.Document#getIncomingCoverPoints <em>Incoming Cover Points</em>}</li>
 *   <li>{@link ttm.Document#getConversionMethodID <em>Conversion Method ID</em>}</li>
 *   <li>{@link ttm.Document#getAnalyzerArguments <em>Analyzer Arguments</em>}</li>
 *   <li>{@link ttm.Document#getGlobalCoverageRatio <em>Global Coverage Ratio</em>}</li>
 *   <li>{@link ttm.Document#getEditionMethodID <em>Edition Method ID</em>}</li>
 * </ul>
 * </p>
 *
 * @see ttm.TtmPackage#getDocument()
 * @model
 * @generated
 */
public interface Document extends HierarchicalElement
{
    /**
	 * Returns the value of the '<em><b>Analyzer ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Analyzer ID</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Analyzer ID</em>' attribute.
	 * @see #setAnalyzerID(String)
	 * @see ttm.TtmPackage#getDocument_AnalyzerID()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getAnalyzerID();

    /**
	 * Sets the value of the '{@link ttm.Document#getAnalyzerID <em>Analyzer ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Analyzer ID</em>' attribute.
	 * @see #getAnalyzerID()
	 * @generated
	 */
	void setAnalyzerID(String value);

    /**
	 * Returns the value of the '<em><b>Last Modified Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Last Modified Date</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Last Modified Date</em>' attribute.
	 * @see #setLastModifiedDate(long)
	 * @see ttm.TtmPackage#getDocument_LastModifiedDate()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Long"
	 * @generated
	 */
	long getLastModifiedDate();

    /**
	 * Sets the value of the '{@link ttm.Document#getLastModifiedDate <em>Last Modified Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Last Modified Date</em>' attribute.
	 * @see #getLastModifiedDate()
	 * @generated
	 */
	void setLastModifiedDate(long value);

    /**
	 * Returns the value of the '<em><b>Filename</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Filename</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Filename</em>' attribute.
	 * @see #setFilename(String)
	 * @see ttm.TtmPackage#getDocument_Filename()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getFilename();

    /**
	 * Sets the value of the '{@link ttm.Document#getFilename <em>Filename</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Filename</em>' attribute.
	 * @see #getFilename()
	 * @generated
	 */
	void setFilename(String value);

    /**
	 * Returns the value of the '<em><b>Covers Itself</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Covers Itself</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Covers Itself</em>' attribute.
	 * @see #setCoversItself(boolean)
	 * @see ttm.TtmPackage#getDocument_CoversItself()
	 * @model default="0" dataType="org.eclipse.emf.ecore.xml.type.Boolean"
	 * @generated
	 */
	boolean isCoversItself();

    /**
	 * Sets the value of the '{@link ttm.Document#isCoversItself <em>Covers Itself</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Covers Itself</em>' attribute.
	 * @see #isCoversItself()
	 * @generated
	 */
	void setCoversItself(boolean value);

    /**
	 * Returns the value of the '<em><b>Project</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ttm.Project#getDocuments <em>Documents</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Project</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Project</em>' container reference.
	 * @see #setProject(Project)
	 * @see ttm.TtmPackage#getDocument_Project()
	 * @see ttm.Project#getDocuments
	 * @model opposite="documents" required="true"
	 * @generated
	 */
	Project getProject();

    /**
	 * Sets the value of the '{@link ttm.Document#getProject <em>Project</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Project</em>' container reference.
	 * @see #getProject()
	 * @generated
	 */
	void setProject(Project value);

    /**
	 * Returns the value of the '<em><b>Cover Points</b></em>' containment reference list.
	 * The list contents are of type {@link ttm.CoverPoint}.
	 * It is bidirectional and its opposite is '{@link ttm.CoverPoint#getCoveredDocument <em>Covered Document</em>}'.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Cover Points</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Cover Points</em>' containment reference list.
	 * @see ttm.TtmPackage#getDocument_CoverPoints()
	 * @see ttm.CoverPoint#getCoveredDocument
	 * @model type="ttm.CoverPoint" opposite="coveredDocument" containment="true"
	 * @generated
	 */
    EList getCoverPoints();

    /**
	 * Returns the value of the '<em><b>Incoming Cover Points</b></em>' reference list.
	 * The list contents are of type {@link ttm.CoverPoint}.
	 * It is bidirectional and its opposite is '{@link ttm.CoverPoint#getConnectedDocuments <em>Connected Documents</em>}'.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Incoming Cover Points</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Incoming Cover Points</em>' reference list.
	 * @see ttm.TtmPackage#getDocument_IncomingCoverPoints()
	 * @see ttm.CoverPoint#getConnectedDocuments
	 * @model type="ttm.CoverPoint" opposite="connectedDocuments"
	 * @generated
	 */
    EList getIncomingCoverPoints();

    /**
	 * Returns the value of the '<em><b>Conversion Method ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Conversion Method ID</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Conversion Method ID</em>' attribute.
	 * @see #setConversionMethodID(String)
	 * @see ttm.TtmPackage#getDocument_ConversionMethodID()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getConversionMethodID();

    /**
	 * Sets the value of the '{@link ttm.Document#getConversionMethodID <em>Conversion Method ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Conversion Method ID</em>' attribute.
	 * @see #getConversionMethodID()
	 * @generated
	 */
	void setConversionMethodID(String value);

    /**
	 * Returns the value of the '<em><b>Analyzer Arguments</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Analyzer Arguments</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Analyzer Arguments</em>' attribute.
	 * @see #setAnalyzerArguments(String)
	 * @see ttm.TtmPackage#getDocument_AnalyzerArguments()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
    String getAnalyzerArguments();

    /**
	 * Sets the value of the '{@link ttm.Document#getAnalyzerArguments <em>Analyzer Arguments</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Analyzer Arguments</em>' attribute.
	 * @see #getAnalyzerArguments()
	 * @generated
	 */
    void setAnalyzerArguments(String value);

    /**
	 * Returns the value of the '<em><b>Global Coverage Ratio</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Global Coverage Ratio</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Global Coverage Ratio</em>' attribute.
	 * @see #setGlobalCoverageRatio(float)
	 * @see ttm.TtmPackage#getDocument_GlobalCoverageRatio()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Float"
	 * @generated
	 */
    float getGlobalCoverageRatio();

    /**
	 * Sets the value of the '{@link ttm.Document#getGlobalCoverageRatio <em>Global Coverage Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Global Coverage Ratio</em>' attribute.
	 * @see #getGlobalCoverageRatio()
	 * @generated
	 */
    void setGlobalCoverageRatio(float value);

	/**
	 * Returns the value of the '<em><b>Edition Method ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Edition Method ID</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Edition Method ID</em>' attribute.
	 * @see #setEditionMethodID(String)
	 * @see ttm.TtmPackage#getDocument_EditionMethodID()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getEditionMethodID();

				/**
	 * Sets the value of the '{@link ttm.Document#getEditionMethodID <em>Edition Method ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Edition Method ID</em>' attribute.
	 * @see #getEditionMethodID()
	 * @generated
	 */
	void setEditionMethodID(String value);

	/**
	 * Returns the value of the '<em><b>Covering Documents</b></em>' reference list.
	 * The list contents are of type {@link ttm.Document}.
	 * It is bidirectional and its opposite is '{@link ttm.Document#getCoveredDocuments <em>Covered Documents</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Covering Documents</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Covering Documents</em>' reference list.
	 * @see ttm.TtmPackage#getDocument_CoveringDocuments()
	 * @see ttm.Document#getCoveredDocuments
	 * @model type="ttm.Document" opposite="coveredDocuments"
	 * @generated NOT
	 */
	List<Document> getCoveringDocuments();

	/**
	 * Returns the value of the '<em><b>Covered Documents</b></em>' reference list.
	 * The list contents are of type {@link ttm.Document}.
	 * It is bidirectional and its opposite is '{@link ttm.Document#getCoveringDocuments <em>Covering Documents</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Covered Documents</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Covered Documents</em>' reference list.
	 * @see ttm.TtmPackage#getDocument_CoveredDocuments()
	 * @see ttm.Document#getCoveringDocuments
	 * @model type="ttm.Document" opposite="coveringDocuments"
	 * @generated NOT
	 */
	List<Document> getCoveredDocuments();

	/**
	 * aks to the project the coverage ratio for each document that covers
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	Map<Object,Float> getCoverageResults();

	/**
	 * print the coverage ratio on the stream in parameter
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @generated NOT
	 * */
	void printCoverageResultsOn(PrintStream ptstr);


} // Document
