/**
 * <copyright>
 * </copyright>
 *
 * $Id: HierarchicalElement.java,v 1.2 2007-05-15 10:30:13 llebars Exp $
 */
package ttm;

import java.util.List;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hierarchical Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ttm.HierarchicalElement#getIncomingNavigationLinks <em>Incoming Navigation Links</em>}</li>
 *   <li>{@link ttm.HierarchicalElement#getNavigationLinks <em>Navigation Links</em>}</li>
 *   <li>{@link ttm.HierarchicalElement#getCoverLinks <em>Cover Links</em>}</li>
 *   <li>{@link ttm.HierarchicalElement#getChildren <em>Children</em>}</li>
 *   <li>{@link ttm.HierarchicalElement#getParent <em>Parent</em>}</li>
 * </ul>
 * </p>
 *
 * @see ttm.TtmPackage#getHierarchicalElement()
 * @model abstract="true"
 * @generated
 */
public interface HierarchicalElement extends IdentifiedElement
{
    /**
	 * Returns the value of the '<em><b>Incoming Navigation Links</b></em>' reference list.
	 * The list contents are of type {@link ttm.NavigationLink}.
	 * It is bidirectional and its opposite is '{@link ttm.NavigationLink#getTo <em>To</em>}'.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Incoming Navigation Links</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Incoming Navigation Links</em>' reference list.
	 * @see ttm.TtmPackage#getHierarchicalElement_IncomingNavigationLinks()
	 * @see ttm.NavigationLink#getTo
	 * @model type="ttm.NavigationLink" opposite="to"
	 * @generated
	 */
    EList getIncomingNavigationLinks();

    /**
	 * Returns the value of the '<em><b>Navigation Links</b></em>' containment reference list.
	 * The list contents are of type {@link ttm.NavigationLink}.
	 * It is bidirectional and its opposite is '{@link ttm.NavigationLink#getFrom <em>From</em>}'.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Navigation Links</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Navigation Links</em>' containment reference list.
	 * @see ttm.TtmPackage#getHierarchicalElement_NavigationLinks()
	 * @see ttm.NavigationLink#getFrom
	 * @model type="ttm.NavigationLink" opposite="from" containment="true"
	 * @generated
	 */
    EList getNavigationLinks();

    /**
	 * Returns the value of the '<em><b>Children</b></em>' containment reference list.
	 * The list contents are of type {@link ttm.HierarchicalElement}.
	 * It is bidirectional and its opposite is '{@link ttm.HierarchicalElement#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Children</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Children</em>' containment reference list.
	 * @see ttm.TtmPackage#getHierarchicalElement_Children()
	 * @see ttm.HierarchicalElement#getParent
	 * @model type="ttm.HierarchicalElement" opposite="parent" containment="true"
	 * @generated
	 */
    EList getChildren();

    /**
     * Returns the value of the '<em><b>Cover Link</b></em>' containment reference list.
     * The list contents are of type {@link ttm.CoverLink}.
     * It is bidirectional and its opposite is '{@link ttm.CoverLink#getFrom <em>From</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Cover Link</em>' containment reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Cover Link</em>' containment reference list.
     * @see ttm.TtmPackage#getHierarchicalElement_CoverLink()
     * @see ttm.CoverLink#getFrom
     * @model type="ttm.CoverLink" opposite="from" containment="true"
     * @generated NOT
     */
    List< CoverLink > getCoverLinks();

    /**
	 * Returns the value of the '<em><b>Parent</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ttm.HierarchicalElement#getChildren <em>Children</em>}'.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent</em>' container reference.
	 * @see #setParent(HierarchicalElement)
	 * @see ttm.TtmPackage#getHierarchicalElement_Parent()
	 * @see ttm.HierarchicalElement#getChildren
	 * @model opposite="children"
	 * @generated
	 */
    HierarchicalElement getParent();

    /**
     * Returns the value of the '<em><b>Parent document</b></em>'.
     * <!-- begin-user-doc -->
     * <p>
     * when parent is a Document it will be returned, else we will call
     * getParent() while it is not a Document.
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Parent document</em>'.
     * @see ttm.TtmPackage#getHierarchicalElement_Parent()
     */
    Document getDocument();

    /**
	 * Sets the value of the '{@link ttm.HierarchicalElement#getParent <em>Parent</em>}' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent</em>' container reference.
	 * @see #getParent()
	 * @generated
	 */
    void setParent(HierarchicalElement value);

    /**
     * Indicates if the element is a requirement that contains other requirements.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return if the element is a requirement that contains requirements
     */
    Boolean isMacroRequirement();

    /**
     * Returns if the requirement is covering the element which identifier is in parameter.
     * @return  if the requirement is covering the element which identifier is in parameter
     */
    Boolean isCoveringElementID(String identifier);


} // HierarchicalElement
