/**
 * <copyright>
 * </copyright>
 *
 * $Id: Project.java,v 1.3 2007-05-21 16:04:18 llebars Exp $
 */
package ttm;



import org.eclipse.emf.common.util.EList;

import java.util.List;
import java.util.Set;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Project</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ttm.Project#getDocuments <em>Documents</em>}</li>
 *   <li>{@link ttm.Project#getRules <em>Rules</em>}</li>
 *   <li>{@link ttm.Project#getCoverageResults <em>Coverage Results</em>}</li>
 *   <li>{@link ttm.Project#isAnyDocumentCovered <em>Any Document Covered</em>}</li>
 * </ul>
 * </p>
 *
 * @see ttm.TtmPackage#getProject()
 * @model
 * @generated
 */
public interface Project extends IdentifiedElement
{
    /**
	 * Returns the value of the '<em><b>Rule</b></em>' containment reference list.
	 * The list contents are of type {@link ttm.Rule}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rule</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rule</em>' containment reference list.
	 * @see ttm.TtmPackage#getProject_Rule()
	 * @model type="ttm.Rule" containment="true"
	 * @generated NOT
	 */
	List<Rule> getRules();

	/**
	 * Returns the value of the '<em><b>Document</b></em>' containment reference list.
	 * The list contents are of type {@link ttm.Document}.
	 * It is bidirectional and its opposite is '{@link ttm.Document#getProject <em>Project</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Document</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Documents</em>' containment reference list.
	 * @see ttm.TtmPackage#getProject_Document()
	 * @see ttm.Document#getProject
	 * @model type="ttm.Document" opposite="project" containment="true"
	 * @generated NOT
	 */
	List<Document> getDocuments();

	/**
	 * Returns the value of the '<em><b>Coverage Result</b></em>' containment reference list.
	 * The list contents are of type {@link ttm.CoverageResult}.
	 * It is bidirectional and its opposite is '{@link ttm.CoverageResult#getProject <em>Project</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Coverage Result</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Coverage Result</em>' containment reference list.
	 * @see ttm.TtmPackage#getProject_CoverageResult()
	 * @see ttm.CoverageResult#getProject
	 * @model type="ttm.CoverageResult" opposite="project" containment="true"
	 * @generated NOT
	 */
	List<CoverageResult> getCoverageResults();

    /**
	 * Returns the value of the '<em><b>Any Document Covered</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Any Document Covered</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Any Document Covered</em>' attribute.
	 * @see #setAnyDocumentCovered(boolean)
	 * @see ttm.TtmPackage#getProject_AnyDocumentCovered()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Boolean"
	 * @generated
	 */
    boolean isAnyDocumentCovered();

    /**
	 * Sets the value of the '{@link ttm.Project#isAnyDocumentCovered <em>Any Document Covered</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Any Document Covered</em>' attribute.
	 * @see #isAnyDocumentCovered()
	 * @generated
	 */
    void setAnyDocumentCovered(boolean value);

	/**
	 * returns the documents of the projet which do not cover any other document
	 * The set contents are of type {@link DataDescription.Document}.
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @return a set of documents which do not cover any other document
	 * @generated NOT
	 */
	 Set<Document> getRootDocumentsFromProjectElements();
	 
	 
	/**
	 *add Coverage Result between a document/coverPoint and another document
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @param the document that covers, can be null
	 * @param the coverpoint taht covers, can be null
	 * @param the document that is covered
	 * @param the coverage ratio
	 * @generated NOT
	 */
	 void addCoverageResult(Document fromDoc, CoverPoint fromCoverPoint, Document to, float ratio);
	 
	/**
	 * add new Rule to the project
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @param rule that will be checked during processing
	 * @generated NOT
	 */
	 void addRuleDefinition(Rule aRule);

    /**
     * add converted elements by classifier IDs
     * @param key is the object.eClass.classifierID
     * @param elt is a list of object in project which class id is key
     */
     void addCachedElement(Integer key, Object elt);
 
     /**
      * clean the converted elements map
      */
      void cleanCachedElements();

    /**
     * gets the list of requirements in the project
     * @return list of '<b>Requirement</b>' class elements
     */
     public  List<Object> getRequirements();
     
     /**
      * gets the ttm filename.
      * @return the ttm filename.
      */
     public String getTtmFilename();
      
} // Project
