/**
 * <copyright>
 * </copyright>
 *
 * $Id: Requirement.java,v 1.2 2007-05-15 10:30:12 llebars Exp $
 */
package ttm;

import java.util.List;
import java.util.Set;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ttm.Requirement#getIncomingCoverLinks <em>Incoming Cover Links</em>}</li>
 *   <li>{@link ttm.Requirement#getSubCoveringRequirementsRatio <em>Sub Covering Requirements Ratio</em>}</li>
 * </ul>
 * </p>
 *
 * @see ttm.TtmPackage#getRequirement()
 * @model
 * @generated
 */
public interface Requirement extends HierarchicalElement
{
    /**
     * Returns the value of the '<em><b>Incoming Cover Links</b></em>' reference list.
     * The list contents are of type {@link ttm.CoverLink}.
     * It is bidirectional and its opposite is '{@link ttm.CoverLink#getTo <em>To</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Incoming Cover Links</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Incoming Cover Links</em>' reference list.
     * @see ttm.TtmPackage#getRequirement_IncomingCoverLinks()
     * @see ttm.CoverLink#getTo
     * @model type="ttm.CoverLink" opposite="to"
     * @generated NOT
     */
    List<CoverLink> getIncomingCoverLinks();

    /**
	 * Returns the value of the '<em><b>Sub Covering Requirements Ratio</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Sub Covering Requirements Ratio</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Sub Covering Requirements Ratio</em>' attribute.
	 * @see #setSubCoveringRequirementsRatio(float)
	 * @see ttm.TtmPackage#getRequirement_SubCoveringRequirementsRatio()
	 * @model dataType="org.eclipse.emf.ecore.xml.type.Float"
	 * @generated
	 */
    float getSubCoveringRequirementsRatio();

    /**
	 * Sets the value of the '{@link ttm.Requirement#getSubCoveringRequirementsRatio <em>Sub Covering Requirements Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sub Covering Requirements Ratio</em>' attribute.
	 * @see #getSubCoveringRequirementsRatio()
	 * @generated
	 */
    void setSubCoveringRequirementsRatio(float value);

	/**
	 * Return all the elements that covers this requirement, recursively going through documents cover relations 
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @return 	the covering elements list
	 */
	Set<HierarchicalElement> getAllReferencers();
        
    /**
     * Returns the parent requirements recursively.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the list of all parent requirements
     */
     List<Requirement> getAllParentRequirements();

     /**
      * Returns the child requirements recursively.
      * <!-- begin-user-doc -->
      * <!-- end-user-doc -->
      * @return the list of all child requirements
      */
      List<Requirement> getAllChildRequirements();

} // Requirement
