/**
 * <copyright>
 * </copyright>
 *
 * $Id: TtmPackage.java,v 1.3 2007-05-16 15:10:54 llebars Exp $
 */
package ttm;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see ttm.TtmFactory
 * @model kind="package"
 * @generated
 */
public interface TtmPackage extends EPackage
{
    /**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "ttm";

    /**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://org.topcased.traceability.model";

    /**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "ttm";

    /**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TtmPackage eINSTANCE = ttm.impl.TtmPackageImpl.init();

    /**
	 * The meta object id for the '{@link ttm.impl.ElementImpl <em>Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.ElementImpl
	 * @see ttm.impl.TtmPackageImpl#getElement()
	 * @generated
	 */
	int ELEMENT = 11;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ELEMENT__ACTIVATED_RULES = 0;

    /**
	 * The number of structural features of the '<em>Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_FEATURE_COUNT = 1;

    /**
	 * The meta object id for the '{@link ttm.impl.AttributeOwnerImpl <em>Attribute Owner</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.AttributeOwnerImpl
	 * @see ttm.impl.TtmPackageImpl#getAttributeOwner()
	 * @generated
	 */
	int ATTRIBUTE_OWNER = 13;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ATTRIBUTE_OWNER__ACTIVATED_RULES = ELEMENT__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ATTRIBUTE_OWNER__ATTRIBUTES = ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Attribute Owner</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_OWNER_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link ttm.impl.IdentifiedElementImpl <em>Identified Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.IdentifiedElementImpl
	 * @see ttm.impl.TtmPackageImpl#getIdentifiedElement()
	 * @generated
	 */
	int IDENTIFIED_ELEMENT = 3;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IDENTIFIED_ELEMENT__ACTIVATED_RULES = ATTRIBUTE_OWNER__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IDENTIFIED_ELEMENT__ATTRIBUTES = ATTRIBUTE_OWNER__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Ident</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIED_ELEMENT__IDENT = ATTRIBUTE_OWNER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Short Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIED_ELEMENT__SHORT_DESCRIPTION = ATTRIBUTE_OWNER_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Texts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IDENTIFIED_ELEMENT__TEXTS = ATTRIBUTE_OWNER_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Identified Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIED_ELEMENT_FEATURE_COUNT = ATTRIBUTE_OWNER_FEATURE_COUNT + 3;

    /**
	 * The meta object id for the '{@link ttm.impl.HierarchicalElementImpl <em>Hierarchical Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.HierarchicalElementImpl
	 * @see ttm.impl.TtmPackageImpl#getHierarchicalElement()
	 * @generated
	 */
	int HIERARCHICAL_ELEMENT = 2;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HIERARCHICAL_ELEMENT__ACTIVATED_RULES = IDENTIFIED_ELEMENT__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HIERARCHICAL_ELEMENT__ATTRIBUTES = IDENTIFIED_ELEMENT__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Ident</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HIERARCHICAL_ELEMENT__IDENT = IDENTIFIED_ELEMENT__IDENT;

    /**
	 * The feature id for the '<em><b>Short Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HIERARCHICAL_ELEMENT__SHORT_DESCRIPTION = IDENTIFIED_ELEMENT__SHORT_DESCRIPTION;

    /**
	 * The feature id for the '<em><b>Texts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HIERARCHICAL_ELEMENT__TEXTS = IDENTIFIED_ELEMENT__TEXTS;

    /**
	 * The feature id for the '<em><b>Incoming Navigation Links</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS = IDENTIFIED_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Navigation Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HIERARCHICAL_ELEMENT__NAVIGATION_LINKS = IDENTIFIED_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Cover Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HIERARCHICAL_ELEMENT__COVER_LINKS = IDENTIFIED_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int HIERARCHICAL_ELEMENT__CHILDREN = IDENTIFIED_ELEMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HIERARCHICAL_ELEMENT__PARENT = IDENTIFIED_ELEMENT_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Hierarchical Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HIERARCHICAL_ELEMENT_FEATURE_COUNT = IDENTIFIED_ELEMENT_FEATURE_COUNT + 5;

    /**
	 * The meta object id for the '{@link ttm.impl.DocumentImpl <em>Document</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.DocumentImpl
	 * @see ttm.impl.TtmPackageImpl#getDocument()
	 * @generated
	 */
	int DOCUMENT = 0;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__ACTIVATED_RULES = HIERARCHICAL_ELEMENT__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__ATTRIBUTES = HIERARCHICAL_ELEMENT__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Ident</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__IDENT = HIERARCHICAL_ELEMENT__IDENT;

    /**
	 * The feature id for the '<em><b>Short Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__SHORT_DESCRIPTION = HIERARCHICAL_ELEMENT__SHORT_DESCRIPTION;

    /**
	 * The feature id for the '<em><b>Texts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__TEXTS = HIERARCHICAL_ELEMENT__TEXTS;

    /**
	 * The feature id for the '<em><b>Incoming Navigation Links</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__INCOMING_NAVIGATION_LINKS = HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS;

    /**
	 * The feature id for the '<em><b>Navigation Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__NAVIGATION_LINKS = HIERARCHICAL_ELEMENT__NAVIGATION_LINKS;

    /**
	 * The feature id for the '<em><b>Cover Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__COVER_LINKS = HIERARCHICAL_ELEMENT__COVER_LINKS;

    /**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__CHILDREN = HIERARCHICAL_ELEMENT__CHILDREN;

    /**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__PARENT = HIERARCHICAL_ELEMENT__PARENT;

    /**
	 * The feature id for the '<em><b>Analyzer ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__ANALYZER_ID = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Last Modified Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__LAST_MODIFIED_DATE = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Filename</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__FILENAME = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Covers Itself</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__COVERS_ITSELF = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Project</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__PROJECT = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Cover Points</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__COVER_POINTS = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 5;

    /**
	 * The feature id for the '<em><b>Incoming Cover Points</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__INCOMING_COVER_POINTS = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 6;

    /**
	 * The feature id for the '<em><b>Conversion Method ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__CONVERSION_METHOD_ID = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 7;

    /**
	 * The feature id for the '<em><b>Analyzer Arguments</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__ANALYZER_ARGUMENTS = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 8;

    /**
	 * The feature id for the '<em><b>Global Coverage Ratio</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int DOCUMENT__GLOBAL_COVERAGE_RATIO = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 9;

    /**
	 * The feature id for the '<em><b>Edition Method ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT__EDITION_METHOD_ID = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 10;

				/**
	 * The number of structural features of the '<em>Document</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_FEATURE_COUNT = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 11;

    /**
	 * The meta object id for the '{@link ttm.impl.SectionImpl <em>Section</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.SectionImpl
	 * @see ttm.impl.TtmPackageImpl#getSection()
	 * @generated
	 */
	int SECTION = 1;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SECTION__ACTIVATED_RULES = HIERARCHICAL_ELEMENT__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SECTION__ATTRIBUTES = HIERARCHICAL_ELEMENT__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Ident</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SECTION__IDENT = HIERARCHICAL_ELEMENT__IDENT;

    /**
	 * The feature id for the '<em><b>Short Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SECTION__SHORT_DESCRIPTION = HIERARCHICAL_ELEMENT__SHORT_DESCRIPTION;

    /**
	 * The feature id for the '<em><b>Texts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SECTION__TEXTS = HIERARCHICAL_ELEMENT__TEXTS;

    /**
	 * The feature id for the '<em><b>Incoming Navigation Links</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SECTION__INCOMING_NAVIGATION_LINKS = HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS;

    /**
	 * The feature id for the '<em><b>Navigation Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SECTION__NAVIGATION_LINKS = HIERARCHICAL_ELEMENT__NAVIGATION_LINKS;

    /**
	 * The feature id for the '<em><b>Cover Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SECTION__COVER_LINKS = HIERARCHICAL_ELEMENT__COVER_LINKS;

    /**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SECTION__CHILDREN = HIERARCHICAL_ELEMENT__CHILDREN;

    /**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SECTION__PARENT = HIERARCHICAL_ELEMENT__PARENT;

    /**
	 * The number of structural features of the '<em>Section</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SECTION_FEATURE_COUNT = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link ttm.impl.TextImpl <em>Text</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.TextImpl
	 * @see ttm.impl.TtmPackageImpl#getText()
	 * @generated
	 */
	int TEXT = 4;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TEXT__ACTIVATED_RULES = ELEMENT__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT__VALUE = ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT__PARENT = ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Text</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link ttm.impl.AttributeImpl <em>Attribute</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.AttributeImpl
	 * @see ttm.impl.TtmPackageImpl#getAttribute()
	 * @generated
	 */
	int ATTRIBUTE = 5;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ATTRIBUTE__ACTIVATED_RULES = ELEMENT__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__NAME = ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__VALUE = ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__PARENT = ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Attribute</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_FEATURE_COUNT = ELEMENT_FEATURE_COUNT + 3;

    /**
	 * The meta object id for the '{@link ttm.impl.RequirementImpl <em>Requirement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.RequirementImpl
	 * @see ttm.impl.TtmPackageImpl#getRequirement()
	 * @generated
	 */
	int REQUIREMENT = 6;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__ACTIVATED_RULES = HIERARCHICAL_ELEMENT__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__ATTRIBUTES = HIERARCHICAL_ELEMENT__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Ident</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__IDENT = HIERARCHICAL_ELEMENT__IDENT;

    /**
	 * The feature id for the '<em><b>Short Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__SHORT_DESCRIPTION = HIERARCHICAL_ELEMENT__SHORT_DESCRIPTION;

    /**
	 * The feature id for the '<em><b>Texts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__TEXTS = HIERARCHICAL_ELEMENT__TEXTS;

    /**
	 * The feature id for the '<em><b>Incoming Navigation Links</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__INCOMING_NAVIGATION_LINKS = HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS;

    /**
	 * The feature id for the '<em><b>Navigation Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__NAVIGATION_LINKS = HIERARCHICAL_ELEMENT__NAVIGATION_LINKS;

    /**
	 * The feature id for the '<em><b>Cover Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__COVER_LINKS = HIERARCHICAL_ELEMENT__COVER_LINKS;

    /**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__CHILDREN = HIERARCHICAL_ELEMENT__CHILDREN;

    /**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT__PARENT = HIERARCHICAL_ELEMENT__PARENT;

    /**
	 * The feature id for the '<em><b>Incoming Cover Links</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__INCOMING_COVER_LINKS = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Sub Covering Requirements Ratio</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int REQUIREMENT__SUB_COVERING_REQUIREMENTS_RATIO = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Requirement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REQUIREMENT_FEATURE_COUNT = HIERARCHICAL_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link ttm.impl.AbstractLinkImpl <em>Abstract Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.AbstractLinkImpl
	 * @see ttm.impl.TtmPackageImpl#getAbstractLink()
	 * @generated
	 */
	int ABSTRACT_LINK = 9;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_LINK__ACTIVATED_RULES = ATTRIBUTE_OWNER__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_LINK__ATTRIBUTES = ATTRIBUTE_OWNER__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Unresolved</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_LINK__UNRESOLVED = ATTRIBUTE_OWNER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Referenced ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_LINK__REFERENCED_ID = ATTRIBUTE_OWNER_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Abstract Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_LINK_FEATURE_COUNT = ATTRIBUTE_OWNER_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link ttm.impl.CoverLinkImpl <em>Cover Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.CoverLinkImpl
	 * @see ttm.impl.TtmPackageImpl#getCoverLink()
	 * @generated
	 */
	int COVER_LINK = 7;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COVER_LINK__ACTIVATED_RULES = ABSTRACT_LINK__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COVER_LINK__ATTRIBUTES = ABSTRACT_LINK__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Unresolved</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVER_LINK__UNRESOLVED = ABSTRACT_LINK__UNRESOLVED;

    /**
	 * The feature id for the '<em><b>Referenced ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVER_LINK__REFERENCED_ID = ABSTRACT_LINK__REFERENCED_ID;

    /**
	 * The feature id for the '<em><b>From</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVER_LINK__FROM = ABSTRACT_LINK_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>To</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVER_LINK__TO = ABSTRACT_LINK_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Cover Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVER_LINK_FEATURE_COUNT = ABSTRACT_LINK_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link ttm.impl.NavigationLinkImpl <em>Navigation Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.NavigationLinkImpl
	 * @see ttm.impl.TtmPackageImpl#getNavigationLink()
	 * @generated
	 */
	int NAVIGATION_LINK = 8;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAVIGATION_LINK__ACTIVATED_RULES = ABSTRACT_LINK__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int NAVIGATION_LINK__ATTRIBUTES = ABSTRACT_LINK__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Unresolved</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_LINK__UNRESOLVED = ABSTRACT_LINK__UNRESOLVED;

    /**
	 * The feature id for the '<em><b>Referenced ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_LINK__REFERENCED_ID = ABSTRACT_LINK__REFERENCED_ID;

    /**
	 * The feature id for the '<em><b>To</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_LINK__TO = ABSTRACT_LINK_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>From</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_LINK__FROM = ABSTRACT_LINK_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Navigation Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_LINK_FEATURE_COUNT = ABSTRACT_LINK_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link ttm.impl.ProjectImpl <em>Project</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.ProjectImpl
	 * @see ttm.impl.TtmPackageImpl#getProject()
	 * @generated
	 */
	int PROJECT = 10;

    /**
	 * The feature id for the '<em><b>Activated Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROJECT__ACTIVATED_RULES = IDENTIFIED_ELEMENT__ACTIVATED_RULES;

    /**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROJECT__ATTRIBUTES = IDENTIFIED_ELEMENT__ATTRIBUTES;

    /**
	 * The feature id for the '<em><b>Ident</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__IDENT = IDENTIFIED_ELEMENT__IDENT;

    /**
	 * The feature id for the '<em><b>Short Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT__SHORT_DESCRIPTION = IDENTIFIED_ELEMENT__SHORT_DESCRIPTION;

    /**
	 * The feature id for the '<em><b>Texts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROJECT__TEXTS = IDENTIFIED_ELEMENT__TEXTS;

    /**
	 * The feature id for the '<em><b>Documents</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROJECT__DOCUMENTS = IDENTIFIED_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Rules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROJECT__RULES = IDENTIFIED_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Coverage Results</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROJECT__COVERAGE_RESULTS = IDENTIFIED_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Any Document Covered</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PROJECT__ANY_DOCUMENT_COVERED = IDENTIFIED_ELEMENT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Project</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROJECT_FEATURE_COUNT = IDENTIFIED_ELEMENT_FEATURE_COUNT + 4;

    /**
	 * The meta object id for the '{@link ttm.impl.RuleInstanceImpl <em>Rule Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.RuleInstanceImpl
	 * @see ttm.impl.TtmPackageImpl#getRuleInstance()
	 * @generated
	 */
	int RULE_INSTANCE = 12;

    /**
	 * The feature id for the '<em><b>Element</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_INSTANCE__ELEMENT = 0;

    /**
	 * The feature id for the '<em><b>Base Rule</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_INSTANCE__BASE_RULE = 1;

    /**
	 * The feature id for the '<em><b>Display Message</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_INSTANCE__DISPLAY_MESSAGE = 2;

    /**
	 * The number of structural features of the '<em>Rule Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_INSTANCE_FEATURE_COUNT = 3;

    /**
	 * The meta object id for the '{@link ttm.impl.RuleImpl <em>Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.RuleImpl
	 * @see ttm.impl.TtmPackageImpl#getRule()
	 * @generated
	 */
	int RULE = 14;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE__NAME = 0;

    /**
	 * The feature id for the '<em><b>Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE__LEVEL = 1;

    /**
	 * The feature id for the '<em><b>Rule Instances</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int RULE__RULE_INSTANCES = 2;

    /**
	 * The feature id for the '<em><b>Message</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE__MESSAGE = 3;

    /**
	 * The number of structural features of the '<em>Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_FEATURE_COUNT = 4;

    /**
	 * The meta object id for the '{@link ttm.impl.CoverageResultImpl <em>Coverage Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.CoverageResultImpl
	 * @see ttm.impl.TtmPackageImpl#getCoverageResult()
	 * @generated
	 */
	int COVERAGE_RESULT = 15;

    /**
	 * The feature id for the '<em><b>Coverage</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVERAGE_RESULT__COVERAGE = 0;

    /**
	 * The feature id for the '<em><b>Project</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVERAGE_RESULT__PROJECT = 1;

    /**
	 * The feature id for the '<em><b>From Document</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVERAGE_RESULT__FROM_DOCUMENT = 2;

    /**
	 * The feature id for the '<em><b>To Document</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVERAGE_RESULT__TO_DOCUMENT = 3;

    /**
	 * The feature id for the '<em><b>From Cover Point</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVERAGE_RESULT__FROM_COVER_POINT = 4;

    /**
	 * The number of structural features of the '<em>Coverage Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVERAGE_RESULT_FEATURE_COUNT = 5;


    /**
	 * The meta object id for the '{@link ttm.impl.CoverPointImpl <em>Cover Point</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ttm.impl.CoverPointImpl
	 * @see ttm.impl.TtmPackageImpl#getCoverPoint()
	 * @generated
	 */
	int COVER_POINT = 16;

    /**
	 * The feature id for the '<em><b>And Cover</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVER_POINT__AND_COVER = 0;

    /**
	 * The feature id for the '<em><b>Covered Document</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVER_POINT__COVERED_DOCUMENT = 1;

    /**
	 * The feature id for the '<em><b>Connected Documents</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int COVER_POINT__CONNECTED_DOCUMENTS = 2;

    /**
	 * The number of structural features of the '<em>Cover Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COVER_POINT_FEATURE_COUNT = 3;


    /**
	 * Returns the meta object for class '{@link ttm.HierarchicalElement <em>Hierarchical Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hierarchical Element</em>'.
	 * @see ttm.HierarchicalElement
	 * @generated
	 */
	EClass getHierarchicalElement();

    /**
	 * Returns the meta object for the reference list '{@link ttm.HierarchicalElement#getIncomingNavigationLinks <em>Incoming Navigation Links</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Incoming Navigation Links</em>'.
	 * @see ttm.HierarchicalElement#getIncomingNavigationLinks()
	 * @see #getHierarchicalElement()
	 * @generated
	 */
    EReference getHierarchicalElement_IncomingNavigationLinks();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.HierarchicalElement#getNavigationLinks <em>Navigation Links</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Navigation Links</em>'.
	 * @see ttm.HierarchicalElement#getNavigationLinks()
	 * @see #getHierarchicalElement()
	 * @generated
	 */
    EReference getHierarchicalElement_NavigationLinks();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.HierarchicalElement#getCoverLinks <em>Cover Links</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cover Links</em>'.
	 * @see ttm.HierarchicalElement#getCoverLinks()
	 * @see #getHierarchicalElement()
	 * @generated
	 */
    EReference getHierarchicalElement_CoverLinks();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.HierarchicalElement#getChildren <em>Children</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Children</em>'.
	 * @see ttm.HierarchicalElement#getChildren()
	 * @see #getHierarchicalElement()
	 * @generated
	 */
    EReference getHierarchicalElement_Children();

    /**
	 * Returns the meta object for the container reference '{@link ttm.HierarchicalElement#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see ttm.HierarchicalElement#getParent()
	 * @see #getHierarchicalElement()
	 * @generated
	 */
    EReference getHierarchicalElement_Parent();

    /**
	 * Returns the meta object for class '{@link ttm.Document <em>Document</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Document</em>'.
	 * @see ttm.Document
	 * @generated
	 */
	EClass getDocument();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Document#getAnalyzerID <em>Analyzer ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Analyzer ID</em>'.
	 * @see ttm.Document#getAnalyzerID()
	 * @see #getDocument()
	 * @generated
	 */
	EAttribute getDocument_AnalyzerID();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Document#getLastModifiedDate <em>Last Modified Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Last Modified Date</em>'.
	 * @see ttm.Document#getLastModifiedDate()
	 * @see #getDocument()
	 * @generated
	 */
	EAttribute getDocument_LastModifiedDate();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Document#getFilename <em>Filename</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Filename</em>'.
	 * @see ttm.Document#getFilename()
	 * @see #getDocument()
	 * @generated
	 */
	EAttribute getDocument_Filename();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Document#isCoversItself <em>Covers Itself</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Covers Itself</em>'.
	 * @see ttm.Document#isCoversItself()
	 * @see #getDocument()
	 * @generated
	 */
	EAttribute getDocument_CoversItself();

    /**
	 * Returns the meta object for the container reference '{@link ttm.Document#getProject <em>Project</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Project</em>'.
	 * @see ttm.Document#getProject()
	 * @see #getDocument()
	 * @generated
	 */
	EReference getDocument_Project();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.Document#getCoverPoints <em>Cover Points</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cover Points</em>'.
	 * @see ttm.Document#getCoverPoints()
	 * @see #getDocument()
	 * @generated
	 */
    EReference getDocument_CoverPoints();

    /**
	 * Returns the meta object for the reference list '{@link ttm.Document#getIncomingCoverPoints <em>Incoming Cover Points</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Incoming Cover Points</em>'.
	 * @see ttm.Document#getIncomingCoverPoints()
	 * @see #getDocument()
	 * @generated
	 */
    EReference getDocument_IncomingCoverPoints();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Document#getConversionMethodID <em>Conversion Method ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Conversion Method ID</em>'.
	 * @see ttm.Document#getConversionMethodID()
	 * @see #getDocument()
	 * @generated
	 */
	EAttribute getDocument_ConversionMethodID();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Document#getAnalyzerArguments <em>Analyzer Arguments</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Analyzer Arguments</em>'.
	 * @see ttm.Document#getAnalyzerArguments()
	 * @see #getDocument()
	 * @generated
	 */
    EAttribute getDocument_AnalyzerArguments();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Document#getGlobalCoverageRatio <em>Global Coverage Ratio</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Global Coverage Ratio</em>'.
	 * @see ttm.Document#getGlobalCoverageRatio()
	 * @see #getDocument()
	 * @generated
	 */
    EAttribute getDocument_GlobalCoverageRatio();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Document#getEditionMethodID <em>Edition Method ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Edition Method ID</em>'.
	 * @see ttm.Document#getEditionMethodID()
	 * @see #getDocument()
	 * @generated
	 */
	EAttribute getDocument_EditionMethodID();

				/**
	 * Returns the meta object for class '{@link ttm.Section <em>Section</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Section</em>'.
	 * @see ttm.Section
	 * @generated
	 */
	EClass getSection();

    /**
	 * Returns the meta object for class '{@link ttm.IdentifiedElement <em>Identified Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Identified Element</em>'.
	 * @see ttm.IdentifiedElement
	 * @generated
	 */
	EClass getIdentifiedElement();

    /**
	 * Returns the meta object for the attribute '{@link ttm.IdentifiedElement#getIdent <em>Ident</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ident</em>'.
	 * @see ttm.IdentifiedElement#getIdent()
	 * @see #getIdentifiedElement()
	 * @generated
	 */
	EAttribute getIdentifiedElement_Ident();

    /**
	 * Returns the meta object for the attribute '{@link ttm.IdentifiedElement#getShortDescription <em>Short Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Short Description</em>'.
	 * @see ttm.IdentifiedElement#getShortDescription()
	 * @see #getIdentifiedElement()
	 * @generated
	 */
	EAttribute getIdentifiedElement_ShortDescription();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.IdentifiedElement#getTexts <em>Texts</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Texts</em>'.
	 * @see ttm.IdentifiedElement#getTexts()
	 * @see #getIdentifiedElement()
	 * @generated
	 */
    EReference getIdentifiedElement_Texts();

    /**
	 * Returns the meta object for class '{@link ttm.Text <em>Text</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Text</em>'.
	 * @see ttm.Text
	 * @generated
	 */
	EClass getText();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Text#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see ttm.Text#getValue()
	 * @see #getText()
	 * @generated
	 */
	EAttribute getText_Value();

    /**
	 * Returns the meta object for the container reference '{@link ttm.Text#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see ttm.Text#getParent()
	 * @see #getText()
	 * @generated
	 */
	EReference getText_Parent();

    /**
	 * Returns the meta object for class '{@link ttm.Attribute <em>Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Attribute</em>'.
	 * @see ttm.Attribute
	 * @generated
	 */
	EClass getAttribute();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Attribute#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see ttm.Attribute#getName()
	 * @see #getAttribute()
	 * @generated
	 */
	EAttribute getAttribute_Name();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Attribute#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see ttm.Attribute#getValue()
	 * @see #getAttribute()
	 * @generated
	 */
	EAttribute getAttribute_Value();

    /**
	 * Returns the meta object for the container reference '{@link ttm.Attribute#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see ttm.Attribute#getParent()
	 * @see #getAttribute()
	 * @generated
	 */
	EReference getAttribute_Parent();

    /**
	 * Returns the meta object for class '{@link ttm.Requirement <em>Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Requirement</em>'.
	 * @see ttm.Requirement
	 * @generated
	 */
	EClass getRequirement();

    /**
	 * Returns the meta object for the reference list '{@link ttm.Requirement#getIncomingCoverLinks <em>Incoming Cover Links</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Incoming Cover Links</em>'.
	 * @see ttm.Requirement#getIncomingCoverLinks()
	 * @see #getRequirement()
	 * @generated
	 */
    EReference getRequirement_IncomingCoverLinks();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Requirement#getSubCoveringRequirementsRatio <em>Sub Covering Requirements Ratio</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sub Covering Requirements Ratio</em>'.
	 * @see ttm.Requirement#getSubCoveringRequirementsRatio()
	 * @see #getRequirement()
	 * @generated
	 */
    EAttribute getRequirement_SubCoveringRequirementsRatio();

    /**
	 * Returns the meta object for class '{@link ttm.CoverLink <em>Cover Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cover Link</em>'.
	 * @see ttm.CoverLink
	 * @generated
	 */
	EClass getCoverLink();

    /**
	 * Returns the meta object for the container reference '{@link ttm.CoverLink#getFrom <em>From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>From</em>'.
	 * @see ttm.CoverLink#getFrom()
	 * @see #getCoverLink()
	 * @generated
	 */
	EReference getCoverLink_From();

    /**
	 * Returns the meta object for the reference '{@link ttm.CoverLink#getTo <em>To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To</em>'.
	 * @see ttm.CoverLink#getTo()
	 * @see #getCoverLink()
	 * @generated
	 */
	EReference getCoverLink_To();

    /**
	 * Returns the meta object for class '{@link ttm.NavigationLink <em>Navigation Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Navigation Link</em>'.
	 * @see ttm.NavigationLink
	 * @generated
	 */
	EClass getNavigationLink();

    /**
	 * Returns the meta object for the reference '{@link ttm.NavigationLink#getTo <em>To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To</em>'.
	 * @see ttm.NavigationLink#getTo()
	 * @see #getNavigationLink()
	 * @generated
	 */
	EReference getNavigationLink_To();

    /**
	 * Returns the meta object for the container reference '{@link ttm.NavigationLink#getFrom <em>From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>From</em>'.
	 * @see ttm.NavigationLink#getFrom()
	 * @see #getNavigationLink()
	 * @generated
	 */
	EReference getNavigationLink_From();

    /**
	 * Returns the meta object for class '{@link ttm.AbstractLink <em>Abstract Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Link</em>'.
	 * @see ttm.AbstractLink
	 * @generated
	 */
	EClass getAbstractLink();

    /**
	 * Returns the meta object for the attribute '{@link ttm.AbstractLink#isUnresolved <em>Unresolved</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unresolved</em>'.
	 * @see ttm.AbstractLink#isUnresolved()
	 * @see #getAbstractLink()
	 * @generated
	 */
	EAttribute getAbstractLink_Unresolved();

    /**
	 * Returns the meta object for the attribute '{@link ttm.AbstractLink#getReferencedID <em>Referenced ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Referenced ID</em>'.
	 * @see ttm.AbstractLink#getReferencedID()
	 * @see #getAbstractLink()
	 * @generated
	 */
	EAttribute getAbstractLink_ReferencedID();

    /**
	 * Returns the meta object for class '{@link ttm.Project <em>Project</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Project</em>'.
	 * @see ttm.Project
	 * @generated
	 */
	EClass getProject();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.Project#getDocuments <em>Documents</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Documents</em>'.
	 * @see ttm.Project#getDocuments()
	 * @see #getProject()
	 * @generated
	 */
    EReference getProject_Documents();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.Project#getRules <em>Rules</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rules</em>'.
	 * @see ttm.Project#getRules()
	 * @see #getProject()
	 * @generated
	 */
    EReference getProject_Rules();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.Project#getCoverageResults <em>Coverage Results</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Coverage Results</em>'.
	 * @see ttm.Project#getCoverageResults()
	 * @see #getProject()
	 * @generated
	 */
    EReference getProject_CoverageResults();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Project#isAnyDocumentCovered <em>Any Document Covered</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Any Document Covered</em>'.
	 * @see ttm.Project#isAnyDocumentCovered()
	 * @see #getProject()
	 * @generated
	 */
    EAttribute getProject_AnyDocumentCovered();

    /**
	 * Returns the meta object for class '{@link ttm.Element <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Element</em>'.
	 * @see ttm.Element
	 * @generated
	 */
	EClass getElement();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.Element#getActivatedRules <em>Activated Rules</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Activated Rules</em>'.
	 * @see ttm.Element#getActivatedRules()
	 * @see #getElement()
	 * @generated
	 */
    EReference getElement_ActivatedRules();

    /**
	 * Returns the meta object for class '{@link ttm.RuleInstance <em>Rule Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rule Instance</em>'.
	 * @see ttm.RuleInstance
	 * @generated
	 */
	EClass getRuleInstance();

    /**
	 * Returns the meta object for the container reference '{@link ttm.RuleInstance#getElement <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Element</em>'.
	 * @see ttm.RuleInstance#getElement()
	 * @see #getRuleInstance()
	 * @generated
	 */
	EReference getRuleInstance_Element();

    /**
	 * Returns the meta object for the reference '{@link ttm.RuleInstance#getBaseRule <em>Base Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Base Rule</em>'.
	 * @see ttm.RuleInstance#getBaseRule()
	 * @see #getRuleInstance()
	 * @generated
	 */
	EReference getRuleInstance_BaseRule();

    /**
	 * Returns the meta object for the attribute '{@link ttm.RuleInstance#getDisplayMessage <em>Display Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Display Message</em>'.
	 * @see ttm.RuleInstance#getDisplayMessage()
	 * @see #getRuleInstance()
	 * @generated
	 */
	EAttribute getRuleInstance_DisplayMessage();

    /**
	 * Returns the meta object for class '{@link ttm.AttributeOwner <em>Attribute Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Attribute Owner</em>'.
	 * @see ttm.AttributeOwner
	 * @generated
	 */
	EClass getAttributeOwner();

    /**
	 * Returns the meta object for the containment reference list '{@link ttm.AttributeOwner#getAttributes <em>Attributes</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Attributes</em>'.
	 * @see ttm.AttributeOwner#getAttributes()
	 * @see #getAttributeOwner()
	 * @generated
	 */
    EReference getAttributeOwner_Attributes();

    /**
	 * Returns the meta object for class '{@link ttm.Rule <em>Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rule</em>'.
	 * @see ttm.Rule
	 * @generated
	 */
	EClass getRule();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Rule#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see ttm.Rule#getName()
	 * @see #getRule()
	 * @generated
	 */
	EAttribute getRule_Name();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Rule#getLevel <em>Level</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Level</em>'.
	 * @see ttm.Rule#getLevel()
	 * @see #getRule()
	 * @generated
	 */
	EAttribute getRule_Level();

    /**
	 * Returns the meta object for the reference list '{@link ttm.Rule#getRuleInstances <em>Rule Instances</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Rule Instances</em>'.
	 * @see ttm.Rule#getRuleInstances()
	 * @see #getRule()
	 * @generated
	 */
    EReference getRule_RuleInstances();

    /**
	 * Returns the meta object for the attribute '{@link ttm.Rule#getMessage <em>Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Message</em>'.
	 * @see ttm.Rule#getMessage()
	 * @see #getRule()
	 * @generated
	 */
	EAttribute getRule_Message();

    /**
	 * Returns the meta object for class '{@link ttm.CoverageResult <em>Coverage Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Coverage Result</em>'.
	 * @see ttm.CoverageResult
	 * @generated
	 */
	EClass getCoverageResult();

    /**
	 * Returns the meta object for the attribute '{@link ttm.CoverageResult#getCoverage <em>Coverage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Coverage</em>'.
	 * @see ttm.CoverageResult#getCoverage()
	 * @see #getCoverageResult()
	 * @generated
	 */
	EAttribute getCoverageResult_Coverage();

    /**
	 * Returns the meta object for the container reference '{@link ttm.CoverageResult#getProject <em>Project</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Project</em>'.
	 * @see ttm.CoverageResult#getProject()
	 * @see #getCoverageResult()
	 * @generated
	 */
	EReference getCoverageResult_Project();

    /**
	 * Returns the meta object for the reference '{@link ttm.CoverageResult#getFromDocument <em>From Document</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From Document</em>'.
	 * @see ttm.CoverageResult#getFromDocument()
	 * @see #getCoverageResult()
	 * @generated
	 */
	EReference getCoverageResult_FromDocument();

    /**
	 * Returns the meta object for the reference '{@link ttm.CoverageResult#getToDocument <em>To Document</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To Document</em>'.
	 * @see ttm.CoverageResult#getToDocument()
	 * @see #getCoverageResult()
	 * @generated
	 */
	EReference getCoverageResult_ToDocument();

    /**
	 * Returns the meta object for the reference '{@link ttm.CoverageResult#getFromCoverPoint <em>From Cover Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From Cover Point</em>'.
	 * @see ttm.CoverageResult#getFromCoverPoint()
	 * @see #getCoverageResult()
	 * @generated
	 */
	EReference getCoverageResult_FromCoverPoint();

    /**
	 * Returns the meta object for class '{@link ttm.CoverPoint <em>Cover Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cover Point</em>'.
	 * @see ttm.CoverPoint
	 * @generated
	 */
	EClass getCoverPoint();

    /**
	 * Returns the meta object for the attribute '{@link ttm.CoverPoint#isAndCover <em>And Cover</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>And Cover</em>'.
	 * @see ttm.CoverPoint#isAndCover()
	 * @see #getCoverPoint()
	 * @generated
	 */
	EAttribute getCoverPoint_AndCover();

    /**
	 * Returns the meta object for the container reference '{@link ttm.CoverPoint#getCoveredDocument <em>Covered Document</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Covered Document</em>'.
	 * @see ttm.CoverPoint#getCoveredDocument()
	 * @see #getCoverPoint()
	 * @generated
	 */
	EReference getCoverPoint_CoveredDocument();

    /**
	 * Returns the meta object for the reference list '{@link ttm.CoverPoint#getConnectedDocuments <em>Connected Documents</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Connected Documents</em>'.
	 * @see ttm.CoverPoint#getConnectedDocuments()
	 * @see #getCoverPoint()
	 * @generated
	 */
    EReference getCoverPoint_ConnectedDocuments();

    /**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	TtmFactory getTtmFactory();

    /**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals 
	{
        /**
		 * The meta object literal for the '{@link ttm.impl.HierarchicalElementImpl <em>Hierarchical Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.HierarchicalElementImpl
		 * @see ttm.impl.TtmPackageImpl#getHierarchicalElement()
		 * @generated
		 */
		EClass HIERARCHICAL_ELEMENT = eINSTANCE.getHierarchicalElement();

        /**
		 * The meta object literal for the '<em><b>Incoming Navigation Links</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS = eINSTANCE.getHierarchicalElement_IncomingNavigationLinks();

        /**
		 * The meta object literal for the '<em><b>Navigation Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference HIERARCHICAL_ELEMENT__NAVIGATION_LINKS = eINSTANCE.getHierarchicalElement_NavigationLinks();

        /**
		 * The meta object literal for the '<em><b>Cover Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference HIERARCHICAL_ELEMENT__COVER_LINKS = eINSTANCE.getHierarchicalElement_CoverLinks();

        /**
		 * The meta object literal for the '<em><b>Children</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference HIERARCHICAL_ELEMENT__CHILDREN = eINSTANCE.getHierarchicalElement_Children();

        /**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference HIERARCHICAL_ELEMENT__PARENT = eINSTANCE.getHierarchicalElement_Parent();

        /**
		 * The meta object literal for the '{@link ttm.impl.DocumentImpl <em>Document</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.DocumentImpl
		 * @see ttm.impl.TtmPackageImpl#getDocument()
		 * @generated
		 */
		EClass DOCUMENT = eINSTANCE.getDocument();

        /**
		 * The meta object literal for the '<em><b>Analyzer ID</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOCUMENT__ANALYZER_ID = eINSTANCE.getDocument_AnalyzerID();

        /**
		 * The meta object literal for the '<em><b>Last Modified Date</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOCUMENT__LAST_MODIFIED_DATE = eINSTANCE.getDocument_LastModifiedDate();

        /**
		 * The meta object literal for the '<em><b>Filename</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOCUMENT__FILENAME = eINSTANCE.getDocument_Filename();

        /**
		 * The meta object literal for the '<em><b>Covers Itself</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOCUMENT__COVERS_ITSELF = eINSTANCE.getDocument_CoversItself();

        /**
		 * The meta object literal for the '<em><b>Project</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT__PROJECT = eINSTANCE.getDocument_Project();

        /**
		 * The meta object literal for the '<em><b>Cover Points</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference DOCUMENT__COVER_POINTS = eINSTANCE.getDocument_CoverPoints();

        /**
		 * The meta object literal for the '<em><b>Incoming Cover Points</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference DOCUMENT__INCOMING_COVER_POINTS = eINSTANCE.getDocument_IncomingCoverPoints();

        /**
		 * The meta object literal for the '<em><b>Conversion Method ID</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOCUMENT__CONVERSION_METHOD_ID = eINSTANCE.getDocument_ConversionMethodID();

        /**
		 * The meta object literal for the '<em><b>Analyzer Arguments</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DOCUMENT__ANALYZER_ARGUMENTS = eINSTANCE.getDocument_AnalyzerArguments();

        /**
		 * The meta object literal for the '<em><b>Global Coverage Ratio</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute DOCUMENT__GLOBAL_COVERAGE_RATIO = eINSTANCE.getDocument_GlobalCoverageRatio();

        /**
		 * The meta object literal for the '<em><b>Edition Method ID</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOCUMENT__EDITION_METHOD_ID = eINSTANCE.getDocument_EditionMethodID();

								/**
		 * The meta object literal for the '{@link ttm.impl.SectionImpl <em>Section</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.SectionImpl
		 * @see ttm.impl.TtmPackageImpl#getSection()
		 * @generated
		 */
		EClass SECTION = eINSTANCE.getSection();

        /**
		 * The meta object literal for the '{@link ttm.impl.IdentifiedElementImpl <em>Identified Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.IdentifiedElementImpl
		 * @see ttm.impl.TtmPackageImpl#getIdentifiedElement()
		 * @generated
		 */
		EClass IDENTIFIED_ELEMENT = eINSTANCE.getIdentifiedElement();

        /**
		 * The meta object literal for the '<em><b>Ident</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute IDENTIFIED_ELEMENT__IDENT = eINSTANCE.getIdentifiedElement_Ident();

        /**
		 * The meta object literal for the '<em><b>Short Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute IDENTIFIED_ELEMENT__SHORT_DESCRIPTION = eINSTANCE.getIdentifiedElement_ShortDescription();

        /**
		 * The meta object literal for the '<em><b>Texts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference IDENTIFIED_ELEMENT__TEXTS = eINSTANCE.getIdentifiedElement_Texts();

        /**
		 * The meta object literal for the '{@link ttm.impl.TextImpl <em>Text</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.TextImpl
		 * @see ttm.impl.TtmPackageImpl#getText()
		 * @generated
		 */
		EClass TEXT = eINSTANCE.getText();

        /**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TEXT__VALUE = eINSTANCE.getText_Value();

        /**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TEXT__PARENT = eINSTANCE.getText_Parent();

        /**
		 * The meta object literal for the '{@link ttm.impl.AttributeImpl <em>Attribute</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.AttributeImpl
		 * @see ttm.impl.TtmPackageImpl#getAttribute()
		 * @generated
		 */
		EClass ATTRIBUTE = eINSTANCE.getAttribute();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ATTRIBUTE__NAME = eINSTANCE.getAttribute_Name();

        /**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ATTRIBUTE__VALUE = eINSTANCE.getAttribute_Value();

        /**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ATTRIBUTE__PARENT = eINSTANCE.getAttribute_Parent();

        /**
		 * The meta object literal for the '{@link ttm.impl.RequirementImpl <em>Requirement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.RequirementImpl
		 * @see ttm.impl.TtmPackageImpl#getRequirement()
		 * @generated
		 */
		EClass REQUIREMENT = eINSTANCE.getRequirement();

        /**
		 * The meta object literal for the '<em><b>Incoming Cover Links</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference REQUIREMENT__INCOMING_COVER_LINKS = eINSTANCE.getRequirement_IncomingCoverLinks();

        /**
		 * The meta object literal for the '<em><b>Sub Covering Requirements Ratio</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute REQUIREMENT__SUB_COVERING_REQUIREMENTS_RATIO = eINSTANCE.getRequirement_SubCoveringRequirementsRatio();

        /**
		 * The meta object literal for the '{@link ttm.impl.CoverLinkImpl <em>Cover Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.CoverLinkImpl
		 * @see ttm.impl.TtmPackageImpl#getCoverLink()
		 * @generated
		 */
		EClass COVER_LINK = eINSTANCE.getCoverLink();

        /**
		 * The meta object literal for the '<em><b>From</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COVER_LINK__FROM = eINSTANCE.getCoverLink_From();

        /**
		 * The meta object literal for the '<em><b>To</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COVER_LINK__TO = eINSTANCE.getCoverLink_To();

        /**
		 * The meta object literal for the '{@link ttm.impl.NavigationLinkImpl <em>Navigation Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.NavigationLinkImpl
		 * @see ttm.impl.TtmPackageImpl#getNavigationLink()
		 * @generated
		 */
		EClass NAVIGATION_LINK = eINSTANCE.getNavigationLink();

        /**
		 * The meta object literal for the '<em><b>To</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NAVIGATION_LINK__TO = eINSTANCE.getNavigationLink_To();

        /**
		 * The meta object literal for the '<em><b>From</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NAVIGATION_LINK__FROM = eINSTANCE.getNavigationLink_From();

        /**
		 * The meta object literal for the '{@link ttm.impl.AbstractLinkImpl <em>Abstract Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.AbstractLinkImpl
		 * @see ttm.impl.TtmPackageImpl#getAbstractLink()
		 * @generated
		 */
		EClass ABSTRACT_LINK = eINSTANCE.getAbstractLink();

        /**
		 * The meta object literal for the '<em><b>Unresolved</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_LINK__UNRESOLVED = eINSTANCE.getAbstractLink_Unresolved();

        /**
		 * The meta object literal for the '<em><b>Referenced ID</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_LINK__REFERENCED_ID = eINSTANCE.getAbstractLink_ReferencedID();

        /**
		 * The meta object literal for the '{@link ttm.impl.ProjectImpl <em>Project</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.ProjectImpl
		 * @see ttm.impl.TtmPackageImpl#getProject()
		 * @generated
		 */
		EClass PROJECT = eINSTANCE.getProject();

        /**
		 * The meta object literal for the '<em><b>Documents</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference PROJECT__DOCUMENTS = eINSTANCE.getProject_Documents();

        /**
		 * The meta object literal for the '<em><b>Rules</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference PROJECT__RULES = eINSTANCE.getProject_Rules();

        /**
		 * The meta object literal for the '<em><b>Coverage Results</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference PROJECT__COVERAGE_RESULTS = eINSTANCE.getProject_CoverageResults();

        /**
		 * The meta object literal for the '<em><b>Any Document Covered</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute PROJECT__ANY_DOCUMENT_COVERED = eINSTANCE.getProject_AnyDocumentCovered();

        /**
		 * The meta object literal for the '{@link ttm.impl.ElementImpl <em>Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.ElementImpl
		 * @see ttm.impl.TtmPackageImpl#getElement()
		 * @generated
		 */
		EClass ELEMENT = eINSTANCE.getElement();

        /**
		 * The meta object literal for the '<em><b>Activated Rules</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ELEMENT__ACTIVATED_RULES = eINSTANCE.getElement_ActivatedRules();

        /**
		 * The meta object literal for the '{@link ttm.impl.RuleInstanceImpl <em>Rule Instance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.RuleInstanceImpl
		 * @see ttm.impl.TtmPackageImpl#getRuleInstance()
		 * @generated
		 */
		EClass RULE_INSTANCE = eINSTANCE.getRuleInstance();

        /**
		 * The meta object literal for the '<em><b>Element</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RULE_INSTANCE__ELEMENT = eINSTANCE.getRuleInstance_Element();

        /**
		 * The meta object literal for the '<em><b>Base Rule</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RULE_INSTANCE__BASE_RULE = eINSTANCE.getRuleInstance_BaseRule();

        /**
		 * The meta object literal for the '<em><b>Display Message</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RULE_INSTANCE__DISPLAY_MESSAGE = eINSTANCE.getRuleInstance_DisplayMessage();

        /**
		 * The meta object literal for the '{@link ttm.impl.AttributeOwnerImpl <em>Attribute Owner</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.AttributeOwnerImpl
		 * @see ttm.impl.TtmPackageImpl#getAttributeOwner()
		 * @generated
		 */
		EClass ATTRIBUTE_OWNER = eINSTANCE.getAttributeOwner();

        /**
		 * The meta object literal for the '<em><b>Attributes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ATTRIBUTE_OWNER__ATTRIBUTES = eINSTANCE.getAttributeOwner_Attributes();

        /**
		 * The meta object literal for the '{@link ttm.impl.RuleImpl <em>Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.RuleImpl
		 * @see ttm.impl.TtmPackageImpl#getRule()
		 * @generated
		 */
		EClass RULE = eINSTANCE.getRule();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RULE__NAME = eINSTANCE.getRule_Name();

        /**
		 * The meta object literal for the '<em><b>Level</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RULE__LEVEL = eINSTANCE.getRule_Level();

        /**
		 * The meta object literal for the '<em><b>Rule Instances</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference RULE__RULE_INSTANCES = eINSTANCE.getRule_RuleInstances();

        /**
		 * The meta object literal for the '<em><b>Message</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RULE__MESSAGE = eINSTANCE.getRule_Message();

        /**
		 * The meta object literal for the '{@link ttm.impl.CoverageResultImpl <em>Coverage Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.CoverageResultImpl
		 * @see ttm.impl.TtmPackageImpl#getCoverageResult()
		 * @generated
		 */
		EClass COVERAGE_RESULT = eINSTANCE.getCoverageResult();

        /**
		 * The meta object literal for the '<em><b>Coverage</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COVERAGE_RESULT__COVERAGE = eINSTANCE.getCoverageResult_Coverage();

        /**
		 * The meta object literal for the '<em><b>Project</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COVERAGE_RESULT__PROJECT = eINSTANCE.getCoverageResult_Project();

        /**
		 * The meta object literal for the '<em><b>From Document</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COVERAGE_RESULT__FROM_DOCUMENT = eINSTANCE.getCoverageResult_FromDocument();

        /**
		 * The meta object literal for the '<em><b>To Document</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COVERAGE_RESULT__TO_DOCUMENT = eINSTANCE.getCoverageResult_ToDocument();

        /**
		 * The meta object literal for the '<em><b>From Cover Point</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COVERAGE_RESULT__FROM_COVER_POINT = eINSTANCE.getCoverageResult_FromCoverPoint();

        /**
		 * The meta object literal for the '{@link ttm.impl.CoverPointImpl <em>Cover Point</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ttm.impl.CoverPointImpl
		 * @see ttm.impl.TtmPackageImpl#getCoverPoint()
		 * @generated
		 */
		EClass COVER_POINT = eINSTANCE.getCoverPoint();

        /**
		 * The meta object literal for the '<em><b>And Cover</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COVER_POINT__AND_COVER = eINSTANCE.getCoverPoint_AndCover();

        /**
		 * The meta object literal for the '<em><b>Covered Document</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COVER_POINT__COVERED_DOCUMENT = eINSTANCE.getCoverPoint_CoveredDocument();

        /**
		 * The meta object literal for the '<em><b>Connected Documents</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference COVER_POINT__CONNECTED_DOCUMENTS = eINSTANCE.getCoverPoint_ConnectedDocuments();

    }

} //TtmPackage
