/**
 * <copyright>
 * </copyright>
 *
 * $Id: CoverageResultImpl.java,v 1.2 2007-05-15 10:30:15 llebars Exp $
 */
package ttm.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

import ttm.CoverPoint;
import ttm.CoverageResult;
import ttm.Document;
import ttm.Project;
import ttm.TtmPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Coverage Result</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ttm.impl.CoverageResultImpl#getCoverage <em>Coverage</em>}</li>
 *   <li>{@link ttm.impl.CoverageResultImpl#getProject <em>Project</em>}</li>
 *   <li>{@link ttm.impl.CoverageResultImpl#getFromDocument <em>From Document</em>}</li>
 *   <li>{@link ttm.impl.CoverageResultImpl#getToDocument <em>To Document</em>}</li>
 *   <li>{@link ttm.impl.CoverageResultImpl#getFromCoverPoint <em>From Cover Point</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CoverageResultImpl extends EObjectImpl implements CoverageResult 
{
    /**
	 * The default value of the '{@link #getCoverage() <em>Coverage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCoverage()
	 * @generated
	 * @ordered
	 */
	protected static final float COVERAGE_EDEFAULT = 0.0F;

    /**
	 * The cached value of the '{@link #getCoverage() <em>Coverage</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCoverage()
	 * @generated
	 * @ordered
	 */
	protected float coverage = COVERAGE_EDEFAULT;

    /**
	 * The cached value of the '{@link #getFromDocument() <em>From Document</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFromDocument()
	 * @generated
	 * @ordered
	 */
	protected Document fromDocument = null;

    /**
	 * The cached value of the '{@link #getToDocument() <em>To Document</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToDocument()
	 * @generated
	 * @ordered
	 */
	protected Document toDocument = null;

    /**
	 * The cached value of the '{@link #getFromCoverPoint() <em>From Cover Point</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFromCoverPoint()
	 * @generated
	 * @ordered
	 */
	protected CoverPoint fromCoverPoint = null;

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoverageResultImpl()
    {
		super();
	}

	/**
	 * constructor to create Coverage Result between a document/coverPoint and another document
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @param the document that covers, can be null
	 * @param the coverpoint taht covers, can be null
	 * @param the document that is covered
	 * @param the coverage ratio
	 * @generated NOT
	 */
	
	public CoverageResultImpl(Document fromDocument, CoverPoint fromCoverPoint, Document to, float coverageRatio, Project prj){
		CoverageResult cvr = new CoverageResultImpl();
		if(fromDocument != null)
			cvr.setFromDocument(fromDocument);
		if(fromCoverPoint != null)
			cvr.setFromCoverPoint(fromCoverPoint);
		cvr.setToDocument(to);
		cvr.setCoverage(coverageRatio);
		cvr.setProject(prj);
	}


    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
    {
		return TtmPackage.Literals.COVERAGE_RESULT;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getCoverage()
    {
		return coverage;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCoverage(float newCoverage)
    {
		float oldCoverage = coverage;
		coverage = newCoverage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.COVERAGE_RESULT__COVERAGE, oldCoverage, coverage));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Project getProject()
    {
		if (eContainerFeatureID != TtmPackage.COVERAGE_RESULT__PROJECT) return null;
		return (Project)eContainer();
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetProject(Project newProject, NotificationChain msgs)
    {
		msgs = eBasicSetContainer((InternalEObject)newProject, TtmPackage.COVERAGE_RESULT__PROJECT, msgs);
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProject(Project newProject)
    {
		if (newProject != eInternalContainer() || (eContainerFeatureID != TtmPackage.COVERAGE_RESULT__PROJECT && newProject != null)) {
			if (EcoreUtil.isAncestor(this, newProject))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newProject != null)
				msgs = ((InternalEObject)newProject).eInverseAdd(this, TtmPackage.PROJECT__COVERAGE_RESULTS, Project.class, msgs);
			msgs = basicSetProject(newProject, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.COVERAGE_RESULT__PROJECT, newProject, newProject));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Document getFromDocument()
    {
		if (fromDocument != null && fromDocument.eIsProxy()) {
			InternalEObject oldFromDocument = (InternalEObject)fromDocument;
			fromDocument = (Document)eResolveProxy(oldFromDocument);
			if (fromDocument != oldFromDocument) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TtmPackage.COVERAGE_RESULT__FROM_DOCUMENT, oldFromDocument, fromDocument));
			}
		}
		return fromDocument;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Document basicGetFromDocument()
    {
		return fromDocument;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFromDocument(Document newFromDocument)
    {
		Document oldFromDocument = fromDocument;
		fromDocument = newFromDocument;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.COVERAGE_RESULT__FROM_DOCUMENT, oldFromDocument, fromDocument));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Document getToDocument()
    {
		if (toDocument != null && toDocument.eIsProxy()) {
			InternalEObject oldToDocument = (InternalEObject)toDocument;
			toDocument = (Document)eResolveProxy(oldToDocument);
			if (toDocument != oldToDocument) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TtmPackage.COVERAGE_RESULT__TO_DOCUMENT, oldToDocument, toDocument));
			}
		}
		return toDocument;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Document basicGetToDocument()
    {
		return toDocument;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setToDocument(Document newToDocument)
    {
		Document oldToDocument = toDocument;
		toDocument = newToDocument;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.COVERAGE_RESULT__TO_DOCUMENT, oldToDocument, toDocument));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CoverPoint getFromCoverPoint()
    {
		if (fromCoverPoint != null && fromCoverPoint.eIsProxy()) {
			InternalEObject oldFromCoverPoint = (InternalEObject)fromCoverPoint;
			fromCoverPoint = (CoverPoint)eResolveProxy(oldFromCoverPoint);
			if (fromCoverPoint != oldFromCoverPoint) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TtmPackage.COVERAGE_RESULT__FROM_COVER_POINT, oldFromCoverPoint, fromCoverPoint));
			}
		}
		return fromCoverPoint;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CoverPoint basicGetFromCoverPoint()
    {
		return fromCoverPoint;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFromCoverPoint(CoverPoint newFromCoverPoint)
    {
		CoverPoint oldFromCoverPoint = fromCoverPoint;
		fromCoverPoint = newFromCoverPoint;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.COVERAGE_RESULT__FROM_COVER_POINT, oldFromCoverPoint, fromCoverPoint));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.COVERAGE_RESULT__PROJECT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetProject((Project)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.COVERAGE_RESULT__PROJECT:
				return basicSetProject(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
    {
		switch (eContainerFeatureID) {
			case TtmPackage.COVERAGE_RESULT__PROJECT:
				return eInternalContainer().eInverseRemove(this, TtmPackage.PROJECT__COVERAGE_RESULTS, Project.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
		switch (featureID) {
			case TtmPackage.COVERAGE_RESULT__COVERAGE:
				return new Float(getCoverage());
			case TtmPackage.COVERAGE_RESULT__PROJECT:
				return getProject();
			case TtmPackage.COVERAGE_RESULT__FROM_DOCUMENT:
				if (resolve) return getFromDocument();
				return basicGetFromDocument();
			case TtmPackage.COVERAGE_RESULT__TO_DOCUMENT:
				if (resolve) return getToDocument();
				return basicGetToDocument();
			case TtmPackage.COVERAGE_RESULT__FROM_COVER_POINT:
				if (resolve) return getFromCoverPoint();
				return basicGetFromCoverPoint();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue)
    {
		switch (featureID) {
			case TtmPackage.COVERAGE_RESULT__COVERAGE:
				setCoverage(((Float)newValue).floatValue());
				return;
			case TtmPackage.COVERAGE_RESULT__PROJECT:
				setProject((Project)newValue);
				return;
			case TtmPackage.COVERAGE_RESULT__FROM_DOCUMENT:
				setFromDocument((Document)newValue);
				return;
			case TtmPackage.COVERAGE_RESULT__TO_DOCUMENT:
				setToDocument((Document)newValue);
				return;
			case TtmPackage.COVERAGE_RESULT__FROM_COVER_POINT:
				setFromCoverPoint((CoverPoint)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID)
    {
		switch (featureID) {
			case TtmPackage.COVERAGE_RESULT__COVERAGE:
				setCoverage(COVERAGE_EDEFAULT);
				return;
			case TtmPackage.COVERAGE_RESULT__PROJECT:
				setProject((Project)null);
				return;
			case TtmPackage.COVERAGE_RESULT__FROM_DOCUMENT:
				setFromDocument((Document)null);
				return;
			case TtmPackage.COVERAGE_RESULT__TO_DOCUMENT:
				setToDocument((Document)null);
				return;
			case TtmPackage.COVERAGE_RESULT__FROM_COVER_POINT:
				setFromCoverPoint((CoverPoint)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID)
    {
		switch (featureID) {
			case TtmPackage.COVERAGE_RESULT__COVERAGE:
				return coverage != COVERAGE_EDEFAULT;
			case TtmPackage.COVERAGE_RESULT__PROJECT:
				return getProject() != null;
			case TtmPackage.COVERAGE_RESULT__FROM_DOCUMENT:
				return fromDocument != null;
			case TtmPackage.COVERAGE_RESULT__TO_DOCUMENT:
				return toDocument != null;
			case TtmPackage.COVERAGE_RESULT__FROM_COVER_POINT:
				return fromCoverPoint != null;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
    {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (coverage: ");
		result.append(coverage);
		result.append(')');
		return result.toString();
	}

} //CoverageResultImpl
