/**
 * <copyright>
 * </copyright>
 *
 * $Id: DocumentImpl.java,v 1.3 2007-05-16 15:10:53 llebars Exp $
 */
package ttm.impl;

import java.io.PrintStream;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import ttm.CoverPoint;
import ttm.CoverageResult;
import ttm.Document;
import ttm.Project;
import ttm.TtmPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Document</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ttm.impl.DocumentImpl#getAnalyzerID <em>Analyzer ID</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getLastModifiedDate <em>Last Modified Date</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getFilename <em>Filename</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#isCoversItself <em>Covers Itself</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getProject <em>Project</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getCoverPoints <em>Cover Points</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getIncomingCoverPoints <em>Incoming Cover Points</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getConversionMethodID <em>Conversion Method ID</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getAnalyzerArguments <em>Analyzer Arguments</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getGlobalCoverageRatio <em>Global Coverage Ratio</em>}</li>
 *   <li>{@link ttm.impl.DocumentImpl#getEditionMethodID <em>Edition Method ID</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DocumentImpl extends HierarchicalElementImpl implements Document 
{
    /**
	 * The default value of the '{@link #getAnalyzerID() <em>Analyzer ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAnalyzerID()
	 * @generated
	 * @ordered
	 */
	protected static final String ANALYZER_ID_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getAnalyzerID() <em>Analyzer ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAnalyzerID()
	 * @generated
	 * @ordered
	 */
	protected String analyzerID = ANALYZER_ID_EDEFAULT;

    /**
	 * The default value of the '{@link #getLastModifiedDate() <em>Last Modified Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLastModifiedDate()
	 * @generated
	 * @ordered
	 */
	protected static final long LAST_MODIFIED_DATE_EDEFAULT = 0L;

    /**
	 * The cached value of the '{@link #getLastModifiedDate() <em>Last Modified Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLastModifiedDate()
	 * @generated
	 * @ordered
	 */
	protected long lastModifiedDate = LAST_MODIFIED_DATE_EDEFAULT;

    /**
	 * The default value of the '{@link #getFilename() <em>Filename</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFilename()
	 * @generated
	 * @ordered
	 */
	protected static final String FILENAME_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getFilename() <em>Filename</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFilename()
	 * @generated
	 * @ordered
	 */
	protected String filename = FILENAME_EDEFAULT;

    /**
	 * The default value of the '{@link #isCoversItself() <em>Covers Itself</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCoversItself()
	 * @generated
	 * @ordered
	 */
	protected static final boolean COVERS_ITSELF_EDEFAULT = false;

    /**
	 * The cached value of the '{@link #isCoversItself() <em>Covers Itself</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCoversItself()
	 * @generated
	 * @ordered
	 */
	protected boolean coversItself = COVERS_ITSELF_EDEFAULT;

    /**
	 * The cached value of the '{@link #getCoverPoints() <em>Cover Points</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getCoverPoints()
	 * @generated
	 * @ordered
	 */
    protected EList coverPoints = null;

    /**
	 * The cached value of the '{@link #getIncomingCoverPoints() <em>Incoming Cover Points</em>}' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getIncomingCoverPoints()
	 * @generated
	 * @ordered
	 */
    protected EList incomingCoverPoints = null;

    /**
	 * The default value of the '{@link #getConversionMethodID() <em>Conversion Method ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConversionMethodID()
	 * @generated
	 * @ordered
	 */
	protected static final String CONVERSION_METHOD_ID_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getConversionMethodID() <em>Conversion Method ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConversionMethodID()
	 * @generated
	 * @ordered
	 */
	protected String conversionMethodID = CONVERSION_METHOD_ID_EDEFAULT;

    /**
	 * The default value of the '{@link #getAnalyzerArguments() <em>Analyzer Arguments</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getAnalyzerArguments()
	 * @generated
	 * @ordered
	 */
    protected static final String ANALYZER_ARGUMENTS_EDEFAULT = null;

    /**
	 * The cached value of the '{@link #getAnalyzerArguments() <em>Analyzer Arguments</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getAnalyzerArguments()
	 * @generated
	 * @ordered
	 */
    protected String analyzerArguments = ANALYZER_ARGUMENTS_EDEFAULT;

    /**
	 * The default value of the '{@link #getGlobalCoverageRatio() <em>Global Coverage Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getGlobalCoverageRatio()
	 * @generated
	 * @ordered
	 */
    protected static final float GLOBAL_COVERAGE_RATIO_EDEFAULT = 0.0F;

    /**
	 * The cached value of the '{@link #getGlobalCoverageRatio() <em>Global Coverage Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getGlobalCoverageRatio()
	 * @generated
	 * @ordered
	 */
    protected float globalCoverageRatio = GLOBAL_COVERAGE_RATIO_EDEFAULT;

    /**
	 * The default value of the '{@link #getEditionMethodID() <em>Edition Method ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEditionMethodID()
	 * @generated
	 * @ordered
	 */
	protected static final String EDITION_METHOD_ID_EDEFAULT = null;

				/**
	 * The cached value of the '{@link #getEditionMethodID() <em>Edition Method ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEditionMethodID()
	 * @generated
	 * @ordered
	 */
	protected String editionMethodID = EDITION_METHOD_ID_EDEFAULT;

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
    {
		return TtmPackage.Literals.DOCUMENT;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAnalyzerID()
    {
		return analyzerID;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAnalyzerID(String newAnalyzerID)
    {
		String oldAnalyzerID = analyzerID;
		analyzerID = newAnalyzerID;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__ANALYZER_ID, oldAnalyzerID, analyzerID));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getLastModifiedDate()
    {
		return lastModifiedDate;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLastModifiedDate(long newLastModifiedDate)
    {
		long oldLastModifiedDate = lastModifiedDate;
		lastModifiedDate = newLastModifiedDate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__LAST_MODIFIED_DATE, oldLastModifiedDate, lastModifiedDate));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getFilename()
    {
		return filename;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFilename(String newFilename)
    {
		String oldFilename = filename;
		filename = newFilename;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__FILENAME, oldFilename, filename));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isCoversItself()
    {
		return coversItself;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCoversItself(boolean newCoversItself)
    {
		boolean oldCoversItself = coversItself;
		coversItself = newCoversItself;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__COVERS_ITSELF, oldCoversItself, coversItself));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Project getProject()
    {
		if (eContainerFeatureID != TtmPackage.DOCUMENT__PROJECT) return null;
		return (Project)eContainer();
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetProject(Project newProject, NotificationChain msgs)
    {
		msgs = eBasicSetContainer((InternalEObject)newProject, TtmPackage.DOCUMENT__PROJECT, msgs);
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProject(Project newProject)
    {
		if (newProject != eInternalContainer() || (eContainerFeatureID != TtmPackage.DOCUMENT__PROJECT && newProject != null)) {
			if (EcoreUtil.isAncestor(this, newProject))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newProject != null)
				msgs = ((InternalEObject)newProject).eInverseAdd(this, TtmPackage.PROJECT__DOCUMENTS, Project.class, msgs);
			msgs = basicSetProject(newProject, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__PROJECT, newProject, newProject));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getCoverPoints()
    {
		if (coverPoints == null) {
			coverPoints = new EObjectContainmentWithInverseEList(CoverPoint.class, this, TtmPackage.DOCUMENT__COVER_POINTS, TtmPackage.COVER_POINT__COVERED_DOCUMENT);
		}
		return coverPoints;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getIncomingCoverPoints()
    {
		if (incomingCoverPoints == null) {
			incomingCoverPoints = new EObjectWithInverseResolvingEList.ManyInverse(CoverPoint.class, this, TtmPackage.DOCUMENT__INCOMING_COVER_POINTS, TtmPackage.COVER_POINT__CONNECTED_DOCUMENTS);
		}
		return incomingCoverPoints;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getConversionMethodID()
    {
		return conversionMethodID;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConversionMethodID(String newConversionMethodID)
    {
		String oldConversionMethodID = conversionMethodID;
		conversionMethodID = newConversionMethodID;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__CONVERSION_METHOD_ID, oldConversionMethodID, conversionMethodID));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String getAnalyzerArguments()
    {
		return analyzerArguments;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setAnalyzerArguments(String newAnalyzerArguments)
    {
		String oldAnalyzerArguments = analyzerArguments;
		analyzerArguments = newAnalyzerArguments;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__ANALYZER_ARGUMENTS, oldAnalyzerArguments, analyzerArguments));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public float getGlobalCoverageRatio()
    {
		return globalCoverageRatio;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setGlobalCoverageRatio(float newGlobalCoverageRatio)
    {
		float oldGlobalCoverageRatio = globalCoverageRatio;
		globalCoverageRatio = newGlobalCoverageRatio;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__GLOBAL_COVERAGE_RATIO, oldGlobalCoverageRatio, globalCoverageRatio));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getEditionMethodID() {
		return editionMethodID;
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEditionMethodID(String newEditionMethodID) {
		String oldEditionMethodID = editionMethodID;
		editionMethodID = newEditionMethodID;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.DOCUMENT__EDITION_METHOD_ID, oldEditionMethodID, editionMethodID));
	}

				/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.DOCUMENT__PROJECT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetProject((Project)otherEnd, msgs);
			case TtmPackage.DOCUMENT__COVER_POINTS:
				return ((InternalEList)getCoverPoints()).basicAdd(otherEnd, msgs);
			case TtmPackage.DOCUMENT__INCOMING_COVER_POINTS:
				return ((InternalEList)getIncomingCoverPoints()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.DOCUMENT__PROJECT:
				return basicSetProject(null, msgs);
			case TtmPackage.DOCUMENT__COVER_POINTS:
				return ((InternalEList)getCoverPoints()).basicRemove(otherEnd, msgs);
			case TtmPackage.DOCUMENT__INCOMING_COVER_POINTS:
				return ((InternalEList)getIncomingCoverPoints()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
    {
		switch (eContainerFeatureID) {
			case TtmPackage.DOCUMENT__PROJECT:
				return eInternalContainer().eInverseRemove(this, TtmPackage.PROJECT__DOCUMENTS, Project.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
		switch (featureID) {
			case TtmPackage.DOCUMENT__ANALYZER_ID:
				return getAnalyzerID();
			case TtmPackage.DOCUMENT__LAST_MODIFIED_DATE:
				return new Long(getLastModifiedDate());
			case TtmPackage.DOCUMENT__FILENAME:
				return getFilename();
			case TtmPackage.DOCUMENT__COVERS_ITSELF:
				return isCoversItself() ? Boolean.TRUE : Boolean.FALSE;
			case TtmPackage.DOCUMENT__PROJECT:
				return getProject();
			case TtmPackage.DOCUMENT__COVER_POINTS:
				return getCoverPoints();
			case TtmPackage.DOCUMENT__INCOMING_COVER_POINTS:
				return getIncomingCoverPoints();
			case TtmPackage.DOCUMENT__CONVERSION_METHOD_ID:
				return getConversionMethodID();
			case TtmPackage.DOCUMENT__ANALYZER_ARGUMENTS:
				return getAnalyzerArguments();
			case TtmPackage.DOCUMENT__GLOBAL_COVERAGE_RATIO:
				return new Float(getGlobalCoverageRatio());
			case TtmPackage.DOCUMENT__EDITION_METHOD_ID:
				return getEditionMethodID();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue)
    {
		switch (featureID) {
			case TtmPackage.DOCUMENT__ANALYZER_ID:
				setAnalyzerID((String)newValue);
				return;
			case TtmPackage.DOCUMENT__LAST_MODIFIED_DATE:
				setLastModifiedDate(((Long)newValue).longValue());
				return;
			case TtmPackage.DOCUMENT__FILENAME:
				setFilename((String)newValue);
				return;
			case TtmPackage.DOCUMENT__COVERS_ITSELF:
				setCoversItself(((Boolean)newValue).booleanValue());
				return;
			case TtmPackage.DOCUMENT__PROJECT:
				setProject((Project)newValue);
				return;
			case TtmPackage.DOCUMENT__COVER_POINTS:
				getCoverPoints().clear();
				getCoverPoints().addAll((Collection)newValue);
				return;
			case TtmPackage.DOCUMENT__INCOMING_COVER_POINTS:
				getIncomingCoverPoints().clear();
				getIncomingCoverPoints().addAll((Collection)newValue);
				return;
			case TtmPackage.DOCUMENT__CONVERSION_METHOD_ID:
				setConversionMethodID((String)newValue);
				return;
			case TtmPackage.DOCUMENT__ANALYZER_ARGUMENTS:
				setAnalyzerArguments((String)newValue);
				return;
			case TtmPackage.DOCUMENT__GLOBAL_COVERAGE_RATIO:
				setGlobalCoverageRatio(((Float)newValue).floatValue());
				return;
			case TtmPackage.DOCUMENT__EDITION_METHOD_ID:
				setEditionMethodID((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID)
    {
		switch (featureID) {
			case TtmPackage.DOCUMENT__ANALYZER_ID:
				setAnalyzerID(ANALYZER_ID_EDEFAULT);
				return;
			case TtmPackage.DOCUMENT__LAST_MODIFIED_DATE:
				setLastModifiedDate(LAST_MODIFIED_DATE_EDEFAULT);
				return;
			case TtmPackage.DOCUMENT__FILENAME:
				setFilename(FILENAME_EDEFAULT);
				return;
			case TtmPackage.DOCUMENT__COVERS_ITSELF:
				setCoversItself(COVERS_ITSELF_EDEFAULT);
				return;
			case TtmPackage.DOCUMENT__PROJECT:
				setProject((Project)null);
				return;
			case TtmPackage.DOCUMENT__COVER_POINTS:
				getCoverPoints().clear();
				return;
			case TtmPackage.DOCUMENT__INCOMING_COVER_POINTS:
				getIncomingCoverPoints().clear();
				return;
			case TtmPackage.DOCUMENT__CONVERSION_METHOD_ID:
				setConversionMethodID(CONVERSION_METHOD_ID_EDEFAULT);
				return;
			case TtmPackage.DOCUMENT__ANALYZER_ARGUMENTS:
				setAnalyzerArguments(ANALYZER_ARGUMENTS_EDEFAULT);
				return;
			case TtmPackage.DOCUMENT__GLOBAL_COVERAGE_RATIO:
				setGlobalCoverageRatio(GLOBAL_COVERAGE_RATIO_EDEFAULT);
				return;
			case TtmPackage.DOCUMENT__EDITION_METHOD_ID:
				setEditionMethodID(EDITION_METHOD_ID_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID)
    {
		switch (featureID) {
			case TtmPackage.DOCUMENT__ANALYZER_ID:
				return ANALYZER_ID_EDEFAULT == null ? analyzerID != null : !ANALYZER_ID_EDEFAULT.equals(analyzerID);
			case TtmPackage.DOCUMENT__LAST_MODIFIED_DATE:
				return lastModifiedDate != LAST_MODIFIED_DATE_EDEFAULT;
			case TtmPackage.DOCUMENT__FILENAME:
				return FILENAME_EDEFAULT == null ? filename != null : !FILENAME_EDEFAULT.equals(filename);
			case TtmPackage.DOCUMENT__COVERS_ITSELF:
				return coversItself != COVERS_ITSELF_EDEFAULT;
			case TtmPackage.DOCUMENT__PROJECT:
				return getProject() != null;
			case TtmPackage.DOCUMENT__COVER_POINTS:
				return coverPoints != null && !coverPoints.isEmpty();
			case TtmPackage.DOCUMENT__INCOMING_COVER_POINTS:
				return incomingCoverPoints != null && !incomingCoverPoints.isEmpty();
			case TtmPackage.DOCUMENT__CONVERSION_METHOD_ID:
				return CONVERSION_METHOD_ID_EDEFAULT == null ? conversionMethodID != null : !CONVERSION_METHOD_ID_EDEFAULT.equals(conversionMethodID);
			case TtmPackage.DOCUMENT__ANALYZER_ARGUMENTS:
				return ANALYZER_ARGUMENTS_EDEFAULT == null ? analyzerArguments != null : !ANALYZER_ARGUMENTS_EDEFAULT.equals(analyzerArguments);
			case TtmPackage.DOCUMENT__GLOBAL_COVERAGE_RATIO:
				return globalCoverageRatio != GLOBAL_COVERAGE_RATIO_EDEFAULT;
			case TtmPackage.DOCUMENT__EDITION_METHOD_ID:
				return EDITION_METHOD_ID_EDEFAULT == null ? editionMethodID != null : !EDITION_METHOD_ID_EDEFAULT.equals(editionMethodID);
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
    {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (analyzerID: ");
		result.append(analyzerID);
		result.append(", lastModifiedDate: ");
		result.append(lastModifiedDate);
		result.append(", filename: ");
		result.append(filename);
		result.append(", coversItself: ");
		result.append(coversItself);
		result.append(", conversionMethodID: ");
		result.append(conversionMethodID);
		result.append(", analyzerArguments: ");
		result.append(analyzerArguments);
		result.append(", globalCoverageRatio: ");
		result.append(globalCoverageRatio);
		result.append(", editionMethodID: ");
		result.append(editionMethodID);
		result.append(')');
		return result.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Map<Object,Float> getCoverageResults(){
		Map<Object,Float> results = new HashMap<Object,Float>();
		for (CoverageResult covRes : getProject().getCoverageResults()) {
			if(covRes.getToDocument().equals(this)){
				if(covRes.getFromCoverPoint() == null) {
					results.put(covRes.getFromDocument(),covRes.getCoverage());
				} else {
					results.put(covRes.getFromCoverPoint(),covRes.getCoverage());
				}
			}
		}
		return results;
	}



	/**
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */	
	public void printCoverageResultsOn(PrintStream ptstr){
		Map<Object,Float> coverageResults = getCoverageResults();
		List<Document> coveringDocs = new ArrayList<Document>();
		DecimalFormat df = new DecimalFormat("###.00");
		if(getCoverPoints().isEmpty()) {
			String resultStr = "Document "+ident+" is not covered";		
			ptstr.println(resultStr);
		}else {
			String resultStr = "Document "+ident+" is covered by :";
			for(Iterator i = getCoverPoints().iterator();i.hasNext();){
				CoverPoint cvPoint = (CoverPoint)i.next();
				resultStr += "\n - {";
				boolean first = true;
				for(Iterator j = cvPoint.getConnectedDocuments().iterator();j.hasNext();){
					Document doc = (Document)j.next();
					coveringDocs.add(doc);
					if(!first) {
						resultStr += ", ";
					}
					resultStr += doc.getIdent()+"("+coverageResults.get(doc)+"%)";
				}
				resultStr += "}; covering mode is ";
				if(cvPoint.isAndCover()) {
					resultStr += " AND; ";
				} else {
					resultStr += " OR; ";					
				}
				resultStr += "Global ratio is "+df.format(coverageResults.get(cvPoint))+"%";
			}
			ptstr.println(resultStr);
			for(Iterator i = coveringDocs.iterator();i.hasNext();){
				Document covDoc =(Document)i.next();
				if(!covDoc.equals(this)) {
					covDoc.printCoverageResultsOn(ptstr);
				}
			}
		}
	}


	public List<Document> getCoveringDocuments() {
		List<Document>coveringDocs = new ArrayList<Document>();
		for(Iterator i = getCoverPoints().iterator(); i.hasNext();){
			CoverPoint covPoint = (CoverPoint)i.next();	
			for(Iterator i2 = covPoint.getConnectedDocuments().iterator();i2.hasNext();){
				Document covDoc = (Document)i2.next();
				if(covDoc.equals(this)) {
					this.setCoversItself(true);
				} else {
					coveringDocs.add(covDoc);
				}
			}
		}
		return coveringDocs;
	}

	public List<Document> getCoveredDocuments() {
		List<Document>coveredDocuments = new ArrayList<Document>();
		for(Iterator i = getIncomingCoverPoints().iterator();i.hasNext();){
			Document covDoc = ((CoverPoint)i.next()).getCoveredDocument();
			if(covDoc.equals(this)) {
				this.setCoversItself(true);
			} else {
				coveredDocuments.add(covDoc);
			}
		}
		return coveredDocuments;
	}
	
	public Document getDocument() {
		return this;
	}
} //DocumentImpl
