/**
 * <copyright>
 * </copyright>
 *
 * $Id: HierarchicalElementImpl.java,v 1.2 2007-05-15 10:30:16 llebars Exp $
 */
package ttm.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import ttm.CoverLink;
import ttm.Document;
import ttm.HierarchicalElement;
import ttm.NavigationLink;
import ttm.Requirement;
import ttm.TtmPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hierarchical Element</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ttm.impl.HierarchicalElementImpl#getIncomingNavigationLinks <em>Incoming Navigation Links</em>}</li>
 *   <li>{@link ttm.impl.HierarchicalElementImpl#getNavigationLinks <em>Navigation Links</em>}</li>
 *   <li>{@link ttm.impl.HierarchicalElementImpl#getCoverLinks <em>Cover Links</em>}</li>
 *   <li>{@link ttm.impl.HierarchicalElementImpl#getChildren <em>Children</em>}</li>
 *   <li>{@link ttm.impl.HierarchicalElementImpl#getParent <em>Parent</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class HierarchicalElementImpl extends IdentifiedElementImpl implements HierarchicalElement {
    /**
	 * The cached value of the '{@link #getIncomingNavigationLinks() <em>Incoming Navigation Links</em>}' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getIncomingNavigationLinks()
	 * @generated
	 * @ordered
	 */
    protected EList incomingNavigationLinks = null;

    /**
	 * The cached value of the '{@link #getNavigationLinks() <em>Navigation Links</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getNavigationLinks()
	 * @generated
	 * @ordered
	 */
    protected EList navigationLinks = null;

    /**
	 * The cached value of the '{@link #getCoverLinks() <em>Cover Links</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getCoverLinks()
	 * @generated
	 * @ordered
	 */
    protected EList coverLinks = null;

    /**
	 * The cached value of the '{@link #getChildren() <em>Children</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getChildren()
	 * @generated
	 * @ordered
	 */
    protected EList children = null;

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HierarchicalElementImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
    {
		return TtmPackage.Literals.HIERARCHICAL_ELEMENT;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getIncomingNavigationLinks()
    {
		if (incomingNavigationLinks == null) {
			incomingNavigationLinks = new EObjectWithInverseResolvingEList(NavigationLink.class, this, TtmPackage.HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS, TtmPackage.NAVIGATION_LINK__TO);
		}
		return incomingNavigationLinks;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getNavigationLinks()
    {
		if (navigationLinks == null) {
			navigationLinks = new EObjectContainmentWithInverseEList(NavigationLink.class, this, TtmPackage.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS, TtmPackage.NAVIGATION_LINK__FROM);
		}
		return navigationLinks;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getCoverLinks()
    {
		if (coverLinks == null) {
			coverLinks = new EObjectContainmentWithInverseEList(CoverLink.class, this, TtmPackage.HIERARCHICAL_ELEMENT__COVER_LINKS, TtmPackage.COVER_LINK__FROM);
		}
		return coverLinks;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getChildren()
    {
		if (children == null) {
			children = new EObjectContainmentWithInverseEList(HierarchicalElement.class, this, TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN, TtmPackage.HIERARCHICAL_ELEMENT__PARENT);
		}
		return children;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public HierarchicalElement getParent()
    {
		if (eContainerFeatureID != TtmPackage.HIERARCHICAL_ELEMENT__PARENT) return null;
		return (HierarchicalElement)eContainer();
	}

    /**
     * @return the document of the element.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public Document getDocument()
    {
        if (eContainerFeatureID != TtmPackage.HIERARCHICAL_ELEMENT__PARENT) return null;
        if (eContainer instanceof Document) {
            return (Document)eContainer();
        } else {
            HierarchicalElement parent = ((HierarchicalElement)eContainer()).getParent();
            if(parent instanceof Document) {
                return (Document)parent;
            } else {
                return parent.getDocument();
            }
        }
    }

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetParent(HierarchicalElement newParent, NotificationChain msgs)
    {
		msgs = eBasicSetContainer((InternalEObject)newParent, TtmPackage.HIERARCHICAL_ELEMENT__PARENT, msgs);
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setParent(HierarchicalElement newParent)
    {
		if (newParent != eInternalContainer() || (eContainerFeatureID != TtmPackage.HIERARCHICAL_ELEMENT__PARENT && newParent != null)) {
			if (EcoreUtil.isAncestor(this, newParent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newParent != null)
				msgs = ((InternalEObject)newParent).eInverseAdd(this, TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN, HierarchicalElement.class, msgs);
			msgs = basicSetParent(newParent, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.HIERARCHICAL_ELEMENT__PARENT, newParent, newParent));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS:
				return ((InternalEList)getIncomingNavigationLinks()).basicAdd(otherEnd, msgs);
			case TtmPackage.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS:
				return ((InternalEList)getNavigationLinks()).basicAdd(otherEnd, msgs);
			case TtmPackage.HIERARCHICAL_ELEMENT__COVER_LINKS:
				return ((InternalEList)getCoverLinks()).basicAdd(otherEnd, msgs);
			case TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN:
				return ((InternalEList)getChildren()).basicAdd(otherEnd, msgs);
			case TtmPackage.HIERARCHICAL_ELEMENT__PARENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetParent((HierarchicalElement)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS:
				return ((InternalEList)getIncomingNavigationLinks()).basicRemove(otherEnd, msgs);
			case TtmPackage.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS:
				return ((InternalEList)getNavigationLinks()).basicRemove(otherEnd, msgs);
			case TtmPackage.HIERARCHICAL_ELEMENT__COVER_LINKS:
				return ((InternalEList)getCoverLinks()).basicRemove(otherEnd, msgs);
			case TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN:
				return ((InternalEList)getChildren()).basicRemove(otherEnd, msgs);
			case TtmPackage.HIERARCHICAL_ELEMENT__PARENT:
				return basicSetParent(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs)
    {
		switch (eContainerFeatureID) {
			case TtmPackage.HIERARCHICAL_ELEMENT__PARENT:
				return eInternalContainer().eInverseRemove(this, TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN, HierarchicalElement.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
		switch (featureID) {
			case TtmPackage.HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS:
				return getIncomingNavigationLinks();
			case TtmPackage.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS:
				return getNavigationLinks();
			case TtmPackage.HIERARCHICAL_ELEMENT__COVER_LINKS:
				return getCoverLinks();
			case TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN:
				return getChildren();
			case TtmPackage.HIERARCHICAL_ELEMENT__PARENT:
				return getParent();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue)
    {
		switch (featureID) {
			case TtmPackage.HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS:
				getIncomingNavigationLinks().clear();
				getIncomingNavigationLinks().addAll((Collection)newValue);
				return;
			case TtmPackage.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS:
				getNavigationLinks().clear();
				getNavigationLinks().addAll((Collection)newValue);
				return;
			case TtmPackage.HIERARCHICAL_ELEMENT__COVER_LINKS:
				getCoverLinks().clear();
				getCoverLinks().addAll((Collection)newValue);
				return;
			case TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN:
				getChildren().clear();
				getChildren().addAll((Collection)newValue);
				return;
			case TtmPackage.HIERARCHICAL_ELEMENT__PARENT:
				setParent((HierarchicalElement)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID)
    {
		switch (featureID) {
			case TtmPackage.HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS:
				getIncomingNavigationLinks().clear();
				return;
			case TtmPackage.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS:
				getNavigationLinks().clear();
				return;
			case TtmPackage.HIERARCHICAL_ELEMENT__COVER_LINKS:
				getCoverLinks().clear();
				return;
			case TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN:
				getChildren().clear();
				return;
			case TtmPackage.HIERARCHICAL_ELEMENT__PARENT:
				setParent((HierarchicalElement)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID)
    {
		switch (featureID) {
			case TtmPackage.HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS:
				return incomingNavigationLinks != null && !incomingNavigationLinks.isEmpty();
			case TtmPackage.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS:
				return navigationLinks != null && !navigationLinks.isEmpty();
			case TtmPackage.HIERARCHICAL_ELEMENT__COVER_LINKS:
				return coverLinks != null && !coverLinks.isEmpty();
			case TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN:
				return children != null && !children.isEmpty();
			case TtmPackage.HIERARCHICAL_ELEMENT__PARENT:
				return getParent() != null;
		}
		return super.eIsSet(featureID);
	}

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     */
   public Boolean isMacroRequirement() {
       if (this instanceof Requirement) {
           for(Iterator i = getChildren().iterator(); i.hasNext();){
               HierarchicalElement child = (HierarchicalElement)i.next();
               if(child instanceof Requirement)
                   return true;
           }
       }
       return false;
    }
   
   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    */
    public Boolean isCoveringElementID(String identifier) {
        for(Iterator i = getCoverLinks().iterator();i.hasNext();){
            CoverLink cvLnk = (CoverLink)i.next();
            if(cvLnk.getReferencedID().equals(identifier))
                return true;
        } 
        return false;
    }
   
   
} //HierarchicalElementImpl
