/**
 * <copyright>
 * </copyright>
 *
 * $Id: ProjectImpl.java,v 1.4 2007-05-21 16:04:15 llebars Exp $
 */
package ttm.impl;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import ttm.CoverPoint;
import ttm.CoverageResult;
import ttm.Document;
import ttm.Project;
import ttm.Rule;
import ttm.TtmPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Project</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ttm.impl.ProjectImpl#getDocuments <em>Documents</em>}</li>
 *   <li>{@link ttm.impl.ProjectImpl#getRules <em>Rules</em>}</li>
 *   <li>{@link ttm.impl.ProjectImpl#getCoverageResults <em>Coverage Results</em>}</li>
 *   <li>{@link ttm.impl.ProjectImpl#isAnyDocumentCovered <em>Any Document Covered</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ProjectImpl extends IdentifiedElementImpl implements Project 
{
    /**
     * map of elements grouped by
     *  '{@link obj.eClass().getClassifierID()} class id'.
     *  @see #addCachedElement(Integer key, Object elt)
     */
    private HashMap < Integer, List < Object > > cachedElements;

    
    /**
	 * The cached value of the '{@link #getDocuments() <em>Documents</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getDocuments()
	 * @generated
	 * @ordered
	 */
    protected EList documents = null;

    /**
	 * The cached value of the '{@link #getRules() <em>Rules</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getRules()
	 * @generated
	 * @ordered
	 */
    protected EList rules = null;

    /**
	 * The cached value of the '{@link #getCoverageResults() <em>Coverage Results</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getCoverageResults()
	 * @generated
	 * @ordered
	 */
    protected EList coverageResults = null;

    /**
	 * The default value of the '{@link #isAnyDocumentCovered() <em>Any Document Covered</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #isAnyDocumentCovered()
	 * @generated
	 * @ordered
	 */
    protected static final boolean ANY_DOCUMENT_COVERED_EDEFAULT = false;

    /**
	 * The cached value of the '{@link #isAnyDocumentCovered() <em>Any Document Covered</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #isAnyDocumentCovered()
	 * @generated
	 * @ordered
	 */
    protected boolean anyDocumentCovered = ANY_DOCUMENT_COVERED_EDEFAULT;

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProjectImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
    {
		return TtmPackage.Literals.PROJECT;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getDocuments()
    {
		if (documents == null) {
			documents = new EObjectContainmentWithInverseEList(Document.class, this, TtmPackage.PROJECT__DOCUMENTS, TtmPackage.DOCUMENT__PROJECT);
		}
		return documents;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getRules()
    {
		if (rules == null) {
			rules = new EObjectContainmentEList(Rule.class, this, TtmPackage.PROJECT__RULES);
		}
		return rules;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getCoverageResults()
    {
		if (coverageResults == null) {
			coverageResults = new EObjectContainmentWithInverseEList(CoverageResult.class, this, TtmPackage.PROJECT__COVERAGE_RESULTS, TtmPackage.COVERAGE_RESULT__PROJECT);
		}
		return coverageResults;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public boolean isAnyDocumentCovered()
    {
		return anyDocumentCovered;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setAnyDocumentCovered(boolean newAnyDocumentCovered)
    {
		boolean oldAnyDocumentCovered = anyDocumentCovered;
		anyDocumentCovered = newAnyDocumentCovered;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.PROJECT__ANY_DOCUMENT_COVERED, oldAnyDocumentCovered, anyDocumentCovered));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.PROJECT__DOCUMENTS:
				return ((InternalEList)getDocuments()).basicAdd(otherEnd, msgs);
			case TtmPackage.PROJECT__COVERAGE_RESULTS:
				return ((InternalEList)getCoverageResults()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.PROJECT__DOCUMENTS:
				return ((InternalEList)getDocuments()).basicRemove(otherEnd, msgs);
			case TtmPackage.PROJECT__RULES:
				return ((InternalEList)getRules()).basicRemove(otherEnd, msgs);
			case TtmPackage.PROJECT__COVERAGE_RESULTS:
				return ((InternalEList)getCoverageResults()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
		switch (featureID) {
			case TtmPackage.PROJECT__DOCUMENTS:
				return getDocuments();
			case TtmPackage.PROJECT__RULES:
				return getRules();
			case TtmPackage.PROJECT__COVERAGE_RESULTS:
				return getCoverageResults();
			case TtmPackage.PROJECT__ANY_DOCUMENT_COVERED:
				return isAnyDocumentCovered() ? Boolean.TRUE : Boolean.FALSE;
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue)
    {
		switch (featureID) {
			case TtmPackage.PROJECT__DOCUMENTS:
				getDocuments().clear();
				getDocuments().addAll((Collection)newValue);
				return;
			case TtmPackage.PROJECT__RULES:
				getRules().clear();
				getRules().addAll((Collection)newValue);
				return;
			case TtmPackage.PROJECT__COVERAGE_RESULTS:
				getCoverageResults().clear();
				getCoverageResults().addAll((Collection)newValue);
				return;
			case TtmPackage.PROJECT__ANY_DOCUMENT_COVERED:
				setAnyDocumentCovered(((Boolean)newValue).booleanValue());
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID)
    {
		switch (featureID) {
			case TtmPackage.PROJECT__DOCUMENTS:
				getDocuments().clear();
				return;
			case TtmPackage.PROJECT__RULES:
				getRules().clear();
				return;
			case TtmPackage.PROJECT__COVERAGE_RESULTS:
				getCoverageResults().clear();
				return;
			case TtmPackage.PROJECT__ANY_DOCUMENT_COVERED:
				setAnyDocumentCovered(ANY_DOCUMENT_COVERED_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID)
    {
		switch (featureID) {
			case TtmPackage.PROJECT__DOCUMENTS:
				return documents != null && !documents.isEmpty();
			case TtmPackage.PROJECT__RULES:
				return rules != null && !rules.isEmpty();
			case TtmPackage.PROJECT__COVERAGE_RESULTS:
				return coverageResults != null && !coverageResults.isEmpty();
			case TtmPackage.PROJECT__ANY_DOCUMENT_COVERED:
				return anyDocumentCovered != ANY_DOCUMENT_COVERED_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
    {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (anyDocumentCovered: ");
		result.append(anyDocumentCovered);
		result.append(')');
		return result.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	 public Set<Document> getRootDocumentsFromProjectElements(){
			Iterator iter = getDocuments().iterator();
			Set<Document> roots = new HashSet<Document>();
			while (iter.hasNext()) {
				Document doc = (Document) iter.next();
				if(doc.getCoveredDocuments().isEmpty()) {
					roots.add(doc);
				}
			}		
			return roots;
		}

	

	/**
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	 public void addCoverageResult(Document fromDoc, CoverPoint fromCoverPoint, Document to, float ratio) {
		 new CoverageResultImpl(fromDoc, fromCoverPoint, to, ratio, this);
	 }

	/**
	 * <!-- begin-user-doc -->
	 * TNI Addition
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void addRuleDefinition(Rule aRule) {
		getRules().add(aRule);
	}
    
    
    /**
     * add converted elements by classifier IDs
     * @param key is the object.eClass.classifierID
     * @param elt is a list of object in project which class id is key
     */
    public void addCachedElement(Integer key, Object elt){
        if (cachedElements == null)
            cachedElements = new HashMap<Integer, List<Object>>();
        List<Object> list = cachedElements.get(key);
        if (list == null)
            list = new ArrayList<Object>();
        list.add(elt);
        cachedElements.put(key, list);
    }
    
    /**
     * gets the list of requirements in the project
     * @return list of '<b>Requirement</b>' class elements
     */
    public  List<Object> getRequirements()
    {
        if (cachedElements == null)
            return null;
        return cachedElements.get(TtmPackage.REQUIREMENT);
    }

    /**
     * clean the converted elements map
     */
    public void cleanCachedElements() {
         cachedElements = null;
     }

	/**
	 * @return null cause a Project is not owned in a Document
	 */
    public Document getDocument() {
		return null;
	}
    
    /**
     * gets the ttm filename.
     * @return the ttm filename.
     */
    public String getTtmFilename() {
    	try {
			URL url = FileLocator.resolve(new URL(eResource().getURI().toString()));
			if (url.getFile().matches("^.+results$")) {
				return url.getFile().replaceAll("\\.ttmresults$", ".ttm");
			} else {
				return url.getFile();
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
    }


} //ProjectImpl
