/**
 * <copyright>
 * </copyright>
 *
 * $Id: RequirementImpl.java,v 1.2 2007-05-15 10:30:14 llebars Exp $
 */
package ttm.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import ttm.CoverLink;
import ttm.HierarchicalElement;
import ttm.Requirement;
import ttm.TtmPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ttm.impl.RequirementImpl#getIncomingCoverLinks <em>Incoming Cover Links</em>}</li>
 *   <li>{@link ttm.impl.RequirementImpl#getSubCoveringRequirementsRatio <em>Sub Covering Requirements Ratio</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RequirementImpl extends HierarchicalElementImpl implements Requirement 
{
    /**
	 * The cached value of the '{@link #getIncomingCoverLinks() <em>Incoming Cover Links</em>}' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getIncomingCoverLinks()
	 * @generated
	 * @ordered
	 */
    protected EList incomingCoverLinks = null;

    /**
	 * The default value of the '{@link #getSubCoveringRequirementsRatio() <em>Sub Covering Requirements Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getSubCoveringRequirementsRatio()
	 * @generated
	 * @ordered
	 */
    protected static final float SUB_COVERING_REQUIREMENTS_RATIO_EDEFAULT = 0.0F;

    /**
	 * The cached value of the '{@link #getSubCoveringRequirementsRatio() <em>Sub Covering Requirements Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getSubCoveringRequirementsRatio()
	 * @generated
	 * @ordered
	 */
    protected float subCoveringRequirementsRatio = SUB_COVERING_REQUIREMENTS_RATIO_EDEFAULT;

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RequirementImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
    {
		return TtmPackage.Literals.REQUIREMENT;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList getIncomingCoverLinks()
    {
		if (incomingCoverLinks == null) {
			incomingCoverLinks = new EObjectWithInverseResolvingEList(CoverLink.class, this, TtmPackage.REQUIREMENT__INCOMING_COVER_LINKS, TtmPackage.COVER_LINK__TO);
		}
		return incomingCoverLinks;
	}

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public float getSubCoveringRequirementsRatio()
    {
        int nbReq = 0;
        int nbCovered = 0;
        float ratio;
        if (!getIncomingCoverLinks().isEmpty()){
            ratio = 100;
        } else {
            for(Iterator i = getChildren().iterator();i.hasNext();) {
                HierarchicalElement elt = (HierarchicalElement)i.next();
                if (elt instanceof Requirement) {
                    nbReq += 1;
                    if(!((Requirement)elt).getIncomingCoverLinks().isEmpty()){
                        nbCovered += 1;
                    }
                }
            }
            if(nbReq == 0) {
                ratio = 0;
            } else {
                ratio = ((float)(nbCovered* 100)) / (nbReq);
            }
        }
        return ratio;
    }

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setSubCoveringRequirementsRatio(float newSubCoveringRequirementsRatio)
    {
		float oldSubCoveringRequirementsRatio = subCoveringRequirementsRatio;
		subCoveringRequirementsRatio = newSubCoveringRequirementsRatio;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TtmPackage.REQUIREMENT__SUB_COVERING_REQUIREMENTS_RATIO, oldSubCoveringRequirementsRatio, subCoveringRequirementsRatio));
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.REQUIREMENT__INCOMING_COVER_LINKS:
				return ((InternalEList)getIncomingCoverLinks()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
		switch (featureID) {
			case TtmPackage.REQUIREMENT__INCOMING_COVER_LINKS:
				return ((InternalEList)getIncomingCoverLinks()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
		switch (featureID) {
			case TtmPackage.REQUIREMENT__INCOMING_COVER_LINKS:
				return getIncomingCoverLinks();
			case TtmPackage.REQUIREMENT__SUB_COVERING_REQUIREMENTS_RATIO:
				return new Float(getSubCoveringRequirementsRatio());
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue)
    {
		switch (featureID) {
			case TtmPackage.REQUIREMENT__INCOMING_COVER_LINKS:
				getIncomingCoverLinks().clear();
				getIncomingCoverLinks().addAll((Collection)newValue);
				return;
			case TtmPackage.REQUIREMENT__SUB_COVERING_REQUIREMENTS_RATIO:
				setSubCoveringRequirementsRatio(((Float)newValue).floatValue());
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID)
    {
		switch (featureID) {
			case TtmPackage.REQUIREMENT__INCOMING_COVER_LINKS:
				getIncomingCoverLinks().clear();
				return;
			case TtmPackage.REQUIREMENT__SUB_COVERING_REQUIREMENTS_RATIO:
				setSubCoveringRequirementsRatio(SUB_COVERING_REQUIREMENTS_RATIO_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID)
    {
		switch (featureID) {
			case TtmPackage.REQUIREMENT__INCOMING_COVER_LINKS:
				return incomingCoverLinks != null && !incomingCoverLinks.isEmpty();
			case TtmPackage.REQUIREMENT__SUB_COVERING_REQUIREMENTS_RATIO:
				return subCoveringRequirementsRatio != SUB_COVERING_REQUIREMENTS_RATIO_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public String toString()
    {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (Coverage ratio: ");
        result.append(subCoveringRequirementsRatio);
        result.append(')');
        return result.toString();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     */
	public Set<HierarchicalElement> getAllReferencers() {
		Set<HierarchicalElement> referencers = new HashSet<HierarchicalElement>();
		for(Iterator i = getIncomingCoverLinks().iterator();i.hasNext();){
			CoverLink cvLnk = (CoverLink)i.next();
			HierarchicalElement elt = cvLnk.getFrom();
			referencers.add(elt);
			if(elt instanceof Requirement) {
				referencers.addAll(((Requirement)elt).getAllReferencers());
			}
		}
		return referencers;
	}
       
   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    */
   public List<Requirement> getAllParentRequirements() {
      List<Requirement> parentReqs = new ArrayList<Requirement>();
      if (getParent() instanceof Requirement) {
           Requirement parent = (Requirement)getParent();
           parentReqs.add(parent);
           parentReqs.addAll(0,parent.getAllParentRequirements());
       }
           return parentReqs;      
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    */
   public List<Requirement> getAllChildRequirements() {
      List<Requirement> childReqs = new ArrayList<Requirement>();
      for(Iterator i = getChildren().iterator();i.hasNext();){
          HierarchicalElement child = (HierarchicalElement)i.next();
          if (child instanceof Requirement) {
              Requirement childReq = (Requirement)child;
              childReqs.add(childReq);
              childReqs.addAll(childReq.getAllChildRequirements());
          }
      }
      return childReqs;      
   }   
} //RequirementImpl
