/**
 * <copyright>
 * </copyright>
 *
 * $Id: TtmFactoryImpl.java,v 1.2 2007-05-15 10:30:14 llebars Exp $
 */
package ttm.impl;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import ttm.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class TtmFactoryImpl extends EFactoryImpl implements TtmFactory
{
    /**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public static TtmFactory init()
    {
		try {
			TtmFactory theTtmFactory = (TtmFactory)EPackage.Registry.INSTANCE.getEFactory("http://org.topcased.traceability.model"); 
			if (theTtmFactory != null) {
				return theTtmFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new TtmFactoryImpl();
	}

    /**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public TtmFactoryImpl()
    {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EObject create(EClass eClass)
    {
		switch (eClass.getClassifierID()) {
			case TtmPackage.DOCUMENT: return createDocument();
			case TtmPackage.SECTION: return createSection();
			case TtmPackage.TEXT: return createText();
			case TtmPackage.ATTRIBUTE: return createAttribute();
			case TtmPackage.REQUIREMENT: return createRequirement();
			case TtmPackage.COVER_LINK: return createCoverLink();
			case TtmPackage.NAVIGATION_LINK: return createNavigationLink();
			case TtmPackage.PROJECT: return createProject();
			case TtmPackage.RULE_INSTANCE: return createRuleInstance();
			case TtmPackage.ATTRIBUTE_OWNER: return createAttributeOwner();
			case TtmPackage.RULE: return createRule();
			case TtmPackage.COVERAGE_RESULT: return createCoverageResult();
			case TtmPackage.COVER_POINT: return createCoverPoint();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Document createDocument()
    {
		DocumentImpl document = new DocumentImpl();
		return document;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Section createSection()
    {
		SectionImpl section = new SectionImpl();
		return section;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Text createText()
    {
		TextImpl text = new TextImpl();
		return text;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Attribute createAttribute()
    {
		AttributeImpl attribute = new AttributeImpl();
		return attribute;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Requirement createRequirement()
    {
		RequirementImpl requirement = new RequirementImpl();
		return requirement;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public CoverLink createCoverLink()
    {
		CoverLinkImpl coverLink = new CoverLinkImpl();
		return coverLink;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NavigationLink createNavigationLink()
    {
		NavigationLinkImpl navigationLink = new NavigationLinkImpl();
		return navigationLink;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated NOT
	 */
    public Project createProject()
    {
		ProjectImpl project = new ProjectImpl();
		return project;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public RuleInstance createRuleInstance()
    {
		RuleInstanceImpl ruleInstance = new RuleInstanceImpl();
		return ruleInstance;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AttributeOwner createAttributeOwner()
    {
		AttributeOwnerImpl attributeOwner = new AttributeOwnerImpl();
		return attributeOwner;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Rule createRule()
    {
		RuleImpl rule = new RuleImpl();
		return rule;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public CoverageResult createCoverageResult()
    {
		CoverageResultImpl coverageResult = new CoverageResultImpl();
		return coverageResult;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public CoverPoint createCoverPoint()
    {
		CoverPointImpl coverPoint = new CoverPointImpl();
		return coverPoint;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public TtmPackage getTtmPackage()
    {
		return (TtmPackage)getEPackage();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
    public static TtmPackage getPackage()
    {
		return TtmPackage.eINSTANCE;
	}

} //TtmFactoryImpl
