/**
 * <copyright>
 * </copyright>
 *
 * $Id: DocumentItemProvider.java,v 1.7 2007-05-28 08:27:27 llebars Exp $
 */
package ttm.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import ttm.Document;
import ttm.TtmFactory;
import ttm.TtmPackage;

/**
 * This is the item provider adapter for a {@link ttm.Document} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class DocumentItemProvider
	extends HierarchicalElementItemProvider
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
    /**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DocumentItemProvider(AdapterFactory adapterFactory)
    {
		super(adapterFactory);
	}

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated NOT
     */
	public List getPropertyDescriptors(Object object)
    {
        if (itemPropertyDescriptors == null)
        {
            super.getPropertyDescriptors(object);

            addAnalyzerIDPropertyDescriptor(object);
            //addLastModifiedDatePropertyDescriptor(object);
            addFilenamePropertyDescriptor(object);
            addCoversItselfPropertyDescriptor(object);
            //addIncomingCoverPointPropertyDescriptor(object);
            addConversionMethodIDPropertyDescriptor(object);
            addEditionMethodIDPropertyDescriptor(object);
            addAnalyzerArgumentsPropertyDescriptor(object);
            addGlobalCoverageRatioPropertyDescriptor(object);
        }
        return itemPropertyDescriptors;
    }

    /**
     * This adds a property descriptor for the Analyzer ID feature.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated NOT
     */
	protected void addAnalyzerIDPropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Document_analyzerID_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Document_analyzerID_feature", "_UI_Document_type"),
                 TtmPackage.Literals.DOCUMENT__ANALYZER_ID,
                 !TtmEditPlugin.readOnlyFilter(object),
                 false,
                 false,
                 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Last Modified Date feature.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated NOT
     */
	protected void addLastModifiedDatePropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Document_lastModifiedDate_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Document_lastModifiedDate_feature", "_UI_Document_type"),
                 TtmPackage.Literals.DOCUMENT__LAST_MODIFIED_DATE,
                 !TtmEditPlugin.readOnlyFilter(object),
                 false,
                 false,
                 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Filename feature.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated NOT
     */
	protected void addFilenamePropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Document_filename_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Document_filename_feature", "_UI_Document_type"),
                 TtmPackage.Literals.DOCUMENT__FILENAME,
                 !TtmEditPlugin.readOnlyFilter(object),
                 false,
                 false,
                 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Covers Itself feature.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated NOT
     */
	protected void addCoversItselfPropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Document_coversItself_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Document_coversItself_feature", "_UI_Document_type"),
                 TtmPackage.Literals.DOCUMENT__COVERS_ITSELF,
                 !TtmEditPlugin.readOnlyFilter(object),
                 false,
                 false,
                 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Incoming Cover Point feature.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated NOT
     */
	protected void addIncomingCoverPointsPropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Document_incomingCoverPoint_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Document_incomingCoverPoint_feature", "_UI_Document_type"),
                 TtmPackage.Literals.DOCUMENT__INCOMING_COVER_POINTS,
                 !TtmEditPlugin.readOnlyFilter(object),
                 false,
                 true,
                 null,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Conversion Method ID feature.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated NOT
     */
	protected void addConversionMethodIDPropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Document_conversionMethodID_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Document_conversionMethodID_feature", "_UI_Document_type"),
                 TtmPackage.Literals.DOCUMENT__CONVERSION_METHOD_ID,
                 !TtmEditPlugin.readOnlyFilter(object),
                 false,
                 false,
                 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Analyzer Arguments feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    protected void addAnalyzerArgumentsPropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Document_analyzerArguments_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Document_analyzerArguments_feature", "_UI_Document_type"),
                 TtmPackage.Literals.DOCUMENT__ANALYZER_ARGUMENTS,
                 !TtmEditPlugin.readOnlyFilter(object),
                 false,
                 false,
                 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
     * This adds a property descriptor for the Global Coverage Ratio feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    /*
     * Boolean to be editable to false.
     */
    protected void addGlobalCoverageRatioPropertyDescriptor(Object object)
    {
        itemPropertyDescriptors.add
            (createItemPropertyDescriptor
                (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
                 getResourceLocator(),
                 getString("_UI_Document_globalCoverageRatio_feature"),
                 getString("_UI_PropertyDescriptor_description", "_UI_Document_globalCoverageRatio_feature", "_UI_Document_type"),
                 TtmPackage.Literals.DOCUMENT__GLOBAL_COVERAGE_RATIO,
                 false,
                 false,
                 false,
                 ItemPropertyDescriptor.REAL_VALUE_IMAGE,
                 null,
                 null));
    }

    /**
	 * This adds a property descriptor for the Edition Method ID feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addEditionMethodIDPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Document_editionMethodID_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Document_editionMethodID_feature", "_UI_Document_type"),
				 TtmPackage.Literals.DOCUMENT__EDITION_METHOD_ID,
				 !TtmEditPlugin.readOnlyFilter(object),
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

				/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object)
    {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(TtmPackage.Literals.DOCUMENT__COVER_POINTS);
		}
		return childrenFeatures;
	}

    /**
	 * This returns Document.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getImage(Object object)
    {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Document"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * TNI Modification : displaying ident instead of connectorName is more suitable
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public String getText(Object object) {
		String label = ((Document)object).getIdent();
		return label == null || label.length() == 0 ?
			getString("_UI_Document_type") :
			getString("_UI_Document_type") + " " + label;
	}

    /**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification)
    {
		updateChildren(notification);

		switch (notification.getFeatureID(Document.class)) {
			case TtmPackage.DOCUMENT__ANALYZER_ID:
			case TtmPackage.DOCUMENT__LAST_MODIFIED_DATE:
			case TtmPackage.DOCUMENT__FILENAME:
			case TtmPackage.DOCUMENT__COVERS_ITSELF:
			case TtmPackage.DOCUMENT__CONVERSION_METHOD_ID:
			case TtmPackage.DOCUMENT__ANALYZER_ARGUMENTS:
			case TtmPackage.DOCUMENT__GLOBAL_COVERAGE_RATIO:
			case TtmPackage.DOCUMENT__EDITION_METHOD_ID:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case TtmPackage.DOCUMENT__COVER_POINTS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

    /**
	 * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing all of the children that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object)
    {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(TtmPackage.Literals.DOCUMENT__COVER_POINTS,
				 TtmFactory.eINSTANCE.createCoverPoint()));
	}

    /**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator()
    {
		return TtmEditPlugin.INSTANCE;
	}

}
