/**
 * <copyright>
 * </copyright>
 *
 * $Id: HierarchicalElementItemProvider.java,v 1.4 2007-05-15 10:43:45 llebars Exp $
 */
package ttm.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

import ttm.HierarchicalElement;
import ttm.TtmFactory;
import ttm.TtmPackage;

/**
 * This is the item provider adapter for a {@link ttm.HierarchicalElement} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class HierarchicalElementItemProvider
	extends IdentifiedElementItemProvider
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
    /**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HierarchicalElementItemProvider(AdapterFactory adapterFactory)
    {
		super(adapterFactory);
	}

    /**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object)
    {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addIncomingNavigationLinksPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

    /**
	 * This adds a property descriptor for the Incoming Navigation Links feature.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected void addIncomingNavigationLinksPropertyDescriptor(Object object)
    {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_HierarchicalElement_incomingNavigationLinks_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_HierarchicalElement_incomingNavigationLinks_feature", "_UI_HierarchicalElement_type"),
				 TtmPackage.Literals.HIERARCHICAL_ELEMENT__INCOMING_NAVIGATION_LINKS,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

    /**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object)
    {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(TtmPackage.Literals.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS);
			childrenFeatures.add(TtmPackage.Literals.HIERARCHICAL_ELEMENT__COVER_LINKS);
			childrenFeatures.add(TtmPackage.Literals.HIERARCHICAL_ELEMENT__CHILDREN);
		}
		return childrenFeatures;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected EStructuralFeature getChildFeature(Object object, Object child)
    {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

    /**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getText(Object object)
    {
		String label = ((HierarchicalElement)object).getIdent();
		return label == null || label.length() == 0 ?
			getString("_UI_HierarchicalElement_type") :
			getString("_UI_HierarchicalElement_type") + " " + label;
	}

    /**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification)
    {
		updateChildren(notification);

		switch (notification.getFeatureID(HierarchicalElement.class)) {
			case TtmPackage.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS:
			case TtmPackage.HIERARCHICAL_ELEMENT__COVER_LINKS:
			case TtmPackage.HIERARCHICAL_ELEMENT__CHILDREN:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

    /**
	 * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing all of the children that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object)
    {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(TtmPackage.Literals.HIERARCHICAL_ELEMENT__NAVIGATION_LINKS,
				 TtmFactory.eINSTANCE.createNavigationLink()));

		newChildDescriptors.add
			(createChildParameter
				(TtmPackage.Literals.HIERARCHICAL_ELEMENT__COVER_LINKS,
				 TtmFactory.eINSTANCE.createCoverLink()));

		newChildDescriptors.add
			(createChildParameter
				(TtmPackage.Literals.HIERARCHICAL_ELEMENT__CHILDREN,
				 TtmFactory.eINSTANCE.createDocument()));

		newChildDescriptors.add
			(createChildParameter
				(TtmPackage.Literals.HIERARCHICAL_ELEMENT__CHILDREN,
				 TtmFactory.eINSTANCE.createSection()));

		newChildDescriptors.add
			(createChildParameter
				(TtmPackage.Literals.HIERARCHICAL_ELEMENT__CHILDREN,
				 TtmFactory.eINSTANCE.createRequirement()));
	}

    /**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator()
    {
		return TtmEditPlugin.INSTANCE;
	}

}
