/**
 * <copyright>
 * </copyright>
 *
 * $Id: TtmItemProviderAdapterFactory.java,v 1.3 2007-05-15 10:43:45 llebars Exp $
 */
package ttm.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import ttm.util.TtmAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class TtmItemProviderAdapterFactory extends TtmAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable 
{
    /**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

    /**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection supportedTypes = new ArrayList();

    /**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TtmItemProviderAdapterFactory()
    {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);		
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.Document} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentItemProvider documentItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.Document}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDocumentAdapter()
    {
		if (documentItemProvider == null) {
			documentItemProvider = new DocumentItemProvider(this);
		}

		return documentItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.Section} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SectionItemProvider sectionItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.Section}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createSectionAdapter()
    {
		if (sectionItemProvider == null) {
			sectionItemProvider = new SectionItemProvider(this);
		}

		return sectionItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.Text} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TextItemProvider textItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.Text}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createTextAdapter()
    {
		if (textItemProvider == null) {
			textItemProvider = new TextItemProvider(this);
		}

		return textItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.Attribute} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AttributeItemProvider attributeItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.Attribute}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAttributeAdapter()
    {
		if (attributeItemProvider == null) {
			attributeItemProvider = new AttributeItemProvider(this);
		}

		return attributeItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.Requirement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RequirementItemProvider requirementItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.Requirement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRequirementAdapter()
    {
		if (requirementItemProvider == null) {
			requirementItemProvider = new RequirementItemProvider(this);
		}

		return requirementItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.CoverLink} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoverLinkItemProvider coverLinkItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.CoverLink}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCoverLinkAdapter()
    {
		if (coverLinkItemProvider == null) {
			coverLinkItemProvider = new CoverLinkItemProvider(this);
		}

		return coverLinkItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.NavigationLink} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NavigationLinkItemProvider navigationLinkItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.NavigationLink}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createNavigationLinkAdapter()
    {
		if (navigationLinkItemProvider == null) {
			navigationLinkItemProvider = new NavigationLinkItemProvider(this);
		}

		return navigationLinkItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.Project} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProjectItemProvider projectItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.Project}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createProjectAdapter()
    {
		if (projectItemProvider == null) {
			projectItemProvider = new ProjectItemProvider(this);
		}

		return projectItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.RuleInstance} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RuleInstanceItemProvider ruleInstanceItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.RuleInstance}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRuleInstanceAdapter()
    {
		if (ruleInstanceItemProvider == null) {
			ruleInstanceItemProvider = new RuleInstanceItemProvider(this);
		}

		return ruleInstanceItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.AttributeOwner} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AttributeOwnerItemProvider attributeOwnerItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.AttributeOwner}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createAttributeOwnerAdapter()
    {
		if (attributeOwnerItemProvider == null) {
			attributeOwnerItemProvider = new AttributeOwnerItemProvider(this);
		}

		return attributeOwnerItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.Rule} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RuleItemProvider ruleItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.Rule}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRuleAdapter()
    {
		if (ruleItemProvider == null) {
			ruleItemProvider = new RuleItemProvider(this);
		}

		return ruleItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.CoverageResult} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoverageResultItemProvider coverageResultItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.CoverageResult}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCoverageResultAdapter()
    {
		if (coverageResultItemProvider == null) {
			coverageResultItemProvider = new CoverageResultItemProvider(this);
		}

		return coverageResultItemProvider;
	}

    /**
	 * This keeps track of the one adapter used for all {@link ttm.CoverPoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoverPointItemProvider coverPointItemProvider;

    /**
	 * This creates an adapter for a {@link ttm.CoverPoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createCoverPointAdapter()
    {
		if (coverPointItemProvider == null) {
			coverPointItemProvider = new CoverPointItemProvider(this);
		}

		return coverPointItemProvider;
	}

    /**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory()
    {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

    /**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
    {
		this.parentAdapterFactory = parentAdapterFactory;
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isFactoryForType(Object type)
    {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

    /**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type)
    {
		return super.adapt(notifier, this);
	}

    /**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object adapt(Object object, Object type)
    {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

    /**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener)
    {
		changeNotifier.addListener(notifyChangedListener);
	}

    /**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener)
    {
		changeNotifier.removeListener(notifyChangedListener);
	}

    /**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification)
    {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

    /**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose()
    {
		if (documentItemProvider != null) documentItemProvider.dispose();
		if (sectionItemProvider != null) sectionItemProvider.dispose();
		if (textItemProvider != null) textItemProvider.dispose();
		if (attributeItemProvider != null) attributeItemProvider.dispose();
		if (requirementItemProvider != null) requirementItemProvider.dispose();
		if (coverLinkItemProvider != null) coverLinkItemProvider.dispose();
		if (navigationLinkItemProvider != null) navigationLinkItemProvider.dispose();
		if (projectItemProvider != null) projectItemProvider.dispose();
		if (ruleInstanceItemProvider != null) ruleInstanceItemProvider.dispose();
		if (attributeOwnerItemProvider != null) attributeOwnerItemProvider.dispose();
		if (ruleItemProvider != null) ruleItemProvider.dispose();
		if (coverageResultItemProvider != null) coverageResultItemProvider.dispose();
		if (coverPointItemProvider != null) coverPointItemProvider.dispose();
	}

}
