/**
 * <copyright>
 * </copyright>
 *
 * $Id: TtmAdapterFactory.java,v 1.2 2007-05-15 10:30:16 llebars Exp $
 */
package ttm.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import ttm.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see ttm.TtmPackage
 * @generated
 */
public class TtmAdapterFactory extends AdapterFactoryImpl 
{
    /**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static TtmPackage modelPackage;

    /**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TtmAdapterFactory()
    {
		if (modelPackage == null) {
			modelPackage = TtmPackage.eINSTANCE;
		}
	}

    /**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object)
    {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

    /**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TtmSwitch modelSwitch =
        new TtmSwitch() {
			public Object caseDocument(Document object) {
				return createDocumentAdapter();
			}
			public Object caseSection(Section object) {
				return createSectionAdapter();
			}
			public Object caseHierarchicalElement(HierarchicalElement object) {
				return createHierarchicalElementAdapter();
			}
			public Object caseIdentifiedElement(IdentifiedElement object) {
				return createIdentifiedElementAdapter();
			}
			public Object caseText(Text object) {
				return createTextAdapter();
			}
			public Object caseAttribute(Attribute object) {
				return createAttributeAdapter();
			}
			public Object caseRequirement(Requirement object) {
				return createRequirementAdapter();
			}
			public Object caseCoverLink(CoverLink object) {
				return createCoverLinkAdapter();
			}
			public Object caseNavigationLink(NavigationLink object) {
				return createNavigationLinkAdapter();
			}
			public Object caseAbstractLink(AbstractLink object) {
				return createAbstractLinkAdapter();
			}
			public Object caseProject(Project object) {
				return createProjectAdapter();
			}
			public Object caseElement(Element object) {
				return createElementAdapter();
			}
			public Object caseRuleInstance(RuleInstance object) {
				return createRuleInstanceAdapter();
			}
			public Object caseAttributeOwner(AttributeOwner object) {
				return createAttributeOwnerAdapter();
			}
			public Object caseRule(Rule object) {
				return createRuleAdapter();
			}
			public Object caseCoverageResult(CoverageResult object) {
				return createCoverageResultAdapter();
			}
			public Object caseCoverPoint(CoverPoint object) {
				return createCoverPointAdapter();
			}
			public Object defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

    /**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target)
    {
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


    /**
	 * Creates a new adapter for an object of class '{@link ttm.HierarchicalElement <em>Hierarchical Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.HierarchicalElement
	 * @generated
	 */
	public Adapter createHierarchicalElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.Document <em>Document</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.Document
	 * @generated
	 */
	public Adapter createDocumentAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.Section <em>Section</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.Section
	 * @generated
	 */
	public Adapter createSectionAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.IdentifiedElement <em>Identified Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.IdentifiedElement
	 * @generated
	 */
	public Adapter createIdentifiedElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.Text <em>Text</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.Text
	 * @generated
	 */
	public Adapter createTextAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.Attribute <em>Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.Attribute
	 * @generated
	 */
	public Adapter createAttributeAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.Requirement <em>Requirement</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.Requirement
	 * @generated
	 */
	public Adapter createRequirementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.CoverLink <em>Cover Link</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.CoverLink
	 * @generated
	 */
	public Adapter createCoverLinkAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.NavigationLink <em>Navigation Link</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.NavigationLink
	 * @generated
	 */
	public Adapter createNavigationLinkAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.AbstractLink <em>Abstract Link</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.AbstractLink
	 * @generated
	 */
	public Adapter createAbstractLinkAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.Project <em>Project</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.Project
	 * @generated
	 */
	public Adapter createProjectAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.Element <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.Element
	 * @generated
	 */
	public Adapter createElementAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.RuleInstance <em>Rule Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.RuleInstance
	 * @generated
	 */
	public Adapter createRuleInstanceAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.AttributeOwner <em>Attribute Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.AttributeOwner
	 * @generated
	 */
	public Adapter createAttributeOwnerAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.Rule <em>Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.Rule
	 * @generated
	 */
	public Adapter createRuleAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.CoverageResult <em>Coverage Result</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.CoverageResult
	 * @generated
	 */
	public Adapter createCoverageResultAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for an object of class '{@link ttm.CoverPoint <em>Cover Point</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ttm.CoverPoint
	 * @generated
	 */
	public Adapter createCoverPointAdapter()
    {
		return null;
	}

    /**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter()
    {
		return null;
	}

} //TtmAdapterFactory
