/**
 * <copyright>
 * </copyright>
 *
 * $Id: TtmSwitch.java,v 1.2 2007-05-15 10:30:16 llebars Exp $
 */
package ttm.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import ttm.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see ttm.TtmPackage
 * @generated
 */
public class TtmSwitch 
{
    /**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static TtmPackage modelPackage;

    /**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TtmSwitch()
    {
		if (modelPackage == null) {
			modelPackage = TtmPackage.eINSTANCE;
		}
	}

    /**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject)
    {
		return doSwitch(theEObject.eClass(), theEObject);
	}

    /**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject)
    {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch((EClass)eSuperTypes.get(0), theEObject);
		}
	}

    /**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject)
    {
		switch (classifierID) {
			case TtmPackage.DOCUMENT: {
				Document document = (Document)theEObject;
				Object result = caseDocument(document);
				if (result == null) result = caseHierarchicalElement(document);
				if (result == null) result = caseIdentifiedElement(document);
				if (result == null) result = caseAttributeOwner(document);
				if (result == null) result = caseElement(document);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.SECTION: {
				Section section = (Section)theEObject;
				Object result = caseSection(section);
				if (result == null) result = caseHierarchicalElement(section);
				if (result == null) result = caseIdentifiedElement(section);
				if (result == null) result = caseAttributeOwner(section);
				if (result == null) result = caseElement(section);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.HIERARCHICAL_ELEMENT: {
				HierarchicalElement hierarchicalElement = (HierarchicalElement)theEObject;
				Object result = caseHierarchicalElement(hierarchicalElement);
				if (result == null) result = caseIdentifiedElement(hierarchicalElement);
				if (result == null) result = caseAttributeOwner(hierarchicalElement);
				if (result == null) result = caseElement(hierarchicalElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.IDENTIFIED_ELEMENT: {
				IdentifiedElement identifiedElement = (IdentifiedElement)theEObject;
				Object result = caseIdentifiedElement(identifiedElement);
				if (result == null) result = caseAttributeOwner(identifiedElement);
				if (result == null) result = caseElement(identifiedElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.TEXT: {
				Text text = (Text)theEObject;
				Object result = caseText(text);
				if (result == null) result = caseElement(text);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.ATTRIBUTE: {
				Attribute attribute = (Attribute)theEObject;
				Object result = caseAttribute(attribute);
				if (result == null) result = caseElement(attribute);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.REQUIREMENT: {
				Requirement requirement = (Requirement)theEObject;
				Object result = caseRequirement(requirement);
				if (result == null) result = caseHierarchicalElement(requirement);
				if (result == null) result = caseIdentifiedElement(requirement);
				if (result == null) result = caseAttributeOwner(requirement);
				if (result == null) result = caseElement(requirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.COVER_LINK: {
				CoverLink coverLink = (CoverLink)theEObject;
				Object result = caseCoverLink(coverLink);
				if (result == null) result = caseAbstractLink(coverLink);
				if (result == null) result = caseAttributeOwner(coverLink);
				if (result == null) result = caseElement(coverLink);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.NAVIGATION_LINK: {
				NavigationLink navigationLink = (NavigationLink)theEObject;
				Object result = caseNavigationLink(navigationLink);
				if (result == null) result = caseAbstractLink(navigationLink);
				if (result == null) result = caseAttributeOwner(navigationLink);
				if (result == null) result = caseElement(navigationLink);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.ABSTRACT_LINK: {
				AbstractLink abstractLink = (AbstractLink)theEObject;
				Object result = caseAbstractLink(abstractLink);
				if (result == null) result = caseAttributeOwner(abstractLink);
				if (result == null) result = caseElement(abstractLink);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.PROJECT: {
				Project project = (Project)theEObject;
				Object result = caseProject(project);
				if (result == null) result = caseIdentifiedElement(project);
				if (result == null) result = caseAttributeOwner(project);
				if (result == null) result = caseElement(project);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.ELEMENT: {
				Element element = (Element)theEObject;
				Object result = caseElement(element);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.RULE_INSTANCE: {
				RuleInstance ruleInstance = (RuleInstance)theEObject;
				Object result = caseRuleInstance(ruleInstance);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.ATTRIBUTE_OWNER: {
				AttributeOwner attributeOwner = (AttributeOwner)theEObject;
				Object result = caseAttributeOwner(attributeOwner);
				if (result == null) result = caseElement(attributeOwner);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.RULE: {
				Rule rule = (Rule)theEObject;
				Object result = caseRule(rule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.COVERAGE_RESULT: {
				CoverageResult coverageResult = (CoverageResult)theEObject;
				Object result = caseCoverageResult(coverageResult);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case TtmPackage.COVER_POINT: {
				CoverPoint coverPoint = (CoverPoint)theEObject;
				Object result = caseCoverPoint(coverPoint);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Hierarchical Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Hierarchical Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHierarchicalElement(HierarchicalElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Document</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Document</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDocument(Document object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Section</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Section</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSection(Section object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Identified Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Identified Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseIdentifiedElement(IdentifiedElement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Text</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Text</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseText(Text object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Attribute</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Attribute</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAttribute(Attribute object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRequirement(Requirement object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Cover Link</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Cover Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCoverLink(CoverLink object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Navigation Link</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Navigation Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseNavigationLink(NavigationLink object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Abstract Link</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Abstract Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAbstractLink(AbstractLink object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Project</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Project</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseProject(Project object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseElement(Element object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Rule Instance</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Rule Instance</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRuleInstance(RuleInstance object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Attribute Owner</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Attribute Owner</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAttributeOwner(AttributeOwner object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRule(Rule object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Coverage Result</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Coverage Result</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCoverageResult(CoverageResult object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>Cover Point</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Cover Point</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCoverPoint(CoverPoint object)
    {
		return null;
	}

    /**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object)
    {
		return null;
	}

} //TtmSwitch
