/*******************************************************************************
 * Copyright (c) 2005 AIRBUS FRANCE. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Eclipse
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: David Sciamma (Anyware Technologies), Mathieu Garcia (Anyware
 * Technologies), Jacques Lescot (Anyware Technologies), Thomas Friol (Anyware
 * Technologies), Nicolas Lalev�e (Anyware Technologies), Jose Alfredo Serrano
 * (Anyware Technologies) - initial API and implementation
 ******************************************************************************/

package org.topcased.modeler.uml.providers;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.uml2.uml.util.UMLAdapterFactory;
import org.topcased.modeler.providers.IDeleteObjectProvider;
import org.topcased.modeler.providers.ILabelFeatureProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers. The adapters generated by this
 * factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The adapters
 * also support Eclipse property sheets. Note that most of the adapters are shared among multiple instances. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class UMLModelerProviderAdapterFactory extends UMLAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
    /**
     * This keeps track of the root adapter factory that delegates to this adapter factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    private IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private Collection supportedTypes = new ArrayList();

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Element} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ElementModelerProvider elementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.MultiplicityElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private MultiplicityElementModelerProvider multiplicityelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.NamedElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private NamedElementModelerProvider namedelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Namespace} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private NamespaceModelerProvider namespaceModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.OpaqueExpression} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private OpaqueExpressionModelerProvider opaqueexpressionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ValueSpecification} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ValueSpecificationModelerProvider valuespecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Expression} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExpressionModelerProvider expressionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Comment} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CommentModelerProvider commentModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DirectedRelationship} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DirectedRelationshipModelerProvider directedrelationshipModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Relationship} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RelationshipModelerProvider relationshipModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Class} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ClassModelerProvider classModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Type} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TypeModelerProvider typeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Property} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PropertyModelerProvider propertyModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Operation} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private OperationModelerProvider operationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TypedElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TypedElementModelerProvider typedelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Parameter} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ParameterModelerProvider parameterModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Package} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PackageModelerProvider packageModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Enumeration} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EnumerationModelerProvider enumerationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DataType} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DataTypeModelerProvider datatypeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.EnumerationLiteral} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EnumerationLiteralModelerProvider enumerationliteralModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.PrimitiveType} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PrimitiveTypeModelerProvider primitivetypeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Classifier} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ClassifierModelerProvider classifierModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Feature} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private FeatureModelerProvider featureModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Constraint} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConstraintModelerProvider constraintModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LiteralBoolean} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LiteralBooleanModelerProvider literalbooleanModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LiteralSpecification} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LiteralSpecificationModelerProvider literalspecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LiteralString} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LiteralStringModelerProvider literalstringModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LiteralNull} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LiteralNullModelerProvider literalnullModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LiteralInteger} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LiteralIntegerModelerProvider literalintegerModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LiteralUnlimitedNatural} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LiteralUnlimitedNaturalModelerProvider literalunlimitednaturalModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.OpaqueBehavior} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private OpaqueBehaviorModelerProvider opaquebehaviorModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.FunctionBehavior} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private FunctionBehaviorModelerProvider functionbehaviorModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.OpaqueAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private OpaqueActionModelerProvider opaqueactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.BehavioralFeature} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private BehavioralFeatureModelerProvider behavioralfeatureModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.StructuralFeature} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StructuralFeatureModelerProvider structuralfeatureModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InstanceSpecification} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InstanceSpecificationModelerProvider instancespecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Slot} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SlotModelerProvider slotModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InstanceValue} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InstanceValueModelerProvider instancevalueModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.RedefinableElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RedefinableElementModelerProvider redefinableelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Generalization} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private GeneralizationModelerProvider generalizationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.PackageableElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PackageableElementModelerProvider packageableelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ElementImport} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ElementImportModelerProvider elementimportModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.PackageImport} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PackageImportModelerProvider packageimportModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Association} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private AssociationModelerProvider associationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.PackageMerge} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PackageMergeModelerProvider packagemergeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Stereotype} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StereotypeModelerProvider stereotypeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Image} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ImageModelerProvider imageModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Profile} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ProfileModelerProvider profileModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ProfileApplication} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ProfileApplicationModelerProvider profileapplicationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Extension} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExtensionModelerProvider extensionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExtensionEnd} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExtensionEndModelerProvider extensionendModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Behavior} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private BehaviorModelerProvider behaviorModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.BehavioredClassifier} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private BehavioredClassifierModelerProvider behavioredclassifierModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InterfaceRealization} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InterfaceRealizationModelerProvider interfacerealizationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Activity} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActivityModelerProvider activityModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Dependency} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DependencyModelerProvider dependencyModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Usage} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private UsageModelerProvider usageModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Abstraction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private AbstractionModelerProvider abstractionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Realization} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RealizationModelerProvider realizationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Substitution} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SubstitutionModelerProvider substitutionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.GeneralizationSet} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private GeneralizationSetModelerProvider generalizationsetModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.AssociationClass} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private AssociationClassModelerProvider associationclassModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InformationItem} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InformationItemModelerProvider informationitemModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InformationFlow} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InformationFlowModelerProvider informationflowModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Model} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ModelModelerProvider modelModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ConnectorEnd} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConnectorEndModelerProvider connectorendModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ConnectableElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConnectableElementModelerProvider connectableelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Connector} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConnectorModelerProvider connectorModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.StructuredClassifier} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StructuredClassifierModelerProvider structuredclassifierModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ActivityEdge} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActivityEdgeModelerProvider activityedgeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ActivityGroup} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActivityGroupModelerProvider activitygroupModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ActivityNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActivityNodeModelerProvider activitynodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Action} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActionModelerProvider actionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ObjectNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ObjectNodeModelerProvider objectnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ControlNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ControlNodeModelerProvider controlnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ControlFlow} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ControlFlowModelerProvider controlflowModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ObjectFlow} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ObjectFlowModelerProvider objectflowModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InitialNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InitialNodeModelerProvider initialnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.FinalNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private FinalNodeModelerProvider finalnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ActivityFinalNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActivityFinalNodeModelerProvider activityfinalnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ComponentRealization} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ComponentRealizationModelerProvider componentrealizationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DecisionNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DecisionNodeModelerProvider decisionnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.MergeNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private MergeNodeModelerProvider mergenodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExecutableNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExecutableNodeModelerProvider executablenodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.OutputPin} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private OutputPinModelerProvider outputpinModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InputPin} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InputPinModelerProvider inputpinModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Pin} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PinModelerProvider pinModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ActivityParameterNode} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActivityParameterNodeModelerProvider activityparameternodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ValuePin} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ValuePinModelerProvider valuepinModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Interface} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InterfaceModelerProvider interfaceModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Artifact} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ArtifactModelerProvider artifactModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Manifestation} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ManifestationModelerProvider manifestationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Actor} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActorModelerProvider actorModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CallEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CallEventModelerProvider calleventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ChangeEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ChangeEventModelerProvider changeeventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.SignalEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SignalEventModelerProvider signaleventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.AnyReceiveEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private AnyReceiveEventModelerProvider anyreceiveeventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Extend} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExtendModelerProvider extendModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.UseCase} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private UseCaseModelerProvider usecaseModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExtensionPoint} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExtensionPointModelerProvider extensionpointModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Include} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private IncludeModelerProvider includeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Collaboration} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CollaborationModelerProvider collaborationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Port} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PortModelerProvider portModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.EncapsulatedClassifier} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EncapsulatedClassifierModelerProvider encapsulatedclassifierModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Trigger} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TriggerModelerProvider triggerModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Event} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EventModelerProvider eventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Reception} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReceptionModelerProvider receptionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Signal} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SignalModelerProvider signalModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Variable} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private VariableModelerProvider variableModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.StructuredActivityNode} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StructuredActivityNodeModelerProvider structuredactivitynodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ConditionalNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConditionalNodeModelerProvider conditionalnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Clause} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ClauseModelerProvider clauseModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LoopNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LoopNodeModelerProvider loopnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Interaction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InteractionModelerProvider interactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InteractionFragment} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InteractionFragmentModelerProvider interactionfragmentModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Lifeline} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LifelineModelerProvider lifelineModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Message} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private MessageModelerProvider messageModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.GeneralOrdering} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private GeneralOrderingModelerProvider generalorderingModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.OccurrenceSpecification} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private OccurrenceSpecificationModelerProvider occurrencespecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.MessageEnd} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private MessageEndModelerProvider messageendModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.StateInvariant} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StateInvariantModelerProvider stateinvariantModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ActionExecutionSpecification}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActionExecutionSpecificationModelerProvider actionexecutionspecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.BehaviorExecutionSpecification}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private BehaviorExecutionSpecificationModelerProvider behaviorexecutionspecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExecutionEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExecutionEventModelerProvider executioneventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CreationEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CreationEventModelerProvider creationeventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DestructionEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DestructionEventModelerProvider destructioneventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.SendOperationEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SendOperationEventModelerProvider sendoperationeventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.MessageEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private MessageEventModelerProvider messageeventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.SendSignalEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SendSignalEventModelerProvider sendsignaleventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.MessageOccurrenceSpecification}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private MessageOccurrenceSpecificationModelerProvider messageoccurrencespecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExecutionOccurrenceSpecification}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExecutionOccurrenceSpecificationModelerProvider executionoccurrencespecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReceiveOperationEvent} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReceiveOperationEventModelerProvider receiveoperationeventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReceiveSignalEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReceiveSignalEventModelerProvider receivesignaleventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TemplateSignature} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TemplateSignatureModelerProvider templatesignatureModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TemplateParameter} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TemplateParameterModelerProvider templateparameterModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TemplateableElement} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TemplateableElementModelerProvider templateableelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.StringExpression} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StringExpressionModelerProvider stringexpressionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ParameterableElement} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ParameterableElementModelerProvider parameterableelementModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TemplateBinding} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TemplateBindingModelerProvider templatebindingModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TemplateParameterSubstitution}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TemplateParameterSubstitutionModelerProvider templateparametersubstitutionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.OperationTemplateParameter}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private OperationTemplateParameterModelerProvider operationtemplateparameterModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ClassifierTemplateParameter}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ClassifierTemplateParameterModelerProvider classifiertemplateparameterModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.RedefinableTemplateSignature}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RedefinableTemplateSignatureModelerProvider redefinabletemplatesignatureModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ConnectableElementTemplateParameter}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConnectableElementTemplateParameterModelerProvider connectableelementtemplateparameterModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CollaborationUse} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CollaborationUseModelerProvider collaborationuseModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ForkNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ForkNodeModelerProvider forknodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.JoinNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private JoinNodeModelerProvider joinnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.FlowFinalNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private FlowFinalNodeModelerProvider flowfinalnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CentralBufferNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CentralBufferNodeModelerProvider centralbuffernodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ActivityPartition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActivityPartitionModelerProvider activitypartitionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExpansionNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExpansionNodeModelerProvider expansionnodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExpansionRegion} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExpansionRegionModelerProvider expansionregionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExceptionHandler} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExceptionHandlerModelerProvider exceptionhandlerModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Gate} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private GateModelerProvider gateModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.PartDecomposition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PartDecompositionModelerProvider partdecompositionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InteractionUse} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InteractionUseModelerProvider interactionuseModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InteractionOperand} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InteractionOperandModelerProvider interactionoperandModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InteractionConstraint} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InteractionConstraintModelerProvider interactionconstraintModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExecutionSpecification} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExecutionSpecificationModelerProvider executionspecificationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CombinedFragment} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CombinedFragmentModelerProvider combinedfragmentModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Continuation} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ContinuationModelerProvider continuationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ConsiderIgnoreFragment} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConsiderIgnoreFragmentModelerProvider considerignorefragmentModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.StateMachine} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StateMachineModelerProvider statemachineModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Region} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RegionModelerProvider regionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Pseudostate} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private PseudostateModelerProvider pseudostateModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.State} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StateModelerProvider stateModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Vertex} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private VertexModelerProvider vertexModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ConnectionPointReference} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ConnectionPointReferenceModelerProvider connectionpointreferenceModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Transition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TransitionModelerProvider transitionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.FinalState} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private FinalStateModelerProvider finalstateModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TimeEvent} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TimeEventModelerProvider timeeventModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CreateObjectAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CreateObjectActionModelerProvider createobjectactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DestroyObjectAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DestroyObjectActionModelerProvider destroyobjectactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TestIdentityAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TestIdentityActionModelerProvider testidentityactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReadSelfAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReadSelfActionModelerProvider readselfactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.StructuralFeatureAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StructuralFeatureActionModelerProvider structuralfeatureactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReadStructuralFeatureAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReadStructuralFeatureActionModelerProvider readstructuralfeatureactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.WriteStructuralFeatureAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private WriteStructuralFeatureActionModelerProvider writestructuralfeatureactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ClearStructuralFeatureAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ClearStructuralFeatureActionModelerProvider clearstructuralfeatureactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RemoveStructuralFeatureValueActionModelerProvider removestructuralfeaturevalueactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.AddStructuralFeatureValueAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private AddStructuralFeatureValueActionModelerProvider addstructuralfeaturevalueactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LinkAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LinkActionModelerProvider linkactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LinkEndData} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LinkEndDataModelerProvider linkenddataModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReadLinkAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReadLinkActionModelerProvider readlinkactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LinkEndCreationData} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LinkEndCreationDataModelerProvider linkendcreationdataModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CreateLinkAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CreateLinkActionModelerProvider createlinkactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.WriteLinkAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private WriteLinkActionModelerProvider writelinkactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DestroyLinkAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DestroyLinkActionModelerProvider destroylinkactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.LinkEndDestructionData} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private LinkEndDestructionDataModelerProvider linkenddestructiondataModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ClearAssociationAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ClearAssociationActionModelerProvider clearassociationactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.VariableAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private VariableActionModelerProvider variableactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReadVariableAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReadVariableActionModelerProvider readvariableactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.WriteVariableAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private WriteVariableActionModelerProvider writevariableactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ClearVariableAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ClearVariableActionModelerProvider clearvariableactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.AddVariableValueAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private AddVariableValueActionModelerProvider addvariablevalueactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.RemoveVariableValueAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RemoveVariableValueActionModelerProvider removevariablevalueactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CallAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CallActionModelerProvider callactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InvocationAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InvocationActionModelerProvider invocationactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.SendSignalAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SendSignalActionModelerProvider sendsignalactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.BroadcastSignalAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private BroadcastSignalActionModelerProvider broadcastsignalactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.SendObjectAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SendObjectActionModelerProvider sendobjectactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ValueSpecificationAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ValueSpecificationActionModelerProvider valuespecificationactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CallOperationAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CallOperationActionModelerProvider calloperationactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CallBehaviorAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CallBehaviorActionModelerProvider callbehavioractionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.SequenceNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private SequenceNodeModelerProvider sequencenodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TimeExpression} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TimeExpressionModelerProvider timeexpressionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Observation} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ObservationModelerProvider observationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Duration} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DurationModelerProvider durationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DurationInterval} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DurationIntervalModelerProvider durationintervalModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Interval} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private IntervalModelerProvider intervalModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TimeConstraint} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TimeConstraintModelerProvider timeconstraintModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.IntervalConstraint} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private IntervalConstraintModelerProvider intervalconstraintModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TimeInterval} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TimeIntervalModelerProvider timeintervalModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DurationConstraint} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DurationConstraintModelerProvider durationconstraintModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.TimeObservation} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private TimeObservationModelerProvider timeobservationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DurationObservation} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DurationObservationModelerProvider durationobservationModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DataStoreNode} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DataStoreNodeModelerProvider datastorenodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.InterruptibleActivityRegion}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private InterruptibleActivityRegionModelerProvider interruptibleactivityregionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ParameterSet} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ParameterSetModelerProvider parametersetModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Component} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ComponentModelerProvider componentModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Deployment} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DeploymentModelerProvider deploymentModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DeployedArtifact} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DeployedArtifactModelerProvider deployedartifactModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DeploymentTarget} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DeploymentTargetModelerProvider deploymenttargetModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Node} instances. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private NodeModelerProvider nodeModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.Device} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DeviceModelerProvider deviceModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ExecutionEnvironment} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ExecutionEnvironmentModelerProvider executionenvironmentModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CommunicationPath} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CommunicationPathModelerProvider communicationpathModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ProtocolConformance} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ProtocolConformanceModelerProvider protocolconformanceModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ProtocolStateMachine} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ProtocolStateMachineModelerProvider protocolstatemachineModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ProtocolTransition} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ProtocolTransitionModelerProvider protocoltransitionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReadExtentAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReadExtentActionModelerProvider readextentactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReclassifyObjectAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReclassifyObjectActionModelerProvider reclassifyobjectactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReadIsClassifiedObjectAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReadIsClassifiedObjectActionModelerProvider readisclassifiedobjectactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.StartClassifierBehaviorAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private StartClassifierBehaviorActionModelerProvider startclassifierbehavioractionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.QualifierValue} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private QualifierValueModelerProvider qualifiervalueModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReadLinkObjectEndAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReadLinkObjectEndActionModelerProvider readlinkobjectendactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction}
     * instances. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReadLinkObjectEndQualifierActionModelerProvider readlinkobjectendqualifieractionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.CreateLinkObjectAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private CreateLinkObjectActionModelerProvider createlinkobjectactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.AcceptEventAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private AcceptEventActionModelerProvider accepteventactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.AcceptCallAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private AcceptCallActionModelerProvider acceptcallactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReplyAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReplyActionModelerProvider replyactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.UnmarshallAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private UnmarshallActionModelerProvider unmarshallactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ReduceAction} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ReduceActionModelerProvider reduceactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.RaiseExceptionAction} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private RaiseExceptionActionModelerProvider raiseexceptionactionModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.ActionInputPin} instances. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private ActionInputPinModelerProvider actioninputpinModelerProvider;

    /**
     * This keeps track of the one adapter used for all {@link org.eclipse.uml2.uml.DeploymentSpecification} instances.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private DeploymentSpecificationModelerProvider deploymentspecificationModelerProvider;

    /**
     * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public UMLModelerProviderAdapterFactory()
    {
        supportedTypes.add(ILabelFeatureProvider.class);
        supportedTypes.add(IDeleteObjectProvider.class);
    }

    /**
     * This returns the root adapter factory that contains this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the root AdapterFactory
     * 
     * @generated
     */
    public ComposeableAdapterFactory getRootAdapterFactory()
    {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param parentAdapterFactory the new parent adapter factory
     * 
     * @generated
     */
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
    {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param type the type to test
     * @return true if supported
     * 
     * @generated
     */
    public boolean isFactoryForType(Object type)
    {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the adapter. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @param notifier the notifier
     * @param type the object to adapt
     * @return the Adapter the created adatper
     * 
     * @generated
     */
    public Adapter adapt(Notifier notifier, Object type)
    {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param object the object to adapt
     * @param type the type to adapt
     * @return the adapted Object
     * 
     * @generated
     */
    public Object adapt(Object object, Object type)
    {
        if (isFactoryForType(type))
        {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class) || (((Class) type).isInstance(adapter)))
            {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param notifyChangedListener the listener to add
     * 
     * @generated
     */
    public void addListener(INotifyChangedListener notifyChangedListener)
    {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param notifyChangedListener the listener to remove
     * 
     * @generated
     */
    public void removeListener(INotifyChangedListener notifyChangedListener)
    {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @param notification the notification to fire
     * 
     * @generated
     */
    public void fireNotifyChanged(Notification notification)
    {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null)
        {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Element}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createElementAdapter()
    {
        if (elementModelerProvider == null)
        {
            elementModelerProvider = new ElementModelerProvider(this);
        }

        return elementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.MultiplicityElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createMultiplicityElementAdapter()
    {
        if (multiplicityelementModelerProvider == null)
        {
            multiplicityelementModelerProvider = new MultiplicityElementModelerProvider(this);
        }

        return multiplicityelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.NamedElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createNamedElementAdapter()
    {
        if (namedelementModelerProvider == null)
        {
            namedelementModelerProvider = new NamedElementModelerProvider(this);
        }

        return namedelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Namespace}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createNamespaceAdapter()
    {
        if (namespaceModelerProvider == null)
        {
            namespaceModelerProvider = new NamespaceModelerProvider(this);
        }

        return namespaceModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.OpaqueExpression}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createOpaqueExpressionAdapter()
    {
        if (opaqueexpressionModelerProvider == null)
        {
            opaqueexpressionModelerProvider = new OpaqueExpressionModelerProvider(this);
        }

        return opaqueexpressionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ValueSpecification}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createValueSpecificationAdapter()
    {
        if (valuespecificationModelerProvider == null)
        {
            valuespecificationModelerProvider = new ValueSpecificationModelerProvider(this);
        }

        return valuespecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Expression}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExpressionAdapter()
    {
        if (expressionModelerProvider == null)
        {
            expressionModelerProvider = new ExpressionModelerProvider(this);
        }

        return expressionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Comment}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCommentAdapter()
    {
        if (commentModelerProvider == null)
        {
            commentModelerProvider = new CommentModelerProvider(this);
        }

        return commentModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DirectedRelationship}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDirectedRelationshipAdapter()
    {
        if (directedrelationshipModelerProvider == null)
        {
            directedrelationshipModelerProvider = new DirectedRelationshipModelerProvider(this);
        }

        return directedrelationshipModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Relationship}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRelationshipAdapter()
    {
        if (relationshipModelerProvider == null)
        {
            relationshipModelerProvider = new RelationshipModelerProvider(this);
        }

        return relationshipModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Class}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createClassAdapter()
    {
        if (classModelerProvider == null)
        {
            classModelerProvider = new ClassModelerProvider(this);
        }

        return classModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Type}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTypeAdapter()
    {
        if (typeModelerProvider == null)
        {
            typeModelerProvider = new TypeModelerProvider(this);
        }

        return typeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Property}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPropertyAdapter()
    {
        if (propertyModelerProvider == null)
        {
            propertyModelerProvider = new PropertyModelerProvider(this);
        }

        return propertyModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Operation}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createOperationAdapter()
    {
        if (operationModelerProvider == null)
        {
            operationModelerProvider = new OperationModelerProvider(this);
        }

        return operationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TypedElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTypedElementAdapter()
    {
        if (typedelementModelerProvider == null)
        {
            typedelementModelerProvider = new TypedElementModelerProvider(this);
        }

        return typedelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Parameter}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createParameterAdapter()
    {
        if (parameterModelerProvider == null)
        {
            parameterModelerProvider = new ParameterModelerProvider(this);
        }

        return parameterModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Package}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPackageAdapter()
    {
        if (packageModelerProvider == null)
        {
            packageModelerProvider = new PackageModelerProvider(this);
        }

        return packageModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Enumeration}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEnumerationAdapter()
    {
        if (enumerationModelerProvider == null)
        {
            enumerationModelerProvider = new EnumerationModelerProvider(this);
        }

        return enumerationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DataType}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDataTypeAdapter()
    {
        if (datatypeModelerProvider == null)
        {
            datatypeModelerProvider = new DataTypeModelerProvider(this);
        }

        return datatypeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.EnumerationLiteral}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEnumerationLiteralAdapter()
    {
        if (enumerationliteralModelerProvider == null)
        {
            enumerationliteralModelerProvider = new EnumerationLiteralModelerProvider(this);
        }

        return enumerationliteralModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.PrimitiveType}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPrimitiveTypeAdapter()
    {
        if (primitivetypeModelerProvider == null)
        {
            primitivetypeModelerProvider = new PrimitiveTypeModelerProvider(this);
        }

        return primitivetypeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Classifier}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createClassifierAdapter()
    {
        if (classifierModelerProvider == null)
        {
            classifierModelerProvider = new ClassifierModelerProvider(this);
        }

        return classifierModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Feature}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFeatureAdapter()
    {
        if (featureModelerProvider == null)
        {
            featureModelerProvider = new FeatureModelerProvider(this);
        }

        return featureModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Constraint}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConstraintAdapter()
    {
        if (constraintModelerProvider == null)
        {
            constraintModelerProvider = new ConstraintModelerProvider(this);
        }

        return constraintModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LiteralBoolean}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLiteralBooleanAdapter()
    {
        if (literalbooleanModelerProvider == null)
        {
            literalbooleanModelerProvider = new LiteralBooleanModelerProvider(this);
        }

        return literalbooleanModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LiteralSpecification}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLiteralSpecificationAdapter()
    {
        if (literalspecificationModelerProvider == null)
        {
            literalspecificationModelerProvider = new LiteralSpecificationModelerProvider(this);
        }

        return literalspecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LiteralString}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLiteralStringAdapter()
    {
        if (literalstringModelerProvider == null)
        {
            literalstringModelerProvider = new LiteralStringModelerProvider(this);
        }

        return literalstringModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LiteralNull}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLiteralNullAdapter()
    {
        if (literalnullModelerProvider == null)
        {
            literalnullModelerProvider = new LiteralNullModelerProvider(this);
        }

        return literalnullModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LiteralInteger}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLiteralIntegerAdapter()
    {
        if (literalintegerModelerProvider == null)
        {
            literalintegerModelerProvider = new LiteralIntegerModelerProvider(this);
        }

        return literalintegerModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LiteralUnlimitedNatural}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLiteralUnlimitedNaturalAdapter()
    {
        if (literalunlimitednaturalModelerProvider == null)
        {
            literalunlimitednaturalModelerProvider = new LiteralUnlimitedNaturalModelerProvider(this);
        }

        return literalunlimitednaturalModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.OpaqueBehavior}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createOpaqueBehaviorAdapter()
    {
        if (opaquebehaviorModelerProvider == null)
        {
            opaquebehaviorModelerProvider = new OpaqueBehaviorModelerProvider(this);
        }

        return opaquebehaviorModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.FunctionBehavior}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFunctionBehaviorAdapter()
    {
        if (functionbehaviorModelerProvider == null)
        {
            functionbehaviorModelerProvider = new FunctionBehaviorModelerProvider(this);
        }

        return functionbehaviorModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.OpaqueAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createOpaqueActionAdapter()
    {
        if (opaqueactionModelerProvider == null)
        {
            opaqueactionModelerProvider = new OpaqueActionModelerProvider(this);
        }

        return opaqueactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.BehavioralFeature}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createBehavioralFeatureAdapter()
    {
        if (behavioralfeatureModelerProvider == null)
        {
            behavioralfeatureModelerProvider = new BehavioralFeatureModelerProvider(this);
        }

        return behavioralfeatureModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.StructuralFeature}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStructuralFeatureAdapter()
    {
        if (structuralfeatureModelerProvider == null)
        {
            structuralfeatureModelerProvider = new StructuralFeatureModelerProvider(this);
        }

        return structuralfeatureModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InstanceSpecification}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInstanceSpecificationAdapter()
    {
        if (instancespecificationModelerProvider == null)
        {
            instancespecificationModelerProvider = new InstanceSpecificationModelerProvider(this);
        }

        return instancespecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Slot}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSlotAdapter()
    {
        if (slotModelerProvider == null)
        {
            slotModelerProvider = new SlotModelerProvider(this);
        }

        return slotModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InstanceValue}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInstanceValueAdapter()
    {
        if (instancevalueModelerProvider == null)
        {
            instancevalueModelerProvider = new InstanceValueModelerProvider(this);
        }

        return instancevalueModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.RedefinableElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRedefinableElementAdapter()
    {
        if (redefinableelementModelerProvider == null)
        {
            redefinableelementModelerProvider = new RedefinableElementModelerProvider(this);
        }

        return redefinableelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Generalization}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createGeneralizationAdapter()
    {
        if (generalizationModelerProvider == null)
        {
            generalizationModelerProvider = new GeneralizationModelerProvider(this);
        }

        return generalizationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.PackageableElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPackageableElementAdapter()
    {
        if (packageableelementModelerProvider == null)
        {
            packageableelementModelerProvider = new PackageableElementModelerProvider(this);
        }

        return packageableelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ElementImport}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createElementImportAdapter()
    {
        if (elementimportModelerProvider == null)
        {
            elementimportModelerProvider = new ElementImportModelerProvider(this);
        }

        return elementimportModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.PackageImport}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPackageImportAdapter()
    {
        if (packageimportModelerProvider == null)
        {
            packageimportModelerProvider = new PackageImportModelerProvider(this);
        }

        return packageimportModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Association}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createAssociationAdapter()
    {
        if (associationModelerProvider == null)
        {
            associationModelerProvider = new AssociationModelerProvider(this);
        }

        return associationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.PackageMerge}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPackageMergeAdapter()
    {
        if (packagemergeModelerProvider == null)
        {
            packagemergeModelerProvider = new PackageMergeModelerProvider(this);
        }

        return packagemergeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Stereotype}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStereotypeAdapter()
    {
        if (stereotypeModelerProvider == null)
        {
            stereotypeModelerProvider = new StereotypeModelerProvider(this);
        }

        return stereotypeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Image}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createImageAdapter()
    {
        if (imageModelerProvider == null)
        {
            imageModelerProvider = new ImageModelerProvider(this);
        }

        return imageModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Profile}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createProfileAdapter()
    {
        if (profileModelerProvider == null)
        {
            profileModelerProvider = new ProfileModelerProvider(this);
        }

        return profileModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ProfileApplication}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createProfileApplicationAdapter()
    {
        if (profileapplicationModelerProvider == null)
        {
            profileapplicationModelerProvider = new ProfileApplicationModelerProvider(this);
        }

        return profileapplicationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Extension}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExtensionAdapter()
    {
        if (extensionModelerProvider == null)
        {
            extensionModelerProvider = new ExtensionModelerProvider(this);
        }

        return extensionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExtensionEnd}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExtensionEndAdapter()
    {
        if (extensionendModelerProvider == null)
        {
            extensionendModelerProvider = new ExtensionEndModelerProvider(this);
        }

        return extensionendModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Behavior}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createBehaviorAdapter()
    {
        if (behaviorModelerProvider == null)
        {
            behaviorModelerProvider = new BehaviorModelerProvider(this);
        }

        return behaviorModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.BehavioredClassifier}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createBehavioredClassifierAdapter()
    {
        if (behavioredclassifierModelerProvider == null)
        {
            behavioredclassifierModelerProvider = new BehavioredClassifierModelerProvider(this);
        }

        return behavioredclassifierModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InterfaceRealization}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInterfaceRealizationAdapter()
    {
        if (interfacerealizationModelerProvider == null)
        {
            interfacerealizationModelerProvider = new InterfaceRealizationModelerProvider(this);
        }

        return interfacerealizationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Activity}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActivityAdapter()
    {
        if (activityModelerProvider == null)
        {
            activityModelerProvider = new ActivityModelerProvider(this);
        }

        return activityModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Dependency}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDependencyAdapter()
    {
        if (dependencyModelerProvider == null)
        {
            dependencyModelerProvider = new DependencyModelerProvider(this);
        }

        return dependencyModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Usage}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createUsageAdapter()
    {
        if (usageModelerProvider == null)
        {
            usageModelerProvider = new UsageModelerProvider(this);
        }

        return usageModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Abstraction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createAbstractionAdapter()
    {
        if (abstractionModelerProvider == null)
        {
            abstractionModelerProvider = new AbstractionModelerProvider(this);
        }

        return abstractionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Realization}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRealizationAdapter()
    {
        if (realizationModelerProvider == null)
        {
            realizationModelerProvider = new RealizationModelerProvider(this);
        }

        return realizationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Substitution}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSubstitutionAdapter()
    {
        if (substitutionModelerProvider == null)
        {
            substitutionModelerProvider = new SubstitutionModelerProvider(this);
        }

        return substitutionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.GeneralizationSet}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createGeneralizationSetAdapter()
    {
        if (generalizationsetModelerProvider == null)
        {
            generalizationsetModelerProvider = new GeneralizationSetModelerProvider(this);
        }

        return generalizationsetModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.AssociationClass}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createAssociationClassAdapter()
    {
        if (associationclassModelerProvider == null)
        {
            associationclassModelerProvider = new AssociationClassModelerProvider(this);
        }

        return associationclassModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InformationItem}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInformationItemAdapter()
    {
        if (informationitemModelerProvider == null)
        {
            informationitemModelerProvider = new InformationItemModelerProvider(this);
        }

        return informationitemModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InformationFlow}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInformationFlowAdapter()
    {
        if (informationflowModelerProvider == null)
        {
            informationflowModelerProvider = new InformationFlowModelerProvider(this);
        }

        return informationflowModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Model}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createModelAdapter()
    {
        if (modelModelerProvider == null)
        {
            modelModelerProvider = new ModelModelerProvider(this);
        }

        return modelModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ConnectorEnd}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConnectorEndAdapter()
    {
        if (connectorendModelerProvider == null)
        {
            connectorendModelerProvider = new ConnectorEndModelerProvider(this);
        }

        return connectorendModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ConnectableElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConnectableElementAdapter()
    {
        if (connectableelementModelerProvider == null)
        {
            connectableelementModelerProvider = new ConnectableElementModelerProvider(this);
        }

        return connectableelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Connector}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConnectorAdapter()
    {
        if (connectorModelerProvider == null)
        {
            connectorModelerProvider = new ConnectorModelerProvider(this);
        }

        return connectorModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.StructuredClassifier}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStructuredClassifierAdapter()
    {
        if (structuredclassifierModelerProvider == null)
        {
            structuredclassifierModelerProvider = new StructuredClassifierModelerProvider(this);
        }

        return structuredclassifierModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ActivityEdge}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActivityEdgeAdapter()
    {
        if (activityedgeModelerProvider == null)
        {
            activityedgeModelerProvider = new ActivityEdgeModelerProvider(this);
        }

        return activityedgeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ActivityGroup}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActivityGroupAdapter()
    {
        if (activitygroupModelerProvider == null)
        {
            activitygroupModelerProvider = new ActivityGroupModelerProvider(this);
        }

        return activitygroupModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ActivityNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActivityNodeAdapter()
    {
        if (activitynodeModelerProvider == null)
        {
            activitynodeModelerProvider = new ActivityNodeModelerProvider(this);
        }

        return activitynodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Action}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActionAdapter()
    {
        if (actionModelerProvider == null)
        {
            actionModelerProvider = new ActionModelerProvider(this);
        }

        return actionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ObjectNode}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createObjectNodeAdapter()
    {
        if (objectnodeModelerProvider == null)
        {
            objectnodeModelerProvider = new ObjectNodeModelerProvider(this);
        }

        return objectnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ControlNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createControlNodeAdapter()
    {
        if (controlnodeModelerProvider == null)
        {
            controlnodeModelerProvider = new ControlNodeModelerProvider(this);
        }

        return controlnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ControlFlow}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createControlFlowAdapter()
    {
        if (controlflowModelerProvider == null)
        {
            controlflowModelerProvider = new ControlFlowModelerProvider(this);
        }

        return controlflowModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ObjectFlow}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createObjectFlowAdapter()
    {
        if (objectflowModelerProvider == null)
        {
            objectflowModelerProvider = new ObjectFlowModelerProvider(this);
        }

        return objectflowModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InitialNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInitialNodeAdapter()
    {
        if (initialnodeModelerProvider == null)
        {
            initialnodeModelerProvider = new InitialNodeModelerProvider(this);
        }

        return initialnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.FinalNode}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFinalNodeAdapter()
    {
        if (finalnodeModelerProvider == null)
        {
            finalnodeModelerProvider = new FinalNodeModelerProvider(this);
        }

        return finalnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ActivityFinalNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActivityFinalNodeAdapter()
    {
        if (activityfinalnodeModelerProvider == null)
        {
            activityfinalnodeModelerProvider = new ActivityFinalNodeModelerProvider(this);
        }

        return activityfinalnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ComponentRealization}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createComponentRealizationAdapter()
    {
        if (componentrealizationModelerProvider == null)
        {
            componentrealizationModelerProvider = new ComponentRealizationModelerProvider(this);
        }

        return componentrealizationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DecisionNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDecisionNodeAdapter()
    {
        if (decisionnodeModelerProvider == null)
        {
            decisionnodeModelerProvider = new DecisionNodeModelerProvider(this);
        }

        return decisionnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.MergeNode}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createMergeNodeAdapter()
    {
        if (mergenodeModelerProvider == null)
        {
            mergenodeModelerProvider = new MergeNodeModelerProvider(this);
        }

        return mergenodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExecutableNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExecutableNodeAdapter()
    {
        if (executablenodeModelerProvider == null)
        {
            executablenodeModelerProvider = new ExecutableNodeModelerProvider(this);
        }

        return executablenodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.OutputPin}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createOutputPinAdapter()
    {
        if (outputpinModelerProvider == null)
        {
            outputpinModelerProvider = new OutputPinModelerProvider(this);
        }

        return outputpinModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InputPin}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInputPinAdapter()
    {
        if (inputpinModelerProvider == null)
        {
            inputpinModelerProvider = new InputPinModelerProvider(this);
        }

        return inputpinModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Pin}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPinAdapter()
    {
        if (pinModelerProvider == null)
        {
            pinModelerProvider = new PinModelerProvider(this);
        }

        return pinModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ActivityParameterNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActivityParameterNodeAdapter()
    {
        if (activityparameternodeModelerProvider == null)
        {
            activityparameternodeModelerProvider = new ActivityParameterNodeModelerProvider(this);
        }

        return activityparameternodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ValuePin}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createValuePinAdapter()
    {
        if (valuepinModelerProvider == null)
        {
            valuepinModelerProvider = new ValuePinModelerProvider(this);
        }

        return valuepinModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Interface}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInterfaceAdapter()
    {
        if (interfaceModelerProvider == null)
        {
            interfaceModelerProvider = new InterfaceModelerProvider(this);
        }

        return interfaceModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Artifact}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createArtifactAdapter()
    {
        if (artifactModelerProvider == null)
        {
            artifactModelerProvider = new ArtifactModelerProvider(this);
        }

        return artifactModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Manifestation}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createManifestationAdapter()
    {
        if (manifestationModelerProvider == null)
        {
            manifestationModelerProvider = new ManifestationModelerProvider(this);
        }

        return manifestationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Actor}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActorAdapter()
    {
        if (actorModelerProvider == null)
        {
            actorModelerProvider = new ActorModelerProvider(this);
        }

        return actorModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CallEvent}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCallEventAdapter()
    {
        if (calleventModelerProvider == null)
        {
            calleventModelerProvider = new CallEventModelerProvider(this);
        }

        return calleventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ChangeEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createChangeEventAdapter()
    {
        if (changeeventModelerProvider == null)
        {
            changeeventModelerProvider = new ChangeEventModelerProvider(this);
        }

        return changeeventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.SignalEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSignalEventAdapter()
    {
        if (signaleventModelerProvider == null)
        {
            signaleventModelerProvider = new SignalEventModelerProvider(this);
        }

        return signaleventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.AnyReceiveEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createAnyReceiveEventAdapter()
    {
        if (anyreceiveeventModelerProvider == null)
        {
            anyreceiveeventModelerProvider = new AnyReceiveEventModelerProvider(this);
        }

        return anyreceiveeventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Extend}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExtendAdapter()
    {
        if (extendModelerProvider == null)
        {
            extendModelerProvider = new ExtendModelerProvider(this);
        }

        return extendModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.UseCase}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createUseCaseAdapter()
    {
        if (usecaseModelerProvider == null)
        {
            usecaseModelerProvider = new UseCaseModelerProvider(this);
        }

        return usecaseModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExtensionPoint}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExtensionPointAdapter()
    {
        if (extensionpointModelerProvider == null)
        {
            extensionpointModelerProvider = new ExtensionPointModelerProvider(this);
        }

        return extensionpointModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Include}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createIncludeAdapter()
    {
        if (includeModelerProvider == null)
        {
            includeModelerProvider = new IncludeModelerProvider(this);
        }

        return includeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Collaboration}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCollaborationAdapter()
    {
        if (collaborationModelerProvider == null)
        {
            collaborationModelerProvider = new CollaborationModelerProvider(this);
        }

        return collaborationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Port}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPortAdapter()
    {
        if (portModelerProvider == null)
        {
            portModelerProvider = new PortModelerProvider(this);
        }

        return portModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.EncapsulatedClassifier}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEncapsulatedClassifierAdapter()
    {
        if (encapsulatedclassifierModelerProvider == null)
        {
            encapsulatedclassifierModelerProvider = new EncapsulatedClassifierModelerProvider(this);
        }

        return encapsulatedclassifierModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Trigger}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTriggerAdapter()
    {
        if (triggerModelerProvider == null)
        {
            triggerModelerProvider = new TriggerModelerProvider(this);
        }

        return triggerModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Event}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createEventAdapter()
    {
        if (eventModelerProvider == null)
        {
            eventModelerProvider = new EventModelerProvider(this);
        }

        return eventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Reception}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReceptionAdapter()
    {
        if (receptionModelerProvider == null)
        {
            receptionModelerProvider = new ReceptionModelerProvider(this);
        }

        return receptionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Signal}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSignalAdapter()
    {
        if (signalModelerProvider == null)
        {
            signalModelerProvider = new SignalModelerProvider(this);
        }

        return signalModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Variable}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createVariableAdapter()
    {
        if (variableModelerProvider == null)
        {
            variableModelerProvider = new VariableModelerProvider(this);
        }

        return variableModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.StructuredActivityNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStructuredActivityNodeAdapter()
    {
        if (structuredactivitynodeModelerProvider == null)
        {
            structuredactivitynodeModelerProvider = new StructuredActivityNodeModelerProvider(this);
        }

        return structuredactivitynodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ConditionalNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConditionalNodeAdapter()
    {
        if (conditionalnodeModelerProvider == null)
        {
            conditionalnodeModelerProvider = new ConditionalNodeModelerProvider(this);
        }

        return conditionalnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Clause}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createClauseAdapter()
    {
        if (clauseModelerProvider == null)
        {
            clauseModelerProvider = new ClauseModelerProvider(this);
        }

        return clauseModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LoopNode}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLoopNodeAdapter()
    {
        if (loopnodeModelerProvider == null)
        {
            loopnodeModelerProvider = new LoopNodeModelerProvider(this);
        }

        return loopnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Interaction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInteractionAdapter()
    {
        if (interactionModelerProvider == null)
        {
            interactionModelerProvider = new InteractionModelerProvider(this);
        }

        return interactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InteractionFragment}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInteractionFragmentAdapter()
    {
        if (interactionfragmentModelerProvider == null)
        {
            interactionfragmentModelerProvider = new InteractionFragmentModelerProvider(this);
        }

        return interactionfragmentModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Lifeline}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLifelineAdapter()
    {
        if (lifelineModelerProvider == null)
        {
            lifelineModelerProvider = new LifelineModelerProvider(this);
        }

        return lifelineModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Message}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createMessageAdapter()
    {
        if (messageModelerProvider == null)
        {
            messageModelerProvider = new MessageModelerProvider(this);
        }

        return messageModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.GeneralOrdering}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createGeneralOrderingAdapter()
    {
        if (generalorderingModelerProvider == null)
        {
            generalorderingModelerProvider = new GeneralOrderingModelerProvider(this);
        }

        return generalorderingModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.OccurrenceSpecification}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createOccurrenceSpecificationAdapter()
    {
        if (occurrencespecificationModelerProvider == null)
        {
            occurrencespecificationModelerProvider = new OccurrenceSpecificationModelerProvider(this);
        }

        return occurrencespecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.MessageEnd}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createMessageEndAdapter()
    {
        if (messageendModelerProvider == null)
        {
            messageendModelerProvider = new MessageEndModelerProvider(this);
        }

        return messageendModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.StateInvariant}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStateInvariantAdapter()
    {
        if (stateinvariantModelerProvider == null)
        {
            stateinvariantModelerProvider = new StateInvariantModelerProvider(this);
        }

        return stateinvariantModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ActionExecutionSpecification}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActionExecutionSpecificationAdapter()
    {
        if (actionexecutionspecificationModelerProvider == null)
        {
            actionexecutionspecificationModelerProvider = new ActionExecutionSpecificationModelerProvider(this);
        }

        return actionexecutionspecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.BehaviorExecutionSpecification}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createBehaviorExecutionSpecificationAdapter()
    {
        if (behaviorexecutionspecificationModelerProvider == null)
        {
            behaviorexecutionspecificationModelerProvider = new BehaviorExecutionSpecificationModelerProvider(this);
        }

        return behaviorexecutionspecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExecutionEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExecutionEventAdapter()
    {
        if (executioneventModelerProvider == null)
        {
            executioneventModelerProvider = new ExecutionEventModelerProvider(this);
        }

        return executioneventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CreationEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCreationEventAdapter()
    {
        if (creationeventModelerProvider == null)
        {
            creationeventModelerProvider = new CreationEventModelerProvider(this);
        }

        return creationeventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DestructionEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDestructionEventAdapter()
    {
        if (destructioneventModelerProvider == null)
        {
            destructioneventModelerProvider = new DestructionEventModelerProvider(this);
        }

        return destructioneventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.SendOperationEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSendOperationEventAdapter()
    {
        if (sendoperationeventModelerProvider == null)
        {
            sendoperationeventModelerProvider = new SendOperationEventModelerProvider(this);
        }

        return sendoperationeventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.MessageEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createMessageEventAdapter()
    {
        if (messageeventModelerProvider == null)
        {
            messageeventModelerProvider = new MessageEventModelerProvider(this);
        }

        return messageeventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.SendSignalEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSendSignalEventAdapter()
    {
        if (sendsignaleventModelerProvider == null)
        {
            sendsignaleventModelerProvider = new SendSignalEventModelerProvider(this);
        }

        return sendsignaleventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.MessageOccurrenceSpecification}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createMessageOccurrenceSpecificationAdapter()
    {
        if (messageoccurrencespecificationModelerProvider == null)
        {
            messageoccurrencespecificationModelerProvider = new MessageOccurrenceSpecificationModelerProvider(this);
        }

        return messageoccurrencespecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExecutionOccurrenceSpecification}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExecutionOccurrenceSpecificationAdapter()
    {
        if (executionoccurrencespecificationModelerProvider == null)
        {
            executionoccurrencespecificationModelerProvider = new ExecutionOccurrenceSpecificationModelerProvider(this);
        }

        return executionoccurrencespecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReceiveOperationEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReceiveOperationEventAdapter()
    {
        if (receiveoperationeventModelerProvider == null)
        {
            receiveoperationeventModelerProvider = new ReceiveOperationEventModelerProvider(this);
        }

        return receiveoperationeventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReceiveSignalEvent}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReceiveSignalEventAdapter()
    {
        if (receivesignaleventModelerProvider == null)
        {
            receivesignaleventModelerProvider = new ReceiveSignalEventModelerProvider(this);
        }

        return receivesignaleventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TemplateSignature}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTemplateSignatureAdapter()
    {
        if (templatesignatureModelerProvider == null)
        {
            templatesignatureModelerProvider = new TemplateSignatureModelerProvider(this);
        }

        return templatesignatureModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TemplateParameter}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTemplateParameterAdapter()
    {
        if (templateparameterModelerProvider == null)
        {
            templateparameterModelerProvider = new TemplateParameterModelerProvider(this);
        }

        return templateparameterModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TemplateableElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTemplateableElementAdapter()
    {
        if (templateableelementModelerProvider == null)
        {
            templateableelementModelerProvider = new TemplateableElementModelerProvider(this);
        }

        return templateableelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.StringExpression}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStringExpressionAdapter()
    {
        if (stringexpressionModelerProvider == null)
        {
            stringexpressionModelerProvider = new StringExpressionModelerProvider(this);
        }

        return stringexpressionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ParameterableElement}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createParameterableElementAdapter()
    {
        if (parameterableelementModelerProvider == null)
        {
            parameterableelementModelerProvider = new ParameterableElementModelerProvider(this);
        }

        return parameterableelementModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TemplateBinding}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTemplateBindingAdapter()
    {
        if (templatebindingModelerProvider == null)
        {
            templatebindingModelerProvider = new TemplateBindingModelerProvider(this);
        }

        return templatebindingModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TemplateParameterSubstitution}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTemplateParameterSubstitutionAdapter()
    {
        if (templateparametersubstitutionModelerProvider == null)
        {
            templateparametersubstitutionModelerProvider = new TemplateParameterSubstitutionModelerProvider(this);
        }

        return templateparametersubstitutionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.OperationTemplateParameter}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createOperationTemplateParameterAdapter()
    {
        if (operationtemplateparameterModelerProvider == null)
        {
            operationtemplateparameterModelerProvider = new OperationTemplateParameterModelerProvider(this);
        }

        return operationtemplateparameterModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ClassifierTemplateParameter}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createClassifierTemplateParameterAdapter()
    {
        if (classifiertemplateparameterModelerProvider == null)
        {
            classifiertemplateparameterModelerProvider = new ClassifierTemplateParameterModelerProvider(this);
        }

        return classifiertemplateparameterModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.RedefinableTemplateSignature}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRedefinableTemplateSignatureAdapter()
    {
        if (redefinabletemplatesignatureModelerProvider == null)
        {
            redefinabletemplatesignatureModelerProvider = new RedefinableTemplateSignatureModelerProvider(this);
        }

        return redefinabletemplatesignatureModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ConnectableElementTemplateParameter}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConnectableElementTemplateParameterAdapter()
    {
        if (connectableelementtemplateparameterModelerProvider == null)
        {
            connectableelementtemplateparameterModelerProvider = new ConnectableElementTemplateParameterModelerProvider(this);
        }

        return connectableelementtemplateparameterModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CollaborationUse}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCollaborationUseAdapter()
    {
        if (collaborationuseModelerProvider == null)
        {
            collaborationuseModelerProvider = new CollaborationUseModelerProvider(this);
        }

        return collaborationuseModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ForkNode}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createForkNodeAdapter()
    {
        if (forknodeModelerProvider == null)
        {
            forknodeModelerProvider = new ForkNodeModelerProvider(this);
        }

        return forknodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.JoinNode}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createJoinNodeAdapter()
    {
        if (joinnodeModelerProvider == null)
        {
            joinnodeModelerProvider = new JoinNodeModelerProvider(this);
        }

        return joinnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.FlowFinalNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFlowFinalNodeAdapter()
    {
        if (flowfinalnodeModelerProvider == null)
        {
            flowfinalnodeModelerProvider = new FlowFinalNodeModelerProvider(this);
        }

        return flowfinalnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CentralBufferNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCentralBufferNodeAdapter()
    {
        if (centralbuffernodeModelerProvider == null)
        {
            centralbuffernodeModelerProvider = new CentralBufferNodeModelerProvider(this);
        }

        return centralbuffernodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ActivityPartition}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActivityPartitionAdapter()
    {
        if (activitypartitionModelerProvider == null)
        {
            activitypartitionModelerProvider = new ActivityPartitionModelerProvider(this);
        }

        return activitypartitionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExpansionNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExpansionNodeAdapter()
    {
        if (expansionnodeModelerProvider == null)
        {
            expansionnodeModelerProvider = new ExpansionNodeModelerProvider(this);
        }

        return expansionnodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExpansionRegion}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExpansionRegionAdapter()
    {
        if (expansionregionModelerProvider == null)
        {
            expansionregionModelerProvider = new ExpansionRegionModelerProvider(this);
        }

        return expansionregionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExceptionHandler}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExceptionHandlerAdapter()
    {
        if (exceptionhandlerModelerProvider == null)
        {
            exceptionhandlerModelerProvider = new ExceptionHandlerModelerProvider(this);
        }

        return exceptionhandlerModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Gate}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createGateAdapter()
    {
        if (gateModelerProvider == null)
        {
            gateModelerProvider = new GateModelerProvider(this);
        }

        return gateModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.PartDecomposition}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPartDecompositionAdapter()
    {
        if (partdecompositionModelerProvider == null)
        {
            partdecompositionModelerProvider = new PartDecompositionModelerProvider(this);
        }

        return partdecompositionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InteractionUse}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInteractionUseAdapter()
    {
        if (interactionuseModelerProvider == null)
        {
            interactionuseModelerProvider = new InteractionUseModelerProvider(this);
        }

        return interactionuseModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InteractionOperand}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInteractionOperandAdapter()
    {
        if (interactionoperandModelerProvider == null)
        {
            interactionoperandModelerProvider = new InteractionOperandModelerProvider(this);
        }

        return interactionoperandModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InteractionConstraint}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInteractionConstraintAdapter()
    {
        if (interactionconstraintModelerProvider == null)
        {
            interactionconstraintModelerProvider = new InteractionConstraintModelerProvider(this);
        }

        return interactionconstraintModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExecutionSpecification}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExecutionSpecificationAdapter()
    {
        if (executionspecificationModelerProvider == null)
        {
            executionspecificationModelerProvider = new ExecutionSpecificationModelerProvider(this);
        }

        return executionspecificationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CombinedFragment}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCombinedFragmentAdapter()
    {
        if (combinedfragmentModelerProvider == null)
        {
            combinedfragmentModelerProvider = new CombinedFragmentModelerProvider(this);
        }

        return combinedfragmentModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Continuation}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createContinuationAdapter()
    {
        if (continuationModelerProvider == null)
        {
            continuationModelerProvider = new ContinuationModelerProvider(this);
        }

        return continuationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ConsiderIgnoreFragment}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConsiderIgnoreFragmentAdapter()
    {
        if (considerignorefragmentModelerProvider == null)
        {
            considerignorefragmentModelerProvider = new ConsiderIgnoreFragmentModelerProvider(this);
        }

        return considerignorefragmentModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.StateMachine}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStateMachineAdapter()
    {
        if (statemachineModelerProvider == null)
        {
            statemachineModelerProvider = new StateMachineModelerProvider(this);
        }

        return statemachineModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Region}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRegionAdapter()
    {
        if (regionModelerProvider == null)
        {
            regionModelerProvider = new RegionModelerProvider(this);
        }

        return regionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Pseudostate}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createPseudostateAdapter()
    {
        if (pseudostateModelerProvider == null)
        {
            pseudostateModelerProvider = new PseudostateModelerProvider(this);
        }

        return pseudostateModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.State}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStateAdapter()
    {
        if (stateModelerProvider == null)
        {
            stateModelerProvider = new StateModelerProvider(this);
        }

        return stateModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Vertex}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createVertexAdapter()
    {
        if (vertexModelerProvider == null)
        {
            vertexModelerProvider = new VertexModelerProvider(this);
        }

        return vertexModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ConnectionPointReference}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createConnectionPointReferenceAdapter()
    {
        if (connectionpointreferenceModelerProvider == null)
        {
            connectionpointreferenceModelerProvider = new ConnectionPointReferenceModelerProvider(this);
        }

        return connectionpointreferenceModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Transition}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTransitionAdapter()
    {
        if (transitionModelerProvider == null)
        {
            transitionModelerProvider = new TransitionModelerProvider(this);
        }

        return transitionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.FinalState}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createFinalStateAdapter()
    {
        if (finalstateModelerProvider == null)
        {
            finalstateModelerProvider = new FinalStateModelerProvider(this);
        }

        return finalstateModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TimeEvent}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTimeEventAdapter()
    {
        if (timeeventModelerProvider == null)
        {
            timeeventModelerProvider = new TimeEventModelerProvider(this);
        }

        return timeeventModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CreateObjectAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCreateObjectActionAdapter()
    {
        if (createobjectactionModelerProvider == null)
        {
            createobjectactionModelerProvider = new CreateObjectActionModelerProvider(this);
        }

        return createobjectactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DestroyObjectAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDestroyObjectActionAdapter()
    {
        if (destroyobjectactionModelerProvider == null)
        {
            destroyobjectactionModelerProvider = new DestroyObjectActionModelerProvider(this);
        }

        return destroyobjectactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TestIdentityAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTestIdentityActionAdapter()
    {
        if (testidentityactionModelerProvider == null)
        {
            testidentityactionModelerProvider = new TestIdentityActionModelerProvider(this);
        }

        return testidentityactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReadSelfAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReadSelfActionAdapter()
    {
        if (readselfactionModelerProvider == null)
        {
            readselfactionModelerProvider = new ReadSelfActionModelerProvider(this);
        }

        return readselfactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.StructuralFeatureAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStructuralFeatureActionAdapter()
    {
        if (structuralfeatureactionModelerProvider == null)
        {
            structuralfeatureactionModelerProvider = new StructuralFeatureActionModelerProvider(this);
        }

        return structuralfeatureactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReadStructuralFeatureAction}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReadStructuralFeatureActionAdapter()
    {
        if (readstructuralfeatureactionModelerProvider == null)
        {
            readstructuralfeatureactionModelerProvider = new ReadStructuralFeatureActionModelerProvider(this);
        }

        return readstructuralfeatureactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.WriteStructuralFeatureAction}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createWriteStructuralFeatureActionAdapter()
    {
        if (writestructuralfeatureactionModelerProvider == null)
        {
            writestructuralfeatureactionModelerProvider = new WriteStructuralFeatureActionModelerProvider(this);
        }

        return writestructuralfeatureactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ClearStructuralFeatureAction}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createClearStructuralFeatureActionAdapter()
    {
        if (clearstructuralfeatureactionModelerProvider == null)
        {
            clearstructuralfeatureactionModelerProvider = new ClearStructuralFeatureActionModelerProvider(this);
        }

        return clearstructuralfeatureactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRemoveStructuralFeatureValueActionAdapter()
    {
        if (removestructuralfeaturevalueactionModelerProvider == null)
        {
            removestructuralfeaturevalueactionModelerProvider = new RemoveStructuralFeatureValueActionModelerProvider(this);
        }

        return removestructuralfeaturevalueactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.AddStructuralFeatureValueAction}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createAddStructuralFeatureValueActionAdapter()
    {
        if (addstructuralfeaturevalueactionModelerProvider == null)
        {
            addstructuralfeaturevalueactionModelerProvider = new AddStructuralFeatureValueActionModelerProvider(this);
        }

        return addstructuralfeaturevalueactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LinkAction}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLinkActionAdapter()
    {
        if (linkactionModelerProvider == null)
        {
            linkactionModelerProvider = new LinkActionModelerProvider(this);
        }

        return linkactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LinkEndData}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLinkEndDataAdapter()
    {
        if (linkenddataModelerProvider == null)
        {
            linkenddataModelerProvider = new LinkEndDataModelerProvider(this);
        }

        return linkenddataModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReadLinkAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReadLinkActionAdapter()
    {
        if (readlinkactionModelerProvider == null)
        {
            readlinkactionModelerProvider = new ReadLinkActionModelerProvider(this);
        }

        return readlinkactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LinkEndCreationData}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLinkEndCreationDataAdapter()
    {
        if (linkendcreationdataModelerProvider == null)
        {
            linkendcreationdataModelerProvider = new LinkEndCreationDataModelerProvider(this);
        }

        return linkendcreationdataModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CreateLinkAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCreateLinkActionAdapter()
    {
        if (createlinkactionModelerProvider == null)
        {
            createlinkactionModelerProvider = new CreateLinkActionModelerProvider(this);
        }

        return createlinkactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.WriteLinkAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createWriteLinkActionAdapter()
    {
        if (writelinkactionModelerProvider == null)
        {
            writelinkactionModelerProvider = new WriteLinkActionModelerProvider(this);
        }

        return writelinkactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DestroyLinkAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDestroyLinkActionAdapter()
    {
        if (destroylinkactionModelerProvider == null)
        {
            destroylinkactionModelerProvider = new DestroyLinkActionModelerProvider(this);
        }

        return destroylinkactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.LinkEndDestructionData}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createLinkEndDestructionDataAdapter()
    {
        if (linkenddestructiondataModelerProvider == null)
        {
            linkenddestructiondataModelerProvider = new LinkEndDestructionDataModelerProvider(this);
        }

        return linkenddestructiondataModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ClearAssociationAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createClearAssociationActionAdapter()
    {
        if (clearassociationactionModelerProvider == null)
        {
            clearassociationactionModelerProvider = new ClearAssociationActionModelerProvider(this);
        }

        return clearassociationactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.VariableAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createVariableActionAdapter()
    {
        if (variableactionModelerProvider == null)
        {
            variableactionModelerProvider = new VariableActionModelerProvider(this);
        }

        return variableactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReadVariableAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReadVariableActionAdapter()
    {
        if (readvariableactionModelerProvider == null)
        {
            readvariableactionModelerProvider = new ReadVariableActionModelerProvider(this);
        }

        return readvariableactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.WriteVariableAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createWriteVariableActionAdapter()
    {
        if (writevariableactionModelerProvider == null)
        {
            writevariableactionModelerProvider = new WriteVariableActionModelerProvider(this);
        }

        return writevariableactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ClearVariableAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createClearVariableActionAdapter()
    {
        if (clearvariableactionModelerProvider == null)
        {
            clearvariableactionModelerProvider = new ClearVariableActionModelerProvider(this);
        }

        return clearvariableactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.AddVariableValueAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createAddVariableValueActionAdapter()
    {
        if (addvariablevalueactionModelerProvider == null)
        {
            addvariablevalueactionModelerProvider = new AddVariableValueActionModelerProvider(this);
        }

        return addvariablevalueactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.RemoveVariableValueAction}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRemoveVariableValueActionAdapter()
    {
        if (removevariablevalueactionModelerProvider == null)
        {
            removevariablevalueactionModelerProvider = new RemoveVariableValueActionModelerProvider(this);
        }

        return removevariablevalueactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CallAction}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCallActionAdapter()
    {
        if (callactionModelerProvider == null)
        {
            callactionModelerProvider = new CallActionModelerProvider(this);
        }

        return callactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InvocationAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInvocationActionAdapter()
    {
        if (invocationactionModelerProvider == null)
        {
            invocationactionModelerProvider = new InvocationActionModelerProvider(this);
        }

        return invocationactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.SendSignalAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSendSignalActionAdapter()
    {
        if (sendsignalactionModelerProvider == null)
        {
            sendsignalactionModelerProvider = new SendSignalActionModelerProvider(this);
        }

        return sendsignalactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.BroadcastSignalAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createBroadcastSignalActionAdapter()
    {
        if (broadcastsignalactionModelerProvider == null)
        {
            broadcastsignalactionModelerProvider = new BroadcastSignalActionModelerProvider(this);
        }

        return broadcastsignalactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.SendObjectAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSendObjectActionAdapter()
    {
        if (sendobjectactionModelerProvider == null)
        {
            sendobjectactionModelerProvider = new SendObjectActionModelerProvider(this);
        }

        return sendobjectactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ValueSpecificationAction}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createValueSpecificationActionAdapter()
    {
        if (valuespecificationactionModelerProvider == null)
        {
            valuespecificationactionModelerProvider = new ValueSpecificationActionModelerProvider(this);
        }

        return valuespecificationactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CallOperationAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCallOperationActionAdapter()
    {
        if (calloperationactionModelerProvider == null)
        {
            calloperationactionModelerProvider = new CallOperationActionModelerProvider(this);
        }

        return calloperationactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CallBehaviorAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCallBehaviorActionAdapter()
    {
        if (callbehavioractionModelerProvider == null)
        {
            callbehavioractionModelerProvider = new CallBehaviorActionModelerProvider(this);
        }

        return callbehavioractionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.SequenceNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createSequenceNodeAdapter()
    {
        if (sequencenodeModelerProvider == null)
        {
            sequencenodeModelerProvider = new SequenceNodeModelerProvider(this);
        }

        return sequencenodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TimeExpression}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTimeExpressionAdapter()
    {
        if (timeexpressionModelerProvider == null)
        {
            timeexpressionModelerProvider = new TimeExpressionModelerProvider(this);
        }

        return timeexpressionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Observation}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createObservationAdapter()
    {
        if (observationModelerProvider == null)
        {
            observationModelerProvider = new ObservationModelerProvider(this);
        }

        return observationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Duration}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDurationAdapter()
    {
        if (durationModelerProvider == null)
        {
            durationModelerProvider = new DurationModelerProvider(this);
        }

        return durationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DurationInterval}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDurationIntervalAdapter()
    {
        if (durationintervalModelerProvider == null)
        {
            durationintervalModelerProvider = new DurationIntervalModelerProvider(this);
        }

        return durationintervalModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Interval}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createIntervalAdapter()
    {
        if (intervalModelerProvider == null)
        {
            intervalModelerProvider = new IntervalModelerProvider(this);
        }

        return intervalModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TimeConstraint}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTimeConstraintAdapter()
    {
        if (timeconstraintModelerProvider == null)
        {
            timeconstraintModelerProvider = new TimeConstraintModelerProvider(this);
        }

        return timeconstraintModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.IntervalConstraint}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createIntervalConstraintAdapter()
    {
        if (intervalconstraintModelerProvider == null)
        {
            intervalconstraintModelerProvider = new IntervalConstraintModelerProvider(this);
        }

        return intervalconstraintModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TimeInterval}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTimeIntervalAdapter()
    {
        if (timeintervalModelerProvider == null)
        {
            timeintervalModelerProvider = new TimeIntervalModelerProvider(this);
        }

        return timeintervalModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DurationConstraint}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDurationConstraintAdapter()
    {
        if (durationconstraintModelerProvider == null)
        {
            durationconstraintModelerProvider = new DurationConstraintModelerProvider(this);
        }

        return durationconstraintModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.TimeObservation}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createTimeObservationAdapter()
    {
        if (timeobservationModelerProvider == null)
        {
            timeobservationModelerProvider = new TimeObservationModelerProvider(this);
        }

        return timeobservationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DurationObservation}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDurationObservationAdapter()
    {
        if (durationobservationModelerProvider == null)
        {
            durationobservationModelerProvider = new DurationObservationModelerProvider(this);
        }

        return durationobservationModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DataStoreNode}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDataStoreNodeAdapter()
    {
        if (datastorenodeModelerProvider == null)
        {
            datastorenodeModelerProvider = new DataStoreNodeModelerProvider(this);
        }

        return datastorenodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.InterruptibleActivityRegion}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createInterruptibleActivityRegionAdapter()
    {
        if (interruptibleactivityregionModelerProvider == null)
        {
            interruptibleactivityregionModelerProvider = new InterruptibleActivityRegionModelerProvider(this);
        }

        return interruptibleactivityregionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ParameterSet}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createParameterSetAdapter()
    {
        if (parametersetModelerProvider == null)
        {
            parametersetModelerProvider = new ParameterSetModelerProvider(this);
        }

        return parametersetModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Component}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createComponentAdapter()
    {
        if (componentModelerProvider == null)
        {
            componentModelerProvider = new ComponentModelerProvider(this);
        }

        return componentModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Deployment}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDeploymentAdapter()
    {
        if (deploymentModelerProvider == null)
        {
            deploymentModelerProvider = new DeploymentModelerProvider(this);
        }

        return deploymentModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DeployedArtifact}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDeployedArtifactAdapter()
    {
        if (deployedartifactModelerProvider == null)
        {
            deployedartifactModelerProvider = new DeployedArtifactModelerProvider(this);
        }

        return deployedartifactModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DeploymentTarget}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDeploymentTargetAdapter()
    {
        if (deploymenttargetModelerProvider == null)
        {
            deploymenttargetModelerProvider = new DeploymentTargetModelerProvider(this);
        }

        return deploymenttargetModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Node}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createNodeAdapter()
    {
        if (nodeModelerProvider == null)
        {
            nodeModelerProvider = new NodeModelerProvider(this);
        }

        return nodeModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.Device}. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDeviceAdapter()
    {
        if (deviceModelerProvider == null)
        {
            deviceModelerProvider = new DeviceModelerProvider(this);
        }

        return deviceModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ExecutionEnvironment}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createExecutionEnvironmentAdapter()
    {
        if (executionenvironmentModelerProvider == null)
        {
            executionenvironmentModelerProvider = new ExecutionEnvironmentModelerProvider(this);
        }

        return executionenvironmentModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CommunicationPath}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCommunicationPathAdapter()
    {
        if (communicationpathModelerProvider == null)
        {
            communicationpathModelerProvider = new CommunicationPathModelerProvider(this);
        }

        return communicationpathModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ProtocolConformance}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createProtocolConformanceAdapter()
    {
        if (protocolconformanceModelerProvider == null)
        {
            protocolconformanceModelerProvider = new ProtocolConformanceModelerProvider(this);
        }

        return protocolconformanceModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ProtocolStateMachine}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createProtocolStateMachineAdapter()
    {
        if (protocolstatemachineModelerProvider == null)
        {
            protocolstatemachineModelerProvider = new ProtocolStateMachineModelerProvider(this);
        }

        return protocolstatemachineModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ProtocolTransition}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createProtocolTransitionAdapter()
    {
        if (protocoltransitionModelerProvider == null)
        {
            protocoltransitionModelerProvider = new ProtocolTransitionModelerProvider(this);
        }

        return protocoltransitionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReadExtentAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReadExtentActionAdapter()
    {
        if (readextentactionModelerProvider == null)
        {
            readextentactionModelerProvider = new ReadExtentActionModelerProvider(this);
        }

        return readextentactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReclassifyObjectAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReclassifyObjectActionAdapter()
    {
        if (reclassifyobjectactionModelerProvider == null)
        {
            reclassifyobjectactionModelerProvider = new ReclassifyObjectActionModelerProvider(this);
        }

        return reclassifyobjectactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReadIsClassifiedObjectAction}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReadIsClassifiedObjectActionAdapter()
    {
        if (readisclassifiedobjectactionModelerProvider == null)
        {
            readisclassifiedobjectactionModelerProvider = new ReadIsClassifiedObjectActionModelerProvider(this);
        }

        return readisclassifiedobjectactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.StartClassifierBehaviorAction}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createStartClassifierBehaviorActionAdapter()
    {
        if (startclassifierbehavioractionModelerProvider == null)
        {
            startclassifierbehavioractionModelerProvider = new StartClassifierBehaviorActionModelerProvider(this);
        }

        return startclassifierbehavioractionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.QualifierValue}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createQualifierValueAdapter()
    {
        if (qualifiervalueModelerProvider == null)
        {
            qualifiervalueModelerProvider = new QualifierValueModelerProvider(this);
        }

        return qualifiervalueModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReadLinkObjectEndAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReadLinkObjectEndActionAdapter()
    {
        if (readlinkobjectendactionModelerProvider == null)
        {
            readlinkobjectendactionModelerProvider = new ReadLinkObjectEndActionModelerProvider(this);
        }

        return readlinkobjectendactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction}. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReadLinkObjectEndQualifierActionAdapter()
    {
        if (readlinkobjectendqualifieractionModelerProvider == null)
        {
            readlinkobjectendqualifieractionModelerProvider = new ReadLinkObjectEndQualifierActionModelerProvider(this);
        }

        return readlinkobjectendqualifieractionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.CreateLinkObjectAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createCreateLinkObjectActionAdapter()
    {
        if (createlinkobjectactionModelerProvider == null)
        {
            createlinkobjectactionModelerProvider = new CreateLinkObjectActionModelerProvider(this);
        }

        return createlinkobjectactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.AcceptEventAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createAcceptEventActionAdapter()
    {
        if (accepteventactionModelerProvider == null)
        {
            accepteventactionModelerProvider = new AcceptEventActionModelerProvider(this);
        }

        return accepteventactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.AcceptCallAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createAcceptCallActionAdapter()
    {
        if (acceptcallactionModelerProvider == null)
        {
            acceptcallactionModelerProvider = new AcceptCallActionModelerProvider(this);
        }

        return acceptcallactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReplyAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReplyActionAdapter()
    {
        if (replyactionModelerProvider == null)
        {
            replyactionModelerProvider = new ReplyActionModelerProvider(this);
        }

        return replyactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.UnmarshallAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createUnmarshallActionAdapter()
    {
        if (unmarshallactionModelerProvider == null)
        {
            unmarshallactionModelerProvider = new UnmarshallActionModelerProvider(this);
        }

        return unmarshallactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ReduceAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createReduceActionAdapter()
    {
        if (reduceactionModelerProvider == null)
        {
            reduceactionModelerProvider = new ReduceActionModelerProvider(this);
        }

        return reduceactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.RaiseExceptionAction}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createRaiseExceptionActionAdapter()
    {
        if (raiseexceptionactionModelerProvider == null)
        {
            raiseexceptionactionModelerProvider = new RaiseExceptionActionModelerProvider(this);
        }

        return raiseexceptionactionModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.ActionInputPin}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createActionInputPinAdapter()
    {
        if (actioninputpinModelerProvider == null)
        {
            actioninputpinModelerProvider = new ActionInputPinModelerProvider(this);
        }

        return actioninputpinModelerProvider;
    }

    /**
     * This creates an adapter for a {@link org.eclipse.uml2.uml.DeploymentSpecification}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @return the Adapter
     * 
     * @generated
     */
    public Adapter createDeploymentSpecificationAdapter()
    {
        if (deploymentspecificationModelerProvider == null)
        {
            deploymentspecificationModelerProvider = new DeploymentSpecificationModelerProvider(this);
        }

        return deploymentspecificationModelerProvider;
    }

    /**
     * This disposes all of the item providers created by this factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void dispose()
    {
        if (commentModelerProvider != null)
        {
            commentModelerProvider.dispose();
        }
        if (elementModelerProvider != null)
        {
            elementModelerProvider.dispose();
        }
        if (packageModelerProvider != null)
        {
            packageModelerProvider.dispose();
        }
        if (packageableelementModelerProvider != null)
        {
            packageableelementModelerProvider.dispose();
        }
        if (namedelementModelerProvider != null)
        {
            namedelementModelerProvider.dispose();
        }
        if (dependencyModelerProvider != null)
        {
            dependencyModelerProvider.dispose();
        }
        if (directedrelationshipModelerProvider != null)
        {
            directedrelationshipModelerProvider.dispose();
        }
        if (relationshipModelerProvider != null)
        {
            relationshipModelerProvider.dispose();
        }
        if (namespaceModelerProvider != null)
        {
            namespaceModelerProvider.dispose();
        }
        if (elementimportModelerProvider != null)
        {
            elementimportModelerProvider.dispose();
        }
        if (packageimportModelerProvider != null)
        {
            packageimportModelerProvider.dispose();
        }
        if (constraintModelerProvider != null)
        {
            constraintModelerProvider.dispose();
        }
        if (valuespecificationModelerProvider != null)
        {
            valuespecificationModelerProvider.dispose();
        }
        if (typedelementModelerProvider != null)
        {
            typedelementModelerProvider.dispose();
        }
        if (typeModelerProvider != null)
        {
            typeModelerProvider.dispose();
        }
        if (associationModelerProvider != null)
        {
            associationModelerProvider.dispose();
        }
        if (classifierModelerProvider != null)
        {
            classifierModelerProvider.dispose();
        }
        if (redefinableelementModelerProvider != null)
        {
            redefinableelementModelerProvider.dispose();
        }
        if (templateableelementModelerProvider != null)
        {
            templateableelementModelerProvider.dispose();
        }
        if (templatebindingModelerProvider != null)
        {
            templatebindingModelerProvider.dispose();
        }
        if (templatesignatureModelerProvider != null)
        {
            templatesignatureModelerProvider.dispose();
        }
        if (templateparameterModelerProvider != null)
        {
            templateparameterModelerProvider.dispose();
        }
        if (parameterableelementModelerProvider != null)
        {
            parameterableelementModelerProvider.dispose();
        }
        if (templateparametersubstitutionModelerProvider != null)
        {
            templateparametersubstitutionModelerProvider.dispose();
        }
        if (generalizationModelerProvider != null)
        {
            generalizationModelerProvider.dispose();
        }
        if (generalizationsetModelerProvider != null)
        {
            generalizationsetModelerProvider.dispose();
        }
        if (featureModelerProvider != null)
        {
            featureModelerProvider.dispose();
        }
        if (substitutionModelerProvider != null)
        {
            substitutionModelerProvider.dispose();
        }
        if (realizationModelerProvider != null)
        {
            realizationModelerProvider.dispose();
        }
        if (abstractionModelerProvider != null)
        {
            abstractionModelerProvider.dispose();
        }
        if (opaqueexpressionModelerProvider != null)
        {
            opaqueexpressionModelerProvider.dispose();
        }
        if (parameterModelerProvider != null)
        {
            parameterModelerProvider.dispose();
        }
        if (multiplicityelementModelerProvider != null)
        {
            multiplicityelementModelerProvider.dispose();
        }
        if (connectableelementModelerProvider != null)
        {
            connectableelementModelerProvider.dispose();
        }
        if (connectorendModelerProvider != null)
        {
            connectorendModelerProvider.dispose();
        }
        if (propertyModelerProvider != null)
        {
            propertyModelerProvider.dispose();
        }
        if (deploymenttargetModelerProvider != null)
        {
            deploymenttargetModelerProvider.dispose();
        }
        if (deploymentModelerProvider != null)
        {
            deploymentModelerProvider.dispose();
        }
        if (deployedartifactModelerProvider != null)
        {
            deployedartifactModelerProvider.dispose();
        }
        if (deploymentspecificationModelerProvider != null)
        {
            deploymentspecificationModelerProvider.dispose();
        }
        if (artifactModelerProvider != null)
        {
            artifactModelerProvider.dispose();
        }
        if (manifestationModelerProvider != null)
        {
            manifestationModelerProvider.dispose();
        }
        if (operationModelerProvider != null)
        {
            operationModelerProvider.dispose();
        }
        if (behavioralfeatureModelerProvider != null)
        {
            behavioralfeatureModelerProvider.dispose();
        }
        if (behaviorModelerProvider != null)
        {
            behaviorModelerProvider.dispose();
        }
        if (classModelerProvider != null)
        {
            classModelerProvider.dispose();
        }
        if (behavioredclassifierModelerProvider != null)
        {
            behavioredclassifierModelerProvider.dispose();
        }
        if (interfacerealizationModelerProvider != null)
        {
            interfacerealizationModelerProvider.dispose();
        }
        if (interfaceModelerProvider != null)
        {
            interfaceModelerProvider.dispose();
        }
        if (receptionModelerProvider != null)
        {
            receptionModelerProvider.dispose();
        }
        if (signalModelerProvider != null)
        {
            signalModelerProvider.dispose();
        }
        if (protocolstatemachineModelerProvider != null)
        {
            protocolstatemachineModelerProvider.dispose();
        }
        if (statemachineModelerProvider != null)
        {
            statemachineModelerProvider.dispose();
        }
        if (regionModelerProvider != null)
        {
            regionModelerProvider.dispose();
        }
        if (vertexModelerProvider != null)
        {
            vertexModelerProvider.dispose();
        }
        if (transitionModelerProvider != null)
        {
            transitionModelerProvider.dispose();
        }
        if (triggerModelerProvider != null)
        {
            triggerModelerProvider.dispose();
        }
        if (eventModelerProvider != null)
        {
            eventModelerProvider.dispose();
        }
        if (portModelerProvider != null)
        {
            portModelerProvider.dispose();
        }
        if (stateModelerProvider != null)
        {
            stateModelerProvider.dispose();
        }
        if (connectionpointreferenceModelerProvider != null)
        {
            connectionpointreferenceModelerProvider.dispose();
        }
        if (pseudostateModelerProvider != null)
        {
            pseudostateModelerProvider.dispose();
        }
        if (protocolconformanceModelerProvider != null)
        {
            protocolconformanceModelerProvider.dispose();
        }
        if (encapsulatedclassifierModelerProvider != null)
        {
            encapsulatedclassifierModelerProvider.dispose();
        }
        if (structuredclassifierModelerProvider != null)
        {
            structuredclassifierModelerProvider.dispose();
        }
        if (connectorModelerProvider != null)
        {
            connectorModelerProvider.dispose();
        }
        if (extensionModelerProvider != null)
        {
            extensionModelerProvider.dispose();
        }
        if (extensionendModelerProvider != null)
        {
            extensionendModelerProvider.dispose();
        }
        if (stereotypeModelerProvider != null)
        {
            stereotypeModelerProvider.dispose();
        }
        if (imageModelerProvider != null)
        {
            imageModelerProvider.dispose();
        }
        if (profileModelerProvider != null)
        {
            profileModelerProvider.dispose();
        }
        if (modelModelerProvider != null)
        {
            modelModelerProvider.dispose();
        }
        if (parametersetModelerProvider != null)
        {
            parametersetModelerProvider.dispose();
        }
        if (datatypeModelerProvider != null)
        {
            datatypeModelerProvider.dispose();
        }
        if (operationtemplateparameterModelerProvider != null)
        {
            operationtemplateparameterModelerProvider.dispose();
        }
        if (structuralfeatureModelerProvider != null)
        {
            structuralfeatureModelerProvider.dispose();
        }
        if (connectableelementtemplateparameterModelerProvider != null)
        {
            connectableelementtemplateparameterModelerProvider.dispose();
        }
        if (collaborationuseModelerProvider != null)
        {
            collaborationuseModelerProvider.dispose();
        }
        if (collaborationModelerProvider != null)
        {
            collaborationModelerProvider.dispose();
        }
        if (usecaseModelerProvider != null)
        {
            usecaseModelerProvider.dispose();
        }
        if (includeModelerProvider != null)
        {
            includeModelerProvider.dispose();
        }
        if (extendModelerProvider != null)
        {
            extendModelerProvider.dispose();
        }
        if (extensionpointModelerProvider != null)
        {
            extensionpointModelerProvider.dispose();
        }
        if (redefinabletemplatesignatureModelerProvider != null)
        {
            redefinabletemplatesignatureModelerProvider.dispose();
        }
        if (classifiertemplateparameterModelerProvider != null)
        {
            classifiertemplateparameterModelerProvider.dispose();
        }
        if (stringexpressionModelerProvider != null)
        {
            stringexpressionModelerProvider.dispose();
        }
        if (expressionModelerProvider != null)
        {
            expressionModelerProvider.dispose();
        }
        if (packagemergeModelerProvider != null)
        {
            packagemergeModelerProvider.dispose();
        }
        if (profileapplicationModelerProvider != null)
        {
            profileapplicationModelerProvider.dispose();
        }
        if (enumerationModelerProvider != null)
        {
            enumerationModelerProvider.dispose();
        }
        if (enumerationliteralModelerProvider != null)
        {
            enumerationliteralModelerProvider.dispose();
        }
        if (instancespecificationModelerProvider != null)
        {
            instancespecificationModelerProvider.dispose();
        }
        if (slotModelerProvider != null)
        {
            slotModelerProvider.dispose();
        }
        if (primitivetypeModelerProvider != null)
        {
            primitivetypeModelerProvider.dispose();
        }
        if (literalspecificationModelerProvider != null)
        {
            literalspecificationModelerProvider.dispose();
        }
        if (literalintegerModelerProvider != null)
        {
            literalintegerModelerProvider.dispose();
        }
        if (literalstringModelerProvider != null)
        {
            literalstringModelerProvider.dispose();
        }
        if (literalbooleanModelerProvider != null)
        {
            literalbooleanModelerProvider.dispose();
        }
        if (literalnullModelerProvider != null)
        {
            literalnullModelerProvider.dispose();
        }
        if (instancevalueModelerProvider != null)
        {
            instancevalueModelerProvider.dispose();
        }
        if (literalunlimitednaturalModelerProvider != null)
        {
            literalunlimitednaturalModelerProvider.dispose();
        }
        if (opaquebehaviorModelerProvider != null)
        {
            opaquebehaviorModelerProvider.dispose();
        }
        if (functionbehaviorModelerProvider != null)
        {
            functionbehaviorModelerProvider.dispose();
        }
        if (opaqueactionModelerProvider != null)
        {
            opaqueactionModelerProvider.dispose();
        }
        if (actionModelerProvider != null)
        {
            actionModelerProvider.dispose();
        }
        if (executablenodeModelerProvider != null)
        {
            executablenodeModelerProvider.dispose();
        }
        if (activitynodeModelerProvider != null)
        {
            activitynodeModelerProvider.dispose();
        }
        if (structuredactivitynodeModelerProvider != null)
        {
            structuredactivitynodeModelerProvider.dispose();
        }
        if (activitygroupModelerProvider != null)
        {
            activitygroupModelerProvider.dispose();
        }
        if (activityModelerProvider != null)
        {
            activityModelerProvider.dispose();
        }
        if (variableModelerProvider != null)
        {
            variableModelerProvider.dispose();
        }
        if (activityedgeModelerProvider != null)
        {
            activityedgeModelerProvider.dispose();
        }
        if (activitypartitionModelerProvider != null)
        {
            activitypartitionModelerProvider.dispose();
        }
        if (interruptibleactivityregionModelerProvider != null)
        {
            interruptibleactivityregionModelerProvider.dispose();
        }
        if (exceptionhandlerModelerProvider != null)
        {
            exceptionhandlerModelerProvider.dispose();
        }
        if (objectnodeModelerProvider != null)
        {
            objectnodeModelerProvider.dispose();
        }
        if (outputpinModelerProvider != null)
        {
            outputpinModelerProvider.dispose();
        }
        if (pinModelerProvider != null)
        {
            pinModelerProvider.dispose();
        }
        if (inputpinModelerProvider != null)
        {
            inputpinModelerProvider.dispose();
        }
        if (valuepinModelerProvider != null)
        {
            valuepinModelerProvider.dispose();
        }
        if (callactionModelerProvider != null)
        {
            callactionModelerProvider.dispose();
        }
        if (invocationactionModelerProvider != null)
        {
            invocationactionModelerProvider.dispose();
        }
        if (sendsignalactionModelerProvider != null)
        {
            sendsignalactionModelerProvider.dispose();
        }
        if (calloperationactionModelerProvider != null)
        {
            calloperationactionModelerProvider.dispose();
        }
        if (callbehavioractionModelerProvider != null)
        {
            callbehavioractionModelerProvider.dispose();
        }
        if (sequencenodeModelerProvider != null)
        {
            sequencenodeModelerProvider.dispose();
        }
        if (usageModelerProvider != null)
        {
            usageModelerProvider.dispose();
        }
        if (controlnodeModelerProvider != null)
        {
            controlnodeModelerProvider.dispose();
        }
        if (controlflowModelerProvider != null)
        {
            controlflowModelerProvider.dispose();
        }
        if (initialnodeModelerProvider != null)
        {
            initialnodeModelerProvider.dispose();
        }
        if (activityparameternodeModelerProvider != null)
        {
            activityparameternodeModelerProvider.dispose();
        }
        if (messageModelerProvider != null)
        {
            messageModelerProvider.dispose();
        }
        if (messageendModelerProvider != null)
        {
            messageendModelerProvider.dispose();
        }
        if (interactionModelerProvider != null)
        {
            interactionModelerProvider.dispose();
        }
        if (interactionfragmentModelerProvider != null)
        {
            interactionfragmentModelerProvider.dispose();
        }
        if (lifelineModelerProvider != null)
        {
            lifelineModelerProvider.dispose();
        }
        if (partdecompositionModelerProvider != null)
        {
            partdecompositionModelerProvider.dispose();
        }
        if (interactionuseModelerProvider != null)
        {
            interactionuseModelerProvider.dispose();
        }
        if (gateModelerProvider != null)
        {
            gateModelerProvider.dispose();
        }
        if (generalorderingModelerProvider != null)
        {
            generalorderingModelerProvider.dispose();
        }
        if (occurrencespecificationModelerProvider != null)
        {
            occurrencespecificationModelerProvider.dispose();
        }
        if (interactionoperandModelerProvider != null)
        {
            interactionoperandModelerProvider.dispose();
        }
        if (interactionconstraintModelerProvider != null)
        {
            interactionconstraintModelerProvider.dispose();
        }
        if (executionspecificationModelerProvider != null)
        {
            executionspecificationModelerProvider.dispose();
        }
        if (stateinvariantModelerProvider != null)
        {
            stateinvariantModelerProvider.dispose();
        }
        if (actionexecutionspecificationModelerProvider != null)
        {
            actionexecutionspecificationModelerProvider.dispose();
        }
        if (behaviorexecutionspecificationModelerProvider != null)
        {
            behaviorexecutionspecificationModelerProvider.dispose();
        }
        if (executioneventModelerProvider != null)
        {
            executioneventModelerProvider.dispose();
        }
        if (creationeventModelerProvider != null)
        {
            creationeventModelerProvider.dispose();
        }
        if (destructioneventModelerProvider != null)
        {
            destructioneventModelerProvider.dispose();
        }
        if (sendoperationeventModelerProvider != null)
        {
            sendoperationeventModelerProvider.dispose();
        }
        if (messageeventModelerProvider != null)
        {
            messageeventModelerProvider.dispose();
        }
        if (sendsignaleventModelerProvider != null)
        {
            sendsignaleventModelerProvider.dispose();
        }
        if (messageoccurrencespecificationModelerProvider != null)
        {
            messageoccurrencespecificationModelerProvider.dispose();
        }
        if (executionoccurrencespecificationModelerProvider != null)
        {
            executionoccurrencespecificationModelerProvider.dispose();
        }
        if (receiveoperationeventModelerProvider != null)
        {
            receiveoperationeventModelerProvider.dispose();
        }
        if (receivesignaleventModelerProvider != null)
        {
            receivesignaleventModelerProvider.dispose();
        }
        if (actorModelerProvider != null)
        {
            actorModelerProvider.dispose();
        }
        if (calleventModelerProvider != null)
        {
            calleventModelerProvider.dispose();
        }
        if (changeeventModelerProvider != null)
        {
            changeeventModelerProvider.dispose();
        }
        if (signaleventModelerProvider != null)
        {
            signaleventModelerProvider.dispose();
        }
        if (anyreceiveeventModelerProvider != null)
        {
            anyreceiveeventModelerProvider.dispose();
        }
        if (forknodeModelerProvider != null)
        {
            forknodeModelerProvider.dispose();
        }
        if (flowfinalnodeModelerProvider != null)
        {
            flowfinalnodeModelerProvider.dispose();
        }
        if (finalnodeModelerProvider != null)
        {
            finalnodeModelerProvider.dispose();
        }
        if (centralbuffernodeModelerProvider != null)
        {
            centralbuffernodeModelerProvider.dispose();
        }
        if (mergenodeModelerProvider != null)
        {
            mergenodeModelerProvider.dispose();
        }
        if (decisionnodeModelerProvider != null)
        {
            decisionnodeModelerProvider.dispose();
        }
        if (activityfinalnodeModelerProvider != null)
        {
            activityfinalnodeModelerProvider.dispose();
        }
        if (componentrealizationModelerProvider != null)
        {
            componentrealizationModelerProvider.dispose();
        }
        if (componentModelerProvider != null)
        {
            componentModelerProvider.dispose();
        }
        if (nodeModelerProvider != null)
        {
            nodeModelerProvider.dispose();
        }
        if (deviceModelerProvider != null)
        {
            deviceModelerProvider.dispose();
        }
        if (executionenvironmentModelerProvider != null)
        {
            executionenvironmentModelerProvider.dispose();
        }
        if (communicationpathModelerProvider != null)
        {
            communicationpathModelerProvider.dispose();
        }
        if (combinedfragmentModelerProvider != null)
        {
            combinedfragmentModelerProvider.dispose();
        }
        if (continuationModelerProvider != null)
        {
            continuationModelerProvider.dispose();
        }
        if (considerignorefragmentModelerProvider != null)
        {
            considerignorefragmentModelerProvider.dispose();
        }
        if (createobjectactionModelerProvider != null)
        {
            createobjectactionModelerProvider.dispose();
        }
        if (destroyobjectactionModelerProvider != null)
        {
            destroyobjectactionModelerProvider.dispose();
        }
        if (testidentityactionModelerProvider != null)
        {
            testidentityactionModelerProvider.dispose();
        }
        if (readselfactionModelerProvider != null)
        {
            readselfactionModelerProvider.dispose();
        }
        if (structuralfeatureactionModelerProvider != null)
        {
            structuralfeatureactionModelerProvider.dispose();
        }
        if (readstructuralfeatureactionModelerProvider != null)
        {
            readstructuralfeatureactionModelerProvider.dispose();
        }
        if (writestructuralfeatureactionModelerProvider != null)
        {
            writestructuralfeatureactionModelerProvider.dispose();
        }
        if (clearstructuralfeatureactionModelerProvider != null)
        {
            clearstructuralfeatureactionModelerProvider.dispose();
        }
        if (removestructuralfeaturevalueactionModelerProvider != null)
        {
            removestructuralfeaturevalueactionModelerProvider.dispose();
        }
        if (addstructuralfeaturevalueactionModelerProvider != null)
        {
            addstructuralfeaturevalueactionModelerProvider.dispose();
        }
        if (linkactionModelerProvider != null)
        {
            linkactionModelerProvider.dispose();
        }
        if (linkenddataModelerProvider != null)
        {
            linkenddataModelerProvider.dispose();
        }
        if (qualifiervalueModelerProvider != null)
        {
            qualifiervalueModelerProvider.dispose();
        }
        if (readlinkactionModelerProvider != null)
        {
            readlinkactionModelerProvider.dispose();
        }
        if (linkendcreationdataModelerProvider != null)
        {
            linkendcreationdataModelerProvider.dispose();
        }
        if (createlinkactionModelerProvider != null)
        {
            createlinkactionModelerProvider.dispose();
        }
        if (writelinkactionModelerProvider != null)
        {
            writelinkactionModelerProvider.dispose();
        }
        if (destroylinkactionModelerProvider != null)
        {
            destroylinkactionModelerProvider.dispose();
        }
        if (linkenddestructiondataModelerProvider != null)
        {
            linkenddestructiondataModelerProvider.dispose();
        }
        if (clearassociationactionModelerProvider != null)
        {
            clearassociationactionModelerProvider.dispose();
        }
        if (broadcastsignalactionModelerProvider != null)
        {
            broadcastsignalactionModelerProvider.dispose();
        }
        if (sendobjectactionModelerProvider != null)
        {
            sendobjectactionModelerProvider.dispose();
        }
        if (valuespecificationactionModelerProvider != null)
        {
            valuespecificationactionModelerProvider.dispose();
        }
        if (timeexpressionModelerProvider != null)
        {
            timeexpressionModelerProvider.dispose();
        }
        if (observationModelerProvider != null)
        {
            observationModelerProvider.dispose();
        }
        if (durationModelerProvider != null)
        {
            durationModelerProvider.dispose();
        }
        if (durationintervalModelerProvider != null)
        {
            durationintervalModelerProvider.dispose();
        }
        if (intervalModelerProvider != null)
        {
            intervalModelerProvider.dispose();
        }
        if (timeconstraintModelerProvider != null)
        {
            timeconstraintModelerProvider.dispose();
        }
        if (intervalconstraintModelerProvider != null)
        {
            intervalconstraintModelerProvider.dispose();
        }
        if (timeintervalModelerProvider != null)
        {
            timeintervalModelerProvider.dispose();
        }
        if (durationconstraintModelerProvider != null)
        {
            durationconstraintModelerProvider.dispose();
        }
        if (timeobservationModelerProvider != null)
        {
            timeobservationModelerProvider.dispose();
        }
        if (durationobservationModelerProvider != null)
        {
            durationobservationModelerProvider.dispose();
        }
        if (finalstateModelerProvider != null)
        {
            finalstateModelerProvider.dispose();
        }
        if (timeeventModelerProvider != null)
        {
            timeeventModelerProvider.dispose();
        }
        if (variableactionModelerProvider != null)
        {
            variableactionModelerProvider.dispose();
        }
        if (readvariableactionModelerProvider != null)
        {
            readvariableactionModelerProvider.dispose();
        }
        if (writevariableactionModelerProvider != null)
        {
            writevariableactionModelerProvider.dispose();
        }
        if (clearvariableactionModelerProvider != null)
        {
            clearvariableactionModelerProvider.dispose();
        }
        if (addvariablevalueactionModelerProvider != null)
        {
            addvariablevalueactionModelerProvider.dispose();
        }
        if (removevariablevalueactionModelerProvider != null)
        {
            removevariablevalueactionModelerProvider.dispose();
        }
        if (raiseexceptionactionModelerProvider != null)
        {
            raiseexceptionactionModelerProvider.dispose();
        }
        if (actioninputpinModelerProvider != null)
        {
            actioninputpinModelerProvider.dispose();
        }
        if (informationitemModelerProvider != null)
        {
            informationitemModelerProvider.dispose();
        }
        if (informationflowModelerProvider != null)
        {
            informationflowModelerProvider.dispose();
        }
        if (readextentactionModelerProvider != null)
        {
            readextentactionModelerProvider.dispose();
        }
        if (reclassifyobjectactionModelerProvider != null)
        {
            reclassifyobjectactionModelerProvider.dispose();
        }
        if (readisclassifiedobjectactionModelerProvider != null)
        {
            readisclassifiedobjectactionModelerProvider.dispose();
        }
        if (startclassifierbehavioractionModelerProvider != null)
        {
            startclassifierbehavioractionModelerProvider.dispose();
        }
        if (readlinkobjectendactionModelerProvider != null)
        {
            readlinkobjectendactionModelerProvider.dispose();
        }
        if (readlinkobjectendqualifieractionModelerProvider != null)
        {
            readlinkobjectendqualifieractionModelerProvider.dispose();
        }
        if (createlinkobjectactionModelerProvider != null)
        {
            createlinkobjectactionModelerProvider.dispose();
        }
        if (accepteventactionModelerProvider != null)
        {
            accepteventactionModelerProvider.dispose();
        }
        if (acceptcallactionModelerProvider != null)
        {
            acceptcallactionModelerProvider.dispose();
        }
        if (replyactionModelerProvider != null)
        {
            replyactionModelerProvider.dispose();
        }
        if (unmarshallactionModelerProvider != null)
        {
            unmarshallactionModelerProvider.dispose();
        }
        if (reduceactionModelerProvider != null)
        {
            reduceactionModelerProvider.dispose();
        }
        if (joinnodeModelerProvider != null)
        {
            joinnodeModelerProvider.dispose();
        }
        if (datastorenodeModelerProvider != null)
        {
            datastorenodeModelerProvider.dispose();
        }
        if (objectflowModelerProvider != null)
        {
            objectflowModelerProvider.dispose();
        }
        if (conditionalnodeModelerProvider != null)
        {
            conditionalnodeModelerProvider.dispose();
        }
        if (clauseModelerProvider != null)
        {
            clauseModelerProvider.dispose();
        }
        if (loopnodeModelerProvider != null)
        {
            loopnodeModelerProvider.dispose();
        }
        if (expansionnodeModelerProvider != null)
        {
            expansionnodeModelerProvider.dispose();
        }
        if (expansionregionModelerProvider != null)
        {
            expansionregionModelerProvider.dispose();
        }
        if (protocoltransitionModelerProvider != null)
        {
            protocoltransitionModelerProvider.dispose();
        }
        if (associationclassModelerProvider != null)
        {
            associationclassModelerProvider.dispose();
        }
    }

}
